
#include "disassemble.h"

UNUSED static const char *valhall_action[] = {
    ".wait0126",
    ".barrier",
    ".reconverge",
    ".reserved",
    ".reserved",
    ".td",
    ".reserved",
    ".return",
};

UNUSED static const char *valhall_immediate_mode[] = {
    "",
    ".ts",
    ".reserved",
    ".id",
};

UNUSED static const char *valhall_thread_storage_pointers[] = {
    ".reserved",
    ".reserved",
    ".tls_ptr",
    ".tls_ptr_hi",
    ".reserved",
    ".reserved",
    ".wls_ptr",
    ".wls_ptr_hi",
};

UNUSED static const char *valhall_thread_identification[] = {
    ".reserved",
    ".reserved",
    ".lane_id",
    ".reserved",
    ".reserved",
    ".reserved",
    ".core_id",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".program_counter",
    ".reserved",
};

UNUSED static const char *valhall_swizzles_8_bit[] = {
    "",
    ".b3210",
    ".b0101",
    ".b2323",
    ".b0000",
    ".b1111",
    ".b2222",
    ".b3333",
    ".b2301",
    ".b1032",
    ".b0011",
    ".b2233",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
};

UNUSED static const char *valhall_lanes_8_bit[] = {
    ".b02",
    ".reserved",
    ".reserved",
    ".reserved",
    ".b00",
    ".b11",
    ".b22",
    ".b33",
    ".reserved",
    ".reserved",
    ".b01",
    ".b23",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
};

UNUSED static const char *valhall_half_swizzles_8_bit[] = {
    ".b00",
    ".b10",
    ".b20",
    ".b30",
    ".b01",
    ".b11",
    ".b21",
    ".b31",
    ".b02",
    ".b12",
    ".b22",
    ".b32",
    ".b03",
    ".b13",
    ".b23",
    ".b33",
};

UNUSED static const char *valhall_swizzles_16_bit[] = {
    ".h00",
    ".h10",
    "",
    ".h11",
    ".b00",
    ".b20",
    ".b02",
    ".b22",
    ".b11",
    ".b31",
    ".b13",
    ".b33",
    ".b01",
    ".b23",
    ".reserved",
    ".reserved",
};

UNUSED static const char *valhall_swizzles_32_bit[] = {
    "",
    ".reserved",
    ".h0",
    ".h1",
    ".b0",
    ".b1",
    ".b2",
    ".b3",
};

UNUSED static const char *valhall_swizzles_64_bit[] = {
    "",
    ".reserved",
    ".h0",
    ".h1",
    ".b0",
    ".b1",
    ".b2",
    ".b3",
    ".w0",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
};

UNUSED static const char *valhall_lane_8_bit[] = {
    ".b0",
    ".b1",
    ".b2",
    ".b3",
};

UNUSED static const char *valhall_lane_32_bit[] = {
    "",
    ".h0",
    ".h1",
    ".reserved",
};

UNUSED static const char *valhall_lane_16_bit[] = {
    ".h0",
    ".h1",
};

UNUSED static const char *valhall_load_lane_8_bit[] = {
    "",
    ".b1",
    ".b2",
    ".b3",
    ".h0",
    ".h1",
    ".w0",
    ".d0",
};

UNUSED static const char *valhall_load_lane_16_bit[] = {
    "",
    ".h1",
    ".w0",
    ".d0",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
};

UNUSED static const char *valhall_load_lane_24_bit[] = {
    "",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
};

UNUSED static const char *valhall_load_lane_32_bit[] = {
    "",
    ".d0",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
};

UNUSED static const char *valhall_load_lane_48_bit[] = {
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    "",
    ".reserved",
    ".reserved",
    ".reserved",
};

UNUSED static const char *valhall_load_lane_64_bit[] = {
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    "",
};

UNUSED static const char *valhall_load_lane_96_bit[] = {
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    "",
    ".reserved",
};

UNUSED static const char *valhall_load_lane_128_bit[] = {
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    "",
};

UNUSED static const char *valhall_round_mode[] = {
    "",
    ".rtp",
    ".rtn",
    ".rtz",
};

UNUSED static const char *valhall_result_type[] = {
    ".i1",
    ".f1",
    ".m1",
    ".u1",
};

UNUSED static const char *valhall_widen[] = {
    "",
    ".h0",
    ".h1",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
};

UNUSED static const char *valhall_clamp[] = {
    "",
    ".clamp_0_inf",
    ".clamp_m1_1",
    ".clamp_0_1",
};

UNUSED static const char *valhall_condition[] = {
    ".eq",
    ".gt",
    ".ge",
    ".ne",
    ".lt",
    ".le",
    ".gtlt",
    ".total",
};

UNUSED static const char *valhall_dimension[] = {
    ".1d",
    ".2d",
    ".3d",
    ".cube",
};

UNUSED static const char *valhall_lod_mode[] = {
    ".zero",
    ".computed",
    ".reserved",
    ".reserved",
    ".explicit",
    ".computed_bias",
    ".grdesc",
    ".reserved",
};

UNUSED static const char *valhall_register_format[] = {
    ".reserved",
    ".reserved",
    ".f32",
    ".f16",
    ".s32",
    ".s16",
    ".u32",
    ".u16",
};

UNUSED static const char *valhall_staging_register_count[] = {
    ".sr0",
    ".sr1",
    ".sr2",
    ".sr3",
    ".sr4",
    ".sr5",
    ".sr6",
    ".sr7",
};

UNUSED static const char *valhall_vector_size[] = {
    "",
    ".v2",
    ".v3",
    ".v4",
};

UNUSED static const char *valhall_slot[] = {
    ".slot0",
    ".slot1",
    ".slot2",
    ".reserved",
    ".reserved",
    ".reserved",
    ".reserved",
    ".slot7",
};

UNUSED static const char *valhall_store_segment[] = {
    "",
    ".pos",
    ".vary",
    ".tl",
};

UNUSED static const char *valhall_subgroup_size[] = {
    ".subgroup2",
    ".subgroup4",
    ".subgroup8",
    "",
};

UNUSED static const char *valhall_lane_operation[] = {
    "",
    ".xor",
    ".accumulate",
    ".shift",
};

UNUSED static const char *valhall_inactive_result[] = {
    "",
    ".umax",
    ".i1",
    ".v2i1",
    ".smin",
    ".smax",
    ".v2smin",
    ".v2smax",
    ".v4smin",
    ".v4smax",
    ".f1",
    ".v2f1",
    ".infn",
    ".inf",
    ".v2infn",
    ".v2inf",
};

UNUSED static const char *valhall_mux[] = {
    ".neg",
    "",
    ".fp_zero",
    ".bit",
};

UNUSED static const char *valhall_sample_mode[] = {
    ".center",
    ".centroid",
    ".sample",
    ".explicit",
};

UNUSED static const char *valhall_update_mode[] = {
    ".store",
    ".retrieve",
    ".reserved",
    ".clobber",
};

static const uint32_t va_immediates[32] = {
    0x0,
    0xffffffff,
    0x7fffffff,
    0xfafcfdfe,
    0x1000000,
    0x80002000,
    0x70605030,
    0xc0b0a090,
    0x3020100,
    0x7060504,
    0xb0a0908,
    0xf0e0d0c,
    0x13121110,
    0x17161514,
    0x1b1a1918,
    0x1f1e1d1c,
    0x3f800000,
    0x3dcccccd,
    0x3ea2f983,
    0x3f317218,
    0x40490fdb,
    0x0,
    0x477fff00,
    0x5c005bf8,
    0x2e660000,
    0x34000000,
    0x38000000,
    0x3c000000,
    0x40000000,
    0x44000000,
    0x48000000,
    0x42480000,
};

/* Byte 7 has instruction metadata, analogous to Bifrost's clause header */
struct va_metadata {
	bool opcode_high : 1;
    unsigned immediate_mode : 2;
    unsigned action : 3;
	bool do_action : 1;
	bool unk3 : 1;
} __attribute__((packed));

static inline void
va_print_metadata(FILE *fp, uint8_t meta)
{
	struct va_metadata m;
	memcpy(&m, &meta, 1);

    fputs(valhall_immediate_mode[m.immediate_mode], fp);

	if (m.do_action) {
        fputs(valhall_action[m.action], fp);
	} else if (m.action) {
		fprintf(fp, ".wait%s%s%s",
				m.action & (1 << 0) ? "0" : "",
				m.action & (1 << 1) ? "1" : "",
				m.action & (1 << 2) ? "2" : "");
	}

	if (m.unk3)
		fprintf(fp, ".unk3");
}

static inline void
va_print_src(FILE *fp, uint8_t src, unsigned imm_mode)
{
	unsigned type = (src >> 6);
	unsigned value = (src & 0x3F);

	if (type == VA_SRC_IMM_TYPE) {
        if (value >= 32) {
            if (imm_mode == 0) {
                if (value >= 0x30)
                    fprintf(fp, "blend_descriptor_%u_%c", (value - 0x30) >> 1, value & 1 ? 'y' : 'x');
                else if (value == 0x2A)
                    fprintf(fp, "atest_datum");
                else
                    fprintf(fp, "unk:%X", value);
            } else if (imm_mode == 1) {
                if (value < 0x28)
                    fputs(valhall_thread_storage_pointers[value - 0x20] + 1, fp);
                else
                    fprintf(fp, "unk:%X", value);
            } else if (imm_mode == 3) {
                if (value < 0x40)
                    fputs(valhall_thread_identification[value - 0x20] + 1, fp);
                else
                    fprintf(fp, "unk:%X", value);
            } else {
                    fprintf(fp, "unk:%X", value);
            }
        } else {
            fprintf(fp, "0x%X", va_immediates[value]);
        }
	} else if (type == VA_SRC_UNIFORM_TYPE) {
		fprintf(fp, "u%u", value);
	} else {
		bool discard = (type & 1);
		fprintf(fp, "%sr%u", discard ? "`" : "", value);
	}
}

static inline void
va_print_float_src(FILE *fp, uint8_t src, unsigned imm_mode, bool neg, bool abs)
{
	unsigned type = (src >> 6);
	unsigned value = (src & 0x3F);

	if (type == VA_SRC_IMM_TYPE) {
        assert(value < 32 && "overflow in LUT");
        fprintf(fp, "0x%X", va_immediates[value]);
	} else {
        va_print_src(fp, src, imm_mode);
    }

	if (neg)
		fprintf(fp, ".neg");

	if (abs)
		fprintf(fp, ".abs");
}

void
va_disasm_instr(FILE *fp, uint64_t instr)
{
   unsigned primary_opc = (instr >> 48) & MASK(9);
   unsigned imm_mode = (instr >> 57) & MASK(2);
   unsigned secondary_opc = 0;

   switch (primary_opc) {
    
   case 0x0:

            fputs("NOP", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);
     break;

    
   case 0x1f:

            fputs("BRANCHZ", fp);
            if (instr & BIT(36)) fputs(".eq", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_lane_32_bit[(instr >> 37) & 0x3], fp);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(27)) , 27));
     break;

    
   case 0x20:

            fputs("DISCARD.f32", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_widen[(instr >> 26) & 3], fp);
     break;

    
   case 0x2f:

            fputs("BRANCHZI", fp);
            if (instr & BIT(36)) fputs(".eq", fp);
            if (instr & BIT(40)) fputs(".absolute", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
     break;

    
   case 0x45:

            fputs("BARRIER", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);
     break;

    
   case 0x154:

            fputs("CSEL.f32", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode, false, false);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode, false, false);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 16, imm_mode, false, false);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 24, imm_mode, false, false);
     break;

    
   case 0x155:

            fputs("CSEL.v2f16", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode, false, false);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode, false, false);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 16, imm_mode, false, false);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 24, imm_mode, false, false);
     break;

    
   case 0x150:

            fputs("CSEL.u32", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 24, imm_mode);
     break;

    
   case 0x151:

            fputs("CSEL.v2u16", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 24, imm_mode);
     break;

    
   case 0x158:

            fputs("CSEL.s32", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 24, imm_mode);
     break;

    
   case 0x159:

            fputs("CSEL.v2s16", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 24, imm_mode);
     break;

    
   case 0x56:

            fputs("LD_VAR_SPECIAL", fp);
            fputs(valhall_vector_size[(instr >> 28) & 0x3], fp);
            fputs(valhall_register_format[(instr >> 24) & 0x7], fp);
            fputs(valhall_sample_mode[(instr >> 38) & 0x3], fp);
            fputs(valhall_update_mode[(instr >> 36) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", index:0x%X", (uint32_t) 
                    ((instr >> 12) & MASK(4)) );
     break;

    
   case 0x5c:

            fputs("LD_VAR_IMM_F32", fp);
            fputs(valhall_vector_size[(instr >> 28) & 0x3], fp);
            if (instr & BIT(24)) fputs(".half", fp);
            if (instr & BIT(25)) fputs(".smooth", fp);
            fputs(valhall_sample_mode[(instr >> 38) & 0x3], fp);
            fputs(valhall_update_mode[(instr >> 36) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", index:0x%X", (uint32_t) 
                    ((instr >> 16) & MASK(8)) );
     break;

    
   case 0x5d:

            fputs("LD_VAR_IMM_F16", fp);
            fputs(valhall_vector_size[(instr >> 28) & 0x3], fp);
            if (instr & BIT(24)) fputs(".half", fp);
            if (instr & BIT(25)) fputs(".smooth", fp);
            fputs(valhall_sample_mode[(instr >> 38) & 0x3], fp);
            fputs(valhall_update_mode[(instr >> 36) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", index:0x%X", (uint32_t) 
                    ((instr >> 16) & MASK(8)) );
     break;

    
   case 0x66:

            fputs("LD_ATTR_IMM", fp);
            fputs(valhall_vector_size[(instr >> 28) & 0x3], fp);
            fputs(valhall_register_format[(instr >> 24) & 0x7], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);

            fprintf(fp, ", index:0x%X", (uint32_t) 
                    ((instr >> 20) & MASK(4)) );

            fprintf(fp, ", table:0x%X", (uint32_t) 
                    ((instr >> 16) & MASK(4)) );
     break;

    
   case 0x67:

            fputs("LEA_IMAGE_IMM", fp);
            fputs(valhall_vector_size[(instr >> 28) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);

            fprintf(fp, ", unk:0x%X", (uint32_t) 
                    ((instr >> 36) & MASK(4)) );

            fprintf(fp, ", index:0x%X", (uint32_t) 
                    ((instr >> 20) & MASK(4)) );

            fprintf(fp, ", unk2:0x%X", (uint32_t) 
                    ((instr >> 16) & MASK(4)) );
     break;

    
   case 0x6a:
	secondary_opc = (instr >> 27) & 0x7;


        if (secondary_opc == 0) { 
            fputs("LD_BUFFER.i8", fp);
            fputs(valhall_load_lane_8_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
        }


        if (secondary_opc == 1) { 
            fputs("LD_BUFFER.i16", fp);
            fputs(valhall_load_lane_16_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
        }


        if (secondary_opc == 2) { 
            fputs("LD_BUFFER.i24", fp);
            fputs(valhall_load_lane_24_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
        }


        if (secondary_opc == 3) { 
            fputs("LD_BUFFER.i32", fp);
            fputs(valhall_load_lane_32_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
        }


        if (secondary_opc == 4) { 
            fputs("LD_BUFFER.i48", fp);
            fputs(valhall_load_lane_48_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
        }


        if (secondary_opc == 5) { 
            fputs("LD_BUFFER.i64", fp);
            fputs(valhall_load_lane_64_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
        }


        if (secondary_opc == 6) { 
            fputs("LD_BUFFER.i96", fp);
            fputs(valhall_load_lane_96_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
        }


        if (secondary_opc == 7) { 
            fputs("LD_BUFFER.i128", fp);
            fputs(valhall_load_lane_128_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
        }
     break;

    
   case 0x76:

            fputs("LD_ATTR", fp);
            fputs(valhall_vector_size[(instr >> 28) & 0x3], fp);
            fputs(valhall_register_format[(instr >> 24) & 0x7], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0x5e:

            fputs("LEA_VARY", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", unk:0x%X", (uint32_t) 
                    ((instr >> 8) & MASK(4)) );
     break;

    
   case 0x60:
	secondary_opc = (instr >> 27) & 0x7;


        if (secondary_opc == 0) { 
            fputs("LOAD.i8", fp);
            fputs(valhall_load_lane_8_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 1) { 
            fputs("LOAD.i16", fp);
            fputs(valhall_load_lane_16_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 2) { 
            fputs("LOAD.i24", fp);
            fputs(valhall_load_lane_24_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 3) { 
            fputs("LOAD.i32", fp);
            fputs(valhall_load_lane_32_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 4) { 
            fputs("LOAD.i48", fp);
            fputs(valhall_load_lane_48_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 5) { 
            fputs("LOAD.i64", fp);
            fputs(valhall_load_lane_64_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 6) { 
            fputs("LOAD.i96", fp);
            fputs(valhall_load_lane_96_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 7) { 
            fputs("LOAD.i128", fp);
            fputs(valhall_load_lane_128_bit[(instr >> 36) & 0x7], fp);
            if (instr & BIT(39)) fputs(".unsigned", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }
     break;

    
   case 0x61:
	secondary_opc = (instr >> 27) & 0x7;


        if (secondary_opc == 0) { 
            fputs("STORE.i8", fp);
            fputs(valhall_store_segment[(instr >> 24) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 1) { 
            fputs("STORE.i16", fp);
            fputs(valhall_store_segment[(instr >> 24) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 2) { 
            fputs("STORE.i24", fp);
            fputs(valhall_store_segment[(instr >> 24) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 3) { 
            fputs("STORE.i32", fp);
            fputs(valhall_store_segment[(instr >> 24) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 4) { 
            fputs("STORE.i48", fp);
            fputs(valhall_store_segment[(instr >> 24) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 5) { 
            fputs("STORE.i64", fp);
            fputs(valhall_store_segment[(instr >> 24) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 6) { 
            fputs("STORE.i96", fp);
            fputs(valhall_store_segment[(instr >> 24) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }


        if (secondary_opc == 7) { 
            fputs("STORE.i128", fp);
            fputs(valhall_store_segment[(instr >> 24) & 0x3], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", offset:%d", (uint32_t) SEXT(
                    ((instr >> 8) & MASK(16)) , 16));
        }
     break;

    
   case 0x71:

            fputs("ST_CVT", fp);
            fputs(valhall_vector_size[(instr >> 28) & 0x3], fp);
            fputs(valhall_register_format[(instr >> 24) & 0x7], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);

            fprintf(fp, ", unk:0x%X", (uint32_t) 
                    ((instr >> 36) & MASK(4)) );
     break;

    
   case 0x78:

            fputs("LD_TILE", fp);
            fputs(valhall_vector_size[(instr >> 28) & 0x3], fp);
            fputs(valhall_register_format[(instr >> 24) & 0x7], fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0x7f:

            fputs("BLEND", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            fputs(valhall_vector_size[(instr >> 28) & 0x3], fp);
            fputs(valhall_register_format[(instr >> 24) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

//            assert(((instr >> 16) & 0xC0) == 0);
            for (unsigned i = 0; i < 1; ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 16) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", target:0x%X", (uint32_t) 
                    ((instr >> 8) & MASK(8)) );
     break;

    
   case 0x7d:

            fputs("ATEST", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_widen[(instr >> 26) & 3], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0x7e:

            fputs("ZS_EMIT", fp);
            if (instr & BIT(25)) fputs(".z", fp);
            if (instr & BIT(24)) fputs(".stencil", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0x90:
	secondary_opc = (instr >> 16) & 0x1f;


        if (secondary_opc == 7) { 
            fputs("V2S16_TO_V2F16", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
        }


        if (secondary_opc == 9) { 
            fputs("S32_TO_F32", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
        }


        if (secondary_opc == 23) { 
            fputs("V2U16_TO_V2F16", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
        }


        if (secondary_opc == 25) { 
            fputs("U32_TO_F32", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
        }


        if (secondary_opc == 4) { 
            fputs("S16_TO_S32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 5) { 
            fputs("S16_TO_F32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 20) { 
            fputs("U16_TO_U32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 21) { 
            fputs("U16_TO_F32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 12) { 
            fputs("F32_TO_S32", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
        }


        if (secondary_opc == 28) { 
            fputs("F32_TO_U32", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
        }


        if (secondary_opc == 14) { 
            fputs("V2F16_TO_V2S16", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 30) { 
            fputs("V2F16_TO_V2U16", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 10) { 
            fputs("F16_TO_S32", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 26) { 
            fputs("F16_TO_U32", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 11) { 
            fputs("F16_TO_F32", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_lane_16_bit[(instr >> 28) & 0x3], fp);
        }


        if (secondary_opc == 0) { 
            fputs("S8_TO_S32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_lane_8_bit[(instr >> 28) & 0x3], fp);
        }


        if (secondary_opc == 1) { 
            fputs("S8_TO_F32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_lane_8_bit[(instr >> 28) & 0x3], fp);
        }


        if (secondary_opc == 16) { 
            fputs("U8_TO_U32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_lane_8_bit[(instr >> 28) & 0x3], fp);
        }


        if (secondary_opc == 17) { 
            fputs("U8_TO_F32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_lane_8_bit[(instr >> 28) & 0x3], fp);
        }


        if (secondary_opc == 2) { 
            fputs("V2S8_TO_V2S16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_half_swizzles_8_bit[(instr >> 36) & 0xF], fp);
        }


        if (secondary_opc == 3) { 
            fputs("V2S8_TO_V2F16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_half_swizzles_8_bit[(instr >> 36) & 0xF], fp);
        }


        if (secondary_opc == 18) { 
            fputs("V2U8_TO_V2U16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_half_swizzles_8_bit[(instr >> 36) & 0xF], fp);
        }


        if (secondary_opc == 19) { 
            fputs("V2U8_TO_V2F16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_half_swizzles_8_bit[(instr >> 36) & 0xF], fp);
        }


        if (secondary_opc == 13) { 
            fputs("FROUND.f32", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 15) { 
            fputs("FROUND.v2f16", fp);
            fputs(valhall_round_mode[(instr >> 30) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }
     break;

    
   case 0x91:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("MOV.i32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
        }


        if (secondary_opc == 4) { 
            fputs("CLZ.u32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
        }


        if (secondary_opc == 5) { 
            fputs("CLZ.v2u16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
        }


        if (secondary_opc == 6) { 
            fputs("CLZ.v4u8", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
        }


        if (secondary_opc == 8) { 
            fputs("IABS.s32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
        }


        if (secondary_opc == 9) { 
            fputs("IABS.v2s16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
        }


        if (secondary_opc == 10) { 
            fputs("IABS.v4s8", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
        }


        if (secondary_opc == 12) { 
            fputs("POPCOUNT.i32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
        }


        if (secondary_opc == 13) { 
            fputs("BITREV.i32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
        }


        if (secondary_opc == 14) { 
            fputs("NOT.i32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
        }
     break;

    
   case 0x191:

            fputs("NOT.i64", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
     break;

    
   case 0x95:

            fputs("WMASK", fp);
            fputs(valhall_subgroup_size[(instr >> 36) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
     break;

    
   case 0x99:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("FREXPM.f32", fp);
            if (instr & BIT(24)) fputs(".sqrt", fp);
            if (instr & BIT(25)) fputs(".log", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode, false, false);
            fputs(valhall_widen[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 1) { 
            fputs("FREXPM.v2f16", fp);
            if (instr & BIT(24)) fputs(".sqrt", fp);
            if (instr & BIT(25)) fputs(".log", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode, false, false);
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 2) { 
            fputs("FREXPE.f32", fp);
            if (instr & BIT(24)) fputs(".sqrt", fp);
            if (instr & BIT(25)) fputs(".log", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode, false, false);
            fputs(valhall_widen[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 3) { 
            fputs("FREXPE.v2f16", fp);
            if (instr & BIT(24)) fputs(".sqrt", fp);
            if (instr & BIT(25)) fputs(".log", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode, false, false);
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }
     break;

    
   case 0x9c:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("FRCP.f32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 1) { 
            fputs("FRCP.f16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 2) { 
            fputs("FRSQ.f32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 3) { 
            fputs("FRSQ.f16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 8) { 
            fputs("FLOGD.f32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
        }


        if (secondary_opc == 4) { 
            fputs("FSIN_TABLE.u6", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
        }


        if (secondary_opc == 5) { 
            fputs("FCOS_TABLE.u6", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
        }
     break;

    
   case 0xa4:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("FADD.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_widen[(instr >> 26) & 3], fp);
        }


        if (secondary_opc == 2) { 
            fputs("FMIN.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_widen[(instr >> 26) & 3], fp);
        }


        if (secondary_opc == 3) { 
            fputs("FMAX.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_widen[(instr >> 26) & 3], fp);
        }


        if (secondary_opc == 6) { 
            fputs("FRSCALE.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_widen[(instr >> 26) & 3], fp);
        }


        if (secondary_opc == 8) { 
            fputs("FEXP.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
        }


        if (secondary_opc == 9) { 
            fputs("FADD_LSCALE.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
        }
     break;

    
   case 0xa5:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("FADD.v2f16", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_swizzles_16_bit[(instr >> 26) & 3], fp);
        }


        if (secondary_opc == 2) { 
            fputs("FMIN.v2f16", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_swizzles_16_bit[(instr >> 26) & 3], fp);
        }


        if (secondary_opc == 3) { 
            fputs("FMAX.v2f16", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_swizzles_16_bit[(instr >> 26) & 3], fp);
        }


        if (secondary_opc == 4) { 
            fputs("V2F32_TO_V2F16", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
        }


        if (secondary_opc == 6) { 
            fputs("FRSCALE.v2f16", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_swizzles_16_bit[(instr >> 26) & 3], fp);
        }
     break;

    
   case 0xa0:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("IADD.u32", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 1) { 
            fputs("ISUB.u32", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 10) { 
            fputs("IMUL.i32", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 11) { 
            fputs("HADD.u32", fp);
            if (instr & BIT(30)) fputs(".rhadd", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 15) { 
            fputs("CLPER.i32", fp);
            fputs(valhall_subgroup_size[(instr >> 36) & 0x3], fp);
            fputs(valhall_lane_operation[(instr >> 32) & 0x3], fp);
            fputs(valhall_inactive_result[(instr >> 22) & 0xf], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
        }
     break;

    
   case 0xa1:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("IADD.v2u16", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 5) { 
            fputs("MKVEC.v2i16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_swizzles_16_bit[(instr >> 26) & 3], fp);
        }


        if (secondary_opc == 1) { 
            fputs("ISUB.v2u16", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 10) { 
            fputs("IMUL.v2i16", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 11) { 
            fputs("HADD.v2u16", fp);
            if (instr & BIT(30)) fputs(".rhadd", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 15) { 
            fputs("CLPER.v2u16", fp);
            fputs(valhall_subgroup_size[(instr >> 36) & 0x3], fp);
            fputs(valhall_lane_operation[(instr >> 32) & 0x3], fp);
            fputs(valhall_inactive_result[(instr >> 22) & 0xf], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
        }
     break;

    
   case 0xa2:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("IADD.v4u8", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 1) { 
            fputs("ISUB.v4u8", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 10) { 
            fputs("IMUL.v4i8", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 11) { 
            fputs("HADD.v4u8", fp);
            if (instr & BIT(30)) fputs(".rhadd", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 15) { 
            fputs("CLPER.v4u8", fp);
            fputs(valhall_subgroup_size[(instr >> 36) & 0x3], fp);
            fputs(valhall_lane_operation[(instr >> 32) & 0x3], fp);
            fputs(valhall_inactive_result[(instr >> 22) & 0xf], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
        }
     break;

    
   case 0xa8:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("IADD.s32", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 1) { 
            fputs("ISUB.s32", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 10) { 
            fputs("IMUL.s32", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 11) { 
            fputs("HADD.s32", fp);
            if (instr & BIT(30)) fputs(".rhadd", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 15) { 
            fputs("CLPER.s32", fp);
            fputs(valhall_subgroup_size[(instr >> 36) & 0x3], fp);
            fputs(valhall_lane_operation[(instr >> 32) & 0x3], fp);
            fputs(valhall_inactive_result[(instr >> 22) & 0xf], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
        }
     break;

    
   case 0xa9:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("IADD.v2s16", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 1) { 
            fputs("ISUB.v2s16", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 10) { 
            fputs("IMUL.v2s16", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 11) { 
            fputs("HADD.v2s16", fp);
            if (instr & BIT(30)) fputs(".rhadd", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 15) { 
            fputs("CLPER.v2s16", fp);
            fputs(valhall_subgroup_size[(instr >> 36) & 0x3], fp);
            fputs(valhall_lane_operation[(instr >> 32) & 0x3], fp);
            fputs(valhall_inactive_result[(instr >> 22) & 0xf], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
        }
     break;

    
   case 0x1a2:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("IADD.v4s8", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 1) { 
            fputs("ISUB.v4s8", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 10) { 
            fputs("IMUL.v4s8", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 11) { 
            fputs("HADD.v4s8", fp);
            if (instr & BIT(30)) fputs(".rhadd", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 15) { 
            fputs("CLPER.v4s8", fp);
            fputs(valhall_subgroup_size[(instr >> 36) & 0x3], fp);
            fputs(valhall_lane_operation[(instr >> 32) & 0x3], fp);
            fputs(valhall_inactive_result[(instr >> 22) & 0xf], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
        }
     break;

    
   case 0x1a3:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("IADD.u64", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 1) { 
            fputs("ISUB.u64", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 7) { 
            fputs("SHADDX.u64", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 26) & 0xF], fp);

            fprintf(fp, ", shift:0x%X", (uint32_t) 
                    ((instr >> 20) & MASK(3)) );
        }


        if (secondary_opc == 10) { 
            fputs("IMULD.u64", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 15) { 
            fputs("CLPER.u64", fp);
            fputs(valhall_subgroup_size[(instr >> 36) & 0x3], fp);
            fputs(valhall_lane_operation[(instr >> 32) & 0x3], fp);
            fputs(valhall_inactive_result[(instr >> 22) & 0xf], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 26) & 0xF], fp);
        }
     break;

    
   case 0x1ab:
	secondary_opc = (instr >> 16) & 0xf;


        if (secondary_opc == 0) { 
            fputs("IADD.s64", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 1) { 
            fputs("ISUB.s64", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 26) & 0xF], fp);
        }


        if (secondary_opc == 7) { 
            fputs("SHADDX.s64", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 26) & 0xF], fp);

            fprintf(fp, ", shift:0x%X", (uint32_t) 
                    ((instr >> 20) & MASK(3)) );
        }


        if (secondary_opc == 15) { 
            fputs("CLPER.s64", fp);
            fputs(valhall_subgroup_size[(instr >> 36) & 0x3], fp);
            fputs(valhall_lane_operation[(instr >> 32) & 0x3], fp);
            fputs(valhall_inactive_result[(instr >> 22) & 0xf], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 26) & 0xF], fp);
        }
     break;

    
   case 0xb2:

            fputs("FMA.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_widen[(instr >> 26) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 16, imm_mode,
                    instr & BIT(34),
                    instr & BIT(35));
            fputs(valhall_widen[(instr >> 24) & 3], fp);
     break;

    
   case 0xb3:

            fputs("FMA.v2f16", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_swizzles_16_bit[(instr >> 26) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 16, imm_mode,
                    instr & BIT(34),
                    instr & BIT(35));
            fputs(valhall_swizzles_16_bit[(instr >> 24) & 3], fp);
     break;

    
   case 0xb4:
	secondary_opc = (instr >> 24) & 0x103;


        if (secondary_opc == 256) { 
            fputs("LSHIFT_AND.i32", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 0) { 
            fputs("RSHIFT_AND.i32", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 257) { 
            fputs("LSHIFT_OR.i32", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 1) { 
            fputs("RSHIFT_OR.i32", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 258) { 
            fputs("LSHIFT_XOR.i32", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 2) { 
            fputs("RSHIFT_XOR.i32", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }
     break;

    
   case 0xb5:
	secondary_opc = (instr >> 24) & 0x103;


        if (secondary_opc == 256) { 
            fputs("LSHIFT_AND.v2i16", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 0) { 
            fputs("RSHIFT_AND.v2i16", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 257) { 
            fputs("LSHIFT_OR.v2i16", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 1) { 
            fputs("RSHIFT_OR.v2i16", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 258) { 
            fputs("LSHIFT_XOR.v2i16", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 2) { 
            fputs("RSHIFT_XOR.v2i16", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }
     break;

    
   case 0xb6:
	secondary_opc = (instr >> 24) & 0x103;


        if (secondary_opc == 256) { 
            fputs("LSHIFT_AND.v4i8", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 0) { 
            fputs("RSHIFT_AND.v4i8", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 257) { 
            fputs("LSHIFT_OR.v4i8", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 1) { 
            fputs("RSHIFT_OR.v4i8", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 258) { 
            fputs("LSHIFT_XOR.v4i8", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 2) { 
            fputs("RSHIFT_XOR.v4i8", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }
     break;

    
   case 0x1b7:
	secondary_opc = (instr >> 24) & 0x103;


        if (secondary_opc == 256) { 
            fputs("LSHIFT_AND.i64", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 0) { 
            fputs("RSHIFT_AND.i64", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 257) { 
            fputs("LSHIFT_OR.i64", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 1) { 
            fputs("RSHIFT_OR.i64", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 258) { 
            fputs("LSHIFT_XOR.i64", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }


        if (secondary_opc == 2) { 
            fputs("RSHIFT_XOR.i64", fp);
            if (instr & BIT(34)) fputs(".signed", fp);
            if (instr & BIT(30)) fputs(".not_result", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_64_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lanes_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
            if (instr & BIT(35)) fputs(".not", fp);
        }
     break;

    
   case 0xb8:

            fputs("MUX.i32", fp);
            fputs(valhall_mux[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0xbc:
	secondary_opc = (instr >> 24) & 0xf;


        if (secondary_opc == 0) { 
            fputs("CUBE_SSEL", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
        }


        if (secondary_opc == 1) { 
            fputs("CUBE_TSEL", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
        }
     break;

    
   case 0xbd:

            fputs("MKVEC.v4i8", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(valhall_lane_8_bit[(instr >> 38) & 0x3], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(valhall_lane_8_bit[(instr >> 36) & 0x3], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0xc0:

            fputs("CUBEFACE1", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 16, imm_mode,
                    instr & BIT(34),
                    instr & BIT(35));
     break;

    
   case 0xc1:

            fputs("CUBEFACE2", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 16, imm_mode,
                    instr & BIT(34),
                    instr & BIT(35));
     break;

    
   case 0xc2:
	secondary_opc = (instr >> 24) & 0xf;


        if (secondary_opc == 0) { 
            fputs("IDP.v4s8", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
        }


        if (secondary_opc == 1) { 
            fputs("IDP.v4u8", fp);
            if (instr & BIT(30)) fputs(".saturate", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
        }
     break;

    
   case 0xf0:

            fputs("ICMP.u32", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            fputs(valhall_result_type[(instr >> 30) & 0x3], fp);
            if (instr & BIT(24)) fputs(".and", fp);
            if (instr & BIT(25)) fputs(".seq", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0xf1:

            fputs("ICMP.v2u16", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            fputs(valhall_result_type[(instr >> 30) & 0x3], fp);
            if (instr & BIT(24)) fputs(".and", fp);
            if (instr & BIT(25)) fputs(".seq", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0xf2:

            fputs("ICMP.v4u8", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            fputs(valhall_result_type[(instr >> 30) & 0x3], fp);
            if (instr & BIT(24)) fputs(".and", fp);
            if (instr & BIT(25)) fputs(".seq", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0xf4:

            fputs("FCMP.f32", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            fputs(valhall_result_type[(instr >> 30) & 0x3], fp);
            if (instr & BIT(24)) fputs(".and", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_widen[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_widen[(instr >> 26) & 3], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0xf5:

            fputs("FCMP.v2f16", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            fputs(valhall_result_type[(instr >> 30) & 0x3], fp);
            if (instr & BIT(24)) fputs(".and", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(valhall_swizzles_16_bit[(instr >> 28) & 3], fp);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(valhall_swizzles_16_bit[(instr >> 26) & 3], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0xf8:

            fputs("ICMP.s32", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            fputs(valhall_result_type[(instr >> 30) & 0x3], fp);
            if (instr & BIT(24)) fputs(".and", fp);
            if (instr & BIT(25)) fputs(".seq", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_32_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0xf9:

            fputs("ICMP.v2s16", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            fputs(valhall_result_type[(instr >> 30) & 0x3], fp);
            if (instr & BIT(24)) fputs(".and", fp);
            if (instr & BIT(25)) fputs(".seq", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_16_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0xfa:

            fputs("ICMP.v4s8", fp);
            fputs(valhall_condition[(instr >> 32) & 0x7], fp);
            fputs(valhall_result_type[(instr >> 30) & 0x3], fp);
            if (instr & BIT(24)) fputs(".and", fp);
            if (instr & BIT(25)) fputs(".seq", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 36) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 8, imm_mode);
		    fputs(valhall_swizzles_8_bit[(instr >> 26) & 0xF], fp);
            fputs(", ", fp);

            va_print_src(fp, instr >> 16, imm_mode);
     break;

    
   case 0x110:

            fputs("IADD_IMM.i32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", #0x%X", (uint32_t) 
                    ((instr >> 8) & MASK(32)) );
     break;

    
   case 0x111:

            fputs("IADD_IMM.v2i16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", #0x%X", (uint32_t) 
                    ((instr >> 8) & MASK(32)) );
     break;

    
   case 0x112:

            fputs("IADD_IMM.v4i8", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", #0x%X", (uint32_t) 
                    ((instr >> 8) & MASK(32)) );
     break;

    
   case 0x114:

            fputs("FADD_IMM.f32", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", #0x%X", (uint32_t) 
                    ((instr >> 8) & MASK(32)) );
     break;

    
   case 0x115:

            fputs("FADD_IMM.v2f16", fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode, false, false);

            fprintf(fp, ", #0x%X", (uint32_t) 
                    ((instr >> 8) & MASK(32)) );
     break;

    
   case 0x69:

            fputs("TODO.ATOM_C1", fp);
            if (instr & BIT(17)) fputs(".i32", fp);
            if (instr & BIT(23)) fputs(".unk", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", operation:0x%X", (uint32_t) 
                    ((instr >> 24) & MASK(6)) );
     break;

    
   case 0x120:

            fputs("TODO.ATOM_C", fp);
            if (instr & BIT(17)) fputs(".i32", fp);
            if (instr & BIT(23)) fputs(".unk", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 192);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);

            fprintf(fp, ", operation:0x%X", (uint32_t) 
                    ((instr >> 24) & MASK(6)) );
     break;

    
   case 0x125:

            fputs("TEX_FETCH", fp);
            if (instr & BIT(11)) fputs(".explicit_offset", fp);
            fputs(valhall_dimension[(instr >> 28) & 0x3], fp);
            if (instr & BIT(39)) fputs(".skip", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

//            assert(((instr >> 16) & 0xC0) == 192);
            for (unsigned i = 0; i < 4; ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 16) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
     break;

    
   case 0x128:

            fputs("TEX", fp);
            if (instr & BIT(11)) fputs(".explicit_offset", fp);
            if (instr & BIT(12)) fputs(".shadow", fp);
            fputs(valhall_lod_mode[(instr >> 13) & 0x7], fp);
            fputs(valhall_dimension[(instr >> 28) & 0x3], fp);
            if (instr & BIT(39)) fputs(".skip", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 64);
            for (unsigned i = 0; i < ((instr >> 33) & MASK(3)); ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

//            assert(((instr >> 16) & 0xC0) == 192);
            for (unsigned i = 0; i < 4; ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 16) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
     break;

    
   case 0x130:

            fputs("TODO.VAR_TEX", fp);
            fputs(valhall_dimension[(instr >> 28) & 0x3], fp);
            if (instr & BIT(39)) fputs(".skip", fp);
            fputs(valhall_slot[(instr >> 30) & 0x7], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

//            assert(((instr >> 40) & 0xC0) == 128);
            for (unsigned i = 0; i < 4; ++i) {
                fprintf(fp, "%sr%u", (i == 0) ? "@" : ":",
                        (uint32_t) (((instr >> 40) & 0x3F) + i));
            }
            fputs(", ", fp);

            va_print_src(fp, instr >> 0, imm_mode);
     break;

    
   case 0x160:

            fputs("FMA_RSCALE.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 16, imm_mode,
                    instr & BIT(34),
                    instr & BIT(35));
            fputs(", ", fp);

            va_print_src(fp, instr >> 24, imm_mode);
     break;

    
   case 0x161:

            fputs("FMA_RSCALE_N.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 16, imm_mode,
                    instr & BIT(34),
                    instr & BIT(35));
            fputs(", ", fp);

            va_print_src(fp, instr >> 24, imm_mode);
     break;

    
   case 0x162:

            fputs("FMA_RSCALE_LEFT.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 16, imm_mode,
                    instr & BIT(34),
                    instr & BIT(35));
            fputs(", ", fp);

            va_print_src(fp, instr >> 24, imm_mode);
     break;

    
   case 0x163:

            fputs("FMA_RSCALE_SCALE16.f32", fp);
            fputs(valhall_clamp[(instr >> 32) & 0x3], fp);
            va_print_metadata(fp, instr >> 56);
            fputs(" ", fp);

            va_print_dest(fp, (instr >> 40), true);
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 0, imm_mode,
                    instr & BIT(38),
                    instr & BIT(39));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 8, imm_mode,
                    instr & BIT(36),
                    instr & BIT(37));
            fputs(", ", fp);

            va_print_float_src(fp, instr >> 16, imm_mode,
                    instr & BIT(34),
                    instr & BIT(35));
            fputs(", ", fp);

            va_print_src(fp, instr >> 24, imm_mode);
     break;

   }
}

