/* This file is autogenerated by sid_tables.py from sid.h. Do not edit directly. */

/*
 * Copyright 2015-2019 Advanced Micro Devices, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * on the rights to use, copy, modify, merge, publish, distribute, sub
 * license, and/or sell copies of the Software, and to permit persons to whom
 * the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) AND/OR THEIR SUPPLIERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
 * USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef SID_TABLES_H
#define SID_TABLES_H

struct si_field {
        unsigned name_offset;
        unsigned mask;
        unsigned num_values;
        unsigned values_offset; /* offset into sid_strings_offsets */
};

struct si_reg {
        unsigned name_offset;
        unsigned offset;
        unsigned num_fields;
        unsigned fields_offset;
};

struct si_packet3 {
        unsigned name_offset;
        unsigned op;
};

static const struct si_packet3 packet3_table[] = {
	{0, PKT3_NOP},
	{4, PKT3_SET_BASE},
	{13, PKT3_CLEAR_STATE},
	{25, PKT3_INDEX_BUFFER_SIZE},
	{43, PKT3_DISPATCH_DIRECT},
	{59, PKT3_DISPATCH_INDIRECT},
	{77, PKT3_OCCLUSION_QUERY},
	{93, PKT3_SET_PREDICATION},
	{109, PKT3_COND_EXEC},
	{119, PKT3_PRED_EXEC},
	{129, PKT3_DRAW_INDIRECT},
	{143, PKT3_DRAW_INDEX_INDIRECT},
	{163, PKT3_INDEX_BASE},
	{174, PKT3_DRAW_INDEX_2},
	{187, PKT3_CONTEXT_CONTROL},
	{203, PKT3_INDEX_TYPE},
	{214, PKT3_DRAW_INDIRECT_MULTI},
	{234, PKT3_DRAW_INDEX_AUTO},
	{250, PKT3_DRAW_INDEX_IMMD},
	{266, PKT3_NUM_INSTANCES},
	{280, PKT3_DRAW_INDEX_MULTI_AUTO},
	{302, PKT3_INDIRECT_BUFFER_SI},
	{321, PKT3_INDIRECT_BUFFER_CONST},
	{343, PKT3_STRMOUT_BUFFER_UPDATE},
	{365, PKT3_DRAW_INDEX_OFFSET_2},
	{385, PKT3_WRITE_DATA},
	{396, PKT3_DRAW_INDEX_INDIRECT_MULTI},
	{422, PKT3_MEM_SEMAPHORE},
	{436, PKT3_MPEG_INDEX},
	{447, PKT3_WAIT_REG_MEM},
	{460, PKT3_MEM_WRITE},
	{470, PKT3_INDIRECT_BUFFER_CIK},
	{490, PKT3_COPY_DATA},
	{500, PKT3_PFP_SYNC_ME},
	{512, PKT3_SURFACE_SYNC},
	{525, PKT3_ME_INITIALIZE},
	{539, PKT3_COND_WRITE},
	{550, PKT3_EVENT_WRITE},
	{562, PKT3_EVENT_WRITE_EOP},
	{578, PKT3_EVENT_WRITE_EOS},
	{594, PKT3_RELEASE_MEM},
	{606, PKT3_CONTEXT_REG_RMW},
	{622, PKT3_ONE_REG_WRITE},
	{636, PKT3_ACQUIRE_MEM},
	{648, PKT3_REWIND},
	{655, PKT3_LOAD_UCONFIG_REG},
	{672, PKT3_LOAD_SH_REG},
	{684, PKT3_LOAD_CONTEXT_REG},
	{701, PKT3_SET_CONFIG_REG},
	{716, PKT3_SET_CONTEXT_REG},
	{732, PKT3_SET_SH_REG},
	{743, PKT3_SET_SH_REG_OFFSET},
	{761, PKT3_SET_UCONFIG_REG},
	{777, PKT3_SET_UCONFIG_REG_INDEX},
	{799, PKT3_LOAD_CONST_RAM},
	{814, PKT3_WRITE_CONST_RAM},
	{830, PKT3_DUMP_CONST_RAM},
	{845, PKT3_INCREMENT_CE_COUNTER},
	{866, PKT3_INCREMENT_DE_COUNTER},
	{887, PKT3_WAIT_ON_CE_COUNTER},
	{906, PKT3_SET_SH_REG_INDEX},
	{923, PKT3_LOAD_CONTEXT_REG_INDEX},
	{946, PKT3_IT_OPCODE_C},
	{958, PKT3_CP_DMA},
	{965, PKT3_DMA_DATA},
};

static const struct si_reg gfx10_reg_table[] = {
	{974, 1028, 10, 0},
	{987, 1032, 20, 10},
	{1002, 1036, 10, 30},
	{1018, 1040, 12, 40},
	{1039, 1044, 4, 52},
	{1057, 1048, 3, 56},
	{1075, 1052, 11, 59},
	{1090, 1056},
	{1104, 1060, 1, 70},
	{1118, 1064},
	{1135, 1076, 9, 71},
	{1151, 1080},
	{1168, 1116, 5, 80},
	{1183, 1120, 7, 85},
	{1198, 1124, 2, 92},
	{1218, 1128, 1, 94},
	{1237, 1132, 4, 95},
	{1257, 1136, 7, 99},
	{1273, 2480},
	{1287, 2484},
	{1301, 2488},
	{1315, 2492},
	{1329, 2496},
	{1343, 2500},
	{1357, 2504},
	{1371, 2508},
	{1385, 2512},
	{1399, 2516},
	{1413, 2520},
	{1428, 2524},
	{1443, 2528},
	{1458, 2532},
	{1473, 2536},
	{1488, 2540},
	{1503, 2544},
	{1514, 2552},
	{1530, 2556},
	{1546, 2560},
	{1570, 2564},
	{1594, 2568},
	{1618, 32776, 27, 106},
	{1631, 32784, 21, 133},
	{1643, 32788, 14, 154},
	{1659, 32792, 14, 154},
	{1675, 32796, 15, 168},
	{1688, 32824, 14, 154},
	{1704, 32828, 14, 154},
	{1720, 33296, 21, 183},
	{1734, 33300, 28, 204},
	{1751, 33304, 15, 232},
	{1772, 33308, 28, 247},
	{1786, 33312, 32, 275},
	{1803, 33316, 13, 307},
	{1824, 33320, 9, 320},
	{1842, 33324, 1, 329},
	{1865, 33344, 2, 330},
	{1886, 33348},
	{1906, 33352, 1, 332},
	{1929, 33356, 9, 333},
	{1947, 33436, 1, 342},
	{1970, 36096},
	{1996, 36100, 2, 343},
	{2022, 36104},
	{2048, 36108, 2, 343},
	{2074, 36112, 2, 345},
	{2095, 36116, 4, 347},
	{2116, 36120, 4, 351},
	{2143, 36124, 17, 355},
	{2164, 36128, 6, 372},
	{2187, 36132},
	{2216, 36140},
	{2246, 36144},
	{2278, 36148},
	{2309, 36152},
	{2342, 36348, 5, 378},
	{2351, 36608},
	{2369, 36612, 4, 383},
	{2387, 36616},
	{2405, 36620, 10, 387},
	{2423, 36656, 14, 397},
	{2441, 36660, 4, 411},
	{2459, 36664, 12, 415},
	{2477, 36668, 2, 427},
	{2495, 37120, 9, 429},
	{2511, 39160, 5, 438},
	{2526, 39184, 5, 443},
	{2540, 39188, 5, 443},
	{2554, 39192, 5, 443},
	{2568, 39196, 5, 443},
	{2582, 39200, 5, 443},
	{2596, 39204, 5, 443},
	{2610, 39208, 5, 443},
	{2624, 39212, 5, 443},
	{2638, 39216, 5, 443},
	{2652, 39220, 5, 443},
	{2666, 39224, 5, 443},
	{2681, 39228, 5, 443},
	{2696, 39232, 5, 443},
	{2711, 39236, 5, 443},
	{2726, 39240, 5, 443},
	{2741, 39244, 5, 443},
	{2756, 39248, 5, 443},
	{2771, 39252, 5, 443},
	{2786, 39256, 5, 443},
	{2801, 39260, 5, 443},
	{2816, 39264, 5, 443},
	{2831, 39268, 5, 443},
	{2846, 39272, 5, 443},
	{2861, 39276, 5, 443},
	{2876, 39280, 5, 443},
	{2891, 39284, 5, 443},
	{2906, 39288, 5, 443},
	{2921, 39292, 5, 443},
	{2936, 39296, 5, 443},
	{2951, 39300, 5, 443},
	{2966, 39304, 5, 443},
	{2981, 39308, 5, 443},
	{2996, 39312, 4, 448},
	{3015, 39316, 4, 448},
	{3034, 39320, 4, 448},
	{3053, 39324, 4, 448},
	{3072, 39328, 4, 448},
	{3091, 39332, 4, 448},
	{3110, 39336, 4, 448},
	{3129, 39340, 4, 448},
	{3148, 39344, 4, 448},
	{3167, 39348, 4, 448},
	{3186, 39352, 4, 448},
	{3206, 39356, 4, 448},
	{3226, 39360, 4, 448},
	{3246, 39364, 4, 448},
	{3266, 39368, 4, 448},
	{3286, 39372, 4, 448},
	{3306, 40960},
	{3324, 40964, 4, 452},
	{3342, 40968, 3, 456},
	{3360, 40972, 9, 459},
	{3378, 40976, 2, 468},
	{3396, 40980, 7, 470},
	{3414, 40984, 10, 477},
	{3432, 40988},
	{3450, 45060, 1, 487},
	{3474, 45080},
	{3499, 45084, 3, 488},
	{3523, 45088},
	{3544, 45092, 1, 491},
	{3565, 45096, 11, 492},
	{3589, 45100, 10, 503},
	{3613, 45104},
	{3639, 45108},
	{3665, 45112},
	{3691, 45116},
	{3717, 45120},
	{3743, 45124},
	{3769, 45128},
	{3795, 45132},
	{3821, 45136},
	{3847, 45140},
	{3873, 45144},
	{3900, 45148},
	{3927, 45152},
	{3954, 45156},
	{3981, 45160},
	{4008, 45164},
	{4035, 45168},
	{4062, 45172},
	{4089, 45176},
	{4116, 45180},
	{4143, 45184},
	{4170, 45188},
	{4197, 45192},
	{4224, 45196},
	{4251, 45200},
	{4278, 45204},
	{4305, 45208},
	{4332, 45212},
	{4359, 45216},
	{4386, 45220},
	{4413, 45224},
	{4440, 45228},
	{4467, 45248, 8, 513},
	{4490, 45252, 5, 521},
	{4523, 45256, 1, 526},
	{4550, 45260, 1, 526},
	{4577, 45264, 1, 526},
	{4604, 45268, 1, 526},
	{4631, 45316, 1, 487},
	{4655, 45332},
	{4680, 45336, 3, 488},
	{4704, 45340, 1, 527},
	{4729, 45344},
	{4750, 45348, 1, 491},
	{4771, 45352, 12, 528},
	{4795, 45356, 14, 540},
	{4819, 45360},
	{4845, 45364},
	{4871, 45368},
	{4897, 45372},
	{4923, 45376},
	{4949, 45380},
	{4975, 45384},
	{5001, 45388},
	{5027, 45392},
	{5053, 45396},
	{5079, 45400},
	{5106, 45404},
	{5133, 45408},
	{5160, 45412},
	{5187, 45416},
	{5214, 45420},
	{5241, 45424},
	{5268, 45428},
	{5295, 45432},
	{5322, 45436},
	{5349, 45440},
	{5376, 45444},
	{5403, 45448},
	{5430, 45452},
	{5457, 45456},
	{5484, 45460},
	{5511, 45464},
	{5538, 45468},
	{5565, 45472},
	{5592, 45476},
	{5619, 45480},
	{5646, 45484},
	{5673, 45504, 8, 513},
	{5696, 45508, 5, 521},
	{5729, 45512, 1, 526},
	{5756, 45516, 1, 526},
	{5783, 45520, 1, 526},
	{5810, 45524, 1, 526},
	{5837, 45548, 9, 554},
	{5864, 45552, 6, 563},
	{5891, 45556, 5, 569},
	{5918, 45568},
	{5943, 45572, 2, 574},
	{5967, 45576},
	{5999, 45580},
	{6031, 45584},
	{6055, 45588, 1, 491},
	{6079, 45596, 4, 576},
	{6103, 45600},
	{6124, 45604, 1, 491},
	{6145, 45608, 13, 580},
	{6169, 45612, 9, 593},
	{6193, 45616},
	{6219, 45620},
	{6245, 45624},
	{6271, 45628},
	{6297, 45632},
	{6323, 45636},
	{6349, 45640},
	{6375, 45644},
	{6401, 45648},
	{6427, 45652},
	{6453, 45656},
	{6480, 45660},
	{6507, 45664},
	{6534, 45668},
	{6561, 45672},
	{6588, 45676},
	{6615, 45680},
	{6642, 45684},
	{6669, 45688},
	{6696, 45692},
	{6723, 45696},
	{6750, 45700},
	{6777, 45704},
	{6804, 45708},
	{6831, 45712},
	{6858, 45716},
	{6885, 45720},
	{6912, 45724},
	{6939, 45728},
	{6966, 45732},
	{6993, 45736},
	{7020, 45740},
	{7047, 45760, 8, 513},
	{7072, 45764, 5, 521},
	{7107, 45768, 1, 526},
	{7136, 45772, 1, 526},
	{7165, 45776, 1, 526},
	{7194, 45780, 1, 526},
	{7223, 45808, 6, 563},
	{7250, 45852, 4, 576},
	{7274, 45856},
	{7295, 45860, 1, 491},
	{7316, 45864, 10, 602},
	{7340, 45868, 6, 563},
	{7364, 45872},
	{7390, 45876},
	{7416, 45880},
	{7442, 45884},
	{7468, 45888},
	{7494, 45892},
	{7520, 45896},
	{7546, 45900},
	{7572, 45904},
	{7598, 45908},
	{7624, 45912},
	{7651, 45916},
	{7678, 45920},
	{7705, 45924},
	{7732, 45928},
	{7759, 45932},
	{7786, 46068, 5, 569},
	{7813, 46080},
	{7838, 46084, 1, 487},
	{7862, 46088},
	{7894, 46092},
	{7926, 46096},
	{7950, 46100, 1, 491},
	{7974, 46108, 4, 612},
	{7998, 46112},
	{8019, 46116, 1, 491},
	{8040, 46120, 12, 616},
	{8064, 46124, 9, 628},
	{8088, 46128},
	{8114, 46132},
	{8140, 46136},
	{8166, 46140},
	{8192, 46144},
	{8218, 46148},
	{8244, 46152},
	{8270, 46156},
	{8296, 46160},
	{8322, 46164},
	{8348, 46168},
	{8375, 46172},
	{8402, 46176},
	{8429, 46180},
	{8456, 46184},
	{8483, 46188},
	{8510, 46192},
	{8537, 46196},
	{8564, 46200},
	{8591, 46204},
	{8618, 46208},
	{8645, 46212},
	{8672, 46216},
	{8699, 46220},
	{8726, 46224},
	{8753, 46228},
	{8780, 46232},
	{8807, 46236},
	{8834, 46240},
	{8861, 46244},
	{8888, 46248},
	{8915, 46252},
	{8942, 46272, 8, 513},
	{8967, 46276, 5, 521},
	{9002, 46280, 1, 526},
	{9031, 46284, 1, 526},
	{9060, 46288, 1, 526},
	{9089, 46292, 1, 526},
	{9118, 46324, 5, 569},
	{9145, 46364, 4, 576},
	{9169, 46368},
	{9190, 46372, 1, 491},
	{9211, 46376, 9, 637},
	{9235, 46380, 5, 569},
	{9259, 46384},
	{9285, 46388},
	{9311, 46392},
	{9337, 46396},
	{9363, 46400},
	{9389, 46404},
	{9415, 46408},
	{9441, 46412},
	{9467, 46416},
	{9493, 46420},
	{9519, 46424},
	{9546, 46428},
	{9573, 46432},
	{9600, 46436},
	{9627, 46440},
	{9654, 46444},
	{9681, 47104, 13, 646},
	{9708, 47108},
	{9722, 47112},
	{9736, 47116},
	{9750, 47120},
	{9766, 47124},
	{9782, 47128},
	{9798, 47132, 2, 659},
	{9819, 47136, 2, 659},
	{9840, 47140, 2, 659},
	{9861, 47144, 1, 661},
	{9889, 47148, 1, 662},
	{9914, 47152},
	{9929, 47156, 1, 663},
	{9944, 47160},
	{9973, 47164, 1, 663},
	{10002, 47168},
	{10035, 47172, 1, 663},
	{10068, 47176, 12, 664},
	{10086, 47180, 11, 676},
	{10104, 47184, 1, 687},
	{10117, 47188, 6, 688},
	{10141, 47192},
	{10168, 47196},
	{10195, 47200, 2, 694},
	{10216, 47204},
	{10243, 47208},
	{10270, 47212},
	{10288, 47216},
	{10306, 47220},
	{10324, 47224, 1, 696},
	{10352, 47228, 5, 697},
	{10374, 47232},
	{10394, 47236},
	{10417, 47240, 9, 702},
	{10434, 47248, 1, 526},
	{10455, 47252, 1, 526},
	{10476, 47256, 1, 526},
	{10497, 47260, 1, 526},
	{10518, 47264, 1, 711},
	{10536, 47268, 1, 712},
	{10555, 47272},
	{10577, 47276, 3, 713},
	{10594, 47280},
	{10623, 47284, 1, 716},
	{10652, 47288, 3, 713},
	{10670, 47360},
	{10690, 47364},
	{10710, 47368},
	{10730, 47372},
	{10750, 47376},
	{10770, 47380},
	{10790, 47384},
	{10810, 47388},
	{10830, 47392},
	{10850, 47396},
	{10870, 47400},
	{10891, 47404},
	{10912, 47408},
	{10933, 47412},
	{10954, 47416},
	{10975, 47420},
	{10996, 47604, 2, 717},
	{11020, 47608},
	{11041, 47612},
	{11057, 163840, 10, 719},
	{11075, 163844, 11, 729},
	{11092, 163848, 7, 740},
	{11106, 163852, 23, 747},
	{11125, 163856, 16, 770},
	{11145, 163860},
	{11164, 163868, 2, 786},
	{11181, 163872},
	{11201, 163876},
	{11221, 163880, 1, 788},
	{11238, 163884},
	{11253, 163888, 2, 789},
	{11277, 163892, 2, 791},
	{11301, 163896, 3, 793},
	{11317, 163900, 8, 796},
	{11335, 163904, 14, 804},
	{11345, 163908, 9, 818},
	{11361, 163912},
	{11376, 163916},
	{11397, 163920},
	{11413, 163924},
	{11435, 163928, 2, 827},
	{11453, 163932, 1, 829},
	{11471, 163944, 1, 830},
	{11489, 163948, 1, 830},
	{11513, 163952, 1, 830},
	{11532, 163956, 1, 830},
	{11557, 163960, 1, 830},
	{11579, 163964, 9, 831},
	{11603, 163968},
	{11619, 163972, 1, 840},
	{11638, 164328, 1, 841},
	{11659, 164332, 1, 841},
	{11680, 164336, 1, 841},
	{11701, 164340, 1, 841},
	{11722, 164344},
	{11740, 164348},
	{11758, 164352, 2, 842},
	{11778, 164356, 3, 844},
	{11802, 164360, 2, 847},
	{11826, 164364, 1, 849},
	{11846, 164368, 2, 844},
	{11866, 164372, 2, 847},
	{11886, 164376, 2, 844},
	{11906, 164380, 2, 847},
	{11926, 164384, 2, 844},
	{11946, 164388, 2, 847},
	{11966, 164392, 2, 844},
	{11986, 164396, 2, 847},
	{12006, 164400, 7, 850},
	{12021, 164404, 2, 857},
	{12050, 164408, 8, 859},
	{12065, 164412, 8, 867},
	{12080, 164416, 3, 844},
	{12105, 164420, 2, 847},
	{12130, 164424},
	{12148, 164428},
	{12166, 164432, 3, 844},
	{12191, 164436, 2, 847},
	{12216, 164440, 3, 844},
	{12241, 164444, 2, 847},
	{12266, 164448, 3, 844},
	{12291, 164452, 2, 847},
	{12316, 164456, 3, 844},
	{12341, 164460, 2, 847},
	{12366, 164464, 3, 844},
	{12391, 164468, 2, 847},
	{12416, 164472, 3, 844},
	{12441, 164476, 2, 847},
	{12466, 164480, 3, 844},
	{12491, 164484, 2, 847},
	{12516, 164488, 3, 844},
	{12541, 164492, 2, 847},
	{12566, 164496, 3, 844},
	{12591, 164500, 2, 847},
	{12616, 164504, 3, 844},
	{12641, 164508, 2, 847},
	{12666, 164512, 3, 844},
	{12692, 164516, 2, 847},
	{12718, 164520, 3, 844},
	{12744, 164524, 2, 847},
	{12770, 164528, 3, 844},
	{12796, 164532, 2, 847},
	{12822, 164536, 3, 844},
	{12848, 164540, 2, 847},
	{12874, 164544, 3, 844},
	{12900, 164548, 2, 847},
	{12926, 164552, 3, 844},
	{12952, 164556, 2, 847},
	{12978, 164560},
	{12997, 164564},
	{13016, 164568},
	{13035, 164572},
	{13054, 164576},
	{13073, 164580},
	{13092, 164584},
	{13111, 164588},
	{13130, 164592},
	{13149, 164596},
	{13168, 164600},
	{13187, 164604},
	{13206, 164608},
	{13225, 164612},
	{13244, 164616},
	{13263, 164620},
	{13282, 164624},
	{13301, 164628},
	{13320, 164632},
	{13339, 164636},
	{13358, 164640},
	{13378, 164644},
	{13398, 164648},
	{13418, 164652},
	{13438, 164656},
	{13458, 164660},
	{13478, 164664},
	{13498, 164668},
	{13518, 164672},
	{13538, 164676},
	{13558, 164680},
	{13578, 164684},
	{13598, 164688, 15, 875},
	{13618, 164692, 3, 890},
	{13640, 164696, 2, 893},
	{13668, 164700, 7, 895},
	{13697, 164704, 1, 902},
	{13718, 164708, 1, 903},
	{13728, 164712, 1, 904},
	{13736, 164768, 4, 905},
	{13758, 164772, 4, 905},
	{13779, 164776, 4, 909},
	{13796, 164864},
	{13813, 164868},
	{13830, 164872},
	{13846, 164876},
	{13875, 164880, 10, 913},
	{13900, 164884},
	{13913, 164888},
	{13928, 164892},
	{13942, 164896},
	{13957, 164900, 8, 923},
	{13972, 164904, 4, 931},
	{13996, 164908, 6, 935},
	{14015, 164912, 4, 941},
	{14033, 164916, 4, 945},
	{14054, 164924},
	{14073, 164928},
	{14093, 164932},
	{14112, 164936},
	{14132, 164940},
	{14151, 164944},
	{14171, 164948},
	{14192, 164952},
	{14214, 164956},
	{14235, 164960},
	{14257, 164964},
	{14278, 164968},
	{14300, 164972},
	{14321, 164976},
	{14343, 164980},
	{14364, 164984},
	{14386, 164988},
	{14407, 164992},
	{14429, 164996},
	{14450, 165000},
	{14472, 165004},
	{14493, 165008},
	{14515, 165012},
	{14536, 165016},
	{14558, 165020},
	{14579, 165024},
	{14601, 165028},
	{14622, 165032},
	{14644, 165036},
	{14665, 165040},
	{14687, 165044},
	{14708, 165048},
	{14730, 165052},
	{14751, 165056},
	{14773, 165060},
	{14794, 165064},
	{14816, 165068},
	{14837, 165072},
	{14859, 165076},
	{14880, 165080},
	{14902, 165084},
	{14923, 165088},
	{14945, 165092},
	{14966, 165096},
	{14988, 165100},
	{15009, 165104},
	{15031, 165108},
	{15052, 165112},
	{15074, 165116},
	{15095, 165120},
	{15117, 165124},
	{15138, 165128},
	{15160, 165132},
	{15181, 165136},
	{15203, 165140},
	{15224, 165144},
	{15246, 165148},
	{15267, 165152},
	{15289, 165156},
	{15310, 165160},
	{15332, 165164},
	{15354, 165168},
	{15377, 165172},
	{15399, 165176},
	{15422, 165180},
	{15444, 165184},
	{15467, 165188},
	{15489, 165192},
	{15512, 165196},
	{15534, 165200},
	{15557, 165204},
	{15579, 165208},
	{15602, 165212},
	{15624, 165216},
	{15647, 165220},
	{15669, 165224},
	{15692, 165228},
	{15714, 165232},
	{15737, 165236},
	{15759, 165240},
	{15782, 165244},
	{15804, 165248},
	{15827, 165252},
	{15849, 165256},
	{15872, 165260},
	{15894, 165264},
	{15917, 165268},
	{15939, 165272},
	{15962, 165276},
	{15984, 165280},
	{16007, 165284},
	{16029, 165288},
	{16052, 165292},
	{16074, 165296},
	{16097, 165300},
	{16119, 165304},
	{16142, 165308},
	{16156, 165312},
	{16170, 165316},
	{16184, 165320},
	{16198, 165324},
	{16212, 165328},
	{16226, 165332},
	{16240, 165336},
	{16254, 165340},
	{16268, 165344},
	{16282, 165348},
	{16296, 165352},
	{16310, 165356},
	{16324, 165360},
	{16338, 165364},
	{16352, 165368},
	{16366, 165372},
	{16380, 165376},
	{16394, 165380},
	{16408, 165384},
	{16422, 165388},
	{16436, 165392},
	{16450, 165396},
	{16464, 165400},
	{16478, 165404},
	{16501, 165444, 12, 949},
	{16521, 165448, 12, 949},
	{16541, 165452, 12, 949},
	{16561, 165456, 12, 949},
	{16581, 165460, 12, 949},
	{16601, 165464, 12, 949},
	{16621, 165468, 12, 949},
	{16641, 165472, 12, 949},
	{16661, 165476, 12, 949},
	{16681, 165480, 12, 949},
	{16701, 165484, 12, 949},
	{16722, 165488, 12, 949},
	{16743, 165492, 12, 949},
	{16764, 165496, 12, 949},
	{16785, 165500, 12, 949},
	{16806, 165504, 12, 949},
	{16827, 165508, 12, 949},
	{16848, 165512, 12, 949},
	{16869, 165516, 12, 949},
	{16890, 165520, 12, 949},
	{16911, 165524, 9, 961},
	{16932, 165528, 9, 961},
	{16953, 165532, 9, 961},
	{16974, 165536, 9, 961},
	{16995, 165540, 9, 961},
	{17016, 165544, 9, 961},
	{17037, 165548, 9, 961},
	{17058, 165552, 9, 961},
	{17079, 165556, 9, 961},
	{17100, 165560, 9, 961},
	{17121, 165564, 9, 961},
	{17142, 165568, 9, 961},
	{17163, 165572, 3, 970},
	{17181, 165580, 16, 973},
	{17198, 165584, 16, 973},
	{17216, 165588, 7, 989},
	{17237, 165592, 6, 996},
	{17255, 165600, 7, 1002},
	{17270, 165608, 2, 694},
	{17287, 165640, 1, 1009},
	{17309, 165644, 5, 1010},
	{17331, 165648, 1, 1015},
	{17351, 165652, 8, 1016},
	{17373, 165716, 8, 1024},
	{17391, 165720, 8, 1032},
	{17412, 165724, 17, 1040},
	{17433, 165728, 6, 1057},
	{17451, 165732, 6, 1057},
	{17469, 165736, 6, 1057},
	{17487, 165740, 6, 1057},
	{17505, 165744, 6, 1057},
	{17523, 165748, 6, 1057},
	{17541, 165752, 6, 1057},
	{17559, 165756, 6, 1057},
	{17577, 165760, 9, 1063},
	{17595, 165764, 9, 1063},
	{17613, 165768, 9, 1063},
	{17631, 165772, 9, 1063},
	{17649, 165776, 9, 1063},
	{17667, 165780, 9, 1063},
	{17685, 165784, 9, 1063},
	{17703, 165788, 9, 1063},
	{17721, 165836, 1, 1072},
	{17735, 165840, 1, 1072},
	{17750, 165844},
	{17768, 165848},
	{17786, 165852},
	{17803, 165856},
	{17824, 165860, 1, 1073},
	{17840, 165864},
	{17853, 165872, 8, 1074},
	{17872, 165876},
	{17887, 165880, 1, 1082},
	{17909, 165884, 1, 1083},
	{17936, 165888, 10, 1084},
	{17953, 165892, 12, 1094},
	{17961, 165896, 4, 1106},
	{17978, 165900, 17, 1110},
	{17996, 165904, 20, 1127},
	{18012, 165908, 16, 1147},
	{18031, 165912, 10, 1163},
	{18046, 165916, 28, 1173},
	{18064, 165920, 16, 1201},
	{18082, 165924, 4, 1217},
	{18106, 165928},
	{18131, 165932, 11, 1221},
	{18154, 165936, 7, 1232},
	{18183, 165940, 2, 1239},
	{18205, 165944, 2, 1241},
	{18220, 165948, 5, 1243},
	{18250, 165952, 5, 1248},
	{18265, 165956},
	{18283, 166400, 2, 1253},
	{18300, 166404, 2, 1255},
	{18319, 166408, 1, 1257},
	{18335, 166412, 4, 1258},
	{18354, 166416, 1, 1262},
	{18375, 166420, 1, 1263},
	{18388, 166424},
	{18411, 166428},
	{18434, 166432, 1, 1264},
	{18454, 166436, 4, 1265},
	{18474, 166440, 1, 1269},
	{18495, 166444, 1, 1270},
	{18510, 166448, 6, 1271},
	{18532, 166452, 6, 1271},
	{18554, 166456, 8, 1277},
	{18580, 166460, 8, 1277},
	{18606, 166464, 15, 1285},
	{18618, 166468, 3, 1300},
	{18637, 166472, 7, 1303},
	{18655, 166476, 24, 1310},
	{18673, 166480},
	{18685, 166484, 1, 1334},
	{18699, 166488, 1, 1335},
	{18713, 166492, 1, 1336},
	{18727, 166496, 1, 1337},
	{18750, 166500, 1, 1337},
	{18773, 166504, 1, 1337},
	{18796, 166508, 5, 1338},
	{18817, 166512},
	{18828, 166516},
	{18841, 166520},
	{18858, 166524, 8, 1343},
	{18877, 166528},
	{18888, 166532, 3, 1351},
	{18907, 166536},
	{18929, 166540},
	{18951, 166544, 3, 1354},
	{18971, 166548, 2, 1357},
	{18998, 166552, 5, 1359},
	{19020, 166560},
	{19045, 166564},
	{19070, 166568, 6, 1364},
	{19089, 166572, 1, 1370},
	{19112, 166576, 1, 1370},
	{19135, 166580, 1, 1371},
	{19149, 166584, 1, 1372},
	{19164, 166588, 9, 1373},
	{19181, 166592, 4, 1382},
	{19208, 166596, 4, 1386},
	{19235, 166600, 4, 1390},
	{19254, 166608},
	{19280, 166612, 1, 1394},
	{19305, 166620},
	{19333, 166624},
	{19359, 166628, 1, 1394},
	{19384, 166636},
	{19412, 166640},
	{19438, 166644, 1, 1394},
	{19463, 166652},
	{19491, 166656},
	{19517, 166660, 1, 1394},
	{19542, 166668},
	{19570, 166696},
	{19601, 166700},
	{19644, 166704, 1, 1395},
	{19682, 166712, 1, 1396},
	{19702, 166732, 2, 1397},
	{19721, 166736, 5, 1399},
	{19743, 166740, 19, 1404},
	{19764, 166744, 3, 1423},
	{19781, 166748, 1, 1370},
	{19802, 166752, 1, 1370},
	{19825, 166756, 1, 1370},
	{19848, 166760, 1, 1370},
	{19871, 166764, 12, 1426},
	{19884, 166768, 6, 1438},
	{19901, 166772},
	{19925, 166776, 2, 1444},
	{19955, 166780},
	{19979, 166784},
	{20009, 166788},
	{20040, 166792},
	{20069, 166796},
	{20099, 166800, 3, 1446},
	{20119, 166804, 8, 1449},
	{20138, 166808, 4, 1457},
	{20164, 166812, 3, 1354},
	{20188, 166868, 8, 1461},
	{20214, 166872, 8, 1469},
	{20240, 166876, 5, 1477},
	{20256, 166880, 6, 1482},
	{20272, 166884, 3, 1488},
	{20287, 166888},
	{20310, 166892},
	{20333, 166896},
	{20356, 166900},
	{20379, 166904, 8, 1491},
	{20413, 166908, 8, 1499},
	{20447, 166912, 8, 1507},
	{20481, 166916, 8, 1515},
	{20515, 166920, 8, 1491},
	{20549, 166924, 8, 1499},
	{20583, 166928, 8, 1507},
	{20617, 166932, 8, 1515},
	{20651, 166936, 8, 1491},
	{20685, 166940, 8, 1499},
	{20719, 166944, 8, 1507},
	{20753, 166948, 8, 1515},
	{20787, 166952, 8, 1491},
	{20821, 166956, 8, 1499},
	{20855, 166960, 8, 1507},
	{20889, 166964, 8, 1515},
	{20923, 166968, 2, 1523},
	{20947, 166972, 2, 1525},
	{20971, 166976, 4, 1527},
	{20992, 166980, 12, 1531},
	{21012, 166984, 2, 1543},
	{21032, 166988, 20, 1545},
	{21070, 166992, 2, 1565},
	{21090, 167000, 1, 1567},
	{21118, 167004, 1, 1568},
	{21139, 167008},
	{21154, 167012, 2, 1569},
	{21170, 167016, 1, 1571},
	{21186, 167020, 3, 1572},
	{21201, 167024, 19, 1575},
	{21216, 167028, 8, 1594},
	{21233, 167032, 12, 1602},
	{21255, 167036},
	{21271, 167040, 1, 1614},
	{21293, 167044},
	{21309, 167048, 1, 1571},
	{21331, 167052},
	{21353, 167056},
	{21375, 167060},
	{21394, 167068},
	{21409, 167072, 2, 1569},
	{21425, 167076, 1, 1571},
	{21441, 167080, 3, 1572},
	{21456, 167084, 19, 1575},
	{21471, 167088, 8, 1594},
	{21488, 167092, 12, 1602},
	{21510, 167096},
	{21526, 167100, 1, 1614},
	{21548, 167104},
	{21564, 167108, 1, 1571},
	{21586, 167112},
	{21608, 167116},
	{21630, 167120},
	{21649, 167128},
	{21664, 167132, 2, 1569},
	{21680, 167136, 1, 1571},
	{21696, 167140, 3, 1572},
	{21711, 167144, 19, 1575},
	{21726, 167148, 8, 1594},
	{21743, 167152, 12, 1602},
	{21765, 167156},
	{21781, 167160, 1, 1614},
	{21803, 167164},
	{21819, 167168, 1, 1571},
	{21841, 167172},
	{21863, 167176},
	{21885, 167180},
	{21904, 167188},
	{21919, 167192, 2, 1569},
	{21935, 167196, 1, 1571},
	{21951, 167200, 3, 1572},
	{21966, 167204, 19, 1575},
	{21981, 167208, 8, 1594},
	{21998, 167212, 12, 1602},
	{22020, 167216},
	{22036, 167220, 1, 1614},
	{22058, 167224},
	{22074, 167228, 1, 1571},
	{22096, 167232},
	{22118, 167236},
	{22140, 167240},
	{22159, 167248},
	{22174, 167252, 2, 1569},
	{22190, 167256, 1, 1571},
	{22206, 167260, 3, 1572},
	{22221, 167264, 19, 1575},
	{22236, 167268, 8, 1594},
	{22253, 167272, 12, 1602},
	{22275, 167276},
	{22291, 167280, 1, 1614},
	{22313, 167284},
	{22329, 167288, 1, 1571},
	{22351, 167292},
	{22373, 167296},
	{22395, 167300},
	{22414, 167308},
	{22429, 167312, 2, 1569},
	{22445, 167316, 1, 1571},
	{22461, 167320, 3, 1572},
	{22476, 167324, 19, 1575},
	{22491, 167328, 8, 1594},
	{22508, 167332, 12, 1602},
	{22530, 167336},
	{22546, 167340, 1, 1614},
	{22568, 167344},
	{22584, 167348, 1, 1571},
	{22606, 167352},
	{22628, 167356},
	{22650, 167360},
	{22669, 167368},
	{22684, 167372, 2, 1569},
	{22700, 167376, 1, 1571},
	{22716, 167380, 3, 1572},
	{22731, 167384, 19, 1575},
	{22746, 167388, 8, 1594},
	{22763, 167392, 12, 1602},
	{22785, 167396},
	{22801, 167400, 1, 1614},
	{22823, 167404},
	{22839, 167408, 1, 1571},
	{22861, 167412},
	{22883, 167416},
	{22905, 167420},
	{22924, 167428},
	{22939, 167432, 2, 1569},
	{22955, 167436, 1, 1571},
	{22971, 167440, 3, 1572},
	{22986, 167444, 19, 1575},
	{23001, 167448, 8, 1594},
	{23018, 167452, 12, 1602},
	{23040, 167456},
	{23056, 167460, 1, 1614},
	{23078, 167464},
	{23094, 167468, 1, 1571},
	{23116, 167472},
	{23138, 167476},
	{23160, 167480},
	{23179, 167488, 1, 1615},
	{23198, 167492, 1, 1615},
	{23217, 167496, 1, 1615},
	{23236, 167500, 1, 1615},
	{23255, 167504, 1, 1615},
	{23274, 167508, 1, 1615},
	{23293, 167512, 1, 1615},
	{23312, 167516, 1, 1615},
	{23331, 167520, 1, 1615},
	{23356, 167524, 1, 1615},
	{23381, 167528, 1, 1615},
	{23406, 167532, 1, 1615},
	{23431, 167536, 1, 1615},
	{23456, 167540, 1, 1615},
	{23481, 167544, 1, 1615},
	{23506, 167548, 1, 1615},
	{23531, 167552, 1, 1615},
	{23556, 167556, 1, 1615},
	{23581, 167560, 1, 1615},
	{23606, 167564, 1, 1615},
	{23631, 167568, 1, 1615},
	{23656, 167572, 1, 1615},
	{23681, 167576, 1, 1615},
	{23706, 167580, 1, 1615},
	{23731, 167584, 1, 1615},
	{23754, 167588, 1, 1615},
	{23777, 167592, 1, 1615},
	{23800, 167596, 1, 1615},
	{23823, 167600, 1, 1615},
	{23846, 167604, 1, 1615},
	{23869, 167608, 1, 1615},
	{23892, 167612, 1, 1615},
	{23915, 167616, 3, 1616},
	{23933, 167620, 3, 1616},
	{23951, 167624, 3, 1616},
	{23969, 167628, 3, 1616},
	{23987, 167632, 3, 1616},
	{24005, 167636, 3, 1616},
	{24023, 167640, 3, 1616},
	{24041, 167644, 3, 1616},
	{24059, 167648, 8, 1619},
	{24077, 167652, 8, 1619},
	{24095, 167656, 8, 1619},
	{24113, 167660, 8, 1619},
	{24131, 167664, 8, 1619},
	{24149, 167668, 8, 1619},
	{24167, 167672, 8, 1619},
	{24185, 167676, 8, 1619},
	{24203, 196608, 1, 1627},
	{24223, 196612, 1, 1628},
	{24243, 196616},
	{24263, 196620},
	{24283, 196624},
	{24304, 196628},
	{24325, 196632, 1, 1629},
	{24347, 196636, 1, 1630},
	{24369, 196640},
	{24399, 196644},
	{24429, 196648},
	{24458, 196652},
	{24487, 196656},
	{24517, 196660},
	{24547, 196664},
	{24576, 196668},
	{24605, 196672},
	{24635, 196676},
	{24665, 196680},
	{24694, 196684},
	{24723, 196688},
	{24753, 196692},
	{24783, 196696},
	{24812, 196700},
	{24841, 196704, 1, 1631},
	{24863, 196708, 1, 1632},
	{24885, 196712},
	{24908, 196716},
	{24931, 196720},
	{24954, 196724},
	{24977, 196728},
	{25000, 196732},
	{25023, 196736},
	{25047, 196740},
	{25071, 196744},
	{25095, 196748},
	{25119, 196752},
	{25143, 196756},
	{25167, 196760},
	{25191, 196764},
	{25215, 196768},
	{25237, 196772},
	{25259, 196776},
	{25280, 196780},
	{25301, 196784},
	{25325, 196788},
	{25349, 196792},
	{25373, 196796},
	{25397, 196800},
	{25421, 196804},
	{25445, 196808, 1, 1633},
	{25466, 196812, 1, 1633},
	{25489, 196816, 1, 1633},
	{25505, 196852, 1, 1634},
	{25527, 196856, 1, 1634},
	{25549, 196860, 1, 1635},
	{25565, 196864},
	{25578, 196868},
	{25591, 196872},
	{25604, 196876},
	{25617, 196880},
	{25630, 196884},
	{25643, 196888},
	{25656, 196892},
	{25669, 196896, 1, 1633},
	{25692, 196908, 1, 663},
	{25711, 196912},
	{25729, 196916},
	{25756, 196920},
	{25783, 196928, 2, 1636},
	{25796, 196932},
	{25809, 196936},
	{25832, 196940},
	{25855, 196944},
	{25883, 196948},
	{25911, 196952},
	{25939, 196956},
	{25967, 196960, 1, 1638},
	{25985, 196964, 4, 1639},
	{26003, 196968},
	{26018, 196972},
	{26042, 196976},
	{26066, 196980},
	{26085, 196984},
	{26104, 196988},
	{26128, 196992},
	{26152, 196996},
	{26176, 197000},
	{26200, 197028, 1, 1643},
	{26218, 197032, 2, 1644},
	{26236, 197036},
	{26254, 197040},
	{26272, 197044, 1, 1646},
	{26290, 197048, 2, 1647},
	{26308, 197052},
	{26326, 197056, 2, 1649},
	{26345, 197060, 5, 1651},
	{26364, 197072},
	{26388, 197076, 2, 1649},
	{26408, 197080, 5, 1651},
	{26428, 197084, 7, 1656},
	{26447, 197088, 7, 1656},
	{26465, 197092, 1, 1663},
	{26482, 197100, 1, 1664},
	{26503, 197104, 13, 1665},
	{26517, 197108},
	{26531, 197112},
	{26545, 197116, 2, 1678},
	{26561, 197120},
	{26580, 197124, 1, 1680},
	{26602, 197128},
	{26621, 197132, 1, 1681},
	{26643, 197136, 7, 1682},
	{26661, 197140},
	{26681, 197144, 1, 1680},
	{26704, 197148},
	{26724, 197152, 1, 1681},
	{26747, 197156, 7, 1682},
	{26766, 197160, 7, 1689},
	{26778, 197164, 2, 1696},
	{26795, 197168, 1, 1698},
	{26812, 197172, 1, 1699},
	{26830, 197176, 4, 1700},
	{26850, 197180, 2, 1704},
	{26867, 197184},
	{26883, 197188, 1, 1706},
	{26896, 197192, 1, 1707},
	{26910, 197196, 1, 1708},
	{26924, 197200, 1, 1709},
	{26946, 197204, 1, 1710},
	{26966, 197208, 1, 1711},
	{26988, 197212, 1, 1712},
	{27008, 197216, 1, 1707},
	{27025, 197220, 1, 1708},
	{27042, 197224},
	{27056, 197232, 2, 1713},
	{27078, 197236, 2, 1715},
	{27100, 197240, 2, 1713},
	{27123, 197244, 2, 1715},
	{27146, 197248, 2, 1713},
	{27168, 197252, 2, 1715},
	{27190, 197364, 1, 1717},
	{27211, 197368, 1, 1718},
	{27231, 197372, 1, 1719},
	{27251, 197376, 1, 1718},
	{27268, 197380, 1, 1719},
	{27285, 197384, 1, 1720},
	{27301, 197388, 1, 1721},
	{27320, 197392, 1, 1722},
	{27339, 197396, 1, 1723},
	{27356, 197400, 1, 1724},
	{27374, 197404, 1, 1725},
	{27392, 197408, 1, 1726},
	{27408, 197412, 1, 1727},
	{27426, 197416, 1, 1728},
	{27444, 197420, 1, 1729},
	{27460, 197424, 1, 1724},
	{27475, 197428, 1, 1725},
	{27490, 197432, 1, 1726},
	{27503, 197436, 1, 1727},
	{27518, 197440, 1, 1728},
	{27533, 197444, 1, 1729},
	{27546, 197448, 1, 1730},
	{27560, 197452, 1, 1731},
	{27574, 197456, 1, 1732},
	{27586, 197460, 4, 1733},
	{27609, 197464, 3, 1737},
	{27631, 197468, 1, 1740},
	{27651, 197472, 1, 1741},
	{27665, 197476, 1, 1742},
	{27679, 197480, 1, 1743},
	{27691, 197484, 1, 1744},
	{27707, 197488, 1, 1741},
	{27724, 197492, 1, 1742},
	{27741, 197496, 1, 1743},
	{27756, 197500, 1, 1744},
	{27775, 197552, 1, 1745},
	{27800, 197556, 1, 1745},
	{27824, 197560, 1, 1746},
	{27844, 197568},
	{27870, 197572, 1, 1628},
	{27899, 197576},
	{27924, 197580, 1, 1628},
	{27952, 197584},
	{27975, 197588, 1, 1628},
	{28001, 197592},
	{28023, 197596, 1, 1628},
	{28048, 197600},
	{28067, 197604, 1, 1628},
	{28089, 197608, 1, 1343},
	{28103, 197612},
	{28120, 197616, 1, 1628},
	{28140, 197620, 8, 1747},
	{28157, 197624, 13, 1755},
	{28174, 197628},
	{28191, 197632, 1, 1698},
	{28211, 197636},
	{28228, 197640, 1, 1663},
	{28248, 197644, 2, 1768},
	{28267, 197888, 8, 1770},
	{28288, 197892, 8, 1770},
	{28309, 198656, 6, 1778},
	{28324, 198912},
	{28347, 198916},
	{28370, 198920, 1, 1784},
	{28389, 198924, 1, 1343},
	{28404, 198928},
	{28437, 198932},
	{28470, 198936},
	{28503, 198940},
	{28536, 198948},
	{28552, 198952},
	{28567, 198956, 2, 1357},
	{28593, 198960},
	{28609, 198964},
	{28627, 198968, 1, 1785},
	{28648, 198972, 2, 1786},
	{28673, 198976},
	{28696, 198980},
	{28715, 198984},
	{28731, 198988, 1, 830},
	{28750, 198992},
	{28770, 198996, 1, 830},
	{28793, 199000},
	{28811, 199004, 1, 830},
	{28832, 199008, 9, 1788},
	{28857, 199012},
	{28873, 199016},
	{28894, 199020, 4, 1797},
	{28902, 199024},
	{28916, 199028},
	{28930, 199032},
	{28944, 199036, 3, 1801},
	{28959, 199040, 2, 1804},
	{28971, 199044, 1, 830},
	{28997, 199048, 3, 1806},
	{29013, 199168, 1, 1809},
	{29038, 199172, 2, 1810},
	{29063, 199184, 2, 1812},
	{29089, 199188, 2, 1812},
	{29115, 199192, 2, 1812},
	{29141, 199212, 2, 1812},
	{29167, 199296, 2, 1814},
	{29195, 199300, 1, 1816},
	{29219, 199304, 1, 1817},
	{29243, 199308, 1, 1818},
	{29276, 199312, 1, 1818},
	{29304, 199328, 2, 1814},
	{29333, 199332, 1, 1816},
	{29358, 199336, 1, 1817},
	{29383, 199340, 1, 1818},
	{29417, 199344, 1, 1818},
	{29446, 199360, 2, 1814},
	{29470, 199364, 1, 1816},
	{29490, 199368, 1, 1817},
	{29510, 199372, 1, 1818},
	{29539, 199376, 1, 1818},
	{29563, 199936},
	{29590, 199940},
	{29617, 199944},
	{29644, 199948},
	{29671, 199952},
	{29698, 199956},
	{29725, 199960},
	{29752, 199964},
	{29779, 199968, 7, 1819},
	{29790, 199972, 2, 1826},
	{29804, 200192},
	{29823, 200196, 1, 840},
	{29845, 200448},
	{29869, 200452, 1, 1828},
	{29892, 200456},
	{29916, 200460, 1, 1828},
	{29939, 200464},
	{29963, 200468, 1, 1828},
	{29986, 200472},
	{30010, 200476, 1, 1828},
	{30033, 200696},
	{30052, 200700, 1, 1828},
	{30070, 200704},
	{30082, 200708},
	{30094, 200712},
	{30112, 200716},
	{30131, 200720},
	{30149, 200724},
	{30161, 200728},
	{30173, 200732},
	{30191, 200736},
	{30209, 200740},
	{30228, 200744, 4, 1829},
	{30242, 200748, 2, 1833},
	{30260, 200752, 2, 1835},
	{30274, 200756, 2, 1837},
	{30288, 200760, 2, 1839},
	{30305, 200764, 2, 1841},
	{30322, 200768},
	{30335, 200772, 2, 1843},
	{30347, 200776},
	{30361, 200780},
	{30377, 200784},
	{30391, 200788},
	{30407, 200792},
	{30422, 200796},
	{30439, 200800},
	{30454, 200804},
	{30471, 200808, 2, 1845},
	{30493, 200812, 10, 1847},
	{30510, 200816, 2, 1857},
	{30531, 200820, 2, 1859},
	{30543, 200824},
	{30558, 200828, 6, 1861},
	{30573, 200832, 2, 1867},
	{30587, 200836},
	{30604, 200960},
	{30626, 200964},
	{30650, 200968},
	{30674, 200972},
	{30700, 212992},
	{30720, 212996},
	{30740, 213000},
	{30760, 213004},
	{30780, 213008},
	{30800, 213012},
	{30820, 213016},
	{30840, 213020},
	{30860, 213024},
	{30880, 213028},
	{30900, 213032},
	{30920, 213036},
	{30940, 213040},
	{30963, 213044},
	{30986, 213048},
	{31009, 213248},
	{31030, 213252},
	{31051, 213260},
	{31072, 213264},
	{31093, 213268},
	{31117, 213272},
	{31141, 213276},
	{31165, 213280},
	{31189, 213284},
	{31213, 213288},
	{31237, 213292},
	{31261, 213296},
	{31285, 213504},
	{31304, 213508},
	{31323, 213512},
	{31342, 213516},
	{31361, 213520},
	{31380, 213524},
	{31399, 213528},
	{31418, 213532},
	{31437, 213536},
	{31456, 213540},
	{31475, 213544},
	{31494, 213548},
	{31513, 213552},
	{31532, 213556},
	{31551, 213560},
	{31570, 213564},
	{31589, 213568},
	{31608, 213572},
	{31627, 213576},
	{31646, 213580},
	{31665, 213584},
	{31685, 213588},
	{31705, 213592},
	{31725, 213596},
	{31745, 214016},
	{31767, 214020, 1, 1869},
	{31789, 214024},
	{31811, 214028, 1, 1869},
	{31833, 214032},
	{31855, 214036, 1, 1869},
	{31877, 214040},
	{31899, 214044, 1, 1869},
	{31921, 214272},
	{31943, 214276},
	{31965, 214280},
	{31987, 214284},
	{32009, 214288},
	{32031, 214292},
	{32053, 214296},
	{32075, 214300},
	{32097, 214304},
	{32119, 214308},
	{32141, 214312},
	{32163, 214316},
	{32185, 214320},
	{32207, 214324},
	{32229, 214328},
	{32251, 214332},
	{32273, 214528},
	{32293, 214532},
	{32313, 214536},
	{32333, 214540},
	{32353, 214544},
	{32373, 214548},
	{32393, 214552},
	{32413, 214556},
	{32433, 214560},
	{32453, 214564},
	{32473, 214568},
	{32493, 214572},
	{32513, 214784},
	{32532, 214788},
	{32551, 214792},
	{32570, 214796},
	{32589, 214800},
	{32608, 214804},
	{32627, 214808},
	{32646, 214812},
	{32665, 214816},
	{32684, 214820},
	{32703, 214824},
	{32722, 214828},
	{32741, 214832},
	{32760, 214836},
	{32779, 214840},
	{32798, 214844},
	{32817, 214848},
	{32836, 214852},
	{32855, 214856},
	{32874, 214860},
	{32893, 214864},
	{32913, 214868},
	{32933, 214872},
	{32953, 214876},
	{32973, 214880},
	{32993, 214884},
	{33013, 214888},
	{33033, 214892},
	{33053, 214896},
	{33073, 214900},
	{33093, 214904},
	{33113, 214908},
	{33133, 215296},
	{33152, 215300},
	{33171, 215304},
	{33190, 215308},
	{33209, 215312},
	{33228, 215316},
	{33247, 215320},
	{33266, 215324},
	{33285, 215424},
	{33306, 215428},
	{33327, 215552},
	{33347, 215556},
	{33367, 215560},
	{33387, 215564},
	{33407, 215568},
	{33427, 215572},
	{33447, 215576},
	{33467, 215580},
	{33487, 215808},
	{33506, 215812},
	{33525, 215816},
	{33544, 215820},
	{33563, 216064},
	{33582, 216068},
	{33601, 216072},
	{33620, 216076},
	{33639, 216320},
	{33659, 216324},
	{33679, 216328},
	{33699, 216332},
	{33719, 216336},
	{33739, 216340},
	{33759, 216344},
	{33779, 216348},
	{33799, 216576},
	{33820, 216580},
	{33841, 216584},
	{33862, 216588},
	{33883, 216592},
	{33904, 216596},
	{33925, 216600},
	{33946, 216604},
	{33967, 216640},
	{33988, 216644},
	{34009, 216648},
	{34030, 216652},
	{34051, 216656},
	{34072, 216660},
	{34093, 216664},
	{34114, 216668},
	{34135, 216704},
	{34156, 216708},
	{34177, 216712},
	{34198, 216716},
	{34219, 216720},
	{34240, 216724},
	{34261, 216728},
	{34282, 216732},
	{34303, 216832},
	{34323, 216836},
	{34343, 216840},
	{34363, 216844},
	{34383, 216848},
	{34403, 216852},
	{34423, 216856},
	{34443, 216860},
	{34463, 216864},
	{34484, 216868},
	{34505, 216872},
	{34526, 216876},
	{34547, 216880},
	{34568, 216884},
	{34589, 216888},
	{34610, 216892},
	{34631, 217112},
	{34650, 217116},
	{34669, 217120},
	{34688, 217124},
	{34707, 217128},
	{34726, 217132},
	{34745, 217136},
	{34764, 217140},
	{34783, 217344},
	{34802, 217348},
	{34821, 217352},
	{34840, 217356},
	{34859, 217360},
	{34878, 217364},
	{34897, 217368},
	{34916, 217372},
	{34935, 217600},
	{34955, 217604},
	{34975, 217608},
	{34995, 217612},
	{35015, 217856},
	{35035, 217860},
	{35055, 217864},
	{35075, 217868},
	{35095, 217872},
	{35115, 217876},
	{35135, 217880},
	{35155, 217884},
	{35175, 217984},
	{35200, 217988, 2, 1870},
	{35225, 218016},
	{35251, 218020, 2, 1870},
	{35277, 218080},
	{35302, 218084},
	{35327, 218088},
	{35352, 218092},
	{35377, 218096},
	{35403, 218100},
	{35429, 218224},
	{35451, 218228},
	{35473, 218232},
	{35495, 218236},
	{35517, 218240},
	{35537, 218244},
	{35557, 218248},
	{35577, 218252},
	{35597, 218624},
	{35619, 218628},
	{35641, 218632},
	{35663, 218636},
	{35685, 218640},
	{35707, 218644},
	{35729, 218648},
	{35751, 218652},
	{35773, 218656},
	{35795, 218660},
	{35817, 218664},
	{35839, 218668},
	{35861, 218672},
	{35883, 218676},
	{35905, 218680},
	{35927, 218684},
	{35949, 218880},
	{35970, 218884},
	{35991, 218888},
	{36012, 218892},
	{36033, 218896},
	{36054, 218900},
	{36075, 218904},
	{36096, 218908},
	{36117, 219136},
	{36137, 219140},
	{36157, 219144},
	{36177, 219148},
	{36197, 219152},
	{36217, 219156},
	{36237, 219160},
	{36257, 219164},
	{36277, 219392},
	{36297, 219396},
	{36317, 221184, 5, 1872},
	{36341, 221188, 4, 1877},
	{36366, 221192, 5, 1872},
	{36390, 221196, 5, 1872},
	{36414, 221200, 4, 1877},
	{36439, 221204, 5, 1872},
	{36463, 221208, 4, 1877},
	{36488, 221212, 5, 1872},
	{36512, 221216, 4, 1881},
	{36528, 221220, 5, 1872},
	{36552, 221224, 3, 1885},
	{36586, 221228, 3, 1888},
	{36620, 221232, 3, 1891},
	{36645, 221236, 3, 1894},
	{36670, 221240, 3, 1891},
	{36695, 221248},
	{36710, 221252, 1, 1818},
	{36733, 221256},
	{36756, 221260},
	{36774, 221264, 2, 1897},
	{36792, 221268, 4, 1899},
	{36812, 221440, 20, 1903},
	{36837, 221444, 20, 1903},
	{36862, 221448, 15, 1923},
	{36890, 221452, 15, 1923},
	{36918, 221456, 15, 1923},
	{36946, 221460, 15, 1923},
	{36974, 221492, 8, 1938},
	{37002, 221496, 8, 1938},
	{37030, 221696, 5, 1946},
	{37053, 221700, 4, 1951},
	{37077, 221704, 5, 1946},
	{37100, 221708, 4, 1951},
	{37124, 221712, 5, 1946},
	{37147, 221716, 4, 1951},
	{37171, 221720, 5, 1946},
	{37194, 221724, 4, 1951},
	{37218, 221728, 2, 1955},
	{37241, 221736, 2, 1955},
	{37264, 221744, 2, 1955},
	{37287, 221752, 2, 1955},
	{37310, 221760, 2, 1955},
	{37333, 221768, 2, 1955},
	{37356, 221776, 2, 1955},
	{37380, 221784, 2, 1955},
	{37404, 222208, 5, 1957},
	{37430, 222212, 4, 1962},
	{37457, 222216, 5, 1957},
	{37483, 222220, 4, 1962},
	{37510, 222224, 5, 1957},
	{37536, 222228, 4, 1962},
	{37563, 222232, 5, 1957},
	{37589, 222236, 4, 1962},
	{37616, 222464, 5, 1957},
	{37642, 222468, 4, 1962},
	{37669, 222472, 1, 1872},
	{37695, 222476, 1, 1872},
	{37721, 222480, 1, 1872},
	{37747, 222484, 1, 1872},
	{37773, 222488, 1, 1872},
	{37799, 222492, 1, 1872},
	{37825, 222496, 1, 1872},
	{37851, 222720, 5, 1957},
	{37875, 222724, 5, 1957},
	{37899, 222728, 5, 1957},
	{37923, 222732, 5, 1957},
	{37947, 222736, 4, 1962},
	{37972, 222740, 4, 1962},
	{37997, 222744, 4, 1962},
	{38022, 222748, 4, 1962},
	{38047, 222752, 1, 1872},
	{38071, 222756, 1, 1872},
	{38095, 222760, 8, 1966},
	{38116, 222976, 4, 1974},
	{38139, 222980, 4, 1974},
	{38162, 222984, 4, 1974},
	{38185, 222988, 4, 1974},
	{38208, 222992, 4, 1974},
	{38231, 222996, 4, 1974},
	{38254, 223000, 4, 1974},
	{38277, 223004, 4, 1974},
	{38300, 223008, 4, 1974},
	{38323, 223012, 4, 1974},
	{38346, 223016, 4, 1974},
	{38370, 223020, 4, 1974},
	{38394, 223024, 4, 1974},
	{38418, 223028, 4, 1974},
	{38442, 223032, 4, 1974},
	{38466, 223036, 4, 1974},
	{38490, 223104, 9, 1978},
	{38510, 223112, 1, 1987},
	{38531, 223232, 5, 1957},
	{38556, 223236, 4, 1962},
	{38582, 223240, 8, 1988},
	{38605, 223488, 3, 1996},
	{38628, 223492, 3, 1996},
	{38651, 223496, 3, 1996},
	{38674, 223500, 3, 1996},
	{38697, 223504, 2, 1999},
	{38721, 223508, 2, 1999},
	{38745, 223744, 5, 1957},
	{38769, 223748, 5, 1957},
	{38793, 223752, 5, 1957},
	{38817, 223756, 5, 1957},
	{38841, 223760, 4, 1962},
	{38866, 224000, 5, 2001},
	{38889, 224004, 4, 2006},
	{38913, 224008, 3, 2010},
	{38936, 224256, 5, 2001},
	{38959, 224260, 4, 2006},
	{38983, 224264, 3, 2010},
	{39006, 224512, 5, 1957},
	{39030, 224516, 4, 1962},
	{39055, 224520, 5, 1957},
	{39079, 224524, 4, 1962},
	{39104, 224528, 3, 2013},
	{39128, 224532, 3, 2013},
	{39152, 224768, 5, 1957},
	{39177, 224772, 4, 1951},
	{39203, 224776, 5, 1957},
	{39228, 224780, 4, 1951},
	{39254, 224784, 3, 2013},
	{39279, 224788, 3, 2013},
	{39304, 224832, 5, 1957},
	{39329, 224836, 4, 1951},
	{39355, 224840, 5, 1957},
	{39380, 224844, 4, 1951},
	{39406, 224848, 3, 2013},
	{39431, 224852, 3, 2013},
	{39456, 224896, 5, 1957},
	{39481, 224900, 4, 1951},
	{39507, 224904, 3, 2013},
	{39532, 224908, 3, 2013},
	{39557, 224912, 3, 2013},
	{39582, 225024, 5, 1957},
	{39606, 225028, 4, 1951},
	{39631, 225032, 3, 2013},
	{39655, 225036, 3, 2013},
	{39679, 225040, 3, 2013},
	{39703, 225048, 5, 1957},
	{39728, 225052, 4, 1951},
	{39754, 225056, 3, 2013},
	{39779, 225060, 3, 2013},
	{39804, 225064, 3, 2013},
	{39829, 225280, 12, 2016},
	{39851, 225284, 5, 2028},
	{39874, 225288, 4, 2033},
	{39898, 225292, 2, 2037},
	{39921, 225296, 2, 2037},
	{39944, 225300, 2, 2037},
	{39967, 225536, 5, 1957},
	{39990, 225540, 4, 1962},
	{40014, 225544, 5, 1957},
	{40037, 225548, 4, 1962},
	{40061, 225552, 5, 1957},
	{40084, 225560, 5, 1957},
	{40107, 225792, 4, 2039},
	{40128, 225796},
	{40157, 225800, 2, 2043},
	{40186, 225804},
	{40212, 225808, 7, 2045},
	{40241, 225812},
	{40260, 225816, 2, 2052},
	{40286, 225820, 2, 2054},
	{40309, 225824},
	{40332, 225828, 2, 2056},
	{40359, 225832},
	{40386, 225836, 2, 2058},
	{40411, 225840, 2, 2060},
	{40439, 225844, 2, 2062},
	{40467, 225848, 2, 2064},
	{40490, 225852, 2, 2066},
	{40513, 225856},
	{40546, 225860, 2, 2068},
	{40579, 225864},
	{40611, 225868, 2, 2068},
	{40643, 225872, 2, 2070},
	{40662, 225876, 2, 2072},
	{40689, 225880},
	{40716, 225884, 2, 2074},
	{40743, 225888, 2, 2076},
	{40770, 225892, 10, 2078},
	{40791, 225896, 8, 2088},
	{40810, 225900, 8, 2096},
	{40829, 225904, 2, 2104},
	{40853, 225908, 2, 2106},
	{40885, 225912, 2, 2108},
	{40915, 225916, 4, 2110},
	{40951, 225920, 3, 2114},
	{40984, 225924, 1, 2117},
	{41002, 225932, 1, 2118},
	{41022, 226048, 2, 2119},
	{41039, 226052, 1, 2121},
	{41063, 226056, 1, 2121},
	{41087, 226060, 4, 2122},
	{41113, 226064, 3, 2126},
	{41142, 226068, 1, 687},
	{41171, 226072, 3, 2126},
	{41200, 226076, 1, 687},
	{41229, 226192, 1, 2129},
	{41250, 226196, 1, 2129},
	{41277, 226304, 5, 2028},
	{41301, 226308, 4, 2033},
	{41326, 226312, 2, 2037},
	{41350, 226316, 5, 2028},
	{41374, 226320, 4, 2033},
	{41399, 226324, 2, 2037},
	{41423, 226328, 10, 2130},
	{41445, 226432, 5, 2140},
	{41472, 226436, 5, 2140},
	{41499, 226440, 6, 2145},
	{41531, 226480, 5, 2140},
	{41559, 226484, 5, 2140},
	{41587, 226488, 5, 2140},
	{41615, 226492, 5, 2140},
	{41643, 226496, 5, 2140},
	{41671, 226500, 5, 2140},
	{41699, 226504, 5, 2140},
	{41727, 226508, 5, 2140},
	{41755, 226512, 6, 2145},
	{41788, 226544, 5, 1957},
	{41817, 226548, 5, 1957},
	{41846, 226552, 4, 1962},
	{41876, 226556, 4, 1962},
	{41906, 226560, 8, 1988},
	{41933, 226564, 8, 1988},
	{41960, 226608, 5, 1957},
	{41990, 226612, 4, 1962},
	{42021, 226616, 8, 1988},
	{42049, 226688, 5, 2028},
	{42073, 226692, 4, 2033},
	{42098, 226696, 3, 2151},
	{42122, 226700, 2, 2154},
	{42148, 226704, 2, 2154},
	{42174, 226816, 5, 1957},
	{42200, 226820, 4, 1962},
	{42227, 226824, 5, 1957},
	{42253, 226828, 5, 1957},
	{42279, 226832, 5, 1957},
	{42305, 226836, 1, 1872},
	{42331, 226840, 1, 1872},
	{42357, 226844, 1, 1872},
	{42383, 226848, 1, 1872},
	{42409, 226880, 4, 1962},
	{42436, 226884, 4, 1962},
	{42463, 226888, 4, 1962},
	{42490, 227072, 5, 1957},
	{42515, 227076, 4, 1951},
	{42541, 227080, 3, 2013},
	{42566, 227084, 3, 2013},
	{42591, 227088, 3, 2013},
	{42616, 227200, 5, 1957},
	{42640, 227204, 4, 1951},
	{42665, 227208, 3, 2013},
	{42689, 227212, 3, 2013},
	{42713, 227216, 3, 2013},
	{42737, 227328, 5, 1957},
	{42761, 227332, 4, 1962},
	{42786, 227336, 8, 1988},
	{195, 880, 4, 2156},
	{42808, 881},
	{26631, 882},
	{42820, 1008},
	{42831, 1009},
	{26819, 1010, 3, 2160},
	{42842, 1040, 1, 2163},
	{42855, 1041, 5, 2164},
	{42868, 1042, 1, 2169},
	{42881, 1043, 1, 1681},
	{26653, 1045, 7, 2170},
	{42894, 1168, 12, 2177},
	{42909, 1280, 6, 2189},
	{42924, 1281},
	{26590, 1282},
	{42808, 1283},
	{26631, 1284},
	{42936, 1414, 15, 2195},
};

static const struct si_reg gfx103_reg_table[] = {
	{42945, 40, 1, 2210},
	{42960, 44, 1, 2210},
	{974, 1028, 8, 0},
	{987, 1032, 20, 10},
	{1002, 1036, 10, 2211},
	{1018, 1040, 12, 40},
	{1039, 1044, 4, 52},
	{1057, 1048, 3, 56},
	{1075, 1052, 8, 2221},
	{1090, 1056},
	{1104, 1060, 1, 70},
	{1118, 1064},
	{1135, 1076, 2, 78},
	{1151, 1080},
	{1546, 1104},
	{1570, 1108},
	{1168, 1116, 5, 80},
	{1183, 1120, 6, 85},
	{1198, 1124, 2, 92},
	{1218, 1128, 1, 94},
	{1237, 1132, 4, 95},
	{1257, 1136, 5, 99},
	{42983, 1140, 1, 2229},
	{1273, 2480},
	{1287, 2484},
	{1301, 2488},
	{1315, 2492},
	{1329, 2496},
	{1343, 2500},
	{1357, 2504},
	{1371, 2508},
	{1385, 2512},
	{1399, 2516},
	{1413, 2520},
	{1428, 2524},
	{1443, 2528},
	{1458, 2532},
	{1473, 2536},
	{1488, 2540},
	{1503, 2544},
	{1514, 2552},
	{1530, 2556},
	{1618, 32776, 29, 2230},
	{1631, 32784, 20, 2259},
	{1643, 32788, 14, 154},
	{1659, 32792, 14, 154},
	{1675, 32796, 15, 168},
	{1688, 32824, 14, 154},
	{1704, 32828, 14, 154},
	{1720, 33296, 21, 183},
	{1734, 33300, 28, 204},
	{1751, 33304, 15, 232},
	{1772, 33308, 28, 247},
	{1786, 33312, 32, 275},
	{1803, 33316, 13, 307},
	{1824, 33320, 9, 320},
	{1842, 33324, 1, 329},
	{43005, 33328, 1, 2279},
	{1865, 33344, 2, 330},
	{1886, 33348},
	{1906, 33352, 1, 332},
	{1929, 33356, 9, 333},
	{1947, 33436, 1, 342},
	{1970, 36096},
	{1996, 36100, 2, 343},
	{2022, 36104},
	{2048, 36108, 2, 343},
	{2074, 36112, 2, 345},
	{2095, 36116, 4, 347},
	{2116, 36120, 6, 2280},
	{2143, 36124, 20, 2286},
	{2164, 36128, 7, 2306},
	{2187, 36132},
	{2216, 36140},
	{2246, 36144},
	{2278, 36148},
	{2309, 36152},
	{43032, 36156, 3, 2313},
	{2342, 36348, 5, 378},
	{2351, 36608},
	{2369, 36612, 4, 383},
	{2387, 36616},
	{2405, 36620, 11, 2316},
	{2423, 36656, 14, 397},
	{2441, 36660, 4, 411},
	{2459, 36664, 12, 415},
	{2477, 36668, 2, 427},
	{2495, 37168, 9, 2327},
	{2511, 39160, 6, 2336},
	{3306, 40960},
	{3324, 40964, 4, 452},
	{3342, 40968, 3, 456},
	{3360, 40972, 9, 459},
	{3378, 40976, 3, 2342},
	{3396, 40980, 8, 2345},
	{3414, 40984, 11, 2353},
	{3432, 40988},
	{3450, 45060, 1, 487},
	{3474, 45080},
	{3499, 45084, 3, 488},
	{3523, 45088},
	{3544, 45092, 1, 491},
	{3565, 45096, 12, 2364},
	{3589, 45100, 10, 503},
	{3613, 45104},
	{3639, 45108},
	{3665, 45112},
	{3691, 45116},
	{3717, 45120},
	{3743, 45124},
	{3769, 45128},
	{3795, 45132},
	{3821, 45136},
	{3847, 45140},
	{3873, 45144},
	{3900, 45148},
	{3927, 45152},
	{3954, 45156},
	{3981, 45160},
	{4008, 45164},
	{4035, 45168},
	{4062, 45172},
	{4089, 45176},
	{4116, 45180},
	{4143, 45184},
	{4170, 45188},
	{4197, 45192},
	{4224, 45196},
	{4251, 45200},
	{4278, 45204},
	{4305, 45208},
	{4332, 45212},
	{4359, 45216},
	{4386, 45220},
	{4413, 45224},
	{4440, 45228},
	{4467, 45248, 8, 513},
	{4523, 45256, 1, 526},
	{4550, 45260, 1, 526},
	{4577, 45264, 1, 526},
	{4604, 45268, 1, 526},
	{4631, 45316, 1, 487},
	{4655, 45332},
	{4680, 45336, 3, 488},
	{4704, 45340, 1, 527},
	{4729, 45344},
	{4750, 45348, 1, 491},
	{4771, 45352, 12, 528},
	{4795, 45356, 14, 540},
	{4819, 45360},
	{4845, 45364},
	{4871, 45368},
	{4897, 45372},
	{4923, 45376},
	{4949, 45380},
	{4975, 45384},
	{5001, 45388},
	{5027, 45392},
	{5053, 45396},
	{5079, 45400},
	{5106, 45404},
	{5133, 45408},
	{5160, 45412},
	{5187, 45416},
	{5214, 45420},
	{5241, 45424},
	{5268, 45428},
	{5295, 45432},
	{5322, 45436},
	{5349, 45440},
	{5376, 45444},
	{5403, 45448},
	{5430, 45452},
	{5457, 45456},
	{5484, 45460},
	{5511, 45464},
	{5538, 45468},
	{5565, 45472},
	{5592, 45476},
	{5619, 45480},
	{5646, 45484},
	{5673, 45504, 8, 513},
	{5729, 45512, 1, 526},
	{5756, 45516, 1, 526},
	{5783, 45520, 1, 526},
	{5810, 45524, 1, 526},
	{5837, 45548, 9, 554},
	{5918, 45568},
	{5943, 45572, 2, 574},
	{5967, 45576},
	{5999, 45580},
	{6031, 45584},
	{6055, 45588, 1, 491},
	{6079, 45596, 4, 576},
	{6103, 45600},
	{6124, 45604, 1, 491},
	{6145, 45608, 13, 580},
	{6169, 45612, 9, 593},
	{6193, 45616},
	{6219, 45620},
	{6245, 45624},
	{6271, 45628},
	{6297, 45632},
	{6323, 45636},
	{6349, 45640},
	{6375, 45644},
	{6401, 45648},
	{6427, 45652},
	{6453, 45656},
	{6480, 45660},
	{6507, 45664},
	{6534, 45668},
	{6561, 45672},
	{6588, 45676},
	{6615, 45680},
	{6642, 45684},
	{6669, 45688},
	{6696, 45692},
	{6723, 45696},
	{6750, 45700},
	{6777, 45704},
	{6804, 45708},
	{6831, 45712},
	{6858, 45716},
	{6885, 45720},
	{6912, 45724},
	{6939, 45728},
	{6966, 45732},
	{6993, 45736},
	{7020, 45740},
	{7047, 45760, 8, 513},
	{7107, 45768, 1, 526},
	{7136, 45772, 1, 526},
	{7165, 45776, 1, 526},
	{7194, 45780, 1, 526},
	{7274, 45856},
	{7295, 45860, 1, 491},
	{7813, 46080},
	{7838, 46084, 1, 487},
	{7862, 46088},
	{7894, 46092},
	{7926, 46096},
	{7950, 46100, 1, 491},
	{7974, 46108, 4, 612},
	{7998, 46112},
	{8019, 46116, 1, 491},
	{8040, 46120, 12, 616},
	{8064, 46124, 9, 628},
	{8088, 46128},
	{8114, 46132},
	{8140, 46136},
	{8166, 46140},
	{8192, 46144},
	{8218, 46148},
	{8244, 46152},
	{8270, 46156},
	{8296, 46160},
	{8322, 46164},
	{8348, 46168},
	{8375, 46172},
	{8402, 46176},
	{8429, 46180},
	{8456, 46184},
	{8483, 46188},
	{8510, 46192},
	{8537, 46196},
	{8564, 46200},
	{8591, 46204},
	{8618, 46208},
	{8645, 46212},
	{8672, 46216},
	{8699, 46220},
	{8726, 46224},
	{8753, 46228},
	{8780, 46232},
	{8807, 46236},
	{8834, 46240},
	{8861, 46244},
	{8888, 46248},
	{8915, 46252},
	{8942, 46272, 8, 513},
	{9002, 46280, 1, 526},
	{9031, 46284, 1, 526},
	{9060, 46288, 1, 526},
	{9089, 46292, 1, 526},
	{9169, 46368},
	{9190, 46372, 1, 491},
	{9681, 47104, 13, 646},
	{9708, 47108},
	{9722, 47112},
	{9736, 47116},
	{9750, 47120},
	{9766, 47124},
	{9782, 47128},
	{9798, 47132, 2, 659},
	{9819, 47136, 2, 659},
	{9840, 47140, 2, 659},
	{9861, 47144, 1, 661},
	{9889, 47148, 1, 662},
	{9914, 47152},
	{9929, 47156, 1, 663},
	{9944, 47160},
	{9973, 47164, 1, 663},
	{10002, 47168},
	{10035, 47172, 1, 663},
	{10068, 47176, 12, 664},
	{10086, 47180, 11, 676},
	{10104, 47184, 1, 687},
	{10117, 47188, 6, 688},
	{10141, 47192},
	{10168, 47196},
	{10195, 47200, 2, 694},
	{10216, 47204},
	{10243, 47208},
	{10270, 47212},
	{10288, 47216},
	{10306, 47220},
	{10324, 47224, 1, 696},
	{10352, 47228, 5, 697},
	{10374, 47232},
	{10394, 47236},
	{10417, 47240, 9, 702},
	{10434, 47248, 1, 526},
	{10455, 47252, 1, 526},
	{10476, 47256, 1, 526},
	{10497, 47260, 1, 526},
	{10518, 47264, 1, 711},
	{10536, 47268, 1, 712},
	{10555, 47272},
	{10577, 47276, 3, 713},
	{10594, 47280},
	{10623, 47284, 1, 716},
	{10652, 47288, 3, 713},
	{10670, 47360},
	{10690, 47364},
	{10710, 47368},
	{10730, 47372},
	{10750, 47376},
	{10770, 47380},
	{10790, 47384},
	{10810, 47388},
	{10830, 47392},
	{10850, 47396},
	{10870, 47400},
	{10891, 47404},
	{10912, 47408},
	{10933, 47412},
	{10954, 47416},
	{10975, 47420},
	{10996, 47604, 2, 717},
	{11020, 47608},
	{11041, 47612},
	{43056, 47616},
	{43073, 47620},
	{11057, 163840, 11, 2376},
	{11075, 163844, 11, 729},
	{11092, 163848, 7, 740},
	{11106, 163852, 23, 747},
	{11125, 163856, 18, 2387},
	{11145, 163860},
	{11164, 163868, 2, 786},
	{11181, 163872},
	{11201, 163876},
	{11221, 163880, 1, 788},
	{11238, 163884},
	{11253, 163888, 2, 789},
	{11277, 163892, 2, 791},
	{11301, 163896, 3, 793},
	{11317, 163900, 8, 796},
	{11335, 163904, 14, 804},
	{11345, 163908, 9, 818},
	{11361, 163912},
	{11376, 163916},
	{11397, 163920},
	{11413, 163924},
	{11435, 163928, 2, 827},
	{11453, 163932, 1, 829},
	{43090, 163940, 3, 2405},
	{11471, 163944, 1, 830},
	{11489, 163948, 1, 830},
	{11513, 163952, 1, 830},
	{11532, 163956, 1, 830},
	{11557, 163960, 1, 830},
	{11579, 163964, 13, 2408},
	{11603, 163968},
	{11619, 163972, 1, 840},
	{11638, 164328, 1, 841},
	{11659, 164332, 1, 841},
	{11680, 164336, 1, 841},
	{11701, 164340, 1, 841},
	{11722, 164344},
	{11740, 164348},
	{11758, 164352, 2, 842},
	{11778, 164356, 3, 844},
	{11802, 164360, 2, 847},
	{11826, 164364, 1, 849},
	{11846, 164368, 2, 844},
	{11866, 164372, 2, 847},
	{11886, 164376, 2, 844},
	{11906, 164380, 2, 847},
	{11926, 164384, 2, 844},
	{11946, 164388, 2, 847},
	{11966, 164392, 2, 844},
	{11986, 164396, 2, 847},
	{12006, 164400, 7, 850},
	{12021, 164404, 2, 857},
	{12050, 164408, 8, 859},
	{12065, 164412, 8, 867},
	{12080, 164416, 3, 844},
	{12105, 164420, 2, 847},
	{12130, 164424},
	{12148, 164428},
	{12166, 164432, 3, 844},
	{12191, 164436, 2, 847},
	{12216, 164440, 3, 844},
	{12241, 164444, 2, 847},
	{12266, 164448, 3, 844},
	{12291, 164452, 2, 847},
	{12316, 164456, 3, 844},
	{12341, 164460, 2, 847},
	{12366, 164464, 3, 844},
	{12391, 164468, 2, 847},
	{12416, 164472, 3, 844},
	{12441, 164476, 2, 847},
	{12466, 164480, 3, 844},
	{12491, 164484, 2, 847},
	{12516, 164488, 3, 844},
	{12541, 164492, 2, 847},
	{12566, 164496, 3, 844},
	{12591, 164500, 2, 847},
	{12616, 164504, 3, 844},
	{12641, 164508, 2, 847},
	{12666, 164512, 3, 844},
	{12692, 164516, 2, 847},
	{12718, 164520, 3, 844},
	{12744, 164524, 2, 847},
	{12770, 164528, 3, 844},
	{12796, 164532, 2, 847},
	{12822, 164536, 3, 844},
	{12848, 164540, 2, 847},
	{12874, 164544, 3, 844},
	{12900, 164548, 2, 847},
	{12926, 164552, 3, 844},
	{12952, 164556, 2, 847},
	{12978, 164560},
	{12997, 164564},
	{13016, 164568},
	{13035, 164572},
	{13054, 164576},
	{13073, 164580},
	{13092, 164584},
	{13111, 164588},
	{13130, 164592},
	{13149, 164596},
	{13168, 164600},
	{13187, 164604},
	{13206, 164608},
	{13225, 164612},
	{13244, 164616},
	{13263, 164620},
	{13282, 164624},
	{13301, 164628},
	{13320, 164632},
	{13339, 164636},
	{13358, 164640},
	{13378, 164644},
	{13398, 164648},
	{13418, 164652},
	{13438, 164656},
	{13458, 164660},
	{13478, 164664},
	{13498, 164668},
	{13518, 164672},
	{13538, 164676},
	{13558, 164680},
	{13578, 164684},
	{13598, 164688, 15, 875},
	{13618, 164692, 3, 890},
	{13640, 164696, 2, 893},
	{13668, 164700, 6, 2421},
	{13697, 164704, 1, 902},
	{13718, 164708, 1, 903},
	{13728, 164712, 1, 904},
	{43111, 164716},
	{43133, 164720},
	{13796, 164864},
	{13813, 164868},
	{13830, 164872},
	{13846, 164876},
	{13875, 164880, 14, 2427},
	{13900, 164884},
	{13913, 164888},
	{13928, 164892},
	{13942, 164896},
	{13957, 164900, 8, 923},
	{13972, 164904, 4, 931},
	{13996, 164908, 6, 935},
	{14015, 164912, 4, 941},
	{14033, 164916, 4, 945},
	{14054, 164924},
	{14073, 164928},
	{14093, 164932},
	{14112, 164936},
	{14132, 164940},
	{14151, 164944},
	{14171, 164948},
	{14192, 164952},
	{14214, 164956},
	{14235, 164960},
	{14257, 164964},
	{14278, 164968},
	{14300, 164972},
	{14321, 164976},
	{14343, 164980},
	{14364, 164984},
	{14386, 164988},
	{14407, 164992},
	{14429, 164996},
	{14450, 165000},
	{14472, 165004},
	{14493, 165008},
	{14515, 165012},
	{14536, 165016},
	{14558, 165020},
	{14579, 165024},
	{14601, 165028},
	{14622, 165032},
	{14644, 165036},
	{14665, 165040},
	{14687, 165044},
	{14708, 165048},
	{14730, 165052},
	{14751, 165056},
	{14773, 165060},
	{14794, 165064},
	{14816, 165068},
	{14837, 165072},
	{14859, 165076},
	{14880, 165080},
	{14902, 165084},
	{14923, 165088},
	{14945, 165092},
	{14966, 165096},
	{14988, 165100},
	{15009, 165104},
	{15031, 165108},
	{15052, 165112},
	{15074, 165116},
	{15095, 165120},
	{15117, 165124},
	{15138, 165128},
	{15160, 165132},
	{15181, 165136},
	{15203, 165140},
	{15224, 165144},
	{15246, 165148},
	{15267, 165152},
	{15289, 165156},
	{15310, 165160},
	{15332, 165164},
	{15354, 165168},
	{15377, 165172},
	{15399, 165176},
	{15422, 165180},
	{15444, 165184},
	{15467, 165188},
	{15489, 165192},
	{15512, 165196},
	{15534, 165200},
	{15557, 165204},
	{15579, 165208},
	{15602, 165212},
	{15624, 165216},
	{15647, 165220},
	{15669, 165224},
	{15692, 165228},
	{15714, 165232},
	{15737, 165236},
	{15759, 165240},
	{15782, 165244},
	{15804, 165248},
	{15827, 165252},
	{15849, 165256},
	{15872, 165260},
	{15894, 165264},
	{15917, 165268},
	{15939, 165272},
	{15962, 165276},
	{15984, 165280},
	{16007, 165284},
	{16029, 165288},
	{16052, 165292},
	{16074, 165296},
	{16097, 165300},
	{16119, 165304},
	{16142, 165308},
	{16156, 165312},
	{16170, 165316},
	{16184, 165320},
	{16198, 165324},
	{16212, 165328},
	{16226, 165332},
	{16240, 165336},
	{16254, 165340},
	{16268, 165344},
	{16282, 165348},
	{16296, 165352},
	{16310, 165356},
	{16324, 165360},
	{16338, 165364},
	{16352, 165368},
	{16366, 165372},
	{16380, 165376},
	{16394, 165380},
	{16408, 165384},
	{16422, 165388},
	{16436, 165392},
	{16450, 165396},
	{16464, 165400},
	{16478, 165404},
	{16501, 165444, 13, 2441},
	{16521, 165448, 13, 2441},
	{16541, 165452, 13, 2441},
	{16561, 165456, 13, 2441},
	{16581, 165460, 13, 2441},
	{16601, 165464, 13, 2441},
	{16621, 165468, 13, 2441},
	{16641, 165472, 13, 2441},
	{16661, 165476, 13, 2441},
	{16681, 165480, 13, 2441},
	{16701, 165484, 13, 2441},
	{16722, 165488, 13, 2441},
	{16743, 165492, 13, 2441},
	{16764, 165496, 13, 2441},
	{16785, 165500, 13, 2441},
	{16806, 165504, 13, 2441},
	{16827, 165508, 13, 2441},
	{16848, 165512, 13, 2441},
	{16869, 165516, 13, 2441},
	{16890, 165520, 13, 2441},
	{16911, 165524, 10, 2454},
	{16932, 165528, 10, 2454},
	{16953, 165532, 10, 2454},
	{16974, 165536, 10, 2454},
	{16995, 165540, 10, 2454},
	{17016, 165544, 10, 2454},
	{17037, 165548, 10, 2454},
	{17058, 165552, 10, 2454},
	{17079, 165556, 10, 2454},
	{17100, 165560, 10, 2454},
	{17121, 165564, 10, 2454},
	{17142, 165568, 10, 2454},
	{17163, 165572, 4, 2464},
	{17181, 165580, 16, 973},
	{17198, 165584, 16, 973},
	{17216, 165588, 7, 989},
	{17237, 165592, 6, 2468},
	{17255, 165600, 7, 1002},
	{17270, 165608, 2, 694},
	{17287, 165640, 1, 1009},
	{17309, 165644, 5, 1010},
	{17331, 165648, 1, 1015},
	{17351, 165652, 8, 1016},
	{43155, 165712, 8, 2474},
	{17373, 165716, 8, 2482},
	{17391, 165720, 8, 1032},
	{17412, 165724, 17, 1040},
	{17433, 165728, 6, 1057},
	{17451, 165732, 6, 1057},
	{17469, 165736, 6, 1057},
	{17487, 165740, 6, 1057},
	{17505, 165744, 6, 1057},
	{17523, 165748, 6, 1057},
	{17541, 165752, 6, 1057},
	{17559, 165756, 6, 1057},
	{17577, 165760, 9, 1063},
	{17595, 165764, 9, 1063},
	{17613, 165768, 9, 1063},
	{17631, 165772, 9, 1063},
	{17649, 165776, 9, 1063},
	{17667, 165780, 9, 1063},
	{17685, 165784, 9, 1063},
	{17703, 165788, 9, 1063},
	{17721, 165836, 1, 1072},
	{17735, 165840, 1, 1072},
	{17750, 165844},
	{17768, 165848},
	{17786, 165852},
	{17803, 165856},
	{17824, 165860, 1, 1073},
	{17840, 165864},
	{17853, 165872, 6, 2490},
	{17872, 165876},
	{17887, 165880, 1, 1082},
	{17909, 165884, 1, 1083},
	{17936, 165888, 10, 1084},
	{17953, 165892, 12, 1094},
	{17961, 165896, 5, 2496},
	{17978, 165900, 17, 1110},
	{17996, 165904, 20, 1127},
	{18012, 165908, 16, 1147},
	{18031, 165912, 10, 1163},
	{18046, 165916, 30, 2501},
	{18064, 165920, 16, 1201},
	{18082, 165924, 4, 1217},
	{18106, 165928},
	{18131, 165932, 11, 1221},
	{18154, 165936, 5, 1232},
	{18205, 165944, 3, 2531},
	{18220, 165948, 5, 1243},
	{18250, 165952, 5, 1248},
	{18265, 165956},
	{43181, 165960, 6, 2534},
	{18283, 166400, 2, 1253},
	{18300, 166404, 2, 1255},
	{18319, 166408, 1, 1257},
	{18335, 166412, 4, 1258},
	{18354, 166416, 1, 1262},
	{18375, 166420, 1, 1263},
	{18388, 166424},
	{18411, 166428},
	{18434, 166432, 1, 1264},
	{18454, 166436, 4, 1265},
	{18474, 166440, 1, 1269},
	{18495, 166444, 1, 1270},
	{18510, 166448, 6, 1271},
	{18532, 166452, 6, 1271},
	{18554, 166456, 8, 1277},
	{18580, 166460, 8, 1277},
	{18606, 166464, 15, 1285},
	{18618, 166468, 3, 1300},
	{18637, 166472, 6, 2540},
	{18655, 166476, 24, 1310},
	{18673, 166480},
	{18685, 166484, 1, 1334},
	{18699, 166488, 1, 1335},
	{18713, 166492, 1, 1336},
	{18727, 166496, 1, 1337},
	{18750, 166500, 1, 1337},
	{18773, 166504, 1, 1337},
	{18796, 166508, 5, 1338},
	{18817, 166512},
	{18828, 166516},
	{18841, 166520},
	{18858, 166524, 9, 2546},
	{18877, 166528},
	{18888, 166532, 3, 1351},
	{18907, 166536},
	{18929, 166540},
	{18951, 166544, 3, 1354},
	{18971, 166548, 2, 1357},
	{18998, 166552, 4, 2555},
	{19020, 166560},
	{19045, 166564},
	{19070, 166568, 6, 1364},
	{19089, 166572, 1, 1370},
	{19112, 166576, 1, 1370},
	{19135, 166580, 1, 1371},
	{19149, 166584, 1, 1372},
	{19164, 166588, 10, 2559},
	{19181, 166592, 4, 1382},
	{19208, 166596, 4, 1386},
	{19235, 166600, 4, 1390},
	{19254, 166608},
	{19280, 166612, 1, 1394},
	{19305, 166620},
	{19333, 166624},
	{19359, 166628, 1, 1394},
	{19384, 166636},
	{19412, 166640},
	{19438, 166644, 1, 1394},
	{19463, 166652},
	{19491, 166656},
	{19517, 166660, 1, 1394},
	{19542, 166668},
	{19570, 166696},
	{19601, 166700},
	{19644, 166704, 1, 1395},
	{19682, 166712, 1, 1396},
	{19702, 166732, 2, 1397},
	{19721, 166736, 5, 1399},
	{19743, 166740, 20, 2569},
	{19764, 166744, 3, 1423},
	{19781, 166748, 1, 1370},
	{19802, 166752, 1, 1370},
	{19825, 166756, 1, 1370},
	{19848, 166760, 1, 1370},
	{19871, 166764, 12, 1426},
	{19884, 166768, 6, 1438},
	{19901, 166772},
	{19925, 166776, 2, 1444},
	{19955, 166780},
	{19979, 166784},
	{20009, 166788},
	{20040, 166792},
	{20069, 166796},
	{20099, 166800, 3, 1446},
	{20119, 166804, 8, 1449},
	{20138, 166808, 4, 1457},
	{20164, 166812, 3, 1354},
	{20188, 166868, 8, 1461},
	{20214, 166872, 8, 1469},
	{20240, 166876, 5, 1477},
	{20256, 166880, 8, 2589},
	{20272, 166884, 3, 1488},
	{20287, 166888},
	{20310, 166892},
	{20333, 166896},
	{20356, 166900},
	{20379, 166904, 8, 1491},
	{20413, 166908, 8, 1499},
	{20447, 166912, 8, 1507},
	{20481, 166916, 8, 1515},
	{20515, 166920, 8, 1491},
	{20549, 166924, 8, 1499},
	{20583, 166928, 8, 1507},
	{20617, 166932, 8, 1515},
	{20651, 166936, 8, 1491},
	{20685, 166940, 8, 1499},
	{20719, 166944, 8, 1507},
	{20753, 166948, 8, 1515},
	{20787, 166952, 8, 1491},
	{20821, 166956, 8, 1499},
	{20855, 166960, 8, 1507},
	{20889, 166964, 8, 1515},
	{20923, 166968, 2, 1523},
	{20947, 166972, 2, 1525},
	{20971, 166976, 4, 1527},
	{20992, 166980, 12, 1531},
	{21012, 166984, 2, 1543},
	{21032, 166988, 20, 1545},
	{21070, 166992, 2, 1565},
	{21090, 167000, 1, 1567},
	{21118, 167004, 1, 1568},
	{21139, 167008},
	{21154, 167012, 2, 1569},
	{21170, 167016, 1, 1571},
	{21186, 167020, 3, 1572},
	{21201, 167024, 19, 2597},
	{21216, 167028, 8, 1594},
	{21233, 167032, 14, 2616},
	{21255, 167036},
	{21271, 167040, 1, 1614},
	{21293, 167044},
	{21309, 167048, 1, 1571},
	{21331, 167052},
	{21353, 167056},
	{21375, 167060},
	{21394, 167068},
	{21409, 167072, 2, 1569},
	{21425, 167076, 1, 1571},
	{21441, 167080, 3, 1572},
	{21456, 167084, 19, 2597},
	{21471, 167088, 8, 1594},
	{21488, 167092, 14, 2616},
	{21510, 167096},
	{21526, 167100, 1, 1614},
	{21548, 167104},
	{21564, 167108, 1, 1571},
	{21586, 167112},
	{21608, 167116},
	{21630, 167120},
	{21649, 167128},
	{21664, 167132, 2, 1569},
	{21680, 167136, 1, 1571},
	{21696, 167140, 3, 1572},
	{21711, 167144, 19, 2597},
	{21726, 167148, 8, 1594},
	{21743, 167152, 14, 2616},
	{21765, 167156},
	{21781, 167160, 1, 1614},
	{21803, 167164},
	{21819, 167168, 1, 1571},
	{21841, 167172},
	{21863, 167176},
	{21885, 167180},
	{21904, 167188},
	{21919, 167192, 2, 1569},
	{21935, 167196, 1, 1571},
	{21951, 167200, 3, 1572},
	{21966, 167204, 19, 2597},
	{21981, 167208, 8, 1594},
	{21998, 167212, 14, 2616},
	{22020, 167216},
	{22036, 167220, 1, 1614},
	{22058, 167224},
	{22074, 167228, 1, 1571},
	{22096, 167232},
	{22118, 167236},
	{22140, 167240},
	{22159, 167248},
	{22174, 167252, 2, 1569},
	{22190, 167256, 1, 1571},
	{22206, 167260, 3, 1572},
	{22221, 167264, 19, 2597},
	{22236, 167268, 8, 1594},
	{22253, 167272, 14, 2616},
	{22275, 167276},
	{22291, 167280, 1, 1614},
	{22313, 167284},
	{22329, 167288, 1, 1571},
	{22351, 167292},
	{22373, 167296},
	{22395, 167300},
	{22414, 167308},
	{22429, 167312, 2, 1569},
	{22445, 167316, 1, 1571},
	{22461, 167320, 3, 1572},
	{22476, 167324, 19, 2597},
	{22491, 167328, 8, 1594},
	{22508, 167332, 14, 2616},
	{22530, 167336},
	{22546, 167340, 1, 1614},
	{22568, 167344},
	{22584, 167348, 1, 1571},
	{22606, 167352},
	{22628, 167356},
	{22650, 167360},
	{22669, 167368},
	{22684, 167372, 2, 1569},
	{22700, 167376, 1, 1571},
	{22716, 167380, 3, 1572},
	{22731, 167384, 19, 2597},
	{22746, 167388, 8, 1594},
	{22763, 167392, 14, 2616},
	{22785, 167396},
	{22801, 167400, 1, 1614},
	{22823, 167404},
	{22839, 167408, 1, 1571},
	{22861, 167412},
	{22883, 167416},
	{22905, 167420},
	{22924, 167428},
	{22939, 167432, 2, 1569},
	{22955, 167436, 1, 1571},
	{22971, 167440, 3, 1572},
	{22986, 167444, 19, 2597},
	{23001, 167448, 8, 1594},
	{23018, 167452, 14, 2616},
	{23040, 167456},
	{23056, 167460, 1, 1614},
	{23078, 167464},
	{23094, 167468, 1, 1571},
	{23116, 167472},
	{23138, 167476},
	{23160, 167480},
	{23179, 167488, 1, 1615},
	{23198, 167492, 1, 1615},
	{23217, 167496, 1, 1615},
	{23236, 167500, 1, 1615},
	{23255, 167504, 1, 1615},
	{23274, 167508, 1, 1615},
	{23293, 167512, 1, 1615},
	{23312, 167516, 1, 1615},
	{23331, 167520, 1, 1615},
	{23356, 167524, 1, 1615},
	{23381, 167528, 1, 1615},
	{23406, 167532, 1, 1615},
	{23431, 167536, 1, 1615},
	{23456, 167540, 1, 1615},
	{23481, 167544, 1, 1615},
	{23506, 167548, 1, 1615},
	{23531, 167552, 1, 1615},
	{23556, 167556, 1, 1615},
	{23581, 167560, 1, 1615},
	{23606, 167564, 1, 1615},
	{23631, 167568, 1, 1615},
	{23656, 167572, 1, 1615},
	{23681, 167576, 1, 1615},
	{23706, 167580, 1, 1615},
	{23731, 167584, 1, 1615},
	{23754, 167588, 1, 1615},
	{23777, 167592, 1, 1615},
	{23800, 167596, 1, 1615},
	{23823, 167600, 1, 1615},
	{23846, 167604, 1, 1615},
	{23869, 167608, 1, 1615},
	{23892, 167612, 1, 1615},
	{23915, 167616, 3, 1616},
	{23933, 167620, 3, 1616},
	{23951, 167624, 3, 1616},
	{23969, 167628, 3, 1616},
	{23987, 167632, 3, 1616},
	{24005, 167636, 3, 1616},
	{24023, 167640, 3, 1616},
	{24041, 167644, 3, 1616},
	{24059, 167648, 9, 2630},
	{24077, 167652, 9, 2630},
	{24095, 167656, 9, 2630},
	{24113, 167660, 9, 2630},
	{24131, 167664, 9, 2630},
	{24149, 167668, 9, 2630},
	{24167, 167672, 9, 2630},
	{24185, 167676, 9, 2630},
	{24203, 196608, 1, 1627},
	{24223, 196612, 1, 1628},
	{24243, 196616},
	{24263, 196620},
	{24283, 196624},
	{24304, 196628},
	{24325, 196632, 1, 1629},
	{24347, 196636, 1, 1630},
	{24369, 196640},
	{24399, 196644},
	{24429, 196648},
	{24458, 196652},
	{24487, 196656},
	{24517, 196660},
	{24547, 196664},
	{24576, 196668},
	{24605, 196672},
	{24635, 196676},
	{24665, 196680},
	{24694, 196684},
	{24723, 196688},
	{24753, 196692},
	{24783, 196696},
	{24812, 196700},
	{24841, 196704, 1, 1631},
	{24863, 196708, 1, 1632},
	{24885, 196712},
	{24908, 196716},
	{24931, 196720},
	{24954, 196724},
	{24977, 196728},
	{25000, 196732},
	{25023, 196736},
	{25047, 196740},
	{25071, 196744},
	{25095, 196748},
	{25119, 196752},
	{25143, 196756},
	{25167, 196760},
	{25191, 196764},
	{25215, 196768},
	{25237, 196772},
	{25259, 196776},
	{25280, 196780},
	{25301, 196784},
	{25325, 196788},
	{25349, 196792},
	{25373, 196796},
	{25397, 196800},
	{25421, 196804},
	{25505, 196852, 1, 1634},
	{25527, 196856, 1, 1634},
	{25549, 196860, 1, 1635},
	{25565, 196864},
	{25578, 196868},
	{25591, 196872},
	{25604, 196876},
	{25617, 196880},
	{25630, 196884},
	{25643, 196888},
	{25656, 196892},
	{43196, 196896, 5, 2639},
	{25692, 196908, 1, 663},
	{25711, 196912},
	{25729, 196916},
	{25756, 196920},
	{25783, 196928, 2, 1636},
	{25796, 196932},
	{25809, 196936},
	{25832, 196940},
	{25855, 196944},
	{25883, 196948},
	{25911, 196952},
	{25939, 196956},
	{25967, 196960, 1, 1638},
	{25985, 196964, 4, 1639},
	{26003, 196968},
	{26018, 196972},
	{26042, 196976},
	{26066, 196980},
	{26085, 196984},
	{26104, 196988},
	{26128, 196992},
	{26152, 196996},
	{26176, 197000},
	{26200, 197028, 1, 1643},
	{26218, 197032, 2, 1644},
	{26236, 197036},
	{26254, 197040},
	{26272, 197044, 1, 1646},
	{26290, 197048, 2, 1647},
	{26308, 197052},
	{26326, 197056, 2, 2644},
	{26345, 197060, 5, 1651},
	{26364, 197072},
	{26388, 197076, 2, 2644},
	{26408, 197080, 5, 1651},
	{26428, 197084, 7, 1656},
	{26447, 197088, 7, 1656},
	{26465, 197092, 1, 1663},
	{26482, 197100, 1, 1664},
	{26503, 197104, 13, 1665},
	{26517, 197108},
	{26531, 197112},
	{26545, 197116, 2, 1678},
	{26561, 197120},
	{26580, 197124, 1, 1680},
	{26602, 197128},
	{26621, 197132, 1, 1681},
	{26643, 197136, 7, 1682},
	{26661, 197140},
	{26681, 197144, 1, 1680},
	{26704, 197148},
	{26724, 197152, 1, 1681},
	{26747, 197156, 7, 1682},
	{26766, 197160, 7, 1689},
	{26778, 197164, 2, 1696},
	{26795, 197168, 1, 1698},
	{26812, 197172, 1, 1699},
	{26830, 197176, 5, 2646},
	{26850, 197180, 2, 330},
	{26867, 197184},
	{26883, 197188, 1, 1706},
	{26910, 197196, 1, 1708},
	{26966, 197208, 1, 1711},
	{26988, 197212, 1, 1712},
	{27008, 197216, 1, 1707},
	{27025, 197220, 1, 1708},
	{27042, 197224},
	{27056, 197232, 2, 1713},
	{27078, 197236, 2, 1715},
	{27100, 197240, 2, 1713},
	{27123, 197244, 2, 1715},
	{27146, 197248, 2, 1713},
	{27168, 197252, 2, 1715},
	{43215, 197256},
	{43237, 197260},
	{43259, 197280},
	{43281, 197284},
	{43303, 197288},
	{43330, 197292},
	{43357, 197296},
	{43384, 197300},
	{27190, 197364, 1, 1717},
	{27211, 197368, 1, 1718},
	{27231, 197372, 1, 1719},
	{27268, 197380, 1, 1719},
	{27285, 197384, 1, 1720},
	{27301, 197388, 1, 1721},
	{27320, 197392, 1, 1722},
	{27339, 197396, 1, 1723},
	{27356, 197400, 1, 1724},
	{27374, 197404, 1, 1725},
	{27392, 197408, 1, 1726},
	{27408, 197412, 1, 1727},
	{27426, 197416, 1, 1728},
	{27444, 197420, 1, 1729},
	{27460, 197424, 1, 1724},
	{27475, 197428, 1, 1725},
	{27490, 197432, 1, 1726},
	{27503, 197436, 1, 1727},
	{27518, 197440, 1, 1728},
	{27533, 197444, 1, 1729},
	{27546, 197448, 1, 1730},
	{27560, 197452, 1, 1731},
	{27574, 197456, 1, 1732},
	{27586, 197460, 4, 1733},
	{27609, 197464, 5, 2651},
	{27631, 197468, 1, 1740},
	{27651, 197472, 1, 1741},
	{27665, 197476, 1, 1742},
	{27679, 197480, 1, 1743},
	{27691, 197484, 1, 1744},
	{27707, 197488, 1, 1741},
	{27724, 197492, 1, 1742},
	{27741, 197496, 1, 1743},
	{27756, 197500, 1, 1744},
	{27775, 197552, 1, 1745},
	{27800, 197556, 1, 1745},
	{27824, 197560, 1, 1746},
	{27844, 197568},
	{27870, 197572, 1, 1628},
	{27899, 197576},
	{27924, 197580, 1, 1628},
	{27952, 197584},
	{27975, 197588, 1, 1628},
	{28001, 197592},
	{28023, 197596, 1, 1628},
	{28048, 197600},
	{28067, 197604, 1, 1628},
	{28089, 197608, 1, 1343},
	{28103, 197612},
	{28120, 197616, 1, 1628},
	{28140, 197620, 8, 1747},
	{28157, 197624, 13, 1755},
	{28174, 197628},
	{28191, 197632, 1, 1698},
	{28211, 197636},
	{28228, 197640, 1, 1663},
	{28248, 197644, 2, 1768},
	{28267, 197888, 8, 1770},
	{28288, 197892, 8, 1770},
	{28309, 198656, 6, 1778},
	{28324, 198912},
	{28347, 198916},
	{28370, 198920, 1, 1784},
	{28389, 198924, 2, 2656},
	{28404, 198928},
	{28437, 198932},
	{28470, 198936},
	{28503, 198940},
	{28536, 198948},
	{28552, 198952},
	{28567, 198956, 2, 1357},
	{28593, 198960},
	{28609, 198964},
	{28627, 198968, 1, 1785},
	{28648, 198972, 2, 2658},
	{28673, 198976},
	{28696, 198980},
	{28715, 198984},
	{28731, 198988, 1, 830},
	{28750, 198992},
	{28770, 198996, 1, 830},
	{28793, 199000},
	{28811, 199004, 1, 830},
	{28832, 199008, 9, 1788},
	{28857, 199012},
	{28873, 199016},
	{28894, 199020, 4, 1797},
	{28902, 199024},
	{28916, 199028},
	{28930, 199032},
	{28944, 199036, 3, 1801},
	{28959, 199040, 2, 1804},
	{28971, 199044, 1, 830},
	{28997, 199048, 3, 1806},
	{43411, 199052, 2, 2660},
	{29013, 199168, 1, 1809},
	{29038, 199172, 2, 1810},
	{29063, 199184, 2, 1812},
	{29089, 199188, 2, 1812},
	{29115, 199192, 2, 1812},
	{29141, 199212, 2, 1812},
	{29167, 199296, 2, 1814},
	{29195, 199300, 1, 1816},
	{29219, 199304, 1, 1817},
	{29243, 199308, 1, 1818},
	{29276, 199312, 1, 1818},
	{29304, 199328, 2, 1814},
	{29333, 199332, 1, 1816},
	{29358, 199336, 1, 1817},
	{29383, 199340, 1, 1818},
	{29417, 199344, 1, 1818},
	{29446, 199360, 2, 1814},
	{29470, 199364, 1, 1816},
	{29490, 199368, 1, 1817},
	{29510, 199372, 1, 1818},
	{29539, 199376, 1, 1818},
	{29563, 199936},
	{29590, 199940},
	{29617, 199944},
	{29644, 199948},
	{29671, 199952},
	{29698, 199956},
	{29725, 199960},
	{29752, 199964},
	{29779, 199968, 5, 2662},
	{29804, 200192},
	{29823, 200196, 1, 840},
	{29845, 200448},
	{29869, 200452, 1, 1828},
	{29892, 200456},
	{29916, 200460, 1, 1828},
	{29939, 200464},
	{29963, 200468, 1, 1828},
	{29986, 200472},
	{30010, 200476, 1, 1828},
	{30033, 200696},
	{30052, 200700, 1, 1828},
	{30070, 200704},
	{30082, 200708},
	{30094, 200712},
	{30112, 200716},
	{30131, 200720},
	{30149, 200724},
	{30161, 200728},
	{30173, 200732},
	{30191, 200736},
	{30209, 200740},
	{30228, 200744, 4, 1829},
	{30242, 200748, 2, 1833},
	{30260, 200752, 2, 1835},
	{30274, 200756, 2, 1837},
	{30288, 200760, 2, 1839},
	{30305, 200764, 2, 1841},
	{30322, 200768},
	{30335, 200772, 2, 1843},
	{30347, 200776},
	{30361, 200780},
	{30377, 200784},
	{30391, 200788},
	{30407, 200792},
	{30422, 200796},
	{30439, 200800},
	{30454, 200804},
	{30471, 200808, 2, 1845},
	{30493, 200812, 11, 2667},
	{30510, 200816, 2, 1857},
	{30531, 200820, 2, 1859},
	{30543, 200824},
	{30558, 200828, 6, 1861},
	{30573, 200832, 2, 1867},
	{30587, 200836},
	{30604, 200960},
	{30626, 200964},
	{30650, 200968},
	{30674, 200972},
	{30700, 212992},
	{30720, 212996},
	{30740, 213000},
	{30760, 213004},
	{30780, 213008},
	{30800, 213012},
	{30820, 213016},
	{30840, 213020},
	{30860, 213024},
	{30880, 213028},
	{30900, 213032},
	{30920, 213036},
	{30940, 213040},
	{30963, 213044},
	{30986, 213048},
	{31009, 213248},
	{31030, 213252},
	{31051, 213260},
	{31072, 213264},
	{31093, 213268},
	{31117, 213272},
	{31141, 213276},
	{31165, 213280},
	{31189, 213284},
	{31213, 213288},
	{31237, 213292},
	{31261, 213296},
	{43423, 213648},
	{43443, 213652},
	{43463, 213656},
	{43483, 213660},
	{43503, 213664},
	{43523, 213668},
	{43543, 213672},
	{43563, 213676},
	{43583, 213680},
	{43608, 213684},
	{43633, 213688},
	{43658, 213692},
	{43683, 213696},
	{43708, 213700},
	{43733, 213704},
	{43758, 213708},
	{43783, 213712},
	{43806, 213716},
	{43829, 213720},
	{43852, 213724},
	{43875, 213728},
	{43898, 213732},
	{43921, 213736},
	{43944, 213740},
	{31745, 214016},
	{31767, 214020, 1, 1869},
	{31789, 214024},
	{31811, 214028, 1, 1869},
	{31833, 214032},
	{31855, 214036, 1, 1869},
	{31877, 214040},
	{31899, 214044, 1, 1869},
	{31921, 214272},
	{31943, 214276},
	{31965, 214280},
	{31987, 214284},
	{32009, 214288},
	{32031, 214292},
	{32053, 214296},
	{32075, 214300},
	{32097, 214304},
	{32119, 214308},
	{32141, 214312},
	{32163, 214316},
	{32185, 214320},
	{32207, 214324},
	{32229, 214328},
	{32251, 214332},
	{32273, 214528},
	{32293, 214532},
	{32313, 214536},
	{32333, 214540},
	{32353, 214544},
	{32373, 214548},
	{32393, 214552},
	{32413, 214556},
	{32433, 214560},
	{32453, 214564},
	{32473, 214568},
	{32493, 214572},
	{32513, 214784},
	{32532, 214788},
	{32551, 214792},
	{32570, 214796},
	{32589, 214800},
	{32608, 214804},
	{32627, 214808},
	{32646, 214812},
	{32665, 214816},
	{32684, 214820},
	{32703, 214824},
	{32722, 214828},
	{32741, 214832},
	{32760, 214836},
	{32779, 214840},
	{32798, 214844},
	{32817, 214848},
	{32836, 214852},
	{32855, 214856},
	{32874, 214860},
	{32893, 214864},
	{32913, 214868},
	{32933, 214872},
	{32953, 214876},
	{32973, 214880},
	{32993, 214884},
	{33013, 214888},
	{33033, 214892},
	{33053, 214896},
	{33073, 214900},
	{33093, 214904},
	{33113, 214908},
	{33133, 215296},
	{33152, 215300},
	{33171, 215304},
	{33190, 215308},
	{33209, 215312},
	{33228, 215316},
	{33247, 215320},
	{33266, 215324},
	{33285, 215424},
	{33306, 215428},
	{43967, 215432},
	{43987, 215436, 2, 1870},
	{33327, 215552},
	{33347, 215556},
	{33367, 215560},
	{33387, 215564},
	{33407, 215568},
	{33427, 215572},
	{33447, 215576},
	{33467, 215580},
	{33487, 215808},
	{33506, 215812},
	{33525, 215816},
	{33544, 215820},
	{33563, 216064},
	{33582, 216068},
	{33601, 216072},
	{33620, 216076},
	{33639, 216320},
	{33659, 216324},
	{33679, 216328},
	{33699, 216332},
	{33719, 216336},
	{33739, 216340},
	{33759, 216344},
	{33779, 216348},
	{33799, 216576},
	{33820, 216580},
	{33841, 216584},
	{33862, 216588},
	{33883, 216592},
	{33904, 216596},
	{33925, 216600},
	{33946, 216604},
	{33967, 216640},
	{33988, 216644},
	{34009, 216648},
	{34030, 216652},
	{34051, 216656},
	{34072, 216660},
	{34093, 216664},
	{34114, 216668},
	{34135, 216704},
	{34156, 216708},
	{34177, 216712},
	{34198, 216716},
	{34219, 216720},
	{34240, 216724},
	{34261, 216728},
	{34282, 216732},
	{34303, 216832},
	{34323, 216836},
	{34343, 216840},
	{34363, 216844},
	{34383, 216848},
	{34403, 216852},
	{34423, 216856},
	{34443, 216860},
	{34463, 216864},
	{34484, 216868},
	{34505, 216872},
	{34526, 216876},
	{34547, 216880},
	{34568, 216884},
	{34589, 216888},
	{34610, 216892},
	{34631, 217112},
	{34650, 217116},
	{34669, 217120},
	{34688, 217124},
	{34707, 217128},
	{34726, 217132},
	{34745, 217136},
	{34764, 217140},
	{34783, 217344},
	{34802, 217348},
	{34821, 217352},
	{34840, 217356},
	{34859, 217360},
	{34878, 217364},
	{34897, 217368},
	{34916, 217372},
	{34935, 217600},
	{34955, 217604},
	{34975, 217608},
	{34995, 217612},
	{35015, 217856},
	{35035, 217860},
	{35055, 217864},
	{35075, 217868},
	{35095, 217872},
	{35115, 217876},
	{35135, 217880},
	{35155, 217884},
	{35225, 218016},
	{35251, 218020, 2, 1870},
	{44007, 218024},
	{44030, 218028, 2, 1870},
	{35277, 218080},
	{35302, 218084},
	{35327, 218088},
	{35352, 218092},
	{35429, 218224},
	{35451, 218228},
	{35473, 218232},
	{35495, 218236},
	{35517, 218240},
	{35537, 218244},
	{35557, 218248},
	{35577, 218252},
	{35597, 218624},
	{35619, 218628},
	{35641, 218632},
	{35663, 218636},
	{35685, 218640},
	{35707, 218644},
	{35729, 218648},
	{35751, 218652},
	{35773, 218656},
	{35795, 218660},
	{35817, 218664},
	{35839, 218668},
	{35861, 218672},
	{35883, 218676},
	{35905, 218680},
	{35927, 218684},
	{35949, 218880},
	{35970, 218884},
	{35991, 218888},
	{36012, 218892},
	{36033, 218896},
	{36054, 218900},
	{36075, 218904},
	{36096, 218908},
	{36117, 219136},
	{36137, 219140},
	{36157, 219144},
	{36177, 219148},
	{36197, 219152},
	{36217, 219156},
	{36237, 219160},
	{36257, 219164},
	{36277, 219392},
	{36297, 219396},
	{44053, 219400},
	{44072, 219404, 2, 1870},
	{44091, 219520},
	{44120, 219524, 2, 1870},
	{44149, 219528},
	{44171, 219532},
	{44193, 219536},
	{44215, 219540},
	{44237, 219568},
	{44266, 219572, 2, 1870},
	{44295, 219576},
	{44317, 219580},
	{44339, 219584},
	{44361, 219588},
	{44383, 219616},
	{44412, 219620, 2, 1870},
	{44441, 219624},
	{44463, 219628},
	{44485, 219632},
	{44507, 219636},
	{44529, 219664},
	{44558, 219668, 2, 1870},
	{44587, 219672},
	{44609, 219676},
	{44631, 219680},
	{44653, 219684},
	{36317, 221184, 5, 1872},
	{36341, 221188, 4, 1877},
	{36366, 221192, 5, 1872},
	{36390, 221196, 5, 1872},
	{36414, 221200, 4, 1877},
	{36439, 221204, 5, 1872},
	{36463, 221208, 4, 1877},
	{36488, 221212, 5, 1872},
	{36512, 221216, 4, 1881},
	{36528, 221220, 5, 1872},
	{36552, 221224, 3, 1885},
	{36586, 221228, 3, 1888},
	{36620, 221232, 3, 1891},
	{36645, 221236, 3, 1894},
	{36670, 221240, 3, 1891},
	{36695, 221248},
	{36710, 221252, 1, 1818},
	{36733, 221256},
	{36756, 221260},
	{36774, 221264, 2, 1897},
	{36792, 221268, 4, 1899},
	{36812, 221440, 20, 1903},
	{36837, 221444, 20, 1903},
	{36862, 221448, 15, 1923},
	{36890, 221452, 15, 1923},
	{36918, 221456, 15, 1923},
	{36946, 221460, 15, 1923},
	{36974, 221492, 8, 1938},
	{37002, 221496, 8, 1938},
	{44675, 221840, 5, 1946},
	{44699, 221844, 4, 1951},
	{44724, 221848, 5, 1946},
	{44748, 221852, 4, 1951},
	{44773, 221856, 5, 1946},
	{44797, 221860, 4, 1951},
	{44822, 221864, 5, 1946},
	{44846, 221868, 4, 1951},
	{44871, 221872, 5, 1946},
	{44900, 221876, 4, 1951},
	{44930, 221880, 5, 1946},
	{44959, 221884, 4, 1951},
	{44989, 221888, 5, 1946},
	{45018, 221892, 4, 1951},
	{45048, 221896, 5, 1946},
	{45077, 221900, 4, 1951},
	{45107, 221904, 5, 1946},
	{45134, 221908, 4, 1951},
	{45162, 221912, 5, 1946},
	{45189, 221916, 4, 1951},
	{45217, 221920, 5, 1946},
	{45244, 221924, 4, 1951},
	{45272, 221928, 5, 1946},
	{45299, 221932, 4, 1951},
	{37404, 222208, 5, 1957},
	{37430, 222212, 4, 1962},
	{37457, 222216, 5, 1957},
	{37483, 222220, 4, 1962},
	{37510, 222224, 5, 1957},
	{37536, 222228, 4, 1962},
	{37563, 222232, 5, 1957},
	{37589, 222236, 4, 1962},
	{37616, 222464, 5, 1957},
	{37642, 222468, 4, 1962},
	{37669, 222472, 1, 1872},
	{37695, 222476, 1, 1872},
	{37721, 222480, 1, 1872},
	{37747, 222484, 1, 1872},
	{37773, 222488, 1, 1872},
	{37799, 222492, 1, 1872},
	{37825, 222496, 1, 1872},
	{37851, 222720, 5, 1957},
	{37875, 222724, 5, 1957},
	{37899, 222728, 5, 1957},
	{37923, 222732, 5, 1957},
	{37947, 222736, 4, 1962},
	{37972, 222740, 4, 1962},
	{37997, 222744, 4, 1962},
	{38022, 222748, 4, 1962},
	{38047, 222752, 1, 1872},
	{38071, 222756, 1, 1872},
	{38095, 222760, 8, 1966},
	{38116, 222976, 3, 2678},
	{38139, 222980, 3, 2678},
	{38162, 222984, 3, 2678},
	{38185, 222988, 3, 2678},
	{38208, 222992, 3, 2678},
	{38231, 222996, 3, 2678},
	{38254, 223000, 3, 2678},
	{38277, 223004, 3, 2678},
	{38300, 223008, 3, 2678},
	{38323, 223012, 3, 2678},
	{38346, 223016, 3, 2678},
	{38370, 223020, 3, 2678},
	{38394, 223024, 3, 2678},
	{38418, 223028, 3, 2678},
	{38442, 223032, 3, 2678},
	{38466, 223036, 3, 2678},
	{38490, 223104, 15, 2681},
	{38510, 223112, 1, 1987},
	{38531, 223232, 5, 1957},
	{38556, 223236, 4, 1962},
	{38582, 223240, 8, 1988},
	{45327, 223244, 5, 2140},
	{45349, 223248, 5, 2140},
	{45371, 223252, 6, 2145},
	{38605, 223488, 5, 1957},
	{38628, 223492, 5, 1957},
	{38651, 223496, 3, 2013},
	{38674, 223500, 3, 2013},
	{38697, 223504, 4, 1962},
	{38721, 223508, 4, 1962},
	{38745, 223744, 5, 1957},
	{38769, 223748, 5, 1957},
	{38793, 223752, 5, 1957},
	{38817, 223756, 5, 1957},
	{38841, 223760, 4, 1962},
	{45398, 223764, 4, 1962},
	{45423, 223768, 4, 1962},
	{45448, 223772, 4, 1962},
	{38866, 224000, 5, 1957},
	{38889, 224004, 4, 1962},
	{38913, 224008, 3, 2013},
	{38936, 224256, 5, 1957},
	{38959, 224260, 4, 1962},
	{38983, 224264, 3, 2013},
	{39006, 224512, 5, 1957},
	{39030, 224516, 4, 1962},
	{39055, 224520, 5, 1957},
	{39079, 224524, 4, 1962},
	{39104, 224528, 3, 2013},
	{39128, 224532, 3, 2013},
	{39152, 224768, 5, 1957},
	{39177, 224772, 4, 1951},
	{39203, 224776, 5, 1957},
	{39228, 224780, 4, 1951},
	{39254, 224784, 3, 2013},
	{39279, 224788, 3, 2013},
	{39304, 224832, 5, 1957},
	{39329, 224836, 4, 1951},
	{39355, 224840, 5, 1957},
	{39380, 224844, 4, 1951},
	{39406, 224848, 3, 2013},
	{39431, 224852, 3, 2013},
	{39456, 224896, 5, 1957},
	{39481, 224900, 4, 1951},
	{39507, 224904, 3, 2013},
	{39532, 224908, 3, 2013},
	{39557, 224912, 3, 2013},
	{39582, 225024, 5, 1957},
	{39606, 225028, 4, 1951},
	{39631, 225032, 3, 2013},
	{39655, 225036, 3, 2013},
	{39679, 225040, 3, 2013},
	{39703, 225048, 5, 1957},
	{39728, 225052, 4, 1951},
	{39754, 225056, 3, 2013},
	{39779, 225060, 3, 2013},
	{39804, 225064, 3, 2013},
	{39829, 225280, 12, 2016},
	{39851, 225284, 5, 2028},
	{39874, 225288, 4, 2033},
	{39898, 225292, 2, 2037},
	{39921, 225296, 2, 2037},
	{39944, 225300, 2, 2037},
	{39967, 225536, 5, 1957},
	{39990, 225540, 4, 1962},
	{40014, 225544, 5, 1957},
	{40037, 225548, 4, 1962},
	{40061, 225552, 5, 1957},
	{40084, 225560, 5, 1957},
	{40107, 225792, 4, 2039},
	{40128, 225796},
	{40157, 225800, 2, 2043},
	{40186, 225804},
	{40212, 225808, 7, 2045},
	{40241, 225812},
	{40260, 225816, 2, 2052},
	{40286, 225820, 2, 2054},
	{40309, 225824},
	{40332, 225828, 2, 2056},
	{40359, 225832},
	{40386, 225836, 2, 2058},
	{40411, 225840, 2, 2060},
	{40439, 225844, 2, 2062},
	{40467, 225848, 2, 2064},
	{40490, 225852, 2, 2066},
	{40513, 225856},
	{40546, 225860, 2, 2068},
	{40579, 225864},
	{40611, 225868, 2, 2068},
	{40643, 225872, 2, 2070},
	{40662, 225876, 2, 2072},
	{40689, 225880},
	{40716, 225884, 2, 2696},
	{40743, 225888, 2, 2076},
	{40770, 225892, 17, 2698},
	{40791, 225896, 9, 2715},
	{40810, 225900, 19, 2724},
	{40829, 225904, 1, 2104},
	{40853, 225908, 1, 2106},
	{40885, 225912, 2, 2108},
	{40915, 225916, 4, 2110},
	{40951, 225920, 3, 2114},
	{40984, 225924, 1, 2117},
	{45473, 225928, 7, 2045},
	{41002, 225932, 1, 2118},
	{45506, 225936},
	{45533, 225940},
	{45559, 225944, 4, 2110},
	{45599, 225948, 2, 2743},
	{45633, 225952, 2, 2743},
	{45663, 225956, 2, 2072},
	{45694, 225960},
	{45725, 225964, 4, 2745},
	{45759, 225968, 3, 2114},
	{45796, 225972, 3, 2749},
	{41022, 226048, 2, 2119},
	{41039, 226052, 1, 2121},
	{41063, 226056, 1, 2121},
	{41087, 226060, 4, 2122},
	{41113, 226064, 3, 2126},
	{41142, 226068, 1, 687},
	{41171, 226072, 3, 2126},
	{41200, 226076, 1, 687},
	{41229, 226192, 1, 2129},
	{41277, 226304, 5, 2028},
	{41301, 226308, 4, 2033},
	{41326, 226312, 2, 2037},
	{41350, 226316, 5, 2028},
	{41374, 226320, 4, 2033},
	{41399, 226324, 2, 2037},
	{41423, 226328, 10, 2130},
	{41531, 226480, 5, 2140},
	{41559, 226484, 5, 2140},
	{41587, 226488, 5, 2140},
	{41615, 226492, 5, 2140},
	{41643, 226496, 5, 2140},
	{41671, 226500, 5, 2140},
	{41699, 226504, 5, 2140},
	{41727, 226508, 5, 2140},
	{41755, 226512, 6, 2145},
	{45837, 226516, 5, 2140},
	{45862, 226520, 5, 2140},
	{45887, 226524, 5, 2140},
	{45912, 226528, 5, 2140},
	{45937, 226532, 6, 2145},
	{41788, 226544, 5, 1957},
	{41817, 226548, 5, 1957},
	{41846, 226552, 4, 1962},
	{41876, 226556, 4, 1962},
	{41906, 226560, 8, 1988},
	{41933, 226564, 8, 1988},
	{42049, 226688, 5, 2028},
	{42073, 226692, 4, 2033},
	{42098, 226696, 3, 2151},
	{42122, 226700, 2, 2154},
	{42148, 226704, 2, 2154},
	{42174, 226816, 5, 1957},
	{42200, 226820, 4, 1962},
	{42227, 226824, 5, 1957},
	{42253, 226828, 5, 1957},
	{42279, 226832, 5, 1957},
	{42305, 226836, 1, 1872},
	{42331, 226840, 1, 1872},
	{42357, 226844, 1, 1872},
	{42383, 226848, 1, 1872},
	{42409, 226880, 4, 1962},
	{42436, 226884, 4, 1962},
	{42463, 226888, 4, 1962},
	{42490, 227072, 5, 1957},
	{42515, 227076, 4, 1951},
	{42541, 227080, 3, 2013},
	{42566, 227084, 3, 2013},
	{42591, 227088, 3, 2013},
	{42616, 227200, 5, 1957},
	{42640, 227204, 4, 1951},
	{42665, 227208, 3, 2013},
	{42689, 227212, 3, 2013},
	{42713, 227216, 3, 2013},
	{42737, 227328, 5, 1957},
	{42761, 227332, 4, 1962},
	{42786, 227336, 8, 1988},
	{45967, 227340, 5, 2140},
	{45988, 227344, 5, 2140},
	{46009, 227348, 6, 2145},
	{46035, 227456, 5, 2140},
	{46066, 227460, 5, 2140},
	{46097, 227464, 6, 2145},
	{46133, 227468, 1, 2752},
	{46157, 227472, 5, 1957},
	{46183, 227476, 4, 1962},
	{46210, 227480, 5, 1957},
	{46236, 227484, 4, 1962},
	{46263, 227504, 5, 2140},
	{46294, 227508, 5, 2140},
	{46325, 227512, 6, 2145},
	{46361, 227516, 1, 2752},
	{46385, 227520, 5, 1957},
	{46411, 227524, 4, 1962},
	{46438, 227528, 5, 1957},
	{46464, 227532, 4, 1962},
	{46491, 227552, 5, 2140},
	{46522, 227556, 5, 2140},
	{46553, 227560, 6, 2145},
	{46589, 227564, 1, 2752},
	{46613, 227568, 5, 1957},
	{46639, 227572, 4, 1962},
	{46666, 227576, 5, 1957},
	{46692, 227580, 4, 1962},
	{46719, 227600, 5, 2140},
	{46750, 227604, 5, 2140},
	{46781, 227608, 6, 2145},
	{46817, 227612, 1, 2752},
	{46841, 227616, 5, 1957},
	{46867, 227620, 4, 1962},
	{46894, 227624, 5, 1957},
	{46920, 227628, 4, 1962},
	{195, 880, 4, 2156},
	{42808, 881},
	{26631, 882},
	{42820, 1008},
	{42831, 1009},
	{26819, 1010, 3, 2160},
	{42842, 1040, 1, 2163},
	{42855, 1041, 5, 2164},
	{42868, 1042, 1, 2169},
	{42881, 1043, 1, 1681},
	{26653, 1045, 7, 2170},
	{42894, 1168, 12, 2177},
	{42909, 1280, 6, 2189},
	{42924, 1281},
	{26590, 1282},
	{42808, 1283},
	{26631, 1284},
	{42936, 1414, 15, 2195},
};

static const struct si_reg gfx6_reg_table[] = {
	{974, 68, 9, 2753},
	{987, 72, 24, 2762},
	{1002, 76, 3, 2786},
	{46947, 80, 11, 2789},
	{1039, 84, 4, 2800},
	{1057, 88, 2, 2804},
	{1075, 92, 4, 2806},
	{1090, 96},
	{1104, 100, 1, 2810},
	{1118, 104},
	{46961, 108},
	{46978, 112, 13, 2811},
	{46994, 2480},
	{47009, 2484, 1, 2824},
	{47024, 2488},
	{47039, 2492, 1, 2824},
	{1273, 2496},
	{1287, 2500},
	{1301, 2504},
	{1315, 2508},
	{1329, 2512},
	{1343, 2516},
	{1357, 2520},
	{1371, 2524},
	{1385, 2528},
	{1399, 2532},
	{1413, 2536},
	{1428, 2540},
	{1503, 2544},
	{1514, 2552},
	{1530, 2556},
	{47054, 3660, 21, 2825},
	{47067, 3664, 20, 2846},
	{47079, 3668, 16, 2866},
	{47092, 32768, 1, 2882},
	{47102, 32772, 2, 2883},
	{1618, 32776, 17, 2885},
	{47117, 32780, 2, 2902},
	{1631, 32784, 24, 2904},
	{1643, 32788, 11, 2928},
	{1659, 32792, 11, 2928},
	{47131, 32800, 6, 2939},
	{47147, 32804, 1, 2945},
	{47163, 32808},
	{28309, 32812, 6, 2946},
	{47179, 32816, 2, 2952},
	{47199, 32820, 1, 2954},
	{47221, 32848, 6, 2955},
	{47232, 32852, 22, 2961},
	{47252, 32856, 4, 2983},
	{47268, 32864, 2, 2987},
	{36812, 32880, 19, 2989},
	{36837, 32884, 19, 2989},
	{31009, 32888},
	{31030, 32892},
	{31051, 32896},
	{31072, 32900},
	{36862, 32920, 12, 3008},
	{36890, 32924, 12, 3008},
	{31093, 32936},
	{31117, 32940},
	{31141, 32944},
	{31165, 32948},
	{47282, 33008, 1, 3020},
	{47168, 33012},
	{47294, 33020},
	{47307, 33024},
	{47325, 33028},
	{47343, 33032},
	{47361, 33036},
	{47379, 33040},
	{47397, 33044},
	{47415, 33048},
	{47433, 33052},
	{47451, 33536, 10, 3021},
	{24203, 33792, 2, 3031},
	{24223, 33796, 1, 1628},
	{24243, 33800},
	{24263, 33804},
	{24283, 33808},
	{24304, 33812},
	{24325, 33816, 2, 3033},
	{24347, 33820},
	{24369, 33824},
	{24399, 33828},
	{24429, 33832},
	{24458, 33836},
	{24487, 33840},
	{24517, 33844},
	{24547, 33848},
	{24576, 33852},
	{24605, 33856},
	{24635, 33860},
	{24665, 33864},
	{24694, 33868},
	{24723, 33872},
	{24753, 33876},
	{24783, 33880},
	{24812, 33884},
	{24841, 33888, 2, 3035},
	{24863, 33892},
	{24885, 33896},
	{24908, 33900},
	{24931, 33904},
	{24954, 33908},
	{24977, 33912},
	{25000, 33916},
	{25023, 33920},
	{25047, 33924},
	{25071, 33928},
	{25095, 33932},
	{25119, 33936},
	{25143, 33940},
	{25167, 33944},
	{25191, 33948},
	{25215, 33952},
	{25237, 33956},
	{25259, 33960},
	{25280, 33964},
	{25301, 33968},
	{25325, 33972},
	{25349, 33976},
	{25373, 33980},
	{25397, 33984},
	{25421, 33988},
	{25549, 34044, 1, 1635},
	{25565, 34048},
	{25578, 34052},
	{25591, 34056},
	{25604, 34060},
	{25617, 34064},
	{25630, 34068},
	{25643, 34072},
	{25656, 34076},
	{25783, 34112, 2, 1636},
	{25796, 34116},
	{25967, 34144, 1, 1638},
	{25985, 34148, 3, 3037},
	{26003, 34152},
	{26018, 34156},
	{26042, 34160},
	{26066, 34164},
	{26085, 34168},
	{26104, 34172},
	{26128, 34176},
	{26152, 34180},
	{26176, 34184},
	{26200, 34212, 2, 3040},
	{26218, 34216, 1, 3042},
	{26236, 34220},
	{26254, 34224},
	{26272, 34228, 2, 3043},
	{26290, 34232, 1, 3045},
	{26308, 34236},
	{26326, 34240, 2, 1649},
	{26345, 34244, 5, 3046},
	{26364, 34256},
	{26388, 34260, 2, 1649},
	{26408, 34264, 5, 3046},
	{26482, 34284, 1, 1664},
	{26503, 34288, 23, 3051},
	{26517, 34292},
	{26531, 34296},
	{26545, 34300, 4, 3074},
	{26561, 34304},
	{26580, 34308, 1, 3078},
	{26602, 34312},
	{26621, 34316, 1, 3079},
	{26643, 34320, 9, 3080},
	{26661, 34324},
	{26681, 34328, 1, 3078},
	{26704, 34332},
	{26724, 34336, 1, 3079},
	{26747, 34340, 9, 3080},
	{26766, 34344, 5, 3089},
	{26778, 34348, 2, 1696},
	{26812, 34356, 1, 3094},
	{26830, 34360, 5, 2646},
	{26850, 34364, 1, 1704},
	{26867, 34368},
	{26883, 34372, 1, 1706},
	{26896, 34376, 1, 1707},
	{26910, 34380, 1, 1708},
	{26924, 34384, 1, 1709},
	{26946, 34388, 1, 1710},
	{26966, 34392, 1, 1711},
	{26988, 34396, 1, 1712},
	{47474, 34416, 15, 3095},
	{47491, 34420, 18, 3110},
	{47508, 34424, 31, 3128},
	{47525, 34428, 16, 3159},
	{47538, 34432, 24, 3175},
	{47546, 34436},
	{47564, 34440},
	{47583, 34444, 3, 3199},
	{47602, 34448},
	{47620, 34460, 1, 3202},
	{47641, 34512, 2, 3203},
	{47653, 34516, 1, 3205},
	{47665, 34520, 9, 3206},
	{47676, 34528, 4, 3215},
	{47689, 34532, 1, 3219},
	{47706, 34552, 1, 3220},
	{47718, 34556, 1, 3220},
	{47730, 34560, 1, 3220},
	{47742, 34564, 2, 3221},
	{47759, 34568, 2, 3223},
	{27301, 34572, 1, 1721},
	{27320, 34576, 1, 3225},
	{27339, 34580, 1, 1723},
	{27356, 34584, 1, 1724},
	{27374, 34588, 1, 3226},
	{27392, 34592, 1, 1726},
	{27408, 34596, 1, 1727},
	{27426, 34600, 1, 3227},
	{27444, 34604, 1, 1729},
	{27460, 34608, 1, 1724},
	{27475, 34612, 1, 3226},
	{27490, 34616, 1, 1726},
	{27503, 34620, 1, 1727},
	{27518, 34624, 1, 3227},
	{27533, 34628, 1, 1729},
	{27546, 34632, 1, 1730},
	{27560, 34636, 1, 3228},
	{27574, 34640, 1, 1732},
	{47780, 34644, 4, 3229},
	{47799, 34648, 4, 3233},
	{47818, 34652, 3, 3237},
	{47836, 34656, 2, 3240},
	{47856, 34660, 2, 3242},
	{47874, 34664, 2, 3244},
	{47887, 34668, 1, 3246},
	{47900, 34672, 1, 3247},
	{47914, 34676, 1, 3248},
	{47927, 34680, 3, 3249},
	{47940, 34684},
	{47952, 34688, 2, 3252},
	{47967, 34692, 2, 3254},
	{47983, 34696, 2, 3256},
	{47999, 34700, 1, 3258},
	{48011, 34708, 2, 3259},
	{48023, 34712, 2, 3261},
	{48037, 34716, 1, 3263},
	{48051, 34720, 2, 3264},
	{48069, 34724, 2, 3266},
	{48088, 34728, 2, 3268},
	{48107, 34780, 12, 3270},
	{36512, 34812, 4, 1881},
	{48125, 34944, 5, 3282},
	{48148, 34948, 2, 3287},
	{48171, 34952, 2, 3287},
	{48194, 34956, 2, 3287},
	{48217, 34960},
	{48236, 34964},
	{48255, 34968},
	{48274, 34972},
	{48293, 34976},
	{48312, 34980},
	{48331, 34984},
	{48350, 34988},
	{48369, 34992, 1, 3289},
	{48392, 34996, 1, 3290},
	{48416, 35000, 1, 3291},
	{48439, 35004, 1, 3292},
	{48464, 35008, 2, 3293},
	{48484, 35012, 8, 3295},
	{48507, 35016},
	{48526, 35020},
	{48545, 35024, 4, 3303},
	{48561, 35028, 1, 3307},
	{48581, 35032, 1, 3308},
	{48597, 35036, 5, 3309},
	{48612, 35040, 2, 3314},
	{48627, 35044},
	{48642, 35048, 2, 3316},
	{48656, 35052},
	{48670, 35056, 10, 3318},
	{48686, 35100, 1, 3328},
	{48712, 35104, 5, 3282},
	{48736, 35108, 5, 3282},
	{48760, 35112, 2, 3287},
	{48784, 35116, 2, 3287},
	{48808, 35120},
	{48828, 35124},
	{48848, 35128},
	{48868, 35132},
	{48888, 35136},
	{48908, 35140},
	{48928, 35144},
	{48948, 35148},
	{28370, 35160, 1, 3329},
	{28389, 35164, 1, 3330},
	{28404, 35168},
	{28437, 35172},
	{28470, 35176},
	{28503, 35180},
	{28593, 35184},
	{28609, 35188},
	{48968, 35196, 10, 3331},
	{48986, 35200, 2, 3341},
	{49003, 35204, 10, 3343},
	{49020, 35208, 1, 1785},
	{49037, 35212, 3, 3353},
	{49052, 35248, 2, 3356},
	{49073, 35256},
	{49092, 35260, 4, 3358},
	{49118, 35264, 4, 3358},
	{49146, 35328, 1, 3362},
	{49163, 35332},
	{49180, 35344, 1, 3363},
	{49198, 35348, 9, 3364},
	{49212, 35352, 10, 3373},
	{37404, 35360, 3, 3282},
	{37457, 35364, 3, 3282},
	{37510, 35368, 2, 2010},
	{37563, 35372, 2, 2010},
	{31745, 35376},
	{31767, 35380, 1, 1869},
	{31789, 35384},
	{31811, 35388, 1, 1869},
	{31833, 35392},
	{31855, 35396, 1, 1869},
	{31877, 35400},
	{31899, 35404, 1, 1869},
	{49229, 35408, 1, 3383},
	{49247, 35412, 1, 3384},
	{29013, 35424, 1, 1809},
	{37616, 35456, 3, 3385},
	{37669, 35460, 1, 1974},
	{37695, 35464, 1, 1974},
	{37721, 35468, 1, 1974},
	{37747, 35472, 1, 1974},
	{37773, 35476, 1, 1974},
	{37799, 35480, 1, 1974},
	{37825, 35484, 1, 1974},
	{31921, 35488},
	{31943, 35492},
	{31965, 35496},
	{31987, 35500},
	{32009, 35504},
	{32031, 35508},
	{32053, 35512},
	{32075, 35516},
	{32097, 35520},
	{32119, 35524},
	{32141, 35528},
	{32163, 35532},
	{32185, 35536},
	{32207, 35540},
	{32229, 35544},
	{32251, 35548},
	{29038, 35600, 2, 1810},
	{49269, 35620, 2, 3388},
	{49294, 35624, 10, 3390},
	{49311, 35788, 4, 3400},
	{49327, 35796, 4, 3404},
	{49346, 35800, 1, 3408},
	{49363, 35804},
	{49380, 35824, 26, 3409},
	{49394, 35840, 9, 3435},
	{49404, 35844, 9, 3444},
	{29779, 35848, 3, 3453},
	{49415, 35852, 3, 3456},
	{49434, 35856, 6, 3459},
	{49449, 35860, 4, 3465},
	{38490, 35864, 9, 3469},
	{49463, 35868, 4, 3478},
	{49483, 35872, 4, 3478},
	{49505, 35876, 4, 3482},
	{32513, 35968},
	{32532, 35972},
	{32551, 35976},
	{32570, 35980},
	{32589, 35984},
	{32608, 35988},
	{32627, 35992},
	{32646, 35996},
	{32665, 36000},
	{32684, 36004},
	{32703, 36008},
	{32722, 36012},
	{32741, 36016},
	{32760, 36020},
	{32779, 36024},
	{32798, 36028},
	{32817, 36032},
	{32836, 36036},
	{32855, 36040},
	{32874, 36044},
	{32893, 36048},
	{32913, 36052},
	{32933, 36056},
	{32953, 36060},
	{32973, 36064},
	{32993, 36068},
	{33013, 36072},
	{33033, 36076},
	{33053, 36080},
	{33073, 36084},
	{33093, 36088},
	{33113, 36092},
	{38116, 36096, 6, 3486},
	{38139, 36100, 6, 3486},
	{38162, 36104, 6, 3486},
	{38185, 36108, 6, 3486},
	{38208, 36112, 6, 3486},
	{38231, 36116, 6, 3486},
	{38254, 36120, 6, 3486},
	{38277, 36124, 6, 3486},
	{38300, 36128, 6, 3486},
	{38323, 36132, 6, 3486},
	{38346, 36136, 6, 3486},
	{38370, 36140, 6, 3486},
	{38394, 36144, 6, 3486},
	{38418, 36148, 6, 3486},
	{38442, 36152, 6, 3486},
	{38466, 36156, 6, 3486},
	{49525, 36224, 2, 3492},
	{49541, 36228, 2, 3492},
	{49557, 36232, 4, 3494},
	{49574, 36236, 4, 3494},
	{49592, 36320, 8, 3498},
	{49605, 36324},
	{49617, 36336},
	{49628, 36340},
	{49639, 36352},
	{49660, 36356, 1, 3506},
	{2095, 36360, 8, 3507},
	{2116, 36364, 3, 3515},
	{49681, 36368, 2, 3518},
	{29563, 36384},
	{29590, 36388},
	{29617, 36392},
	{29644, 36396},
	{2074, 36400, 2, 3520},
	{2164, 36404, 5, 3522},
	{49707, 36408, 15, 3527},
	{2143, 36412, 1, 3542},
	{49728, 36416},
	{49749, 36424, 1, 3543},
	{49773, 36440, 3, 3544},
	{49791, 36444, 4, 3547},
	{49810, 36448, 3, 3551},
	{49825, 36452},
	{49847, 36456},
	{49869, 36460},
	{49891, 36464},
	{49913, 36480, 4, 3554},
	{49928, 36484, 3, 3558},
	{49939, 36488, 3, 3561},
	{49950, 36492, 4, 3564},
	{2351, 36608},
	{2369, 36612, 4, 383},
	{2387, 36616},
	{2405, 36620, 14, 3568},
	{3306, 36624},
	{3324, 36628, 5, 3582},
	{3342, 36632, 4, 3587},
	{3360, 36636, 11, 3591},
	{3378, 36640, 2, 3602},
	{3396, 36644, 2, 3604},
	{3414, 36648, 4, 3606},
	{3432, 36652},
	{2423, 36656, 13, 3610},
	{2441, 36660, 4, 411},
	{2459, 36664, 9, 3623},
	{2477, 36668, 3, 3632},
	{2495, 37120, 6, 429},
	{29804, 38156},
	{2511, 39160, 9, 3635},
	{2526, 39184, 6, 3644},
	{2540, 39188, 5, 3645},
	{2554, 39192, 5, 3645},
	{2568, 39196, 5, 3645},
	{2582, 39200, 5, 3645},
	{2596, 39204, 5, 3645},
	{2610, 39208, 5, 3645},
	{2624, 39212, 5, 3645},
	{2638, 39216, 5, 3645},
	{2652, 39220, 5, 3645},
	{2666, 39224, 5, 3645},
	{2681, 39228, 5, 3645},
	{2696, 39232, 5, 3645},
	{2711, 39236, 5, 3645},
	{2726, 39240, 5, 3645},
	{2741, 39244, 5, 3645},
	{2756, 39248, 5, 3645},
	{2771, 39252, 5, 3645},
	{2786, 39256, 5, 3645},
	{2801, 39260, 5, 3645},
	{2816, 39264, 5, 3645},
	{2831, 39268, 5, 3645},
	{2846, 39272, 5, 3645},
	{2861, 39276, 5, 3645},
	{2876, 39280, 5, 3645},
	{2891, 39284, 5, 3645},
	{2906, 39288, 5, 3645},
	{2921, 39292, 5, 3645},
	{2936, 39296, 5, 3645},
	{2951, 39300, 5, 3645},
	{2966, 39304, 5, 3645},
	{2981, 39308, 5, 3645},
	{49962, 45056},
	{49983, 45060, 1, 491},
	{50004, 45064},
	{50025, 45068, 1, 491},
	{3523, 45088},
	{3544, 45092, 1, 491},
	{3565, 45096, 11, 3650},
	{3589, 45100, 6, 3661},
	{3613, 45104},
	{3639, 45108},
	{3665, 45112},
	{3691, 45116},
	{3717, 45120},
	{3743, 45124},
	{3769, 45128},
	{3795, 45132},
	{3821, 45136},
	{3847, 45140},
	{3873, 45144},
	{3900, 45148},
	{3927, 45152},
	{3954, 45156},
	{3981, 45160},
	{4008, 45164},
	{50046, 45312},
	{50067, 45316, 1, 491},
	{50088, 45320},
	{50109, 45324, 1, 491},
	{4729, 45344},
	{4750, 45348, 1, 491},
	{4771, 45352, 12, 3667},
	{4795, 45356, 10, 3679},
	{4819, 45360},
	{4845, 45364},
	{4871, 45368},
	{4897, 45372},
	{4923, 45376},
	{4949, 45380},
	{4975, 45384},
	{5001, 45388},
	{5027, 45392},
	{5053, 45396},
	{5079, 45400},
	{5106, 45404},
	{5133, 45408},
	{5160, 45412},
	{5187, 45416},
	{5214, 45420},
	{50130, 45568},
	{50151, 45572, 1, 491},
	{50172, 45576},
	{50193, 45580, 1, 491},
	{6103, 45600},
	{6124, 45604, 1, 491},
	{6145, 45608, 11, 3689},
	{6169, 45612, 4, 3700},
	{6193, 45616},
	{6219, 45620},
	{6245, 45624},
	{6271, 45628},
	{6297, 45632},
	{6323, 45636},
	{6349, 45640},
	{6375, 45644},
	{6401, 45648},
	{6427, 45652},
	{6453, 45656},
	{6480, 45660},
	{6507, 45664},
	{6534, 45668},
	{6561, 45672},
	{6588, 45676},
	{50214, 45824},
	{50235, 45828, 1, 491},
	{50256, 45832},
	{50277, 45836, 1, 491},
	{7274, 45856},
	{7295, 45860, 1, 491},
	{7316, 45864, 12, 3667},
	{7340, 45868, 6, 3704},
	{7364, 45872},
	{7390, 45876},
	{7416, 45880},
	{7442, 45884},
	{7468, 45888},
	{7494, 45892},
	{7520, 45896},
	{7546, 45900},
	{7572, 45904},
	{7598, 45908},
	{7624, 45912},
	{7651, 45916},
	{7678, 45920},
	{7705, 45924},
	{7732, 45928},
	{7759, 45932},
	{50298, 46080},
	{50319, 46084, 1, 491},
	{50340, 46088},
	{50361, 46092, 1, 491},
	{7998, 46112},
	{8019, 46116, 1, 491},
	{8040, 46120, 10, 3710},
	{8064, 46124, 6, 3720},
	{8088, 46128},
	{8114, 46132},
	{8140, 46136},
	{8166, 46140},
	{8192, 46144},
	{8218, 46148},
	{8244, 46152},
	{8270, 46156},
	{8296, 46160},
	{8322, 46164},
	{8348, 46168},
	{8375, 46172},
	{8402, 46176},
	{8429, 46180},
	{8456, 46184},
	{8483, 46188},
	{50382, 46336},
	{50403, 46340, 1, 491},
	{50424, 46344},
	{50445, 46348, 1, 491},
	{9169, 46368},
	{9190, 46372, 1, 491},
	{9211, 46376, 11, 3726},
	{9235, 46380, 5, 3737},
	{9259, 46384},
	{9285, 46388},
	{9311, 46392},
	{9337, 46396},
	{9363, 46400},
	{9389, 46404},
	{9415, 46408},
	{9441, 46412},
	{9467, 46416},
	{9493, 46420},
	{9519, 46424},
	{9546, 46428},
	{9573, 46432},
	{9600, 46436},
	{9627, 46440},
	{9654, 46444},
	{9681, 47104, 12, 3742},
	{9708, 47108},
	{9722, 47112},
	{9736, 47116},
	{9750, 47120},
	{9766, 47124},
	{9782, 47128},
	{9798, 47132, 2, 659},
	{9819, 47136, 2, 659},
	{9840, 47140, 2, 659},
	{50466, 47148, 1, 3754},
	{9914, 47152},
	{9929, 47156, 2, 3755},
	{50486, 47160},
	{50501, 47164, 1, 663},
	{50516, 47168},
	{50531, 47172, 1, 663},
	{10068, 47176, 10, 3757},
	{10086, 47180, 11, 676},
	{10104, 47184, 1, 687},
	{10117, 47188, 7, 3767},
	{50546, 47192, 2, 3774},
	{50577, 47196, 2, 3774},
	{10195, 47200, 2, 694},
	{10670, 47360},
	{10690, 47364},
	{10710, 47368},
	{10730, 47372},
	{10750, 47376},
	{10770, 47380},
	{10790, 47384},
	{10810, 47388},
	{10830, 47392},
	{10850, 47396},
	{10870, 47400},
	{10891, 47404},
	{10912, 47408},
	{10933, 47412},
	{10954, 47416},
	{10975, 47420},
	{50608, 53300, 29, 3776},
	{50625, 55348, 29, 3776},
	{11057, 163840, 9, 719},
	{11075, 163844, 9, 3805},
	{11092, 163848, 4, 3814},
	{11106, 163852, 23, 747},
	{11125, 163856, 15, 770},
	{11145, 163860},
	{11181, 163872},
	{11201, 163876},
	{11221, 163880, 1, 788},
	{11238, 163884},
	{11253, 163888, 2, 789},
	{11277, 163892, 2, 791},
	{50642, 163900, 7, 3818},
	{11335, 163904, 8, 3825},
	{11345, 163908, 5, 3833},
	{11361, 163912},
	{11376, 163916},
	{11397, 163920},
	{11413, 163924},
	{50656, 163928, 2, 3838},
	{50670, 163932, 1, 3840},
	{11603, 163968},
	{11722, 164344},
	{11740, 164348},
	{11758, 164352, 2, 842},
	{11778, 164356, 3, 844},
	{11802, 164360, 2, 847},
	{11826, 164364, 1, 849},
	{11846, 164368, 2, 844},
	{11866, 164372, 2, 847},
	{11886, 164376, 2, 844},
	{11906, 164380, 2, 847},
	{11926, 164384, 2, 844},
	{11946, 164388, 2, 847},
	{11966, 164392, 2, 844},
	{11986, 164396, 2, 847},
	{12006, 164400, 7, 850},
	{12021, 164404, 2, 857},
	{12050, 164408, 8, 859},
	{12065, 164412, 8, 867},
	{12080, 164416, 3, 844},
	{12105, 164420, 2, 847},
	{12130, 164424},
	{12148, 164428},
	{12166, 164432, 3, 844},
	{12191, 164436, 2, 847},
	{12216, 164440, 3, 844},
	{12241, 164444, 2, 847},
	{12266, 164448, 3, 844},
	{12291, 164452, 2, 847},
	{12316, 164456, 3, 844},
	{12341, 164460, 2, 847},
	{12366, 164464, 3, 844},
	{12391, 164468, 2, 847},
	{12416, 164472, 3, 844},
	{12441, 164476, 2, 847},
	{12466, 164480, 3, 844},
	{12491, 164484, 2, 847},
	{12516, 164488, 3, 844},
	{12541, 164492, 2, 847},
	{12566, 164496, 3, 844},
	{12591, 164500, 2, 847},
	{12616, 164504, 3, 844},
	{12641, 164508, 2, 847},
	{12666, 164512, 3, 844},
	{12692, 164516, 2, 847},
	{12718, 164520, 3, 844},
	{12744, 164524, 2, 847},
	{12770, 164528, 3, 844},
	{12796, 164532, 2, 847},
	{12822, 164536, 3, 844},
	{12848, 164540, 2, 847},
	{12874, 164544, 3, 844},
	{12900, 164548, 2, 847},
	{12926, 164552, 3, 844},
	{12952, 164556, 2, 847},
	{12978, 164560},
	{12997, 164564},
	{13016, 164568},
	{13035, 164572},
	{13054, 164576},
	{13073, 164580},
	{13092, 164584},
	{13111, 164588},
	{13130, 164592},
	{13149, 164596},
	{13168, 164600},
	{13187, 164604},
	{13206, 164608},
	{13225, 164612},
	{13244, 164616},
	{13263, 164620},
	{13282, 164624},
	{13301, 164628},
	{13320, 164632},
	{13339, 164636},
	{13358, 164640},
	{13378, 164644},
	{13398, 164648},
	{13418, 164652},
	{13438, 164656},
	{13458, 164660},
	{13478, 164664},
	{13498, 164668},
	{13518, 164672},
	{13538, 164676},
	{13558, 164680},
	{13578, 164684},
	{13598, 164688, 15, 875},
	{13697, 164704, 1, 902},
	{50685, 164708, 1, 3841},
	{13728, 164712, 1, 904},
	{13796, 164864},
	{13813, 164868},
	{13830, 164872},
	{13846, 164876},
	{13900, 164884},
	{13913, 164888},
	{13928, 164892},
	{13942, 164896},
	{13996, 164908, 6, 935},
	{14015, 164912, 4, 941},
	{14033, 164916, 4, 945},
	{14054, 164924},
	{14073, 164928},
	{14093, 164932},
	{14112, 164936},
	{14132, 164940},
	{14151, 164944},
	{14171, 164948},
	{14192, 164952},
	{14214, 164956},
	{14235, 164960},
	{14257, 164964},
	{14278, 164968},
	{14300, 164972},
	{14321, 164976},
	{14343, 164980},
	{14364, 164984},
	{14386, 164988},
	{14407, 164992},
	{14429, 164996},
	{14450, 165000},
	{14472, 165004},
	{14493, 165008},
	{14515, 165012},
	{14536, 165016},
	{14558, 165020},
	{14579, 165024},
	{14601, 165028},
	{14622, 165032},
	{14644, 165036},
	{14665, 165040},
	{14687, 165044},
	{14708, 165048},
	{14730, 165052},
	{14751, 165056},
	{14773, 165060},
	{14794, 165064},
	{14816, 165068},
	{14837, 165072},
	{14859, 165076},
	{14880, 165080},
	{14902, 165084},
	{14923, 165088},
	{14945, 165092},
	{14966, 165096},
	{14988, 165100},
	{15009, 165104},
	{15031, 165108},
	{15052, 165112},
	{15074, 165116},
	{15095, 165120},
	{15117, 165124},
	{15138, 165128},
	{15160, 165132},
	{15181, 165136},
	{15203, 165140},
	{15224, 165144},
	{15246, 165148},
	{15267, 165152},
	{15289, 165156},
	{15310, 165160},
	{15332, 165164},
	{15354, 165168},
	{15377, 165172},
	{15399, 165176},
	{15422, 165180},
	{15444, 165184},
	{15467, 165188},
	{15489, 165192},
	{15512, 165196},
	{15534, 165200},
	{15557, 165204},
	{15579, 165208},
	{15602, 165212},
	{15624, 165216},
	{15647, 165220},
	{15669, 165224},
	{15692, 165228},
	{15714, 165232},
	{15737, 165236},
	{15759, 165240},
	{15782, 165244},
	{15804, 165248},
	{15827, 165252},
	{15849, 165256},
	{15872, 165260},
	{15894, 165264},
	{15917, 165268},
	{15939, 165272},
	{15962, 165276},
	{15984, 165280},
	{16007, 165284},
	{16029, 165288},
	{16052, 165292},
	{16074, 165296},
	{16097, 165300},
	{16119, 165304},
	{16142, 165308},
	{16156, 165312},
	{16170, 165316},
	{16184, 165320},
	{16198, 165324},
	{16212, 165328},
	{16226, 165332},
	{16240, 165336},
	{16254, 165340},
	{16268, 165344},
	{16282, 165348},
	{16296, 165352},
	{16310, 165356},
	{16324, 165360},
	{16338, 165364},
	{16352, 165368},
	{16366, 165372},
	{16380, 165376},
	{16394, 165380},
	{16408, 165384},
	{16422, 165388},
	{16436, 165392},
	{16450, 165396},
	{16464, 165400},
	{16501, 165444, 6, 949},
	{16521, 165448, 6, 949},
	{16541, 165452, 6, 949},
	{16561, 165456, 6, 949},
	{16581, 165460, 6, 949},
	{16601, 165464, 6, 949},
	{16621, 165468, 6, 949},
	{16641, 165472, 6, 949},
	{16661, 165476, 6, 949},
	{16681, 165480, 6, 949},
	{16701, 165484, 6, 949},
	{16722, 165488, 6, 949},
	{16743, 165492, 6, 949},
	{16764, 165496, 6, 949},
	{16785, 165500, 6, 949},
	{16806, 165504, 6, 949},
	{16827, 165508, 6, 949},
	{16848, 165512, 6, 949},
	{16869, 165516, 6, 949},
	{16890, 165520, 6, 949},
	{16911, 165524, 4, 961},
	{16932, 165528, 4, 961},
	{16953, 165532, 4, 961},
	{16974, 165536, 4, 961},
	{16995, 165540, 4, 961},
	{17016, 165544, 4, 961},
	{17037, 165548, 4, 961},
	{17058, 165552, 4, 961},
	{17079, 165556, 4, 961},
	{17100, 165560, 4, 961},
	{17121, 165564, 4, 961},
	{17142, 165568, 4, 961},
	{17163, 165572, 2, 970},
	{17181, 165580, 16, 973},
	{17198, 165584, 16, 973},
	{17216, 165588, 7, 989},
	{17237, 165592, 3, 3842},
	{17255, 165600, 7, 1002},
	{17270, 165608, 2, 694},
	{17309, 165644, 4, 1010},
	{17331, 165648, 1, 1015},
	{17351, 165652, 8, 1016},
	{17577, 165760, 9, 1063},
	{17595, 165764, 9, 1063},
	{17613, 165768, 9, 1063},
	{17631, 165772, 9, 1063},
	{17649, 165776, 9, 1063},
	{17667, 165780, 9, 1063},
	{17685, 165784, 9, 1063},
	{17703, 165788, 9, 1063},
	{17721, 165836, 1, 1072},
	{17735, 165840, 1, 1072},
	{17750, 165844},
	{17768, 165848},
	{17786, 165852},
	{17803, 165856},
	{17824, 165860, 1, 3845},
	{17840, 165864},
	{17853, 165872, 5, 1074},
	{17872, 165876},
	{17887, 165880, 1, 1082},
	{17936, 165888, 10, 1084},
	{17953, 165892, 12, 1094},
	{17961, 165896, 3, 3846},
	{17978, 165900, 12, 1110},
	{17996, 165904, 19, 1127},
	{18012, 165908, 13, 1147},
	{18031, 165912, 10, 1163},
	{18046, 165916, 26, 1173},
	{18064, 165920, 16, 1201},
	{18082, 165924, 4, 1217},
	{18106, 165928},
	{18131, 165932, 11, 1221},
	{18283, 166400, 2, 1253},
	{18300, 166404, 2, 1255},
	{18319, 166408, 1, 1257},
	{18335, 166412, 4, 1258},
	{18354, 166416, 1, 1262},
	{18375, 166420, 1, 1263},
	{18388, 166424},
	{18411, 166428},
	{18434, 166432, 1, 1264},
	{18454, 166436, 4, 3849},
	{18474, 166440, 1, 1269},
	{18495, 166444, 1, 1270},
	{18510, 166448, 6, 1271},
	{18532, 166452, 6, 1271},
	{18554, 166456, 8, 1277},
	{18580, 166460, 8, 1277},
	{18606, 166464, 15, 1285},
	{18637, 166472, 4, 1303},
	{18655, 166476, 24, 1310},
	{18673, 166480},
	{18685, 166484, 1, 1334},
	{18699, 166488, 1, 1335},
	{18713, 166492, 1, 1336},
	{18727, 166496, 1, 1337},
	{18750, 166500, 1, 1337},
	{18773, 166504, 1, 1337},
	{18796, 166508, 5, 3853},
	{18817, 166512},
	{18828, 166516},
	{18841, 166520},
	{18858, 166524, 7, 3858},
	{18888, 166532, 2, 1351},
	{18907, 166536},
	{18929, 166540},
	{18951, 166544, 3, 3865},
	{18971, 166548, 1, 1357},
	{19020, 166560},
	{19045, 166564},
	{19070, 166568, 6, 1364},
	{19089, 166572, 1, 1370},
	{19112, 166576, 1, 1370},
	{19135, 166580, 1, 1371},
	{19149, 166584, 1, 1372},
	{19164, 166588, 7, 3868},
	{19181, 166592, 4, 1382},
	{19208, 166596, 4, 1386},
	{19235, 166600, 4, 1390},
	{19254, 166608},
	{19280, 166612, 1, 1394},
	{19305, 166620},
	{19333, 166624},
	{19359, 166628, 1, 1394},
	{19384, 166636},
	{19412, 166640},
	{19438, 166644, 1, 1394},
	{19463, 166652},
	{19491, 166656},
	{19517, 166660, 1, 1394},
	{19542, 166668},
	{19570, 166696},
	{19601, 166700},
	{19644, 166704, 1, 1395},
	{19682, 166712, 1, 1396},
	{19743, 166740, 6, 1404},
	{19764, 166744, 3, 1423},
	{19781, 166748, 1, 1370},
	{19802, 166752, 1, 1370},
	{19825, 166756, 1, 1370},
	{19848, 166760, 1, 1370},
	{19871, 166764, 8, 3875},
	{19884, 166768, 6, 1438},
	{19925, 166776, 2, 1444},
	{19955, 166780},
	{19979, 166784},
	{20009, 166788},
	{20040, 166792},
	{20069, 166796},
	{20099, 166800, 2, 1446},
	{20119, 166804, 7, 3883},
	{20138, 166808, 4, 1457},
	{20188, 166868, 8, 1461},
	{20214, 166872, 8, 1469},
	{20240, 166876, 4, 1477},
	{20256, 166880, 5, 1482},
	{20272, 166884, 3, 1488},
	{20287, 166888},
	{20310, 166892},
	{20333, 166896},
	{20356, 166900},
	{20379, 166904, 8, 1491},
	{20413, 166908, 8, 1499},
	{20447, 166912, 8, 1507},
	{20481, 166916, 8, 1515},
	{20515, 166920, 8, 1491},
	{20549, 166924, 8, 1499},
	{20583, 166928, 8, 1507},
	{20617, 166932, 8, 1515},
	{20651, 166936, 8, 1491},
	{20685, 166940, 8, 1499},
	{20719, 166944, 8, 1507},
	{20753, 166948, 8, 1515},
	{20787, 166952, 8, 1491},
	{20821, 166956, 8, 1499},
	{20855, 166960, 8, 1507},
	{20889, 166964, 8, 1515},
	{20923, 166968, 2, 1523},
	{20947, 166972, 2, 1525},
	{21090, 167000, 1, 1567},
	{21118, 167004, 1, 1568},
	{21139, 167008},
	{21154, 167012, 2, 1569},
	{21170, 167016, 1, 1571},
	{21186, 167020, 2, 3814},
	{21201, 167024, 15, 3890},
	{21216, 167028, 6, 1594},
	{21255, 167036},
	{21271, 167040, 1, 1614},
	{21293, 167044},
	{21309, 167048, 1, 1571},
	{21331, 167052},
	{21353, 167056},
	{21394, 167068},
	{21409, 167072, 2, 1569},
	{21425, 167076, 1, 1571},
	{21441, 167080, 2, 3814},
	{21456, 167084, 15, 3890},
	{21471, 167088, 6, 1594},
	{21510, 167096},
	{21526, 167100, 1, 1614},
	{21548, 167104},
	{21564, 167108, 1, 1571},
	{21586, 167112},
	{21608, 167116},
	{21649, 167128},
	{21664, 167132, 2, 1569},
	{21680, 167136, 1, 1571},
	{21696, 167140, 2, 3814},
	{21711, 167144, 15, 3890},
	{21726, 167148, 6, 1594},
	{21765, 167156},
	{21781, 167160, 1, 1614},
	{21803, 167164},
	{21819, 167168, 1, 1571},
	{21841, 167172},
	{21863, 167176},
	{21904, 167188},
	{21919, 167192, 2, 1569},
	{21935, 167196, 1, 1571},
	{21951, 167200, 2, 3814},
	{21966, 167204, 15, 3890},
	{21981, 167208, 6, 1594},
	{22020, 167216},
	{22036, 167220, 1, 1614},
	{22058, 167224},
	{22074, 167228, 1, 1571},
	{22096, 167232},
	{22118, 167236},
	{22159, 167248},
	{22174, 167252, 2, 1569},
	{22190, 167256, 1, 1571},
	{22206, 167260, 2, 3814},
	{22221, 167264, 15, 3890},
	{22236, 167268, 6, 1594},
	{22275, 167276},
	{22291, 167280, 1, 1614},
	{22313, 167284},
	{22329, 167288, 1, 1571},
	{22351, 167292},
	{22373, 167296},
	{22414, 167308},
	{22429, 167312, 2, 1569},
	{22445, 167316, 1, 1571},
	{22461, 167320, 2, 3814},
	{22476, 167324, 15, 3890},
	{22491, 167328, 6, 1594},
	{22530, 167336},
	{22546, 167340, 1, 1614},
	{22568, 167344},
	{22584, 167348, 1, 1571},
	{22606, 167352},
	{22628, 167356},
	{22669, 167368},
	{22684, 167372, 2, 1569},
	{22700, 167376, 1, 1571},
	{22716, 167380, 2, 3814},
	{22731, 167384, 15, 3890},
	{22746, 167388, 6, 1594},
	{22785, 167396},
	{22801, 167400, 1, 1614},
	{22823, 167404},
	{22839, 167408, 1, 1571},
	{22861, 167412},
	{22883, 167416},
	{22924, 167428},
	{22939, 167432, 2, 1569},
	{22955, 167436, 1, 1571},
	{22971, 167440, 2, 3814},
	{22986, 167444, 15, 3890},
	{23001, 167448, 6, 1594},
	{23040, 167456},
	{23056, 167460, 1, 1614},
	{23078, 167464},
	{23094, 167468, 1, 1571},
	{23116, 167472},
	{23138, 167476},
	{195, 880, 4, 3905},
	{42808, 881},
	{26631, 882},
	{42820, 1008},
	{42831, 1009},
	{26819, 1010, 3, 2160},
	{42842, 1040, 1, 2163},
	{42855, 1041, 5, 3909},
	{42868, 1042, 1, 2169},
	{42881, 1043, 1, 1681},
	{26653, 1045, 9, 3914},
	{42909, 1280, 4, 3923},
	{42924, 1281},
	{26590, 1282},
	{42808, 1283},
	{26631, 1284},
};

static const struct si_reg gfx7_reg_table[] = {
	{974, 68, 9, 3927},
	{987, 72, 24, 2762},
	{1002, 76, 3, 3936},
	{46947, 80, 11, 3939},
	{1039, 84, 4, 2800},
	{1057, 88, 2, 2804},
	{1075, 92, 4, 3950},
	{1090, 96},
	{1104, 100, 1, 2810},
	{1118, 104},
	{46961, 108},
	{46978, 112, 13, 2811},
	{46994, 2480},
	{47009, 2484, 1, 2824},
	{47024, 2488},
	{47039, 2492, 1, 2824},
	{1273, 2496},
	{1287, 2500},
	{1301, 2504},
	{1315, 2508},
	{1329, 2512},
	{1343, 2516},
	{1357, 2520},
	{1371, 2524},
	{1385, 2528},
	{1399, 2532},
	{1413, 2536},
	{1428, 2540},
	{1503, 2544},
	{1514, 2552},
	{1530, 2556},
	{47054, 3660, 21, 2825},
	{47067, 3664, 20, 2846},
	{47079, 3668, 16, 2866},
	{1618, 32776, 17, 3954},
	{1631, 32784, 24, 2904},
	{1643, 32788, 11, 2928},
	{1659, 32792, 11, 2928},
	{1688, 32824, 11, 2928},
	{1704, 32828, 11, 2928},
	{1720, 33296, 16, 3971},
	{1734, 33300, 28, 204},
	{1751, 33304, 17, 3987},
	{1772, 33308, 18, 4004},
	{1786, 33312, 31, 4022},
	{1803, 33316, 7, 4053},
	{50695, 33320, 1, 3202},
	{1842, 33324, 1, 329},
	{1865, 33344, 1, 1704},
	{1886, 33348},
	{1947, 33436, 1, 342},
	{49639, 36352},
	{49660, 36356, 1, 3506},
	{2095, 36360, 9, 4060},
	{2116, 36364, 3, 3515},
	{49681, 36368, 2, 3518},
	{50710, 36372, 2, 4069},
	{50732, 36376, 1, 4071},
	{2074, 36400, 2, 3520},
	{2164, 36404, 5, 4072},
	{49707, 36408, 15, 3527},
	{2143, 36412, 1, 3542},
	{49728, 36416},
	{49749, 36424, 1, 3543},
	{2351, 36608},
	{2369, 36612, 4, 383},
	{2387, 36616},
	{2405, 36620, 14, 3568},
	{3306, 36624},
	{3324, 36628, 5, 3582},
	{3342, 36632, 4, 3587},
	{3360, 36636, 11, 3591},
	{3378, 36640, 2, 3602},
	{3396, 36644, 2, 3604},
	{3414, 36648, 4, 3606},
	{3432, 36652},
	{2423, 36656, 13, 3610},
	{2441, 36660, 4, 411},
	{2459, 36664, 9, 3623},
	{2477, 36668, 3, 3632},
	{2495, 37120, 6, 429},
	{2511, 39160, 9, 3635},
	{2526, 39184, 5, 3645},
	{2540, 39188, 5, 3645},
	{2554, 39192, 5, 3645},
	{2568, 39196, 5, 3645},
	{2582, 39200, 5, 3645},
	{2596, 39204, 5, 3645},
	{2610, 39208, 5, 3645},
	{2624, 39212, 5, 3645},
	{2638, 39216, 5, 3645},
	{2652, 39220, 5, 3645},
	{2666, 39224, 5, 3645},
	{2681, 39228, 5, 3645},
	{2696, 39232, 5, 3645},
	{2711, 39236, 5, 3645},
	{2726, 39240, 5, 3645},
	{2741, 39244, 5, 3645},
	{2756, 39248, 5, 3645},
	{2771, 39252, 5, 3645},
	{2786, 39256, 5, 3645},
	{2801, 39260, 5, 3645},
	{2816, 39264, 5, 3645},
	{2831, 39268, 5, 3645},
	{2846, 39272, 5, 3645},
	{2861, 39276, 5, 3645},
	{2876, 39280, 5, 3645},
	{2891, 39284, 5, 3645},
	{2906, 39288, 5, 3645},
	{2921, 39292, 5, 3645},
	{2936, 39296, 5, 3645},
	{2951, 39300, 5, 3645},
	{2966, 39304, 5, 3645},
	{2981, 39308, 5, 3645},
	{2996, 39312, 4, 448},
	{3015, 39316, 4, 448},
	{3034, 39320, 4, 448},
	{3053, 39324, 4, 448},
	{3072, 39328, 4, 448},
	{3091, 39332, 4, 448},
	{3110, 39336, 4, 448},
	{3129, 39340, 4, 448},
	{3148, 39344, 4, 448},
	{3167, 39348, 4, 448},
	{3186, 39352, 4, 448},
	{3206, 39356, 4, 448},
	{3226, 39360, 4, 448},
	{3246, 39364, 4, 448},
	{3266, 39368, 4, 448},
	{3286, 39372, 4, 448},
	{49962, 45056},
	{49983, 45060, 1, 491},
	{50004, 45064},
	{50025, 45068, 1, 491},
	{3499, 45084, 3, 488},
	{3523, 45088},
	{3544, 45092, 1, 491},
	{3565, 45096, 11, 3650},
	{3589, 45100, 6, 503},
	{3613, 45104},
	{3639, 45108},
	{3665, 45112},
	{3691, 45116},
	{3717, 45120},
	{3743, 45124},
	{3769, 45128},
	{3795, 45132},
	{3821, 45136},
	{3847, 45140},
	{3873, 45144},
	{3900, 45148},
	{3927, 45152},
	{3954, 45156},
	{3981, 45160},
	{4008, 45164},
	{50046, 45312},
	{50067, 45316, 1, 491},
	{50088, 45320},
	{50109, 45324, 1, 491},
	{4680, 45336, 3, 488},
	{4704, 45340, 1, 527},
	{4729, 45344},
	{4750, 45348, 1, 491},
	{4771, 45352, 12, 3667},
	{4795, 45356, 10, 540},
	{4819, 45360},
	{4845, 45364},
	{4871, 45368},
	{4897, 45372},
	{4923, 45376},
	{4949, 45380},
	{4975, 45384},
	{5001, 45388},
	{5027, 45392},
	{5053, 45396},
	{5079, 45400},
	{5106, 45404},
	{5133, 45408},
	{5160, 45412},
	{5187, 45416},
	{5214, 45420},
	{5864, 45552, 6, 563},
	{5891, 45556, 5, 569},
	{50130, 45568},
	{50151, 45572, 1, 491},
	{50172, 45576},
	{50193, 45580, 1, 491},
	{6079, 45596, 3, 488},
	{6103, 45600},
	{6124, 45604, 1, 491},
	{6145, 45608, 11, 3689},
	{6169, 45612, 4, 554},
	{6193, 45616},
	{6219, 45620},
	{6245, 45624},
	{6271, 45628},
	{6297, 45632},
	{6323, 45636},
	{6349, 45640},
	{6375, 45644},
	{6401, 45648},
	{6427, 45652},
	{6453, 45656},
	{6480, 45660},
	{6507, 45664},
	{6534, 45668},
	{6561, 45672},
	{6588, 45676},
	{7223, 45808, 6, 563},
	{50214, 45824},
	{50235, 45828, 1, 491},
	{50256, 45832},
	{50277, 45836, 1, 491},
	{7250, 45852, 3, 488},
	{7274, 45856},
	{7295, 45860, 1, 491},
	{7316, 45864, 12, 3667},
	{7340, 45868, 6, 563},
	{7364, 45872},
	{7390, 45876},
	{7416, 45880},
	{7442, 45884},
	{7468, 45888},
	{7494, 45892},
	{7520, 45896},
	{7546, 45900},
	{7572, 45904},
	{7598, 45908},
	{7624, 45912},
	{7651, 45916},
	{7678, 45920},
	{7705, 45924},
	{7732, 45928},
	{7759, 45932},
	{7786, 46068, 5, 569},
	{50298, 46080},
	{50319, 46084, 1, 491},
	{50340, 46088},
	{50361, 46092, 1, 491},
	{7974, 46108, 2, 612},
	{7998, 46112},
	{8019, 46116, 1, 491},
	{8040, 46120, 10, 3710},
	{8064, 46124, 6, 628},
	{8088, 46128},
	{8114, 46132},
	{8140, 46136},
	{8166, 46140},
	{8192, 46144},
	{8218, 46148},
	{8244, 46152},
	{8270, 46156},
	{8296, 46160},
	{8322, 46164},
	{8348, 46168},
	{8375, 46172},
	{8402, 46176},
	{8429, 46180},
	{8456, 46184},
	{8483, 46188},
	{9118, 46324, 5, 569},
	{50382, 46336},
	{50403, 46340, 1, 491},
	{50424, 46344},
	{50445, 46348, 1, 491},
	{9145, 46364, 3, 488},
	{9169, 46368},
	{9190, 46372, 1, 491},
	{9211, 46376, 11, 3726},
	{9235, 46380, 5, 569},
	{9259, 46384},
	{9285, 46388},
	{9311, 46392},
	{9337, 46396},
	{9363, 46400},
	{9389, 46404},
	{9415, 46408},
	{9441, 46412},
	{9467, 46416},
	{9493, 46420},
	{9519, 46424},
	{9546, 46428},
	{9573, 46432},
	{9600, 46436},
	{9627, 46440},
	{9654, 46444},
	{9681, 47104, 12, 3742},
	{9708, 47108},
	{9722, 47112},
	{9736, 47116},
	{9750, 47120},
	{9766, 47124},
	{9782, 47128},
	{9798, 47132, 2, 659},
	{9819, 47136, 2, 659},
	{9840, 47140, 2, 659},
	{9861, 47144, 1, 661},
	{9889, 47148, 1, 662},
	{9914, 47152},
	{9929, 47156, 2, 3755},
	{50486, 47160},
	{50501, 47164, 1, 663},
	{50516, 47168},
	{50531, 47172, 1, 663},
	{10068, 47176, 10, 3757},
	{10086, 47180, 11, 676},
	{10104, 47184, 1, 687},
	{10117, 47188, 6, 688},
	{50546, 47192, 2, 3774},
	{50577, 47196, 2, 3774},
	{10195, 47200, 2, 694},
	{50760, 47204, 2, 3774},
	{50791, 47208, 2, 3774},
	{10270, 47212},
	{10288, 47216},
	{10306, 47220},
	{10324, 47224, 1, 696},
	{10352, 47228, 4, 697},
	{10670, 47360},
	{10690, 47364},
	{10710, 47368},
	{10730, 47372},
	{10750, 47376},
	{10770, 47380},
	{10790, 47384},
	{10810, 47388},
	{10830, 47392},
	{10850, 47396},
	{10870, 47400},
	{10891, 47404},
	{10912, 47408},
	{10933, 47412},
	{10954, 47416},
	{10975, 47420},
	{50608, 53300, 29, 3776},
	{50625, 55348, 29, 3776},
	{11057, 163840, 9, 719},
	{11075, 163844, 9, 3805},
	{11092, 163848, 4, 3814},
	{11106, 163852, 23, 747},
	{11125, 163856, 15, 770},
	{11145, 163860},
	{11181, 163872},
	{11201, 163876},
	{11221, 163880, 1, 788},
	{11238, 163884},
	{11253, 163888, 2, 789},
	{11277, 163892, 2, 791},
	{50642, 163900, 7, 3818},
	{11335, 163904, 8, 3825},
	{11345, 163908, 5, 3833},
	{11361, 163912},
	{11376, 163916},
	{11397, 163920},
	{11413, 163924},
	{50656, 163928, 2, 3838},
	{50670, 163932, 1, 3840},
	{11603, 163968},
	{11619, 163972, 1, 840},
	{11638, 164328, 1, 841},
	{11659, 164332, 1, 841},
	{11680, 164336, 1, 841},
	{11701, 164340, 1, 841},
	{11722, 164344},
	{11740, 164348},
	{11758, 164352, 2, 842},
	{11778, 164356, 3, 844},
	{11802, 164360, 2, 847},
	{11826, 164364, 1, 849},
	{11846, 164368, 2, 844},
	{11866, 164372, 2, 847},
	{11886, 164376, 2, 844},
	{11906, 164380, 2, 847},
	{11926, 164384, 2, 844},
	{11946, 164388, 2, 847},
	{11966, 164392, 2, 844},
	{11986, 164396, 2, 847},
	{12006, 164400, 7, 850},
	{12021, 164404, 2, 857},
	{12050, 164408, 8, 859},
	{12065, 164412, 8, 867},
	{12080, 164416, 3, 844},
	{12105, 164420, 2, 847},
	{12130, 164424},
	{12148, 164428},
	{12166, 164432, 3, 844},
	{12191, 164436, 2, 847},
	{12216, 164440, 3, 844},
	{12241, 164444, 2, 847},
	{12266, 164448, 3, 844},
	{12291, 164452, 2, 847},
	{12316, 164456, 3, 844},
	{12341, 164460, 2, 847},
	{12366, 164464, 3, 844},
	{12391, 164468, 2, 847},
	{12416, 164472, 3, 844},
	{12441, 164476, 2, 847},
	{12466, 164480, 3, 844},
	{12491, 164484, 2, 847},
	{12516, 164488, 3, 844},
	{12541, 164492, 2, 847},
	{12566, 164496, 3, 844},
	{12591, 164500, 2, 847},
	{12616, 164504, 3, 844},
	{12641, 164508, 2, 847},
	{12666, 164512, 3, 844},
	{12692, 164516, 2, 847},
	{12718, 164520, 3, 844},
	{12744, 164524, 2, 847},
	{12770, 164528, 3, 844},
	{12796, 164532, 2, 847},
	{12822, 164536, 3, 844},
	{12848, 164540, 2, 847},
	{12874, 164544, 3, 844},
	{12900, 164548, 2, 847},
	{12926, 164552, 3, 844},
	{12952, 164556, 2, 847},
	{12978, 164560},
	{12997, 164564},
	{13016, 164568},
	{13035, 164572},
	{13054, 164576},
	{13073, 164580},
	{13092, 164584},
	{13111, 164588},
	{13130, 164592},
	{13149, 164596},
	{13168, 164600},
	{13187, 164604},
	{13206, 164608},
	{13225, 164612},
	{13244, 164616},
	{13263, 164620},
	{13282, 164624},
	{13301, 164628},
	{13320, 164632},
	{13339, 164636},
	{13358, 164640},
	{13378, 164644},
	{13398, 164648},
	{13418, 164652},
	{13438, 164656},
	{13458, 164660},
	{13478, 164664},
	{13498, 164668},
	{13518, 164672},
	{13538, 164676},
	{13558, 164680},
	{13578, 164684},
	{13598, 164688, 15, 875},
	{13618, 164692, 3, 890},
	{13640, 164696, 2, 893},
	{13697, 164704, 1, 902},
	{50685, 164708, 1, 3841},
	{13728, 164712, 1, 904},
	{13796, 164864},
	{13813, 164868},
	{13830, 164872},
	{13846, 164876},
	{13900, 164884},
	{13913, 164888},
	{13928, 164892},
	{13942, 164896},
	{13996, 164908, 6, 935},
	{14015, 164912, 4, 941},
	{14033, 164916, 4, 945},
	{14054, 164924},
	{14073, 164928},
	{14093, 164932},
	{14112, 164936},
	{14132, 164940},
	{14151, 164944},
	{14171, 164948},
	{14192, 164952},
	{14214, 164956},
	{14235, 164960},
	{14257, 164964},
	{14278, 164968},
	{14300, 164972},
	{14321, 164976},
	{14343, 164980},
	{14364, 164984},
	{14386, 164988},
	{14407, 164992},
	{14429, 164996},
	{14450, 165000},
	{14472, 165004},
	{14493, 165008},
	{14515, 165012},
	{14536, 165016},
	{14558, 165020},
	{14579, 165024},
	{14601, 165028},
	{14622, 165032},
	{14644, 165036},
	{14665, 165040},
	{14687, 165044},
	{14708, 165048},
	{14730, 165052},
	{14751, 165056},
	{14773, 165060},
	{14794, 165064},
	{14816, 165068},
	{14837, 165072},
	{14859, 165076},
	{14880, 165080},
	{14902, 165084},
	{14923, 165088},
	{14945, 165092},
	{14966, 165096},
	{14988, 165100},
	{15009, 165104},
	{15031, 165108},
	{15052, 165112},
	{15074, 165116},
	{15095, 165120},
	{15117, 165124},
	{15138, 165128},
	{15160, 165132},
	{15181, 165136},
	{15203, 165140},
	{15224, 165144},
	{15246, 165148},
	{15267, 165152},
	{15289, 165156},
	{15310, 165160},
	{15332, 165164},
	{15354, 165168},
	{15377, 165172},
	{15399, 165176},
	{15422, 165180},
	{15444, 165184},
	{15467, 165188},
	{15489, 165192},
	{15512, 165196},
	{15534, 165200},
	{15557, 165204},
	{15579, 165208},
	{15602, 165212},
	{15624, 165216},
	{15647, 165220},
	{15669, 165224},
	{15692, 165228},
	{15714, 165232},
	{15737, 165236},
	{15759, 165240},
	{15782, 165244},
	{15804, 165248},
	{15827, 165252},
	{15849, 165256},
	{15872, 165260},
	{15894, 165264},
	{15917, 165268},
	{15939, 165272},
	{15962, 165276},
	{15984, 165280},
	{16007, 165284},
	{16029, 165288},
	{16052, 165292},
	{16074, 165296},
	{16097, 165300},
	{16119, 165304},
	{16142, 165308},
	{16156, 165312},
	{16170, 165316},
	{16184, 165320},
	{16198, 165324},
	{16212, 165328},
	{16226, 165332},
	{16240, 165336},
	{16254, 165340},
	{16268, 165344},
	{16282, 165348},
	{16296, 165352},
	{16310, 165356},
	{16324, 165360},
	{16338, 165364},
	{16352, 165368},
	{16366, 165372},
	{16380, 165376},
	{16394, 165380},
	{16408, 165384},
	{16422, 165388},
	{16436, 165392},
	{16450, 165396},
	{16464, 165400},
	{16501, 165444, 6, 949},
	{16521, 165448, 6, 949},
	{16541, 165452, 6, 949},
	{16561, 165456, 6, 949},
	{16581, 165460, 6, 949},
	{16601, 165464, 6, 949},
	{16621, 165468, 6, 949},
	{16641, 165472, 6, 949},
	{16661, 165476, 6, 949},
	{16681, 165480, 6, 949},
	{16701, 165484, 6, 949},
	{16722, 165488, 6, 949},
	{16743, 165492, 6, 949},
	{16764, 165496, 6, 949},
	{16785, 165500, 6, 949},
	{16806, 165504, 6, 949},
	{16827, 165508, 6, 949},
	{16848, 165512, 6, 949},
	{16869, 165516, 6, 949},
	{16890, 165520, 6, 949},
	{16911, 165524, 4, 961},
	{16932, 165528, 4, 961},
	{16953, 165532, 4, 961},
	{16974, 165536, 4, 961},
	{16995, 165540, 4, 961},
	{17016, 165544, 4, 961},
	{17037, 165548, 4, 961},
	{17058, 165552, 4, 961},
	{17079, 165556, 4, 961},
	{17100, 165560, 4, 961},
	{17121, 165564, 4, 961},
	{17142, 165568, 4, 961},
	{17163, 165572, 2, 970},
	{17181, 165580, 16, 973},
	{17198, 165584, 16, 973},
	{17216, 165588, 7, 989},
	{17237, 165592, 3, 3842},
	{17255, 165600, 7, 1002},
	{17270, 165608, 2, 694},
	{17309, 165644, 4, 1010},
	{17331, 165648, 1, 1015},
	{17351, 165652, 8, 1016},
	{17577, 165760, 9, 1063},
	{17595, 165764, 9, 1063},
	{17613, 165768, 9, 1063},
	{17631, 165772, 9, 1063},
	{17649, 165776, 9, 1063},
	{17667, 165780, 9, 1063},
	{17685, 165784, 9, 1063},
	{17703, 165788, 9, 1063},
	{17721, 165836, 1, 1072},
	{17735, 165840, 1, 1072},
	{17750, 165844},
	{17768, 165848},
	{17786, 165852},
	{17803, 165856},
	{17824, 165860, 1, 3845},
	{17840, 165864},
	{17853, 165872, 5, 1074},
	{17872, 165876},
	{17887, 165880, 1, 1082},
	{17936, 165888, 10, 1084},
	{17953, 165892, 12, 1094},
	{17961, 165896, 3, 3846},
	{17978, 165900, 12, 1110},
	{17996, 165904, 19, 1127},
	{18012, 165908, 13, 1147},
	{18031, 165912, 10, 1163},
	{18046, 165916, 26, 1173},
	{18064, 165920, 16, 1201},
	{18082, 165924, 4, 1217},
	{18106, 165928},
	{18131, 165932, 11, 1221},
	{18283, 166400, 2, 1253},
	{18300, 166404, 2, 1255},
	{18319, 166408, 1, 1257},
	{18335, 166412, 4, 1258},
	{18354, 166416, 1, 1262},
	{18375, 166420, 1, 1263},
	{18388, 166424},
	{18411, 166428},
	{18434, 166432, 1, 1264},
	{18454, 166436, 4, 3849},
	{18474, 166440, 1, 1269},
	{18495, 166444, 1, 1270},
	{18510, 166448, 6, 1271},
	{18532, 166452, 6, 1271},
	{18554, 166456, 8, 1277},
	{18580, 166460, 8, 1277},
	{18606, 166464, 15, 1285},
	{18618, 166468, 2, 1300},
	{18637, 166472, 4, 1303},
	{18655, 166476, 24, 1310},
	{18673, 166480},
	{18685, 166484, 1, 1334},
	{18699, 166488, 1, 1335},
	{18713, 166492, 1, 1336},
	{18727, 166496, 1, 1337},
	{18750, 166500, 1, 1337},
	{18773, 166504, 1, 1337},
	{18796, 166508, 5, 3853},
	{18817, 166512},
	{18828, 166516},
	{18841, 166520},
	{18858, 166524, 7, 3858},
	{18877, 166528},
	{18888, 166532, 2, 1351},
	{18907, 166536},
	{18929, 166540},
	{18951, 166544, 3, 3865},
	{18971, 166548, 1, 1357},
	{19020, 166560},
	{19045, 166564},
	{19070, 166568, 6, 1364},
	{19089, 166572, 1, 1370},
	{19112, 166576, 1, 1370},
	{19135, 166580, 1, 1371},
	{19149, 166584, 1, 1372},
	{19164, 166588, 7, 3868},
	{19181, 166592, 4, 1382},
	{19208, 166596, 4, 1386},
	{19235, 166600, 4, 1390},
	{19254, 166608},
	{19280, 166612, 1, 1394},
	{19305, 166620},
	{19333, 166624},
	{19359, 166628, 1, 1394},
	{19384, 166636},
	{19412, 166640},
	{19438, 166644, 1, 1394},
	{19463, 166652},
	{19491, 166656},
	{19517, 166660, 1, 1394},
	{19542, 166668},
	{19570, 166696},
	{19601, 166700},
	{19644, 166704, 1, 1395},
	{19682, 166712, 1, 1396},
	{19743, 166740, 6, 1404},
	{19764, 166744, 3, 1423},
	{19781, 166748, 1, 1370},
	{19802, 166752, 1, 1370},
	{19825, 166756, 1, 1370},
	{19848, 166760, 1, 1370},
	{19871, 166764, 8, 3875},
	{19884, 166768, 6, 1438},
	{19901, 166772},
	{19925, 166776, 2, 1444},
	{19955, 166780},
	{19979, 166784},
	{20009, 166788},
	{20040, 166792},
	{20069, 166796},
	{20099, 166800, 2, 1446},
	{20119, 166804, 7, 3883},
	{20138, 166808, 4, 1457},
	{20188, 166868, 8, 1461},
	{20214, 166872, 8, 1469},
	{20240, 166876, 4, 1477},
	{20256, 166880, 5, 1482},
	{20272, 166884, 3, 1488},
	{20287, 166888},
	{20310, 166892},
	{20333, 166896},
	{20356, 166900},
	{20379, 166904, 8, 1491},
	{20413, 166908, 8, 1499},
	{20447, 166912, 8, 1507},
	{20481, 166916, 8, 1515},
	{20515, 166920, 8, 1491},
	{20549, 166924, 8, 1499},
	{20583, 166928, 8, 1507},
	{20617, 166932, 8, 1515},
	{20651, 166936, 8, 1491},
	{20685, 166940, 8, 1499},
	{20719, 166944, 8, 1507},
	{20753, 166948, 8, 1515},
	{20787, 166952, 8, 1491},
	{20821, 166956, 8, 1499},
	{20855, 166960, 8, 1507},
	{20889, 166964, 8, 1515},
	{20923, 166968, 2, 1523},
	{20947, 166972, 2, 1525},
	{21090, 167000, 1, 1567},
	{21118, 167004, 1, 1568},
	{21139, 167008},
	{21154, 167012, 2, 1569},
	{21170, 167016, 1, 1571},
	{21186, 167020, 2, 3814},
	{21201, 167024, 15, 3890},
	{21216, 167028, 6, 1594},
	{21255, 167036},
	{21271, 167040, 1, 1614},
	{21293, 167044},
	{21309, 167048, 1, 1571},
	{21331, 167052},
	{21353, 167056},
	{21394, 167068},
	{21409, 167072, 2, 1569},
	{21425, 167076, 1, 1571},
	{21441, 167080, 2, 3814},
	{21456, 167084, 15, 3890},
	{21471, 167088, 6, 1594},
	{21510, 167096},
	{21526, 167100, 1, 1614},
	{21548, 167104},
	{21564, 167108, 1, 1571},
	{21586, 167112},
	{21608, 167116},
	{21649, 167128},
	{21664, 167132, 2, 1569},
	{21680, 167136, 1, 1571},
	{21696, 167140, 2, 3814},
	{21711, 167144, 15, 3890},
	{21726, 167148, 6, 1594},
	{21765, 167156},
	{21781, 167160, 1, 1614},
	{21803, 167164},
	{21819, 167168, 1, 1571},
	{21841, 167172},
	{21863, 167176},
	{21904, 167188},
	{21919, 167192, 2, 1569},
	{21935, 167196, 1, 1571},
	{21951, 167200, 2, 3814},
	{21966, 167204, 15, 3890},
	{21981, 167208, 6, 1594},
	{22020, 167216},
	{22036, 167220, 1, 1614},
	{22058, 167224},
	{22074, 167228, 1, 1571},
	{22096, 167232},
	{22118, 167236},
	{22159, 167248},
	{22174, 167252, 2, 1569},
	{22190, 167256, 1, 1571},
	{22206, 167260, 2, 3814},
	{22221, 167264, 15, 3890},
	{22236, 167268, 6, 1594},
	{22275, 167276},
	{22291, 167280, 1, 1614},
	{22313, 167284},
	{22329, 167288, 1, 1571},
	{22351, 167292},
	{22373, 167296},
	{22414, 167308},
	{22429, 167312, 2, 1569},
	{22445, 167316, 1, 1571},
	{22461, 167320, 2, 3814},
	{22476, 167324, 15, 3890},
	{22491, 167328, 6, 1594},
	{22530, 167336},
	{22546, 167340, 1, 1614},
	{22568, 167344},
	{22584, 167348, 1, 1571},
	{22606, 167352},
	{22628, 167356},
	{22669, 167368},
	{22684, 167372, 2, 1569},
	{22700, 167376, 1, 1571},
	{22716, 167380, 2, 3814},
	{22731, 167384, 15, 3890},
	{22746, 167388, 6, 1594},
	{22785, 167396},
	{22801, 167400, 1, 1614},
	{22823, 167404},
	{22839, 167408, 1, 1571},
	{22861, 167412},
	{22883, 167416},
	{22924, 167428},
	{22939, 167432, 2, 1569},
	{22955, 167436, 1, 1571},
	{22971, 167440, 2, 3814},
	{22986, 167444, 15, 3890},
	{23001, 167448, 6, 1594},
	{23040, 167456},
	{23056, 167460, 1, 1614},
	{23078, 167464},
	{23094, 167468, 1, 1571},
	{23116, 167472},
	{23138, 167476},
	{24203, 196608, 2, 3031},
	{24223, 196612, 1, 1628},
	{24243, 196616},
	{24263, 196620},
	{24283, 196624},
	{24304, 196628},
	{24325, 196632, 2, 3033},
	{24347, 196636, 1, 1630},
	{24369, 196640},
	{24399, 196644},
	{24429, 196648},
	{24458, 196652},
	{24487, 196656},
	{24517, 196660},
	{24547, 196664},
	{24576, 196668},
	{24605, 196672},
	{24635, 196676},
	{24665, 196680},
	{24694, 196684},
	{24723, 196688},
	{24753, 196692},
	{24783, 196696},
	{24812, 196700},
	{24841, 196704, 2, 3035},
	{24863, 196708, 1, 1632},
	{24885, 196712},
	{24908, 196716},
	{24931, 196720},
	{24954, 196724},
	{24977, 196728},
	{25000, 196732},
	{25023, 196736},
	{25047, 196740},
	{25071, 196744},
	{25095, 196748},
	{25119, 196752},
	{25143, 196756},
	{25167, 196760},
	{25191, 196764},
	{25215, 196768},
	{25237, 196772},
	{25259, 196776},
	{25280, 196780},
	{25301, 196784},
	{25325, 196788},
	{25349, 196792},
	{25373, 196796},
	{25397, 196800},
	{25421, 196804},
	{25549, 196860, 1, 1635},
	{25565, 196864},
	{25578, 196868},
	{25591, 196872},
	{25604, 196876},
	{25617, 196880},
	{25630, 196884},
	{25643, 196888},
	{25656, 196892},
	{25783, 196928, 2, 1636},
	{25796, 196932},
	{25809, 196936},
	{25832, 196940},
	{25855, 196944},
	{25883, 196948},
	{25911, 196952},
	{25939, 196956},
	{25967, 196960, 1, 1638},
	{25985, 196964, 3, 4077},
	{26003, 196968},
	{26018, 196972},
	{26042, 196976},
	{26066, 196980},
	{26085, 196984},
	{26104, 196988},
	{26128, 196992},
	{26152, 196996},
	{26176, 197000},
	{26200, 197028, 2, 3040},
	{26218, 197032, 1, 1644},
	{26236, 197036},
	{26254, 197040},
	{26272, 197044, 2, 3043},
	{26290, 197048, 1, 1647},
	{26308, 197052},
	{26326, 197056, 2, 1649},
	{26345, 197060, 5, 1651},
	{26364, 197072},
	{26388, 197076, 2, 1649},
	{26408, 197080, 5, 1651},
	{26428, 197084, 8, 4080},
	{26447, 197088, 8, 4080},
	{26465, 197092, 1, 1663},
	{26482, 197100, 1, 1664},
	{26503, 197104, 23, 3051},
	{26517, 197108},
	{26531, 197112},
	{26545, 197116, 4, 3074},
	{26561, 197120},
	{26580, 197124, 1, 1680},
	{26602, 197128},
	{26621, 197132, 1, 1681},
	{26643, 197136, 9, 3080},
	{26661, 197140},
	{26681, 197144, 1, 1680},
	{26704, 197148},
	{26724, 197152, 1, 1681},
	{26747, 197156, 9, 3080},
	{26766, 197160, 5, 3089},
	{26778, 197164, 2, 1696},
	{26795, 197168, 1, 1698},
	{26812, 197172, 1, 1699},
	{26830, 197176, 5, 2646},
	{26850, 197180, 1, 1704},
	{26867, 197184},
	{26883, 197188, 1, 1706},
	{26896, 197192, 1, 1707},
	{26910, 197196, 1, 1708},
	{26924, 197200, 1, 1709},
	{26946, 197204, 1, 1710},
	{26966, 197208, 1, 1711},
	{26988, 197212, 1, 1712},
	{27008, 197216, 1, 1707},
	{27025, 197220, 1, 1708},
	{27042, 197224},
	{27301, 197388, 1, 1721},
	{27320, 197392, 1, 1722},
	{27339, 197396, 1, 1723},
	{27356, 197400, 1, 1724},
	{27374, 197404, 1, 1725},
	{27392, 197408, 1, 1726},
	{27408, 197412, 1, 1727},
	{27426, 197416, 1, 1728},
	{27444, 197420, 1, 1729},
	{27460, 197424, 1, 1724},
	{27475, 197428, 1, 1725},
	{27490, 197432, 1, 1726},
	{27503, 197436, 1, 1727},
	{27518, 197440, 1, 1728},
	{27533, 197444, 1, 1729},
	{27546, 197448, 1, 1730},
	{27560, 197452, 1, 1731},
	{27574, 197456, 1, 1732},
	{27586, 197460, 4, 4088},
	{27609, 197464, 4, 4092},
	{28309, 198656, 6, 2946},
	{48507, 198912},
	{48526, 198916},
	{28370, 198920, 1, 3329},
	{28389, 198924, 1, 3330},
	{28404, 198928},
	{28437, 198932},
	{28470, 198936},
	{28503, 198940},
	{28593, 198960},
	{28609, 198964},
	{49020, 198968, 1, 1785},
	{49052, 198972, 2, 1786},
	{49073, 198976},
	{29013, 199168, 1, 1809},
	{29038, 199172, 2, 1810},
	{29063, 199184, 2, 1812},
	{29089, 199188, 2, 1812},
	{29115, 199192, 2, 1812},
	{29141, 199212, 2, 1812},
	{29167, 199296, 2, 1814},
	{29195, 199300, 1, 1816},
	{29219, 199304, 1, 1817},
	{29243, 199308, 1, 1818},
	{29276, 199312, 1, 1818},
	{29304, 199328, 2, 1814},
	{29333, 199332, 1, 1816},
	{29358, 199336, 1, 1817},
	{29383, 199340, 1, 1818},
	{29417, 199344, 1, 1818},
	{29446, 199360, 2, 1814},
	{29470, 199364, 1, 1816},
	{29490, 199368, 1, 1817},
	{29510, 199372, 1, 1818},
	{29539, 199376, 1, 1818},
	{29563, 199936},
	{29590, 199940},
	{29617, 199944},
	{29644, 199948},
	{29779, 199968, 3, 3453},
	{29804, 200192},
	{29823, 200196, 1, 840},
	{29845, 200448},
	{29869, 200452, 1, 1828},
	{29892, 200456},
	{29916, 200460, 1, 1828},
	{29939, 200464},
	{29963, 200468, 1, 1828},
	{29986, 200472},
	{30010, 200476, 1, 1828},
	{30033, 200696},
	{30052, 200700, 1, 1828},
	{30070, 200704},
	{30082, 200708},
	{30094, 200712},
	{30112, 200716},
	{30131, 200720},
	{30149, 200724},
	{30161, 200728},
	{30173, 200732},
	{30191, 200736},
	{30209, 200740},
	{30228, 200744, 4, 4096},
	{30242, 200748, 2, 1833},
	{30260, 200752, 2, 1835},
	{30274, 200756, 2, 1837},
	{30288, 200760, 2, 1839},
	{30305, 200764, 2, 1841},
	{30322, 200768},
	{30335, 200772, 2, 1843},
	{30347, 200776},
	{30361, 200780},
	{30377, 200784},
	{30391, 200788},
	{30407, 200792},
	{30422, 200796},
	{30439, 200800},
	{30454, 200804},
	{30471, 200808, 2, 1845},
	{30493, 200812, 9, 4100},
	{30510, 200816, 2, 1857},
	{30531, 200820, 2, 1859},
	{30543, 200824},
	{30558, 200828, 6, 1861},
	{30573, 200832, 2, 1867},
	{30587, 200836},
	{30700, 212992},
	{30720, 212996},
	{30740, 213000},
	{30760, 213004},
	{30780, 213008},
	{30800, 213012},
	{30820, 213016},
	{30840, 213020},
	{30860, 213024},
	{30880, 213028},
	{30900, 213032},
	{30920, 213036},
	{31009, 213248},
	{31030, 213252},
	{31051, 213260},
	{31072, 213264},
	{31093, 213268},
	{31117, 213272},
	{31141, 213276},
	{31165, 213280},
	{31189, 213284},
	{31213, 213288},
	{31237, 213292},
	{31261, 213296},
	{50822, 213504},
	{50841, 213508},
	{50860, 213512},
	{50879, 213516},
	{50898, 213520},
	{50917, 213524},
	{50936, 213528},
	{50955, 213532},
	{48217, 213536},
	{48236, 213540},
	{48255, 213544},
	{48274, 213548},
	{48293, 213552},
	{48312, 213556},
	{48331, 213560},
	{48350, 213564},
	{48808, 213568},
	{48828, 213572},
	{48848, 213576},
	{48868, 213580},
	{48888, 213584},
	{48908, 213588},
	{48928, 213592},
	{48948, 213596},
	{31745, 214016},
	{31767, 214020, 1, 1869},
	{31789, 214024},
	{31811, 214028, 1, 1869},
	{31833, 214032},
	{31855, 214036, 1, 1869},
	{31877, 214040},
	{31899, 214044, 1, 1869},
	{31921, 214272},
	{31943, 214276},
	{31965, 214280},
	{31987, 214284},
	{32009, 214288},
	{32031, 214292},
	{32053, 214296},
	{32075, 214300},
	{32097, 214304},
	{32119, 214308},
	{32141, 214312},
	{32163, 214316},
	{32185, 214320},
	{32207, 214324},
	{32229, 214328},
	{32251, 214332},
	{32273, 214528},
	{32293, 214532},
	{32313, 214536},
	{32333, 214540},
	{32353, 214544},
	{32373, 214548},
	{32393, 214552},
	{32413, 214556},
	{32433, 214560},
	{32453, 214564},
	{32473, 214568},
	{32493, 214572},
	{32513, 214784},
	{32532, 214788},
	{32551, 214792},
	{32570, 214796},
	{32589, 214800},
	{32608, 214804},
	{32627, 214808},
	{32646, 214812},
	{32665, 214816},
	{32684, 214820},
	{32703, 214824},
	{32722, 214828},
	{32741, 214832},
	{32760, 214836},
	{32779, 214840},
	{32798, 214844},
	{32817, 214848},
	{32836, 214852},
	{32855, 214856},
	{32874, 214860},
	{32893, 214864},
	{32913, 214868},
	{32933, 214872},
	{32953, 214876},
	{32973, 214880},
	{32993, 214884},
	{33013, 214888},
	{33033, 214892},
	{33053, 214896},
	{33073, 214900},
	{33093, 214904},
	{33113, 214908},
	{33133, 215296},
	{33152, 215300},
	{33171, 215304},
	{33190, 215308},
	{33209, 215312},
	{33228, 215316},
	{33247, 215320},
	{33266, 215324},
	{33327, 215552},
	{33347, 215556},
	{33367, 215560},
	{33387, 215564},
	{33407, 215568},
	{33427, 215572},
	{33447, 215576},
	{33467, 215580},
	{33487, 215808},
	{33506, 215812},
	{33525, 215816},
	{33544, 215820},
	{33563, 216064},
	{33582, 216068},
	{33601, 216072},
	{33620, 216076},
	{33639, 216320},
	{33659, 216324},
	{33679, 216328},
	{33699, 216332},
	{33719, 216336},
	{33739, 216340},
	{33759, 216344},
	{33779, 216348},
	{50974, 216576},
	{50994, 216580},
	{51014, 216584},
	{51034, 216588},
	{51054, 216592},
	{51074, 216596},
	{51094, 216600},
	{51114, 216604},
	{51134, 216640},
	{51154, 216644},
	{51174, 216648},
	{51194, 216652},
	{51214, 216656},
	{51234, 216660},
	{51254, 216664},
	{51274, 216668},
	{51294, 216704},
	{51314, 216708},
	{51334, 216712},
	{51354, 216716},
	{51374, 216720},
	{51394, 216724},
	{51414, 216728},
	{51434, 216732},
	{34631, 217112},
	{34650, 217116},
	{34669, 217120},
	{34688, 217124},
	{34707, 217128},
	{34726, 217132},
	{34745, 217136},
	{34764, 217140},
	{34783, 217344},
	{34802, 217348},
	{34821, 217352},
	{34840, 217356},
	{34859, 217360},
	{34878, 217364},
	{34897, 217368},
	{34916, 217372},
	{34935, 217600},
	{34955, 217604},
	{34975, 217608},
	{34995, 217612},
	{36317, 221184, 1, 1903},
	{36341, 221188, 2, 4109},
	{36366, 221192, 3, 4111},
	{36390, 221196, 1, 1903},
	{36414, 221200, 2, 4109},
	{36439, 221204, 1, 1903},
	{36463, 221208, 2, 4109},
	{36488, 221212, 3, 4111},
	{36512, 221216, 4, 1881},
	{36528, 221220, 3, 4111},
	{36695, 221248},
	{36710, 221252, 1, 1818},
	{36733, 221256},
	{36756, 221260},
	{36774, 221264, 2, 1897},
	{36792, 221268, 4, 1899},
	{36812, 221440, 19, 2989},
	{36837, 221444, 19, 2989},
	{36862, 221448, 12, 3008},
	{36890, 221452, 12, 3008},
	{36918, 221456, 12, 3008},
	{36946, 221460, 12, 3008},
	{51454, 221696, 2, 3287},
	{51477, 221700, 2, 3287},
	{51500, 221704, 2, 3287},
	{51523, 221708, 2, 3287},
	{48125, 221712, 5, 1957},
	{48148, 221716, 2, 3287},
	{48171, 221720, 2, 3287},
	{48194, 221724, 2, 3287},
	{51546, 221728, 4, 1962},
	{48712, 221744, 5, 1957},
	{48736, 221748, 5, 1957},
	{48760, 221752, 2, 3287},
	{48784, 221756, 2, 3287},
	{51570, 221760, 4, 1962},
	{51595, 221764, 4, 1962},
	{48686, 221776, 1, 3328},
	{37404, 222208, 3, 1957},
	{37430, 222212, 2, 1877},
	{37457, 222216, 3, 1957},
	{37483, 222220, 2, 1877},
	{37510, 222224, 2, 2013},
	{37563, 222228, 2, 2013},
	{37616, 222464, 3, 1957},
	{37642, 222468, 2, 1877},
	{37669, 222472, 1, 1872},
	{37695, 222476, 1, 1872},
	{37721, 222480, 1, 1872},
	{37747, 222484, 1, 1872},
	{37773, 222488, 1, 1872},
	{37799, 222492, 1, 1872},
	{37825, 222496, 1, 1872},
	{37851, 222720, 3, 1957},
	{37875, 222724, 3, 1957},
	{37899, 222728, 3, 1957},
	{37923, 222732, 3, 1957},
	{37947, 222736, 2, 1877},
	{37972, 222740, 2, 1877},
	{37997, 222744, 2, 1877},
	{38022, 222748, 2, 1877},
	{38047, 222752, 1, 2001},
	{38071, 222756, 1, 2001},
	{38095, 222760, 8, 1966},
	{38116, 222976, 6, 4114},
	{38139, 222980, 6, 4114},
	{38162, 222984, 6, 4114},
	{38185, 222988, 6, 4114},
	{38208, 222992, 6, 4114},
	{38231, 222996, 6, 4114},
	{38254, 223000, 6, 4114},
	{38277, 223004, 6, 4114},
	{38300, 223008, 6, 4114},
	{38323, 223012, 6, 4114},
	{38346, 223016, 6, 4114},
	{38370, 223020, 6, 4114},
	{38394, 223024, 6, 4114},
	{38418, 223028, 6, 4114},
	{38442, 223032, 6, 4114},
	{38466, 223036, 6, 4114},
	{38490, 223104, 9, 3469},
	{51620, 223108, 2, 3518},
	{38510, 223112, 1, 1987},
	{38605, 223488, 3, 1996},
	{38628, 223492, 3, 1996},
	{38651, 223496, 3, 1996},
	{38674, 223500, 3, 1996},
	{38697, 223504, 2, 1999},
	{38721, 223508, 2, 1999},
	{38745, 223744, 3, 1996},
	{38769, 223748, 3, 1996},
	{38793, 223752, 3, 1996},
	{38817, 223756, 3, 1996},
	{38841, 223760, 2, 1999},
	{38866, 224000, 5, 2001},
	{38889, 224004, 4, 2006},
	{38913, 224008, 5, 2001},
	{38936, 224256, 5, 2001},
	{38959, 224260, 4, 2006},
	{38983, 224264, 5, 2001},
	{39006, 224512, 5, 1957},
	{39030, 224516, 4, 1962},
	{39055, 224520, 5, 1957},
	{39079, 224524, 4, 1962},
	{39104, 224528, 3, 2013},
	{39128, 224532, 3, 2013},
	{51640, 224768, 5, 1957},
	{51664, 224772, 4, 1951},
	{51689, 224776, 5, 1957},
	{51713, 224780, 4, 1951},
	{51738, 224784, 3, 2013},
	{51762, 224788, 3, 2013},
	{51786, 224832, 5, 1957},
	{51810, 224836, 4, 1951},
	{51835, 224840, 5, 1957},
	{51859, 224844, 4, 1951},
	{51884, 224848, 3, 2013},
	{51908, 224852, 3, 2013},
	{51932, 224896, 5, 1957},
	{51956, 224900, 4, 1951},
	{51981, 224904, 3, 2013},
	{52005, 224908, 3, 2013},
	{52029, 224912, 3, 2013},
	{39829, 225280, 12, 2016},
	{39851, 225284, 5, 2028},
	{39874, 225288, 4, 2033},
	{39898, 225292, 2, 2037},
	{39921, 225296, 2, 2037},
	{39944, 225300, 2, 2037},
	{39967, 225536, 5, 1957},
	{39990, 225540, 4, 1962},
	{40014, 225544, 5, 1957},
	{40037, 225548, 4, 1962},
	{40061, 225552, 5, 1957},
	{40084, 225560, 5, 1957},
	{40107, 225792, 4, 2039},
	{40128, 225796},
	{40157, 225800, 2, 2043},
	{40186, 225804},
	{40212, 225808, 7, 2045},
	{40286, 225812},
	{40309, 225816},
	{52053, 225820, 2, 4120},
	{52086, 225824, 2, 4120},
	{52119, 225828, 2, 4120},
	{52152, 225832, 2, 4120},
	{52184, 225836, 2, 4120},
	{52216, 225840, 2, 4120},
	{52248, 225844, 2, 4120},
	{52281, 225848, 2, 4120},
	{52313, 225856, 2, 4120},
	{52345, 225860, 2, 4120},
	{52378, 225864, 2, 4120},
	{52411, 225868, 2, 4120},
	{52444, 225872, 2, 4120},
	{52476, 225876, 2, 4120},
	{52508, 225880, 2, 4120},
	{52541, 225884, 2, 4120},
	{52574, 225888, 2, 4120},
	{52607, 225892, 2, 4120},
	{52640, 225896, 2, 4120},
	{40332, 225900},
	{40359, 225904},
	{40241, 225908},
	{40260, 225912},
	{52672, 225916, 2, 4120},
	{52706, 225920, 2, 4120},
	{52740, 225924, 2, 4120},
	{52774, 225928, 2, 4120},
	{41022, 226048, 2, 2119},
	{41039, 226052, 1, 2121},
	{41063, 226056, 1, 2121},
	{195, 880, 4, 2156},
	{42808, 881},
	{26631, 882},
	{42820, 1008},
	{42831, 1009},
	{26819, 1010, 3, 2160},
	{42842, 1040, 1, 2163},
	{42855, 1041, 5, 4122},
	{42868, 1042, 1, 2169},
	{42881, 1043, 1, 1681},
	{26653, 1045, 9, 3914},
	{42909, 1280, 6, 4127},
	{42924, 1281},
	{26590, 1282},
	{42808, 1283},
	{26631, 1284},
};

static const struct si_reg gfx8_reg_table[] = {
	{974, 68, 10, 4133},
	{987, 72, 23, 4143},
	{1002, 76, 4, 4166},
	{46947, 80, 11, 3939},
	{1039, 84, 4, 2800},
	{1057, 88, 2, 2804},
	{1075, 92, 6, 4170},
	{1090, 96},
	{1104, 100, 1, 2810},
	{1118, 104},
	{46961, 108},
	{46978, 112, 13, 4176},
	{1135, 116, 5, 4189},
	{46994, 2480},
	{47009, 2484, 1, 2824},
	{47024, 2488},
	{47039, 2492, 1, 2824},
	{1273, 2496},
	{1287, 2500},
	{1301, 2504},
	{1315, 2508},
	{1329, 2512},
	{1343, 2516},
	{1357, 2520},
	{1371, 2524},
	{1385, 2528},
	{1399, 2532},
	{1413, 2536},
	{1428, 2540},
	{1503, 2544},
	{1514, 2552},
	{1530, 2556},
	{47054, 3660, 21, 2825},
	{47067, 3664, 20, 2846},
	{47079, 3668, 16, 2866},
	{1618, 32776, 18, 4194},
	{1631, 32784, 24, 2904},
	{1643, 32788, 11, 2928},
	{1659, 32792, 11, 2928},
	{1688, 32824, 11, 2928},
	{1704, 32828, 11, 2928},
	{1720, 33296, 15, 4212},
	{1734, 33300, 28, 204},
	{1751, 33304, 14, 4227},
	{1772, 33308, 21, 4241},
	{1786, 33312, 31, 4022},
	{1803, 33316, 9, 4262},
	{1842, 33324, 1, 329},
	{1865, 33344, 1, 330},
	{1886, 33348},
	{1947, 33436, 1, 342},
	{49728, 36416},
	{2351, 36608},
	{2369, 36612, 4, 383},
	{2387, 36616},
	{2405, 36620, 14, 4271},
	{3306, 36624},
	{3324, 36628, 5, 4285},
	{3342, 36632, 4, 3587},
	{3360, 36636, 11, 3591},
	{3378, 36640, 2, 3602},
	{3396, 36644, 2, 3604},
	{3414, 36648, 8, 4290},
	{3432, 36652},
	{2423, 36656, 14, 4298},
	{2441, 36660, 4, 411},
	{2459, 36664, 10, 4312},
	{2477, 36668, 3, 3632},
	{2495, 37120, 6, 429},
	{2511, 39160, 9, 3635},
	{2526, 39184, 5, 3645},
	{2540, 39188, 5, 3645},
	{2554, 39192, 5, 3645},
	{2568, 39196, 5, 3645},
	{2582, 39200, 5, 3645},
	{2596, 39204, 5, 3645},
	{2610, 39208, 5, 3645},
	{2624, 39212, 5, 3645},
	{2638, 39216, 5, 3645},
	{2652, 39220, 5, 3645},
	{2666, 39224, 5, 3645},
	{2681, 39228, 5, 3645},
	{2696, 39232, 5, 3645},
	{2711, 39236, 5, 3645},
	{2726, 39240, 5, 3645},
	{2741, 39244, 5, 3645},
	{2756, 39248, 5, 3645},
	{2771, 39252, 5, 3645},
	{2786, 39256, 5, 3645},
	{2801, 39260, 5, 3645},
	{2816, 39264, 5, 3645},
	{2831, 39268, 5, 3645},
	{2846, 39272, 5, 3645},
	{2861, 39276, 5, 3645},
	{2876, 39280, 5, 3645},
	{2891, 39284, 5, 3645},
	{2906, 39288, 5, 3645},
	{2921, 39292, 5, 3645},
	{2936, 39296, 5, 3645},
	{2951, 39300, 5, 3645},
	{2966, 39304, 5, 3645},
	{2981, 39308, 5, 3645},
	{2996, 39312, 4, 448},
	{3015, 39316, 4, 448},
	{3034, 39320, 4, 448},
	{3053, 39324, 4, 448},
	{3072, 39328, 4, 448},
	{3091, 39332, 4, 448},
	{3110, 39336, 4, 448},
	{3129, 39340, 4, 448},
	{3148, 39344, 4, 448},
	{3167, 39348, 4, 448},
	{3186, 39352, 4, 448},
	{3206, 39356, 4, 448},
	{3226, 39360, 4, 448},
	{3246, 39364, 4, 448},
	{3266, 39368, 4, 448},
	{3286, 39372, 4, 448},
	{49962, 45056},
	{49983, 45060, 1, 491},
	{50004, 45064},
	{50025, 45068, 1, 491},
	{3499, 45084, 3, 488},
	{3523, 45088},
	{3544, 45092, 1, 491},
	{3565, 45096, 11, 3650},
	{3589, 45100, 6, 503},
	{3613, 45104},
	{3639, 45108},
	{3665, 45112},
	{3691, 45116},
	{3717, 45120},
	{3743, 45124},
	{3769, 45128},
	{3795, 45132},
	{3821, 45136},
	{3847, 45140},
	{3873, 45144},
	{3900, 45148},
	{3927, 45152},
	{3954, 45156},
	{3981, 45160},
	{4008, 45164},
	{50046, 45312},
	{50067, 45316, 1, 491},
	{50088, 45320},
	{50109, 45324, 1, 491},
	{4680, 45336, 3, 488},
	{4704, 45340, 1, 527},
	{4729, 45344},
	{4750, 45348, 1, 491},
	{4771, 45352, 12, 3667},
	{4795, 45356, 11, 4322},
	{4819, 45360},
	{4845, 45364},
	{4871, 45368},
	{4897, 45372},
	{4923, 45376},
	{4949, 45380},
	{4975, 45384},
	{5001, 45388},
	{5027, 45392},
	{5053, 45396},
	{5079, 45400},
	{5106, 45404},
	{5133, 45408},
	{5160, 45412},
	{5187, 45416},
	{5214, 45420},
	{5864, 45552, 6, 563},
	{5891, 45556, 5, 569},
	{50130, 45568},
	{50151, 45572, 1, 491},
	{50172, 45576},
	{50193, 45580, 1, 491},
	{6079, 45596, 4, 576},
	{6103, 45600},
	{6124, 45604, 1, 491},
	{6145, 45608, 11, 3689},
	{6169, 45612, 4, 554},
	{6193, 45616},
	{6219, 45620},
	{6245, 45624},
	{6271, 45628},
	{6297, 45632},
	{6323, 45636},
	{6349, 45640},
	{6375, 45644},
	{6401, 45648},
	{6427, 45652},
	{6453, 45656},
	{6480, 45660},
	{6507, 45664},
	{6534, 45668},
	{6561, 45672},
	{6588, 45676},
	{7223, 45808, 6, 563},
	{50214, 45824},
	{50235, 45828, 1, 491},
	{50256, 45832},
	{50277, 45836, 1, 491},
	{7250, 45852, 4, 576},
	{7274, 45856},
	{7295, 45860, 1, 491},
	{7316, 45864, 12, 3667},
	{7340, 45868, 6, 563},
	{7364, 45872},
	{7390, 45876},
	{7416, 45880},
	{7442, 45884},
	{7468, 45888},
	{7494, 45892},
	{7520, 45896},
	{7546, 45900},
	{7572, 45904},
	{7598, 45908},
	{7624, 45912},
	{7651, 45916},
	{7678, 45920},
	{7705, 45924},
	{7732, 45928},
	{7759, 45932},
	{7786, 46068, 5, 569},
	{50298, 46080},
	{50319, 46084, 1, 491},
	{50340, 46088},
	{50361, 46092, 1, 491},
	{7974, 46108, 3, 612},
	{7998, 46112},
	{8019, 46116, 1, 491},
	{8040, 46120, 10, 3710},
	{8064, 46124, 6, 628},
	{8088, 46128},
	{8114, 46132},
	{8140, 46136},
	{8166, 46140},
	{8192, 46144},
	{8218, 46148},
	{8244, 46152},
	{8270, 46156},
	{8296, 46160},
	{8322, 46164},
	{8348, 46168},
	{8375, 46172},
	{8402, 46176},
	{8429, 46180},
	{8456, 46184},
	{8483, 46188},
	{9118, 46324, 5, 569},
	{50382, 46336},
	{50403, 46340, 1, 491},
	{50424, 46344},
	{50445, 46348, 1, 491},
	{9145, 46364, 4, 576},
	{9169, 46368},
	{9190, 46372, 1, 491},
	{9211, 46376, 11, 3726},
	{9235, 46380, 5, 569},
	{9259, 46384},
	{9285, 46388},
	{9311, 46392},
	{9337, 46396},
	{9363, 46400},
	{9389, 46404},
	{9415, 46408},
	{9441, 46412},
	{9467, 46416},
	{9493, 46420},
	{9519, 46424},
	{9546, 46428},
	{9573, 46432},
	{9600, 46436},
	{9627, 46440},
	{9654, 46444},
	{9681, 47104, 12, 3742},
	{9708, 47108},
	{9722, 47112},
	{9736, 47116},
	{9750, 47120},
	{9766, 47124},
	{9782, 47128},
	{9798, 47132, 2, 659},
	{9819, 47136, 2, 659},
	{9840, 47140, 2, 659},
	{9861, 47144, 1, 661},
	{9889, 47148, 1, 662},
	{9914, 47152},
	{9929, 47156, 2, 3755},
	{50486, 47160},
	{50501, 47164, 1, 663},
	{50516, 47168},
	{50531, 47172, 1, 663},
	{10068, 47176, 10, 3757},
	{10086, 47180, 11, 676},
	{10104, 47184, 1, 687},
	{10117, 47188, 6, 688},
	{50546, 47192, 2, 3774},
	{50577, 47196, 2, 3774},
	{10195, 47200, 2, 694},
	{50760, 47204, 2, 3774},
	{50791, 47208, 2, 3774},
	{10270, 47212},
	{10288, 47216},
	{10306, 47220},
	{10324, 47224, 1, 696},
	{10352, 47228, 5, 697},
	{10374, 47232},
	{10394, 47236},
	{10577, 47240, 3, 713},
	{10594, 47244},
	{10623, 47248, 1, 716},
	{52808, 47252, 2, 4333},
	{10670, 47360},
	{10690, 47364},
	{10710, 47368},
	{10730, 47372},
	{10750, 47376},
	{10770, 47380},
	{10790, 47384},
	{10810, 47388},
	{10830, 47392},
	{10850, 47396},
	{10870, 47400},
	{10891, 47404},
	{10912, 47408},
	{10933, 47412},
	{10954, 47416},
	{10975, 47420},
	{11041, 47612},
	{50608, 53300, 29, 3776},
	{50625, 55348, 29, 3776},
	{11057, 163840, 10, 719},
	{11075, 163844, 9, 3805},
	{11092, 163848, 4, 3814},
	{11106, 163852, 23, 747},
	{11125, 163856, 15, 770},
	{11145, 163860},
	{11181, 163872},
	{11201, 163876},
	{11221, 163880, 1, 788},
	{11238, 163884},
	{11253, 163888, 2, 789},
	{11277, 163892, 2, 791},
	{50642, 163900, 7, 3818},
	{11335, 163904, 10, 4335},
	{11345, 163908, 6, 4345},
	{11361, 163912},
	{11376, 163916},
	{11397, 163920},
	{11413, 163924},
	{50656, 163928, 2, 3838},
	{50670, 163932, 1, 3840},
	{11603, 163968},
	{11619, 163972, 1, 840},
	{11638, 164328, 1, 841},
	{11659, 164332, 1, 841},
	{11680, 164336, 1, 841},
	{11701, 164340, 1, 841},
	{11722, 164344},
	{11740, 164348},
	{11758, 164352, 2, 842},
	{11778, 164356, 3, 844},
	{11802, 164360, 2, 847},
	{11826, 164364, 1, 849},
	{11846, 164368, 2, 844},
	{11866, 164372, 2, 847},
	{11886, 164376, 2, 844},
	{11906, 164380, 2, 847},
	{11926, 164384, 2, 844},
	{11946, 164388, 2, 847},
	{11966, 164392, 2, 844},
	{11986, 164396, 2, 847},
	{12006, 164400, 7, 850},
	{12021, 164404, 2, 857},
	{12050, 164408, 8, 859},
	{12065, 164412, 8, 867},
	{12080, 164416, 3, 844},
	{12105, 164420, 2, 847},
	{12130, 164424},
	{12148, 164428},
	{12166, 164432, 3, 844},
	{12191, 164436, 2, 847},
	{12216, 164440, 3, 844},
	{12241, 164444, 2, 847},
	{12266, 164448, 3, 844},
	{12291, 164452, 2, 847},
	{12316, 164456, 3, 844},
	{12341, 164460, 2, 847},
	{12366, 164464, 3, 844},
	{12391, 164468, 2, 847},
	{12416, 164472, 3, 844},
	{12441, 164476, 2, 847},
	{12466, 164480, 3, 844},
	{12491, 164484, 2, 847},
	{12516, 164488, 3, 844},
	{12541, 164492, 2, 847},
	{12566, 164496, 3, 844},
	{12591, 164500, 2, 847},
	{12616, 164504, 3, 844},
	{12641, 164508, 2, 847},
	{12666, 164512, 3, 844},
	{12692, 164516, 2, 847},
	{12718, 164520, 3, 844},
	{12744, 164524, 2, 847},
	{12770, 164528, 3, 844},
	{12796, 164532, 2, 847},
	{12822, 164536, 3, 844},
	{12848, 164540, 2, 847},
	{12874, 164544, 3, 844},
	{12900, 164548, 2, 847},
	{12926, 164552, 3, 844},
	{12952, 164556, 2, 847},
	{12978, 164560},
	{12997, 164564},
	{13016, 164568},
	{13035, 164572},
	{13054, 164576},
	{13073, 164580},
	{13092, 164584},
	{13111, 164588},
	{13130, 164592},
	{13149, 164596},
	{13168, 164600},
	{13187, 164604},
	{13206, 164608},
	{13225, 164612},
	{13244, 164616},
	{13263, 164620},
	{13282, 164624},
	{13301, 164628},
	{13320, 164632},
	{13339, 164636},
	{13358, 164640},
	{13378, 164644},
	{13398, 164648},
	{13418, 164652},
	{13438, 164656},
	{13458, 164660},
	{13478, 164664},
	{13498, 164668},
	{13518, 164672},
	{13538, 164676},
	{13558, 164680},
	{13578, 164684},
	{13598, 164688, 15, 875},
	{13618, 164692, 3, 890},
	{13640, 164696, 2, 893},
	{13697, 164704, 1, 902},
	{50685, 164708, 1, 3841},
	{13728, 164712, 1, 904},
	{13796, 164864},
	{13813, 164868},
	{13830, 164872},
	{13846, 164876},
	{13900, 164884},
	{13913, 164888},
	{13928, 164892},
	{13942, 164896},
	{13957, 164900, 3, 4351},
	{13996, 164908, 6, 935},
	{14015, 164912, 4, 941},
	{14033, 164916, 4, 945},
	{14054, 164924},
	{14073, 164928},
	{14093, 164932},
	{14112, 164936},
	{14132, 164940},
	{14151, 164944},
	{14171, 164948},
	{14192, 164952},
	{14214, 164956},
	{14235, 164960},
	{14257, 164964},
	{14278, 164968},
	{14300, 164972},
	{14321, 164976},
	{14343, 164980},
	{14364, 164984},
	{14386, 164988},
	{14407, 164992},
	{14429, 164996},
	{14450, 165000},
	{14472, 165004},
	{14493, 165008},
	{14515, 165012},
	{14536, 165016},
	{14558, 165020},
	{14579, 165024},
	{14601, 165028},
	{14622, 165032},
	{14644, 165036},
	{14665, 165040},
	{14687, 165044},
	{14708, 165048},
	{14730, 165052},
	{14751, 165056},
	{14773, 165060},
	{14794, 165064},
	{14816, 165068},
	{14837, 165072},
	{14859, 165076},
	{14880, 165080},
	{14902, 165084},
	{14923, 165088},
	{14945, 165092},
	{14966, 165096},
	{14988, 165100},
	{15009, 165104},
	{15031, 165108},
	{15052, 165112},
	{15074, 165116},
	{15095, 165120},
	{15117, 165124},
	{15138, 165128},
	{15160, 165132},
	{15181, 165136},
	{15203, 165140},
	{15224, 165144},
	{15246, 165148},
	{15267, 165152},
	{15289, 165156},
	{15310, 165160},
	{15332, 165164},
	{15354, 165168},
	{15377, 165172},
	{15399, 165176},
	{15422, 165180},
	{15444, 165184},
	{15467, 165188},
	{15489, 165192},
	{15512, 165196},
	{15534, 165200},
	{15557, 165204},
	{15579, 165208},
	{15602, 165212},
	{15624, 165216},
	{15647, 165220},
	{15669, 165224},
	{15692, 165228},
	{15714, 165232},
	{15737, 165236},
	{15759, 165240},
	{15782, 165244},
	{15804, 165248},
	{15827, 165252},
	{15849, 165256},
	{15872, 165260},
	{15894, 165264},
	{15917, 165268},
	{15939, 165272},
	{15962, 165276},
	{15984, 165280},
	{16007, 165284},
	{16029, 165288},
	{16052, 165292},
	{16074, 165296},
	{16097, 165300},
	{16119, 165304},
	{16142, 165308},
	{16156, 165312},
	{16170, 165316},
	{16184, 165320},
	{16198, 165324},
	{16212, 165328},
	{16226, 165332},
	{16240, 165336},
	{16254, 165340},
	{16268, 165344},
	{16282, 165348},
	{16296, 165352},
	{16310, 165356},
	{16324, 165360},
	{16338, 165364},
	{16352, 165368},
	{16366, 165372},
	{16380, 165376},
	{16394, 165380},
	{16408, 165384},
	{16422, 165388},
	{16436, 165392},
	{16450, 165396},
	{16464, 165400},
	{16501, 165444, 12, 949},
	{16521, 165448, 12, 949},
	{16541, 165452, 12, 949},
	{16561, 165456, 12, 949},
	{16581, 165460, 12, 949},
	{16601, 165464, 12, 949},
	{16621, 165468, 12, 949},
	{16641, 165472, 12, 949},
	{16661, 165476, 12, 949},
	{16681, 165480, 12, 949},
	{16701, 165484, 12, 949},
	{16722, 165488, 12, 949},
	{16743, 165492, 12, 949},
	{16764, 165496, 12, 949},
	{16785, 165500, 12, 949},
	{16806, 165504, 12, 949},
	{16827, 165508, 12, 949},
	{16848, 165512, 12, 949},
	{16869, 165516, 12, 949},
	{16890, 165520, 12, 949},
	{16911, 165524, 9, 961},
	{16932, 165528, 9, 961},
	{16953, 165532, 9, 961},
	{16974, 165536, 9, 961},
	{16995, 165540, 9, 961},
	{17016, 165544, 9, 961},
	{17037, 165548, 9, 961},
	{17058, 165552, 9, 961},
	{17079, 165556, 9, 961},
	{17100, 165560, 9, 961},
	{17121, 165564, 9, 961},
	{17142, 165568, 9, 961},
	{17163, 165572, 2, 970},
	{17181, 165580, 16, 973},
	{17198, 165584, 16, 973},
	{17216, 165588, 7, 989},
	{17237, 165592, 3, 3842},
	{17255, 165600, 7, 1002},
	{17270, 165608, 2, 694},
	{17309, 165644, 4, 1010},
	{17331, 165648, 1, 1015},
	{17351, 165652, 8, 1016},
	{17577, 165760, 9, 1063},
	{17595, 165764, 9, 1063},
	{17613, 165768, 9, 1063},
	{17631, 165772, 9, 1063},
	{17649, 165776, 9, 1063},
	{17667, 165780, 9, 1063},
	{17685, 165784, 9, 1063},
	{17703, 165788, 9, 1063},
	{17721, 165836, 1, 1072},
	{17735, 165840, 1, 1072},
	{17750, 165844},
	{17768, 165848},
	{17786, 165852},
	{17803, 165856},
	{17824, 165860, 1, 3845},
	{17840, 165864},
	{17853, 165872, 5, 1074},
	{17872, 165876},
	{17887, 165880, 1, 1082},
	{17936, 165888, 10, 1084},
	{17953, 165892, 12, 1094},
	{17961, 165896, 3, 4354},
	{17978, 165900, 12, 1110},
	{17996, 165904, 19, 1127},
	{18012, 165908, 13, 1147},
	{18031, 165912, 10, 1163},
	{18046, 165916, 27, 4357},
	{18064, 165920, 16, 1201},
	{18082, 165924, 4, 1217},
	{18106, 165928},
	{18131, 165932, 11, 1221},
	{18283, 166400, 2, 1253},
	{18300, 166404, 2, 1255},
	{18319, 166408, 1, 1257},
	{18335, 166412, 4, 1258},
	{18354, 166416, 1, 1262},
	{18375, 166420, 1, 1263},
	{18388, 166424},
	{18411, 166428},
	{18434, 166432, 1, 1264},
	{18454, 166436, 4, 3849},
	{18474, 166440, 1, 1269},
	{18495, 166444, 1, 1270},
	{18510, 166448, 6, 1271},
	{18532, 166452, 6, 1271},
	{18554, 166456, 8, 1277},
	{18580, 166460, 8, 1277},
	{18606, 166464, 15, 4384},
	{18618, 166468, 2, 1300},
	{18637, 166472, 4, 1303},
	{18655, 166476, 24, 1310},
	{18673, 166480},
	{18685, 166484, 1, 1334},
	{18699, 166488, 1, 1335},
	{18713, 166492, 1, 1336},
	{18727, 166496, 1, 1337},
	{18750, 166500, 1, 1337},
	{18773, 166504, 1, 1337},
	{18796, 166508, 5, 3853},
	{18817, 166512},
	{18828, 166516},
	{18841, 166520},
	{18858, 166524, 7, 4399},
	{18877, 166528},
	{18888, 166532, 2, 1351},
	{18907, 166536},
	{18929, 166540},
	{18951, 166544, 3, 4406},
	{18971, 166548, 1, 1357},
	{19020, 166560},
	{19045, 166564},
	{19070, 166568, 7, 4409},
	{19089, 166572, 1, 1370},
	{19112, 166576, 1, 1370},
	{19135, 166580, 1, 1371},
	{19149, 166584, 1, 1372},
	{19164, 166588, 8, 4416},
	{19181, 166592, 4, 1382},
	{19208, 166596, 4, 1386},
	{19235, 166600, 4, 1390},
	{19254, 166608},
	{19280, 166612, 1, 1394},
	{19305, 166620},
	{19333, 166624},
	{19359, 166628, 1, 1394},
	{19384, 166636},
	{19412, 166640},
	{19438, 166644, 1, 1394},
	{19463, 166652},
	{19491, 166656},
	{19517, 166660, 1, 1394},
	{19542, 166668},
	{19570, 166696},
	{19601, 166700},
	{19644, 166704, 1, 1395},
	{19682, 166712, 1, 1396},
	{19721, 166736, 3, 1399},
	{19743, 166740, 10, 1404},
	{19764, 166744, 3, 1423},
	{19781, 166748, 1, 1370},
	{19802, 166752, 1, 1370},
	{19825, 166756, 1, 1370},
	{19848, 166760, 1, 1370},
	{19871, 166764, 10, 4424},
	{19884, 166768, 6, 1438},
	{19901, 166772},
	{19925, 166776, 2, 1444},
	{19955, 166780},
	{19979, 166784},
	{20009, 166788},
	{20040, 166792},
	{20069, 166796},
	{20099, 166800, 2, 1446},
	{20119, 166804, 7, 3883},
	{20138, 166808, 4, 1457},
	{20188, 166868, 8, 1461},
	{20214, 166872, 8, 1469},
	{20240, 166876, 4, 1477},
	{20256, 166880, 5, 1482},
	{20272, 166884, 3, 1488},
	{20287, 166888},
	{20310, 166892},
	{20333, 166896},
	{20356, 166900},
	{20379, 166904, 8, 1491},
	{20413, 166908, 8, 1499},
	{20447, 166912, 8, 1507},
	{20481, 166916, 8, 1515},
	{20515, 166920, 8, 1491},
	{20549, 166924, 8, 1499},
	{20583, 166928, 8, 1507},
	{20617, 166932, 8, 1515},
	{20651, 166936, 8, 1491},
	{20685, 166940, 8, 1499},
	{20719, 166944, 8, 1507},
	{20753, 166948, 8, 1515},
	{20787, 166952, 8, 1491},
	{20821, 166956, 8, 1499},
	{20855, 166960, 8, 1507},
	{20889, 166964, 8, 1515},
	{20923, 166968, 2, 1523},
	{20947, 166972, 2, 1525},
	{21090, 167000, 1, 1567},
	{21118, 167004, 1, 1568},
	{21139, 167008},
	{21154, 167012, 2, 1569},
	{21170, 167016, 1, 1571},
	{21186, 167020, 2, 3814},
	{21201, 167024, 18, 4434},
	{21216, 167028, 6, 1594},
	{21233, 167032, 9, 1602},
	{21255, 167036},
	{21271, 167040, 1, 1614},
	{21293, 167044},
	{21309, 167048, 1, 1571},
	{21331, 167052},
	{21353, 167056},
	{21375, 167060},
	{21394, 167068},
	{21409, 167072, 2, 1569},
	{21425, 167076, 1, 1571},
	{21441, 167080, 2, 3814},
	{21456, 167084, 18, 4434},
	{21471, 167088, 6, 1594},
	{21488, 167092, 9, 1602},
	{21510, 167096},
	{21526, 167100, 1, 1614},
	{21548, 167104},
	{21564, 167108, 1, 1571},
	{21586, 167112},
	{21608, 167116},
	{21630, 167120},
	{21649, 167128},
	{21664, 167132, 2, 1569},
	{21680, 167136, 1, 1571},
	{21696, 167140, 2, 3814},
	{21711, 167144, 18, 4434},
	{21726, 167148, 6, 1594},
	{21743, 167152, 9, 1602},
	{21765, 167156},
	{21781, 167160, 1, 1614},
	{21803, 167164},
	{21819, 167168, 1, 1571},
	{21841, 167172},
	{21863, 167176},
	{21885, 167180},
	{21904, 167188},
	{21919, 167192, 2, 1569},
	{21935, 167196, 1, 1571},
	{21951, 167200, 2, 3814},
	{21966, 167204, 18, 4434},
	{21981, 167208, 6, 1594},
	{21998, 167212, 9, 1602},
	{22020, 167216},
	{22036, 167220, 1, 1614},
	{22058, 167224},
	{22074, 167228, 1, 1571},
	{22096, 167232},
	{22118, 167236},
	{22140, 167240},
	{22159, 167248},
	{22174, 167252, 2, 1569},
	{22190, 167256, 1, 1571},
	{22206, 167260, 2, 3814},
	{22221, 167264, 18, 4434},
	{22236, 167268, 6, 1594},
	{22253, 167272, 9, 1602},
	{22275, 167276},
	{22291, 167280, 1, 1614},
	{22313, 167284},
	{22329, 167288, 1, 1571},
	{22351, 167292},
	{22373, 167296},
	{22395, 167300},
	{22414, 167308},
	{22429, 167312, 2, 1569},
	{22445, 167316, 1, 1571},
	{22461, 167320, 2, 3814},
	{22476, 167324, 18, 4434},
	{22491, 167328, 6, 1594},
	{22508, 167332, 9, 1602},
	{22530, 167336},
	{22546, 167340, 1, 1614},
	{22568, 167344},
	{22584, 167348, 1, 1571},
	{22606, 167352},
	{22628, 167356},
	{22650, 167360},
	{22669, 167368},
	{22684, 167372, 2, 1569},
	{22700, 167376, 1, 1571},
	{22716, 167380, 2, 3814},
	{22731, 167384, 18, 4434},
	{22746, 167388, 6, 1594},
	{22763, 167392, 9, 1602},
	{22785, 167396},
	{22801, 167400, 1, 1614},
	{22823, 167404},
	{22839, 167408, 1, 1571},
	{22861, 167412},
	{22883, 167416},
	{22905, 167420},
	{22924, 167428},
	{22939, 167432, 2, 1569},
	{22955, 167436, 1, 1571},
	{22971, 167440, 2, 3814},
	{22986, 167444, 18, 4434},
	{23001, 167448, 6, 1594},
	{23018, 167452, 9, 1602},
	{23040, 167456},
	{23056, 167460, 1, 1614},
	{23078, 167464},
	{23094, 167468, 1, 1571},
	{23116, 167472},
	{23138, 167476},
	{23160, 167480},
	{24203, 196608, 1, 1627},
	{24223, 196612, 1, 1628},
	{24243, 196616},
	{24263, 196620},
	{24283, 196624},
	{24304, 196628},
	{24325, 196632, 1, 1629},
	{24347, 196636, 1, 1630},
	{24369, 196640},
	{24399, 196644},
	{24429, 196648},
	{24458, 196652},
	{24487, 196656},
	{24517, 196660},
	{24547, 196664},
	{24576, 196668},
	{24605, 196672},
	{24635, 196676},
	{24665, 196680},
	{24694, 196684},
	{24723, 196688},
	{24753, 196692},
	{24783, 196696},
	{24812, 196700},
	{24841, 196704, 1, 1631},
	{24863, 196708, 1, 1632},
	{24885, 196712},
	{24908, 196716},
	{24931, 196720},
	{24954, 196724},
	{24977, 196728},
	{25000, 196732},
	{25023, 196736},
	{25047, 196740},
	{25071, 196744},
	{25095, 196748},
	{25119, 196752},
	{25143, 196756},
	{25167, 196760},
	{25191, 196764},
	{25215, 196768},
	{25237, 196772},
	{25259, 196776},
	{25280, 196780},
	{25301, 196784},
	{25325, 196788},
	{25349, 196792},
	{25373, 196796},
	{25397, 196800},
	{25421, 196804},
	{25505, 196852, 2, 4452},
	{25527, 196856, 2, 4452},
	{25549, 196860, 1, 1635},
	{25565, 196864},
	{25578, 196868},
	{25591, 196872},
	{25604, 196876},
	{25617, 196880},
	{25630, 196884},
	{25643, 196888},
	{25656, 196892},
	{25783, 196928, 2, 1636},
	{25796, 196932},
	{25809, 196936},
	{25832, 196940},
	{25855, 196944},
	{25883, 196948},
	{25911, 196952},
	{25939, 196956},
	{25967, 196960, 1, 1638},
	{25985, 196964, 5, 4454},
	{26003, 196968},
	{26018, 196972},
	{26042, 196976},
	{26066, 196980},
	{26085, 196984},
	{26104, 196988},
	{26128, 196992},
	{26152, 196996},
	{26176, 197000},
	{26200, 197028, 2, 3040},
	{26218, 197032, 3, 4459},
	{26236, 197036},
	{26254, 197040},
	{26272, 197044, 2, 3043},
	{26290, 197048, 3, 4462},
	{26308, 197052},
	{26326, 197056, 2, 1649},
	{26345, 197060, 5, 1651},
	{26364, 197072},
	{26388, 197076, 2, 1649},
	{26408, 197080, 5, 1651},
	{26428, 197084, 8, 4465},
	{26447, 197088, 8, 4465},
	{26465, 197092, 1, 1663},
	{26482, 197100, 1, 1664},
	{26503, 197104, 26, 4473},
	{26517, 197108},
	{26531, 197112},
	{26545, 197116, 4, 3074},
	{26561, 197120},
	{26580, 197124, 1, 1680},
	{26602, 197128},
	{26621, 197132, 1, 1681},
	{26643, 197136, 9, 3080},
	{26661, 197140},
	{26681, 197144, 1, 1680},
	{26704, 197148},
	{26724, 197152, 1, 1681},
	{26747, 197156, 9, 3080},
	{26766, 197160, 5, 3089},
	{26778, 197164, 2, 1696},
	{26795, 197168, 1, 1698},
	{26812, 197172, 1, 1699},
	{26830, 197176, 4, 1700},
	{26850, 197180, 1, 1704},
	{26867, 197184},
	{26883, 197188, 1, 1706},
	{26896, 197192, 1, 1707},
	{26910, 197196, 1, 1708},
	{26924, 197200, 1, 1709},
	{26946, 197204, 1, 1710},
	{26966, 197208, 1, 1711},
	{26988, 197212, 1, 1712},
	{27008, 197216, 1, 1707},
	{27025, 197220, 1, 1708},
	{27042, 197224},
	{52837, 197228, 1, 1706},
	{27301, 197388, 1, 1721},
	{27320, 197392, 1, 1722},
	{27339, 197396, 1, 1723},
	{27356, 197400, 1, 1724},
	{27374, 197404, 1, 1725},
	{27392, 197408, 1, 1726},
	{27408, 197412, 1, 1727},
	{27426, 197416, 1, 1728},
	{27444, 197420, 1, 1729},
	{27460, 197424, 1, 1724},
	{27475, 197428, 1, 1725},
	{27490, 197432, 1, 1726},
	{27503, 197436, 1, 1727},
	{27518, 197440, 1, 1728},
	{27533, 197444, 1, 1729},
	{27546, 197448, 1, 1730},
	{27560, 197452, 1, 1731},
	{27574, 197456, 1, 1732},
	{27586, 197460, 4, 4499},
	{27609, 197464, 4, 4092},
	{27631, 197468, 1, 1740},
	{27775, 197552, 1, 1745},
	{27800, 197556, 1, 1745},
	{27824, 197560, 1, 1746},
	{27844, 197568},
	{27870, 197572, 1, 1628},
	{27899, 197576},
	{27924, 197580, 1, 1628},
	{27952, 197584},
	{27975, 197588, 1, 1628},
	{28001, 197592},
	{28023, 197596, 1, 1628},
	{28048, 197600},
	{28067, 197604, 1, 1628},
	{28089, 197608, 1, 1343},
	{28103, 197612},
	{28120, 197616, 1, 1628},
	{28140, 197620, 8, 1747},
	{28309, 198656, 6, 2946},
	{48507, 198912},
	{48526, 198916},
	{28370, 198920, 1, 3329},
	{28389, 198924, 1, 1343},
	{28404, 198928},
	{28437, 198932},
	{28470, 198936},
	{28503, 198940},
	{28593, 198960},
	{28609, 198964},
	{49020, 198968, 1, 1785},
	{49052, 198972, 2, 1786},
	{49073, 198976},
	{29013, 199168, 1, 1809},
	{29038, 199172, 2, 1810},
	{29063, 199184, 2, 1812},
	{29089, 199188, 2, 1812},
	{29115, 199192, 2, 1812},
	{29141, 199212, 2, 1812},
	{29167, 199296, 2, 1814},
	{29195, 199300, 1, 1816},
	{29219, 199304, 1, 1817},
	{29243, 199308, 1, 1818},
	{29276, 199312, 1, 1818},
	{29304, 199328, 2, 1814},
	{29333, 199332, 1, 1816},
	{29358, 199336, 1, 1817},
	{29383, 199340, 1, 1818},
	{29417, 199344, 1, 1818},
	{29446, 199360, 2, 1814},
	{29470, 199364, 1, 1816},
	{29490, 199368, 1, 1817},
	{29510, 199372, 1, 1818},
	{29539, 199376, 1, 1818},
	{49639, 199872},
	{49660, 199876, 1, 3506},
	{2095, 199880, 8, 4060},
	{2116, 199884, 3, 3515},
	{49681, 199888, 2, 3518},
	{2143, 199892, 1, 3542},
	{49707, 199896, 15, 3527},
	{50710, 199900, 1, 4069},
	{50732, 199904},
	{2074, 199908, 2, 3520},
	{2164, 199912, 5, 4072},
	{49749, 199916, 1, 3543},
	{29563, 199936},
	{29590, 199940},
	{29617, 199944},
	{29644, 199948},
	{29779, 199968, 6, 1819},
	{29790, 199972, 2, 1826},
	{29804, 200192},
	{29823, 200196, 1, 840},
	{29845, 200448},
	{29869, 200452, 1, 1828},
	{29892, 200456},
	{29916, 200460, 1, 1828},
	{29939, 200464},
	{29963, 200468, 1, 1828},
	{29986, 200472},
	{30010, 200476, 1, 1828},
	{30033, 200696},
	{30052, 200700, 1, 1828},
	{30070, 200704},
	{30082, 200708},
	{30094, 200712},
	{30112, 200716},
	{30131, 200720},
	{30149, 200724},
	{30161, 200728},
	{30173, 200732},
	{30191, 200736},
	{30209, 200740},
	{30228, 200744, 4, 1829},
	{30242, 200748, 2, 1833},
	{30260, 200752, 2, 1835},
	{30274, 200756, 2, 1837},
	{30288, 200760, 2, 1839},
	{30305, 200764, 2, 1841},
	{30322, 200768},
	{30335, 200772, 2, 1843},
	{30347, 200776},
	{30361, 200780},
	{30377, 200784},
	{30391, 200788},
	{30407, 200792},
	{30422, 200796},
	{30439, 200800},
	{30454, 200804},
	{30471, 200808, 2, 1845},
	{30493, 200812, 9, 4100},
	{30510, 200816, 2, 1857},
	{30531, 200820, 2, 1859},
	{30543, 200824},
	{30558, 200828, 6, 4503},
	{30573, 200832, 2, 1867},
	{30587, 200836},
	{30700, 212992},
	{30720, 212996},
	{30740, 213000},
	{30760, 213004},
	{30780, 213008},
	{30800, 213012},
	{30820, 213016},
	{30840, 213020},
	{30860, 213024},
	{30880, 213028},
	{30900, 213032},
	{30920, 213036},
	{31009, 213248},
	{31030, 213252},
	{31051, 213260},
	{31072, 213264},
	{31093, 213268},
	{31117, 213272},
	{31141, 213276},
	{31165, 213280},
	{31189, 213284},
	{31213, 213288},
	{31237, 213292},
	{31261, 213296},
	{50822, 213504},
	{50841, 213508},
	{50860, 213512},
	{50879, 213516},
	{50898, 213520},
	{50917, 213524},
	{50936, 213528},
	{50955, 213532},
	{48217, 213536},
	{48236, 213540},
	{48255, 213544},
	{48274, 213548},
	{48293, 213552},
	{48312, 213556},
	{48331, 213560},
	{48350, 213564},
	{48808, 213568},
	{48828, 213572},
	{48848, 213576},
	{48868, 213580},
	{48888, 213584},
	{48908, 213588},
	{48928, 213592},
	{48948, 213596},
	{31745, 214016},
	{31767, 214020, 1, 1869},
	{31789, 214024},
	{31811, 214028, 1, 1869},
	{31833, 214032},
	{31855, 214036, 1, 1869},
	{31877, 214040},
	{31899, 214044, 1, 1869},
	{31921, 214272},
	{31943, 214276},
	{31965, 214280},
	{31987, 214284},
	{32009, 214288},
	{32031, 214292},
	{32053, 214296},
	{32075, 214300},
	{32097, 214304},
	{32119, 214308},
	{32141, 214312},
	{32163, 214316},
	{32185, 214320},
	{32207, 214324},
	{32229, 214328},
	{32251, 214332},
	{32273, 214528},
	{32293, 214532},
	{32313, 214536},
	{32333, 214540},
	{32353, 214544},
	{32373, 214548},
	{32393, 214552},
	{32413, 214556},
	{32433, 214560},
	{32453, 214564},
	{32473, 214568},
	{32493, 214572},
	{32513, 214784},
	{32532, 214788},
	{32551, 214792},
	{32570, 214796},
	{32589, 214800},
	{32608, 214804},
	{32627, 214808},
	{32646, 214812},
	{32665, 214816},
	{32684, 214820},
	{32703, 214824},
	{32722, 214828},
	{32741, 214832},
	{32760, 214836},
	{32779, 214840},
	{32798, 214844},
	{32817, 214848},
	{32836, 214852},
	{32855, 214856},
	{32874, 214860},
	{32893, 214864},
	{32913, 214868},
	{32933, 214872},
	{32953, 214876},
	{32973, 214880},
	{32993, 214884},
	{33013, 214888},
	{33033, 214892},
	{33053, 214896},
	{33073, 214900},
	{33093, 214904},
	{33113, 214908},
	{33133, 215296},
	{33152, 215300},
	{33171, 215304},
	{33190, 215308},
	{33209, 215312},
	{33228, 215316},
	{33247, 215320},
	{33266, 215324},
	{33327, 215552},
	{33347, 215556},
	{33367, 215560},
	{33387, 215564},
	{33407, 215568},
	{33427, 215572},
	{33447, 215576},
	{33467, 215580},
	{33487, 215808},
	{33506, 215812},
	{33525, 215816},
	{33544, 215820},
	{33563, 216064},
	{33582, 216068},
	{33601, 216072},
	{33620, 216076},
	{33639, 216320},
	{33659, 216324},
	{33679, 216328},
	{33699, 216332},
	{33719, 216336},
	{33739, 216340},
	{33759, 216344},
	{33779, 216348},
	{50974, 216576},
	{50994, 216580},
	{51014, 216584},
	{51034, 216588},
	{51054, 216592},
	{51074, 216596},
	{51094, 216600},
	{51114, 216604},
	{51134, 216640},
	{51154, 216644},
	{51174, 216648},
	{51194, 216652},
	{51214, 216656},
	{51234, 216660},
	{51254, 216664},
	{51274, 216668},
	{34631, 217112},
	{34650, 217116},
	{34669, 217120},
	{34688, 217124},
	{34707, 217128},
	{34726, 217132},
	{34745, 217136},
	{34764, 217140},
	{34783, 217344},
	{34802, 217348},
	{34821, 217352},
	{34840, 217356},
	{34859, 217360},
	{34878, 217364},
	{34897, 217368},
	{34916, 217372},
	{34935, 217600},
	{34955, 217604},
	{34975, 217608},
	{34995, 217612},
	{36317, 221184, 1, 1903},
	{36341, 221188, 2, 4109},
	{36366, 221192, 3, 4111},
	{36390, 221196, 1, 1903},
	{36414, 221200, 2, 4109},
	{36439, 221204, 1, 1903},
	{36463, 221208, 2, 4109},
	{36488, 221212, 3, 4111},
	{36512, 221216, 4, 1881},
	{36528, 221220, 3, 4111},
	{36695, 221248},
	{36710, 221252, 1, 1818},
	{36733, 221256},
	{36756, 221260},
	{36774, 221264, 2, 1897},
	{36792, 221268, 4, 1899},
	{36812, 221440, 19, 2989},
	{36837, 221444, 19, 2989},
	{36862, 221448, 12, 3008},
	{36890, 221452, 12, 3008},
	{36918, 221456, 12, 3008},
	{36946, 221460, 12, 3008},
	{51454, 221696, 2, 3287},
	{51477, 221700, 2, 3287},
	{51500, 221704, 2, 3287},
	{51523, 221708, 2, 3287},
	{48125, 221712, 5, 1957},
	{48148, 221716, 2, 3287},
	{48171, 221720, 2, 3287},
	{48194, 221724, 2, 3287},
	{51546, 221728, 4, 1962},
	{48712, 221744, 5, 1957},
	{48736, 221748, 5, 1957},
	{48760, 221752, 2, 3287},
	{48784, 221756, 2, 3287},
	{51570, 221760, 4, 1962},
	{51595, 221764, 4, 1962},
	{48686, 221776, 1, 3328},
	{37404, 222208, 3, 1957},
	{37430, 222212, 2, 1877},
	{37457, 222216, 3, 1957},
	{37483, 222220, 2, 1877},
	{37510, 222224, 2, 2013},
	{37563, 222228, 2, 2013},
	{37616, 222464, 3, 1957},
	{37642, 222468, 2, 1877},
	{37669, 222472, 1, 1872},
	{37695, 222476, 1, 1872},
	{37721, 222480, 1, 1872},
	{37747, 222484, 1, 1872},
	{37773, 222488, 1, 1872},
	{37799, 222492, 1, 1872},
	{37825, 222496, 1, 1872},
	{37851, 222720, 3, 1957},
	{37875, 222724, 3, 1957},
	{37899, 222728, 3, 1957},
	{37923, 222732, 3, 1957},
	{37947, 222736, 2, 1877},
	{37972, 222740, 2, 1877},
	{37997, 222744, 2, 1877},
	{38022, 222748, 2, 1877},
	{38047, 222752, 1, 2001},
	{38071, 222756, 1, 2001},
	{38095, 222760, 8, 1966},
	{38116, 222976, 6, 3486},
	{38139, 222980, 6, 3486},
	{38162, 222984, 6, 3486},
	{38185, 222988, 6, 3486},
	{38208, 222992, 6, 3486},
	{38231, 222996, 6, 3486},
	{38254, 223000, 6, 3486},
	{38277, 223004, 6, 3486},
	{38300, 223008, 6, 3486},
	{38323, 223012, 6, 3486},
	{38346, 223016, 6, 3486},
	{38370, 223020, 6, 3486},
	{38394, 223024, 6, 3486},
	{38418, 223028, 6, 3486},
	{38442, 223032, 6, 3486},
	{38466, 223036, 6, 3486},
	{38490, 223104, 9, 3469},
	{51620, 223108, 2, 3518},
	{38510, 223112, 1, 1987},
	{38605, 223488, 3, 1996},
	{38628, 223492, 3, 1996},
	{38651, 223496, 3, 1996},
	{38674, 223500, 3, 1996},
	{38697, 223504, 2, 1999},
	{38721, 223508, 2, 1999},
	{38745, 223744, 3, 1996},
	{38769, 223748, 3, 1996},
	{38793, 223752, 3, 1996},
	{38817, 223756, 3, 1996},
	{38841, 223760, 2, 1999},
	{38866, 224000, 5, 2001},
	{38889, 224004, 4, 2006},
	{38913, 224008, 5, 2001},
	{38936, 224256, 5, 2001},
	{38959, 224260, 4, 2006},
	{38983, 224264, 5, 2001},
	{39006, 224512, 5, 1957},
	{39030, 224516, 4, 1962},
	{39055, 224520, 5, 1957},
	{39079, 224524, 4, 1962},
	{39104, 224528, 3, 2013},
	{39128, 224532, 3, 2013},
	{51640, 224768, 5, 1957},
	{51664, 224772, 4, 1951},
	{51689, 224776, 5, 1957},
	{51713, 224780, 4, 1951},
	{51738, 224784, 3, 2013},
	{51762, 224788, 3, 2013},
	{51786, 224832, 5, 1957},
	{51810, 224836, 4, 1951},
	{51835, 224840, 5, 1957},
	{51859, 224844, 4, 1951},
	{51884, 224848, 3, 2013},
	{51908, 224852, 3, 2013},
	{39829, 225280, 12, 2016},
	{39851, 225284, 5, 2028},
	{39874, 225288, 4, 2033},
	{39898, 225292, 2, 2037},
	{39921, 225296, 2, 2037},
	{39944, 225300, 2, 2037},
	{39967, 225536, 5, 1957},
	{39990, 225540, 4, 1962},
	{40014, 225544, 5, 1957},
	{40037, 225548, 4, 1962},
	{40061, 225552, 5, 1957},
	{40084, 225560, 5, 1957},
	{40107, 225792, 4, 2039},
	{40128, 225796},
	{40157, 225800, 2, 2043},
	{40186, 225804},
	{40212, 225808, 7, 2045},
	{40286, 225812},
	{40309, 225816},
	{52053, 225820, 2, 4120},
	{52086, 225824, 2, 4120},
	{52119, 225828, 2, 4120},
	{52152, 225832, 2, 4120},
	{52184, 225836, 2, 4120},
	{52216, 225840, 2, 4120},
	{52248, 225844, 2, 4120},
	{52281, 225848, 2, 4120},
	{52313, 225856, 2, 4120},
	{52345, 225860, 2, 4120},
	{52378, 225864, 2, 4120},
	{52411, 225868, 2, 4120},
	{52444, 225872, 2, 4120},
	{52476, 225876, 2, 4120},
	{52508, 225880, 2, 4120},
	{52541, 225884, 2, 4120},
	{52574, 225888, 2, 4120},
	{52640, 225896, 2, 4120},
	{40332, 225900},
	{40359, 225904},
	{40241, 225908},
	{40260, 225912},
	{52672, 225916, 2, 4120},
	{52706, 225920, 2, 4120},
	{52740, 225924, 2, 4120},
	{52774, 225928, 2, 4120},
	{41229, 226044, 1, 2129},
	{41022, 226048, 2, 2119},
	{41039, 226052, 1, 2121},
	{41063, 226056, 1, 2121},
	{195, 880, 4, 2156},
	{42808, 881},
	{26631, 882},
	{42820, 1008},
	{42831, 1009},
	{26819, 1010, 3, 2160},
	{42842, 1040, 1, 2163},
	{42855, 1041, 5, 4122},
	{42868, 1042, 1, 2169},
	{42881, 1043, 1, 1681},
	{26653, 1045, 9, 3914},
	{42909, 1280, 6, 4127},
	{42924, 1281},
	{26590, 1282},
	{42808, 1283},
	{26631, 1284},
};

static const struct si_reg gfx81_reg_table[] = {
	{974, 68, 10, 4133},
	{987, 72, 23, 4143},
	{1002, 76, 4, 4166},
	{46947, 80, 11, 3939},
	{1039, 84, 4, 2800},
	{1057, 88, 2, 2804},
	{1075, 92, 6, 4170},
	{1090, 96},
	{1104, 100, 1, 70},
	{1118, 104},
	{46961, 108},
	{46978, 112, 13, 4176},
	{1135, 116, 5, 4189},
	{46994, 2480},
	{47009, 2484, 1, 2824},
	{47024, 2488},
	{47039, 2492, 1, 2824},
	{1273, 2496},
	{1287, 2500},
	{1301, 2504},
	{1315, 2508},
	{1329, 2512},
	{1343, 2516},
	{1357, 2520},
	{1371, 2524},
	{1385, 2528},
	{1399, 2532},
	{1413, 2536},
	{1428, 2540},
	{1503, 2544},
	{1514, 2552},
	{1530, 2556},
	{47054, 3660, 21, 2825},
	{47067, 3664, 20, 2846},
	{47079, 3668, 16, 2866},
	{1618, 32776, 18, 4194},
	{1631, 32784, 24, 2904},
	{1643, 32788, 11, 2928},
	{1659, 32792, 11, 2928},
	{1688, 32824, 11, 2928},
	{1704, 32828, 11, 2928},
	{1720, 33296, 15, 4212},
	{1734, 33300, 28, 204},
	{1751, 33304, 14, 4227},
	{1772, 33308, 21, 4241},
	{1786, 33312, 31, 4022},
	{1803, 33316, 9, 4262},
	{1842, 33324, 1, 329},
	{1865, 33344, 1, 330},
	{1886, 33348},
	{1947, 33436, 1, 342},
	{49728, 36416},
	{2351, 36608},
	{2369, 36612, 4, 383},
	{2387, 36616},
	{2405, 36620, 14, 4271},
	{3306, 36624},
	{3324, 36628, 5, 4509},
	{3342, 36632, 4, 3587},
	{3360, 36636, 11, 3591},
	{3378, 36640, 2, 3602},
	{3396, 36644, 2, 3604},
	{3414, 36648, 8, 4290},
	{3432, 36652},
	{2423, 36656, 14, 4298},
	{2441, 36660, 4, 411},
	{2459, 36664, 10, 4312},
	{2477, 36668, 3, 3632},
	{2495, 37120, 6, 429},
	{2511, 39160, 9, 3635},
	{2526, 39184, 5, 3645},
	{2540, 39188, 5, 3645},
	{2554, 39192, 5, 3645},
	{2568, 39196, 5, 3645},
	{2582, 39200, 5, 3645},
	{2596, 39204, 5, 3645},
	{2610, 39208, 5, 3645},
	{2624, 39212, 5, 3645},
	{2638, 39216, 5, 3645},
	{2652, 39220, 5, 3645},
	{2666, 39224, 5, 3645},
	{2681, 39228, 5, 3645},
	{2696, 39232, 5, 3645},
	{2711, 39236, 5, 3645},
	{2726, 39240, 5, 3645},
	{2741, 39244, 5, 3645},
	{2756, 39248, 5, 3645},
	{2771, 39252, 5, 3645},
	{2786, 39256, 5, 3645},
	{2801, 39260, 5, 3645},
	{2816, 39264, 5, 3645},
	{2831, 39268, 5, 3645},
	{2846, 39272, 5, 3645},
	{2861, 39276, 5, 3645},
	{2876, 39280, 5, 3645},
	{2891, 39284, 5, 3645},
	{2906, 39288, 5, 3645},
	{2921, 39292, 5, 3645},
	{2936, 39296, 5, 3645},
	{2951, 39300, 5, 3645},
	{2966, 39304, 5, 3645},
	{2981, 39308, 5, 3645},
	{2996, 39312, 4, 448},
	{3015, 39316, 4, 448},
	{3034, 39320, 4, 448},
	{3053, 39324, 4, 448},
	{3072, 39328, 4, 448},
	{3091, 39332, 4, 448},
	{3110, 39336, 4, 448},
	{3129, 39340, 4, 448},
	{3148, 39344, 4, 448},
	{3167, 39348, 4, 448},
	{3186, 39352, 4, 448},
	{3206, 39356, 4, 448},
	{3226, 39360, 4, 448},
	{3246, 39364, 4, 448},
	{3266, 39368, 4, 448},
	{3286, 39372, 4, 448},
	{49962, 45056},
	{49983, 45060, 1, 491},
	{50004, 45064},
	{50025, 45068, 1, 491},
	{3499, 45084, 3, 488},
	{3523, 45088},
	{3544, 45092, 1, 491},
	{3565, 45096, 11, 3650},
	{3589, 45100, 6, 503},
	{3613, 45104},
	{3639, 45108},
	{3665, 45112},
	{3691, 45116},
	{3717, 45120},
	{3743, 45124},
	{3769, 45128},
	{3795, 45132},
	{3821, 45136},
	{3847, 45140},
	{3873, 45144},
	{3900, 45148},
	{3927, 45152},
	{3954, 45156},
	{3981, 45160},
	{4008, 45164},
	{50046, 45312},
	{50067, 45316, 1, 491},
	{50088, 45320},
	{50109, 45324, 1, 491},
	{4680, 45336, 3, 488},
	{4704, 45340, 1, 527},
	{4729, 45344},
	{4750, 45348, 1, 491},
	{4771, 45352, 12, 3667},
	{4795, 45356, 11, 4322},
	{4819, 45360},
	{4845, 45364},
	{4871, 45368},
	{4897, 45372},
	{4923, 45376},
	{4949, 45380},
	{4975, 45384},
	{5001, 45388},
	{5027, 45392},
	{5053, 45396},
	{5079, 45400},
	{5106, 45404},
	{5133, 45408},
	{5160, 45412},
	{5187, 45416},
	{5214, 45420},
	{5864, 45552, 6, 563},
	{5891, 45556, 5, 569},
	{50130, 45568},
	{50151, 45572, 1, 491},
	{50172, 45576},
	{50193, 45580, 1, 491},
	{6079, 45596, 4, 576},
	{6103, 45600},
	{6124, 45604, 1, 491},
	{6145, 45608, 11, 3689},
	{6169, 45612, 4, 554},
	{6193, 45616},
	{6219, 45620},
	{6245, 45624},
	{6271, 45628},
	{6297, 45632},
	{6323, 45636},
	{6349, 45640},
	{6375, 45644},
	{6401, 45648},
	{6427, 45652},
	{6453, 45656},
	{6480, 45660},
	{6507, 45664},
	{6534, 45668},
	{6561, 45672},
	{6588, 45676},
	{7223, 45808, 6, 563},
	{50214, 45824},
	{50235, 45828, 1, 491},
	{50256, 45832},
	{50277, 45836, 1, 491},
	{7250, 45852, 4, 576},
	{7274, 45856},
	{7295, 45860, 1, 491},
	{7316, 45864, 12, 3667},
	{7340, 45868, 6, 563},
	{7364, 45872},
	{7390, 45876},
	{7416, 45880},
	{7442, 45884},
	{7468, 45888},
	{7494, 45892},
	{7520, 45896},
	{7546, 45900},
	{7572, 45904},
	{7598, 45908},
	{7624, 45912},
	{7651, 45916},
	{7678, 45920},
	{7705, 45924},
	{7732, 45928},
	{7759, 45932},
	{7786, 46068, 5, 569},
	{50298, 46080},
	{50319, 46084, 1, 491},
	{50340, 46088},
	{50361, 46092, 1, 491},
	{7974, 46108, 3, 612},
	{7998, 46112},
	{8019, 46116, 1, 491},
	{8040, 46120, 10, 3710},
	{8064, 46124, 6, 628},
	{8088, 46128},
	{8114, 46132},
	{8140, 46136},
	{8166, 46140},
	{8192, 46144},
	{8218, 46148},
	{8244, 46152},
	{8270, 46156},
	{8296, 46160},
	{8322, 46164},
	{8348, 46168},
	{8375, 46172},
	{8402, 46176},
	{8429, 46180},
	{8456, 46184},
	{8483, 46188},
	{9118, 46324, 5, 569},
	{50382, 46336},
	{50403, 46340, 1, 491},
	{50424, 46344},
	{50445, 46348, 1, 491},
	{9145, 46364, 4, 576},
	{9169, 46368},
	{9190, 46372, 1, 491},
	{9211, 46376, 11, 3726},
	{9235, 46380, 5, 569},
	{9259, 46384},
	{9285, 46388},
	{9311, 46392},
	{9337, 46396},
	{9363, 46400},
	{9389, 46404},
	{9415, 46408},
	{9441, 46412},
	{9467, 46416},
	{9493, 46420},
	{9519, 46424},
	{9546, 46428},
	{9573, 46432},
	{9600, 46436},
	{9627, 46440},
	{9654, 46444},
	{9681, 47104, 12, 3742},
	{9708, 47108},
	{9722, 47112},
	{9736, 47116},
	{9750, 47120},
	{9766, 47124},
	{9782, 47128},
	{9798, 47132, 2, 659},
	{9819, 47136, 2, 659},
	{9840, 47140, 2, 659},
	{9861, 47144, 1, 661},
	{9889, 47148, 1, 662},
	{9914, 47152},
	{9929, 47156, 2, 3755},
	{50486, 47160},
	{50501, 47164, 1, 663},
	{50516, 47168},
	{50531, 47172, 1, 663},
	{10068, 47176, 10, 3757},
	{10086, 47180, 11, 676},
	{10104, 47184, 1, 687},
	{10117, 47188, 6, 688},
	{50546, 47192, 2, 3774},
	{50577, 47196, 2, 3774},
	{10195, 47200, 2, 694},
	{50760, 47204, 2, 3774},
	{50791, 47208, 2, 3774},
	{10270, 47212},
	{10288, 47216},
	{10306, 47220},
	{10324, 47224, 1, 696},
	{10352, 47228, 5, 697},
	{10374, 47232},
	{10394, 47236},
	{10577, 47240, 3, 713},
	{10594, 47244},
	{10623, 47248, 1, 716},
	{52808, 47252, 2, 4333},
	{10670, 47360},
	{10690, 47364},
	{10710, 47368},
	{10730, 47372},
	{10750, 47376},
	{10770, 47380},
	{10790, 47384},
	{10810, 47388},
	{10830, 47392},
	{10850, 47396},
	{10870, 47400},
	{10891, 47404},
	{10912, 47408},
	{10933, 47412},
	{10954, 47416},
	{10975, 47420},
	{11041, 47612},
	{50608, 53300, 29, 3776},
	{50625, 55348, 29, 3776},
	{11057, 163840, 10, 719},
	{11075, 163844, 9, 3805},
	{11092, 163848, 4, 3814},
	{11106, 163852, 23, 747},
	{11125, 163856, 15, 770},
	{11145, 163860},
	{11181, 163872},
	{11201, 163876},
	{11221, 163880, 1, 788},
	{11238, 163884},
	{11253, 163888, 2, 789},
	{11277, 163892, 2, 791},
	{50642, 163900, 7, 3818},
	{11335, 163904, 10, 4335},
	{11345, 163908, 6, 4345},
	{11361, 163912},
	{11376, 163916},
	{11397, 163920},
	{11413, 163924},
	{50656, 163928, 2, 3838},
	{50670, 163932, 1, 3840},
	{11603, 163968},
	{11619, 163972, 1, 840},
	{11638, 164328, 1, 841},
	{11659, 164332, 1, 841},
	{11680, 164336, 1, 841},
	{11701, 164340, 1, 841},
	{11722, 164344},
	{11740, 164348},
	{11758, 164352, 2, 842},
	{11778, 164356, 3, 844},
	{11802, 164360, 2, 847},
	{11826, 164364, 1, 849},
	{11846, 164368, 2, 844},
	{11866, 164372, 2, 847},
	{11886, 164376, 2, 844},
	{11906, 164380, 2, 847},
	{11926, 164384, 2, 844},
	{11946, 164388, 2, 847},
	{11966, 164392, 2, 844},
	{11986, 164396, 2, 847},
	{12006, 164400, 7, 850},
	{12021, 164404, 2, 857},
	{12050, 164408, 8, 859},
	{12065, 164412, 8, 867},
	{12080, 164416, 3, 844},
	{12105, 164420, 2, 847},
	{12130, 164424},
	{12148, 164428},
	{12166, 164432, 3, 844},
	{12191, 164436, 2, 847},
	{12216, 164440, 3, 844},
	{12241, 164444, 2, 847},
	{12266, 164448, 3, 844},
	{12291, 164452, 2, 847},
	{12316, 164456, 3, 844},
	{12341, 164460, 2, 847},
	{12366, 164464, 3, 844},
	{12391, 164468, 2, 847},
	{12416, 164472, 3, 844},
	{12441, 164476, 2, 847},
	{12466, 164480, 3, 844},
	{12491, 164484, 2, 847},
	{12516, 164488, 3, 844},
	{12541, 164492, 2, 847},
	{12566, 164496, 3, 844},
	{12591, 164500, 2, 847},
	{12616, 164504, 3, 844},
	{12641, 164508, 2, 847},
	{12666, 164512, 3, 844},
	{12692, 164516, 2, 847},
	{12718, 164520, 3, 844},
	{12744, 164524, 2, 847},
	{12770, 164528, 3, 844},
	{12796, 164532, 2, 847},
	{12822, 164536, 3, 844},
	{12848, 164540, 2, 847},
	{12874, 164544, 3, 844},
	{12900, 164548, 2, 847},
	{12926, 164552, 3, 844},
	{12952, 164556, 2, 847},
	{12978, 164560},
	{12997, 164564},
	{13016, 164568},
	{13035, 164572},
	{13054, 164576},
	{13073, 164580},
	{13092, 164584},
	{13111, 164588},
	{13130, 164592},
	{13149, 164596},
	{13168, 164600},
	{13187, 164604},
	{13206, 164608},
	{13225, 164612},
	{13244, 164616},
	{13263, 164620},
	{13282, 164624},
	{13301, 164628},
	{13320, 164632},
	{13339, 164636},
	{13358, 164640},
	{13378, 164644},
	{13398, 164648},
	{13418, 164652},
	{13438, 164656},
	{13458, 164660},
	{13478, 164664},
	{13498, 164668},
	{13518, 164672},
	{13538, 164676},
	{13558, 164680},
	{13578, 164684},
	{13598, 164688, 15, 875},
	{13618, 164692, 3, 890},
	{13640, 164696, 2, 893},
	{13697, 164704, 1, 902},
	{50685, 164708, 1, 3841},
	{13728, 164712, 1, 904},
	{13796, 164864},
	{13813, 164868},
	{13830, 164872},
	{13846, 164876},
	{13900, 164884},
	{13913, 164888},
	{13928, 164892},
	{13942, 164896},
	{13957, 164900, 3, 4351},
	{13996, 164908, 6, 935},
	{14015, 164912, 4, 941},
	{14033, 164916, 4, 945},
	{14054, 164924},
	{14073, 164928},
	{14093, 164932},
	{14112, 164936},
	{14132, 164940},
	{14151, 164944},
	{14171, 164948},
	{14192, 164952},
	{14214, 164956},
	{14235, 164960},
	{14257, 164964},
	{14278, 164968},
	{14300, 164972},
	{14321, 164976},
	{14343, 164980},
	{14364, 164984},
	{14386, 164988},
	{14407, 164992},
	{14429, 164996},
	{14450, 165000},
	{14472, 165004},
	{14493, 165008},
	{14515, 165012},
	{14536, 165016},
	{14558, 165020},
	{14579, 165024},
	{14601, 165028},
	{14622, 165032},
	{14644, 165036},
	{14665, 165040},
	{14687, 165044},
	{14708, 165048},
	{14730, 165052},
	{14751, 165056},
	{14773, 165060},
	{14794, 165064},
	{14816, 165068},
	{14837, 165072},
	{14859, 165076},
	{14880, 165080},
	{14902, 165084},
	{14923, 165088},
	{14945, 165092},
	{14966, 165096},
	{14988, 165100},
	{15009, 165104},
	{15031, 165108},
	{15052, 165112},
	{15074, 165116},
	{15095, 165120},
	{15117, 165124},
	{15138, 165128},
	{15160, 165132},
	{15181, 165136},
	{15203, 165140},
	{15224, 165144},
	{15246, 165148},
	{15267, 165152},
	{15289, 165156},
	{15310, 165160},
	{15332, 165164},
	{15354, 165168},
	{15377, 165172},
	{15399, 165176},
	{15422, 165180},
	{15444, 165184},
	{15467, 165188},
	{15489, 165192},
	{15512, 165196},
	{15534, 165200},
	{15557, 165204},
	{15579, 165208},
	{15602, 165212},
	{15624, 165216},
	{15647, 165220},
	{15669, 165224},
	{15692, 165228},
	{15714, 165232},
	{15737, 165236},
	{15759, 165240},
	{15782, 165244},
	{15804, 165248},
	{15827, 165252},
	{15849, 165256},
	{15872, 165260},
	{15894, 165264},
	{15917, 165268},
	{15939, 165272},
	{15962, 165276},
	{15984, 165280},
	{16007, 165284},
	{16029, 165288},
	{16052, 165292},
	{16074, 165296},
	{16097, 165300},
	{16119, 165304},
	{16142, 165308},
	{16156, 165312},
	{16170, 165316},
	{16184, 165320},
	{16198, 165324},
	{16212, 165328},
	{16226, 165332},
	{16240, 165336},
	{16254, 165340},
	{16268, 165344},
	{16282, 165348},
	{16296, 165352},
	{16310, 165356},
	{16324, 165360},
	{16338, 165364},
	{16352, 165368},
	{16366, 165372},
	{16380, 165376},
	{16394, 165380},
	{16408, 165384},
	{16422, 165388},
	{16436, 165392},
	{16450, 165396},
	{16464, 165400},
	{16501, 165444, 12, 949},
	{16521, 165448, 12, 949},
	{16541, 165452, 12, 949},
	{16561, 165456, 12, 949},
	{16581, 165460, 12, 949},
	{16601, 165464, 12, 949},
	{16621, 165468, 12, 949},
	{16641, 165472, 12, 949},
	{16661, 165476, 12, 949},
	{16681, 165480, 12, 949},
	{16701, 165484, 12, 949},
	{16722, 165488, 12, 949},
	{16743, 165492, 12, 949},
	{16764, 165496, 12, 949},
	{16785, 165500, 12, 949},
	{16806, 165504, 12, 949},
	{16827, 165508, 12, 949},
	{16848, 165512, 12, 949},
	{16869, 165516, 12, 949},
	{16890, 165520, 12, 949},
	{16911, 165524, 9, 961},
	{16932, 165528, 9, 961},
	{16953, 165532, 9, 961},
	{16974, 165536, 9, 961},
	{16995, 165540, 9, 961},
	{17016, 165544, 9, 961},
	{17037, 165548, 9, 961},
	{17058, 165552, 9, 961},
	{17079, 165556, 9, 961},
	{17100, 165560, 9, 961},
	{17121, 165564, 9, 961},
	{17142, 165568, 9, 961},
	{17163, 165572, 2, 970},
	{17181, 165580, 16, 973},
	{17198, 165584, 16, 973},
	{17216, 165588, 7, 989},
	{17237, 165592, 3, 3842},
	{17255, 165600, 7, 1002},
	{17270, 165608, 2, 694},
	{17309, 165644, 4, 1010},
	{17331, 165648, 1, 1015},
	{17351, 165652, 8, 1016},
	{17373, 165716, 8, 1024},
	{17391, 165720, 8, 1032},
	{17412, 165724, 17, 1040},
	{17433, 165728, 6, 1057},
	{17451, 165732, 6, 1057},
	{17469, 165736, 6, 1057},
	{17487, 165740, 6, 1057},
	{17505, 165744, 6, 1057},
	{17523, 165748, 6, 1057},
	{17541, 165752, 6, 1057},
	{17559, 165756, 6, 1057},
	{17577, 165760, 9, 1063},
	{17595, 165764, 9, 1063},
	{17613, 165768, 9, 1063},
	{17631, 165772, 9, 1063},
	{17649, 165776, 9, 1063},
	{17667, 165780, 9, 1063},
	{17685, 165784, 9, 1063},
	{17703, 165788, 9, 1063},
	{17721, 165836, 1, 1072},
	{17735, 165840, 1, 1072},
	{17750, 165844},
	{17768, 165848},
	{17786, 165852},
	{17803, 165856},
	{17824, 165860, 1, 3845},
	{17840, 165864},
	{17853, 165872, 5, 1074},
	{17872, 165876},
	{17887, 165880, 1, 1082},
	{17936, 165888, 10, 1084},
	{17953, 165892, 12, 1094},
	{17961, 165896, 4, 4514},
	{17978, 165900, 13, 1110},
	{17996, 165904, 19, 1127},
	{18012, 165908, 13, 1147},
	{18031, 165912, 10, 1163},
	{18046, 165916, 27, 4357},
	{18064, 165920, 16, 1201},
	{18082, 165924, 4, 1217},
	{18106, 165928},
	{18131, 165932, 11, 1221},
	{18283, 166400, 2, 1253},
	{18300, 166404, 2, 1255},
	{18319, 166408, 1, 1257},
	{18335, 166412, 4, 1258},
	{18354, 166416, 1, 1262},
	{18375, 166420, 1, 1263},
	{18388, 166424},
	{18411, 166428},
	{18434, 166432, 1, 1264},
	{18454, 166436, 4, 3849},
	{18474, 166440, 1, 1269},
	{18495, 166444, 1, 1270},
	{18510, 166448, 6, 1271},
	{18532, 166452, 6, 1271},
	{18554, 166456, 8, 1277},
	{18580, 166460, 8, 1277},
	{18606, 166464, 15, 4384},
	{18618, 166468, 2, 1300},
	{18637, 166472, 4, 1303},
	{18655, 166476, 24, 1310},
	{18673, 166480},
	{18685, 166484, 1, 1334},
	{18699, 166488, 1, 1335},
	{18713, 166492, 1, 1336},
	{18727, 166496, 1, 1337},
	{18750, 166500, 1, 1337},
	{18773, 166504, 1, 1337},
	{18796, 166508, 5, 3853},
	{18817, 166512},
	{18828, 166516},
	{18841, 166520},
	{18858, 166524, 7, 4399},
	{18877, 166528},
	{18888, 166532, 2, 1351},
	{18907, 166536},
	{18929, 166540},
	{18951, 166544, 3, 4406},
	{18971, 166548, 1, 1357},
	{19020, 166560},
	{19045, 166564},
	{19070, 166568, 7, 4409},
	{19089, 166572, 1, 1370},
	{19112, 166576, 1, 1370},
	{19135, 166580, 1, 1371},
	{19149, 166584, 1, 1372},
	{19164, 166588, 8, 4416},
	{19181, 166592, 4, 1382},
	{19208, 166596, 4, 1386},
	{19235, 166600, 4, 1390},
	{19254, 166608},
	{19280, 166612, 1, 1394},
	{19305, 166620},
	{19333, 166624},
	{19359, 166628, 1, 1394},
	{19384, 166636},
	{19412, 166640},
	{19438, 166644, 1, 1394},
	{19463, 166652},
	{19491, 166656},
	{19517, 166660, 1, 1394},
	{19542, 166668},
	{19570, 166696},
	{19601, 166700},
	{19644, 166704, 1, 1395},
	{19682, 166712, 1, 1396},
	{19721, 166736, 4, 4518},
	{19743, 166740, 10, 1404},
	{19764, 166744, 3, 1423},
	{19781, 166748, 1, 1370},
	{19802, 166752, 1, 1370},
	{19825, 166756, 1, 1370},
	{19848, 166760, 1, 1370},
	{19871, 166764, 10, 4424},
	{19884, 166768, 6, 1438},
	{19901, 166772},
	{19925, 166776, 2, 1444},
	{19955, 166780},
	{19979, 166784},
	{20009, 166788},
	{20040, 166792},
	{20069, 166796},
	{20099, 166800, 2, 1446},
	{20119, 166804, 7, 3883},
	{20138, 166808, 4, 1457},
	{20188, 166868, 8, 1461},
	{20214, 166872, 8, 1469},
	{20240, 166876, 4, 1477},
	{20256, 166880, 5, 1482},
	{20272, 166884, 3, 1488},
	{20287, 166888},
	{20310, 166892},
	{20333, 166896},
	{20356, 166900},
	{20379, 166904, 8, 1491},
	{20413, 166908, 8, 1499},
	{20447, 166912, 8, 1507},
	{20481, 166916, 8, 1515},
	{20515, 166920, 8, 1491},
	{20549, 166924, 8, 1499},
	{20583, 166928, 8, 1507},
	{20617, 166932, 8, 1515},
	{20651, 166936, 8, 1491},
	{20685, 166940, 8, 1499},
	{20719, 166944, 8, 1507},
	{20753, 166948, 8, 1515},
	{20787, 166952, 8, 1491},
	{20821, 166956, 8, 1499},
	{20855, 166960, 8, 1507},
	{20889, 166964, 8, 1515},
	{20923, 166968, 2, 1523},
	{20947, 166972, 2, 1525},
	{20971, 166976, 1, 1527},
	{21090, 167000, 1, 1567},
	{21118, 167004, 1, 1568},
	{21139, 167008},
	{21154, 167012, 2, 1569},
	{21170, 167016, 1, 1571},
	{21186, 167020, 2, 3814},
	{21201, 167024, 18, 4522},
	{21216, 167028, 6, 1594},
	{21233, 167032, 9, 1602},
	{21255, 167036},
	{21271, 167040, 1, 1614},
	{21293, 167044},
	{21309, 167048, 1, 1571},
	{21331, 167052},
	{21353, 167056},
	{21375, 167060},
	{21394, 167068},
	{21409, 167072, 2, 1569},
	{21425, 167076, 1, 1571},
	{21441, 167080, 2, 3814},
	{21456, 167084, 18, 4522},
	{21471, 167088, 6, 1594},
	{21488, 167092, 9, 1602},
	{21510, 167096},
	{21526, 167100, 1, 1614},
	{21548, 167104},
	{21564, 167108, 1, 1571},
	{21586, 167112},
	{21608, 167116},
	{21630, 167120},
	{21649, 167128},
	{21664, 167132, 2, 1569},
	{21680, 167136, 1, 1571},
	{21696, 167140, 2, 3814},
	{21711, 167144, 18, 4522},
	{21726, 167148, 6, 1594},
	{21743, 167152, 9, 1602},
	{21765, 167156},
	{21781, 167160, 1, 1614},
	{21803, 167164},
	{21819, 167168, 1, 1571},
	{21841, 167172},
	{21863, 167176},
	{21885, 167180},
	{21904, 167188},
	{21919, 167192, 2, 1569},
	{21935, 167196, 1, 1571},
	{21951, 167200, 2, 3814},
	{21966, 167204, 18, 4522},
	{21981, 167208, 6, 1594},
	{21998, 167212, 9, 1602},
	{22020, 167216},
	{22036, 167220, 1, 1614},
	{22058, 167224},
	{22074, 167228, 1, 1571},
	{22096, 167232},
	{22118, 167236},
	{22140, 167240},
	{22159, 167248},
	{22174, 167252, 2, 1569},
	{22190, 167256, 1, 1571},
	{22206, 167260, 2, 3814},
	{22221, 167264, 18, 4522},
	{22236, 167268, 6, 1594},
	{22253, 167272, 9, 1602},
	{22275, 167276},
	{22291, 167280, 1, 1614},
	{22313, 167284},
	{22329, 167288, 1, 1571},
	{22351, 167292},
	{22373, 167296},
	{22395, 167300},
	{22414, 167308},
	{22429, 167312, 2, 1569},
	{22445, 167316, 1, 1571},
	{22461, 167320, 2, 3814},
	{22476, 167324, 18, 4522},
	{22491, 167328, 6, 1594},
	{22508, 167332, 9, 1602},
	{22530, 167336},
	{22546, 167340, 1, 1614},
	{22568, 167344},
	{22584, 167348, 1, 1571},
	{22606, 167352},
	{22628, 167356},
	{22650, 167360},
	{22669, 167368},
	{22684, 167372, 2, 1569},
	{22700, 167376, 1, 1571},
	{22716, 167380, 2, 3814},
	{22731, 167384, 18, 4522},
	{22746, 167388, 6, 1594},
	{22763, 167392, 9, 1602},
	{22785, 167396},
	{22801, 167400, 1, 1614},
	{22823, 167404},
	{22839, 167408, 1, 1571},
	{22861, 167412},
	{22883, 167416},
	{22905, 167420},
	{22924, 167428},
	{22939, 167432, 2, 1569},
	{22955, 167436, 1, 1571},
	{22971, 167440, 2, 3814},
	{22986, 167444, 18, 4522},
	{23001, 167448, 6, 1594},
	{23018, 167452, 9, 1602},
	{23040, 167456},
	{23056, 167460, 1, 1614},
	{23078, 167464},
	{23094, 167468, 1, 1571},
	{23116, 167472},
	{23138, 167476},
	{23160, 167480},
	{24203, 196608, 1, 1627},
	{24223, 196612, 1, 1628},
	{24243, 196616},
	{24263, 196620},
	{24283, 196624},
	{24304, 196628},
	{24325, 196632, 1, 1629},
	{24347, 196636, 1, 1630},
	{24369, 196640},
	{24399, 196644},
	{24429, 196648},
	{24458, 196652},
	{24487, 196656},
	{24517, 196660},
	{24547, 196664},
	{24576, 196668},
	{24605, 196672},
	{24635, 196676},
	{24665, 196680},
	{24694, 196684},
	{24723, 196688},
	{24753, 196692},
	{24783, 196696},
	{24812, 196700},
	{24841, 196704, 1, 1631},
	{24863, 196708, 1, 1632},
	{24885, 196712},
	{24908, 196716},
	{24931, 196720},
	{24954, 196724},
	{24977, 196728},
	{25000, 196732},
	{25023, 196736},
	{25047, 196740},
	{25071, 196744},
	{25095, 196748},
	{25119, 196752},
	{25143, 196756},
	{25167, 196760},
	{25191, 196764},
	{25215, 196768},
	{25237, 196772},
	{25259, 196776},
	{25280, 196780},
	{25301, 196784},
	{25325, 196788},
	{25349, 196792},
	{25373, 196796},
	{25397, 196800},
	{25421, 196804},
	{25505, 196852, 2, 4452},
	{25527, 196856, 2, 4452},
	{25549, 196860, 1, 1635},
	{25565, 196864},
	{25578, 196868},
	{25591, 196872},
	{25604, 196876},
	{25617, 196880},
	{25630, 196884},
	{25643, 196888},
	{25656, 196892},
	{25783, 196928, 2, 1636},
	{25796, 196932},
	{25809, 196936},
	{25832, 196940},
	{25855, 196944},
	{25883, 196948},
	{25911, 196952},
	{25939, 196956},
	{25967, 196960, 1, 1638},
	{25985, 196964, 5, 4454},
	{26003, 196968},
	{26018, 196972},
	{26042, 196976},
	{26066, 196980},
	{26085, 196984},
	{26104, 196988},
	{26128, 196992},
	{26152, 196996},
	{26176, 197000},
	{26200, 197028, 2, 3040},
	{26218, 197032, 3, 4459},
	{26236, 197036},
	{26254, 197040},
	{26272, 197044, 2, 3043},
	{26290, 197048, 3, 4462},
	{26308, 197052},
	{26326, 197056, 2, 1649},
	{26345, 197060, 5, 1651},
	{26364, 197072},
	{26388, 197076, 2, 1649},
	{26408, 197080, 5, 1651},
	{26428, 197084, 8, 4465},
	{26447, 197088, 8, 4465},
	{26465, 197092, 1, 1663},
	{26482, 197100, 1, 1664},
	{26503, 197104, 26, 4473},
	{26517, 197108},
	{26531, 197112},
	{26545, 197116, 4, 3074},
	{26561, 197120},
	{26580, 197124, 1, 1680},
	{26602, 197128},
	{26621, 197132, 1, 1681},
	{26643, 197136, 9, 3080},
	{26661, 197140},
	{26681, 197144, 1, 1680},
	{26704, 197148},
	{26724, 197152, 1, 1681},
	{26747, 197156, 9, 3080},
	{26766, 197160, 5, 3089},
	{26778, 197164, 2, 1696},
	{26795, 197168, 1, 1698},
	{26812, 197172, 1, 1699},
	{26830, 197176, 4, 1700},
	{26850, 197180, 1, 1704},
	{26867, 197184},
	{26883, 197188, 1, 1706},
	{26896, 197192, 1, 1707},
	{26910, 197196, 1, 1708},
	{26924, 197200, 1, 1709},
	{26946, 197204, 1, 1710},
	{26966, 197208, 1, 1711},
	{26988, 197212, 1, 1712},
	{27008, 197216, 1, 1707},
	{27025, 197220, 1, 1708},
	{27042, 197224},
	{52837, 197228, 1, 1706},
	{27301, 197388, 1, 1721},
	{27320, 197392, 1, 1722},
	{27339, 197396, 1, 1723},
	{27356, 197400, 1, 1724},
	{27374, 197404, 1, 1725},
	{27392, 197408, 1, 1726},
	{27408, 197412, 1, 1727},
	{27426, 197416, 1, 1728},
	{27444, 197420, 1, 1729},
	{27460, 197424, 1, 1724},
	{27475, 197428, 1, 1725},
	{27490, 197432, 1, 1726},
	{27503, 197436, 1, 1727},
	{27518, 197440, 1, 1728},
	{27533, 197444, 1, 1729},
	{27546, 197448, 1, 1730},
	{27560, 197452, 1, 1731},
	{27574, 197456, 1, 1732},
	{27586, 197460, 4, 4499},
	{27609, 197464, 4, 4092},
	{27631, 197468, 1, 1740},
	{27775, 197552, 1, 1745},
	{27800, 197556, 1, 1745},
	{27824, 197560, 1, 1746},
	{27844, 197568},
	{27870, 197572, 1, 1628},
	{27899, 197576},
	{27924, 197580, 1, 1628},
	{27952, 197584},
	{27975, 197588, 1, 1628},
	{28001, 197592},
	{28023, 197596, 1, 1628},
	{28048, 197600},
	{28067, 197604, 1, 1628},
	{28089, 197608, 1, 1343},
	{28103, 197612},
	{28120, 197616, 1, 1628},
	{28140, 197620, 8, 1747},
	{28309, 198656, 6, 2946},
	{48507, 198912},
	{48526, 198916},
	{28370, 198920, 1, 3329},
	{28389, 198924, 1, 1343},
	{28404, 198928},
	{28437, 198932},
	{28470, 198936},
	{28503, 198940},
	{28593, 198960},
	{28609, 198964},
	{49020, 198968, 1, 1785},
	{49052, 198972, 2, 1786},
	{49073, 198976},
	{29013, 199168, 1, 1809},
	{29038, 199172, 2, 1810},
	{29063, 199184, 2, 1812},
	{29089, 199188, 2, 1812},
	{29115, 199192, 2, 1812},
	{29141, 199212, 2, 1812},
	{29167, 199296, 2, 1814},
	{29195, 199300, 1, 1816},
	{29219, 199304, 1, 1817},
	{29243, 199308, 1, 1818},
	{29276, 199312, 1, 1818},
	{29304, 199328, 2, 1814},
	{29333, 199332, 1, 1816},
	{29358, 199336, 1, 1817},
	{29383, 199340, 1, 1818},
	{29417, 199344, 1, 1818},
	{29446, 199360, 2, 1814},
	{29470, 199364, 1, 1816},
	{29490, 199368, 1, 1817},
	{29510, 199372, 1, 1818},
	{29539, 199376, 1, 1818},
	{49639, 199872},
	{49660, 199876, 1, 3506},
	{2095, 199880, 8, 4060},
	{2116, 199884, 3, 3515},
	{49681, 199888, 2, 3518},
	{2143, 199892, 1, 3542},
	{49707, 199896, 15, 3527},
	{50710, 199900, 1, 4069},
	{50732, 199904},
	{2074, 199908, 2, 3520},
	{2164, 199912, 5, 4072},
	{49749, 199916, 1, 3543},
	{29563, 199936},
	{29590, 199940},
	{29617, 199944},
	{29644, 199948},
	{29779, 199968, 6, 1819},
	{29790, 199972, 2, 1826},
	{29804, 200192},
	{29823, 200196, 1, 840},
	{29845, 200448},
	{29869, 200452, 1, 1828},
	{29892, 200456},
	{29916, 200460, 1, 1828},
	{29939, 200464},
	{29963, 200468, 1, 1828},
	{29986, 200472},
	{30010, 200476, 1, 1828},
	{30033, 200696},
	{30052, 200700, 1, 1828},
	{30070, 200704},
	{30082, 200708},
	{30094, 200712},
	{30112, 200716},
	{30131, 200720},
	{30149, 200724},
	{30161, 200728},
	{30173, 200732},
	{30191, 200736},
	{30209, 200740},
	{30228, 200744, 4, 1829},
	{30242, 200748, 2, 1833},
	{30260, 200752, 2, 1835},
	{30274, 200756, 2, 1837},
	{30288, 200760, 2, 1839},
	{30305, 200764, 2, 1841},
	{30322, 200768},
	{30335, 200772, 2, 1843},
	{30347, 200776},
	{30361, 200780},
	{30377, 200784},
	{30391, 200788},
	{30407, 200792},
	{30422, 200796},
	{30439, 200800},
	{30454, 200804},
	{30471, 200808, 2, 1845},
	{30493, 200812, 9, 4540},
	{30510, 200816, 2, 1857},
	{30531, 200820, 2, 1859},
	{30543, 200824},
	{30558, 200828, 6, 4503},
	{30573, 200832, 2, 1867},
	{30587, 200836},
	{30700, 212992},
	{30720, 212996},
	{30740, 213000},
	{30760, 213004},
	{30780, 213008},
	{30800, 213012},
	{30820, 213016},
	{30840, 213020},
	{30860, 213024},
	{30880, 213028},
	{30900, 213032},
	{30920, 213036},
	{31009, 213248},
	{31030, 213252},
	{31051, 213260},
	{31072, 213264},
	{31093, 213268},
	{31117, 213272},
	{31141, 213276},
	{31165, 213280},
	{31189, 213284},
	{31213, 213288},
	{31237, 213292},
	{31261, 213296},
	{50822, 213504},
	{50841, 213508},
	{50860, 213512},
	{50879, 213516},
	{50898, 213520},
	{50917, 213524},
	{50936, 213528},
	{50955, 213532},
	{48217, 213536},
	{48236, 213540},
	{48255, 213544},
	{48274, 213548},
	{48293, 213552},
	{48312, 213556},
	{48331, 213560},
	{48350, 213564},
	{48808, 213568},
	{48828, 213572},
	{48848, 213576},
	{48868, 213580},
	{48888, 213584},
	{48908, 213588},
	{48928, 213592},
	{48948, 213596},
	{31745, 214016},
	{31767, 214020, 1, 1869},
	{31789, 214024},
	{31811, 214028, 1, 1869},
	{31833, 214032},
	{31855, 214036, 1, 1869},
	{31877, 214040},
	{31899, 214044, 1, 1869},
	{31921, 214272},
	{31943, 214276},
	{31965, 214280},
	{31987, 214284},
	{32009, 214288},
	{32031, 214292},
	{32053, 214296},
	{32075, 214300},
	{32097, 214304},
	{32119, 214308},
	{32141, 214312},
	{32163, 214316},
	{32185, 214320},
	{32207, 214324},
	{32229, 214328},
	{32251, 214332},
	{32273, 214528},
	{32293, 214532},
	{32313, 214536},
	{32333, 214540},
	{32353, 214544},
	{32373, 214548},
	{32393, 214552},
	{32413, 214556},
	{32433, 214560},
	{32453, 214564},
	{32473, 214568},
	{32493, 214572},
	{32513, 214784},
	{32532, 214788},
	{32551, 214792},
	{32570, 214796},
	{32589, 214800},
	{32608, 214804},
	{32627, 214808},
	{32646, 214812},
	{32665, 214816},
	{32684, 214820},
	{32703, 214824},
	{32722, 214828},
	{32741, 214832},
	{32760, 214836},
	{32779, 214840},
	{32798, 214844},
	{32817, 214848},
	{32836, 214852},
	{32855, 214856},
	{32874, 214860},
	{32893, 214864},
	{32913, 214868},
	{32933, 214872},
	{32953, 214876},
	{32973, 214880},
	{32993, 214884},
	{33013, 214888},
	{33033, 214892},
	{33053, 214896},
	{33073, 214900},
	{33093, 214904},
	{33113, 214908},
	{33133, 215296},
	{33152, 215300},
	{33171, 215304},
	{33190, 215308},
	{33209, 215312},
	{33228, 215316},
	{33247, 215320},
	{33266, 215324},
	{33327, 215552},
	{33347, 215556},
	{33367, 215560},
	{33387, 215564},
	{33407, 215568},
	{33427, 215572},
	{33447, 215576},
	{33467, 215580},
	{33487, 215808},
	{33506, 215812},
	{33525, 215816},
	{33544, 215820},
	{33563, 216064},
	{33582, 216068},
	{33601, 216072},
	{33620, 216076},
	{33639, 216320},
	{33659, 216324},
	{33679, 216328},
	{33699, 216332},
	{33719, 216336},
	{33739, 216340},
	{33759, 216344},
	{33779, 216348},
	{50974, 216576},
	{50994, 216580},
	{51014, 216584},
	{51034, 216588},
	{51054, 216592},
	{51074, 216596},
	{51094, 216600},
	{51114, 216604},
	{51134, 216640},
	{51154, 216644},
	{51174, 216648},
	{51194, 216652},
	{51214, 216656},
	{51234, 216660},
	{51254, 216664},
	{51274, 216668},
	{34631, 217112},
	{34650, 217116},
	{34669, 217120},
	{34688, 217124},
	{34707, 217128},
	{34726, 217132},
	{34745, 217136},
	{34764, 217140},
	{34783, 217344},
	{34802, 217348},
	{34821, 217352},
	{34840, 217356},
	{34859, 217360},
	{34878, 217364},
	{34897, 217368},
	{34916, 217372},
	{34935, 217600},
	{34955, 217604},
	{34975, 217608},
	{34995, 217612},
	{36317, 221184, 1, 1903},
	{36341, 221188, 2, 4109},
	{36366, 221192, 3, 4111},
	{36390, 221196, 1, 1903},
	{36414, 221200, 2, 4109},
	{36439, 221204, 1, 1903},
	{36463, 221208, 2, 4109},
	{36488, 221212, 3, 4111},
	{36512, 221216, 4, 1881},
	{36528, 221220, 3, 4111},
	{36695, 221248},
	{36710, 221252, 1, 1818},
	{36733, 221256},
	{36756, 221260},
	{36774, 221264, 2, 1897},
	{36792, 221268, 4, 1899},
	{36812, 221440, 19, 2989},
	{36837, 221444, 19, 2989},
	{36862, 221448, 12, 3008},
	{36890, 221452, 12, 3008},
	{36918, 221456, 12, 3008},
	{36946, 221460, 12, 3008},
	{51454, 221696, 2, 3287},
	{51477, 221700, 2, 3287},
	{51500, 221704, 2, 3287},
	{51523, 221708, 2, 3287},
	{48125, 221712, 5, 1957},
	{48148, 221716, 2, 3287},
	{48171, 221720, 2, 3287},
	{48194, 221724, 2, 3287},
	{51546, 221728, 4, 1962},
	{48712, 221744, 5, 1957},
	{48736, 221748, 5, 1957},
	{48760, 221752, 2, 3287},
	{48784, 221756, 2, 3287},
	{51570, 221760, 4, 1962},
	{51595, 221764, 4, 1962},
	{48686, 221776, 1, 3328},
	{37404, 222208, 3, 1957},
	{37430, 222212, 2, 1877},
	{37457, 222216, 3, 1957},
	{37483, 222220, 2, 1877},
	{37510, 222224, 2, 2013},
	{37563, 222228, 2, 2013},
	{37616, 222464, 3, 1957},
	{37642, 222468, 2, 1877},
	{37669, 222472, 1, 1872},
	{37695, 222476, 1, 1872},
	{37721, 222480, 1, 1872},
	{37747, 222484, 1, 1872},
	{37773, 222488, 1, 1872},
	{37799, 222492, 1, 1872},
	{37825, 222496, 1, 1872},
	{37851, 222720, 3, 1957},
	{37875, 222724, 3, 1957},
	{37899, 222728, 3, 1957},
	{37923, 222732, 3, 1957},
	{37947, 222736, 2, 1877},
	{37972, 222740, 2, 1877},
	{37997, 222744, 2, 1877},
	{38022, 222748, 2, 1877},
	{38047, 222752, 1, 2001},
	{38071, 222756, 1, 2001},
	{38095, 222760, 8, 1966},
	{38116, 222976, 6, 3486},
	{38139, 222980, 6, 3486},
	{38162, 222984, 6, 3486},
	{38185, 222988, 6, 3486},
	{38208, 222992, 6, 3486},
	{38231, 222996, 6, 3486},
	{38254, 223000, 6, 3486},
	{38277, 223004, 6, 3486},
	{38300, 223008, 6, 3486},
	{38323, 223012, 6, 3486},
	{38346, 223016, 6, 3486},
	{38370, 223020, 6, 3486},
	{38394, 223024, 6, 3486},
	{38418, 223028, 6, 3486},
	{38442, 223032, 6, 3486},
	{38466, 223036, 6, 3486},
	{38490, 223104, 9, 3469},
	{51620, 223108, 2, 3518},
	{38510, 223112, 1, 1987},
	{38605, 223488, 3, 1996},
	{38628, 223492, 3, 1996},
	{38651, 223496, 3, 1996},
	{38674, 223500, 3, 1996},
	{38697, 223504, 2, 1999},
	{38721, 223508, 2, 1999},
	{38745, 223744, 3, 1996},
	{38769, 223748, 3, 1996},
	{38793, 223752, 3, 1996},
	{38817, 223756, 3, 1996},
	{38841, 223760, 2, 1999},
	{38866, 224000, 5, 2001},
	{38889, 224004, 4, 2006},
	{38913, 224008, 5, 2001},
	{38936, 224256, 5, 2001},
	{38959, 224260, 4, 2006},
	{38983, 224264, 5, 2001},
	{39006, 224512, 5, 1957},
	{39030, 224516, 4, 1962},
	{39055, 224520, 5, 1957},
	{39079, 224524, 4, 1962},
	{39104, 224528, 3, 2013},
	{39128, 224532, 3, 2013},
	{51640, 224768, 5, 1957},
	{51664, 224772, 4, 1951},
	{51689, 224776, 5, 1957},
	{51713, 224780, 4, 1951},
	{51738, 224784, 3, 2013},
	{51762, 224788, 3, 2013},
	{51786, 224832, 5, 1957},
	{51810, 224836, 4, 1951},
	{51835, 224840, 5, 1957},
	{51859, 224844, 4, 1951},
	{51884, 224848, 3, 2013},
	{51908, 224852, 3, 2013},
	{39829, 225280, 12, 2016},
	{39851, 225284, 5, 2028},
	{39874, 225288, 4, 2033},
	{39898, 225292, 2, 2037},
	{39921, 225296, 2, 2037},
	{39944, 225300, 2, 2037},
	{39967, 225536, 5, 1957},
	{39990, 225540, 4, 1962},
	{40014, 225544, 5, 1957},
	{40037, 225548, 4, 1962},
	{40061, 225552, 5, 1957},
	{40084, 225560, 5, 1957},
	{40107, 225792, 4, 2039},
	{40128, 225796},
	{40157, 225800, 2, 2043},
	{40186, 225804},
	{40212, 225808, 7, 2045},
	{40286, 225812},
	{40309, 225816},
	{52053, 225820, 2, 4120},
	{52086, 225824, 2, 4120},
	{52119, 225828, 2, 4120},
	{52152, 225832, 2, 4120},
	{52184, 225836, 2, 4120},
	{52216, 225840, 2, 4120},
	{52248, 225844, 2, 4120},
	{52281, 225848, 2, 4120},
	{52313, 225856, 2, 4120},
	{52345, 225860, 2, 4120},
	{52378, 225864, 2, 4120},
	{52411, 225868, 2, 4120},
	{52444, 225872, 2, 4120},
	{52476, 225876, 2, 4120},
	{52508, 225880, 2, 4120},
	{52541, 225884, 2, 4120},
	{52574, 225888, 2, 4120},
	{52640, 225896, 2, 4120},
	{40332, 225900},
	{40359, 225904},
	{40241, 225908},
	{40260, 225912},
	{41229, 226044, 1, 2129},
	{41022, 226048, 2, 2119},
	{41039, 226052, 1, 2121},
	{41063, 226056, 1, 2121},
	{195, 880, 4, 2156},
	{42808, 881},
	{26631, 882},
	{42820, 1008},
	{42831, 1009},
	{26819, 1010, 3, 2160},
	{42842, 1040, 1, 2163},
	{42855, 1041, 5, 4122},
	{42868, 1042, 1, 2169},
	{42881, 1043, 1, 1681},
	{26653, 1045, 9, 3914},
	{42909, 1280, 6, 4127},
	{42924, 1281},
	{26590, 1282},
	{42808, 1283},
	{26631, 1284},
};

static const struct si_reg gfx9_reg_table[] = {
	{974, 68, 14, 4549},
	{987, 72, 23, 4563},
	{1002, 76, 7, 4586},
	{46947, 80, 11, 3939},
	{1039, 84, 4, 2800},
	{1057, 88, 2, 2804},
	{1075, 92, 7, 4593},
	{1090, 96},
	{1104, 100, 1, 70},
	{1118, 104},
	{46961, 108},
	{46978, 112, 13, 4600},
	{1135, 116, 7, 4613},
	{1151, 120},
	{1273, 2480},
	{1287, 2484},
	{1301, 2488},
	{1315, 2492},
	{1329, 2496},
	{1343, 2500},
	{1357, 2504},
	{1371, 2508},
	{1385, 2512},
	{1399, 2516},
	{1413, 2520},
	{1428, 2524},
	{1443, 2528},
	{1458, 2532},
	{1473, 2536},
	{1488, 2540},
	{1503, 2544},
	{1514, 2552},
	{1530, 2556},
	{1618, 32776, 25, 4620},
	{1631, 32784, 24, 4645},
	{1643, 32788, 12, 4669},
	{1659, 32792, 12, 4669},
	{1688, 32824, 12, 4669},
	{1704, 32828, 12, 4669},
	{1720, 33296, 16, 4681},
	{1734, 33300, 28, 204},
	{1751, 33304, 14, 232},
	{1772, 33308, 21, 4697},
	{1786, 33312, 31, 4022},
	{1803, 33316, 11, 307},
	{1842, 33324, 1, 329},
	{1865, 33344, 1, 330},
	{1886, 33348},
	{1906, 33352, 1, 332},
	{1947, 33436, 1, 342},
	{2351, 36608},
	{2369, 36612, 4, 383},
	{2387, 36616},
	{2405, 36620, 12, 4718},
	{3306, 36624},
	{3324, 36628, 8, 4730},
	{3342, 36632, 3, 3587},
	{3360, 36636, 8, 4738},
	{3378, 36640, 3, 4746},
	{3396, 36644, 7, 4749},
	{3414, 36648, 8, 4290},
	{3432, 36652},
	{2423, 36656, 14, 4298},
	{2441, 36660, 4, 411},
	{2459, 36664, 10, 4756},
	{2477, 36668, 3, 4766},
	{2511, 39160, 13, 4769},
	{2526, 39184, 5, 3645},
	{2540, 39188, 5, 3645},
	{2554, 39192, 5, 3645},
	{2568, 39196, 5, 3645},
	{2582, 39200, 5, 3645},
	{2596, 39204, 5, 3645},
	{2610, 39208, 5, 3645},
	{2624, 39212, 5, 3645},
	{2638, 39216, 5, 3645},
	{2652, 39220, 5, 3645},
	{2666, 39224, 5, 3645},
	{2681, 39228, 5, 3645},
	{2696, 39232, 5, 3645},
	{2711, 39236, 5, 3645},
	{2726, 39240, 5, 3645},
	{2741, 39244, 5, 3645},
	{2756, 39248, 5, 3645},
	{2771, 39252, 5, 3645},
	{2786, 39256, 5, 3645},
	{2801, 39260, 5, 3645},
	{2816, 39264, 5, 3645},
	{2831, 39268, 5, 3645},
	{2846, 39272, 5, 3645},
	{2861, 39276, 5, 3645},
	{2876, 39280, 5, 3645},
	{2891, 39284, 5, 3645},
	{2906, 39288, 5, 3645},
	{2921, 39292, 5, 3645},
	{2936, 39296, 5, 3645},
	{2951, 39300, 5, 3645},
	{2966, 39304, 5, 3645},
	{2981, 39308, 5, 3645},
	{2996, 39312, 4, 448},
	{3015, 39316, 4, 448},
	{3034, 39320, 4, 448},
	{3053, 39324, 4, 448},
	{3072, 39328, 4, 448},
	{3091, 39332, 4, 448},
	{3110, 39336, 4, 448},
	{3129, 39340, 4, 448},
	{3148, 39344, 4, 448},
	{3167, 39348, 4, 448},
	{3186, 39352, 4, 448},
	{3206, 39356, 4, 448},
	{3226, 39360, 4, 448},
	{3246, 39364, 4, 448},
	{3266, 39368, 4, 448},
	{3286, 39372, 4, 448},
	{3499, 45084, 4, 4782},
	{3523, 45088},
	{3544, 45092, 1, 491},
	{3565, 45096, 11, 4786},
	{3589, 45100, 10, 4797},
	{3613, 45104},
	{3639, 45108},
	{3665, 45112},
	{3691, 45116},
	{3717, 45120},
	{3743, 45124},
	{3769, 45128},
	{3795, 45132},
	{3821, 45136},
	{3847, 45140},
	{3873, 45144},
	{3900, 45148},
	{3927, 45152},
	{3954, 45156},
	{3981, 45160},
	{4008, 45164},
	{4035, 45168},
	{4062, 45172},
	{4089, 45176},
	{4116, 45180},
	{4143, 45184},
	{4170, 45188},
	{4197, 45192},
	{4224, 45196},
	{4251, 45200},
	{4278, 45204},
	{4305, 45208},
	{4332, 45212},
	{4359, 45216},
	{4386, 45220},
	{4413, 45224},
	{4440, 45228},
	{4680, 45336, 4, 4782},
	{4704, 45340, 1, 527},
	{4729, 45344},
	{4750, 45348, 1, 491},
	{4771, 45352, 12, 4807},
	{4795, 45356, 14, 4819},
	{4819, 45360},
	{4845, 45364},
	{4871, 45368},
	{4897, 45372},
	{4923, 45376},
	{4949, 45380},
	{4975, 45384},
	{5001, 45388},
	{5027, 45392},
	{5053, 45396},
	{5079, 45400},
	{5106, 45404},
	{5133, 45408},
	{5160, 45412},
	{5187, 45416},
	{5214, 45420},
	{5241, 45424},
	{5268, 45428},
	{5295, 45432},
	{5322, 45436},
	{5349, 45440},
	{5376, 45444},
	{5403, 45448},
	{5430, 45452},
	{5457, 45456},
	{5484, 45460},
	{5511, 45464},
	{5538, 45468},
	{5565, 45472},
	{5592, 45476},
	{5619, 45480},
	{5646, 45484},
	{5837, 45552, 9, 554},
	{5943, 45572, 2, 4833},
	{5967, 45576},
	{5999, 45580},
	{7274, 45584},
	{7295, 45588, 1, 491},
	{6079, 45596, 4, 4782},
	{6103, 45600},
	{6124, 45604, 1, 491},
	{6145, 45608, 12, 4835},
	{6169, 45612, 9, 4847},
	{7364, 45872},
	{7390, 45876},
	{7416, 45880},
	{7442, 45884},
	{7468, 45888},
	{7494, 45892},
	{7520, 45896},
	{7546, 45900},
	{7572, 45904},
	{7598, 45908},
	{7624, 45912},
	{7651, 45916},
	{7678, 45920},
	{7705, 45924},
	{7732, 45928},
	{7759, 45932},
	{52853, 45936},
	{52880, 45940},
	{52907, 45944},
	{52934, 45948},
	{52961, 45952},
	{52988, 45956},
	{53015, 45960},
	{53042, 45964},
	{53069, 45968},
	{53096, 45972},
	{53123, 45976},
	{53150, 45980},
	{53177, 45984},
	{53204, 45988},
	{53231, 45992},
	{53258, 45996},
	{7838, 46084, 1, 4833},
	{7862, 46088},
	{7894, 46092},
	{9169, 46096},
	{9190, 46100, 1, 491},
	{7974, 46108, 4, 4856},
	{7998, 46112},
	{8019, 46116, 1, 491},
	{8040, 46120, 11, 4860},
	{8064, 46124, 7, 4871},
	{9259, 46128},
	{9285, 46132},
	{9311, 46136},
	{9337, 46140},
	{9363, 46144},
	{9389, 46148},
	{9415, 46152},
	{9441, 46156},
	{9467, 46160},
	{9493, 46164},
	{9519, 46168},
	{9546, 46172},
	{9573, 46176},
	{9600, 46180},
	{9627, 46184},
	{9654, 46188},
	{53285, 46192},
	{53312, 46196},
	{53339, 46200},
	{53366, 46204},
	{53393, 46208},
	{53420, 46212},
	{53447, 46216},
	{53474, 46220},
	{53501, 46224},
	{53528, 46228},
	{53555, 46232},
	{53582, 46236},
	{53609, 46240},
	{53636, 46244},
	{53663, 46248},
	{53690, 46252},
	{53717, 46384},
	{53747, 46388},
	{53777, 46392},
	{53807, 46396},
	{53837, 46400},
	{53867, 46404},
	{53897, 46408},
	{53927, 46412},
	{53957, 46416},
	{53987, 46420},
	{54017, 46424},
	{54048, 46428},
	{54079, 46432},
	{54110, 46436},
	{54141, 46440},
	{54172, 46444},
	{54203, 46448},
	{54234, 46452},
	{54265, 46456},
	{54296, 46460},
	{54327, 46464},
	{54358, 46468},
	{54389, 46472},
	{54420, 46476},
	{54451, 46480},
	{54482, 46484},
	{54513, 46488},
	{54544, 46492},
	{54575, 46496},
	{54606, 46500},
	{54637, 46504},
	{54668, 46508},
	{9681, 47104, 11, 4878},
	{9708, 47108},
	{9722, 47112},
	{9736, 47116},
	{9750, 47120},
	{9766, 47124},
	{9782, 47128},
	{9798, 47132, 2, 659},
	{9819, 47136, 2, 659},
	{9840, 47140, 2, 659},
	{9861, 47144, 1, 661},
	{9889, 47148, 1, 662},
	{9914, 47152},
	{9929, 47156, 1, 663},
	{9944, 47160},
	{9973, 47164, 1, 663},
	{10002, 47168},
	{10035, 47172, 1, 663},
	{10068, 47176, 11, 4889},
	{10086, 47180, 12, 4900},
	{10104, 47184, 1, 687},
	{10117, 47188, 7, 4912},
	{50546, 47192, 2, 3774},
	{50577, 47196, 2, 3774},
	{10195, 47200, 2, 694},
	{50760, 47204, 2, 3774},
	{50791, 47208, 2, 3774},
	{10270, 47212},
	{10288, 47216},
	{10306, 47220},
	{10324, 47224, 1, 696},
	{10352, 47228, 5, 697},
	{10374, 47232},
	{10394, 47236},
	{10577, 47240, 3, 713},
	{10594, 47244},
	{10623, 47248, 1, 716},
	{10555, 47252},
	{54699, 47252},
	{54730, 47256},
	{54761, 47260},
	{54792, 47264},
	{10670, 47360},
	{10690, 47364},
	{10710, 47368},
	{10730, 47372},
	{10750, 47376},
	{10770, 47380},
	{10790, 47384},
	{10810, 47388},
	{10830, 47392},
	{10850, 47396},
	{10870, 47400},
	{10891, 47404},
	{10912, 47408},
	{10933, 47412},
	{10954, 47416},
	{10975, 47420},
	{11020, 47608},
	{11041, 47612},
	{11057, 163840, 10, 719},
	{11075, 163844, 9, 3805},
	{11092, 163848, 5, 4919},
	{11106, 163852, 23, 747},
	{11125, 163856, 16, 770},
	{11145, 163860},
	{11557, 163864, 1, 830},
	{50656, 163868, 2, 786},
	{11181, 163872},
	{11201, 163876},
	{11221, 163880, 1, 788},
	{11238, 163884},
	{11253, 163888, 2, 789},
	{11277, 163892, 2, 791},
	{11335, 163896, 13, 4924},
	{11345, 163900, 8, 4937},
	{11361, 163904},
	{11471, 163908, 1, 830},
	{11376, 163912},
	{11489, 163916, 1, 830},
	{11397, 163920},
	{11513, 163924, 1, 830},
	{11413, 163928},
	{11532, 163932, 1, 830},
	{11301, 163936, 3, 793},
	{54823, 163944, 1, 4945},
	{54834, 163948, 1, 4945},
	{11603, 163968},
	{11619, 163972, 1, 840},
	{11638, 164328, 1, 841},
	{11659, 164332, 1, 841},
	{11680, 164336, 1, 841},
	{11701, 164340, 1, 841},
	{11722, 164344},
	{11740, 164348},
	{11758, 164352, 2, 842},
	{11778, 164356, 3, 844},
	{11802, 164360, 2, 847},
	{11826, 164364, 1, 849},
	{11846, 164368, 2, 844},
	{11866, 164372, 2, 847},
	{11886, 164376, 2, 844},
	{11906, 164380, 2, 847},
	{11926, 164384, 2, 844},
	{11946, 164388, 2, 847},
	{11966, 164392, 2, 844},
	{11986, 164396, 2, 847},
	{12006, 164400, 7, 850},
	{12021, 164404, 2, 857},
	{12050, 164408, 8, 859},
	{12065, 164412, 8, 867},
	{12080, 164416, 3, 844},
	{12105, 164420, 2, 847},
	{12130, 164424},
	{12148, 164428},
	{12166, 164432, 3, 844},
	{12191, 164436, 2, 847},
	{12216, 164440, 3, 844},
	{12241, 164444, 2, 847},
	{12266, 164448, 3, 844},
	{12291, 164452, 2, 847},
	{12316, 164456, 3, 844},
	{12341, 164460, 2, 847},
	{12366, 164464, 3, 844},
	{12391, 164468, 2, 847},
	{12416, 164472, 3, 844},
	{12441, 164476, 2, 847},
	{12466, 164480, 3, 844},
	{12491, 164484, 2, 847},
	{12516, 164488, 3, 844},
	{12541, 164492, 2, 847},
	{12566, 164496, 3, 844},
	{12591, 164500, 2, 847},
	{12616, 164504, 3, 844},
	{12641, 164508, 2, 847},
	{12666, 164512, 3, 844},
	{12692, 164516, 2, 847},
	{12718, 164520, 3, 844},
	{12744, 164524, 2, 847},
	{12770, 164528, 3, 844},
	{12796, 164532, 2, 847},
	{12822, 164536, 3, 844},
	{12848, 164540, 2, 847},
	{12874, 164544, 3, 844},
	{12900, 164548, 2, 847},
	{12926, 164552, 3, 844},
	{12952, 164556, 2, 847},
	{12978, 164560},
	{12997, 164564},
	{13016, 164568},
	{13035, 164572},
	{13054, 164576},
	{13073, 164580},
	{13092, 164584},
	{13111, 164588},
	{13130, 164592},
	{13149, 164596},
	{13168, 164600},
	{13187, 164604},
	{13206, 164608},
	{13225, 164612},
	{13244, 164616},
	{13263, 164620},
	{13282, 164624},
	{13301, 164628},
	{13320, 164632},
	{13339, 164636},
	{13358, 164640},
	{13378, 164644},
	{13398, 164648},
	{13418, 164652},
	{13438, 164656},
	{13458, 164660},
	{13478, 164664},
	{13498, 164668},
	{13518, 164672},
	{13538, 164676},
	{13558, 164680},
	{13578, 164684},
	{13598, 164688, 15, 4946},
	{13618, 164692, 3, 4961},
	{13640, 164696, 2, 893},
	{13668, 164700, 3, 895},
	{13697, 164704, 1, 902},
	{13718, 164708, 1, 903},
	{13728, 164712, 1, 904},
	{13736, 164768, 4, 905},
	{13758, 164772, 4, 905},
	{13779, 164776, 4, 909},
	{13846, 164876},
	{13900, 164884},
	{13913, 164888},
	{13928, 164892},
	{13942, 164896},
	{13957, 164900, 9, 4964},
	{13996, 164908, 6, 935},
	{14015, 164912, 4, 941},
	{14033, 164916, 4, 945},
	{14054, 164924},
	{14073, 164928},
	{14093, 164932},
	{14112, 164936},
	{14132, 164940},
	{14151, 164944},
	{14171, 164948},
	{14192, 164952},
	{14214, 164956},
	{14235, 164960},
	{14257, 164964},
	{14278, 164968},
	{14300, 164972},
	{14321, 164976},
	{14343, 164980},
	{14364, 164984},
	{14386, 164988},
	{14407, 164992},
	{14429, 164996},
	{14450, 165000},
	{14472, 165004},
	{14493, 165008},
	{14515, 165012},
	{14536, 165016},
	{14558, 165020},
	{14579, 165024},
	{14601, 165028},
	{14622, 165032},
	{14644, 165036},
	{14665, 165040},
	{14687, 165044},
	{14708, 165048},
	{14730, 165052},
	{14751, 165056},
	{14773, 165060},
	{14794, 165064},
	{14816, 165068},
	{14837, 165072},
	{14859, 165076},
	{14880, 165080},
	{14902, 165084},
	{14923, 165088},
	{14945, 165092},
	{14966, 165096},
	{14988, 165100},
	{15009, 165104},
	{15031, 165108},
	{15052, 165112},
	{15074, 165116},
	{15095, 165120},
	{15117, 165124},
	{15138, 165128},
	{15160, 165132},
	{15181, 165136},
	{15203, 165140},
	{15224, 165144},
	{15246, 165148},
	{15267, 165152},
	{15289, 165156},
	{15310, 165160},
	{15332, 165164},
	{15354, 165168},
	{15377, 165172},
	{15399, 165176},
	{15422, 165180},
	{15444, 165184},
	{15467, 165188},
	{15489, 165192},
	{15512, 165196},
	{15534, 165200},
	{15557, 165204},
	{15579, 165208},
	{15602, 165212},
	{15624, 165216},
	{15647, 165220},
	{15669, 165224},
	{15692, 165228},
	{15714, 165232},
	{15737, 165236},
	{15759, 165240},
	{15782, 165244},
	{15804, 165248},
	{15827, 165252},
	{15849, 165256},
	{15872, 165260},
	{15894, 165264},
	{15917, 165268},
	{15939, 165272},
	{15962, 165276},
	{15984, 165280},
	{16007, 165284},
	{16029, 165288},
	{16052, 165292},
	{16074, 165296},
	{16097, 165300},
	{16119, 165304},
	{16142, 165308},
	{16156, 165312},
	{16170, 165316},
	{16184, 165320},
	{16198, 165324},
	{16212, 165328},
	{16226, 165332},
	{16240, 165336},
	{16254, 165340},
	{16268, 165344},
	{16282, 165348},
	{16296, 165352},
	{16310, 165356},
	{16324, 165360},
	{16338, 165364},
	{16352, 165368},
	{16366, 165372},
	{16380, 165376},
	{16394, 165380},
	{16408, 165384},
	{16422, 165388},
	{16436, 165392},
	{16450, 165396},
	{16464, 165400},
	{16478, 165404},
	{16501, 165444, 12, 949},
	{16521, 165448, 12, 949},
	{16541, 165452, 12, 949},
	{16561, 165456, 12, 949},
	{16581, 165460, 12, 949},
	{16601, 165464, 12, 949},
	{16621, 165468, 12, 949},
	{16641, 165472, 12, 949},
	{16661, 165476, 12, 949},
	{16681, 165480, 12, 949},
	{16701, 165484, 12, 949},
	{16722, 165488, 12, 949},
	{16743, 165492, 12, 949},
	{16764, 165496, 12, 949},
	{16785, 165500, 12, 949},
	{16806, 165504, 12, 949},
	{16827, 165508, 12, 949},
	{16848, 165512, 12, 949},
	{16869, 165516, 12, 949},
	{16890, 165520, 12, 949},
	{16911, 165524, 9, 961},
	{16932, 165528, 9, 961},
	{16953, 165532, 9, 961},
	{16974, 165536, 9, 961},
	{16995, 165540, 9, 961},
	{17016, 165544, 9, 961},
	{17037, 165548, 9, 961},
	{17058, 165552, 9, 961},
	{17079, 165556, 9, 961},
	{17100, 165560, 9, 961},
	{17121, 165564, 9, 961},
	{17142, 165568, 9, 961},
	{17163, 165572, 2, 970},
	{17181, 165580, 16, 973},
	{17198, 165584, 16, 973},
	{17216, 165588, 7, 989},
	{17237, 165592, 5, 996},
	{17255, 165600, 7, 1002},
	{17270, 165608, 2, 694},
	{17309, 165644, 4, 1010},
	{17331, 165648, 1, 1015},
	{17351, 165652, 8, 1016},
	{17373, 165716, 8, 1024},
	{17391, 165720, 8, 1032},
	{17412, 165724, 17, 1040},
	{17433, 165728, 6, 1057},
	{17451, 165732, 6, 1057},
	{17469, 165736, 6, 1057},
	{17487, 165740, 6, 1057},
	{17505, 165744, 6, 1057},
	{17523, 165748, 6, 1057},
	{17541, 165752, 6, 1057},
	{17559, 165756, 6, 1057},
	{17577, 165760, 9, 1063},
	{17595, 165764, 9, 1063},
	{17613, 165768, 9, 1063},
	{17631, 165772, 9, 1063},
	{17649, 165776, 9, 1063},
	{17667, 165780, 9, 1063},
	{17685, 165784, 9, 1063},
	{17703, 165788, 9, 1063},
	{54851, 165792, 1, 4945},
	{54866, 165796, 1, 4945},
	{54881, 165800, 1, 4945},
	{54896, 165804, 1, 4945},
	{54911, 165808, 1, 4945},
	{54926, 165812, 1, 4945},
	{54941, 165816, 1, 4945},
	{54956, 165820, 1, 4945},
	{17721, 165836, 1, 1072},
	{17735, 165840, 1, 1072},
	{17750, 165844},
	{17768, 165848},
	{17786, 165852},
	{17803, 165856},
	{17824, 165860, 1, 1073},
	{17840, 165864},
	{17853, 165872, 8, 1074},
	{17872, 165876},
	{17887, 165880, 1, 1082},
	{17936, 165888, 10, 1084},
	{17953, 165892, 12, 1094},
	{17961, 165896, 4, 4514},
	{17978, 165900, 16, 1110},
	{17996, 165904, 20, 1127},
	{18012, 165908, 15, 1147},
	{18031, 165912, 10, 1163},
	{18046, 165916, 28, 4973},
	{18064, 165920, 16, 1201},
	{18082, 165924, 4, 1217},
	{18106, 165928},
	{18131, 165932, 11, 1221},
	{18154, 165936, 6, 5001},
	{18183, 165940, 3, 5007},
	{18205, 165944, 2, 1241},
	{18220, 165948, 5, 1243},
	{18250, 165952, 6, 5010},
	{18283, 166400, 2, 1253},
	{18300, 166404, 2, 1255},
	{18319, 166408, 1, 1257},
	{18335, 166412, 4, 1258},
	{18354, 166416, 1, 1262},
	{18375, 166420, 1, 1263},
	{18388, 166424},
	{18411, 166428},
	{18434, 166432, 1, 1264},
	{18454, 166436, 4, 1265},
	{18474, 166440, 1, 1269},
	{18495, 166444, 1, 1270},
	{18510, 166448, 6, 1271},
	{18532, 166452, 6, 1271},
	{18554, 166456, 8, 1277},
	{18580, 166460, 8, 1277},
	{18606, 166464, 15, 4384},
	{18618, 166468, 3, 1300},
	{18637, 166472, 7, 1303},
	{18655, 166476, 24, 1310},
	{18673, 166480},
	{18685, 166484, 1, 1334},
	{18699, 166488, 1, 1335},
	{18713, 166492, 1, 1336},
	{18727, 166496, 1, 1337},
	{18750, 166500, 1, 1337},
	{18773, 166504, 1, 1337},
	{18796, 166508, 5, 1338},
	{18817, 166512},
	{18828, 166516},
	{18841, 166520},
	{18858, 166524, 7, 5016},
	{18877, 166528},
	{18888, 166532, 3, 1351},
	{18907, 166536},
	{18929, 166540},
	{18951, 166544, 3, 5023},
	{54971, 166548, 1, 5026},
	{18998, 166552, 4, 5027},
	{19020, 166560},
	{19045, 166564},
	{19089, 166572, 1, 1370},
	{19112, 166576, 1, 1370},
	{19135, 166580, 1, 1371},
	{19149, 166584, 1, 1372},
	{19164, 166588, 8, 5031},
	{19181, 166592, 4, 1382},
	{19208, 166596, 4, 1386},
	{19235, 166600, 4, 1390},
	{19254, 166608},
	{19280, 166612, 1, 1394},
	{19305, 166620},
	{19333, 166624},
	{19359, 166628, 1, 1394},
	{19384, 166636},
	{19412, 166640},
	{19438, 166644, 1, 1394},
	{19463, 166652},
	{19491, 166656},
	{19517, 166660, 1, 1394},
	{19542, 166668},
	{19570, 166696},
	{19601, 166700},
	{19644, 166704, 1, 1395},
	{19682, 166712, 1, 1396},
	{19721, 166736, 5, 1399},
	{19743, 166740, 13, 5039},
	{19764, 166744, 3, 1423},
	{19781, 166748, 1, 1370},
	{19802, 166752, 1, 1370},
	{19825, 166756, 1, 1370},
	{19848, 166760, 1, 1370},
	{19871, 166764, 8, 5052},
	{19884, 166768, 6, 1438},
	{19901, 166772},
	{19925, 166776, 2, 1444},
	{19955, 166780},
	{19979, 166784},
	{20009, 166788},
	{20040, 166792},
	{20069, 166796},
	{20099, 166800, 2, 1446},
	{20119, 166804, 8, 1449},
	{20138, 166808, 4, 1457},
	{20164, 166812, 3, 5023},
	{20188, 166868, 8, 1461},
	{20214, 166872, 8, 1469},
	{20240, 166876, 5, 1477},
	{20256, 166880, 6, 1482},
	{20272, 166884, 3, 1488},
	{20287, 166888},
	{20310, 166892},
	{20333, 166896},
	{20356, 166900},
	{20379, 166904, 8, 1491},
	{20413, 166908, 8, 1499},
	{20447, 166912, 8, 1507},
	{20481, 166916, 8, 1515},
	{20515, 166920, 8, 1491},
	{20549, 166924, 8, 1499},
	{20583, 166928, 8, 1507},
	{20617, 166932, 8, 1515},
	{20651, 166936, 8, 1491},
	{20685, 166940, 8, 1499},
	{20719, 166944, 8, 1507},
	{20753, 166948, 8, 1515},
	{20787, 166952, 8, 1491},
	{20821, 166956, 8, 1499},
	{20855, 166960, 8, 1507},
	{20889, 166964, 8, 1515},
	{20923, 166968, 2, 1523},
	{20947, 166972, 2, 1525},
	{20971, 166976, 3, 1527},
	{20992, 166980, 11, 5060},
	{21012, 166984, 2, 1543},
	{21032, 166988, 18, 5071},
	{21070, 166992, 1, 1565},
	{21090, 167000, 1, 1567},
	{21118, 167004, 1, 1568},
	{21139, 167008},
	{23179, 167012, 1, 1615},
	{23915, 167016, 3, 1616},
	{21186, 167020, 3, 5089},
	{21201, 167024, 16, 5092},
	{21216, 167028, 10, 5108},
	{21233, 167032, 11, 1602},
	{21255, 167036},
	{23331, 167040, 1, 1615},
	{21293, 167044},
	{23531, 167048, 1, 1615},
	{21331, 167052},
	{21353, 167056},
	{21375, 167060},
	{23731, 167064, 1, 1615},
	{21394, 167068},
	{23198, 167072, 1, 1615},
	{23933, 167076, 3, 1616},
	{21441, 167080, 3, 5089},
	{21456, 167084, 16, 5092},
	{21471, 167088, 10, 5108},
	{21488, 167092, 11, 1602},
	{21510, 167096},
	{23356, 167100, 1, 1615},
	{21548, 167104},
	{23556, 167108, 1, 1615},
	{21586, 167112},
	{21608, 167116},
	{21630, 167120},
	{23754, 167124, 1, 1615},
	{21649, 167128},
	{23217, 167132, 1, 1615},
	{23951, 167136, 3, 1616},
	{21696, 167140, 3, 5089},
	{21711, 167144, 16, 5092},
	{21726, 167148, 10, 5108},
	{21743, 167152, 11, 1602},
	{21765, 167156},
	{23381, 167160, 1, 1615},
	{21803, 167164},
	{23581, 167168, 1, 1615},
	{21841, 167172},
	{21863, 167176},
	{21885, 167180},
	{23777, 167184, 1, 1615},
	{21904, 167188},
	{23236, 167192, 1, 1615},
	{23969, 167196, 3, 1616},
	{21951, 167200, 3, 5089},
	{21966, 167204, 16, 5092},
	{21981, 167208, 10, 5108},
	{21998, 167212, 11, 1602},
	{22020, 167216},
	{23406, 167220, 1, 1615},
	{22058, 167224},
	{23606, 167228, 1, 1615},
	{22096, 167232},
	{22118, 167236},
	{22140, 167240},
	{23800, 167244, 1, 1615},
	{22159, 167248},
	{23255, 167252, 1, 1615},
	{23987, 167256, 3, 1616},
	{22206, 167260, 3, 5089},
	{22221, 167264, 16, 5092},
	{22236, 167268, 10, 5108},
	{22253, 167272, 11, 1602},
	{22275, 167276},
	{23431, 167280, 1, 1615},
	{22313, 167284},
	{23631, 167288, 1, 1615},
	{22351, 167292},
	{22373, 167296},
	{22395, 167300},
	{23823, 167304, 1, 1615},
	{22414, 167308},
	{23274, 167312, 1, 1615},
	{24005, 167316, 3, 1616},
	{22461, 167320, 3, 5089},
	{22476, 167324, 16, 5092},
	{22491, 167328, 10, 5108},
	{22508, 167332, 11, 1602},
	{22530, 167336},
	{23456, 167340, 1, 1615},
	{22568, 167344},
	{23656, 167348, 1, 1615},
	{22606, 167352},
	{22628, 167356},
	{22650, 167360},
	{23846, 167364, 1, 1615},
	{22669, 167368},
	{23293, 167372, 1, 1615},
	{24023, 167376, 3, 1616},
	{22716, 167380, 3, 5089},
	{22731, 167384, 16, 5092},
	{22746, 167388, 10, 5108},
	{22763, 167392, 11, 1602},
	{22785, 167396},
	{23481, 167400, 1, 1615},
	{22823, 167404},
	{23681, 167408, 1, 1615},
	{22861, 167412},
	{22883, 167416},
	{22905, 167420},
	{23869, 167424, 1, 1615},
	{22924, 167428},
	{23312, 167432, 1, 1615},
	{24041, 167436, 3, 1616},
	{22971, 167440, 3, 5089},
	{22986, 167444, 16, 5092},
	{23001, 167448, 10, 5108},
	{23018, 167452, 11, 1602},
	{23040, 167456},
	{23506, 167460, 1, 1615},
	{23078, 167464},
	{23706, 167468, 1, 1615},
	{23116, 167472},
	{23138, 167476},
	{23160, 167480},
	{23892, 167484, 1, 1615},
	{24203, 196608, 1, 1627},
	{24223, 196612, 1, 1628},
	{24243, 196616},
	{24263, 196620},
	{24283, 196624},
	{24304, 196628},
	{24325, 196632, 1, 1629},
	{24347, 196636, 1, 1630},
	{24369, 196640},
	{24399, 196644},
	{24429, 196648},
	{24458, 196652},
	{24487, 196656},
	{24517, 196660},
	{24547, 196664},
	{24576, 196668},
	{24605, 196672},
	{24635, 196676},
	{24665, 196680},
	{24694, 196684},
	{24723, 196688},
	{24753, 196692},
	{24783, 196696},
	{24812, 196700},
	{24841, 196704, 1, 1631},
	{24863, 196708, 1, 1632},
	{24885, 196712},
	{24908, 196716},
	{24931, 196720},
	{24954, 196724},
	{24977, 196728},
	{25000, 196732},
	{25023, 196736},
	{25047, 196740},
	{25071, 196744},
	{25095, 196748},
	{25119, 196752},
	{25143, 196756},
	{25167, 196760},
	{25191, 196764},
	{25215, 196768},
	{25237, 196772},
	{25259, 196776},
	{25280, 196780},
	{25301, 196784},
	{25325, 196788},
	{25349, 196792},
	{25373, 196796},
	{25397, 196800},
	{25421, 196804},
	{25505, 196852, 1, 4456},
	{25527, 196856, 1, 4456},
	{25549, 196860, 1, 1635},
	{25565, 196864},
	{25578, 196868},
	{25591, 196872},
	{25604, 196876},
	{25617, 196880},
	{25630, 196884},
	{25643, 196888},
	{25656, 196892},
	{25711, 196912},
	{25729, 196916},
	{25756, 196920},
	{25783, 196928, 2, 1636},
	{25796, 196932},
	{25809, 196936},
	{25832, 196940},
	{25855, 196944},
	{25883, 196948},
	{25911, 196952},
	{25939, 196956},
	{25967, 196960, 1, 1638},
	{25985, 196964, 4, 5118},
	{55001, 196968},
	{55019, 196972},
	{55046, 196976},
	{26066, 196980},
	{26085, 196984},
	{26104, 196988},
	{26128, 196992},
	{26152, 196996},
	{26176, 197000},
	{26200, 197028, 1, 1643},
	{26218, 197032, 2, 5122},
	{26236, 197036},
	{26254, 197040},
	{26272, 197044, 1, 1646},
	{26290, 197048, 2, 5124},
	{26308, 197052},
	{26326, 197056, 2, 1649},
	{26345, 197060, 5, 1651},
	{26364, 197072},
	{26388, 197076, 2, 1649},
	{26408, 197080, 5, 1651},
	{26428, 197084, 5, 5126},
	{26447, 197088, 5, 5126},
	{26465, 197092, 1, 1663},
	{26482, 197100, 1, 1664},
	{26503, 197104, 13, 1665},
	{26517, 197108},
	{26531, 197112},
	{26545, 197116, 2, 1678},
	{26561, 197120},
	{26580, 197124, 1, 1680},
	{26602, 197128},
	{26621, 197132, 1, 1681},
	{26643, 197136, 7, 1682},
	{26661, 197140},
	{26681, 197144, 1, 1680},
	{26704, 197148},
	{26724, 197152, 1, 1681},
	{26747, 197156, 7, 1682},
	{26766, 197160, 6, 5131},
	{26778, 197164, 2, 1696},
	{26795, 197168, 1, 1698},
	{26812, 197172, 1, 1699},
	{26830, 197176, 4, 1700},
	{26850, 197180, 1, 1704},
	{26867, 197184},
	{26883, 197188, 1, 1706},
	{26896, 197192, 1, 1707},
	{26910, 197196, 1, 1708},
	{26924, 197200, 1, 1709},
	{26946, 197204, 1, 1710},
	{26966, 197208, 1, 1711},
	{26988, 197212, 1, 1712},
	{27008, 197216, 1, 1707},
	{27025, 197220, 1, 1708},
	{27042, 197224},
	{52837, 197228, 1, 1706},
	{27190, 197364, 1, 1717},
	{27211, 197368, 1, 1718},
	{27231, 197372, 1, 1719},
	{27251, 197376, 1, 1718},
	{27268, 197380, 1, 1719},
	{27285, 197384, 1, 1720},
	{27301, 197388, 1, 1721},
	{27320, 197392, 1, 1722},
	{27339, 197396, 1, 1723},
	{27356, 197400, 1, 1724},
	{27374, 197404, 1, 1725},
	{27392, 197408, 1, 1726},
	{27408, 197412, 1, 1727},
	{27426, 197416, 1, 1728},
	{27444, 197420, 1, 1729},
	{27460, 197424, 1, 1724},
	{27475, 197428, 1, 1725},
	{27490, 197432, 1, 1726},
	{27503, 197436, 1, 1727},
	{27518, 197440, 1, 1728},
	{27533, 197444, 1, 1729},
	{27546, 197448, 1, 1730},
	{27560, 197452, 1, 1731},
	{27574, 197456, 1, 1732},
	{27586, 197460, 4, 5137},
	{27609, 197464, 3, 1737},
	{27631, 197468, 1, 1740},
	{27775, 197552, 1, 1745},
	{27800, 197556, 1, 1745},
	{27824, 197560, 1, 1746},
	{27844, 197568},
	{27870, 197572, 1, 1628},
	{27899, 197576},
	{27924, 197580, 1, 1628},
	{27952, 197584},
	{27975, 197588, 1, 1628},
	{28001, 197592},
	{28023, 197596, 1, 1628},
	{28048, 197600},
	{28067, 197604, 1, 1628},
	{28089, 197608, 1, 1343},
	{28103, 197612},
	{28120, 197616, 1, 1628},
	{28140, 197620, 8, 1747},
	{28157, 197624, 13, 1755},
	{28174, 197628},
	{28191, 197632, 1, 1698},
	{28211, 197636},
	{28228, 197640, 1, 1663},
	{28248, 197644, 2, 1768},
	{28267, 197888, 8, 5141},
	{28288, 197892, 8, 5141},
	{28309, 198656, 6, 2946},
	{48526, 198916},
	{28370, 198920, 1, 1784},
	{28389, 198924, 2, 5149},
	{28404, 198928},
	{28437, 198932},
	{28470, 198936},
	{28503, 198940},
	{13796, 198944},
	{13813, 198948},
	{13830, 198952},
	{18971, 198956, 2, 1357},
	{28593, 198960},
	{28609, 198964},
	{49020, 198968, 1, 1785},
	{49052, 198972, 2, 1786},
	{49073, 198976},
	{55073, 198980, 1, 830},
	{28715, 198984},
	{28731, 198988, 1, 830},
	{28750, 198992},
	{28770, 198996, 1, 830},
	{28793, 199000},
	{28811, 199004, 1, 830},
	{19070, 199008, 9, 1788},
	{28873, 199016},
	{29013, 199168, 1, 1809},
	{29038, 199172, 2, 1810},
	{29063, 199184, 2, 1812},
	{29089, 199188, 2, 1812},
	{29115, 199192, 2, 1812},
	{29141, 199212, 2, 1812},
	{29167, 199296, 2, 1814},
	{29195, 199300, 1, 1816},
	{29219, 199304, 1, 1817},
	{29243, 199308, 1, 1818},
	{29276, 199312, 1, 1818},
	{29304, 199328, 2, 1814},
	{29333, 199332, 1, 1816},
	{29358, 199336, 1, 1817},
	{29383, 199340, 1, 1818},
	{29417, 199344, 1, 1818},
	{29446, 199360, 2, 1814},
	{29470, 199364, 1, 1816},
	{29490, 199368, 1, 1817},
	{29510, 199372, 1, 1818},
	{29539, 199376, 1, 1818},
	{18265, 199380},
	{49639, 199872},
	{49660, 199876, 1, 3506},
	{2095, 199880, 7, 4060},
	{2116, 199884, 3, 3515},
	{49681, 199888, 2, 3518},
	{2143, 199892, 1, 3542},
	{49707, 199896, 15, 5151},
	{50710, 199900, 1, 4069},
	{50732, 199904},
	{2074, 199908, 2, 3520},
	{2164, 199912, 6, 5166},
	{49749, 199916, 1, 3543},
	{49728, 199920},
	{29563, 199936},
	{29590, 199940},
	{29617, 199944},
	{29644, 199948},
	{29779, 199968, 6, 1819},
	{29790, 199972, 2, 1826},
	{29804, 200192},
	{29823, 200196, 1, 840},
	{29845, 200448},
	{29869, 200452, 1, 1828},
	{29892, 200456},
	{29916, 200460, 1, 1828},
	{29939, 200464},
	{29963, 200468, 1, 1828},
	{29986, 200472},
	{30010, 200476, 1, 1828},
	{30033, 200696},
	{30052, 200700, 1, 1828},
	{30070, 200704},
	{30082, 200708},
	{30094, 200712},
	{30112, 200716},
	{30131, 200720},
	{30149, 200724},
	{30161, 200728},
	{30173, 200732},
	{30191, 200736},
	{30209, 200740},
	{30228, 200744, 4, 1829},
	{30242, 200748, 2, 1833},
	{30260, 200752, 2, 1835},
	{30274, 200756, 2, 1837},
	{30288, 200760, 2, 1839},
	{30305, 200764, 2, 1841},
	{30322, 200768},
	{30335, 200772, 2, 1843},
	{30347, 200776},
	{30361, 200780},
	{30377, 200784},
	{30391, 200788},
	{30407, 200792},
	{30422, 200796},
	{30439, 200800},
	{30454, 200804},
	{30471, 200808, 2, 1845},
	{30493, 200812, 10, 5172},
	{30510, 200816, 2, 1857},
	{30531, 200820, 2, 1859},
	{30543, 200824},
	{30558, 200828, 6, 4503},
	{30573, 200832, 2, 1867},
	{30587, 200836},
	{2495, 200960, 9, 429},
	{55095, 200964, 11, 5182},
	{55113, 200968, 2, 5193},
	{55131, 200972, 4, 5195},
	{30700, 212992},
	{30720, 212996},
	{30740, 213000},
	{30760, 213004},
	{30780, 213008},
	{30800, 213012},
	{30820, 213016},
	{30840, 213020},
	{30860, 213024},
	{30880, 213028},
	{30900, 213032},
	{30920, 213036},
	{30940, 213040},
	{30963, 213044},
	{30986, 213048},
	{31009, 213248},
	{31030, 213252},
	{31051, 213260},
	{31072, 213264},
	{31093, 213268},
	{31117, 213272},
	{31141, 213276},
	{31165, 213280},
	{31189, 213284},
	{31213, 213288},
	{31237, 213292},
	{31261, 213296},
	{50822, 213504},
	{50841, 213508},
	{50860, 213512},
	{50879, 213516},
	{50898, 213520},
	{50917, 213524},
	{50936, 213528},
	{50955, 213532},
	{48217, 213536},
	{48236, 213540},
	{48255, 213544},
	{48274, 213548},
	{48293, 213552},
	{48312, 213556},
	{48331, 213560},
	{48350, 213564},
	{48808, 213568},
	{48828, 213572},
	{48848, 213576},
	{48868, 213580},
	{48888, 213584},
	{48908, 213588},
	{48928, 213592},
	{48948, 213596},
	{31745, 214016},
	{31767, 214020, 1, 1869},
	{31789, 214024},
	{31811, 214028, 1, 1869},
	{31833, 214032},
	{31855, 214036, 1, 1869},
	{31877, 214040},
	{31899, 214044, 1, 1869},
	{31921, 214272},
	{31943, 214276},
	{31965, 214280},
	{31987, 214284},
	{32009, 214288},
	{32031, 214292},
	{32053, 214296},
	{32075, 214300},
	{32097, 214304},
	{32119, 214308},
	{32141, 214312},
	{32163, 214316},
	{32185, 214320},
	{32207, 214324},
	{32229, 214328},
	{32251, 214332},
	{32273, 214528},
	{32293, 214532},
	{32313, 214536},
	{32333, 214540},
	{32353, 214544},
	{32373, 214548},
	{32393, 214552},
	{32413, 214556},
	{32433, 214560},
	{32453, 214564},
	{32473, 214568},
	{32493, 214572},
	{32513, 214784},
	{32532, 214788},
	{32551, 214792},
	{32570, 214796},
	{32589, 214800},
	{32608, 214804},
	{32627, 214808},
	{32646, 214812},
	{32665, 214816},
	{32684, 214820},
	{32703, 214824},
	{32722, 214828},
	{32741, 214832},
	{32760, 214836},
	{32779, 214840},
	{32798, 214844},
	{32817, 214848},
	{32836, 214852},
	{32855, 214856},
	{32874, 214860},
	{32893, 214864},
	{32913, 214868},
	{32933, 214872},
	{32953, 214876},
	{32973, 214880},
	{32993, 214884},
	{33013, 214888},
	{33033, 214892},
	{33053, 214896},
	{33073, 214900},
	{33093, 214904},
	{33113, 214908},
	{33133, 215296},
	{33152, 215300},
	{33171, 215304},
	{33190, 215308},
	{33209, 215312},
	{33228, 215316},
	{33247, 215320},
	{33266, 215324},
	{33327, 215552},
	{33347, 215556},
	{33367, 215560},
	{33387, 215564},
	{33407, 215568},
	{33427, 215572},
	{33447, 215576},
	{33467, 215580},
	{33487, 215808},
	{33506, 215812},
	{33525, 215816},
	{33544, 215820},
	{33563, 216064},
	{33582, 216068},
	{33601, 216072},
	{33620, 216076},
	{33639, 216320},
	{33659, 216324},
	{33679, 216328},
	{33699, 216332},
	{33719, 216336},
	{33739, 216340},
	{33759, 216344},
	{33779, 216348},
	{50974, 216576},
	{50994, 216580},
	{51014, 216584},
	{51034, 216588},
	{51054, 216592},
	{51074, 216596},
	{51094, 216600},
	{51114, 216604},
	{51134, 216640},
	{51154, 216644},
	{51174, 216648},
	{51194, 216652},
	{51214, 216656},
	{51234, 216660},
	{51254, 216664},
	{51274, 216668},
	{34631, 217112},
	{34650, 217116},
	{34669, 217120},
	{34688, 217124},
	{34707, 217128},
	{34726, 217132},
	{34745, 217136},
	{34764, 217140},
	{34783, 217344},
	{34802, 217348},
	{34821, 217352},
	{34840, 217356},
	{34859, 217360},
	{34878, 217364},
	{34897, 217368},
	{34916, 217372},
	{34935, 217600},
	{34955, 217604},
	{34975, 217608},
	{34995, 217612},
	{35015, 217856},
	{35035, 217860},
	{35055, 217864},
	{35075, 217868},
	{35095, 217872},
	{35115, 217876},
	{35135, 217880},
	{35155, 217884},
	{35178, 218112},
	{35203, 218116, 2, 1870},
	{35227, 218144},
	{35253, 218148, 2, 1870},
	{36317, 221184, 5, 5199},
	{36341, 221188, 4, 5204},
	{36366, 221192, 5, 5199},
	{36390, 221196, 5, 5199},
	{36414, 221200, 4, 5204},
	{36439, 221204, 5, 5199},
	{36463, 221208, 4, 5204},
	{36488, 221212, 5, 5199},
	{36512, 221216, 4, 1881},
	{36528, 221220, 5, 5199},
	{36552, 221224, 3, 1885},
	{36586, 221228, 3, 1888},
	{36620, 221232, 3, 1891},
	{36645, 221236, 3, 1894},
	{36670, 221240, 3, 5208},
	{36695, 221248},
	{36710, 221252, 1, 1818},
	{36733, 221256},
	{36756, 221260},
	{36774, 221264, 2, 1897},
	{36792, 221268, 4, 1899},
	{36812, 221440, 22, 5211},
	{36837, 221444, 22, 5211},
	{36862, 221448, 13, 5233},
	{36890, 221452, 13, 5233},
	{36918, 221456, 13, 5233},
	{36946, 221460, 13, 5233},
	{51454, 221696, 2, 3287},
	{51477, 221700, 2, 3287},
	{51500, 221704, 2, 3287},
	{51523, 221708, 2, 3287},
	{48125, 221712, 5, 1957},
	{48148, 221716, 2, 3287},
	{48171, 221720, 2, 3287},
	{48194, 221724, 2, 3287},
	{51546, 221728, 4, 1962},
	{48712, 221744, 5, 1957},
	{48736, 221748, 5, 1957},
	{48760, 221752, 2, 3287},
	{48784, 221756, 2, 3287},
	{51570, 221760, 4, 1962},
	{51595, 221764, 4, 1962},
	{48686, 221776, 1, 3328},
	{37404, 222208, 5, 1957},
	{37430, 222212, 4, 1962},
	{37457, 222216, 5, 1957},
	{37483, 222220, 4, 1962},
	{37510, 222224, 3, 2013},
	{37563, 222228, 3, 2013},
	{37616, 222464, 5, 1957},
	{37642, 222468, 4, 1962},
	{37669, 222472, 1, 1872},
	{37695, 222476, 1, 1872},
	{37721, 222480, 1, 1872},
	{37747, 222484, 1, 1872},
	{37773, 222488, 1, 1872},
	{37799, 222492, 1, 1872},
	{37825, 222496, 1, 1872},
	{37851, 222720, 5, 1957},
	{37875, 222724, 5, 1957},
	{37899, 222728, 5, 1957},
	{37923, 222732, 5, 1957},
	{37947, 222736, 4, 1962},
	{37972, 222740, 4, 1962},
	{37997, 222744, 4, 1962},
	{38022, 222748, 4, 1962},
	{38047, 222752, 1, 2001},
	{38071, 222756, 1, 2001},
	{38095, 222760, 8, 1966},
	{38116, 222976, 6, 3486},
	{38139, 222980, 6, 3486},
	{38162, 222984, 6, 3486},
	{38185, 222988, 6, 3486},
	{38208, 222992, 6, 3486},
	{38231, 222996, 6, 3486},
	{38254, 223000, 6, 3486},
	{38277, 223004, 6, 3486},
	{38300, 223008, 6, 3486},
	{38323, 223012, 6, 3486},
	{38346, 223016, 6, 3486},
	{38370, 223020, 6, 3486},
	{38394, 223024, 6, 3486},
	{38418, 223028, 6, 3486},
	{38442, 223032, 6, 3486},
	{38466, 223036, 6, 3486},
	{38490, 223104, 9, 3469},
	{51620, 223108, 2, 3518},
	{38510, 223112, 1, 1987},
	{38605, 223488, 5, 1957},
	{38628, 223492, 5, 1957},
	{38651, 223496, 3, 2013},
	{38674, 223500, 3, 2013},
	{38697, 223504, 4, 1962},
	{38721, 223508, 4, 1962},
	{38745, 223744, 5, 1957},
	{38769, 223748, 5, 1957},
	{38793, 223752, 5, 1957},
	{38817, 223756, 5, 1957},
	{38841, 223760, 4, 1962},
	{38866, 224000, 5, 2001},
	{38889, 224004, 4, 2006},
	{38913, 224008, 3, 2010},
	{38936, 224256, 5, 2001},
	{38959, 224260, 4, 2006},
	{38983, 224264, 3, 2010},
	{39006, 224512, 5, 1957},
	{39030, 224516, 4, 1962},
	{39055, 224520, 5, 1957},
	{39079, 224524, 4, 1962},
	{39104, 224528, 3, 2013},
	{39128, 224532, 3, 2013},
	{51640, 224768, 5, 1957},
	{51664, 224772, 4, 1951},
	{51689, 224776, 5, 1957},
	{51713, 224780, 4, 1951},
	{51738, 224784, 3, 2013},
	{51762, 224788, 3, 2013},
	{51786, 224832, 5, 1957},
	{51810, 224836, 4, 1951},
	{51835, 224840, 5, 1957},
	{51859, 224844, 4, 1951},
	{51884, 224848, 3, 2013},
	{51908, 224852, 3, 2013},
	{39829, 225280, 12, 2016},
	{39851, 225284, 5, 2028},
	{39874, 225288, 4, 2033},
	{39898, 225292, 2, 2037},
	{39921, 225296, 2, 2037},
	{39944, 225300, 2, 2037},
	{39967, 225536, 5, 1957},
	{39990, 225540, 4, 1962},
	{40014, 225544, 5, 1957},
	{40037, 225548, 4, 1962},
	{40061, 225552, 5, 1957},
	{40084, 225560, 5, 1957},
	{40107, 225792, 4, 2039},
	{40128, 225796},
	{40157, 225800, 2, 2043},
	{40186, 225804},
	{40212, 225808, 7, 2045},
	{40286, 225812},
	{40309, 225816},
	{52053, 225820, 2, 4120},
	{52086, 225824, 2, 4120},
	{52119, 225828, 2, 4120},
	{52152, 225832, 2, 4120},
	{52184, 225836, 2, 4120},
	{52216, 225840, 2, 4120},
	{52248, 225844, 2, 4120},
	{52281, 225848, 2, 4120},
	{52313, 225856, 2, 4120},
	{52345, 225860, 2, 4120},
	{52378, 225864, 2, 4120},
	{52411, 225868, 2, 4120},
	{52444, 225872, 2, 4120},
	{52476, 225876, 2, 4120},
	{52508, 225880, 2, 4120},
	{52541, 225884, 2, 4120},
	{52574, 225888, 2, 4120},
	{52640, 225896, 2, 4120},
	{40332, 225900},
	{40359, 225904},
	{40241, 225908},
	{40260, 225912},
	{55151, 225932, 2, 4120},
	{55184, 225936, 2, 5246},
	{41250, 226040, 1, 2129},
	{41229, 226044, 1, 2129},
	{41022, 226048, 2, 2119},
	{41039, 226052, 1, 2121},
	{41063, 226056, 1, 2121},
	{41087, 226060, 4, 2122},
	{41113, 226064, 3, 2126},
	{41142, 226068, 1, 687},
	{41171, 226072, 3, 2126},
	{41200, 226076, 1, 687},
	{41277, 226304, 5, 2028},
	{41301, 226308, 4, 2033},
	{41326, 226312, 2, 2037},
	{41350, 226316, 5, 2028},
	{41374, 226320, 4, 2033},
	{41399, 226324, 2, 2037},
	{41423, 226328, 10, 2130},
	{41448, 226560, 5, 2140},
	{41475, 226564, 5, 2140},
	{41502, 226568, 6, 2145},
	{41533, 226608, 5, 2140},
	{41561, 226612, 5, 2140},
	{41589, 226616, 5, 2140},
	{41617, 226620, 5, 2140},
	{41645, 226624, 5, 2140},
	{41673, 226628, 5, 2140},
	{41701, 226632, 5, 2140},
	{41729, 226636, 5, 2140},
	{41757, 226640, 6, 2145},
	{195, 880, 4, 2156},
	{42808, 881},
	{26631, 882},
	{42820, 1008},
	{42831, 1009},
	{26819, 1010, 3, 2160},
	{42842, 1040, 1, 2163},
	{42855, 1041, 5, 2164},
	{42868, 1042, 1, 2169},
	{42881, 1043, 1, 1681},
	{26653, 1045, 7, 2170},
	{42909, 1280, 6, 2189},
	{42924, 1281},
	{26590, 1282},
	{42808, 1283},
	{26631, 1284},
};

static const struct si_field sid_fields_table[] = {
	/* 0 */
	{55217, 0xF},
	{55226, 0xF0},
	{55236, 0x100},
	{55247, 0x200},
	{55252, 0x400},
	{55379, 0x1FF000, 257, 0},
	{55387, 0x800000},
	{55397, 0x8000000},
	{55410, 0x10000000},
	{55416, 0xE0000000},
	/* 10 */
	{55420, 0x1},
	{55424, 0x6},
	{55433, 0x18},
	{55443, 0x20},
	{55448, 0x40},
	{55456, 0x80},
	{55466, 0x100},
	{55477, 0x200},
	{55483, 0x400},
	{55488, 0x800},
	{55494, 0x1000},
	{55505, 0x2000},
	{55510, 0x4000},
	{55515, 0x8000},
	{55266, 0x10000},
	{55530, 0x20000},
	{55538, 0x40000},
	{55550, 0x80000},
	{55558, 0x800000},
	{55569, 0x8000000},
	/* 30 */
	{55581, 0x1FF, 257, 0},
	{55586, 0x400},
	{55594, 0x800},
	{55607, 0x7000},
	{55615, 0x8000},
	{55626, 0xF0000},
	{55637, 0xF00000},
	{55653, 0x1000000},
	{55667, 0x10000000},
	{55679, 0xE0000000},
	/* 40 */
	{50478, 0xF},
	{55687, 0x30},
	{55695, 0xC0},
	{55703, 0xF00},
	{55709, 0x1000},
	{28888, 0x6000},
	{55715, 0x8000},
	{55727, 0xF0000},
	{55733, 0xF00000},
	{55739, 0x7000000},
	{55748, 0x38000000},
	{55757, 0xC0000000},
	/* 52 */
	{55763, 0xFF},
	{55773, 0xFF00},
	{55783, 0xFF0000},
	{55793, 0xF000000},
	/* 56 */
	{55803, 0x1FF},
	{55812, 0x1FF000},
	{55821, 0xF000000},
	/* 59 */
	{55838, 0xF},
	{55845, 0x70},
	{55853, 0x80},
	{55867, 0xF00},
	{55876, 0x7000},
	{55885, 0x8000},
	{55898, 0x3F0000},
	{55903, 0xC00000},
	{55913, 0x1000000},
	{55927, 0x2000000},
	{55939, 0xFC000000},
	/* 70 */
	{1112, 0xFFFF},
	/* 71 */
	{55667, 0x1},
	{55946, 0x2},
	{55952, 0x4},
	{55966, 0x8},
	{55981, 0x3F0},
	{55986, 0x1F800},
	{55898, 0xFC0000},
	{55991, 0x1000000},
	{56001, 0xFE000000},
	/* 80 */
	{50478, 0x1F},
	{55687, 0x300},
	{56010, 0x3C00},
	{56017, 0x10000},
	{28888, 0xC0000},
	/* 85 */
	{55739, 0xF},
	{55695, 0x30},
	{55757, 0x300},
	{55748, 0x7000},
	{56023, 0x1F0000},
	{55733, 0xF000000},
	{56029, 0x60000000},
	/* 92 */
	{56042, 0x1},
	{56050, 0x6},
	/* 94 */
	{56065, 0x3},
	/* 95 */
	{30356, 0x3F},
	{10081, 0xFC0},
	{10099, 0x3F000},
	{30331, 0xFC0000},
	/* 99 */
	{56074, 0x3},
	{56088, 0x80},
	{56106, 0x300},
	{56116, 0x400},
	{56129, 0x800},
	{55658, 0x1000},
	{56136, 0x2000},
	/* 106 */
	{56146, 0xF},
	{56169, 0x10},
	{56192, 0x20},
	{56215, 0x40},
	{56235, 0x80},
	{56255, 0x100},
	{56275, 0x200},
	{56295, 0x400},
	{56315, 0x800},
	{56335, 0x1000},
	{56355, 0x2000},
	{56375, 0x4000},
	{56390, 0x8000},
	{56401, 0x10000},
	{56409, 0x20000},
	{56418, 0x40000},
	{56435, 0x80000},
	{56450, 0x100000},
	{56463, 0x200000},
	{56473, 0x400000},
	{56490, 0x800000},
	{56507, 0x1000000},
	{56516, 0x2000000},
	{56525, 0x10000000},
	{56534, 0x20000000},
	{56543, 0x40000000},
	{56552, 0x80000000},
	/* 133 */
	{56563, 0xF},
	{56586, 0x20},
	{56602, 0x80},
	{56625, 0x100},
	{56648, 0x200},
	{56667, 0x1000},
	{56676, 0x2000},
	{56685, 0x4000},
	{56693, 0x8000},
	{56702, 0x10000},
	{56717, 0x100000},
	{56725, 0x200000},
	{56733, 0x400000},
	{56742, 0x800000},
	{56751, 0x1000000},
	{56759, 0x2000000},
	{56767, 0x4000000},
	{56775, 0x10000000},
	{56517, 0x20000000},
	{56793, 0x40000000},
	{56801, 0x80000000},
	/* 154 */
	{56667, 0x2},
	{56676, 0x4},
	{56812, 0x8},
	{56516, 0x10},
	{56823, 0x20},
	{56409, 0x200000},
	{56742, 0x400000},
	{56759, 0x1000000},
	{56685, 0x2000000},
	{56717, 0x4000000},
	{56733, 0x8000000},
	{56751, 0x20000000},
	{56767, 0x40000000},
	{56793, 0x80000000},
	/* 168 */
	{56834, 0x20},
	{56863, 0x40},
	{56894, 0x80},
	{56923, 0x100},
	{56943, 0x200},
	{56963, 0x400},
	{56983, 0x800},
	{57003, 0x2000},
	{57011, 0x4000},
	{57019, 0x8000},
	{56823, 0x10000},
	{57030, 0x10000000},
	{57044, 0x20000000},
	{56812, 0x40000000},
	{57053, 0x80000000},
	/* 183 */
	{57062, 0x1},
	{57072, 0x2},
	{57082, 0x4},
	{57091, 0x8},
	{57100, 0x10},
	{57111, 0x20},
	{57122, 0x40},
	{57132, 0x80},
	{57142, 0x400},
	{57152, 0x800},
	{57169, 0x1000},
	{57177, 0x2000},
	{57190, 0x4000},
	{57208, 0x8000},
	{57219, 0x10000},
	{57228, 0x20000},
	{57249, 0x40000},
	{57260, 0x80000},
	{57287, 0x20000000},
	{57300, 0x40000000},
	{56534, 0x80000000},
	/* 204 */
	{57313, 0x1},
	{57328, 0x2},
	{57348, 0x4},
	{57364, 0x8},
	{57382, 0x10},
	{57402, 0x20},
	{57421, 0x40},
	{57440, 0x80},
	{57453, 0x100},
	{57467, 0x200},
	{57491, 0x400},
	{57507, 0x800},
	{57523, 0x1000},
	{57539, 0x2000},
	{57555, 0x10000},
	{57570, 0x20000},
	{57590, 0x40000},
	{57606, 0x80000},
	{57624, 0x100000},
	{57644, 0x200000},
	{57663, 0x400000},
	{57682, 0x800000},
	{57695, 0x1000000},
	{57709, 0x2000000},
	{57733, 0x4000000},
	{57749, 0x8000000},
	{57765, 0x10000000},
	{57781, 0x20000000},
	/* 232 */
	{57797, 0x8},
	{57816, 0x10},
	{57836, 0x40},
	{57855, 0x100},
	{57876, 0x200},
	{57894, 0x400},
	{57917, 0x2000},
	{57939, 0x10000},
	{57960, 0x20000},
	{57978, 0x40000},
	{58001, 0x200000},
	{58023, 0x400000},
	{58047, 0x800000},
	{58071, 0x1000000},
	{58094, 0x2000000},
	/* 247 */
	{58116, 0x1},
	{58135, 0x2},
	{58144, 0x10},
	{58159, 0x20},
	{58173, 0x40},
	{58192, 0x80},
	{58211, 0x100},
	{58226, 0x200},
	{58243, 0x400},
	{58265, 0x800},
	{58287, 0x1000},
	{58302, 0x2000},
	{57142, 0x4000},
	{58317, 0x8000},
	{58326, 0x10000},
	{57177, 0x20000},
	{58335, 0x40000},
	{58345, 0x80000},
	{58359, 0x100000},
	{58373, 0x200000},
	{58387, 0x400000},
	{57208, 0x800000},
	{58404, 0x1000000},
	{58417, 0x4000000},
	{58430, 0x8000000},
	{58443, 0x30000000},
	{58462, 0x40000000},
	{56525, 0x80000000},
	/* 275 */
	{58475, 0x1},
	{58493, 0x2},
	{58507, 0x4},
	{58526, 0x8},
	{58545, 0x10},
	{58560, 0x20},
	{58578, 0x40},
	{58596, 0x80},
	{58613, 0x100},
	{58628, 0x200},
	{58642, 0x400},
	{58659, 0x800},
	{58683, 0x1000},
	{58701, 0x2000},
	{58719, 0x4000},
	{58740, 0x8000},
	{58764, 0x10000},
	{58790, 0x20000},
	{58807, 0x40000},
	{58827, 0x80000},
	{58847, 0x100000},
	{58867, 0x200000},
	{58888, 0x400000},
	{58911, 0x800000},
	{58932, 0x1000000},
	{58951, 0x2000000},
	{58968, 0x4000000},
	{58984, 0x8000000},
	{59000, 0x10000000},
	{59016, 0x20000000},
	{59035, 0x40000000},
	{59047, 0x80000000},
	/* 307 */
	{59059, 0x1},
	{59078, 0x2},
	{59098, 0x4},
	{59118, 0x8},
	{59138, 0x20},
	{59159, 0x40},
	{58023, 0x80},
	{58047, 0x100},
	{59180, 0x200},
	{59207, 0x400},
	{59234, 0x800},
	{59255, 0x1000},
	{59274, 0x2000},
	/* 320 */
	{59293, 0x1},
	{59307, 0x4},
	{59322, 0x8},
	{59339, 0x80},
	{59351, 0x100},
	{59364, 0x400},
	{59379, 0x800},
	{59394, 0x1000},
	{59409, 0x2000},
	/* 329 */
	{1854, 0x3F},
	/* 330 */
	{1872, 0x1FF},
	{59424, 0x80000000},
	/* 332 */
	{1854, 0x7},
	/* 333 */
	{59449, 0x1000},
	{59471, 0x4000},
	{59496, 0x20000},
	{59517, 0x40000},
	{59541, 0x400000},
	{59568, 0x800000},
	{59593, 0x1000000},
	{59616, 0x8000000},
	{59636, 0x40000000},
	/* 342 */
	{1859, 0xF},
	/* 343 */
	{10060, 0xF},
	{38, 0x3FFFFF00},
	/* 345 */
	{754, 0x1FFFFFFF},
	{59652, 0x80000000},
	/* 347 */
	{59662, 0x3},
	{59671, 0xF0},
	{59679, 0x200},
	{59686, 0x1FC00},
	/* 351 */
	{59957, 0xFFF, 2049, 257},
	{60119, 0xFF0000, 129, 2306},
	{60131, 0x3000000},
	{60144, 0x80000000},
	/* 355 */
	{982, 0x3},
	{60159, 0x4},
	{60168, 0x8},
	{60179, 0x10},
	{60192, 0x20},
	{49765, 0x1C0},
	{60206, 0x200},
	{60219, 0x400},
	{60232, 0x800},
	{60244, 0x1000},
	{60262, 0x2000},
	{60273, 0xC000},
	{60288, 0x30000},
	{60296, 0x40000},
	{60315, 0x80000},
	{60332, 0x40000000},
	{60344, 0x80000000},
	/* 372 */
	{60358, 0xFFF},
	{60373, 0xFFF000},
	{60385, 0x1000000},
	{56396, 0x2000000},
	{60393, 0x4000000},
	{60413, 0x8000000},
	/* 378 */
	{13925, 0xF},
	{60501, 0x3F0, 33, 2435},
	{60505, 0x400},
	{60380, 0x800},
	{60511, 0x1000},
	/* 383 */
	{60514, 0xFFFF},
	{19675, 0x3FFF0000},
	{60530, 0x40000000},
	{60544, 0x80000000},
	/* 387 */
	{60559, 0x7},
	{60569, 0x38},
	{60579, 0x1C0},
	{60589, 0xE00},
	{17302, 0x7F000, 293, 2468},
	{64826, 0x600000},
	{64839, 0x800000},
	{64854, 0x1000000},
	{64960, 0x30000000, 4, 2761},
	{209, 0xC0000000},
	/* 397 */
	{64971, 0x7},
	{64979, 0x38},
	{64987, 0x1C0},
	{64995, 0xE00},
	{65011, 0x7000},
	{65030, 0x8000},
	{65049, 0x70000},
	{65065, 0x80000},
	{65080, 0x100000},
	{65094, 0x7E00000},
	{65105, 0x8000000},
	{65117, 0x10000000},
	{65135, 0x60000000},
	{65147, 0x80000000},
	/* 411 */
	{65160, 0xFFF},
	{65168, 0xFFF000},
	{65176, 0xF000000},
	{65185, 0xF0000000},
	/* 415 */
	{65192, 0x3FFF},
	{65201, 0xFFF},
	{65218, 0x3000},
	{65236, 0xFC000},
	{65249, 0x300000},
	{65263, 0xC00000},
	{65277, 0x3000000},
	{65286, 0xC000000},
	{65297, 0x10000000},
	{65316, 0x20000000},
	{65331, 0x40000000},
	{65346, 0x80000000},
	/* 427 */
	{65201, 0xFFF},
	{65218, 0xC0000000},
	/* 429 */
	{65362, 0x1FFFFF},
	{65381, 0xE00000},
	{65400, 0x1000000},
	{65422, 0x2000000},
	{65444, 0x4000000},
	{65460, 0x8000000},
	{65477, 0x10000000},
	{65495, 0x20000000},
	{65511, 0xC0000000},
	/* 438 */
	{65532, 0x7},
	{65542, 0x38},
	{65563, 0xC0},
	{65584, 0x180000},
	{65603, 0xC000000},
	/* 443 */
	{65973, 0x3C, 16, 2765},
	{66401, 0x7C0, 19, 2781},
	{66591, 0x3800, 7, 2800},
	{66750, 0x1C00000, 5, 2807},
	{66770, 0x6000000},
	/* 448 */
	{66875, 0x3, 4, 2812},
	{66982, 0xC, 4, 2816},
	{67094, 0x30, 4, 2820},
	{67181, 0xC0, 4, 2824},
	/* 452 */
	{60514, 0xFF},
	{65160, 0xFFF00},
	{17302, 0x1FF00000, 293, 2468},
	{67191, 0xC0000000},
	/* 456 */
	{67200, 0xFFF},
	{66987, 0xFFFC000},
	{64854, 0x80000000},
	/* 459 */
	{60559, 0x7},
	{60569, 0x38},
	{60579, 0x1C0},
	{60589, 0xE00},
	{67209, 0xF000},
	{67220, 0xF0000},
	{67231, 0x1F00000},
	{67335, 0xE000000, 6, 2828},
	{209, 0xF0000000},
	/* 468 */
	{18448, 0x1FFF},
	{67346, 0x1FFF0000},
	/* 470 */
	{67357, 0xF},
	{67369, 0xF0},
	{67377, 0xFFF00},
	{67390, 0x700000},
	{67399, 0x800000},
	{67414, 0x2000000},
	{67429, 0x4000000},
	/* 477 */
	{67441, 0xFF},
	{67457, 0x400},
	{67469, 0x18000},
	{67497, 0x60000},
	{67523, 0x80000},
	{67541, 0x100000},
	{67563, 0x200000},
	{67578, 0x400000},
	{67594, 0x800000},
	{67610, 0xFF000000},
	/* 487 */
	{67631, 0xFFFF},
	/* 488 */
	{67631, 0xFFFF},
	{67637, 0x3F0000},
	{67648, 0x3C00000},
	/* 491 */
	{67667, 0xFF},
	/* 492 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{67742, 0x800000},
	{67752, 0x1000000},
	{67769, 0x2000000},
	{56116, 0x4000000},
	{55387, 0x20000000},
	/* 503 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{67815, 0x80},
	{67827, 0xFF00},
	{55379, 0x1FF0000, 257, 0},
	{67842, 0x2000000},
	{67864, 0x4000000},
	{67889, 0x8000000},
	{67903, 0xF0000000},
	/* 513 */
	{67919, 0x1},
	{67936, 0x1E},
	{67962, 0x1E0},
	{67995, 0x200},
	{68016, 0x7C00},
	{68040, 0x8000},
	{68065, 0x10000},
	{68084, 0xE0000},
	/* 521 */
	{68121, 0x7},
	{68150, 0x38},
	{68182, 0x40},
	{68198, 0xFF00},
	{68227, 0xFF0000},
	/* 526 */
	{68259, 0x7F},
	/* 527 */
	{67642, 0x3F},
	/* 528 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{67742, 0x800000},
	{68272, 0x3000000},
	{68286, 0x4000000},
	{67769, 0x8000000},
	{56116, 0x10000000},
	{55387, 0x80000000},
	/* 540 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{68302, 0x80},
	{68312, 0x100},
	{68324, 0x200},
	{68336, 0x400},
	{68348, 0x800},
	{68360, 0x1000},
	{55379, 0x3FE000, 257, 0},
	{68366, 0x400000},
	{68377, 0x1000000},
	{67889, 0x8000000},
	{67903, 0xF0000000},
	/* 554 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{55379, 0xFF80, 257, 0},
	{68272, 0x30000},
	{68302, 0x40000},
	{55812, 0x7F80000},
	{68394, 0x8000000},
	{67889, 0x10000000},
	/* 563 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{68302, 0x80},
	{55379, 0x1FF00, 257, 0},
	{55812, 0x1FF00000},
	/* 569 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{55812, 0xFF80},
	{55379, 0x1FF0000, 257, 0},
	/* 574 */
	{67631, 0xFFFF},
	{68406, 0x7F0000},
	/* 576 */
	{67631, 0xFFFF},
	{67637, 0x3F0000},
	{67648, 0x3C00000},
	{68431, 0xFC000000},
	/* 580 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{67742, 0x800000},
	{68286, 0x1000000},
	{67769, 0x2000000},
	{56116, 0x4000000},
	{68448, 0x8000000},
	{68457, 0x60000000},
	{55387, 0x80000000},
	/* 593 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{55379, 0xFF80, 257, 0},
	{68474, 0x30000},
	{68302, 0x40000},
	{55812, 0x7F80000},
	{67889, 0x8000000},
	{67903, 0xF0000000},
	/* 602 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{67742, 0x800000},
	{68272, 0x3000000},
	{68286, 0x4000000},
	{55387, 0x80000000},
	/* 612 */
	{67637, 0x3F},
	{67648, 0x3C0},
	{68431, 0xFC00},
	{67631, 0xFFFF0000},
	/* 616 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{67742, 0x800000},
	{67769, 0x1000000},
	{56116, 0x2000000},
	{68448, 0x4000000},
	{68491, 0x30000000},
	{55387, 0x40000000},
	/* 628 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{68302, 0x80},
	{68508, 0x100},
	{55379, 0x3FE00, 257, 0},
	{55812, 0x7FC0000},
	{67889, 0x8000000},
	{67903, 0xF0000000},
	/* 637 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{67742, 0x800000},
	{68272, 0x3000000},
	{55387, 0x40000000},
	/* 646 */
	{68519, 0x1},
	{68537, 0x2},
	{68551, 0x4},
	{68570, 0x8},
	{68590, 0x10},
	{68610, 0x20},
	{68632, 0x40},
	{68643, 0x400},
	{68661, 0x800},
	{10365, 0x1000},
	{68679, 0x2000},
	{68693, 0x4000},
	{68701, 0x8000},
	/* 659 */
	{68711, 0xFFFF},
	{68727, 0xFFFF0000},
	/* 661 */
	{9869, 0x1},
	/* 662 */
	{9897, 0x1},
	/* 663 */
	{391, 0xFF},
	/* 664 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{67742, 0x800000},
	{68746, 0x1000000},
	{55387, 0x4000000},
	{68448, 0x20000000},
	{67769, 0x40000000},
	{56116, 0x80000000},
	/* 676 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{68752, 0x80},
	{68762, 0x100},
	{68772, 0x200},
	{68508, 0x400},
	{68782, 0x1800},
	{68797, 0x6000},
	{55812, 0xFF8000},
	{55379, 0x7F000000, 257, 0},
	/* 687 */
	{391, 0xF},
	/* 688 */
	{68809, 0x3FF},
	{68822, 0xF000},
	{68832, 0x3F0000},
	{68847, 0x400000},
	{68862, 0x800000},
	{68878, 0x7000000},
	/* 694 */
	{68893, 0xFFF},
	{68899, 0x1FFF000},
	/* 696 */
	{10332, 0x1},
	/* 697 */
	{68908, 0x3},
	{66056, 0x4},
	{68918, 0x8},
	{68928, 0x10},
	{68938, 0x1FFE0},
	/* 702 */
	{67919, 0x1},
	{67936, 0x1E},
	{67962, 0x1E0},
	{67995, 0x200},
	{68016, 0x7C00},
	{68040, 0x8000},
	{68065, 0x10000},
	{68084, 0xE0000},
	{68951, 0x7F00000},
	/* 711 */
	{67903, 0xF},
	/* 712 */
	{441, 0x7FF},
	/* 713 */
	{68988, 0x3FFFFFFF},
	{68996, 0x40000000},
	{69005, 0x80000000},
	/* 716 */
	{11614, 0xFFFF},
	/* 717 */
	{69014, 0x3FF},
	{59825, 0x400},
	/* 719 */
	{69024, 0x1},
	{69043, 0x2},
	{69064, 0x4},
	{69075, 0x8},
	{69088, 0x10},
	{69107, 0x20},
	{69132, 0x40},
	{69155, 0x80},
	{69169, 0xF00},
	{69181, 0x1000},
	/* 729 */
	{69199, 0x1},
	{69223, 0x2},
	{69244, 0x4},
	{69278, 0x8},
	{69313, 0x70},
	{69325, 0xF00},
	{69338, 0xF000},
	{69351, 0xF0000},
	{69364, 0xF00000},
	{69378, 0xF000000},
	{69396, 0xF0000000},
	/* 740 */
	{69413, 0x7FF},
	{69425, 0x1800},
	{69440, 0xFFE000},
	{69450, 0x1000000},
	{69462, 0x2000000},
	{69480, 0x3C000000},
	{69486, 0xC0000000},
	/* 747 */
	{69551, 0x3, 4, 3075},
	{69568, 0xC, 4, 3075},
	{69586, 0x30, 4, 3075},
	{69604, 0x40},
	{69625, 0x80},
	{69640, 0x100},
	{69661, 0x200},
	{69679, 0x400},
	{69696, 0x800},
	{69709, 0x1000},
	{69728, 0x6000, 4, 3075},
	{69747, 0x8000},
	{69771, 0x10000},
	{69794, 0x20000},
	{69811, 0x40000},
	{69896, 0x180000, 4, 3079},
	{69915, 0x3E00000},
	{69932, 0x4000000},
	{69956, 0x8000000},
	{69970, 0x10000000},
	{69990, 0x20000000},
	{70004, 0x40000000},
	{70024, 0x80000000},
	/* 770 */
	{70098, 0x3, 4, 3083},
	{70127, 0x1C},
	{70158, 0x20},
	{70194, 0x40},
	{70229, 0x80},
	{70257, 0x100},
	{70279, 0x200},
	{70297, 0x400},
	{70329, 0x800},
	{70450, 0x7000, 8, 3087},
	{70460, 0x38000},
	{70473, 0x1C0000},
	{70486, 0x200000},
	{70502, 0x400000},
	{70520, 0x800000},
	{70538, 0x2000000},
	/* 786 */
	{70566, 0x3FFF},
	{55211, 0x3FFF0000},
	/* 788 */
	{11232, 0xFF},
	/* 789 */
	{70572, 0xFFFF},
	{70577, 0xFFFF0000},
	/* 791 */
	{70582, 0xFFFF},
	{70587, 0xFFFF0000},
	/* 793 */
	{70601, 0x3, 4, 3095},
	{70615, 0x4},
	{70640, 0x8},
	/* 796 */
	{70658, 0xF},
	{70666, 0xF0},
	{70674, 0x1F00},
	{70682, 0x6000},
	{70690, 0x18000},
	{70698, 0x60000},
	{70706, 0x180000},
	{64854, 0xF0000000},
	/* 804 */
	{17302, 0x3, 4, 3099},
	{70745, 0xC},
	{67231, 0x1F0},
	{70800, 0x600, 4, 3103},
	{70815, 0x800},
	{70829, 0x1000},
	{70848, 0xE000},
	{70865, 0xF0000},
	{67457, 0x100000},
	{70872, 0x7800000},
	{70896, 0x8000000},
	{70911, 0x10000000},
	{70921, 0x20000000},
	{70941, 0x80000000},
	/* 818 */
	{17302, 0x1, 2, 3107},
	{67231, 0x1F0},
	{70800, 0x600, 4, 3103},
	{70815, 0x800},
	{70829, 0x1000},
	{70848, 0xE000},
	{67457, 0x100000},
	{70896, 0x8000000},
	{70984, 0x20000000},
	/* 827 */
	{70658, 0x7FF},
	{70666, 0x3FF800},
	/* 829 */
	{70658, 0x3FFFFF},
	/* 830 */
	{10060, 0xFF},
	/* 831 */
	{71056, 0x3, 4, 3109},
	{71068, 0xC, 4, 3109},
	{71080, 0x30, 4, 3109},
	{71096, 0xC0, 4, 3109},
	{71166, 0x30000, 4, 3113},
	{71178, 0xC0000, 4, 3113},
	{71190, 0x300000, 4, 3113},
	{71206, 0x1000000},
	{71217, 0x2000000},
	/* 840 */
	{30565, 0xFF},
	/* 841 */
	{71228, 0xFF},
	/* 842 */
	{71246, 0xFFFF},
	{71262, 0xFFFF0000},
	/* 844 */
	{70572, 0x7FFF},
	{70577, 0x7FFF0000},
	{71278, 0x80000000},
	/* 847 */
	{70582, 0x7FFF},
	{70587, 0x7FFF0000},
	/* 849 */
	{71366, 0xFFFF, 32769, 3117},
	/* 850 */
	{71376, 0xF},
	{71383, 0xF0},
	{71392, 0xF00},
	{71400, 0x3F000},
	{71411, 0xFC0000},
	{71422, 0xF000000},
	{71433, 0xF0000000},
	/* 857 */
	{71444, 0x1FF},
	{71463, 0x1FF0000},
	/* 859 */
	{71482, 0xF},
	{71497, 0xF0},
	{71512, 0xF00},
	{71527, 0xF000},
	{71542, 0xF0000},
	{71557, 0xF00000},
	{71572, 0xF000000},
	{71587, 0xF0000000},
	/* 867 */
	{71602, 0xF},
	{71617, 0xF0},
	{71632, 0xF00},
	{71647, 0xF000},
	{71662, 0xF0000},
	{71677, 0xF00000},
	{71692, 0xF000000},
	{71707, 0xF0000000},
	/* 875 */
	{71814, 0x3, 4, 35886},
	{71826, 0xC, 4, 35886},
	{71938, 0x30, 4, 35890},
	{71995, 0x40, 2, 35894},
	{72051, 0x80, 2, 35896},
	{72155, 0x300, 4, 35898},
	{72263, 0xC00, 4, 35902},
	{72372, 0x3000, 4, 35906},
	{72485, 0xC000, 4, 35910},
	{72587, 0x30000, 4, 35914},
	{72733, 0xC0000, 4, 35918},
	{72880, 0x300000, 4, 35922},
	{72980, 0x3000000, 4, 35926},
	{73126, 0xC000000, 4, 35930},
	{73273, 0x30000000, 4, 35934},
	/* 890 */
	{73393, 0x3, 4, 35938},
	{73564, 0xC, 4, 35942},
	{73736, 0x30, 4, 35946},
	/* 893 */
	{69378, 0x3},
	{69396, 0xC},
	/* 895 */
	{9882, 0x1},
	{73749, 0x6},
	{65603, 0x60},
	{73756, 0x100},
	{73791, 0x3000},
	{73798, 0x30000},
	{73812, 0x100000},
	/* 902 */
	{73830, 0x80000000},
	/* 903 */
	{55695, 0x3},
	/* 904 */
	{10112, 0xF},
	/* 905 */
	{73845, 0xFF},
	{73854, 0xFF00},
	{73864, 0xFF0000},
	{73875, 0xFF000000},
	/* 909 */
	{73885, 0xFF},
	{73893, 0xFF00},
	{73902, 0xFF0000},
	{73911, 0xFF000000},
	/* 913 */
	{73919, 0x3, 4, 3109},
	{73935, 0xC, 4, 3109},
	{73951, 0x30, 4, 3109},
	{73965, 0xC0, 4, 3109},
	{73981, 0x30000, 4, 3113},
	{73997, 0xC0000, 4, 3113},
	{74013, 0x300000, 4, 3113},
	{74027, 0xC00000, 4, 3113},
	{74043, 0x40000000},
	{74058, 0x80000000},
	/* 923 */
	{74073, 0x1},
	{74100, 0x7C},
	{74129, 0x100},
	{74158, 0x200},
	{74189, 0x400},
	{74217, 0x1000},
	{74245, 0x2000},
	{74275, 0x4000},
	/* 931 */
	{74301, 0x1},
	{74321, 0xE},
	{74338, 0x30},
	{74359, 0xF00},
	/* 935 */
	{74617, 0xF, 16, 35950},
	{74629, 0xF0, 16, 35950},
	{74642, 0xF00, 16, 35950},
	{74655, 0xF000, 16, 35950},
	{74670, 0xF0000, 16, 35950},
	{74686, 0xF00000, 16, 35950},
	/* 941 */
	{74702, 0xFF},
	{74717, 0xFF00},
	{74729, 0xFF0000},
	{74746, 0xFF000000},
	/* 945 */
	{74759, 0xFF},
	{74777, 0xFF00},
	{74792, 0xFF0000},
	{74812, 0xFF000000},
	/* 949 */
	{754, 0x3F},
	{74828, 0x300},
	{74840, 0x400},
	{74851, 0x1E000},
	{74860, 0x20000},
	{74874, 0x40000},
	{74878, 0x80000},
	{74895, 0x100000},
	{74913, 0x600000},
	{74931, 0x800000},
	{74951, 0x1000000},
	{74963, 0x2000000},
	/* 961 */
	{754, 0x3F},
	{74828, 0x300},
	{74840, 0x400},
	{74874, 0x40000},
	{74878, 0x80000},
	{74895, 0x100000},
	{74913, 0x600000},
	{74951, 0x1000000},
	{74963, 0x2000000},
	/* 970 */
	{74975, 0x3E},
	{74991, 0x40},
	{75004, 0x80},
	/* 973 */
	{75017, 0x1},
	{75034, 0x2},
	{75051, 0x4},
	{75070, 0x8},
	{75091, 0x10},
	{75109, 0x20},
	{75127, 0x40},
	{75147, 0x80},
	{75168, 0x100},
	{75184, 0x200},
	{75200, 0x400},
	{75216, 0x800},
	{75232, 0x1000},
	{75247, 0x2000},
	{75261, 0x4000},
	{75281, 0x8000},
	/* 989 */
	{75298, 0x1},
	{75313, 0x2},
	{75436, 0x1C, 5, 35966},
	{75454, 0xE0, 5, 35966},
	{75472, 0x700, 5, 35966},
	{75490, 0x3800, 5, 35966},
	{75508, 0x4000},
	/* 996 */
	{75525, 0x3F},
	{75536, 0x40},
	{75546, 0x80},
	{75563, 0x100},
	{75579, 0x4000},
	{75599, 0x8000},
	/* 1002 */
	{75609, 0x1},
	{75627, 0x10},
	{75647, 0x100},
	{75666, 0x1000},
	{75687, 0x30000},
	{75706, 0x100000},
	{75720, 0x1000000},
	/* 1009 */
	{75828, 0xF, 5, 35971},
	/* 1010 */
	{75847, 0xF, 5, 35971},
	{75866, 0xF0, 5, 35971},
	{75885, 0xF00, 5, 35971},
	{75904, 0xF000, 5, 35971},
	{75923, 0xF0000, 5, 35971},
	/* 1015 */
	{76142, 0xF, 10, 35976},
	/* 1016 */
	{76158, 0xF, 10, 35976},
	{76177, 0xF0, 10, 35976},
	{76196, 0xF00, 10, 35976},
	{76215, 0xF000, 10, 35976},
	{76234, 0xF0000, 10, 35976},
	{76253, 0xF00000, 10, 35976},
	{76272, 0xF000000, 10, 35976},
	{76291, 0xF0000000, 10, 35976},
	/* 1024 */
	{76545, 0xF, 11, 35986},
	{76550, 0xF0, 11, 35986},
	{76555, 0xF00, 11, 35986},
	{76560, 0xF000, 11, 35986},
	{76565, 0xF0000, 11, 35986},
	{76570, 0xF00000, 11, 35986},
	{76575, 0xF000000, 11, 35986},
	{76580, 0xF0000000, 11, 35986},
	/* 1032 */
	{76659, 0xF, 16, 35997},
	{76672, 0xF0},
	{76685, 0xF00},
	{76698, 0xF000},
	{76711, 0xF0000},
	{76724, 0xF00000},
	{76737, 0xF000000},
	{76750, 0xF0000000},
	/* 1040 */
	{76763, 0x1},
	{76786, 0x2},
	{76809, 0x10},
	{76832, 0x20},
	{76855, 0x100},
	{76878, 0x200},
	{76901, 0x1000},
	{76924, 0x2000},
	{76947, 0x10000},
	{76970, 0x20000},
	{76993, 0x100000},
	{77016, 0x200000},
	{77039, 0x1000000},
	{77062, 0x2000000},
	{77085, 0x10000000},
	{77108, 0x20000000},
	{77131, 0x80000000},
	/* 1057 */
	{77422, 0x7, 8, 36013},
	{77436, 0x70, 8, 36013},
	{77584, 0x700, 8, 36021},
	{77599, 0x70000, 8, 36013},
	{77613, 0x700000, 8, 36013},
	{77627, 0x7000000, 8, 36021},
	/* 1063 */
	{78082, 0x1F, 21, 36029},
	{77584, 0xE0, 5, 36050},
	{78187, 0x1F00, 21, 36029},
	{78203, 0x1F0000, 21, 36029},
	{77627, 0xE00000, 5, 36050},
	{78218, 0x1F000000, 21, 36029},
	{78234, 0x20000000},
	{9882, 0x40000000},
	{78255, 0x80000000},
	/* 1072 */
	{78268, 0x7},
	/* 1073 */
	{11609, 0xFFFF},
	/* 1074 */
	{78359, 0x3, 4, 36055},
	{78405, 0xC, 2, 36059},
	{78416, 0x10},
	{78431, 0x20},
	{78439, 0x40},
	{78450, 0x80},
	{78464, 0x100},
	{78481, 0xE0000000},
	/* 1082 */
	{78494, 0xFFFFFFF},
	/* 1083 */
	{78506, 0x3FF},
	/* 1084 */
	{78529, 0x1},
	{69559, 0x2},
	{78544, 0x4},
	{78559, 0x8},
	{70454, 0x70, 8, 3087},
	{78579, 0x80},
	{78595, 0x700, 8, 3087},
	{78607, 0x700000, 8, 3087},
	{78622, 0x40000000},
	{78656, 0x80000000},
	/* 1094 */
	{78691, 0x7},
	{78710, 0x70},
	{78726, 0x700},
	{78750, 0x7000},
	{78776, 0x10000},
	{78803, 0x20000},
	{78825, 0x40000},
	{78844, 0x80000},
	{78862, 0x100000},
	{78889, 0x200000},
	{78916, 0x7000000},
	{78941, 0x8000000},
	/* 1106 */
	{78972, 0x1},
	{78990, 0x8},
	{982, 0x70, 8, 36061},
	{78263, 0xFF0000, 256, 36069},
	/* 1110 */
	{79410, 0x1},
	{79426, 0x2},
	{79457, 0x4},
	{69617, 0x30, 4, 36325},
	{79536, 0x40},
	{79548, 0x80},
	{79572, 0x100},
	{79591, 0x200},
	{79609, 0x400},
	{79622, 0x800},
	{79644, 0x1000},
	{79734, 0x6000, 4, 36329},
	{79756, 0x8000},
	{79774, 0x10000},
	{79805, 0x20000},
	{79824, 0x700000},
	{79849, 0x800000},
	/* 1127 */
	{79882, 0x1},
	{79892, 0x2},
	{79902, 0x4},
	{79912, 0x8},
	{79922, 0x10},
	{79932, 0x20},
	{79942, 0x2000},
	{79961, 0xC000},
	{79973, 0x10000},
	{79986, 0x20000},
	{80004, 0x40000},
	{80027, 0x80000},
	{80045, 0x100000},
	{80065, 0x200000},
	{80077, 0x400000},
	{80099, 0x1000000},
	{80123, 0x2000000},
	{80149, 0x4000000},
	{80168, 0x8000000},
	{80186, 0x10000000},
	/* 1147 */
	{80206, 0x1},
	{80217, 0x2},
	{19176, 0x4},
	{80237, 0x18, 2, 36333},
	{80303, 0xE0, 3, 36335},
	{80324, 0x700, 3, 36335},
	{80344, 0x800},
	{80369, 0x1000},
	{80393, 0x2000},
	{80417, 0x10000},
	{80442, 0x80000},
	{80461, 0x100000},
	{80476, 0x200000},
	{80494, 0x400000},
	{80532, 0x800000},
	{80555, 0x1000000},
	/* 1163 */
	{80576, 0x1},
	{80594, 0x2},
	{80613, 0x4},
	{80631, 0x8},
	{80650, 0x10},
	{80668, 0x20},
	{80687, 0x100},
	{80698, 0x200},
	{80708, 0x400},
	{80719, 0x800},
	/* 1173 */
	{80735, 0x1},
	{80751, 0x2},
	{80767, 0x4},
	{80783, 0x8},
	{80799, 0x10},
	{80815, 0x20},
	{80831, 0x40},
	{80847, 0x80},
	{80863, 0x100},
	{80879, 0x200},
	{80895, 0x400},
	{80911, 0x800},
	{80927, 0x1000},
	{80943, 0x2000},
	{80959, 0x4000},
	{80975, 0x8000},
	{80991, 0x10000},
	{81010, 0x20000},
	{81028, 0x40000},
	{81055, 0x80000},
	{81077, 0x100000},
	{81095, 0x200000},
	{81115, 0x400000},
	{81138, 0x800000},
	{81161, 0x1000000},
	{81186, 0x2000000},
	{81206, 0x4000000},
	{81229, 0x8000000},
	/* 1201 */
	{81248, 0x1},
	{81267, 0x2},
	{81285, 0x4},
	{81303, 0x8},
	{81321, 0x10},
	{81339, 0x20},
	{81356, 0x40},
	{81373, 0x80},
	{81394, 0x100},
	{81411, 0x200},
	{81428, 0x400},
	{81444, 0x800},
	{81460, 0x1000},
	{81476, 0x2000},
	{81492, 0x4000},
	{81517, 0x100000},
	/* 1217 */
	{81537, 0x3},
	{81556, 0x4},
	{81575, 0x8},
	{81592, 0x10},
	/* 1221 */
	{81607, 0x1},
	{81631, 0x2},
	{81651, 0x4},
	{81672, 0x8},
	{81697, 0x10},
	{81717, 0x20},
	{81733, 0x40},
	{81750, 0x80},
	{81771, 0xFF00},
	{81792, 0x40000000},
	{81813, 0x80000000},
	/* 1232 */
	{81835, 0x1},
	{81607, 0x2},
	{81631, 0x4},
	{81651, 0x8},
	{81672, 0x10},
	{81860, 0x20},
	{81873, 0x40},
	/* 1239 */
	{81902, 0x1},
	{81913, 0x2},
	/* 1241 */
	{81931, 0x1},
	{81948, 0x2},
	/* 1243 */
	{81972, 0x1},
	{81997, 0x2},
	{82018, 0x4},
	{82040, 0x8},
	{82066, 0x10},
	/* 1248 */
	{82083, 0x1E},
	{82095, 0xE0},
	{82109, 0xF00},
	{82125, 0x70000},
	{82136, 0x780000},
	/* 1253 */
	{66987, 0xFFFF},
	{66880, 0xFFFF0000},
	/* 1255 */
	{82149, 0xFFFF},
	{18849, 0xFFFF0000},
	/* 1257 */
	{66880, 0xFFFF},
	/* 1258 */
	{82158, 0xFFFF},
	{82171, 0xFF0000},
	{82184, 0x10000000},
	{82202, 0x60000000},
	/* 1262 */
	{82218, 0x7},
	/* 1263 */
	{82230, 0x3},
	/* 1264 */
	{18442, 0xFF},
	/* 1265 */
	{18464, 0x1F, 22, 36338},
	{82589, 0x4000},
	{82602, 0x8000},
	{82615, 0x70000},
	/* 1269 */
	{18484, 0xF},
	/* 1270 */
	{18490, 0xF},
	/* 1271 */
	{82626, 0x1},
	{82636, 0x2},
	{82646, 0x4},
	{82656, 0x8},
	{19675, 0xFF00},
	{82666, 0xFF0000},
	/* 1277 */
	{82672, 0xF},
	{13837, 0xF0},
	{82679, 0xF00},
	{71269, 0xF000},
	{82686, 0xF0000},
	{82693, 0xF00000},
	{82702, 0xF000000},
	{11769, 0xF0000000},
	/* 1285 */
	{982, 0x7, 6, 36360},
	{82782, 0x8},
	{82838, 0x30, 4, 36366},
	{82847, 0x7C0},
	{82858, 0x800},
	{82871, 0x1000},
	{82882, 0x2000},
	{82894, 0x4000},
	{82907, 0x8000},
	{82925, 0x10000},
	{82941, 0x20000},
	{82960, 0x40000},
	{82974, 0x80000},
	{82992, 0x100000},
	{83010, 0x600000},
	/* 1300 */
	{83017, 0x7FF},
	{83037, 0x3FF800},
	{83057, 0xFFC00000},
	/* 1303 */
	{83081, 0x1},
	{83093, 0x2},
	{83114, 0x4},
	{83134, 0x8},
	{83159, 0x10},
	{83180, 0x20},
	{83203, 0x40},
	/* 1310 */
	{83233, 0x1},
	{83243, 0x2},
	{83258, 0x4},
	{83283, 0x8},
	{83301, 0x70},
	{83317, 0x80},
	{83322, 0x100},
	{83345, 0x200},
	{83364, 0x400},
	{83386, 0x800},
	{83402, 0x1000},
	{83418, 0x2000},
	{83434, 0x4000},
	{83453, 0x8000},
	{83479, 0x10000},
	{83494, 0x20000},
	{83534, 0x40000},
	{83561, 0x80000},
	{83584, 0xF00000},
	{83600, 0x1000000},
	{83630, 0x2000000},
	{83654, 0x4000000},
	{83675, 0x8000000},
	{83705, 0x70000000},
	/* 1334 */
	{18689, 0x7FF},
	/* 1335 */
	{18703, 0x7FF},
	/* 1336 */
	{18717, 0xF},
	/* 1337 */
	{754, 0x7FFF},
	/* 1338 */
	{83729, 0x3F, 4, 36370},
	{83742, 0x3F00, 4, 36370},
	{83757, 0x3F0000, 4, 36370},
	{83772, 0xFC00000, 4, 36370},
	{83787, 0x80000000},
	/* 1343 */
	{203, 0x3, 3, 36374},
	{83924, 0xC, 4, 36377},
	{84004, 0x30, 4, 36381},
	{84064, 0xC0, 3, 36385},
	{84077, 0x100},
	{78431, 0x200},
	{84081, 0x400},
	{84090, 0x3800},
	/* 1351 */
	{18892, 0x1},
	{84096, 0x2},
	{84117, 0x4},
	/* 1354 */
	{85300, 0x3F, 64, 36388},
	{60519, 0x7FFFC00},
	{85311, 0x8000000},
	/* 1357 */
	{18989, 0x1},
	{85326, 0x2},
	/* 1359 */
	{85341, 0x1},
	{85355, 0x2},
	{85371, 0x4},
	{85389, 0x8},
	{85405, 0x10},
	/* 1364 */
	{85416, 0xFFFF},
	{85431, 0x10000},
	{85450, 0x20000},
	{85464, 0x40000},
	{85483, 0x80000},
	{85497, 0x100000},
	/* 1370 */
	{19103, 0x7FFF},
	/* 1371 */
	{19139, 0x1},
	/* 1372 */
	{19153, 0x1},
	/* 1373 */
	{70848, 0x1},
	{85514, 0x2},
	{85525, 0x4},
	{85542, 0x8},
	{85559, 0x3F0},
	{85576, 0xFC00},
	{85593, 0x10000},
	{85617, 0x20000},
	{67528, 0x40000},
	/* 1382 */
	{85634, 0x7, 8, 3087},
	{85647, 0xFF0},
	{85661, 0xFF000},
	{69578, 0x1000000},
	/* 1386 */
	{85674, 0x7, 8, 3087},
	{85687, 0xFF0},
	{85701, 0xFF000},
	{69596, 0x1000000},
	/* 1390 */
	{9758, 0xFF},
	{9774, 0xFF00},
	{85714, 0xFF0000},
	{85720, 0xFF000000},
	/* 1394 */
	{19675, 0x3FF},
	/* 1395 */
	{19668, 0x1FF},
	/* 1396 */
	{19689, 0x7FF},
	/* 1397 */
	{85726, 0x1FF},
	{85742, 0x3FE00},
	/* 1399 */
	{85758, 0xFF},
	{85772, 0xFF00},
	{85782, 0xFF0000},
	{85793, 0x1F000000},
	{85805, 0xE0000000},
	/* 1404 */
	{85865, 0x3, 4, 36452},
	{85896, 0x4, 2, 36456},
	{19758, 0x18, 4, 36458},
	{85978, 0x20, 2, 36462},
	{86043, 0xC0, 4, 36464},
	{86049, 0x100},
	{68377, 0x200},
	{86060, 0x400},
	{86080, 0x800},
	{86100, 0x1000},
	{86114, 0x2000},
	{86125, 0x4000},
	{86141, 0x78000},
	{86161, 0x180000},
	{86176, 0x200000},
	{86186, 0x400000},
	{86196, 0x800000},
	{86206, 0x1000000},
	{86221, 0x2000000},
	/* 1423 */
	{86241, 0xFF},
	{86253, 0x3F00},
	{86269, 0xFC000},
	/* 1426 */
	{209, 0x3, 3, 36468},
	{86375, 0x1C, 4, 36471},
	{86452, 0xE0, 4, 36475},
	{86461, 0x100},
	{86481, 0x200},
	{86492, 0x3C00},
	{86514, 0x4000},
	{84064, 0x18000, 3, 36385},
	{86548, 0x60000, 4, 36479},
	{86607, 0x80000, 3, 36483},
	{86659, 0x100000, 3, 36486},
	{84090, 0x3800000},
	/* 1438 */
	{86671, 0x1},
	{86692, 0x300},
	{86714, 0xC00},
	{86736, 0x3000},
	{86758, 0xC000},
	{86780, 0x10000},
	/* 1444 */
	{86793, 0xFF},
	{86821, 0x100},
	/* 1446 */
	{9882, 0x1},
	{20115, 0x1FC},
	{86849, 0x80000000},
	/* 1449 */
	{86881, 0x1},
	{86896, 0x2},
	{86911, 0x4},
	{86926, 0x8},
	{86941, 0x70},
	{86953, 0x80},
	{86973, 0xF00},
	{86990, 0x80000000},
	/* 1457 */
	{87011, 0xF},
	{87030, 0xF0},
	{87049, 0xF00},
	{87068, 0xF000},
	/* 1461 */
	{87087, 0xF},
	{87098, 0xF0},
	{87109, 0xF00},
	{87120, 0xF000},
	{87131, 0xF0000},
	{87142, 0xF00000},
	{87153, 0xF000000},
	{87164, 0xF0000000},
	/* 1469 */
	{87175, 0xF},
	{87186, 0xF0},
	{87197, 0xF00},
	{87209, 0xF000},
	{87221, 0xF0000},
	{87233, 0xF00000},
	{87245, 0xF000000},
	{87257, 0xF0000000},
	/* 1477 */
	{87269, 0x200},
	{87287, 0x400},
	{87298, 0x800},
	{87323, 0x1000},
	{87345, 0x2000},
	/* 1482 */
	{87367, 0x7},
	{87384, 0x10},
	{87406, 0x1E000},
	{87422, 0x700000},
	{87443, 0x3000000},
	{87523, 0xC000000, 4, 36489},
	/* 1488 */
	{87549, 0x1},
	{87610, 0x6, 4, 36493},
	{87826, 0x38, 8, 36497},
	/* 1491 */
	{87837, 0xF},
	{87842, 0xF0},
	{87847, 0xF00},
	{87852, 0xF000},
	{87857, 0xF0000},
	{87862, 0xF00000},
	{87867, 0xF000000},
	{87872, 0xF0000000},
	/* 1499 */
	{87877, 0xF},
	{87882, 0xF0},
	{87887, 0xF00},
	{87892, 0xF000},
	{87897, 0xF0000},
	{87902, 0xF00000},
	{87907, 0xF000000},
	{87912, 0xF0000000},
	/* 1507 */
	{87917, 0xF},
	{87922, 0xF0},
	{87927, 0xF00},
	{87932, 0xF000},
	{87937, 0xF0000},
	{87943, 0xF00000},
	{87949, 0xF000000},
	{87955, 0xF0000000},
	/* 1515 */
	{87961, 0xF},
	{87967, 0xF0},
	{87973, 0xF00},
	{87979, 0xF000},
	{87985, 0xF0000},
	{87991, 0xF00000},
	{87997, 0xF000000},
	{88003, 0xF0000000},
	/* 1523 */
	{88009, 0xFFFF},
	{88022, 0xFFFF0000},
	/* 1525 */
	{88035, 0xFFFF},
	{88048, 0xFFFF0000},
	/* 1527 */
	{88061, 0x3},
	{67842, 0x4},
	{67864, 0x8},
	{88090, 0x60},
	/* 1531 */
	{88203, 0x3, 4, 36505},
	{88216, 0x4},
	{88227, 0x8},
	{88336, 0x70, 5, 36509},
	{88354, 0x380, 5, 36509},
	{88372, 0x1C00},
	{88395, 0x3E000},
	{88421, 0x40000},
	{88443, 0x7F80000},
	{88459, 0x8000000},
	{88481, 0x10000000},
	{88568, 0x60000000, 3, 36514},
	/* 1543 */
	{88585, 0xFFFF},
	{88601, 0xFFFF0000},
	/* 1545 */
	{88620, 0x1},
	{88637, 0x1E},
	{88661, 0x20},
	{88679, 0x3C0},
	{88704, 0x400},
	{88734, 0x800},
	{88749, 0x1000},
	{88764, 0x2000},
	{88799, 0x4000},
	{88835, 0x8000},
	{88925, 0x30000, 3, 36517},
	{88949, 0x40000},
	{88985, 0x80000},
	{89021, 0x100000},
	{89047, 0x200000},
	{89071, 0x400000},
	{89091, 0x800000},
	{89112, 0x1000000},
	{89137, 0x6000000},
	{89161, 0x18000000},
	/* 1565 */
	{89189, 0x7FF},
	{89210, 0xFF0000},
	/* 1567 */
	{89228, 0xFF},
	/* 1568 */
	{89244, 0x7F},
	/* 1569 */
	{89257, 0x7FF},
	{89266, 0x7FF00000},
	/* 1571 */
	{89257, 0x3FFFFF},
	/* 1572 */
	{69413, 0x1FFF},
	{69440, 0x3FFE000},
	{89281, 0x3C000000},
	/* 1575 */
	{89342, 0x3, 4, 36520},
	{17302, 0x7C, 32, 36524},
	{65623, 0x80},
	{89940, 0x700, 8, 36556},
	{89996, 0x1800, 4, 36564},
	{79039, 0x2000},
	{70033, 0x4000},
	{90006, 0x8000},
	{90018, 0x10000},
	{90031, 0x20000},
	{87610, 0x40000},
	{90044, 0x80000},
	{90271, 0x700000, 8, 36568},
	{90293, 0x3800000, 8, 36568},
	{90317, 0x4000000},
	{90343, 0x8000000},
	{90369, 0x10000000},
	{90437, 0x60000000, 3, 36576},
	{90453, 0x80000000},
	/* 1594 */
	{90467, 0x1F},
	{90483, 0x3E0},
	{90505, 0xC00},
	{70745, 0x7000},
	{90523, 0x18000},
	{90537, 0x20000},
	{90555, 0x40000},
	{90581, 0x80000},
	/* 1602 */
	{74073, 0x1},
	{90611, 0x2},
	{67469, 0xC, 3, 36579},
	{90725, 0x10, 2, 36582},
	{67497, 0x60},
	{67594, 0x180},
	{90751, 0x200},
	{90774, 0x3C00},
	{90794, 0x3C000},
	{74189, 0x40000},
	{90816, 0x80000},
	{90849, 0x100000},
	/* 1614 */
	{89257, 0x3FFF},
	/* 1615 */
	{90873, 0xFF},
	/* 1616 */
	{90883, 0x3FFF},
	{90895, 0xFFFC000},
	{67369, 0xF0000000},
	/* 1619 */
	{90906, 0x1FFF},
	{90917, 0x2000},
	{90929, 0x7C000},
	{90943, 0xF80000},
	{90957, 0x3000000},
	{90971, 0x4000000},
	{64854, 0x38000000},
	{90990, 0x40000000},
	/* 1627 */
	{9965, 0xFFFFFFFC},
	/* 1628 */
	{9994, 0xFFFF},
	/* 1629 */
	{24328, 0xFFFFFFFC},
	/* 1630 */
	{24350, 0xFFFF},
	/* 1631 */
	{24844, 0xFFFFFFFC},
	/* 1632 */
	{24866, 0xFFFF},
	/* 1633 */
	{91007, 0xFFFFFFC},
	/* 1634 */
	{91023, 0x6000000},
	/* 1635 */
	{91036, 0x1},
	/* 1636 */
	{91055, 0xFF},
	{91069, 0x30000},
	/* 1638 */
	{91083, 0xFFFFFFFC},
	/* 1639 */
	{91095, 0xFFFF},
	{91107, 0x10000},
	{91023, 0x6000000},
	{26653, 0xE0000000},
	/* 1643 */
	{26203, 0xFFFFFFFC},
	/* 1644 */
	{26221, 0xFFFF},
	{91023, 0xC00000},
	/* 1646 */
	{26275, 0xFFFFFFFC},
	/* 1647 */
	{26293, 0xFFFF},
	{91023, 0xC00000},
	/* 1649 */
	{91117, 0x3},
	{26333, 0xFFFFFFF8},
	/* 1651 */
	{26352, 0xFFFF},
	{91131, 0x10000},
	{91147, 0x100000},
	{91163, 0x3000000},
	{91179, 0xE0000000},
	/* 1656 */
	{91190, 0x400},
	{91203, 0x6000},
	{91220, 0x8000},
	{91232, 0x300000},
	{91243, 0x6000000},
	{91260, 0x8000000},
	{91272, 0x60000000},
	/* 1663 */
	{91283, 0xFF},
	/* 1664 */
	{91302, 0x3F},
	/* 1665 */
	{91320, 0x8},
	{91337, 0x10},
	{91354, 0x20},
	{91381, 0x8000},
	{91401, 0x40000},
	{91418, 0x400000},
	{91434, 0x800000},
	{91448, 0x2000000},
	{91462, 0x4000000},
	{91476, 0x8000000},
	{91497, 0x10000000},
	{91522, 0x20000000},
	{91543, 0x40000000},
	/* 1678 */
	{91567, 0x3000000},
	{995, 0x80000000},
	/* 1680 */
	{26590, 0xFFFF},
	/* 1681 */
	{26631, 0xFFFF},
	/* 1682 */
	{91572, 0x3FFFFFF},
	{91583, 0x4000000},
	{91587, 0x8000000},
	{91591, 0x10000000},
	{91596, 0x20000000},
	{91601, 0x40000000},
	{91610, 0x80000000},
	/* 1689 */
	{91617, 0x1},
	{91637, 0x2},
	{91651, 0x30},
	{91663, 0x1FF0000},
	{91676, 0x10000000},
	{91691, 0x20000000},
	{91705, 0xC0000000},
	/* 1696 */
	{91715, 0x3FFFFFF},
	{91728, 0x10000000},
	/* 1698 */
	{91747, 0xFF},
	/* 1699 */
	{91766, 0xFF},
	/* 1700 */
	{91772, 0x1},
	{91786, 0x2},
	{91798, 0x10000},
	{91812, 0x1000000},
	/* 1704 */
	{1872, 0xFF},
	{59424, 0x80000000},
	/* 1706 */
	{26886, 0xFFFFF},
	/* 1707 */
	{26899, 0xFFFFF},
	/* 1708 */
	{26913, 0xFFFFF},
	/* 1709 */
	{26927, 0xFFFFF},
	/* 1710 */
	{26949, 0xFFFFF},
	/* 1711 */
	{26969, 0xFFFFF},
	/* 1712 */
	{26991, 0xFFFFF},
	/* 1713 */
	{91825, 0x3},
	{9965, 0xFFFFFFFC},
	/* 1715 */
	{9994, 0xFFFF},
	{91825, 0xFFFF0000},
	/* 1717 */
	{91830, 0xFFF},
	/* 1718 */
	{91845, 0xFFFFF},
	/* 1719 */
	{91859, 0xFFFFF},
	/* 1720 */
	{91873, 0xFFFFF},
	/* 1721 */
	{27307, 0xFFFFFFE0},
	/* 1722 */
	{27326, 0xFFFF},
	/* 1723 */
	{27345, 0xFFF},
	/* 1724 */
	{27362, 0xFFFFFFFC},
	/* 1725 */
	{27380, 0xFFFF},
	/* 1726 */
	{27398, 0xFFFFF},
	/* 1727 */
	{27414, 0xFFFFFFFC},
	/* 1728 */
	{27432, 0xFFFF},
	/* 1729 */
	{27450, 0xFFFFF},
	/* 1730 */
	{27549, 0xFFFFFFFC},
	/* 1731 */
	{27563, 0xFFFF},
	/* 1732 */
	{27577, 0xFFFFF},
	/* 1733 */
	{42936, 0xFFF000},
	{91023, 0x6000000},
	{91886, 0x8000000},
	{91899, 0x10000000},
	/* 1737 */
	{91907, 0x30000},
	{91915, 0x7000000},
	{91923, 0xE0000000},
	/* 1740 */
	{27643, 0xFFFFFFF},
	/* 1741 */
	{27654, 0xFFFFFFFC},
	/* 1742 */
	{27668, 0xFFFF},
	/* 1743 */
	{27682, 0xFFFFF},
	/* 1744 */
	{91932, 0xFFFFF},
	/* 1745 */
	{995, 0x3},
	/* 1746 */
	{27832, 0x1},
	/* 1747 */
	{91945, 0x1},
	{91959, 0x2},
	{91976, 0x4},
	{91992, 0x8},
	{92007, 0x10},
	{92026, 0x20},
	{92044, 0x40},
	{92065, 0x80},
	/* 1755 */
	{92086, 0x1},
	{92102, 0x2},
	{92118, 0x40},
	{92136, 0x80},
	{92154, 0x100},
	{92172, 0x200},
	{92190, 0x400},
	{92208, 0x800},
	{92226, 0x1000},
	{92244, 0x2000},
	{92262, 0x4000},
	{92279, 0x80000},
	{92295, 0x200000},
	/* 1768 */
	{92311, 0xFF},
	{995, 0x80000000},
	/* 1770 */
	{92329, 0xF},
	{92341, 0xF0},
	{92350, 0xF00},
	{92359, 0xF000},
	{92369, 0x30000},
	{92379, 0xC0000},
	{9882, 0x100000},
	{10365, 0xFFE00000},
	/* 1778 */
	{92386, 0xFF},
	{92350, 0xFF00},
	{92341, 0xFF0000},
	{92401, 0x20000000},
	{92421, 0x40000000},
	{92447, 0x80000000},
	/* 1784 */
	{18464, 0x3F, 22, 36338},
	/* 1785 */
	{38, 0xFFFF},
	/* 1786 */
	{92467, 0x1FF},
	{92533, 0x600, 4, 36584},
	/* 1788 */
	{85416, 0xFFFF},
	{85431, 0x10000},
	{85450, 0x20000},
	{85464, 0x40000},
	{85483, 0x80000},
	{85497, 0x100000},
	{92553, 0x200000},
	{92571, 0x400000},
	{92587, 0x800000},
	/* 1797 */
	{92599, 0x1FF},
	{92613, 0x3FE00},
	{92627, 0x40000},
	{92645, 0x80000},
	/* 1801 */
	{92662, 0x7},
	{92671, 0x78},
	{92680, 0x100},
	/* 1804 */
	{92690, 0x1},
	{92701, 0x7FE},
	/* 1806 */
	{92714, 0x1},
	{92728, 0x2},
	{92742, 0x4},
	/* 1809 */
	{29019, 0xFFFFFF},
	/* 1810 */
	{92756, 0xF},
	{92768, 0xFF00},
	/* 1812 */
	{445, 0xFFFF},
	{91, 0xFFFF0000},
	/* 1814 */
	{92782, 0x1},
	{92803, 0x2},
	/* 1816 */
	{92831, 0x3FFF},
	/* 1817 */
	{92839, 0x3FFF},
	/* 1818 */
	{1859, 0xFFFF},
	/* 1819 */
	{92847, 0x1},
	{92859, 0x2},
	{92871, 0x4},
	{29794, 0x8},
	{68657, 0x10},
	{30219, 0x10000},
	{92882, 0x60000},
	/* 1826 */
	{92895, 0x1},
	{69964, 0x2},
	/* 1828 */
	{24922, 0x7FFFFFFF},
	/* 1829 */
	{92899, 0x3F},
	{92904, 0xC0},
	{92912, 0x300},
	{92918, 0xFFFFFC00},
	/* 1833 */
	{30219, 0x1},
	{92379, 0xFFFFFFFE},
	/* 1835 */
	{8, 0xFFFF},
	{92379, 0xFFFF0000},
	/* 1837 */
	{38, 0xFFFF},
	{92379, 0xFFFF0000},
	/* 1839 */
	{30297, 0xFF},
	{92379, 0xFFFFFF00},
	/* 1841 */
	{30314, 0xFF},
	{92379, 0xFFFFFF00},
	/* 1843 */
	{1, 0xFF},
	{92379, 0xFFFFFF00},
	/* 1845 */
	{441, 0x3F},
	{92379, 0xFFFFFFC0},
	/* 1847 */
	{81023, 0x1},
	{858, 0x1FFE},
	{209, 0x2000},
	{88904, 0x4000},
	{92926, 0x8000},
	{92938, 0x7FF0000},
	{92949, 0x8000000},
	{92960, 0x10000000},
	{92970, 0x20000000},
	{92904, 0xC0000000},
	/* 1857 */
	{30518, 0xFFFF},
	{92379, 0xFFFF0000},
	/* 1859 */
	{441, 0xF},
	{92379, 0xFFFFFFF0},
	/* 1861 */
	{92977, 0xFFFF},
	{92988, 0xF0000},
	{93001, 0xF00000},
	{92379, 0x3F000000},
	{93009, 0x40000000},
	{9882, 0x80000000},
	/* 1867 */
	{29032, 0x7FFFFFFF},
	{30580, 0x80000000},
	/* 1869 */
	{31126, 0xFFFF},
	/* 1870 */
	{31130, 0xFFFF},
	{93018, 0xFFFF0000},
	/* 1872 */
	{93032, 0x3FF},
	{93041, 0xFFC00},
	{93051, 0xF00000},
	{93060, 0xF000000},
	{93071, 0xF0000000},
	/* 1877 */
	{93082, 0x3FF},
	{93092, 0xFFC00},
	{93102, 0xF000000},
	{93113, 0xF0000000},
	/* 1881 */
	{93333, 0xF, 6, 36588},
	{93568, 0xF0, 6, 36594},
	{93741, 0x300, 4, 36600},
	{93761, 0x400},
	/* 1885 */
	{441, 0x7},
	{70443, 0x40000000},
	{9882, 0x80000000},
	/* 1888 */
	{441, 0x1F},
	{70443, 0x40000000},
	{9882, 0x80000000},
	/* 1891 */
	{441, 0xF},
	{11232, 0x40000000},
	{9882, 0x80000000},
	/* 1894 */
	{441, 0x1F},
	{11232, 0x40000000},
	{9882, 0x80000000},
	/* 1897 */
	{11197, 0xFFFF},
	{11217, 0xFFFF0000},
	/* 1899 */
	{93783, 0x1},
	{93810, 0x2},
	{93837, 0x4},
	{982, 0x100},
	/* 1903 */
	{93032, 0x3F},
	{93860, 0x400},
	{93887, 0x800},
	{93914, 0x2000},
	{93940, 0x4000},
	{93966, 0x10000},
	{93993, 0x20000},
	{94019, 0x40000},
	{94045, 0x80000},
	{94073, 0x100000},
	{94099, 0x200000},
	{94125, 0x400000},
	{94151, 0x1000000},
	{94178, 0x2000000},
	{94205, 0x4000000},
	{94232, 0x8000000},
	{94259, 0x10000000},
	{94285, 0x20000000},
	{94314, 0x40000000},
	{94340, 0x80000000},
	/* 1923 */
	{93032, 0x3F},
	{93860, 0x400},
	{93887, 0x800},
	{93914, 0x1000},
	{93940, 0x2000},
	{93966, 0x8000},
	{93993, 0x10000},
	{94073, 0x20000},
	{94099, 0x40000},
	{94019, 0x100000},
	{94178, 0x200000},
	{94340, 0x400000},
	{94367, 0x800000},
	{94232, 0x1000000},
	{94396, 0x2000000},
	/* 1938 */
	{94367, 0x2},
	{94425, 0x4},
	{94454, 0x8},
	{94482, 0x10},
	{94508, 0x20},
	{94534, 0x40},
	{94561, 0x80},
	{94396, 0x100},
	/* 1946 */
	{94588, 0x3FF},
	{93041, 0xFFC00},
	{94598, 0xF00000},
	{94608, 0xF000000},
	{94619, 0xF0000000},
	/* 1951 */
	{93082, 0x3FF},
	{93092, 0xFFC00},
	{94630, 0xF000000},
	{94641, 0xF0000000},
	/* 1955 */
	{94588, 0x3FF},
	{94652, 0xF0000000},
	/* 1957 */
	{93032, 0x3FF},
	{93041, 0xFFC00},
	{94598, 0xF00000},
	{94619, 0xF000000},
	{94652, 0xF0000000},
	/* 1962 */
	{93082, 0x3FF},
	{93092, 0xFFC00},
	{94641, 0xF000000},
	{94630, 0xF0000000},
	/* 1966 */
	{94662, 0xF},
	{94671, 0xF0},
	{94680, 0xF00},
	{94689, 0xF000},
	{94698, 0xF0000},
	{94707, 0xF00000},
	{94716, 0xF000000},
	{94725, 0xF0000000},
	/* 1974 */
	{93032, 0x1FF},
	{94734, 0xF000},
	{93051, 0xF00000},
	{94652, 0xF0000000},
	/* 1978 */
	{56044, 0x1},
	{86043, 0x2, 4, 36464},
	{85978, 0x4, 2, 36462},
	{19758, 0x8, 4, 36458},
	{85896, 0x10, 2, 36456},
	{85865, 0x20, 4, 36452},
	{94748, 0x40},
	{94754, 0x300},
	{94764, 0x2000},
	/* 1987 */
	{94778, 0x1},
	/* 1988 */
	{94787, 0x3},
	{94801, 0xC},
	{94815, 0x30},
	{94829, 0xC0},
	{94843, 0xF00},
	{94858, 0xF000},
	{94873, 0xF0000},
	{94888, 0xF00000},
	/* 1996 */
	{36871, 0x3FF},
	{94903, 0xFFC00},
	{94598, 0xF00000},
	/* 1999 */
	{94923, 0x3FF},
	{94943, 0xFFC00},
	/* 2001 */
	{93032, 0xFF},
	{93041, 0x3FC00},
	{94598, 0xF00000},
	{94619, 0xF000000},
	{94652, 0xF0000000},
	/* 2006 */
	{93082, 0xFF},
	{93092, 0x3FC00},
	{94641, 0xF000000},
	{94630, 0xF0000000},
	/* 2010 */
	{93032, 0xFF},
	{94598, 0xF00000},
	{94652, 0xF0000000},
	/* 2013 */
	{93032, 0x3FF},
	{94598, 0xF00000},
	{94652, 0xF0000000},
	/* 2016 */
	{94963, 0x1},
	{95198, 0xE, 6, 36604},
	{95212, 0x10},
	{95233, 0x3E0},
	{95251, 0x400},
	{95336, 0x800, 2, 36610},
	{95353, 0x1000},
	{95371, 0xE000},
	{95386, 0x20000},
	{95412, 0x1C0000},
	{95435, 0x200000},
	{95463, 0xC00000},
	/* 2028 */
	{93032, 0x1FF},
	{93041, 0x7FC00},
	{94598, 0xF00000},
	{94619, 0xF000000},
	{94652, 0xF0000000},
	/* 2033 */
	{93082, 0x1FF},
	{93092, 0x7FC00},
	{94641, 0xF000000},
	{94630, 0xF0000000},
	/* 2037 */
	{93032, 0x1FF},
	{94652, 0xF0000000},
	/* 2039 */
	{66033, 0xFFF},
	{95488, 0x3000},
	{10365, 0xC000},
	{95506, 0xFFFF0000},
	/* 2043 */
	{40173, 0xFFFF},
	{10365, 0xFFFF0000},
	/* 2045 */
	{40220, 0xFF},
	{66033, 0x700},
	{95530, 0xF800},
	{95546, 0x1F0000},
	{95559, 0x3E00000},
	{95572, 0x7C000000},
	{10365, 0x80000000},
	/* 2052 */
	{95585, 0xFF},
	{10365, 0xFFFFFF00},
	/* 2054 */
	{95607, 0x1FF},
	{10365, 0xFFFFFE00},
	/* 2056 */
	{95607, 0xFF},
	{10365, 0xFFFFFF00},
	/* 2058 */
	{40394, 0x7F},
	{10365, 0xFFFFFF80},
	/* 2060 */
	{40419, 0x7F},
	{10365, 0xFFFFFF80},
	/* 2062 */
	{40447, 0x7F},
	{10365, 0xFFFFFF80},
	/* 2064 */
	{40475, 0x7F},
	{10365, 0xFFFFFF80},
	/* 2066 */
	{40498, 0x7F},
	{10365, 0xFFFFFF80},
	/* 2068 */
	{95624, 0x7F},
	{10365, 0xFFFFFF80},
	/* 2070 */
	{10365, 0x1F},
	{95629, 0xFFFFFFE0},
	/* 2072 */
	{95648, 0x7F},
	{10365, 0xFFFFFF80},
	/* 2074 */
	{95648, 0x1FF},
	{10365, 0xFFFFFE00},
	/* 2076 */
	{95624, 0xFF},
	{10365, 0xFFFFFF00},
	/* 2078 */
	{95653, 0xFF},
	{95674, 0x100},
	{95684, 0x200},
	{95692, 0x400},
	{95706, 0x800},
	{95717, 0x1000},
	{95736, 0x2000},
	{95760, 0x4000},
	{95774, 0x8000},
	{10365, 0xFFFF0000},
	/* 2088 */
	{95784, 0x1},
	{95808, 0x2},
	{95832, 0x4},
	{95849, 0x8},
	{95866, 0x10},
	{95885, 0x20},
	{95902, 0x3C0},
	{10365, 0xFFFFFC00},
	/* 2096 */
	{95917, 0x1},
	{95929, 0x2},
	{95941, 0x4},
	{95951, 0x8},
	{95972, 0x10},
	{95989, 0x20},
	{96006, 0x40},
	{10365, 0xFFFFFF80},
	/* 2104 */
	{96030, 0xFFFF},
	{10365, 0xFFFF0000},
	/* 2106 */
	{96040, 0xFF},
	{10365, 0xFFFFFF00},
	/* 2108 */
	{96057, 0x7FFFF},
	{10365, 0xFFF80000},
	/* 2110 */
	{95546, 0xFF},
	{95559, 0xFF00},
	{95572, 0xFF0000},
	{96072, 0xFF000000},
	/* 2114 */
	{40220, 0xFF},
	{95530, 0xFF00},
	{10365, 0xFFFF0000},
	/* 2117 */
	{96085, 0x1},
	/* 2118 */
	{96109, 0x1},
	/* 2119 */
	{93333, 0x7, 6, 36588},
	{93761, 0x400},
	/* 2121 */
	{36871, 0xFF},
	/* 2122 */
	{9882, 0x1},
	{96127, 0x2},
	{18945, 0x4},
	{10365, 0xFFFFFFF8},
	/* 2126 */
	{96139, 0xF},
	{96144, 0x30},
	{10365, 0xFFFFFFC0},
	/* 2129 */
	{96151, 0x1},
	/* 2130 */
	{96171, 0x3},
	{96195, 0xC},
	{96219, 0x30},
	{96234, 0xC0},
	{96258, 0x300},
	{96282, 0x3C00},
	{96299, 0x7C000},
	{96317, 0x1F80000},
	{96353, 0x2000000},
	{96369, 0x4000000},
	/* 2140 */
	{93032, 0xFF},
	{96387, 0xFF00},
	{94652, 0xF000000},
	{9882, 0x10000000},
	{11232, 0x20000000},
	/* 2145 */
	{96400, 0xF},
	{96420, 0xFF00},
	{96434, 0xFF0000},
	{96447, 0x1000000},
	{96458, 0x2000000},
	{96468, 0x4000000},
	/* 2151 */
	{93032, 0x1FF},
	{94652, 0xF000000},
	{96489, 0xF0000000},
	/* 2154 */
	{93032, 0x3FF},
	{96499, 0xF0000000},
	/* 2156 */
	{91907, 0xF00, 6, 36612},
	{96551, 0x10000},
	{96563, 0x100000},
	{96578, 0xC0000000, 4, 36618},
	/* 2160 */
	{96589, 0xFFFFF},
	{96597, 0x100000},
	{55266, 0x800000},
	/* 2163 */
	{42924, 0xFFFFFFFF},
	/* 2164 */
	{26590, 0xFFFF},
	{91907, 0x300000, 4, 36622},
	{96618, 0x8000000, 2, 36618},
	{96640, 0x60000000, 4, 36626},
	{96648, 0x80000000},
	/* 2169 */
	{42808, 0xFFFFFFFF},
	/* 2170 */
	{91572, 0x3FFFFFF},
	{91583, 0x4000000, 2, 36630},
	{91587, 0x8000000, 2, 36630},
	{91591, 0x10000000, 2, 36632},
	{91596, 0x20000000, 2, 36632},
	{91601, 0x40000000},
	{96686, 0x80000000},
	/* 2177 */
	{85300, 0x3F},
	{96705, 0xF00},
	{96717, 0x1000},
	{96724, 0x2000},
	{96732, 0x4000},
	{96740, 0x8000},
	{96748, 0x10000},
	{96771, 0x60000, 4, 36634},
	{96796, 0x80000},
	{96808, 0x100000},
	{96816, 0x200000},
	{96860, 0xC00000, 3, 36638},
	/* 2189 */
	{96618, 0x1, 2, 36618},
	{91203, 0x6000},
	{91907, 0x300000, 4, 36622},
	{91243, 0x6000000},
	{96640, 0x60000000, 4, 36626},
	{96648, 0x80000000},
	/* 2195 */
	{96905, 0x3, 4, 36641},
	{96921, 0xC, 4, 36645},
	{96717, 0x10},
	{96724, 0x20},
	{96946, 0x40},
	{96953, 0x80},
	{96732, 0x100},
	{96740, 0x200},
	{96748, 0x400},
	{96771, 0x1800, 4, 36634},
	{96796, 0x2000},
	{96808, 0x4000},
	{96816, 0x8000},
	{96860, 0x30000, 3, 36638},
	{96961, 0x40000},
	/* 2210 */
	{96973, 0xFFFFF},
	/* 2211 */
	{55581, 0x1FF, 257, 0},
	{55586, 0x400},
	{55594, 0x800},
	{55607, 0x7000},
	{55615, 0x8000},
	{55626, 0xF0000},
	{55637, 0xF00000},
	{55653, 0x1000000},
	{96983, 0x10000000},
	{55679, 0xE0000000},
	/* 2221 */
	{55838, 0xF},
	{55845, 0x70},
	{55853, 0x80},
	{55867, 0xF00},
	{55876, 0x7000},
	{55903, 0xC00000},
	{55913, 0x1000000},
	{55939, 0xFC000000},
	/* 2229 */
	{42998, 0xFFFFF},
	/* 2230 */
	{56146, 0xF},
	{56169, 0x10},
	{56192, 0x20},
	{56215, 0x40},
	{56235, 0x80},
	{56255, 0x100},
	{56275, 0x200},
	{56295, 0x400},
	{56315, 0x800},
	{56335, 0x1000},
	{56355, 0x2000},
	{56375, 0x4000},
	{56390, 0x8000},
	{56401, 0x10000},
	{56409, 0x20000},
	{56418, 0x40000},
	{96993, 0x80000},
	{56450, 0x100000},
	{56463, 0x200000},
	{56473, 0x400000},
	{56490, 0x800000},
	{97013, 0x1000000},
	{97030, 0x2000000},
	{56507, 0x4000000},
	{56516, 0x8000000},
	{56525, 0x10000000},
	{56534, 0x20000000},
	{56543, 0x40000000},
	{56552, 0x80000000},
	/* 2259 */
	{56563, 0xF},
	{56602, 0x80},
	{56625, 0x100},
	{56648, 0x200},
	{56667, 0x1000},
	{56676, 0x2000},
	{56685, 0x4000},
	{56693, 0x8000},
	{56702, 0x10000},
	{56717, 0x100000},
	{56725, 0x200000},
	{56733, 0x400000},
	{56742, 0x800000},
	{56751, 0x1000000},
	{56759, 0x2000000},
	{56767, 0x4000000},
	{56775, 0x10000000},
	{56517, 0x20000000},
	{56793, 0x40000000},
	{56801, 0x80000000},
	/* 2279 */
	{43012, 0xFFFF},
	/* 2280 */
	{59957, 0x7FF, 2049, 257},
	{97047, 0x1000},
	{60119, 0xFF0000, 129, 2306},
	{60131, 0x3000000},
	{97072, 0x1C000000},
	{60144, 0x80000000},
	/* 2286 */
	{982, 0x3},
	{60159, 0x4},
	{60168, 0x8},
	{60179, 0x10},
	{60192, 0x20},
	{49765, 0x1C0},
	{60206, 0x200},
	{60219, 0x400},
	{60232, 0x800},
	{60244, 0x1000},
	{60262, 0x2000},
	{60273, 0xC000},
	{60288, 0x30000},
	{60296, 0x40000},
	{60315, 0x80000},
	{97084, 0x700000},
	{97099, 0x10000000},
	{97122, 0x20000000},
	{60332, 0x40000000},
	{60344, 0x80000000},
	/* 2306 */
	{60358, 0xFFF},
	{60373, 0xFFF000},
	{60385, 0x1000000},
	{56396, 0x2000000},
	{60393, 0x4000000},
	{60413, 0x8000000},
	{97138, 0xF0000000},
	/* 2313 */
	{97149, 0x1},
	{97159, 0x2},
	{97169, 0x10},
	/* 2316 */
	{60559, 0x7},
	{60569, 0x38},
	{60579, 0x1C0},
	{60589, 0xE00},
	{17302, 0x7F000, 293, 2468},
	{64826, 0x600000},
	{64839, 0x800000},
	{64854, 0x1000000},
	{97197, 0xC000000},
	{64960, 0x30000000, 4, 2761},
	{209, 0xC0000000},
	/* 2327 */
	{65362, 0x1FFFFF},
	{65381, 0xE00000},
	{65400, 0x1000000},
	{65422, 0x2000000},
	{97209, 0x4000000},
	{65460, 0x8000000},
	{65477, 0x10000000},
	{65495, 0x20000000},
	{65511, 0xC0000000},
	/* 2336 */
	{65532, 0x7},
	{65542, 0x38},
	{65563, 0xC0},
	{97232, 0x700},
	{65584, 0x180000},
	{65603, 0xC000000},
	/* 2342 */
	{18448, 0x1FFF},
	{21164, 0x3FFF},
	{67346, 0x1FFF0000},
	/* 2345 */
	{67357, 0xF},
	{67369, 0xF0},
	{67377, 0xFFF00},
	{67390, 0x700000},
	{67399, 0x800000},
	{67414, 0x2000000},
	{67429, 0x4000000},
	{71208, 0x80000000},
	/* 2353 */
	{67441, 0xFF},
	{97197, 0x300},
	{67457, 0x400},
	{67469, 0x18000},
	{67497, 0x60000},
	{67523, 0x80000},
	{67541, 0x100000},
	{67563, 0x200000},
	{67578, 0x400000},
	{67594, 0x800000},
	{67610, 0xFF000000},
	/* 2364 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{67742, 0x800000},
	{67752, 0x1000000},
	{67769, 0x2000000},
	{56116, 0x4000000},
	{97241, 0x8000000},
	{55387, 0x20000000},
	/* 2376 */
	{69024, 0x1},
	{69043, 0x2},
	{69064, 0x4},
	{69075, 0x8},
	{69088, 0x10},
	{69107, 0x20},
	{69132, 0x40},
	{69155, 0x80},
	{69169, 0xF00},
	{69181, 0x1000},
	{97260, 0x2000},
	/* 2387 */
	{70098, 0x3, 4, 3083},
	{70127, 0x1C},
	{70158, 0x20},
	{70194, 0x40},
	{70229, 0x80},
	{70257, 0x100},
	{70279, 0x200},
	{70297, 0x400},
	{70329, 0x800},
	{70450, 0x7000, 8, 3087},
	{70460, 0x38000},
	{70473, 0x1C0000},
	{70486, 0x200000},
	{70502, 0x400000},
	{70520, 0x800000},
	{70538, 0x2000000},
	{97278, 0x4000000},
	{97298, 0x18000000},
	/* 2405 */
	{97429, 0x7, 5, 36649},
	{97461, 0x30},
	{97481, 0xC0},
	/* 2408 */
	{71056, 0x3, 4, 3109},
	{71068, 0xC, 4, 3109},
	{71080, 0x30, 4, 3109},
	{71096, 0xC0, 4, 3109},
	{71166, 0x30000, 4, 3113},
	{71178, 0xC0000, 4, 3113},
	{71190, 0x300000, 4, 3113},
	{71206, 0x1000000},
	{71217, 0x2000000},
	{97501, 0x4000000},
	{97511, 0x8000000},
	{97521, 0x10000000},
	{97535, 0x20000000},
	/* 2421 */
	{9882, 0x1},
	{73749, 0x6},
	{65603, 0x60},
	{73791, 0x3000},
	{73798, 0x30000},
	{73812, 0x300000},
	/* 2427 */
	{73919, 0x3, 4, 3109},
	{73935, 0xC, 4, 3109},
	{73951, 0x30, 4, 3109},
	{73965, 0xC0, 4, 3109},
	{73981, 0x30000, 4, 3113},
	{73997, 0xC0000, 4, 3113},
	{74013, 0x300000, 4, 3113},
	{74027, 0xC00000, 4, 3113},
	{97550, 0x1000000},
	{97566, 0x2000000},
	{97582, 0x4000000},
	{97596, 0x8000000},
	{74043, 0x40000000},
	{74058, 0x80000000},
	/* 2441 */
	{754, 0x3F},
	{74828, 0x300},
	{74840, 0x400},
	{97612, 0x800},
	{74851, 0x1E000},
	{74860, 0x20000},
	{74874, 0x40000},
	{74878, 0x80000},
	{74895, 0x100000},
	{74913, 0x600000},
	{74931, 0x800000},
	{74951, 0x1000000},
	{74963, 0x2000000},
	/* 2454 */
	{754, 0x3F},
	{74828, 0x300},
	{74840, 0x400},
	{97612, 0x800},
	{74874, 0x40000},
	{74878, 0x80000},
	{74895, 0x100000},
	{74913, 0x600000},
	{74951, 0x1000000},
	{74963, 0x2000000},
	/* 2464 */
	{74975, 0x3E},
	{74991, 0x40},
	{75004, 0x80},
	{97626, 0x1F00},
	/* 2468 */
	{75525, 0x3F},
	{75546, 0x80},
	{75563, 0x100},
	{97644, 0x3E00},
	{75579, 0x4000},
	{75599, 0x8000},
	/* 2474 */
	{97660, 0x1},
	{97685, 0x2},
	{97710, 0x4},
	{97735, 0x8},
	{97760, 0x10},
	{97785, 0x20},
	{97810, 0x40},
	{97835, 0x80},
	/* 2482 */
	{76545, 0xF, 12, 36654},
	{76550, 0xF0, 12, 36654},
	{76555, 0xF00, 12, 36654},
	{76560, 0xF000, 12, 36654},
	{76565, 0xF0000, 12, 36654},
	{76570, 0xF00000, 12, 36654},
	{76575, 0xF000000, 12, 36654},
	{76580, 0xF0000000, 12, 36654},
	/* 2490 */
	{78359, 0x3, 4, 36055},
	{78405, 0xC, 2, 36059},
	{78416, 0x10},
	{78431, 0x20},
	{78439, 0x40},
	{78481, 0xE0000000},
	/* 2496 */
	{78972, 0x1},
	{97882, 0x2},
	{78990, 0x8},
	{982, 0x70, 8, 36061},
	{78263, 0xFF0000, 256, 36069},
	/* 2501 */
	{80735, 0x1},
	{80751, 0x2},
	{80767, 0x4},
	{80783, 0x8},
	{80799, 0x10},
	{80815, 0x20},
	{80831, 0x40},
	{80847, 0x80},
	{80863, 0x100},
	{80879, 0x200},
	{80895, 0x400},
	{80911, 0x800},
	{80927, 0x1000},
	{80943, 0x2000},
	{80959, 0x4000},
	{80975, 0x8000},
	{80991, 0x10000},
	{81010, 0x20000},
	{81028, 0x40000},
	{81055, 0x80000},
	{81077, 0x100000},
	{81095, 0x200000},
	{81115, 0x400000},
	{81138, 0x800000},
	{81161, 0x1000000},
	{81186, 0x2000000},
	{81229, 0x8000000},
	{97905, 0x10000000},
	{97922, 0x20000000},
	{97947, 0x40000000},
	/* 2531 */
	{81931, 0x1},
	{81948, 0x2},
	{97973, 0x3FC},
	/* 2534 */
	{97992, 0x7, 5, 36649},
	{98018, 0x38, 5, 36649},
	{98047, 0x1C0, 5, 36649},
	{98072, 0xE00, 5, 36649},
	{98098, 0x2000},
	{98121, 0x4000},
	/* 2540 */
	{83081, 0x1},
	{83093, 0x2},
	{83114, 0x4},
	{83134, 0x8},
	{83180, 0x20},
	{83203, 0x40},
	/* 2546 */
	{203, 0x3, 3, 36374},
	{83924, 0xC, 4, 36377},
	{84004, 0x30, 4, 36381},
	{84064, 0xC0, 3, 36385},
	{84077, 0x100},
	{78431, 0x200},
	{84081, 0x400},
	{84090, 0x3800},
	{98148, 0x4000},
	/* 2555 */
	{85355, 0x2},
	{85389, 0x8},
	{85405, 0x10},
	{98173, 0x40},
	/* 2559 */
	{70848, 0x1},
	{85514, 0x2},
	{85525, 0x4},
	{85542, 0x8},
	{85559, 0x3F0},
	{85576, 0xFC00},
	{85593, 0x10000},
	{85617, 0x20000},
	{67528, 0x40000},
	{98251, 0x180000, 3, 36666},
	/* 2569 */
	{85865, 0x3, 4, 36452},
	{85896, 0x4, 2, 36456},
	{19758, 0x18, 4, 36458},
	{85978, 0x20, 2, 36462},
	{86043, 0xC0, 4, 36464},
	{86049, 0x100},
	{68377, 0x200},
	{86060, 0x400},
	{86080, 0x800},
	{86100, 0x1000},
	{86114, 0x2000},
	{86125, 0x4000},
	{86141, 0x78000},
	{86161, 0x180000},
	{86176, 0x200000},
	{86186, 0x400000},
	{86196, 0x800000},
	{86206, 0x1000000},
	{86221, 0x2000000},
	{98270, 0x4000000},
	/* 2589 */
	{87367, 0x7},
	{87384, 0x10},
	{87406, 0x1E000},
	{87422, 0x700000},
	{87443, 0x3000000},
	{87523, 0xC000000, 4, 36489},
	{98294, 0x10000000},
	{98319, 0x20000000},
	/* 2597 */
	{89342, 0x3, 4, 36520},
	{17302, 0x7C, 25, 36669},
	{65623, 0x80},
	{89940, 0x700, 8, 36556},
	{89996, 0x1800, 4, 36564},
	{79039, 0x2000},
	{70033, 0x4000},
	{90006, 0x8000},
	{90018, 0x10000},
	{90031, 0x20000},
	{87610, 0x40000},
	{90044, 0x80000},
	{90271, 0x700000, 8, 36568},
	{90293, 0x3800000, 8, 36568},
	{90317, 0x4000000},
	{90343, 0x8000000},
	{90369, 0x10000000},
	{90437, 0x60000000, 3, 36576},
	{98360, 0x80000000},
	/* 2616 */
	{74073, 0x1},
	{90611, 0x2},
	{67469, 0xC, 3, 36579},
	{90725, 0x10, 2, 36582},
	{67497, 0x60},
	{67594, 0x180},
	{90751, 0x200},
	{90774, 0x3C00},
	{90794, 0x3C000},
	{74189, 0x40000},
	{90816, 0x80000},
	{90849, 0x100000},
	{98371, 0x200000},
	{98391, 0x400000},
	/* 2630 */
	{90906, 0x1FFF},
	{90917, 0x2000},
	{90929, 0x7C000},
	{90943, 0xF80000},
	{90957, 0x3000000},
	{90971, 0x4000000},
	{64854, 0x38000000},
	{90990, 0x40000000},
	{98412, 0x80000000},
	/* 2639 */
	{98433, 0xFFFFFF},
	{10114, 0x7000000},
	{98439, 0x8000000},
	{1, 0x70000000},
	{98450, 0x80000000},
	/* 2644 */
	{98461, 0x1},
	{26333, 0xFFFFFFF8},
	/* 2646 */
	{91772, 0x1},
	{91786, 0x2},
	{98470, 0x8000},
	{91798, 0x10000},
	{91812, 0x1000000},
	/* 2651 */
	{91907, 0x30000},
	{98485, 0x300000},
	{98500, 0xC00000},
	{91915, 0x7000000},
	{91923, 0xE0000000},
	/* 2656 */
	{203, 0x3, 3, 36374},
	{98148, 0x4000},
	/* 2658 */
	{92467, 0x3FF},
	{92533, 0xC00, 4, 36584},
	/* 2660 */
	{97474, 0x3},
	{97494, 0x30},
	/* 2662 */
	{92847, 0x1},
	{92859, 0x2},
	{92871, 0x4},
	{30219, 0x10000},
	{92882, 0x60000},
	/* 2667 */
	{81023, 0x1},
	{858, 0x1FFE},
	{209, 0x2000},
	{88904, 0x4000},
	{92926, 0x8000},
	{92938, 0x7FF0000},
	{92949, 0x8000000},
	{92960, 0x10000000},
	{92970, 0x20000000},
	{98510, 0x40000000},
	{92904, 0x80000000},
	/* 2678 */
	{93032, 0x1FF},
	{93051, 0xF00000},
	{94652, 0xF0000000},
	/* 2681 */
	{56044, 0x1},
	{86043, 0x2, 4, 36464},
	{85978, 0x4, 2, 36462},
	{19758, 0x8, 4, 36458},
	{85896, 0x10, 2, 36456},
	{85865, 0x20, 4, 36452},
	{94748, 0x40},
	{94754, 0x300},
	{94764, 0x2000},
	{98522, 0x4000},
	{98544, 0x8000},
	{98566, 0x10000},
	{98588, 0x20000},
	{98610, 0x40000},
	{98632, 0x80000},
	/* 2696 */
	{95648, 0x7FF},
	{10365, 0xFFFFF800},
	/* 2698 */
	{95653, 0xFF},
	{95674, 0x100},
	{95684, 0x200},
	{95692, 0x400},
	{95706, 0x800},
	{95717, 0x1000},
	{95736, 0x2000},
	{95760, 0x4000},
	{95774, 0x8000},
	{98654, 0x10000},
	{98667, 0x20000},
	{98678, 0x40000},
	{98695, 0x80000},
	{98709, 0x100000},
	{98721, 0x200000},
	{98737, 0x400000},
	{10365, 0xFF800000},
	/* 2715 */
	{95784, 0x1},
	{95808, 0x2},
	{95832, 0x4},
	{98753, 0x8},
	{95902, 0xF0},
	{98773, 0x100},
	{98793, 0x200},
	{98808, 0x400},
	{10365, 0xFFFFF800},
	/* 2724 */
	{95917, 0x1},
	{98833, 0x2},
	{98856, 0x4},
	{96006, 0x8},
	{98870, 0x10},
	{95929, 0x20},
	{98897, 0x40},
	{95941, 0x80},
	{98912, 0x100},
	{95951, 0x200},
	{98925, 0x400},
	{95972, 0x800},
	{98949, 0x1000},
	{95989, 0x2000},
	{98969, 0x4000},
	{98989, 0x8000},
	{99006, 0x10000},
	{99026, 0x20000},
	{99043, 0x40000},
	/* 2743 */
	{754, 0xFFFF},
	{10365, 0xFFFF0000},
	/* 2745 */
	{99063, 0xFF},
	{99077, 0xFF00},
	{99100, 0xFF0000},
	{10365, 0xFF000000},
	/* 2749 */
	{99127, 0xFF},
	{99143, 0xFF00},
	{10365, 0xFFFF0000},
	/* 2752 */
	{99159, 0xFFFF},
	/* 2753 */
	{55217, 0xF},
	{55226, 0xF0},
	{55236, 0x100},
	{55247, 0x200},
	{55252, 0x400},
	{99166, 0x800},
	{55379, 0x7F000, 257, 0},
	{55410, 0x10000000},
	{55416, 0xE0000000},
	/* 2762 */
	{55420, 0x1},
	{55424, 0x6},
	{99175, 0x18},
	{55443, 0x20},
	{55448, 0x40},
	{55456, 0x80},
	{55466, 0x100},
	{55477, 0x200},
	{55483, 0x400},
	{55488, 0x800},
	{55494, 0x1000},
	{55505, 0x2000},
	{55510, 0x4000},
	{99185, 0x8000},
	{55266, 0x10000},
	{55530, 0x20000},
	{55538, 0x40000},
	{55550, 0x80000},
	{99198, 0x100000},
	{99212, 0x200000},
	{99225, 0x400000},
	{99234, 0x800000},
	{99243, 0x7000000},
	{55569, 0x8000000},
	/* 2786 */
	{55581, 0x7F, 257, 0},
	{55626, 0x3F0000},
	{55679, 0xE0000000},
	/* 2789 */
	{50478, 0xF},
	{55687, 0x30},
	{55695, 0xC0},
	{55703, 0xF00},
	{55709, 0x1000},
	{28888, 0x2000},
	{55727, 0xF0000},
	{55733, 0xF00000},
	{55739, 0x7000000},
	{55748, 0x38000000},
	{55757, 0xC0000000},
	/* 2800 */
	{55763, 0x3F},
	{55773, 0x3F00},
	{55783, 0x3F0000},
	{55793, 0xF000000},
	/* 2804 */
	{55803, 0xFF},
	{55812, 0x1FF000},
	/* 2806 */
	{55838, 0xF},
	{55845, 0x70},
	{55867, 0x1F00},
	{55876, 0xE000},
	/* 2810 */
	{1112, 0xFF},
	/* 2811 */
	{99263, 0x7},
	{99271, 0x8},
	{99282, 0x10},
	{99295, 0xE0},
	{99311, 0x300},
	{99321, 0xC00},
	{99331, 0x70000},
	{56001, 0x380000},
	{99343, 0xC00000},
	{99350, 0x1000000},
	{99357, 0x6000000},
	{69691, 0x8000000},
	{99365, 0x10000000},
	/* 2824 */
	{9994, 0xFF},
	/* 2825 */
	{99382, 0x1},
	{99398, 0x2},
	{56490, 0x4},
	{99413, 0x8},
	{99429, 0x10},
	{56463, 0x20},
	{99438, 0x40},
	{99449, 0x80},
	{99459, 0x100},
	{99469, 0x200},
	{99479, 0x400},
	{99490, 0x800},
	{99501, 0x1000},
	{99513, 0x2000},
	{99522, 0x4000},
	{99532, 0x8000},
	{97013, 0x10000},
	{97030, 0x20000},
	{99541, 0x40000},
	{99559, 0x80000},
	{99574, 0x100000},
	/* 2846 */
	{99590, 0x2},
	{99605, 0x4},
	{99623, 0x8},
	{56587, 0x10},
	{99638, 0x20},
	{99654, 0x40},
	{99668, 0x100},
	{99677, 0x200},
	{99686, 0x400},
	{99707, 0x800},
	{99716, 0x1000},
	{99725, 0x2000},
	{99735, 0x4000},
	{99744, 0x10000},
	{99753, 0x20000},
	{99761, 0x80000},
	{99770, 0x100000},
	{99782, 0x200000},
	{99795, 0x400000},
	{99808, 0x20000000},
	/* 2866 */
	{99817, 0x1},
	{99827, 0x2},
	{99837, 0x4},
	{99847, 0x8},
	{99857, 0x10},
	{99867, 0x20},
	{99877, 0x40},
	{99887, 0x80},
	{99897, 0x100},
	{99907, 0x200},
	{99917, 0x400},
	{99927, 0x800},
	{99937, 0x1000},
	{99947, 0x2000},
	{99957, 0x4000},
	{99967, 0x8000},
	/* 2882 */
	{99977, 0xFF},
	/* 2883 */
	{99990, 0x3F},
	{100009, 0xFC0},
	/* 2885 */
	{56146, 0xF},
	{56375, 0x1},
	{56169, 0x10},
	{56192, 0x20},
	{56215, 0x40},
	{56235, 0x80},
	{56255, 0x100},
	{56507, 0x100},
	{56275, 0x200},
	{57445, 0x200},
	{56295, 0x400},
	{56315, 0x800},
	{56335, 0x1000},
	{56355, 0x2000},
	{56525, 0x10000000},
	{56534, 0x20000000},
	{56543, 0x40000000},
	/* 2902 */
	{100020, 0xF},
	{100029, 0xF0},
	/* 2904 */
	{56563, 0xF},
	{100038, 0x20},
	{56602, 0x80},
	{56625, 0x100},
	{56648, 0x200},
	{56667, 0x1000},
	{56676, 0x2000},
	{56685, 0x4000},
	{56693, 0x8000},
	{100054, 0x10000},
	{100069, 0x20000},
	{100078, 0x40000},
	{100093, 0x80000},
	{56717, 0x100000},
	{100101, 0x200000},
	{56733, 0x400000},
	{56742, 0x800000},
	{56751, 0x1000000},
	{56759, 0x2000000},
	{56767, 0x4000000},
	{56775, 0x10000000},
	{56517, 0x20000000},
	{56793, 0x40000000},
	{56801, 0x80000000},
	/* 2928 */
	{56667, 0x2},
	{56676, 0x4},
	{56742, 0x400000},
	{100069, 0x800000},
	{56759, 0x1000000},
	{56685, 0x2000000},
	{56717, 0x4000000},
	{56733, 0x8000000},
	{56751, 0x20000000},
	{56767, 0x40000000},
	{56793, 0x80000000},
	/* 2939 */
	{100109, 0x1},
	{100123, 0x4},
	{100138, 0x10000},
	{100153, 0x20000},
	{100168, 0x40000},
	{100183, 0x80000},
	/* 2945 */
	{100198, 0x3F},
	/* 2946 */
	{92386, 0xFF},
	{100215, 0xFF00},
	{92341, 0xFF0000},
	{100224, 0x20000000},
	{92421, 0x40000000},
	{92447, 0x80000000},
	/* 2952 */
	{100244, 0xF},
	{100261, 0x1F00},
	/* 2954 */
	{47204, 0xFF},
	/* 2955 */
	{100276, 0x2},
	{100287, 0x20},
	{100298, 0x40},
	{100319, 0x80},
	{100339, 0xF00},
	{100361, 0x1000},
	/* 2961 */
	{100387, 0x1},
	{100395, 0x2},
	{100403, 0x2},
	{100412, 0x8},
	{100428, 0x10},
	{100444, 0x40},
	{100465, 0x80},
	{100486, 0x100},
	{100507, 0x200},
	{100515, 0x200},
	{100536, 0x400},
	{100557, 0x800},
	{100578, 0x1000},
	{100599, 0x2000},
	{100620, 0x4000},
	{100641, 0x8000},
	{100662, 0x10000},
	{100683, 0x20000},
	{100704, 0x40000},
	{100725, 0x80000},
	{100746, 0x100000},
	{100767, 0x200000},
	/* 2983 */
	{100788, 0x3FFFC},
	{100801, 0x300000},
	{100813, 0xC00000},
	{47257, 0x80000000},
	/* 2987 */
	{100823, 0x1},
	{100840, 0x80000},
	/* 2989 */
	{93032, 0x3F},
	{93860, 0x400},
	{93887, 0x800},
	{100860, 0x1000},
	{93914, 0x2000},
	{93940, 0x4000},
	{93966, 0x10000},
	{93993, 0x20000},
	{94019, 0x40000},
	{94045, 0x80000},
	{94073, 0x100000},
	{94099, 0x200000},
	{94125, 0x400000},
	{100887, 0x800000},
	{94151, 0x1000000},
	{94178, 0x2000000},
	{94205, 0x4000000},
	{100913, 0x8000000},
	{100939, 0x10000000},
	/* 3008 */
	{93032, 0x3F},
	{93860, 0x400},
	{93887, 0x800},
	{93914, 0x1000},
	{93940, 0x2000},
	{93966, 0x8000},
	{93993, 0x10000},
	{94073, 0x20000},
	{94099, 0x40000},
	{100860, 0x80000},
	{94019, 0x100000},
	{94178, 0x200000},
	/* 3020 */
	{47282, 0x3FFFF},
	/* 3021 */
	{100965, 0x1},
	{100978, 0x2},
	{100982, 0x4},
	{101004, 0x8},
	{101018, 0x10},
	{101032, 0x20},
	{101050, 0x40},
	{101068, 0x80},
	{28888, 0x2000000},
	{98218, 0xC000000},
	/* 3031 */
	{91121, 0x3},
	{9965, 0xFFFFFFFC},
	/* 3033 */
	{101083, 0x3},
	{24328, 0xFFFFFFFC},
	/* 3035 */
	{101104, 0x3},
	{24844, 0xFFFFFFFC},
	/* 3037 */
	{91095, 0xFF},
	{91107, 0x30000},
	{26653, 0xE0000000},
	/* 3040 */
	{101125, 0x3},
	{26203, 0xFFFFFFFC},
	/* 3042 */
	{26221, 0xFF},
	/* 3043 */
	{101142, 0x3},
	{26275, 0xFFFFFFFC},
	/* 3045 */
	{26293, 0xFF},
	/* 3046 */
	{26352, 0xFF},
	{91131, 0x10000},
	{91147, 0x100000},
	{91163, 0x3000000},
	{91179, 0xE0000000},
	/* 3051 */
	{92086, 0x1},
	{92102, 0x2},
	{92118, 0x40},
	{92136, 0x80},
	{92154, 0x100},
	{92172, 0x200},
	{92190, 0x400},
	{92208, 0x800},
	{92226, 0x1000},
	{92244, 0x2000},
	{92262, 0x4000},
	{91381, 0x8000},
	{101159, 0x10000},
	{91401, 0x40000},
	{92279, 0x80000},
	{92295, 0x200000},
	{91418, 0x400000},
	{91434, 0x800000},
	{91448, 0x2000000},
	{91462, 0x4000000},
	{91476, 0x8000000},
	{91497, 0x10000000},
	{91522, 0x20000000},
	/* 3074 */
	{92311, 0xFF},
	{91567, 0x3000000},
	{101177, 0x40000000},
	{995, 0x80000000},
	/* 3078 */
	{26590, 0xFF},
	/* 3079 */
	{26631, 0xFF},
	/* 3080 */
	{91572, 0x1FFFFF},
	{91610, 0x200000},
	{101191, 0xC00000},
	{101200, 0x3000000},
	{91583, 0x4000000},
	{91587, 0x8000000},
	{91591, 0x10000000},
	{91596, 0x20000000},
	{91601, 0x40000000},
	/* 3089 */
	{91651, 0x30},
	{91663, 0xF0000},
	{91676, 0x10000000},
	{91691, 0x20000000},
	{91705, 0xC0000000},
	/* 3094 */
	{91766, 0x1},
	/* 3095 */
	{101209, 0x1},
	{101234, 0x2},
	{101272, 0x4},
	{101313, 0x8},
	{101336, 0x10},
	{101359, 0x20},
	{101383, 0x40},
	{101413, 0x80},
	{101442, 0x100},
	{101473, 0x400},
	{101499, 0x800},
	{101528, 0x1000},
	{101553, 0x2000},
	{59138, 0x4000},
	{59159, 0x8000},
	/* 3110 */
	{101588, 0x1},
	{101615, 0x4},
	{101642, 0x10},
	{101671, 0x400},
	{101700, 0x800},
	{101729, 0x1000},
	{101757, 0x2000},
	{101787, 0x4000},
	{101814, 0x8000},
	{101842, 0x10000},
	{101868, 0x20000},
	{101894, 0x800000},
	{101919, 0x1000000},
	{101945, 0x2000000},
	{101970, 0x4000000},
	{101994, 0x8000000},
	{102019, 0x10000000},
	{102048, 0x10000000},
	/* 3128 */
	{102076, 0x1},
	{102102, 0x2},
	{102128, 0x4},
	{102155, 0x10},
	{102181, 0x20},
	{102203, 0x40},
	{102224, 0x80},
	{102256, 0x100},
	{102283, 0x200},
	{102305, 0x400},
	{102329, 0x800},
	{102354, 0x1000},
	{102377, 0x2000},
	{102404, 0x4000},
	{102429, 0x8000},
	{102457, 0x10000},
	{102482, 0x20000},
	{102507, 0x40000},
	{102532, 0x80000},
	{102561, 0x100000},
	{102592, 0x200000},
	{102620, 0x400000},
	{102647, 0x800000},
	{102677, 0x1000000},
	{102704, 0x2000000},
	{102731, 0x4000000},
	{102758, 0x8000000},
	{102784, 0x10000000},
	{102808, 0x20000000},
	{102840, 0x40000000},
	{102867, 0x80000000},
	/* 3159 */
	{58475, 0x1},
	{102893, 0x40},
	{102912, 0x80},
	{102932, 0x100},
	{102951, 0x200},
	{102965, 0x400},
	{102978, 0x1000},
	{103000, 0x2000},
	{103023, 0x4000},
	{103044, 0x8000},
	{103061, 0x20000},
	{103076, 0x40000},
	{103090, 0x80000},
	{103104, 0x100000},
	{103120, 0x200000},
	{103133, 0x400000},
	/* 3175 */
	{103152, 0x80},
	{103167, 0x100},
	{58159, 0x200},
	{58173, 0x400},
	{58192, 0x800},
	{58211, 0x1000},
	{103182, 0x2000},
	{102956, 0x8000},
	{103190, 0x10000},
	{102970, 0x20000},
	{103199, 0x40000},
	{58287, 0x80000},
	{58302, 0x100000},
	{103210, 0x200000},
	{56464, 0x400000},
	{58335, 0x800000},
	{57152, 0x1000000},
	{103228, 0x2000000},
	{103125, 0x4000000},
	{57142, 0x8000000},
	{58226, 0x10000000},
	{58243, 0x20000000},
	{58265, 0x40000000},
	{56517, 0x80000000},
	/* 3199 */
	{1854, 0x3F},
	{103241, 0x3F00},
	{103256, 0x3F0000},
	/* 3202 */
	{47626, 0x1F},
	/* 3203 */
	{103271, 0xF},
	{103294, 0x3F00},
	/* 3205 */
	{103315, 0xF},
	/* 3206 */
	{103334, 0x10},
	{103355, 0x40},
	{103377, 0x100},
	{103398, 0x1000000},
	{103406, 0x2000000},
	{103414, 0x4000000},
	{103423, 0x8000000},
	{103432, 0x10000000},
	{103440, 0x20000000},
	/* 3215 */
	{103448, 0xFF},
	{103469, 0x700},
	{103490, 0xFF00000},
	{103510, 0x70000000},
	/* 3219 */
	{103530, 0x1},
	/* 3220 */
	{103551, 0xFFFFF},
	/* 3221 */
	{103559, 0xFFFFFFF},
	{103575, 0xF0000000},
	/* 3223 */
	{103591, 0xFFFF},
	{103606, 0xFFFF0000},
	/* 3225 */
	{27326, 0xFF},
	/* 3226 */
	{27380, 0xFF},
	/* 3227 */
	{27432, 0xFF},
	/* 3228 */
	{27563, 0xFF},
	/* 3229 */
	{103622, 0xFF},
	{103632, 0xFF00},
	{103642, 0xFF0000},
	{103655, 0xFF000000},
	/* 3233 */
	{103668, 0xFF},
	{103681, 0xFF00},
	{103694, 0xFF0000},
	{103707, 0xFF000000},
	/* 3237 */
	{103720, 0xFF},
	{103731, 0xFF00},
	{103742, 0xFF0000},
	/* 3240 */
	{103753, 0x3F},
	{103767, 0x3F00},
	/* 3242 */
	{103781, 0xFF},
	{103792, 0xFF00},
	/* 3244 */
	{103803, 0x7FF},
	{103816, 0x7FF0000},
	/* 3246 */
	{103828, 0x1FF},
	/* 3247 */
	{103836, 0x7FF},
	/* 3248 */
	{103848, 0x3FF},
	/* 3249 */
	{47930, 0x7FF},
	{103856, 0x3000},
	{103867, 0x30000},
	/* 3252 */
	{103881, 0x3FF},
	{103898, 0x3FF0000},
	/* 3254 */
	{103915, 0x3FF},
	{103934, 0x3FF0000},
	/* 3256 */
	{103953, 0x3FF},
	{103972, 0x3FF0000},
	/* 3258 */
	{103991, 0x3FF},
	/* 3259 */
	{104000, 0x3FF},
	{104009, 0x3FF0000},
	/* 3261 */
	{104018, 0x7FF},
	{104031, 0x7FF0000},
	/* 3263 */
	{104043, 0x7FF},
	/* 3264 */
	{104055, 0x3FF},
	{104072, 0x3FF0000},
	/* 3266 */
	{104089, 0x3FF},
	{104108, 0x3FF0000},
	/* 3268 */
	{104127, 0x3FF},
	{104146, 0x3FF0000},
	/* 3270 */
	{104165, 0x4000},
	{104191, 0x20000},
	{104221, 0x80000},
	{104244, 0x100000},
	{104268, 0x400000},
	{104292, 0x800000},
	{104314, 0x1000000},
	{104340, 0x4000000},
	{104364, 0x8000000},
	{104396, 0x20000000},
	{104418, 0x40000000},
	{104440, 0x80000000},
	/* 3282 */
	{93032, 0xFF},
	{93041, 0xFFC00},
	{94598, 0xF00000},
	{94619, 0xF000000},
	{94652, 0xF0000000},
	/* 3287 */
	{93032, 0xFF},
	{94652, 0xF0000000},
	/* 3289 */
	{104462, 0x3FF},
	/* 3290 */
	{48396, 0x1FF},
	/* 3291 */
	{48420, 0x3F},
	/* 3292 */
	{48443, 0x3F},
	/* 3293 */
	{78268, 0x7},
	{104473, 0x70000},
	/* 3295 */
	{48488, 0x3},
	{104486, 0x20},
	{104505, 0xC0},
	{104519, 0x200},
	{104531, 0x800},
	{104552, 0x1000},
	{104569, 0x2000},
	{104590, 0x1F0000},
	/* 3303 */
	{104599, 0x7F},
	{82782, 0x80},
	{104620, 0x3FFF00},
	{82847, 0xFFC00000},
	/* 3307 */
	{104637, 0x1F},
	/* 3308 */
	{104648, 0x3},
	/* 3309 */
	{100093, 0x1},
	{104666, 0x2},
	{104678, 0x4},
	{104694, 0x8},
	{104706, 0x10},
	/* 3314 */
	{104718, 0x3F},
	{104733, 0x40},
	/* 3316 */
	{104753, 0x3F},
	{104767, 0x40},
	/* 3318 */
	{100069, 0x1},
	{104786, 0x2},
	{104804, 0x4},
	{104817, 0x8},
	{104829, 0x10},
	{104841, 0x20},
	{104853, 0x40},
	{104865, 0x80},
	{104877, 0x100},
	{104889, 0x200},
	/* 3328 */
	{104903, 0xFF},
	/* 3329 */
	{18464, 0x3F, 29, 36694},
	/* 3330 */
	{203, 0x3, 2, 36374},
	/* 3331 */
	{105111, 0xF},
	{105120, 0xFF0},
	{105135, 0x1000000},
	{105150, 0x2000000},
	{105162, 0x4000000},
	{105173, 0x8000000},
	{105188, 0x10000000},
	{105203, 0x20000000},
	{105215, 0x40000000},
	{105229, 0x80000000},
	/* 3341 */
	{9882, 0x1},
	{10112, 0x1E},
	/* 3343 */
	{105111, 0xF},
	{105120, 0xFF0},
	{105135, 0x1000000},
	{105150, 0x2000000},
	{105162, 0x4000000},
	{105173, 0x8000000},
	{105188, 0x10000000},
	{105215, 0x20000000},
	{105242, 0x20000000},
	{105229, 0x80000000},
	/* 3353 */
	{105257, 0x1},
	{105270, 0x7E},
	{105287, 0x80},
	/* 3356 */
	{92467, 0x7F},
	{92533, 0x600, 4, 36584},
	/* 3358 */
	{105312, 0x6},
	{105322, 0x8},
	{105342, 0x10},
	{105351, 0xFFFF0000},
	/* 3362 */
	{105364, 0x1F},
	/* 3363 */
	{105378, 0x80000000},
	/* 3364 */
	{105386, 0x1},
	{105407, 0x6},
	{105420, 0x8},
	{105443, 0x10},
	{105463, 0x20},
	{105482, 0x10000000},
	{105493, 0x20000000},
	{105504, 0x40000000},
	{105515, 0x80000000},
	/* 3373 */
	{105111, 0xF},
	{105120, 0xFF0},
	{105135, 0x1000000},
	{105526, 0x2000000},
	{105541, 0x4000000},
	{105173, 0x8000000},
	{105188, 0x10000000},
	{105556, 0x20000000},
	{105572, 0x40000000},
	{105588, 0x80000000},
	/* 3383 */
	{105605, 0x80000000},
	/* 3384 */
	{18448, 0xFF},
	/* 3385 */
	{93032, 0x1FF},
	{93041, 0xFFC00},
	{94598, 0xF00000},
	/* 3388 */
	{105613, 0xFFFF},
	{105635, 0xFFFF0000},
	/* 3390 */
	{105111, 0xF},
	{105120, 0xFF0},
	{105135, 0x1000000},
	{105526, 0x2000000},
	{105541, 0x4000000},
	{105173, 0x8000000},
	{105188, 0x10000000},
	{105242, 0x20000000},
	{105657, 0x40000000},
	{105672, 0x80000000},
	/* 3400 */
	{105687, 0x3F},
	{105714, 0x7FC0},
	{105740, 0x1F8000},
	{105762, 0xFF800000},
	/* 3404 */
	{105787, 0x3F},
	{105811, 0xFC0},
	{105835, 0x3F000},
	{105855, 0xFC0000},
	/* 3408 */
	{105875, 0x3F},
	/* 3409 */
	{105889, 0x1},
	{105915, 0x2},
	{105938, 0x4},
	{105963, 0x8},
	{105994, 0x10},
	{106028, 0x20},
	{106048, 0xC0},
	{106075, 0x100},
	{106103, 0x200},
	{106138, 0x400},
	{106168, 0x800},
	{106203, 0x1000},
	{106233, 0x2000},
	{106256, 0x4000},
	{106295, 0x8000},
	{106327, 0x10000},
	{106363, 0x20000},
	{106393, 0x40000},
	{106439, 0x80000},
	{106480, 0x100000},
	{106530, 0x200000},
	{106580, 0x400000},
	{106631, 0x800000},
	{106679, 0x1000000},
	{105504, 0x40000000},
	{105515, 0x80000000},
	/* 3435 */
	{92379, 0xFF},
	{99166, 0x100},
	{106725, 0x200},
	{106744, 0x400},
	{106765, 0x800},
	{106784, 0x1000},
	{106806, 0x2000},
	{106827, 0x4000},
	{106850, 0x8000},
	/* 3444 */
	{106880, 0x3},
	{106896, 0xC},
	{106912, 0x30},
	{106928, 0x40},
	{106943, 0x80},
	{106961, 0x100},
	{106976, 0x200},
	{106995, 0x400},
	{107013, 0x800},
	/* 3453 */
	{107034, 0x1},
	{107050, 0x2},
	{107066, 0x4},
	/* 3456 */
	{107086, 0x7F},
	{107090, 0x380},
	{107094, 0x1FFC00},
	/* 3459 */
	{107098, 0x3F},
	{107111, 0xF00},
	{107123, 0x10000000},
	{107132, 0x20000000},
	{101068, 0x40000000},
	{101037, 0x80000000},
	/* 3465 */
	{107146, 0xF},
	{107166, 0xF00},
	{107183, 0x30000},
	{107199, 0xC0000},
	/* 3469 */
	{56044, 0x1},
	{86043, 0x2, 4, 36464},
	{85978, 0x4, 2, 36462},
	{19758, 0x8, 4, 36458},
	{85896, 0x10, 2, 36456},
	{85865, 0x20, 4, 36452},
	{94748, 0x40},
	{94754, 0x1F00},
	{94764, 0x2000},
	/* 3478 */
	{107219, 0xF0000},
	{107237, 0xF00000},
	{107255, 0xF000000},
	{107273, 0xF0000000},
	/* 3482 */
	{56396, 0x1},
	{107291, 0x2},
	{107310, 0xFFF0},
	{107325, 0xFFF0000},
	/* 3486 */
	{93032, 0x1FF},
	{94734, 0xF000},
	{107340, 0xF0000},
	{93051, 0xF00000},
	{107356, 0xF000000},
	{94652, 0xF0000000},
	/* 3492 */
	{107366, 0xFFFF},
	{107382, 0xFFFF0000},
	/* 3494 */
	{105111, 0xF},
	{105120, 0xFF0},
	{105215, 0x40000000},
	{105229, 0x80000000},
	/* 3498 */
	{50478, 0xF},
	{55687, 0x30},
	{107398, 0xFC0},
	{107408, 0x1000},
	{107418, 0x2000},
	{99977, 0x4000},
	{107429, 0x8000},
	{441, 0xFFFF0000},
	/* 3506 */
	{38, 0x3FFFFF},
	/* 3507 */
	{107439, 0x1F},
	{107446, 0x20},
	{60206, 0x80},
	{107453, 0x3000},
	{60219, 0x4000},
	{60232, 0x8000},
	{107464, 0xFFFF0000},
	{107464, 0xFFFF0000},
	/* 3515 */
	{2132, 0xFFFF},
	{107476, 0xFF0000},
	{60244, 0x1000000},
	/* 3518 */
	{107485, 0xFFFF},
	{107494, 0xFFFF0000},
	/* 3520 */
	{2090, 0x3FFFFFFF},
	{107503, 0xC0000000},
	/* 3522 */
	{60358, 0x7},
	{60373, 0x70000},
	{107515, 0x20000000},
	{56396, 0x40000000},
	{68722, 0x80000000},
	/* 3527 */
	{107523, 0x7},
	{107531, 0x38},
	{107539, 0x1C0},
	{107547, 0xE00},
	{107555, 0x7000},
	{107563, 0x38000},
	{107571, 0x1C0000},
	{982, 0x600000},
	{107579, 0x1800000},
	{107592, 0x2000000},
	{55443, 0x4000000},
	{107605, 0x18000000},
	{107616, 0x20000000},
	{60179, 0x40000000},
	{65130, 0x80000000},
	/* 3542 */
	{107626, 0x80000000},
	/* 3543 */
	{49765, 0x7},
	/* 3544 */
	{107639, 0x3FFF},
	{107649, 0x3FFF0000},
	{107659, 0xC0000000},
	/* 3547 */
	{107672, 0x3FFF},
	{107688, 0x3FF0000},
	{107713, 0x78000000},
	{107738, 0x80000000},
	/* 3551 */
	{69419, 0x1},
	{68991, 0x2},
	{11232, 0x4},
	/* 3554 */
	{107752, 0xFF},
	{107761, 0xFF00},
	{107770, 0xFF0000},
	{107779, 0xFF000000},
	/* 3558 */
	{107788, 0x3F},
	{107796, 0x1F00},
	{107805, 0x1FF0000},
	/* 3561 */
	{107814, 0x3F},
	{107822, 0x1F00},
	{107831, 0x1FF0000},
	/* 3564 */
	{50478, 0xF},
	{55687, 0x30},
	{30503, 0x1C0},
	{55733, 0x1E00},
	/* 3568 */
	{60559, 0x7, 8, 36723},
	{60569, 0x38, 8, 36723},
	{60579, 0x1C0, 8, 36723},
	{60589, 0xE00, 8, 36723},
	{108104, 0x7000, 8, 36731},
	{108496, 0x78000, 16, 36739},
	{108508, 0x180000},
	{64826, 0x600000},
	{64839, 0x800000},
	{84077, 0x1000000},
	{108521, 0x2000000},
	{108533, 0x4000000},
	{84090, 0x38000000},
	{209, 0xC0000000, 4, 36755},
	/* 3582 */
	{60514, 0xFF},
	{65160, 0xFFF00},
	{108496, 0x3F00000, 64, 36759},
	{108104, 0x3C000000, 16, 36823},
	{84090, 0xC0000000},
	/* 3587 */
	{66880, 0x3FFF},
	{66987, 0xFFFC000},
	{67390, 0x70000000},
	{110591, 0x80000000},
	/* 3591 */
	{60559, 0x7, 8, 36723},
	{60569, 0x38, 8, 36723},
	{60579, 0x1C0, 8, 36723},
	{60589, 0xE00, 8, 36723},
	{67209, 0xF000},
	{67220, 0xF0000},
	{110602, 0x1F00000},
	{110615, 0x2000000},
	{84090, 0x4000000},
	{84077, 0x8000000},
	{209, 0xF0000000, 16, 36839},
	/* 3602 */
	{18448, 0x1FFF},
	{21164, 0x7FFE000},
	/* 3604 */
	{67346, 0x1FFF},
	{110926, 0x3FFE000},
	/* 3606 */
	{67377, 0xFFF},
	{67441, 0xFF000},
	{67414, 0x100000},
	{110937, 0xFFE00000},
	/* 3610 */
	{64971, 0x7, 8, 36855},
	{64979, 0x38, 8, 36855},
	{64987, 0x1C0, 8, 36855},
	{64995, 0xE00},
	{65011, 0x7000, 8, 36863},
	{65030, 0x8000},
	{65049, 0x70000},
	{65065, 0x80000},
	{65080, 0x100000},
	{65094, 0x7E00000},
	{65105, 0x8000000},
	{65117, 0x10000000},
	{65135, 0x60000000, 3, 36871},
	/* 3623 */
	{65192, 0x3FFF},
	{65236, 0xFC000},
	{65249, 0x300000, 4, 36874},
	{65263, 0xC00000, 4, 36874},
	{65277, 0x3000000, 3, 36878},
	{65286, 0xC000000, 3, 36881},
	{65297, 0x10000000},
	{111678, 0x20000000},
	{111695, 0x40000000},
	/* 3632 */
	{65201, 0xFFF},
	{111711, 0x20000000},
	{65218, 0xC0000000, 4, 36884},
	/* 3635 */
	{65532, 0x7},
	{65542, 0x70},
	{111853, 0x700},
	{65584, 0x3000},
	{111874, 0x70000},
	{111898, 0x700000},
	{111907, 0x3000000},
	{111927, 0x30000000},
	{111936, 0x40000000},
	/* 3644 */
	{111986, 0x3, 4, 36888},
	{65973, 0x3C, 16, 2765},
	{66401, 0x7C0, 18, 2781},
	{66591, 0x3800, 7, 2800},
	{66750, 0x1C00000, 5, 2807},
	{66770, 0x6000000},
	/* 3650 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{67752, 0x1000000},
	{112013, 0xE000000},
	{112023, 0x10000000},
	/* 3661 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{67815, 0x80},
	{67827, 0xFF00},
	{55379, 0x7F0000, 257, 0},
	/* 3667 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{68272, 0x3000000},
	{68286, 0x4000000},
	{112013, 0x38000000},
	{112023, 0x40000000},
	/* 3679 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{68302, 0x80},
	{68312, 0x100},
	{68324, 0x200},
	{68336, 0x400},
	{68348, 0x800},
	{68360, 0x1000},
	{55379, 0xFE000, 257, 0},
	/* 3689 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{68286, 0x1000000},
	{112013, 0xE000000},
	{112023, 0x10000000},
	/* 3700 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{55379, 0x3F80, 257, 0},
	/* 3704 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{68302, 0x80},
	{55379, 0x7F00, 257, 0},
	{55812, 0x1FF00000},
	/* 3710 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{112013, 0x7000000},
	{112023, 0x8000000},
	/* 3720 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{68302, 0x80},
	{68508, 0x100},
	{55379, 0xFE00, 257, 0},
	/* 3726 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{68272, 0x3000000},
	{112013, 0x1C000000},
	{112023, 0x20000000},
	/* 3737 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{55812, 0xFF80},
	{55379, 0x7F0000, 257, 0},
	/* 3742 */
	{68519, 0x1},
	{68537, 0x2},
	{68551, 0x4},
	{68570, 0x8},
	{68590, 0x10},
	{68610, 0x20},
	{68632, 0x40},
	{112033, 0x380},
	{68643, 0x400},
	{68661, 0x800},
	{99225, 0x1000},
	{68693, 0x4000},
	/* 3754 */
	{50474, 0xFFF},
	/* 3755 */
	{391, 0xFF},
	{99234, 0x100},
	/* 3757 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{68746, 0x1000000},
	{112023, 0x2000000},
	/* 3767 */
	{68809, 0x3F},
	{112053, 0x3F},
	{68822, 0xF000},
	{68832, 0x3F0000},
	{68847, 0x400000},
	{68862, 0x800000},
	{68878, 0x7000000},
	/* 3774 */
	{112071, 0xFFFF},
	{112081, 0xFFFF0000},
	/* 3776 */
	{42978, 0x1},
	{112091, 0x2},
	{112100, 0x4},
	{112109, 0x8},
	{112117, 0x10},
	{112129, 0x20},
	{112141, 0x40},
	{112153, 0x80},
	{112165, 0x100},
	{112176, 0x200},
	{112186, 0x400},
	{112194, 0x800},
	{112220, 0x1000},
	{112233, 0x2000},
	{112244, 0x4000},
	{112254, 0x8000},
	{112268, 0x10000},
	{112284, 0x20000},
	{112300, 0x40000},
	{112316, 0x80000},
	{112327, 0x100000},
	{112344, 0x200000},
	{112360, 0x400000},
	{112379, 0x2000000},
	{112393, 0x4000000},
	{112402, 0x8000000},
	{112416, 0x30000000},
	{112431, 0x40000000},
	{112440, 0x80000000},
	/* 3805 */
	{69199, 0x1},
	{69223, 0x2},
	{69313, 0x70},
	{69325, 0xF00},
	{69338, 0xF000},
	{69351, 0xF0000},
	{69364, 0xF00000},
	{69378, 0xF000000},
	{69396, 0xF0000000},
	/* 3814 */
	{69413, 0x7FF},
	{69440, 0xFFE000},
	{69450, 0x1000000},
	{69462, 0x2000000},
	/* 3818 */
	{112454, 0xF},
	{65973, 0xF0, 16, 2765},
	{66401, 0x1F00, 18, 2781},
	{66875, 0x6000, 4, 2812},
	{66982, 0x18000, 4, 2816},
	{67094, 0x60000, 4, 2820},
	{67181, 0x180000, 4, 2824},
	/* 3825 */
	{17302, 0x3, 4, 3099},
	{70745, 0xC},
	{66591, 0xE000, 7, 2800},
	{90467, 0x700000},
	{70896, 0x8000000},
	{70911, 0x10000000},
	{70921, 0x20000000},
	{70941, 0x80000000},
	/* 3833 */
	{17302, 0x1, 2, 3107},
	{66591, 0xE000, 7, 2800},
	{90467, 0x700000},
	{70896, 0x8000000},
	{70984, 0x20000000},
	/* 3838 */
	{112473, 0x7FF},
	{112488, 0x3FF800},
	/* 3840 */
	{112504, 0x3FFFFF},
	/* 3841 */
	{50688, 0x3},
	/* 3842 */
	{75525, 0x3F},
	{75536, 0x40},
	{75579, 0x4000},
	/* 3845 */
	{11609, 0xFF},
	/* 3846 */
	{78990, 0x8},
	{982, 0x70, 6, 36061},
	{78263, 0xFF0000, 256, 36069},
	/* 3849 */
	{18464, 0x1F, 29, 36694},
	{82589, 0x4000},
	{82602, 0x8000},
	{82615, 0x70000},
	/* 3853 */
	{83729, 0x3F, 3, 36370},
	{83742, 0x3F00, 3, 36370},
	{83757, 0x3F0000, 3, 36370},
	{83772, 0xFC00000, 3, 36370},
	{83787, 0x80000000},
	/* 3858 */
	{203, 0x3, 2, 36374},
	{83924, 0xC, 4, 36377},
	{84004, 0x30, 3, 36381},
	{84064, 0xC0, 4, 36892},
	{84077, 0x100},
	{78431, 0x200},
	{84081, 0x400},
	/* 3865 */
	{85300, 0x3F, 60, 36896},
	{60519, 0x7FC0000},
	{85311, 0x8000000},
	/* 3868 */
	{90053, 0x1},
	{85514, 0x2},
	{112646, 0x4},
	{112669, 0x8},
	{112677, 0x3F0},
	{112692, 0xFC00},
	{85593, 0x10000},
	/* 3875 */
	{209, 0x3, 3, 36468},
	{86375, 0x1C, 4, 36471},
	{86452, 0xE0, 4, 36475},
	{86461, 0x100},
	{86481, 0x200},
	{86492, 0x3C00},
	{86514, 0x4000},
	{84064, 0x18000, 4, 36892},
	/* 3883 */
	{86881, 0x1},
	{86896, 0x2},
	{86911, 0x4},
	{86926, 0x8},
	{86941, 0x70},
	{86973, 0xF00},
	{86990, 0x80000000},
	/* 3890 */
	{89342, 0x3, 4, 36520},
	{17302, 0x7C, 24, 36524},
	{65623, 0x80},
	{89940, 0x700, 8, 36556},
	{89996, 0x1800, 4, 36564},
	{79039, 0x2000},
	{70033, 0x4000},
	{90006, 0x8000},
	{90018, 0x10000},
	{90031, 0x20000},
	{87610, 0x40000},
	{90044, 0x80000},
	{90271, 0x700000, 8, 36568},
	{90293, 0x3800000, 8, 36568},
	{90317, 0x4000000},
	/* 3905 */
	{91907, 0xF00, 5, 36612},
	{96551, 0x10000},
	{96563, 0x100000},
	{96578, 0xC0000000, 4, 36618},
	/* 3909 */
	{26590, 0xFFFF},
	{91907, 0x300000, 2, 36622},
	{96618, 0x8000000, 2, 36618},
	{96640, 0x60000000, 3, 36626},
	{96648, 0x80000000},
	/* 3914 */
	{91572, 0x1FFFFF},
	{96686, 0x200000},
	{101191, 0xC00000, 4, 36956},
	{101200, 0x3000000, 4, 36956},
	{91583, 0x4000000, 2, 36630},
	{91587, 0x8000000, 2, 36630},
	{91591, 0x10000000, 2, 36632},
	{91596, 0x20000000, 2, 36632},
	{91601, 0x40000000},
	/* 3923 */
	{96618, 0x1, 2, 36618},
	{91907, 0x300000, 2, 36622},
	{96640, 0x60000000, 3, 36626},
	{96648, 0x80000000},
	/* 3927 */
	{55217, 0xF},
	{55226, 0xF0},
	{55236, 0x100},
	{55247, 0x200},
	{55252, 0x400},
	{99166, 0x800},
	{55379, 0x1FF000, 257, 0},
	{55410, 0x10000000},
	{55416, 0xE0000000},
	/* 3936 */
	{55581, 0x1FF, 257, 0},
	{55626, 0x3F0000},
	{55679, 0xE0000000},
	/* 3939 */
	{50478, 0xF},
	{55687, 0x30},
	{55695, 0xC0},
	{55703, 0xF00},
	{55709, 0x1000},
	{28888, 0x6000},
	{55727, 0xF0000},
	{55733, 0xF00000},
	{55739, 0x7000000},
	{55748, 0x38000000},
	{55757, 0xC0000000},
	/* 3950 */
	{55838, 0xF},
	{55845, 0x70},
	{55867, 0xF00},
	{55876, 0x7000},
	/* 3954 */
	{56146, 0xF},
	{56169, 0x10},
	{56192, 0x20},
	{56215, 0x40},
	{56235, 0x80},
	{56255, 0x100},
	{56275, 0x200},
	{56295, 0x400},
	{56315, 0x800},
	{56335, 0x1000},
	{56355, 0x2000},
	{56375, 0x4000},
	{56507, 0x1000000},
	{57445, 0x2000000},
	{56525, 0x10000000},
	{56534, 0x20000000},
	{56543, 0x40000000},
	/* 3971 */
	{57062, 0x1},
	{57072, 0x2},
	{57082, 0x4},
	{57091, 0x8},
	{57100, 0x10},
	{57111, 0x20},
	{57122, 0x40},
	{57132, 0x80},
	{103152, 0x100},
	{103167, 0x200},
	{57142, 0x400},
	{57152, 0x800},
	{57169, 0x1000},
	{57287, 0x20000000},
	{57300, 0x40000000},
	{56534, 0x80000000},
	/* 3987 */
	{112732, 0x1},
	{112753, 0x2},
	{57797, 0x8},
	{57816, 0x10},
	{57836, 0x40},
	{57855, 0x100},
	{57876, 0x200},
	{57894, 0x400},
	{112774, 0x800},
	{112795, 0x1000},
	{57917, 0x2000},
	{57939, 0x10000},
	{57960, 0x20000},
	{57978, 0x40000},
	{112818, 0x80000},
	{112839, 0x100000},
	{58001, 0x200000},
	/* 4004 */
	{58116, 0x1},
	{58135, 0x2},
	{103152, 0x4},
	{103167, 0x8},
	{58144, 0x10},
	{58159, 0x20},
	{58173, 0x40},
	{58192, 0x80},
	{58211, 0x100},
	{58226, 0x200},
	{58243, 0x400},
	{58265, 0x800},
	{58287, 0x1000},
	{58302, 0x2000},
	{57142, 0x4000},
	{58317, 0x8000},
	{58462, 0x40000000},
	{56525, 0x80000000},
	/* 4022 */
	{58475, 0x1},
	{58493, 0x2},
	{58507, 0x4},
	{58526, 0x8},
	{58545, 0x10},
	{58560, 0x20},
	{58578, 0x40},
	{58596, 0x80},
	{58613, 0x100},
	{112862, 0x200},
	{58659, 0x800},
	{58683, 0x1000},
	{58701, 0x2000},
	{58719, 0x4000},
	{58740, 0x8000},
	{58764, 0x10000},
	{58790, 0x20000},
	{58807, 0x40000},
	{58827, 0x80000},
	{58847, 0x100000},
	{58867, 0x200000},
	{58888, 0x400000},
	{58911, 0x800000},
	{58932, 0x1000000},
	{58951, 0x2000000},
	{58968, 0x4000000},
	{58984, 0x8000000},
	{59000, 0x10000000},
	{59016, 0x20000000},
	{59035, 0x40000000},
	{59047, 0x80000000},
	/* 4053 */
	{59059, 0x1},
	{59078, 0x2},
	{59098, 0x4},
	{59118, 0x8},
	{101842, 0x10},
	{59138, 0x20},
	{59159, 0x40},
	/* 4060 */
	{107439, 0x1F},
	{107446, 0x20},
	{60206, 0x80},
	{55522, 0xF00},
	{107453, 0x3000},
	{60219, 0x4000},
	{60232, 0x8000},
	{107464, 0xFFFF0000},
	{107464, 0xFFFF0000},
	/* 4069 */
	{9994, 0xF},
	{84077, 0x10},
	/* 4071 */
	{112884, 0xFFFF},
	/* 4072 */
	{60358, 0x3FF},
	{60373, 0x3FF0000},
	{107515, 0x20000000},
	{56396, 0x40000000},
	{68722, 0x80000000},
	/* 4077 */
	{91095, 0xFFFF},
	{91107, 0x10000},
	{26653, 0xE0000000},
	/* 4080 */
	{112894, 0x1000},
	{91203, 0x6000},
	{112902, 0x8000},
	{91232, 0x300000},
	{112915, 0x1000000},
	{91243, 0x6000000},
	{112923, 0x8000000},
	{91272, 0x60000000},
	/* 4088 */
	{112936, 0x7F},
	{112948, 0x3F000},
	{11589, 0x6000000},
	{91886, 0x8000000},
	/* 4092 */
	{27643, 0xFFFF},
	{91907, 0x30000},
	{91915, 0x7000000},
	{91923, 0xE0000000},
	/* 4096 */
	{92899, 0x3F},
	{92904, 0xC0},
	{92912, 0x100},
	{92918, 0xFFFFFE00},
	/* 4100 */
	{81023, 0x1},
	{858, 0x1FFE},
	{209, 0x2000},
	{88904, 0x4000},
	{92926, 0x8000},
	{92938, 0x7FF0000},
	{92949, 0x8000000},
	{92960, 0x10000000},
	{92904, 0xE0000000},
	/* 4109 */
	{93082, 0x3F},
	{93092, 0xFC00},
	/* 4111 */
	{93032, 0x3F},
	{93041, 0xFC00},
	{94598, 0xF00000},
	/* 4114 */
	{93032, 0xFF},
	{94734, 0xF000},
	{107340, 0xF0000},
	{93051, 0xF00000},
	{107356, 0xF000000},
	{94652, 0xF0000000},
	/* 4120 */
	{52065, 0xFF},
	{10365, 0xFFFFFF00},
	/* 4122 */
	{26590, 0xFFFF},
	{91907, 0x300000, 4, 36960},
	{96618, 0x8000000, 2, 36618},
	{96640, 0x60000000, 4, 36626},
	{96648, 0x80000000},
	/* 4127 */
	{96618, 0x1, 2, 36618},
	{91203, 0x6000},
	{91907, 0x300000, 4, 36960},
	{91243, 0x6000000},
	{96640, 0x60000000, 4, 36626},
	{96648, 0x80000000},
	/* 4133 */
	{55217, 0xF},
	{55226, 0xF0},
	{55236, 0x100},
	{55247, 0x200},
	{55252, 0x400},
	{99166, 0x800},
	{55379, 0x1FF000, 257, 0},
	{112965, 0x8000000},
	{55410, 0x10000000},
	{55416, 0xE0000000},
	/* 4143 */
	{55420, 0x1},
	{55424, 0x6},
	{55433, 0x18},
	{55443, 0x20},
	{55448, 0x40},
	{55456, 0x80},
	{55466, 0x100},
	{55477, 0x200},
	{55483, 0x400},
	{55488, 0x800},
	{55494, 0x1000},
	{55505, 0x2000},
	{55510, 0x4000},
	{99185, 0x8000},
	{55266, 0x10000},
	{55530, 0x20000},
	{55538, 0x40000},
	{55550, 0x80000},
	{99198, 0x100000},
	{99212, 0x200000},
	{112976, 0x400000},
	{99234, 0x800000},
	{55569, 0x8000000},
	/* 4166 */
	{55581, 0x1FF, 257, 0},
	{55586, 0x400},
	{55626, 0x3F0000},
	{55679, 0xE0000000},
	/* 4170 */
	{55838, 0xF},
	{55845, 0x70},
	{55867, 0xF00},
	{55876, 0x7000},
	{55885, 0x8000},
	{55898, 0xF0000},
	/* 4176 */
	{99263, 0x7},
	{99271, 0x8},
	{99282, 0x10},
	{99295, 0xE0},
	{99311, 0x300},
	{99321, 0xC00},
	{99331, 0xF0000},
	{56001, 0xF00000},
	{99343, 0x3000000},
	{99350, 0x4000000},
	{99357, 0x18000000},
	{69691, 0x20000000},
	{99365, 0x40000000},
	/* 4189 */
	{112989, 0x1},
	{55946, 0x2},
	{55952, 0x4},
	{55981, 0xF0},
	{55986, 0xF00},
	/* 4194 */
	{56146, 0xF},
	{56169, 0x10},
	{56192, 0x20},
	{56215, 0x40},
	{56235, 0x80},
	{56255, 0x100},
	{56275, 0x200},
	{56295, 0x400},
	{56315, 0x800},
	{56335, 0x1000},
	{56355, 0x2000},
	{56375, 0x4000},
	{56507, 0x1000000},
	{57445, 0x2000000},
	{112996, 0x4000000},
	{56525, 0x10000000},
	{56534, 0x20000000},
	{56543, 0x40000000},
	/* 4212 */
	{57062, 0x1},
	{57072, 0x2},
	{57082, 0x4},
	{57091, 0x8},
	{57100, 0x10},
	{57111, 0x20},
	{57122, 0x40},
	{57132, 0x80},
	{57142, 0x400},
	{57152, 0x800},
	{57169, 0x1000},
	{113012, 0x2000},
	{57287, 0x20000000},
	{57300, 0x40000000},
	{56534, 0x80000000},
	/* 4227 */
	{57797, 0x8},
	{57816, 0x10},
	{57836, 0x40},
	{57855, 0x100},
	{57876, 0x200},
	{57894, 0x400},
	{57917, 0x2000},
	{57939, 0x10000},
	{57960, 0x20000},
	{57978, 0x40000},
	{58001, 0x200000},
	{113025, 0x400000},
	{113049, 0x800000},
	{113073, 0x1000000},
	/* 4241 */
	{58116, 0x1},
	{58135, 0x2},
	{58144, 0x10},
	{58159, 0x20},
	{58173, 0x40},
	{58192, 0x80},
	{58211, 0x100},
	{58226, 0x200},
	{58243, 0x400},
	{58265, 0x800},
	{58287, 0x1000},
	{58302, 0x2000},
	{57142, 0x4000},
	{58317, 0x8000},
	{58326, 0x10000},
	{113012, 0x20000},
	{58417, 0x4000000},
	{58430, 0x8000000},
	{58443, 0x30000000},
	{58462, 0x40000000},
	{56525, 0x80000000},
	/* 4262 */
	{59059, 0x1},
	{59078, 0x2},
	{59098, 0x4},
	{59118, 0x8},
	{59138, 0x20},
	{59159, 0x40},
	{113025, 0x80},
	{113049, 0x100},
	{113073, 0x200},
	/* 4271 */
	{60559, 0x7, 8, 36723},
	{60569, 0x38, 8, 36723},
	{60579, 0x1C0, 8, 36723},
	{60589, 0xE00, 8, 36723},
	{108104, 0x7000, 8, 36964},
	{108496, 0x78000, 16, 36739},
	{108508, 0x180000},
	{64826, 0x600000},
	{64839, 0x800000},
	{84077, 0x1000000},
	{108521, 0x2000000},
	{108533, 0x4000000},
	{84090, 0x38000000},
	{209, 0xC0000000, 4, 36755},
	/* 4285 */
	{60514, 0xFF},
	{65160, 0xFFF00},
	{108496, 0x3F00000, 64, 36759},
	{108104, 0x3C000000, 16, 36972},
	{84090, 0xC0000000},
	/* 4290 */
	{67377, 0xFFF},
	{67441, 0xFF000},
	{67414, 0x100000},
	{67563, 0x200000},
	{67578, 0x400000},
	{67594, 0x800000},
	{113256, 0xF000000},
	{113272, 0xF0000000},
	/* 4298 */
	{64971, 0x7, 8, 36855},
	{64979, 0x38, 8, 36855},
	{64987, 0x1C0, 8, 36855},
	{64995, 0xE00},
	{65011, 0x7000, 8, 36863},
	{65030, 0x8000},
	{65049, 0x70000},
	{65065, 0x80000},
	{65080, 0x100000},
	{65094, 0x7E00000},
	{65105, 0x8000000},
	{65117, 0x10000000},
	{65135, 0x60000000, 3, 36871},
	{113288, 0x80000000},
	/* 4312 */
	{65192, 0x3FFF},
	{65236, 0xFC000},
	{65249, 0x300000, 4, 36874},
	{65263, 0xC00000, 4, 36874},
	{65277, 0x3000000, 3, 36878},
	{65286, 0xC000000, 4, 36988},
	{65297, 0x10000000},
	{111678, 0x20000000},
	{111695, 0x40000000},
	{65316, 0x80000000},
	/* 4322 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{68302, 0x80},
	{68312, 0x100},
	{68324, 0x200},
	{68336, 0x400},
	{68348, 0x800},
	{68360, 0x1000},
	{55379, 0x3FE000, 257, 0},
	{68377, 0x1000000},
	/* 4333 */
	{84077, 0x1},
	{84090, 0x6},
	/* 4335 */
	{17302, 0x3, 4, 3099},
	{70745, 0xC},
	{66591, 0xE000, 7, 2800},
	{90467, 0x700000},
	{70872, 0x7800000},
	{70896, 0x8000000},
	{70911, 0x10000000},
	{70921, 0x20000000},
	{113334, 0x40000000},
	{70941, 0x80000000},
	/* 4345 */
	{17302, 0x1, 2, 3107},
	{66591, 0xE000, 7, 2800},
	{90467, 0x700000},
	{70896, 0x8000000},
	{70984, 0x20000000},
	{113334, 0x40000000},
	/* 4351 */
	{74073, 0x1},
	{113351, 0x2},
	{74100, 0x7C},
	/* 4354 */
	{78990, 0x8},
	{982, 0x70, 7, 36061},
	{78263, 0xFF0000, 256, 36069},
	/* 4357 */
	{80735, 0x1},
	{80751, 0x2},
	{80767, 0x4},
	{80783, 0x8},
	{80799, 0x10},
	{80815, 0x20},
	{80831, 0x40},
	{80847, 0x80},
	{80863, 0x100},
	{80879, 0x200},
	{80895, 0x400},
	{80911, 0x800},
	{80927, 0x1000},
	{80943, 0x2000},
	{80959, 0x4000},
	{80975, 0x8000},
	{80991, 0x10000},
	{81010, 0x20000},
	{81028, 0x40000},
	{81055, 0x80000},
	{81077, 0x100000},
	{81095, 0x200000},
	{81115, 0x400000},
	{81138, 0x800000},
	{81161, 0x1000000},
	{81186, 0x2000000},
	{81229, 0x4000000},
	/* 4384 */
	{982, 0x7, 6, 36360},
	{82782, 0x8},
	{82838, 0x30, 4, 36366},
	{82847, 0x7C0},
	{82858, 0x800},
	{82871, 0x1000},
	{82882, 0x2000},
	{93239, 0x4000},
	{113390, 0x8000},
	{113401, 0x10000},
	{82941, 0x20000},
	{82960, 0x40000},
	{82974, 0x80000},
	{82992, 0x100000},
	{83010, 0x600000},
	/* 4399 */
	{203, 0x3, 3, 36374},
	{83924, 0xC, 4, 36377},
	{84004, 0x30, 4, 36381},
	{84064, 0x40, 2, 36385},
	{78431, 0x200},
	{84081, 0x400},
	{84090, 0x1800},
	/* 4406 */
	{85300, 0x3F, 61, 36992},
	{60519, 0x7FC0000},
	{85311, 0x8000000},
	/* 4409 */
	{85416, 0xFFFF},
	{85431, 0x10000},
	{85450, 0x20000},
	{85464, 0x40000},
	{85483, 0x80000},
	{85497, 0x100000},
	{86141, 0xF0000000},
	/* 4416 */
	{90053, 0x1},
	{85514, 0x2},
	{112646, 0x4},
	{112669, 0x8},
	{112677, 0x3F0},
	{112692, 0xFC00},
	{85593, 0x10000},
	{113412, 0x20000},
	/* 4424 */
	{209, 0x3, 3, 36468},
	{86375, 0x1C, 4, 36471},
	{86452, 0xE0, 4, 36475},
	{86461, 0x100},
	{86481, 0x200},
	{86492, 0x3C00},
	{86514, 0x4000},
	{84064, 0x8000, 2, 36385},
	{86548, 0x60000, 3, 36479},
	{84090, 0x180000},
	/* 4434 */
	{89342, 0x3, 4, 36520},
	{17302, 0x7C, 24, 36524},
	{65623, 0x80},
	{89940, 0x700, 8, 36556},
	{89996, 0x1800, 4, 36564},
	{79039, 0x2000},
	{70033, 0x4000},
	{90006, 0x8000},
	{90018, 0x10000},
	{90031, 0x20000},
	{87610, 0x40000},
	{90044, 0x80000},
	{90271, 0x700000, 8, 36568},
	{90293, 0x3800000, 8, 36568},
	{90317, 0x4000000},
	{90343, 0x8000000},
	{90369, 0x10000000},
	{90437, 0x60000000, 3, 36576},
	/* 4452 */
	{11589, 0x2000000},
	{84090, 0x18000000},
	/* 4454 */
	{91095, 0xFFFF},
	{91107, 0x10000},
	{91023, 0x2000000},
	{84090, 0x18000000},
	{26653, 0xE0000000},
	/* 4459 */
	{26221, 0xFFFF},
	{84090, 0x300000},
	{91023, 0x400000},
	/* 4462 */
	{26293, 0xFFFF},
	{84090, 0x300000},
	{91023, 0x400000},
	/* 4465 */
	{113426, 0xC00},
	{112894, 0x1000},
	{91203, 0x2000},
	{91232, 0x300000},
	{113436, 0xC00000},
	{112915, 0x1000000},
	{91243, 0x2000000},
	{91272, 0x60000000},
	/* 4473 */
	{92086, 0x1},
	{92102, 0x2},
	{113446, 0x4},
	{91320, 0x8},
	{92118, 0x40},
	{92136, 0x80},
	{92154, 0x100},
	{92172, 0x200},
	{92190, 0x400},
	{92208, 0x800},
	{92226, 0x1000},
	{92244, 0x2000},
	{92262, 0x4000},
	{91381, 0x8000},
	{91401, 0x40000},
	{92279, 0x80000},
	{92295, 0x200000},
	{91418, 0x400000},
	{91434, 0x800000},
	{91448, 0x2000000},
	{91462, 0x4000000},
	{91476, 0x8000000},
	{91497, 0x10000000},
	{91522, 0x20000000},
	{91543, 0x40000000},
	{113463, 0x80000000},
	/* 4499 */
	{112936, 0x7F},
	{112948, 0x3F000},
	{11589, 0x2000000},
	{84090, 0x18000000},
	/* 4503 */
	{92977, 0xFFFF},
	{93001, 0xF0000},
	{92988, 0x300000},
	{92379, 0x3FC00000},
	{93009, 0x40000000},
	{9882, 0x80000000},
	/* 4509 */
	{60514, 0xFF},
	{65160, 0xFFF00},
	{108496, 0x3F00000, 64, 37053},
	{108104, 0x3C000000, 16, 36972},
	{84090, 0xC0000000},
	/* 4514 */
	{78972, 0x1},
	{78990, 0x8},
	{982, 0x70, 7, 36061},
	{78263, 0xFF0000, 256, 36069},
	/* 4518 */
	{85758, 0xFF},
	{85772, 0xFF00},
	{85782, 0xFF0000},
	{85793, 0xFF000000},
	/* 4522 */
	{89342, 0x3, 4, 36520},
	{17302, 0x7C, 31, 36524},
	{65623, 0x80},
	{89940, 0x700, 8, 36556},
	{89996, 0x1800, 4, 36564},
	{79039, 0x2000},
	{70033, 0x4000},
	{90006, 0x8000},
	{90018, 0x10000},
	{90031, 0x20000},
	{87610, 0x40000},
	{90044, 0x80000},
	{90271, 0x700000, 8, 36568},
	{90293, 0x3800000, 8, 36568},
	{90317, 0x4000000},
	{90343, 0x8000000},
	{90369, 0x10000000},
	{90437, 0x60000000, 3, 36576},
	/* 4540 */
	{81023, 0x1},
	{858, 0x1FFE},
	{209, 0x2000},
	{88904, 0x4000},
	{92926, 0x8000},
	{92938, 0xFFF0000},
	{92949, 0x10000000},
	{92960, 0x20000000},
	{92904, 0xC0000000},
	/* 4549 */
	{55217, 0xF},
	{55226, 0xF0},
	{55236, 0x100},
	{55247, 0x200},
	{55252, 0x400},
	{99166, 0x800},
	{55379, 0x1FF000, 257, 0},
	{55387, 0x800000},
	{113781, 0x1000000},
	{113794, 0x2000000},
	{55397, 0x4000000},
	{112965, 0x8000000},
	{55410, 0x10000000},
	{55416, 0xE0000000},
	/* 4563 */
	{55420, 0x1},
	{55424, 0x6},
	{55433, 0x18},
	{55443, 0x20},
	{55448, 0x40},
	{55456, 0x80},
	{55466, 0x100},
	{55477, 0x200},
	{55483, 0x400},
	{55488, 0x800},
	{55494, 0x1000},
	{55505, 0x2000},
	{55510, 0x4000},
	{99185, 0x8000},
	{55266, 0x10000},
	{55530, 0x20000},
	{55538, 0x40000},
	{55550, 0x80000},
	{99198, 0x100000},
	{99212, 0x200000},
	{112976, 0x400000},
	{55558, 0x800000},
	{55569, 0x8000000},
	/* 4586 */
	{55581, 0x1FF, 257, 0},
	{55586, 0x400},
	{55594, 0x800},
	{55607, 0x7000},
	{55626, 0x3F0000},
	{55667, 0x10000000},
	{55679, 0xE0000000},
	/* 4593 */
	{55838, 0xF},
	{55845, 0x70},
	{55867, 0xF00},
	{55876, 0x7000},
	{55885, 0x8000},
	{55898, 0x1F0000},
	{55903, 0xC00000},
	/* 4600 */
	{99263, 0x7},
	{99271, 0x8},
	{99282, 0x10},
	{99295, 0xE0},
	{99311, 0x300},
	{99321, 0xC00},
	{99331, 0xF0000},
	{99343, 0x3000000},
	{99350, 0x4000000},
	{99357, 0x18000000},
	{69691, 0x20000000},
	{99365, 0x40000000},
	{113807, 0x80000000},
	/* 4613 */
	{112989, 0x1},
	{55946, 0x2},
	{55952, 0x4},
	{55981, 0x1F0},
	{55986, 0xF800},
	{55898, 0x7C0000},
	{56001, 0xFE000000},
	/* 4620 */
	{56146, 0xF},
	{56169, 0x10},
	{56192, 0x20},
	{56215, 0x40},
	{56235, 0x80},
	{56255, 0x100},
	{56275, 0x200},
	{56295, 0x400},
	{56315, 0x800},
	{56335, 0x1000},
	{56355, 0x2000},
	{56375, 0x4000},
	{56390, 0x8000},
	{56401, 0x10000},
	{56409, 0x20000},
	{56418, 0x40000},
	{56435, 0x80000},
	{56450, 0x100000},
	{56507, 0x1000000},
	{57445, 0x2000000},
	{112996, 0x4000000},
	{56525, 0x10000000},
	{56534, 0x20000000},
	{56543, 0x40000000},
	{56552, 0x80000000},
	/* 4645 */
	{56563, 0xF},
	{56586, 0x20},
	{56602, 0x80},
	{56625, 0x100},
	{56648, 0x200},
	{56667, 0x1000},
	{56676, 0x2000},
	{56685, 0x4000},
	{56693, 0x8000},
	{100054, 0x10000},
	{100069, 0x20000},
	{100078, 0x40000},
	{100093, 0x80000},
	{56717, 0x100000},
	{100101, 0x200000},
	{56733, 0x400000},
	{56742, 0x800000},
	{56751, 0x1000000},
	{56759, 0x2000000},
	{56767, 0x4000000},
	{56775, 0x10000000},
	{56517, 0x20000000},
	{56793, 0x40000000},
	{56801, 0x80000000},
	/* 4669 */
	{56667, 0x2},
	{56676, 0x4},
	{56409, 0x200000},
	{56742, 0x400000},
	{100069, 0x800000},
	{56759, 0x1000000},
	{56685, 0x2000000},
	{56717, 0x4000000},
	{56733, 0x8000000},
	{56751, 0x20000000},
	{56767, 0x40000000},
	{56793, 0x80000000},
	/* 4681 */
	{57062, 0x1},
	{57072, 0x2},
	{57082, 0x4},
	{57091, 0x8},
	{57100, 0x10},
	{57111, 0x20},
	{57122, 0x40},
	{57132, 0x80},
	{57142, 0x400},
	{57152, 0x800},
	{57169, 0x1000},
	{57177, 0x2000},
	{57190, 0x4000},
	{57287, 0x20000000},
	{57300, 0x40000000},
	{56534, 0x80000000},
	/* 4697 */
	{58116, 0x1},
	{58135, 0x2},
	{58144, 0x10},
	{58159, 0x20},
	{58173, 0x40},
	{58192, 0x80},
	{58211, 0x100},
	{58226, 0x200},
	{58243, 0x400},
	{58265, 0x800},
	{58287, 0x1000},
	{58302, 0x2000},
	{57142, 0x4000},
	{58317, 0x8000},
	{58326, 0x10000},
	{57177, 0x20000},
	{58417, 0x4000000},
	{58430, 0x8000000},
	{58443, 0x30000000},
	{58462, 0x40000000},
	{56525, 0x80000000},
	/* 4718 */
	{60559, 0x7, 8, 36723},
	{60569, 0x38, 8, 36723},
	{60579, 0x1C0, 8, 36723},
	{60589, 0xE00, 8, 36723},
	{108104, 0x7000, 8, 37117},
	{108496, 0x78000, 16, 36739},
	{113852, 0x80000},
	{113867, 0x100000},
	{64826, 0x600000},
	{64839, 0x800000},
	{82676, 0x8000000},
	{209, 0xC0000000, 4, 36755},
	/* 4730 */
	{60514, 0xFF},
	{65160, 0xFFF00},
	{108496, 0x3F00000, 64, 37125},
	{114351, 0x3F00000, 61, 37189},
	{108104, 0x3C000000, 16, 37250},
	{114858, 0x3C000000, 16, 37266},
	{82676, 0x40000000},
	{114875, 0x80000000},
	/* 4738 */
	{60559, 0x7, 8, 36723},
	{60569, 0x38, 8, 36723},
	{60579, 0x1C0, 8, 36723},
	{60589, 0xE00, 8, 36723},
	{67209, 0xF000},
	{67220, 0xF0000},
	{67231, 0x1F00000},
	{209, 0xF0000000, 16, 36839},
	/* 4746 */
	{18448, 0x1FFF},
	{21164, 0x1FFFE000},
	{67335, 0xE0000000, 6, 2828},
	/* 4749 */
	{67346, 0x1FFF},
	{67357, 0x1E000},
	{114887, 0x1FE0000},
	{90917, 0x2000000},
	{67523, 0x4000000},
	{114905, 0x8000000},
	{67369, 0xF0000000},
	/* 4756 */
	{65192, 0x3FFF},
	{65236, 0xFC000},
	{65249, 0x300000, 4, 36874},
	{65263, 0xC00000, 4, 36874},
	{65277, 0x3000000, 3, 36878},
	{65286, 0xC000000, 4, 36988},
	{65297, 0x10000000},
	{65331, 0x20000000},
	{111695, 0x40000000},
	{65316, 0x80000000},
	/* 4766 */
	{65201, 0xFFF},
	{65147, 0x1000},
	{65218, 0xC0000000, 4, 36884},
	/* 4769 */
	{65532, 0x7},
	{65542, 0x38},
	{65563, 0xC0},
	{111853, 0x700},
	{67181, 0x7000, 4, 2824},
	{111874, 0x70000},
	{65584, 0x180000},
	{111898, 0xE00000},
	{111907, 0x3000000},
	{65603, 0xC000000},
	{111927, 0x30000000},
	{111936, 0x40000000},
	{114921, 0x80000000},
	/* 4782 */
	{67631, 0xFFFF},
	{67637, 0x3F0000},
	{67648, 0x3C00000},
	{114931, 0x3C000000},
	/* 4786 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{67752, 0x1000000},
	{112023, 0x10000000},
	{55387, 0x20000000},
	/* 4797 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{67815, 0x80},
	{67827, 0xFF00},
	{55379, 0x1FF0000, 257, 0},
	{67842, 0x2000000},
	{67864, 0x4000000},
	{68394, 0x8000000},
	{67889, 0x10000000},
	/* 4807 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{68272, 0x3000000},
	{68286, 0x4000000},
	{112023, 0x40000000},
	{55387, 0x80000000},
	/* 4819 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{68302, 0x80},
	{68312, 0x100},
	{68324, 0x200},
	{68336, 0x400},
	{68348, 0x800},
	{68360, 0x1000},
	{55379, 0x3FE000, 257, 0},
	{68366, 0x400000},
	{68377, 0x1000000},
	{68394, 0x8000000},
	{67889, 0x10000000},
	/* 4833 */
	{68431, 0x7F},
	{68406, 0x3F80},
	/* 4835 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{68286, 0x1000000},
	{112023, 0x10000000},
	{68457, 0x60000000},
	{55387, 0x80000000},
	/* 4847 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{55379, 0xFF80, 257, 0},
	{68474, 0x30000},
	{68302, 0x40000},
	{55812, 0x7F80000},
	{68394, 0x8000000},
	{67889, 0x10000000},
	/* 4856 */
	{67637, 0x3F},
	{67648, 0x3C0},
	{114931, 0x3C00},
	{67631, 0xFFFF0000},
	/* 4860 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{112023, 0x8000000},
	{68491, 0x30000000},
	{55387, 0x40000000},
	/* 4871 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{55379, 0xFF80, 257, 0},
	{55812, 0x1FF0000},
	{68394, 0x8000000},
	{67889, 0x10000000},
	/* 4878 */
	{68519, 0x1},
	{68537, 0x2},
	{68551, 0x4},
	{68570, 0x8},
	{68590, 0x10},
	{68610, 0x20},
	{68632, 0x40},
	{68643, 0x400},
	{68661, 0x800},
	{10365, 0x1000},
	{68693, 0x4000},
	/* 4889 */
	{67676, 0x3F},
	{67682, 0x3C0},
	{65372, 0xC00},
	{67731, 0xFF000, 241, 2834},
	{55443, 0x100000},
	{55236, 0x200000},
	{112002, 0x400000},
	{67742, 0x800000},
	{68746, 0x1000000},
	{112023, 0x2000000},
	{55387, 0x4000000},
	/* 4900 */
	{67781, 0x1},
	{67792, 0x3E},
	{67802, 0x40},
	{68752, 0x80},
	{68762, 0x100},
	{68772, 0x200},
	{68508, 0x400},
	{68782, 0x1800},
	{68797, 0x6000},
	{55812, 0xFF8000},
	{55379, 0x7F000000, 257, 0},
	{68394, 0x80000000},
	/* 4912 */
	{68809, 0x3FF},
	{68822, 0xF000},
	{68832, 0x3F0000},
	{68847, 0x400000},
	{68862, 0x800000},
	{68878, 0x7000000},
	{114931, 0x78000000},
	/* 4919 */
	{69413, 0x7FF},
	{69440, 0xFFE000},
	{69450, 0x1000000},
	{69462, 0x2000000},
	{69480, 0x3C000000},
	/* 4924 */
	{17302, 0x3, 4, 3099},
	{70745, 0xC},
	{67231, 0x1F0},
	{70829, 0x1000},
	{70800, 0x6000, 4, 3103},
	{70815, 0x8000},
	{70865, 0xF0000},
	{70872, 0x7800000},
	{70896, 0x8000000},
	{70911, 0x10000000},
	{70921, 0x20000000},
	{113334, 0x40000000},
	{70941, 0x80000000},
	/* 4937 */
	{17302, 0x1, 2, 3107},
	{67231, 0x1F0},
	{70829, 0x1000},
	{70800, 0x6000, 4, 3103},
	{70815, 0x8000},
	{70896, 0x8000000},
	{70984, 0x20000000},
	{113334, 0x40000000},
	/* 4945 */
	{54859, 0xFFFF},
	/* 4946 */
	{71814, 0x3, 4, 35886},
	{71826, 0xC, 4, 35886},
	{71938, 0x30, 4, 35890},
	{71995, 0x40, 2, 35894},
	{72051, 0x80, 2, 35896},
	{72155, 0x300, 4, 35898},
	{72263, 0xC00, 4, 35902},
	{72372, 0x3000, 4, 35906},
	{72485, 0xC000, 4, 35910},
	{72587, 0x30000, 4, 35914},
	{72733, 0xC0000, 4, 35918},
	{72880, 0x300000, 4, 35922},
	{72980, 0x3000000, 4, 35926},
	{73126, 0x1C000000, 5, 37282},
	{73273, 0xE0000000, 5, 37287},
	/* 4961 */
	{73393, 0x3, 4, 35938},
	{73564, 0x1C, 5, 37292},
	{73736, 0xE0, 5, 37297},
	/* 4964 */
	{74073, 0x1},
	{113351, 0x2},
	{74100, 0x7C},
	{74129, 0x100},
	{74158, 0x200},
	{74189, 0x400},
	{74217, 0x1000},
	{74245, 0x2000},
	{74275, 0x4000},
	/* 4973 */
	{80735, 0x1},
	{80751, 0x2},
	{80767, 0x4},
	{80783, 0x8},
	{80799, 0x10},
	{80815, 0x20},
	{80831, 0x40},
	{80847, 0x80},
	{80863, 0x100},
	{80879, 0x200},
	{80895, 0x400},
	{80911, 0x800},
	{80927, 0x1000},
	{80943, 0x2000},
	{80959, 0x4000},
	{80975, 0x8000},
	{80991, 0x10000},
	{81010, 0x20000},
	{81028, 0x40000},
	{81055, 0x80000},
	{81077, 0x100000},
	{81095, 0x200000},
	{81115, 0x400000},
	{81138, 0x800000},
	{81161, 0x1000000},
	{81186, 0x2000000},
	{81229, 0x4000000},
	{81206, 0x8000000},
	/* 5001 */
	{81835, 0x1},
	{81607, 0x2},
	{81631, 0x4},
	{81651, 0x8},
	{81672, 0x10},
	{81873, 0x40},
	/* 5007 */
	{81902, 0x1},
	{81913, 0x2},
	{115098, 0x4},
	/* 5010 */
	{92680, 0x1},
	{82083, 0x1E},
	{82095, 0xE0},
	{82109, 0x300},
	{82125, 0x1C00},
	{82136, 0x1E000},
	/* 5016 */
	{203, 0x3, 3, 36374},
	{83924, 0xC, 4, 36377},
	{84004, 0x30, 4, 36381},
	{84064, 0x40, 2, 36385},
	{86114, 0x100},
	{78431, 0x200},
	{84081, 0x400},
	/* 5023 */
	{85300, 0x3F, 64, 37302},
	{60519, 0x7FFFC00},
	{85311, 0x8000000},
	/* 5026 */
	{54978, 0xFFFF},
	/* 5027 */
	{85341, 0x1},
	{85355, 0x2},
	{115161, 0x4},
	{85371, 0x8},
	/* 5031 */
	{85514, 0x2},
	{112646, 0x4},
	{112669, 0x8},
	{112677, 0x3F0},
	{112692, 0xFC00},
	{85593, 0x10000},
	{67528, 0x40000},
	{114910, 0x80000},
	/* 5039 */
	{85865, 0x3, 4, 36452},
	{85896, 0x4, 2, 36456},
	{19758, 0x18, 4, 36458},
	{85978, 0x20, 2, 36462},
	{86043, 0xC0, 4, 36464},
	{68377, 0x200},
	{86060, 0x400},
	{86080, 0x800},
	{86100, 0x1000},
	{86114, 0x2000},
	{86125, 0x4000},
	{86141, 0x78000},
	{86161, 0x180000},
	/* 5052 */
	{209, 0x3, 3, 36468},
	{86375, 0x1C, 4, 36471},
	{86452, 0xE0, 4, 36475},
	{86461, 0x100},
	{86481, 0x200},
	{86514, 0x4000},
	{84064, 0x8000, 2, 36385},
	{86548, 0x60000, 4, 36479},
	/* 5060 */
	{88203, 0x3, 4, 36505},
	{88216, 0x4},
	{88227, 0x8},
	{88336, 0x70},
	{88354, 0x380},
	{88372, 0x1C00},
	{88395, 0x3E000},
	{88421, 0x40000},
	{88443, 0x7F80000},
	{88459, 0x8000000},
	{88481, 0x10000000},
	/* 5071 */
	{88620, 0x1},
	{88637, 0x1E},
	{88661, 0x20},
	{88679, 0x3C0},
	{88704, 0x400},
	{88734, 0x800},
	{88749, 0x1000},
	{88764, 0x2000},
	{88799, 0x4000},
	{88835, 0x8000},
	{88925, 0x30000},
	{88949, 0x40000},
	{88985, 0x80000},
	{89021, 0x100000},
	{89047, 0x200000},
	{89071, 0x400000},
	{89091, 0x800000},
	{89112, 0x1000000},
	/* 5089 */
	{69413, 0x7FF},
	{69440, 0xFFE000},
	{89281, 0xF000000},
	/* 5092 */
	{89342, 0x3, 4, 36520},
	{17302, 0x7C, 32, 36524},
	{89940, 0x700, 8, 36556},
	{89996, 0x1800, 4, 36564},
	{79039, 0x2000},
	{70033, 0x4000},
	{90006, 0x8000},
	{90018, 0x10000},
	{90031, 0x20000},
	{87610, 0x40000},
	{90271, 0x700000, 8, 36568},
	{90293, 0x3800000, 8, 36568},
	{90317, 0x4000000},
	{90343, 0x8000000},
	{90369, 0x10000000},
	{90437, 0x60000000, 3, 36576},
	/* 5108 */
	{90906, 0x7FF},
	{90917, 0x800},
	{70745, 0x7000},
	{90523, 0x18000},
	{90537, 0x20000},
	{90929, 0x7C0000},
	{90943, 0xF800000},
	{90957, 0x30000000},
	{114910, 0x40000000},
	{67528, 0x80000000},
	/* 5118 */
	{91095, 0xFFFF},
	{91107, 0x10000},
	{91023, 0x2000000},
	{26653, 0xE0000000},
	/* 5122 */
	{26221, 0xFFFF},
	{91023, 0x400000},
	/* 5124 */
	{26293, 0xFFFF},
	{91023, 0x400000},
	/* 5126 */
	{91190, 0x400},
	{91203, 0x2000},
	{91232, 0x300000},
	{91243, 0x2000000},
	{91272, 0x60000000},
	/* 5131 */
	{91617, 0x1},
	{91651, 0x30},
	{91663, 0xF0000},
	{91676, 0x10000000},
	{91691, 0x20000000},
	{91705, 0xC0000000},
	/* 5137 */
	{112936, 0x7F},
	{112948, 0x3F000},
	{91023, 0x2000000},
	{91899, 0x10000000},
	/* 5141 */
	{92329, 0xF},
	{92341, 0xF0},
	{100215, 0xF00},
	{115180, 0xF000},
	{92369, 0x30000},
	{92379, 0xC0000},
	{9882, 0x100000},
	{10365, 0xFFE00000},
	/* 5149 */
	{203, 0x3, 3, 36374},
	{86114, 0x100},
	/* 5151 */
	{107523, 0x7},
	{107531, 0x38},
	{107539, 0x1C0},
	{107547, 0xE00},
	{107555, 0x7000},
	{107563, 0x38000},
	{107571, 0x1C0000},
	{982, 0x600000},
	{107579, 0x1800000},
	{107592, 0x2000000},
	{115189, 0x4000000},
	{107605, 0x18000000},
	{107616, 0x20000000},
	{60179, 0x40000000},
	{65130, 0x80000000},
	/* 5166 */
	{60358, 0x3FF},
	{60373, 0x3FF0000},
	{96983, 0x10000000},
	{107515, 0x20000000},
	{56396, 0x40000000},
	{68722, 0x80000000},
	/* 5172 */
	{81023, 0x1},
	{858, 0x1FFE},
	{209, 0x2000},
	{88904, 0x4000},
	{92926, 0x8000},
	{92938, 0xFFF0000},
	{92949, 0x10000000},
	{92960, 0x20000000},
	{92970, 0x40000000},
	{92904, 0x80000000},
	/* 5182 */
	{115200, 0xF},
	{115215, 0x10},
	{115239, 0x20},
	{115259, 0x40},
	{115275, 0x80},
	{115291, 0x100},
	{115317, 0x200},
	{115334, 0x3C00},
	{115350, 0x4000},
	{115371, 0x8000},
	{115392, 0xFFFF0000},
	/* 5193 */
	{115406, 0xF},
	{115447, 0xF0},
	/* 5195 */
	{115486, 0x3},
	{115499, 0xC},
	{115512, 0x30},
	{115525, 0xC0},
	/* 5199 */
	{115538, 0x3FF},
	{115548, 0xFFC00},
	{93051, 0xF00000},
	{93060, 0xF000000},
	{93071, 0xF0000000},
	/* 5204 */
	{115558, 0x3FF},
	{115568, 0xFFC00},
	{93102, 0xF000000},
	{93113, 0xF0000000},
	/* 5208 */
	{441, 0x7},
	{11232, 0x40000000},
	{9882, 0x80000000},
	/* 5211 */
	{93032, 0x3F},
	{93860, 0x400},
	{93887, 0x800},
	{100860, 0x1000},
	{93914, 0x2000},
	{93940, 0x4000},
	{93966, 0x10000},
	{93993, 0x20000},
	{94019, 0x40000},
	{94045, 0x80000},
	{94073, 0x100000},
	{94099, 0x200000},
	{94125, 0x400000},
	{100887, 0x800000},
	{94151, 0x1000000},
	{94178, 0x2000000},
	{94205, 0x4000000},
	{100913, 0x8000000},
	{100939, 0x10000000},
	{94285, 0x20000000},
	{94314, 0x40000000},
	{94340, 0x80000000},
	/* 5233 */
	{93032, 0x3F},
	{93860, 0x400},
	{93887, 0x800},
	{93914, 0x1000},
	{93940, 0x2000},
	{93966, 0x8000},
	{93993, 0x10000},
	{94073, 0x20000},
	{94099, 0x40000},
	{100860, 0x80000},
	{94019, 0x100000},
	{94178, 0x200000},
	{94340, 0x400000},
	/* 5246 */
	{115578, 0xFF},
	{10365, 0xFFFFFF00},
};

static const char sid_strings[] = {
	'N', 'O', 'P', '\0', /* NOP (0, 1) */
	'S', 'E', 'T', '_', 'B', 'A', 'S', 'E', '\0', /* SET_BASE (4, 8) */
	'C', 'L', 'E', 'A', 'R', '_', 'S', 'T', 'A', 'T', 'E', '\0', /* CLEAR_STATE (13) */
	'I', 'N', 'D', 'E', 'X', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'S', 'I', 'Z', 'E', '\0', /* INDEX_BUFFER_SIZE (25, 38) */
	'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'D', 'I', 'R', 'E', 'C', 'T', '\0', /* DISPATCH_DIRECT (43) */
	'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '\0', /* DISPATCH_INDIRECT (59) */
	'O', 'C', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '_', 'Q', 'U', 'E', 'R', 'Y', '\0', /* OCCLUSION_QUERY (77, 91) */
	'S', 'E', 'T', '_', 'P', 'R', 'E', 'D', 'I', 'C', 'A', 'T', 'I', 'O', 'N', '\0', /* SET_PREDICATION (93) */
	'C', 'O', 'N', 'D', '_', 'E', 'X', 'E', 'C', '\0', /* COND_EXEC (109) */
	'P', 'R', 'E', 'D', '_', 'E', 'X', 'E', 'C', '\0', /* PRED_EXEC (119) */
	'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '\0', /* DRAW_INDIRECT (129) */
	'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'E', 'X', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '\0', /* DRAW_INDEX_INDIRECT (143) */
	'I', 'N', 'D', 'E', 'X', '_', 'B', 'A', 'S', 'E', '\0', /* INDEX_BASE (163) */
	'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'E', 'X', '_', '2', '\0', /* DRAW_INDEX_2 (174) */
	'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CONTEXT_CONTROL (187, 195) */
	'I', 'N', 'D', 'E', 'X', '_', 'T', 'Y', 'P', 'E', '\0', /* INDEX_TYPE (203, 209) */
	'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '_', 'M', 'U', 'L', 'T', 'I', '\0', /* DRAW_INDIRECT_MULTI (214) */
	'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'E', 'X', '_', 'A', 'U', 'T', 'O', '\0', /* DRAW_INDEX_AUTO (234, 245) */
	'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'E', 'X', '_', 'I', 'M', 'M', 'D', '\0', /* DRAW_INDEX_IMMD (250) */
	'N', 'U', 'M', '_', 'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', 'S', '\0', /* NUM_INSTANCES (266) */
	'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'E', 'X', '_', 'M', 'U', 'L', 'T', 'I', '_', 'A', 'U', 'T', 'O', '\0', /* DRAW_INDEX_MULTI_AUTO (280) */
	'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'S', 'I', '\0', /* INDIRECT_BUFFER_SI (302) */
	'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'C', 'O', 'N', 'S', 'T', '\0', /* INDIRECT_BUFFER_CONST (321) */
	'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'U', 'P', 'D', 'A', 'T', 'E', '\0', /* STRMOUT_BUFFER_UPDATE (343) */
	'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'E', 'X', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', '2', '\0', /* DRAW_INDEX_OFFSET_2 (365) */
	'W', 'R', 'I', 'T', 'E', '_', 'D', 'A', 'T', 'A', '\0', /* WRITE_DATA (385, 391) */
	'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'E', 'X', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '_', 'M', 'U', 'L', 'T', 'I', '\0', /* DRAW_INDEX_INDIRECT_MULTI (396) */
	'M', 'E', 'M', '_', 'S', 'E', 'M', 'A', 'P', 'H', 'O', 'R', 'E', '\0', /* MEM_SEMAPHORE (422) */
	'M', 'P', 'E', 'G', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* MPEG_INDEX (436, 441, 445) */
	'W', 'A', 'I', 'T', '_', 'R', 'E', 'G', '_', 'M', 'E', 'M', '\0', /* WAIT_REG_MEM (447, 456) */
	'M', 'E', 'M', '_', 'W', 'R', 'I', 'T', 'E', '\0', /* MEM_WRITE (460) */
	'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'C', 'I', 'K', '\0', /* INDIRECT_BUFFER_CIK (470) */
	'C', 'O', 'P', 'Y', '_', 'D', 'A', 'T', 'A', '\0', /* COPY_DATA (490) */
	'P', 'F', 'P', '_', 'S', 'Y', 'N', 'C', '_', 'M', 'E', '\0', /* PFP_SYNC_ME (500, 509) */
	'S', 'U', 'R', 'F', 'A', 'C', 'E', '_', 'S', 'Y', 'N', 'C', '\0', /* SURFACE_SYNC (512) */
	'M', 'E', '_', 'I', 'N', 'I', 'T', 'I', 'A', 'L', 'I', 'Z', 'E', '\0', /* ME_INITIALIZE (525) */
	'C', 'O', 'N', 'D', '_', 'W', 'R', 'I', 'T', 'E', '\0', /* COND_WRITE (539) */
	'E', 'V', 'E', 'N', 'T', '_', 'W', 'R', 'I', 'T', 'E', '\0', /* EVENT_WRITE (550) */
	'E', 'V', 'E', 'N', 'T', '_', 'W', 'R', 'I', 'T', 'E', '_', 'E', 'O', 'P', '\0', /* EVENT_WRITE_EOP (562) */
	'E', 'V', 'E', 'N', 'T', '_', 'W', 'R', 'I', 'T', 'E', '_', 'E', 'O', 'S', '\0', /* EVENT_WRITE_EOS (578) */
	'R', 'E', 'L', 'E', 'A', 'S', 'E', '_', 'M', 'E', 'M', '\0', /* RELEASE_MEM (594) */
	'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'R', 'E', 'G', '_', 'R', 'M', 'W', '\0', /* CONTEXT_REG_RMW (606) */
	'O', 'N', 'E', '_', 'R', 'E', 'G', '_', 'W', 'R', 'I', 'T', 'E', '\0', /* ONE_REG_WRITE (622) */
	'A', 'C', 'Q', 'U', 'I', 'R', 'E', '_', 'M', 'E', 'M', '\0', /* ACQUIRE_MEM (636) */
	'R', 'E', 'W', 'I', 'N', 'D', '\0', /* REWIND (648) */
	'L', 'O', 'A', 'D', '_', 'U', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'E', 'G', '\0', /* LOAD_UCONFIG_REG (655) */
	'L', 'O', 'A', 'D', '_', 'S', 'H', '_', 'R', 'E', 'G', '\0', /* LOAD_SH_REG (672) */
	'L', 'O', 'A', 'D', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'R', 'E', 'G', '\0', /* LOAD_CONTEXT_REG (684) */
	'S', 'E', 'T', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'E', 'G', '\0', /* SET_CONFIG_REG (701) */
	'S', 'E', 'T', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'R', 'E', 'G', '\0', /* SET_CONTEXT_REG (716) */
	'S', 'E', 'T', '_', 'S', 'H', '_', 'R', 'E', 'G', '\0', /* SET_SH_REG (732) */
	'S', 'E', 'T', '_', 'S', 'H', '_', 'R', 'E', 'G', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* SET_SH_REG_OFFSET (743, 754) */
	'S', 'E', 'T', '_', 'U', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'E', 'G', '\0', /* SET_UCONFIG_REG (761) */
	'S', 'E', 'T', '_', 'U', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'E', 'G', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* SET_UCONFIG_REG_INDEX (777) */
	'L', 'O', 'A', 'D', '_', 'C', 'O', 'N', 'S', 'T', '_', 'R', 'A', 'M', '\0', /* LOAD_CONST_RAM (799) */
	'W', 'R', 'I', 'T', 'E', '_', 'C', 'O', 'N', 'S', 'T', '_', 'R', 'A', 'M', '\0', /* WRITE_CONST_RAM (814) */
	'D', 'U', 'M', 'P', '_', 'C', 'O', 'N', 'S', 'T', '_', 'R', 'A', 'M', '\0', /* DUMP_CONST_RAM (830) */
	'I', 'N', 'C', 'R', 'E', 'M', 'E', 'N', 'T', '_', 'C', 'E', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '\0', /* INCREMENT_CE_COUNTER (845, 858) */
	'I', 'N', 'C', 'R', 'E', 'M', 'E', 'N', 'T', '_', 'D', 'E', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '\0', /* INCREMENT_DE_COUNTER (866) */
	'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'C', 'E', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '\0', /* WAIT_ON_CE_COUNTER (887) */
	'S', 'E', 'T', '_', 'S', 'H', '_', 'R', 'E', 'G', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* SET_SH_REG_INDEX (906) */
	'L', 'O', 'A', 'D', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'R', 'E', 'G', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* LOAD_CONTEXT_REG_INDEX (923) */
	'I', 'T', '_', 'O', 'P', 'C', 'O', 'D', 'E', '_', 'C', '\0', /* IT_OPCODE_C (946) */
	'C', 'P', '_', 'D', 'M', 'A', '\0', /* CP_DMA (958) */
	'D', 'M', 'A', '_', 'D', 'A', 'T', 'A', '\0', /* DMA_DATA (965) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'M', 'O', 'D', 'E', '\0', /* SQ_WAVE_MODE (974, 982, 984) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* SQ_WAVE_STATUS (987, 995) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'R', 'A', 'P', 'S', 'T', 'S', '\0', /* SQ_WAVE_TRAPSTS (1002) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'H', 'W', '_', 'I', 'D', '_', 'L', 'E', 'G', 'A', 'C', 'Y', '\0', /* SQ_WAVE_HW_ID_LEGACY (1018) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'G', 'P', 'R', '_', 'A', 'L', 'L', 'O', 'C', '\0', /* SQ_WAVE_GPR_ALLOC (1039) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'L', 'D', 'S', '_', 'A', 'L', 'L', 'O', 'C', '\0', /* SQ_WAVE_LDS_ALLOC (1057) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'I', 'B', '_', 'S', 'T', 'S', '\0', /* SQ_WAVE_IB_STS (1075) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'P', 'C', '_', 'L', 'O', '\0', /* SQ_WAVE_PC_LO (1090) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'P', 'C', '_', 'H', 'I', '\0', /* SQ_WAVE_PC_HI (1104, 1112) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'I', 'N', 'S', 'T', '_', 'D', 'W', '0', '\0', /* SQ_WAVE_INST_DW0 (1118) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'I', 'B', '_', 'D', 'B', 'G', '1', '\0', /* SQ_WAVE_IB_DBG1 (1135) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'F', 'L', 'U', 'S', 'H', '_', 'I', 'B', '\0', /* SQ_WAVE_FLUSH_IB (1151) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'H', 'W', '_', 'I', 'D', '1', '\0', /* SQ_WAVE_HW_ID1 (1168) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'H', 'W', '_', 'I', 'D', '2', '\0', /* SQ_WAVE_HW_ID2 (1183) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'P', 'O', 'P', 'S', '_', 'P', 'A', 'C', 'K', 'E', 'R', '\0', /* SQ_WAVE_POPS_PACKER (1198) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'S', 'C', 'H', 'E', 'D', '_', 'M', 'O', 'D', 'E', '\0', /* SQ_WAVE_SCHED_MODE (1218) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'V', 'G', 'P', 'R', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* SQ_WAVE_VGPR_OFFSET (1237) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'I', 'B', '_', 'S', 'T', 'S', '2', '\0', /* SQ_WAVE_IB_STS2 (1257) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '0', '\0', /* SQ_WAVE_TTMP0 (1273) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '1', '\0', /* SQ_WAVE_TTMP1 (1287) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '2', '\0', /* SQ_WAVE_TTMP2 (1301) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '3', '\0', /* SQ_WAVE_TTMP3 (1315) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '4', '\0', /* SQ_WAVE_TTMP4 (1329) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '5', '\0', /* SQ_WAVE_TTMP5 (1343) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '6', '\0', /* SQ_WAVE_TTMP6 (1357) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '7', '\0', /* SQ_WAVE_TTMP7 (1371) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '8', '\0', /* SQ_WAVE_TTMP8 (1385) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '9', '\0', /* SQ_WAVE_TTMP9 (1399) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '1', '0', '\0', /* SQ_WAVE_TTMP10 (1413) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '1', '1', '\0', /* SQ_WAVE_TTMP11 (1428) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '1', '2', '\0', /* SQ_WAVE_TTMP12 (1443) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '1', '3', '\0', /* SQ_WAVE_TTMP13 (1458) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '1', '4', '\0', /* SQ_WAVE_TTMP14 (1473) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'T', 'M', 'P', '1', '5', '\0', /* SQ_WAVE_TTMP15 (1488) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'M', '0', '\0', /* SQ_WAVE_M0 (1503) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'E', 'X', 'E', 'C', '_', 'L', 'O', '\0', /* SQ_WAVE_EXEC_LO (1514) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'E', 'X', 'E', 'C', '_', 'H', 'I', '\0', /* SQ_WAVE_EXEC_HI (1530) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'F', 'L', 'A', 'T', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'L', 'O', '\0', /* SQ_WAVE_FLAT_SCRATCH_LO (1546) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'F', 'L', 'A', 'T', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'H', 'I', '\0', /* SQ_WAVE_FLAT_SCRATCH_HI (1570) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'F', 'L', 'A', 'T', '_', 'X', 'N', 'A', 'C', 'K', '_', 'M', 'A', 'S', 'K', '\0', /* SQ_WAVE_FLAT_XNACK_MASK (1594) */
	'G', 'R', 'B', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '2', '\0', /* GRBM_STATUS2 (1618) */
	'G', 'R', 'B', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* GRBM_STATUS (1631) */
	'G', 'R', 'B', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '_', 'S', 'E', '0', '\0', /* GRBM_STATUS_SE0 (1643) */
	'G', 'R', 'B', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '_', 'S', 'E', '1', '\0', /* GRBM_STATUS_SE1 (1659) */
	'G', 'R', 'B', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '3', '\0', /* GRBM_STATUS3 (1675) */
	'G', 'R', 'B', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '_', 'S', 'E', '2', '\0', /* GRBM_STATUS_SE2 (1688) */
	'G', 'R', 'B', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '_', 'S', 'E', '3', '\0', /* GRBM_STATUS_SE3 (1704) */
	'C', 'P', '_', 'C', 'P', 'C', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* CP_CPC_STATUS (1720) */
	'C', 'P', '_', 'C', 'P', 'C', '_', 'B', 'U', 'S', 'Y', '_', 'S', 'T', 'A', 'T', '\0', /* CP_CPC_BUSY_STAT (1734) */
	'C', 'P', '_', 'C', 'P', 'C', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'S', 'T', 'A', 'T', '1', '\0', /* CP_CPC_STALLED_STAT1 (1751) */
	'C', 'P', '_', 'C', 'P', 'F', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* CP_CPF_STATUS (1772) */
	'C', 'P', '_', 'C', 'P', 'F', '_', 'B', 'U', 'S', 'Y', '_', 'S', 'T', 'A', 'T', '\0', /* CP_CPF_BUSY_STAT (1786) */
	'C', 'P', '_', 'C', 'P', 'F', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'S', 'T', 'A', 'T', '1', '\0', /* CP_CPF_STALLED_STAT1 (1803) */
	'C', 'P', '_', 'C', 'P', 'C', '_', 'B', 'U', 'S', 'Y', '_', 'S', 'T', 'A', 'T', '2', '\0', /* CP_CPC_BUSY_STAT2 (1824) */
	'C', 'P', '_', 'C', 'P', 'C', '_', 'G', 'R', 'B', 'M', '_', 'F', 'R', 'E', 'E', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* CP_CPC_GRBM_FREE_COUNT (1842, 1854, 1859) */
	'C', 'P', '_', 'C', 'P', 'C', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* CP_CPC_SCRATCH_INDEX (1865, 1872) */
	'C', 'P', '_', 'C', 'P', 'C', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'D', 'A', 'T', 'A', '\0', /* CP_CPC_SCRATCH_DATA (1886) */
	'C', 'P', '_', 'C', 'P', 'F', '_', 'G', 'R', 'B', 'M', '_', 'F', 'R', 'E', 'E', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* CP_CPF_GRBM_FREE_COUNT (1906) */
	'C', 'P', '_', 'C', 'P', 'F', '_', 'B', 'U', 'S', 'Y', '_', 'S', 'T', 'A', 'T', '2', '\0', /* CP_CPF_BUSY_STAT2 (1929) */
	'C', 'P', '_', 'C', 'P', 'C', '_', 'H', 'A', 'L', 'T', '_', 'H', 'Y', 'S', 'T', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* CP_CPC_HALT_HYST_COUNT (1947) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'B', 'U', 'F', '0', '_', 'B', 'A', 'S', 'E', '\0', /* SQ_THREAD_TRACE_BUF0_BASE (1970) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'B', 'U', 'F', '0', '_', 'S', 'I', 'Z', 'E', '\0', /* SQ_THREAD_TRACE_BUF0_SIZE (1996) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'B', 'U', 'F', '1', '_', 'B', 'A', 'S', 'E', '\0', /* SQ_THREAD_TRACE_BUF1_BASE (2022) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'B', 'U', 'F', '1', '_', 'S', 'I', 'Z', 'E', '\0', /* SQ_THREAD_TRACE_BUF1_SIZE (2048) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'W', 'P', 'T', 'R', '\0', /* SQ_THREAD_TRACE_WPTR (2074, 2090) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'M', 'A', 'S', 'K', '\0', /* SQ_THREAD_TRACE_MASK (2095) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'T', 'O', 'K', 'E', 'N', '_', 'M', 'A', 'S', 'K', '\0', /* SQ_THREAD_TRACE_TOKEN_MASK (2116, 2132) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'C', 'T', 'R', 'L', '\0', /* SQ_THREAD_TRACE_CTRL (2143) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* SQ_THREAD_TRACE_STATUS (2164) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'D', 'R', 'O', 'P', 'P', 'E', 'D', '_', 'C', 'N', 'T', 'R', '\0', /* SQ_THREAD_TRACE_DROPPED_CNTR (2187) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'G', 'F', 'X', '_', 'D', 'R', 'A', 'W', '_', 'C', 'N', 'T', 'R', '\0', /* SQ_THREAD_TRACE_GFX_DRAW_CNTR (2216) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'G', 'F', 'X', '_', 'M', 'A', 'R', 'K', 'E', 'R', '_', 'C', 'N', 'T', 'R', '\0', /* SQ_THREAD_TRACE_GFX_MARKER_CNTR (2246) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'H', 'P', '3', 'D', '_', 'D', 'R', 'A', 'W', '_', 'C', 'N', 'T', 'R', '\0', /* SQ_THREAD_TRACE_HP3D_DRAW_CNTR (2278) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'H', 'P', '3', 'D', '_', 'M', 'A', 'R', 'K', 'E', 'R', '_', 'C', 'N', 'T', 'R', '\0', /* SQ_THREAD_TRACE_HP3D_MARKER_CNTR (2309) */
	'S', 'Q', '_', 'E', 'X', 'P', '_', '0', '\0', /* SQ_EXP_0 (2342) */
	'S', 'Q', '_', 'B', 'U', 'F', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '0', '\0', /* SQ_BUF_RSRC_WORD0 (2351) */
	'S', 'Q', '_', 'B', 'U', 'F', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '1', '\0', /* SQ_BUF_RSRC_WORD1 (2369) */
	'S', 'Q', '_', 'B', 'U', 'F', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '2', '\0', /* SQ_BUF_RSRC_WORD2 (2387) */
	'S', 'Q', '_', 'B', 'U', 'F', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '3', '\0', /* SQ_BUF_RSRC_WORD3 (2405) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'S', 'A', 'M', 'P', '_', 'W', 'O', 'R', 'D', '0', '\0', /* SQ_IMG_SAMP_WORD0 (2423) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'S', 'A', 'M', 'P', '_', 'W', 'O', 'R', 'D', '1', '\0', /* SQ_IMG_SAMP_WORD1 (2441) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'S', 'A', 'M', 'P', '_', 'W', 'O', 'R', 'D', '2', '\0', /* SQ_IMG_SAMP_WORD2 (2459) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'S', 'A', 'M', 'P', '_', 'W', 'O', 'R', 'D', '3', '\0', /* SQ_IMG_SAMP_WORD3 (2477) */
	'S', 'P', 'I', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'C', 'N', 'T', 'L', '\0', /* SPI_CONFIG_CNTL (2495) */
	'G', 'B', '_', 'A', 'D', 'D', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* GB_ADDR_CONFIG (2511) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '0', '\0', /* GB_TILE_MODE0 (2526) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '\0', /* GB_TILE_MODE1 (2540) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '\0', /* GB_TILE_MODE2 (2554) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '3', '\0', /* GB_TILE_MODE3 (2568) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '4', '\0', /* GB_TILE_MODE4 (2582) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '5', '\0', /* GB_TILE_MODE5 (2596) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '6', '\0', /* GB_TILE_MODE6 (2610) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '7', '\0', /* GB_TILE_MODE7 (2624) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '8', '\0', /* GB_TILE_MODE8 (2638) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '9', '\0', /* GB_TILE_MODE9 (2652) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '0', '\0', /* GB_TILE_MODE10 (2666) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '1', '\0', /* GB_TILE_MODE11 (2681) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '2', '\0', /* GB_TILE_MODE12 (2696) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '3', '\0', /* GB_TILE_MODE13 (2711) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '4', '\0', /* GB_TILE_MODE14 (2726) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '5', '\0', /* GB_TILE_MODE15 (2741) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '6', '\0', /* GB_TILE_MODE16 (2756) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '7', '\0', /* GB_TILE_MODE17 (2771) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '8', '\0', /* GB_TILE_MODE18 (2786) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '9', '\0', /* GB_TILE_MODE19 (2801) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '0', '\0', /* GB_TILE_MODE20 (2816) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '1', '\0', /* GB_TILE_MODE21 (2831) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '2', '\0', /* GB_TILE_MODE22 (2846) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '3', '\0', /* GB_TILE_MODE23 (2861) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '4', '\0', /* GB_TILE_MODE24 (2876) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '5', '\0', /* GB_TILE_MODE25 (2891) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '6', '\0', /* GB_TILE_MODE26 (2906) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '7', '\0', /* GB_TILE_MODE27 (2921) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '8', '\0', /* GB_TILE_MODE28 (2936) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '9', '\0', /* GB_TILE_MODE29 (2951) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '3', '0', '\0', /* GB_TILE_MODE30 (2966) */
	'G', 'B', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '3', '1', '\0', /* GB_TILE_MODE31 (2981) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '0', '\0', /* GB_MACROTILE_MODE0 (2996) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '\0', /* GB_MACROTILE_MODE1 (3015) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '2', '\0', /* GB_MACROTILE_MODE2 (3034) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '3', '\0', /* GB_MACROTILE_MODE3 (3053) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '4', '\0', /* GB_MACROTILE_MODE4 (3072) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '5', '\0', /* GB_MACROTILE_MODE5 (3091) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '6', '\0', /* GB_MACROTILE_MODE6 (3110) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '7', '\0', /* GB_MACROTILE_MODE7 (3129) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '8', '\0', /* GB_MACROTILE_MODE8 (3148) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '9', '\0', /* GB_MACROTILE_MODE9 (3167) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '0', '\0', /* GB_MACROTILE_MODE10 (3186) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '1', '\0', /* GB_MACROTILE_MODE11 (3206) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '2', '\0', /* GB_MACROTILE_MODE12 (3226) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '3', '\0', /* GB_MACROTILE_MODE13 (3246) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '4', '\0', /* GB_MACROTILE_MODE14 (3266) */
	'G', 'B', '_', 'M', 'A', 'C', 'R', 'O', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '1', '5', '\0', /* GB_MACROTILE_MODE15 (3286) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '0', '\0', /* SQ_IMG_RSRC_WORD0 (3306) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '1', '\0', /* SQ_IMG_RSRC_WORD1 (3324) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '2', '\0', /* SQ_IMG_RSRC_WORD2 (3342) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '3', '\0', /* SQ_IMG_RSRC_WORD3 (3360) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '4', '\0', /* SQ_IMG_RSRC_WORD4 (3378) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '5', '\0', /* SQ_IMG_RSRC_WORD5 (3396) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '6', '\0', /* SQ_IMG_RSRC_WORD6 (3414) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'R', 'S', 'R', 'C', '_', 'W', 'O', 'R', 'D', '7', '\0', /* SQ_IMG_RSRC_WORD7 (3432) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '4', '_', 'P', 'S', '\0', /* SPI_SHADER_PGM_RSRC4_PS (3450) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'C', 'H', 'K', 'S', 'U', 'M', '_', 'P', 'S', '\0', /* SPI_SHADER_PGM_CHKSUM_PS (3474) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '3', '_', 'P', 'S', '\0', /* SPI_SHADER_PGM_RSRC3_PS (3499) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'L', 'O', '_', 'P', 'S', '\0', /* SPI_SHADER_PGM_LO_PS (3523) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'H', 'I', '_', 'P', 'S', '\0', /* SPI_SHADER_PGM_HI_PS (3544) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '1', '_', 'P', 'S', '\0', /* SPI_SHADER_PGM_RSRC1_PS (3565) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'P', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_PS (3589) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '0', '\0', /* SPI_SHADER_USER_DATA_PS_0 (3613) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '\0', /* SPI_SHADER_USER_DATA_PS_1 (3639) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '\0', /* SPI_SHADER_USER_DATA_PS_2 (3665) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '3', '\0', /* SPI_SHADER_USER_DATA_PS_3 (3691) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '4', '\0', /* SPI_SHADER_USER_DATA_PS_4 (3717) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '5', '\0', /* SPI_SHADER_USER_DATA_PS_5 (3743) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '6', '\0', /* SPI_SHADER_USER_DATA_PS_6 (3769) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '7', '\0', /* SPI_SHADER_USER_DATA_PS_7 (3795) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '8', '\0', /* SPI_SHADER_USER_DATA_PS_8 (3821) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '9', '\0', /* SPI_SHADER_USER_DATA_PS_9 (3847) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '0', '\0', /* SPI_SHADER_USER_DATA_PS_10 (3873) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '1', '\0', /* SPI_SHADER_USER_DATA_PS_11 (3900) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '2', '\0', /* SPI_SHADER_USER_DATA_PS_12 (3927) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '3', '\0', /* SPI_SHADER_USER_DATA_PS_13 (3954) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '4', '\0', /* SPI_SHADER_USER_DATA_PS_14 (3981) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '5', '\0', /* SPI_SHADER_USER_DATA_PS_15 (4008) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '6', '\0', /* SPI_SHADER_USER_DATA_PS_16 (4035) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '7', '\0', /* SPI_SHADER_USER_DATA_PS_17 (4062) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '8', '\0', /* SPI_SHADER_USER_DATA_PS_18 (4089) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '1', '9', '\0', /* SPI_SHADER_USER_DATA_PS_19 (4116) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '0', '\0', /* SPI_SHADER_USER_DATA_PS_20 (4143) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '1', '\0', /* SPI_SHADER_USER_DATA_PS_21 (4170) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '2', '\0', /* SPI_SHADER_USER_DATA_PS_22 (4197) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '3', '\0', /* SPI_SHADER_USER_DATA_PS_23 (4224) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '4', '\0', /* SPI_SHADER_USER_DATA_PS_24 (4251) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '5', '\0', /* SPI_SHADER_USER_DATA_PS_25 (4278) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '6', '\0', /* SPI_SHADER_USER_DATA_PS_26 (4305) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '7', '\0', /* SPI_SHADER_USER_DATA_PS_27 (4332) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '8', '\0', /* SPI_SHADER_USER_DATA_PS_28 (4359) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '2', '9', '\0', /* SPI_SHADER_USER_DATA_PS_29 (4386) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '3', '0', '\0', /* SPI_SHADER_USER_DATA_PS_30 (4413) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'S', '_', '3', '1', '\0', /* SPI_SHADER_USER_DATA_PS_31 (4440) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'R', 'E', 'Q', '_', 'C', 'T', 'R', 'L', '_', 'P', 'S', '\0', /* SPI_SHADER_REQ_CTRL_PS (4467) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'R', 'E', 'F', '_', 'P', 'R', 'I', '_', 'C', 'N', 'T', 'R', '_', 'C', 'T', 'R', 'L', '_', 'P', 'S', '\0', /* SPI_SHADER_PREF_PRI_CNTR_CTRL_PS (4490) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'P', 'S', '_', '0', '\0', /* SPI_SHADER_USER_ACCUM_PS_0 (4523) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'P', 'S', '_', '1', '\0', /* SPI_SHADER_USER_ACCUM_PS_1 (4550) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'P', 'S', '_', '2', '\0', /* SPI_SHADER_USER_ACCUM_PS_2 (4577) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'P', 'S', '_', '3', '\0', /* SPI_SHADER_USER_ACCUM_PS_3 (4604) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '4', '_', 'V', 'S', '\0', /* SPI_SHADER_PGM_RSRC4_VS (4631) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'C', 'H', 'K', 'S', 'U', 'M', '_', 'V', 'S', '\0', /* SPI_SHADER_PGM_CHKSUM_VS (4655) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '3', '_', 'V', 'S', '\0', /* SPI_SHADER_PGM_RSRC3_VS (4680) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'L', 'A', 'T', 'E', '_', 'A', 'L', 'L', 'O', 'C', '_', 'V', 'S', '\0', /* SPI_SHADER_LATE_ALLOC_VS (4704) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'L', 'O', '_', 'V', 'S', '\0', /* SPI_SHADER_PGM_LO_VS (4729) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'H', 'I', '_', 'V', 'S', '\0', /* SPI_SHADER_PGM_HI_VS (4750) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '1', '_', 'V', 'S', '\0', /* SPI_SHADER_PGM_RSRC1_VS (4771) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'V', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_VS (4795) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '0', '\0', /* SPI_SHADER_USER_DATA_VS_0 (4819) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '\0', /* SPI_SHADER_USER_DATA_VS_1 (4845) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '\0', /* SPI_SHADER_USER_DATA_VS_2 (4871) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '3', '\0', /* SPI_SHADER_USER_DATA_VS_3 (4897) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '4', '\0', /* SPI_SHADER_USER_DATA_VS_4 (4923) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '5', '\0', /* SPI_SHADER_USER_DATA_VS_5 (4949) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '6', '\0', /* SPI_SHADER_USER_DATA_VS_6 (4975) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '7', '\0', /* SPI_SHADER_USER_DATA_VS_7 (5001) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '8', '\0', /* SPI_SHADER_USER_DATA_VS_8 (5027) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '9', '\0', /* SPI_SHADER_USER_DATA_VS_9 (5053) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '0', '\0', /* SPI_SHADER_USER_DATA_VS_10 (5079) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '1', '\0', /* SPI_SHADER_USER_DATA_VS_11 (5106) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '2', '\0', /* SPI_SHADER_USER_DATA_VS_12 (5133) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '3', '\0', /* SPI_SHADER_USER_DATA_VS_13 (5160) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '4', '\0', /* SPI_SHADER_USER_DATA_VS_14 (5187) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '5', '\0', /* SPI_SHADER_USER_DATA_VS_15 (5214) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '6', '\0', /* SPI_SHADER_USER_DATA_VS_16 (5241) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '7', '\0', /* SPI_SHADER_USER_DATA_VS_17 (5268) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '8', '\0', /* SPI_SHADER_USER_DATA_VS_18 (5295) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '1', '9', '\0', /* SPI_SHADER_USER_DATA_VS_19 (5322) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '0', '\0', /* SPI_SHADER_USER_DATA_VS_20 (5349) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '1', '\0', /* SPI_SHADER_USER_DATA_VS_21 (5376) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '2', '\0', /* SPI_SHADER_USER_DATA_VS_22 (5403) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '3', '\0', /* SPI_SHADER_USER_DATA_VS_23 (5430) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '4', '\0', /* SPI_SHADER_USER_DATA_VS_24 (5457) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '5', '\0', /* SPI_SHADER_USER_DATA_VS_25 (5484) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '6', '\0', /* SPI_SHADER_USER_DATA_VS_26 (5511) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '7', '\0', /* SPI_SHADER_USER_DATA_VS_27 (5538) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '8', '\0', /* SPI_SHADER_USER_DATA_VS_28 (5565) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '2', '9', '\0', /* SPI_SHADER_USER_DATA_VS_29 (5592) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '3', '0', '\0', /* SPI_SHADER_USER_DATA_VS_30 (5619) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'V', 'S', '_', '3', '1', '\0', /* SPI_SHADER_USER_DATA_VS_31 (5646) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'R', 'E', 'Q', '_', 'C', 'T', 'R', 'L', '_', 'V', 'S', '\0', /* SPI_SHADER_REQ_CTRL_VS (5673) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'R', 'E', 'F', '_', 'P', 'R', 'I', '_', 'C', 'N', 'T', 'R', '_', 'C', 'T', 'R', 'L', '_', 'V', 'S', '\0', /* SPI_SHADER_PREF_PRI_CNTR_CTRL_VS (5696) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'V', 'S', '_', '0', '\0', /* SPI_SHADER_USER_ACCUM_VS_0 (5729) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'V', 'S', '_', '1', '\0', /* SPI_SHADER_USER_ACCUM_VS_1 (5756) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'V', 'S', '_', '2', '\0', /* SPI_SHADER_USER_ACCUM_VS_2 (5783) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'V', 'S', '_', '3', '\0', /* SPI_SHADER_USER_ACCUM_VS_3 (5810) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'G', 'S', '_', 'V', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_GS_VS (5837) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'E', 'S', '_', 'V', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_ES_VS (5864) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'L', 'S', '_', 'V', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_LS_VS (5891) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'C', 'H', 'K', 'S', 'U', 'M', '_', 'G', 'S', '\0', /* SPI_SHADER_PGM_CHKSUM_GS (5918) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '4', '_', 'G', 'S', '\0', /* SPI_SHADER_PGM_RSRC4_GS (5943) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '_', 'G', 'S', '\0', /* SPI_SHADER_USER_DATA_ADDR_LO_GS (5967) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '_', 'G', 'S', '\0', /* SPI_SHADER_USER_DATA_ADDR_HI_GS (5999) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'L', 'O', '_', 'E', 'S', '_', 'G', 'S', '\0', /* SPI_SHADER_PGM_LO_ES_GS (6031) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'H', 'I', '_', 'E', 'S', '_', 'G', 'S', '\0', /* SPI_SHADER_PGM_HI_ES_GS (6055) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '3', '_', 'G', 'S', '\0', /* SPI_SHADER_PGM_RSRC3_GS (6079) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'L', 'O', '_', 'G', 'S', '\0', /* SPI_SHADER_PGM_LO_GS (6103) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'H', 'I', '_', 'G', 'S', '\0', /* SPI_SHADER_PGM_HI_GS (6124) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '1', '_', 'G', 'S', '\0', /* SPI_SHADER_PGM_RSRC1_GS (6145) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'G', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_GS (6169) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '0', '\0', /* SPI_SHADER_USER_DATA_GS_0 (6193) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '\0', /* SPI_SHADER_USER_DATA_GS_1 (6219) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '\0', /* SPI_SHADER_USER_DATA_GS_2 (6245) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '3', '\0', /* SPI_SHADER_USER_DATA_GS_3 (6271) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '4', '\0', /* SPI_SHADER_USER_DATA_GS_4 (6297) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '5', '\0', /* SPI_SHADER_USER_DATA_GS_5 (6323) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '6', '\0', /* SPI_SHADER_USER_DATA_GS_6 (6349) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '7', '\0', /* SPI_SHADER_USER_DATA_GS_7 (6375) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '8', '\0', /* SPI_SHADER_USER_DATA_GS_8 (6401) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '9', '\0', /* SPI_SHADER_USER_DATA_GS_9 (6427) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '0', '\0', /* SPI_SHADER_USER_DATA_GS_10 (6453) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '1', '\0', /* SPI_SHADER_USER_DATA_GS_11 (6480) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '2', '\0', /* SPI_SHADER_USER_DATA_GS_12 (6507) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '3', '\0', /* SPI_SHADER_USER_DATA_GS_13 (6534) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '4', '\0', /* SPI_SHADER_USER_DATA_GS_14 (6561) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '5', '\0', /* SPI_SHADER_USER_DATA_GS_15 (6588) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '6', '\0', /* SPI_SHADER_USER_DATA_GS_16 (6615) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '7', '\0', /* SPI_SHADER_USER_DATA_GS_17 (6642) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '8', '\0', /* SPI_SHADER_USER_DATA_GS_18 (6669) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '1', '9', '\0', /* SPI_SHADER_USER_DATA_GS_19 (6696) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '0', '\0', /* SPI_SHADER_USER_DATA_GS_20 (6723) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '1', '\0', /* SPI_SHADER_USER_DATA_GS_21 (6750) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '2', '\0', /* SPI_SHADER_USER_DATA_GS_22 (6777) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '3', '\0', /* SPI_SHADER_USER_DATA_GS_23 (6804) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '4', '\0', /* SPI_SHADER_USER_DATA_GS_24 (6831) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '5', '\0', /* SPI_SHADER_USER_DATA_GS_25 (6858) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '6', '\0', /* SPI_SHADER_USER_DATA_GS_26 (6885) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '7', '\0', /* SPI_SHADER_USER_DATA_GS_27 (6912) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '8', '\0', /* SPI_SHADER_USER_DATA_GS_28 (6939) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '2', '9', '\0', /* SPI_SHADER_USER_DATA_GS_29 (6966) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '3', '0', '\0', /* SPI_SHADER_USER_DATA_GS_30 (6993) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'G', 'S', '_', '3', '1', '\0', /* SPI_SHADER_USER_DATA_GS_31 (7020) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'R', 'E', 'Q', '_', 'C', 'T', 'R', 'L', '_', 'E', 'S', 'G', 'S', '\0', /* SPI_SHADER_REQ_CTRL_ESGS (7047) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'R', 'E', 'F', '_', 'P', 'R', 'I', '_', 'C', 'N', 'T', 'R', '_', 'C', 'T', 'R', 'L', '_', 'E', 'S', 'G', 'S', '\0', /* SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS (7072) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'E', 'S', 'G', 'S', '_', '0', '\0', /* SPI_SHADER_USER_ACCUM_ESGS_0 (7107) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'E', 'S', 'G', 'S', '_', '1', '\0', /* SPI_SHADER_USER_ACCUM_ESGS_1 (7136) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'E', 'S', 'G', 'S', '_', '2', '\0', /* SPI_SHADER_USER_ACCUM_ESGS_2 (7165) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'E', 'S', 'G', 'S', '_', '3', '\0', /* SPI_SHADER_USER_ACCUM_ESGS_3 (7194) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'E', 'S', '_', 'G', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_ES_GS (7223) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '3', '_', 'E', 'S', '\0', /* SPI_SHADER_PGM_RSRC3_ES (7250) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'L', 'O', '_', 'E', 'S', '\0', /* SPI_SHADER_PGM_LO_ES (7274) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'H', 'I', '_', 'E', 'S', '\0', /* SPI_SHADER_PGM_HI_ES (7295) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '1', '_', 'E', 'S', '\0', /* SPI_SHADER_PGM_RSRC1_ES (7316) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'E', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_ES (7340) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '0', '\0', /* SPI_SHADER_USER_DATA_ES_0 (7364) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '\0', /* SPI_SHADER_USER_DATA_ES_1 (7390) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '\0', /* SPI_SHADER_USER_DATA_ES_2 (7416) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '3', '\0', /* SPI_SHADER_USER_DATA_ES_3 (7442) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '4', '\0', /* SPI_SHADER_USER_DATA_ES_4 (7468) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '5', '\0', /* SPI_SHADER_USER_DATA_ES_5 (7494) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '6', '\0', /* SPI_SHADER_USER_DATA_ES_6 (7520) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '7', '\0', /* SPI_SHADER_USER_DATA_ES_7 (7546) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '8', '\0', /* SPI_SHADER_USER_DATA_ES_8 (7572) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '9', '\0', /* SPI_SHADER_USER_DATA_ES_9 (7598) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '0', '\0', /* SPI_SHADER_USER_DATA_ES_10 (7624) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '1', '\0', /* SPI_SHADER_USER_DATA_ES_11 (7651) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '2', '\0', /* SPI_SHADER_USER_DATA_ES_12 (7678) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '3', '\0', /* SPI_SHADER_USER_DATA_ES_13 (7705) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '4', '\0', /* SPI_SHADER_USER_DATA_ES_14 (7732) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '5', '\0', /* SPI_SHADER_USER_DATA_ES_15 (7759) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'L', 'S', '_', 'E', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_LS_ES (7786) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'C', 'H', 'K', 'S', 'U', 'M', '_', 'H', 'S', '\0', /* SPI_SHADER_PGM_CHKSUM_HS (7813) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '4', '_', 'H', 'S', '\0', /* SPI_SHADER_PGM_RSRC4_HS (7838) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '_', 'H', 'S', '\0', /* SPI_SHADER_USER_DATA_ADDR_LO_HS (7862) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '_', 'H', 'S', '\0', /* SPI_SHADER_USER_DATA_ADDR_HI_HS (7894) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'L', 'O', '_', 'L', 'S', '_', 'H', 'S', '\0', /* SPI_SHADER_PGM_LO_LS_HS (7926) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'H', 'I', '_', 'L', 'S', '_', 'H', 'S', '\0', /* SPI_SHADER_PGM_HI_LS_HS (7950) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '3', '_', 'H', 'S', '\0', /* SPI_SHADER_PGM_RSRC3_HS (7974) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'L', 'O', '_', 'H', 'S', '\0', /* SPI_SHADER_PGM_LO_HS (7998) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'H', 'I', '_', 'H', 'S', '\0', /* SPI_SHADER_PGM_HI_HS (8019) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '1', '_', 'H', 'S', '\0', /* SPI_SHADER_PGM_RSRC1_HS (8040) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'H', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_HS (8064) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '0', '\0', /* SPI_SHADER_USER_DATA_HS_0 (8088) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '\0', /* SPI_SHADER_USER_DATA_HS_1 (8114) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '\0', /* SPI_SHADER_USER_DATA_HS_2 (8140) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '3', '\0', /* SPI_SHADER_USER_DATA_HS_3 (8166) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '4', '\0', /* SPI_SHADER_USER_DATA_HS_4 (8192) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '5', '\0', /* SPI_SHADER_USER_DATA_HS_5 (8218) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '6', '\0', /* SPI_SHADER_USER_DATA_HS_6 (8244) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '7', '\0', /* SPI_SHADER_USER_DATA_HS_7 (8270) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '8', '\0', /* SPI_SHADER_USER_DATA_HS_8 (8296) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '9', '\0', /* SPI_SHADER_USER_DATA_HS_9 (8322) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '0', '\0', /* SPI_SHADER_USER_DATA_HS_10 (8348) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '1', '\0', /* SPI_SHADER_USER_DATA_HS_11 (8375) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '2', '\0', /* SPI_SHADER_USER_DATA_HS_12 (8402) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '3', '\0', /* SPI_SHADER_USER_DATA_HS_13 (8429) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '4', '\0', /* SPI_SHADER_USER_DATA_HS_14 (8456) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '5', '\0', /* SPI_SHADER_USER_DATA_HS_15 (8483) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '6', '\0', /* SPI_SHADER_USER_DATA_HS_16 (8510) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '7', '\0', /* SPI_SHADER_USER_DATA_HS_17 (8537) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '8', '\0', /* SPI_SHADER_USER_DATA_HS_18 (8564) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '1', '9', '\0', /* SPI_SHADER_USER_DATA_HS_19 (8591) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '0', '\0', /* SPI_SHADER_USER_DATA_HS_20 (8618) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '1', '\0', /* SPI_SHADER_USER_DATA_HS_21 (8645) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '2', '\0', /* SPI_SHADER_USER_DATA_HS_22 (8672) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '3', '\0', /* SPI_SHADER_USER_DATA_HS_23 (8699) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '4', '\0', /* SPI_SHADER_USER_DATA_HS_24 (8726) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '5', '\0', /* SPI_SHADER_USER_DATA_HS_25 (8753) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '6', '\0', /* SPI_SHADER_USER_DATA_HS_26 (8780) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '7', '\0', /* SPI_SHADER_USER_DATA_HS_27 (8807) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '8', '\0', /* SPI_SHADER_USER_DATA_HS_28 (8834) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '2', '9', '\0', /* SPI_SHADER_USER_DATA_HS_29 (8861) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '3', '0', '\0', /* SPI_SHADER_USER_DATA_HS_30 (8888) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'H', 'S', '_', '3', '1', '\0', /* SPI_SHADER_USER_DATA_HS_31 (8915) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'R', 'E', 'Q', '_', 'C', 'T', 'R', 'L', '_', 'L', 'S', 'H', 'S', '\0', /* SPI_SHADER_REQ_CTRL_LSHS (8942) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'R', 'E', 'F', '_', 'P', 'R', 'I', '_', 'C', 'N', 'T', 'R', '_', 'C', 'T', 'R', 'L', '_', 'L', 'S', 'H', 'S', '\0', /* SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS (8967) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'L', 'S', 'H', 'S', '_', '0', '\0', /* SPI_SHADER_USER_ACCUM_LSHS_0 (9002) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'L', 'S', 'H', 'S', '_', '1', '\0', /* SPI_SHADER_USER_ACCUM_LSHS_1 (9031) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'L', 'S', 'H', 'S', '_', '2', '\0', /* SPI_SHADER_USER_ACCUM_LSHS_2 (9060) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', 'L', 'S', 'H', 'S', '_', '3', '\0', /* SPI_SHADER_USER_ACCUM_LSHS_3 (9089) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'L', 'S', '_', 'H', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_LS_HS (9118) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '3', '_', 'L', 'S', '\0', /* SPI_SHADER_PGM_RSRC3_LS (9145) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'L', 'O', '_', 'L', 'S', '\0', /* SPI_SHADER_PGM_LO_LS (9169) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'H', 'I', '_', 'L', 'S', '\0', /* SPI_SHADER_PGM_HI_LS (9190) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '1', '_', 'L', 'S', '\0', /* SPI_SHADER_PGM_RSRC1_LS (9211) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '_', 'L', 'S', '\0', /* SPI_SHADER_PGM_RSRC2_LS (9235) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '0', '\0', /* SPI_SHADER_USER_DATA_LS_0 (9259) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '\0', /* SPI_SHADER_USER_DATA_LS_1 (9285) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '\0', /* SPI_SHADER_USER_DATA_LS_2 (9311) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '3', '\0', /* SPI_SHADER_USER_DATA_LS_3 (9337) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '4', '\0', /* SPI_SHADER_USER_DATA_LS_4 (9363) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '5', '\0', /* SPI_SHADER_USER_DATA_LS_5 (9389) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '6', '\0', /* SPI_SHADER_USER_DATA_LS_6 (9415) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '7', '\0', /* SPI_SHADER_USER_DATA_LS_7 (9441) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '8', '\0', /* SPI_SHADER_USER_DATA_LS_8 (9467) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '9', '\0', /* SPI_SHADER_USER_DATA_LS_9 (9493) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '0', '\0', /* SPI_SHADER_USER_DATA_LS_10 (9519) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '1', '\0', /* SPI_SHADER_USER_DATA_LS_11 (9546) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '2', '\0', /* SPI_SHADER_USER_DATA_LS_12 (9573) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '3', '\0', /* SPI_SHADER_USER_DATA_LS_13 (9600) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '4', '\0', /* SPI_SHADER_USER_DATA_LS_14 (9627) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '5', '\0', /* SPI_SHADER_USER_DATA_LS_15 (9654) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'I', 'N', 'I', 'T', 'I', 'A', 'T', 'O', 'R', '\0', /* COMPUTE_DISPATCH_INITIATOR (9681) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'M', '_', 'X', '\0', /* COMPUTE_DIM_X (9708) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'M', '_', 'Y', '\0', /* COMPUTE_DIM_Y (9722) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'M', '_', 'Z', '\0', /* COMPUTE_DIM_Z (9736) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'R', 'T', '_', 'X', '\0', /* COMPUTE_START_X (9750, 9758) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'R', 'T', '_', 'Y', '\0', /* COMPUTE_START_Y (9766, 9774) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'R', 'T', '_', 'Z', '\0', /* COMPUTE_START_Z (9782) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'N', 'U', 'M', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'X', '\0', /* COMPUTE_NUM_THREAD_X (9798) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'N', 'U', 'M', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'Y', '\0', /* COMPUTE_NUM_THREAD_Y (9819) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'N', 'U', 'M', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'Z', '\0', /* COMPUTE_NUM_THREAD_Z (9840) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'P', 'I', 'P', 'E', 'L', 'I', 'N', 'E', 'S', 'T', 'A', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* COMPUTE_PIPELINESTAT_ENABLE (9861, 9869, 9882) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* COMPUTE_PERFCOUNT_ENABLE (9889, 9897) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'P', 'G', 'M', '_', 'L', 'O', '\0', /* COMPUTE_PGM_LO (9914) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'P', 'G', 'M', '_', 'H', 'I', '\0', /* COMPUTE_PGM_HI (9929) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'P', 'K', 'T', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* COMPUTE_DISPATCH_PKT_ADDR_LO (9944, 9965) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'P', 'K', 'T', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* COMPUTE_DISPATCH_PKT_ADDR_HI (9973, 9994) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* COMPUTE_DISPATCH_SCRATCH_BASE_LO (10002) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* COMPUTE_DISPATCH_SCRATCH_BASE_HI (10035, 10060) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '1', '\0', /* COMPUTE_PGM_RSRC1 (10068, 10081) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '2', '\0', /* COMPUTE_PGM_RSRC2 (10086, 10099) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'V', 'M', 'I', 'D', '\0', /* COMPUTE_VMID (10104, 10112, 10114) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'R', 'E', 'S', 'O', 'U', 'R', 'C', 'E', '_', 'L', 'I', 'M', 'I', 'T', 'S', '\0', /* COMPUTE_RESOURCE_LIMITS (10117) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'E', 'S', 'T', 'I', 'N', 'A', 'T', 'I', 'O', 'N', '_', 'E', 'N', '_', 'S', 'E', '0', '\0', /* COMPUTE_DESTINATION_EN_SE0 (10141) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'E', 'S', 'T', 'I', 'N', 'A', 'T', 'I', 'O', 'N', '_', 'E', 'N', '_', 'S', 'E', '1', '\0', /* COMPUTE_DESTINATION_EN_SE1 (10168) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'T', 'M', 'P', 'R', 'I', 'N', 'G', '_', 'S', 'I', 'Z', 'E', '\0', /* COMPUTE_TMPRING_SIZE (10195) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'E', 'S', 'T', 'I', 'N', 'A', 'T', 'I', 'O', 'N', '_', 'E', 'N', '_', 'S', 'E', '2', '\0', /* COMPUTE_DESTINATION_EN_SE2 (10216) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'E', 'S', 'T', 'I', 'N', 'A', 'T', 'I', 'O', 'N', '_', 'E', 'N', '_', 'S', 'E', '3', '\0', /* COMPUTE_DESTINATION_EN_SE3 (10243) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'R', 'E', 'S', 'T', 'A', 'R', 'T', '_', 'X', '\0', /* COMPUTE_RESTART_X (10270) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'R', 'E', 'S', 'T', 'A', 'R', 'T', '_', 'Y', '\0', /* COMPUTE_RESTART_Y (10288) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'R', 'E', 'S', 'T', 'A', 'R', 'T', '_', 'Z', '\0', /* COMPUTE_RESTART_Z (10306) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* COMPUTE_THREAD_TRACE_ENABLE (10324, 10332) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'M', 'I', 'S', 'C', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '\0', /* COMPUTE_MISC_RESERVED (10352, 10365) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'I', 'D', '\0', /* COMPUTE_DISPATCH_ID (10374) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'T', 'H', 'R', 'E', 'A', 'D', 'G', 'R', 'O', 'U', 'P', '_', 'I', 'D', '\0', /* COMPUTE_THREADGROUP_ID (10394) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'R', 'E', 'Q', '_', 'C', 'T', 'R', 'L', '\0', /* COMPUTE_REQ_CTRL (10417) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', '0', '\0', /* COMPUTE_USER_ACCUM_0 (10434) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', '1', '\0', /* COMPUTE_USER_ACCUM_1 (10455) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', '2', '\0', /* COMPUTE_USER_ACCUM_2 (10476) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'A', 'C', 'C', 'U', 'M', '_', '3', '\0', /* COMPUTE_USER_ACCUM_3 (10497) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'P', 'G', 'M', '_', 'R', 'S', 'R', 'C', '3', '\0', /* COMPUTE_PGM_RSRC3 (10518) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'D', 'I', 'D', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* COMPUTE_DDID_INDEX (10536) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'C', 'H', 'K', 'S', 'U', 'M', '\0', /* COMPUTE_SHADER_CHKSUM (10555) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'R', 'E', 'L', 'A', 'U', 'N', 'C', 'H', '\0', /* COMPUTE_RELAUNCH (10577) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'W', 'A', 'V', 'E', '_', 'R', 'E', 'S', 'T', 'O', 'R', 'E', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* COMPUTE_WAVE_RESTORE_ADDR_LO (10594) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'W', 'A', 'V', 'E', '_', 'R', 'E', 'S', 'T', 'O', 'R', 'E', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* COMPUTE_WAVE_RESTORE_ADDR_HI (10623) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'R', 'E', 'L', 'A', 'U', 'N', 'C', 'H', '2', '\0', /* COMPUTE_RELAUNCH2 (10652) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '0', '\0', /* COMPUTE_USER_DATA_0 (10670) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '1', '\0', /* COMPUTE_USER_DATA_1 (10690) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '2', '\0', /* COMPUTE_USER_DATA_2 (10710) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '3', '\0', /* COMPUTE_USER_DATA_3 (10730) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '4', '\0', /* COMPUTE_USER_DATA_4 (10750) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '5', '\0', /* COMPUTE_USER_DATA_5 (10770) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '6', '\0', /* COMPUTE_USER_DATA_6 (10790) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '7', '\0', /* COMPUTE_USER_DATA_7 (10810) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '8', '\0', /* COMPUTE_USER_DATA_8 (10830) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '9', '\0', /* COMPUTE_USER_DATA_9 (10850) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '1', '0', '\0', /* COMPUTE_USER_DATA_10 (10870) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '1', '1', '\0', /* COMPUTE_USER_DATA_11 (10891) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '1', '2', '\0', /* COMPUTE_USER_DATA_12 (10912) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '1', '3', '\0', /* COMPUTE_USER_DATA_13 (10933) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '1', '4', '\0', /* COMPUTE_USER_DATA_14 (10954) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', '1', '5', '\0', /* COMPUTE_USER_DATA_15 (10975) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'T', 'U', 'N', 'N', 'E', 'L', '\0', /* COMPUTE_DISPATCH_TUNNEL (10996) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'E', 'N', 'D', '\0', /* COMPUTE_DISPATCH_END (11020) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'N', 'O', 'W', 'H', 'E', 'R', 'E', '\0', /* COMPUTE_NOWHERE (11041, 11049) */
	'D', 'B', '_', 'R', 'E', 'N', 'D', 'E', 'R', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* DB_RENDER_CONTROL (11057) */
	'D', 'B', '_', 'C', 'O', 'U', 'N', 'T', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* DB_COUNT_CONTROL (11075) */
	'D', 'B', '_', 'D', 'E', 'P', 'T', 'H', '_', 'V', 'I', 'E', 'W', '\0', /* DB_DEPTH_VIEW (11092) */
	'D', 'B', '_', 'R', 'E', 'N', 'D', 'E', 'R', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* DB_RENDER_OVERRIDE (11106) */
	'D', 'B', '_', 'R', 'E', 'N', 'D', 'E', 'R', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '2', '\0', /* DB_RENDER_OVERRIDE2 (11125) */
	'D', 'B', '_', 'H', 'T', 'I', 'L', 'E', '_', 'D', 'A', 'T', 'A', '_', 'B', 'A', 'S', 'E', '\0', /* DB_HTILE_DATA_BASE (11145) */
	'D', 'B', '_', 'D', 'E', 'P', 'T', 'H', '_', 'S', 'I', 'Z', 'E', '_', 'X', 'Y', '\0', /* DB_DEPTH_SIZE_XY (11164) */
	'D', 'B', '_', 'D', 'E', 'P', 'T', 'H', '_', 'B', 'O', 'U', 'N', 'D', 'S', '_', 'M', 'I', 'N', '\0', /* DB_DEPTH_BOUNDS_MIN (11181, 11197) */
	'D', 'B', '_', 'D', 'E', 'P', 'T', 'H', '_', 'B', 'O', 'U', 'N', 'D', 'S', '_', 'M', 'A', 'X', '\0', /* DB_DEPTH_BOUNDS_MAX (11201, 11217) */
	'D', 'B', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'C', 'L', 'E', 'A', 'R', '\0', /* DB_STENCIL_CLEAR (11221, 11232) */
	'D', 'B', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'L', 'E', 'A', 'R', '\0', /* DB_DEPTH_CLEAR (11238) */
	'P', 'A', '_', 'S', 'C', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', 'T', 'L', '\0', /* PA_SC_SCREEN_SCISSOR_TL (11253) */
	'P', 'A', '_', 'S', 'C', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', 'B', 'R', '\0', /* PA_SC_SCREEN_SCISSOR_BR (11277) */
	'D', 'B', '_', 'D', 'F', 'S', 'M', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* DB_DFSM_CONTROL (11301) */
	'D', 'B', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'E', 'G', '_', '2', '\0', /* DB_RESERVED_REG_2 (11317) */
	'D', 'B', '_', 'Z', '_', 'I', 'N', 'F', 'O', '\0', /* DB_Z_INFO (11335) */
	'D', 'B', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'I', 'N', 'F', 'O', '\0', /* DB_STENCIL_INFO (11345) */
	'D', 'B', '_', 'Z', '_', 'R', 'E', 'A', 'D', '_', 'B', 'A', 'S', 'E', '\0', /* DB_Z_READ_BASE (11361) */
	'D', 'B', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'R', 'E', 'A', 'D', '_', 'B', 'A', 'S', 'E', '\0', /* DB_STENCIL_READ_BASE (11376) */
	'D', 'B', '_', 'Z', '_', 'W', 'R', 'I', 'T', 'E', '_', 'B', 'A', 'S', 'E', '\0', /* DB_Z_WRITE_BASE (11397) */
	'D', 'B', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'W', 'R', 'I', 'T', 'E', '_', 'B', 'A', 'S', 'E', '\0', /* DB_STENCIL_WRITE_BASE (11413) */
	'D', 'B', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'E', 'G', '_', '1', '\0', /* DB_RESERVED_REG_1 (11435) */
	'D', 'B', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'E', 'G', '_', '3', '\0', /* DB_RESERVED_REG_3 (11453) */
	'D', 'B', '_', 'Z', '_', 'R', 'E', 'A', 'D', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* DB_Z_READ_BASE_HI (11471) */
	'D', 'B', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'R', 'E', 'A', 'D', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* DB_STENCIL_READ_BASE_HI (11489) */
	'D', 'B', '_', 'Z', '_', 'W', 'R', 'I', 'T', 'E', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* DB_Z_WRITE_BASE_HI (11513) */
	'D', 'B', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'W', 'R', 'I', 'T', 'E', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* DB_STENCIL_WRITE_BASE_HI (11532) */
	'D', 'B', '_', 'H', 'T', 'I', 'L', 'E', '_', 'D', 'A', 'T', 'A', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* DB_HTILE_DATA_BASE_HI (11557) */
	'D', 'B', '_', 'R', 'M', 'I', '_', 'L', '2', '_', 'C', 'A', 'C', 'H', 'E', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* DB_RMI_L2_CACHE_CONTROL (11579, 11589) */
	'T', 'A', '_', 'B', 'C', '_', 'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', '\0', /* TA_BC_BASE_ADDR (11603, 11609, 11614) */
	'T', 'A', '_', 'B', 'C', '_', 'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* TA_BC_BASE_ADDR_HI (11619) */
	'C', 'O', 'H', 'E', 'R', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '_', '0', '\0', /* COHER_DEST_BASE_HI_0 (11638) */
	'C', 'O', 'H', 'E', 'R', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '_', '1', '\0', /* COHER_DEST_BASE_HI_1 (11659) */
	'C', 'O', 'H', 'E', 'R', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '_', '2', '\0', /* COHER_DEST_BASE_HI_2 (11680) */
	'C', 'O', 'H', 'E', 'R', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '_', '3', '\0', /* COHER_DEST_BASE_HI_3 (11701) */
	'C', 'O', 'H', 'E', 'R', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', '2', '\0', /* COHER_DEST_BASE_2 (11722) */
	'C', 'O', 'H', 'E', 'R', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', '3', '\0', /* COHER_DEST_BASE_3 (11740) */
	'P', 'A', '_', 'S', 'C', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* PA_SC_WINDOW_OFFSET (11758, 11769) */
	'P', 'A', '_', 'S', 'C', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', 'T', 'L', '\0', /* PA_SC_WINDOW_SCISSOR_TL (11778) */
	'P', 'A', '_', 'S', 'C', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', 'B', 'R', '\0', /* PA_SC_WINDOW_SCISSOR_BR (11802) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'L', 'I', 'P', 'R', 'E', 'C', 'T', '_', 'R', 'U', 'L', 'E', '\0', /* PA_SC_CLIPRECT_RULE (11826) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'L', 'I', 'P', 'R', 'E', 'C', 'T', '_', '0', '_', 'T', 'L', '\0', /* PA_SC_CLIPRECT_0_TL (11846) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'L', 'I', 'P', 'R', 'E', 'C', 'T', '_', '0', '_', 'B', 'R', '\0', /* PA_SC_CLIPRECT_0_BR (11866) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'L', 'I', 'P', 'R', 'E', 'C', 'T', '_', '1', '_', 'T', 'L', '\0', /* PA_SC_CLIPRECT_1_TL (11886) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'L', 'I', 'P', 'R', 'E', 'C', 'T', '_', '1', '_', 'B', 'R', '\0', /* PA_SC_CLIPRECT_1_BR (11906) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'L', 'I', 'P', 'R', 'E', 'C', 'T', '_', '2', '_', 'T', 'L', '\0', /* PA_SC_CLIPRECT_2_TL (11926) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'L', 'I', 'P', 'R', 'E', 'C', 'T', '_', '2', '_', 'B', 'R', '\0', /* PA_SC_CLIPRECT_2_BR (11946) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'L', 'I', 'P', 'R', 'E', 'C', 'T', '_', '3', '_', 'T', 'L', '\0', /* PA_SC_CLIPRECT_3_TL (11966) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'L', 'I', 'P', 'R', 'E', 'C', 'T', '_', '3', '_', 'B', 'R', '\0', /* PA_SC_CLIPRECT_3_BR (11986) */
	'P', 'A', '_', 'S', 'C', '_', 'E', 'D', 'G', 'E', 'R', 'U', 'L', 'E', '\0', /* PA_SC_EDGERULE (12006) */
	'P', 'A', '_', 'S', 'U', '_', 'H', 'A', 'R', 'D', 'W', 'A', 'R', 'E', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* PA_SU_HARDWARE_SCREEN_OFFSET (12021) */
	'C', 'B', '_', 'T', 'A', 'R', 'G', 'E', 'T', '_', 'M', 'A', 'S', 'K', '\0', /* CB_TARGET_MASK (12050) */
	'C', 'B', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'M', 'A', 'S', 'K', '\0', /* CB_SHADER_MASK (12065) */
	'P', 'A', '_', 'S', 'C', '_', 'G', 'E', 'N', 'E', 'R', 'I', 'C', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', 'T', 'L', '\0', /* PA_SC_GENERIC_SCISSOR_TL (12080) */
	'P', 'A', '_', 'S', 'C', '_', 'G', 'E', 'N', 'E', 'R', 'I', 'C', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', 'B', 'R', '\0', /* PA_SC_GENERIC_SCISSOR_BR (12105) */
	'C', 'O', 'H', 'E', 'R', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', '0', '\0', /* COHER_DEST_BASE_0 (12130) */
	'C', 'O', 'H', 'E', 'R', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', '1', '\0', /* COHER_DEST_BASE_1 (12148) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '0', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_0_TL (12166) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '0', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_0_BR (12191) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_1_TL (12216) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_1_BR (12241) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '2', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_2_TL (12266) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '2', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_2_BR (12291) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '3', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_3_TL (12316) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '3', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_3_BR (12341) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '4', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_4_TL (12366) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '4', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_4_BR (12391) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '5', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_5_TL (12416) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '5', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_5_BR (12441) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '6', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_6_TL (12466) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '6', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_6_BR (12491) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '7', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_7_TL (12516) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '7', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_7_BR (12541) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '8', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_8_TL (12566) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '8', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_8_BR (12591) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '9', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_9_TL (12616) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '9', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_9_BR (12641) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '0', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_10_TL (12666) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '0', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_10_BR (12692) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '1', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_11_TL (12718) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '1', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_11_BR (12744) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '2', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_12_TL (12770) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '2', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_12_BR (12796) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '3', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_13_TL (12822) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '3', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_13_BR (12848) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '4', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_14_TL (12874) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '4', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_14_BR (12900) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '5', '_', 'T', 'L', '\0', /* PA_SC_VPORT_SCISSOR_15_TL (12926) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', '1', '5', '_', 'B', 'R', '\0', /* PA_SC_VPORT_SCISSOR_15_BR (12952) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '0', '\0', /* PA_SC_VPORT_ZMIN_0 (12978, 12992) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '0', '\0', /* PA_SC_VPORT_ZMAX_0 (12997) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '1', '\0', /* PA_SC_VPORT_ZMIN_1 (13016, 13030) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '1', '\0', /* PA_SC_VPORT_ZMAX_1 (13035) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '2', '\0', /* PA_SC_VPORT_ZMIN_2 (13054, 13068) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '2', '\0', /* PA_SC_VPORT_ZMAX_2 (13073) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '3', '\0', /* PA_SC_VPORT_ZMIN_3 (13092, 13106) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '3', '\0', /* PA_SC_VPORT_ZMAX_3 (13111) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '4', '\0', /* PA_SC_VPORT_ZMIN_4 (13130) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '4', '\0', /* PA_SC_VPORT_ZMAX_4 (13149) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '5', '\0', /* PA_SC_VPORT_ZMIN_5 (13168) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '5', '\0', /* PA_SC_VPORT_ZMAX_5 (13187) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '6', '\0', /* PA_SC_VPORT_ZMIN_6 (13206) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '6', '\0', /* PA_SC_VPORT_ZMAX_6 (13225) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '7', '\0', /* PA_SC_VPORT_ZMIN_7 (13244) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '7', '\0', /* PA_SC_VPORT_ZMAX_7 (13263) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '8', '\0', /* PA_SC_VPORT_ZMIN_8 (13282) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '8', '\0', /* PA_SC_VPORT_ZMAX_8 (13301) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '9', '\0', /* PA_SC_VPORT_ZMIN_9 (13320) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '9', '\0', /* PA_SC_VPORT_ZMAX_9 (13339) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '1', '0', '\0', /* PA_SC_VPORT_ZMIN_10 (13358, 13372) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '1', '0', '\0', /* PA_SC_VPORT_ZMAX_10 (13378) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '1', '1', '\0', /* PA_SC_VPORT_ZMIN_11 (13398) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '1', '1', '\0', /* PA_SC_VPORT_ZMAX_11 (13418) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '1', '2', '\0', /* PA_SC_VPORT_ZMIN_12 (13438) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '1', '2', '\0', /* PA_SC_VPORT_ZMAX_12 (13458) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '1', '3', '\0', /* PA_SC_VPORT_ZMIN_13 (13478) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '1', '3', '\0', /* PA_SC_VPORT_ZMAX_13 (13498) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '1', '4', '\0', /* PA_SC_VPORT_ZMIN_14 (13518) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '1', '4', '\0', /* PA_SC_VPORT_ZMAX_14 (13538) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'I', 'N', '_', '1', '5', '\0', /* PA_SC_VPORT_ZMIN_15 (13558) */
	'P', 'A', '_', 'S', 'C', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'M', 'A', 'X', '_', '1', '5', '\0', /* PA_SC_VPORT_ZMAX_15 (13578) */
	'P', 'A', '_', 'S', 'C', '_', 'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* PA_SC_RASTER_CONFIG (13598) */
	'P', 'A', '_', 'S', 'C', '_', 'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', '1', '\0', /* PA_SC_RASTER_CONFIG_1 (13618) */
	'P', 'A', '_', 'S', 'C', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'E', 'X', 'T', 'E', 'N', 'T', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* PA_SC_SCREEN_EXTENT_CONTROL (13640) */
	'P', 'A', '_', 'S', 'C', '_', 'T', 'I', 'L', 'E', '_', 'S', 'T', 'E', 'E', 'R', 'I', 'N', 'G', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* PA_SC_TILE_STEERING_OVERRIDE (13668) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'C', 'N', 'T', 'X', '_', 'C', 'N', 'T', 'L', '\0', /* CP_PERFMON_CNTX_CNTL (13697) */
	'C', 'P', '_', 'P', 'I', 'P', 'E', 'I', 'D', '\0', /* CP_PIPEID (13718) */
	'C', 'P', '_', 'V', 'M', 'I', 'D', '\0', /* CP_VMID (13728) */
	'P', 'A', '_', 'S', 'C', '_', 'R', 'I', 'G', 'H', 'T', '_', 'V', 'E', 'R', 'T', '_', 'G', 'R', 'I', 'D', '\0', /* PA_SC_RIGHT_VERT_GRID (13736) */
	'P', 'A', '_', 'S', 'C', '_', 'L', 'E', 'F', 'T', '_', 'V', 'E', 'R', 'T', '_', 'G', 'R', 'I', 'D', '\0', /* PA_SC_LEFT_VERT_GRID (13758) */
	'P', 'A', '_', 'S', 'C', '_', 'H', 'O', 'R', 'I', 'Z', '_', 'G', 'R', 'I', 'D', '\0', /* PA_SC_HORIZ_GRID (13779) */
	'V', 'G', 'T', '_', 'M', 'A', 'X', '_', 'V', 'T', 'X', '_', 'I', 'N', 'D', 'X', '\0', /* VGT_MAX_VTX_INDX (13796) */
	'V', 'G', 'T', '_', 'M', 'I', 'N', '_', 'V', 'T', 'X', '_', 'I', 'N', 'D', 'X', '\0', /* VGT_MIN_VTX_INDX (13813) */
	'V', 'G', 'T', '_', 'I', 'N', 'D', 'X', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* VGT_INDX_OFFSET (13830, 13837) */
	'V', 'G', 'T', '_', 'M', 'U', 'L', 'T', 'I', '_', 'P', 'R', 'I', 'M', '_', 'I', 'B', '_', 'R', 'E', 'S', 'E', 'T', '_', 'I', 'N', 'D', 'X', '\0', /* VGT_MULTI_PRIM_IB_RESET_INDX (13846) */
	'C', 'B', '_', 'R', 'M', 'I', '_', 'G', 'L', '2', '_', 'C', 'A', 'C', 'H', 'E', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_RMI_GL2_CACHE_CONTROL (13875) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '_', 'R', 'E', 'D', '\0', /* CB_BLEND_RED (13900) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '_', 'G', 'R', 'E', 'E', 'N', '\0', /* CB_BLEND_GREEN (13913, 13925) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '_', 'B', 'L', 'U', 'E', '\0', /* CB_BLEND_BLUE (13928) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* CB_BLEND_ALPHA (13942) */
	'C', 'B', '_', 'D', 'C', 'C', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_DCC_CONTROL (13957) */
	'C', 'B', '_', 'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'O', 'U', 'T', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_COVERAGE_OUT_CONTROL (13972) */
	'D', 'B', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* DB_STENCIL_CONTROL (13996) */
	'D', 'B', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', 'R', 'E', 'F', 'M', 'A', 'S', 'K', '\0', /* DB_STENCILREFMASK (14015) */
	'D', 'B', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', 'R', 'E', 'F', 'M', 'A', 'S', 'K', '_', 'B', 'F', '\0', /* DB_STENCILREFMASK_BF (14033) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '\0', /* PA_CL_VPORT_XSCALE (14054) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* PA_CL_VPORT_XOFFSET (14073) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '\0', /* PA_CL_VPORT_YSCALE (14093) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* PA_CL_VPORT_YOFFSET (14112) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '\0', /* PA_CL_VPORT_ZSCALE (14132) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* PA_CL_VPORT_ZOFFSET (14151) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '1', '\0', /* PA_CL_VPORT_XSCALE_1 (14171) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '\0', /* PA_CL_VPORT_XOFFSET_1 (14192) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '1', '\0', /* PA_CL_VPORT_YSCALE_1 (14214) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '\0', /* PA_CL_VPORT_YOFFSET_1 (14235) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '1', '\0', /* PA_CL_VPORT_ZSCALE_1 (14257) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '\0', /* PA_CL_VPORT_ZOFFSET_1 (14278) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '2', '\0', /* PA_CL_VPORT_XSCALE_2 (14300) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '2', '\0', /* PA_CL_VPORT_XOFFSET_2 (14321) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '2', '\0', /* PA_CL_VPORT_YSCALE_2 (14343) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '2', '\0', /* PA_CL_VPORT_YOFFSET_2 (14364) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '2', '\0', /* PA_CL_VPORT_ZSCALE_2 (14386) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '2', '\0', /* PA_CL_VPORT_ZOFFSET_2 (14407) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '3', '\0', /* PA_CL_VPORT_XSCALE_3 (14429) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '3', '\0', /* PA_CL_VPORT_XOFFSET_3 (14450) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '3', '\0', /* PA_CL_VPORT_YSCALE_3 (14472) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '3', '\0', /* PA_CL_VPORT_YOFFSET_3 (14493) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '3', '\0', /* PA_CL_VPORT_ZSCALE_3 (14515) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '3', '\0', /* PA_CL_VPORT_ZOFFSET_3 (14536) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '4', '\0', /* PA_CL_VPORT_XSCALE_4 (14558) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '4', '\0', /* PA_CL_VPORT_XOFFSET_4 (14579) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '4', '\0', /* PA_CL_VPORT_YSCALE_4 (14601) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '4', '\0', /* PA_CL_VPORT_YOFFSET_4 (14622) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '4', '\0', /* PA_CL_VPORT_ZSCALE_4 (14644) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '4', '\0', /* PA_CL_VPORT_ZOFFSET_4 (14665) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '5', '\0', /* PA_CL_VPORT_XSCALE_5 (14687) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '5', '\0', /* PA_CL_VPORT_XOFFSET_5 (14708) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '5', '\0', /* PA_CL_VPORT_YSCALE_5 (14730) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '5', '\0', /* PA_CL_VPORT_YOFFSET_5 (14751) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '5', '\0', /* PA_CL_VPORT_ZSCALE_5 (14773) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '5', '\0', /* PA_CL_VPORT_ZOFFSET_5 (14794) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '6', '\0', /* PA_CL_VPORT_XSCALE_6 (14816) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '6', '\0', /* PA_CL_VPORT_XOFFSET_6 (14837) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '6', '\0', /* PA_CL_VPORT_YSCALE_6 (14859) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '6', '\0', /* PA_CL_VPORT_YOFFSET_6 (14880) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '6', '\0', /* PA_CL_VPORT_ZSCALE_6 (14902) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '6', '\0', /* PA_CL_VPORT_ZOFFSET_6 (14923) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '7', '\0', /* PA_CL_VPORT_XSCALE_7 (14945) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '7', '\0', /* PA_CL_VPORT_XOFFSET_7 (14966) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '7', '\0', /* PA_CL_VPORT_YSCALE_7 (14988) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '7', '\0', /* PA_CL_VPORT_YOFFSET_7 (15009) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '7', '\0', /* PA_CL_VPORT_ZSCALE_7 (15031) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '7', '\0', /* PA_CL_VPORT_ZOFFSET_7 (15052) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '8', '\0', /* PA_CL_VPORT_XSCALE_8 (15074) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '8', '\0', /* PA_CL_VPORT_XOFFSET_8 (15095) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '8', '\0', /* PA_CL_VPORT_YSCALE_8 (15117) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '8', '\0', /* PA_CL_VPORT_YOFFSET_8 (15138) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '8', '\0', /* PA_CL_VPORT_ZSCALE_8 (15160) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '8', '\0', /* PA_CL_VPORT_ZOFFSET_8 (15181) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '9', '\0', /* PA_CL_VPORT_XSCALE_9 (15203) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '9', '\0', /* PA_CL_VPORT_XOFFSET_9 (15224) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '9', '\0', /* PA_CL_VPORT_YSCALE_9 (15246) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '9', '\0', /* PA_CL_VPORT_YOFFSET_9 (15267) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '9', '\0', /* PA_CL_VPORT_ZSCALE_9 (15289) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '9', '\0', /* PA_CL_VPORT_ZOFFSET_9 (15310) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '1', '0', '\0', /* PA_CL_VPORT_XSCALE_10 (15332) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '0', '\0', /* PA_CL_VPORT_XOFFSET_10 (15354) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '1', '0', '\0', /* PA_CL_VPORT_YSCALE_10 (15377) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '0', '\0', /* PA_CL_VPORT_YOFFSET_10 (15399) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '1', '0', '\0', /* PA_CL_VPORT_ZSCALE_10 (15422) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '0', '\0', /* PA_CL_VPORT_ZOFFSET_10 (15444) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '1', '1', '\0', /* PA_CL_VPORT_XSCALE_11 (15467) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '1', '\0', /* PA_CL_VPORT_XOFFSET_11 (15489) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '1', '1', '\0', /* PA_CL_VPORT_YSCALE_11 (15512) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '1', '\0', /* PA_CL_VPORT_YOFFSET_11 (15534) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '1', '1', '\0', /* PA_CL_VPORT_ZSCALE_11 (15557) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '1', '\0', /* PA_CL_VPORT_ZOFFSET_11 (15579) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '1', '2', '\0', /* PA_CL_VPORT_XSCALE_12 (15602) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '2', '\0', /* PA_CL_VPORT_XOFFSET_12 (15624) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '1', '2', '\0', /* PA_CL_VPORT_YSCALE_12 (15647) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '2', '\0', /* PA_CL_VPORT_YOFFSET_12 (15669) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '1', '2', '\0', /* PA_CL_VPORT_ZSCALE_12 (15692) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '2', '\0', /* PA_CL_VPORT_ZOFFSET_12 (15714) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '1', '3', '\0', /* PA_CL_VPORT_XSCALE_13 (15737) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '3', '\0', /* PA_CL_VPORT_XOFFSET_13 (15759) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '1', '3', '\0', /* PA_CL_VPORT_YSCALE_13 (15782) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '3', '\0', /* PA_CL_VPORT_YOFFSET_13 (15804) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '1', '3', '\0', /* PA_CL_VPORT_ZSCALE_13 (15827) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '3', '\0', /* PA_CL_VPORT_ZOFFSET_13 (15849) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '1', '4', '\0', /* PA_CL_VPORT_XSCALE_14 (15872) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '4', '\0', /* PA_CL_VPORT_XOFFSET_14 (15894) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '1', '4', '\0', /* PA_CL_VPORT_YSCALE_14 (15917) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '4', '\0', /* PA_CL_VPORT_YOFFSET_14 (15939) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '1', '4', '\0', /* PA_CL_VPORT_ZSCALE_14 (15962) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '4', '\0', /* PA_CL_VPORT_ZOFFSET_14 (15984) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'S', 'C', 'A', 'L', 'E', '_', '1', '5', '\0', /* PA_CL_VPORT_XSCALE_15 (16007) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'X', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '5', '\0', /* PA_CL_VPORT_XOFFSET_15 (16029) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'S', 'C', 'A', 'L', 'E', '_', '1', '5', '\0', /* PA_CL_VPORT_YSCALE_15 (16052) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Y', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '5', '\0', /* PA_CL_VPORT_YOFFSET_15 (16074) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'S', 'C', 'A', 'L', 'E', '_', '1', '5', '\0', /* PA_CL_VPORT_ZSCALE_15 (16097) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'P', 'O', 'R', 'T', '_', 'Z', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '5', '\0', /* PA_CL_VPORT_ZOFFSET_15 (16119) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '0', '_', 'X', '\0', /* PA_CL_UCP_0_X (16142) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '0', '_', 'Y', '\0', /* PA_CL_UCP_0_Y (16156) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '0', '_', 'Z', '\0', /* PA_CL_UCP_0_Z (16170) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '0', '_', 'W', '\0', /* PA_CL_UCP_0_W (16184) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '1', '_', 'X', '\0', /* PA_CL_UCP_1_X (16198) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '1', '_', 'Y', '\0', /* PA_CL_UCP_1_Y (16212) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '1', '_', 'Z', '\0', /* PA_CL_UCP_1_Z (16226) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '1', '_', 'W', '\0', /* PA_CL_UCP_1_W (16240) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '2', '_', 'X', '\0', /* PA_CL_UCP_2_X (16254) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '2', '_', 'Y', '\0', /* PA_CL_UCP_2_Y (16268) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '2', '_', 'Z', '\0', /* PA_CL_UCP_2_Z (16282) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '2', '_', 'W', '\0', /* PA_CL_UCP_2_W (16296) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '3', '_', 'X', '\0', /* PA_CL_UCP_3_X (16310) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '3', '_', 'Y', '\0', /* PA_CL_UCP_3_Y (16324) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '3', '_', 'Z', '\0', /* PA_CL_UCP_3_Z (16338) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '3', '_', 'W', '\0', /* PA_CL_UCP_3_W (16352) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '4', '_', 'X', '\0', /* PA_CL_UCP_4_X (16366) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '4', '_', 'Y', '\0', /* PA_CL_UCP_4_Y (16380) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '4', '_', 'Z', '\0', /* PA_CL_UCP_4_Z (16394) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '4', '_', 'W', '\0', /* PA_CL_UCP_4_W (16408) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '5', '_', 'X', '\0', /* PA_CL_UCP_5_X (16422) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '5', '_', 'Y', '\0', /* PA_CL_UCP_5_Y (16436) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '5', '_', 'Z', '\0', /* PA_CL_UCP_5_Z (16450) */
	'P', 'A', '_', 'C', 'L', '_', 'U', 'C', 'P', '_', '5', '_', 'W', '\0', /* PA_CL_UCP_5_W (16464) */
	'P', 'A', '_', 'C', 'L', '_', 'P', 'R', 'O', 'G', '_', 'N', 'E', 'A', 'R', '_', 'C', 'L', 'I', 'P', '_', 'Z', '\0', /* PA_CL_PROG_NEAR_CLIP_Z (16478) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '0', '\0', /* SPI_PS_INPUT_CNTL_0 (16501) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '\0', /* SPI_PS_INPUT_CNTL_1 (16521) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '\0', /* SPI_PS_INPUT_CNTL_2 (16541) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '3', '\0', /* SPI_PS_INPUT_CNTL_3 (16561) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '4', '\0', /* SPI_PS_INPUT_CNTL_4 (16581) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '5', '\0', /* SPI_PS_INPUT_CNTL_5 (16601) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '6', '\0', /* SPI_PS_INPUT_CNTL_6 (16621) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '7', '\0', /* SPI_PS_INPUT_CNTL_7 (16641) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '8', '\0', /* SPI_PS_INPUT_CNTL_8 (16661) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '9', '\0', /* SPI_PS_INPUT_CNTL_9 (16681) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '0', '\0', /* SPI_PS_INPUT_CNTL_10 (16701) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '1', '\0', /* SPI_PS_INPUT_CNTL_11 (16722) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '2', '\0', /* SPI_PS_INPUT_CNTL_12 (16743) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '3', '\0', /* SPI_PS_INPUT_CNTL_13 (16764) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '4', '\0', /* SPI_PS_INPUT_CNTL_14 (16785) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '5', '\0', /* SPI_PS_INPUT_CNTL_15 (16806) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '6', '\0', /* SPI_PS_INPUT_CNTL_16 (16827) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '7', '\0', /* SPI_PS_INPUT_CNTL_17 (16848) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '8', '\0', /* SPI_PS_INPUT_CNTL_18 (16869) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '1', '9', '\0', /* SPI_PS_INPUT_CNTL_19 (16890) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '0', '\0', /* SPI_PS_INPUT_CNTL_20 (16911) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '1', '\0', /* SPI_PS_INPUT_CNTL_21 (16932) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '2', '\0', /* SPI_PS_INPUT_CNTL_22 (16953) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '3', '\0', /* SPI_PS_INPUT_CNTL_23 (16974) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '4', '\0', /* SPI_PS_INPUT_CNTL_24 (16995) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '5', '\0', /* SPI_PS_INPUT_CNTL_25 (17016) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '6', '\0', /* SPI_PS_INPUT_CNTL_26 (17037) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '7', '\0', /* SPI_PS_INPUT_CNTL_27 (17058) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '8', '\0', /* SPI_PS_INPUT_CNTL_28 (17079) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '2', '9', '\0', /* SPI_PS_INPUT_CNTL_29 (17100) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '3', '0', '\0', /* SPI_PS_INPUT_CNTL_30 (17121) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'N', 'T', 'L', '_', '3', '1', '\0', /* SPI_PS_INPUT_CNTL_31 (17142) */
	'S', 'P', 'I', '_', 'V', 'S', '_', 'O', 'U', 'T', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* SPI_VS_OUT_CONFIG (17163) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'E', 'N', 'A', '\0', /* SPI_PS_INPUT_ENA (17181) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', 'P', 'U', 'T', '_', 'A', 'D', 'D', 'R', '\0', /* SPI_PS_INPUT_ADDR (17198) */
	'S', 'P', 'I', '_', 'I', 'N', 'T', 'E', 'R', 'P', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '_', '0', '\0', /* SPI_INTERP_CONTROL_0 (17216) */
	'S', 'P', 'I', '_', 'P', 'S', '_', 'I', 'N', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* SPI_PS_IN_CONTROL (17237) */
	'S', 'P', 'I', '_', 'B', 'A', 'R', 'Y', 'C', '_', 'C', 'N', 'T', 'L', '\0', /* SPI_BARYC_CNTL (17255) */
	'S', 'P', 'I', '_', 'T', 'M', 'P', 'R', 'I', 'N', 'G', '_', 'S', 'I', 'Z', 'E', '\0', /* SPI_TMPRING_SIZE (17270) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'I', 'D', 'X', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* SPI_SHADER_IDX_FORMAT (17287, 17302) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'P', 'O', 'S', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* SPI_SHADER_POS_FORMAT (17309) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'Z', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* SPI_SHADER_Z_FORMAT (17331) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'C', 'O', 'L', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* SPI_SHADER_COL_FORMAT (17351) */
	'S', 'X', '_', 'P', 'S', '_', 'D', 'O', 'W', 'N', 'C', 'O', 'N', 'V', 'E', 'R', 'T', '\0', /* SX_PS_DOWNCONVERT (17373) */
	'S', 'X', '_', 'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'E', 'P', 'S', 'I', 'L', 'O', 'N', '\0', /* SX_BLEND_OPT_EPSILON (17391) */
	'S', 'X', '_', 'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* SX_BLEND_OPT_CONTROL (17412) */
	'S', 'X', '_', 'M', 'R', 'T', '0', '_', 'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '\0', /* SX_MRT0_BLEND_OPT (17433) */
	'S', 'X', '_', 'M', 'R', 'T', '1', '_', 'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '\0', /* SX_MRT1_BLEND_OPT (17451) */
	'S', 'X', '_', 'M', 'R', 'T', '2', '_', 'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '\0', /* SX_MRT2_BLEND_OPT (17469) */
	'S', 'X', '_', 'M', 'R', 'T', '3', '_', 'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '\0', /* SX_MRT3_BLEND_OPT (17487) */
	'S', 'X', '_', 'M', 'R', 'T', '4', '_', 'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '\0', /* SX_MRT4_BLEND_OPT (17505) */
	'S', 'X', '_', 'M', 'R', 'T', '5', '_', 'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '\0', /* SX_MRT5_BLEND_OPT (17523) */
	'S', 'X', '_', 'M', 'R', 'T', '6', '_', 'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '\0', /* SX_MRT6_BLEND_OPT (17541) */
	'S', 'X', '_', 'M', 'R', 'T', '7', '_', 'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '\0', /* SX_MRT7_BLEND_OPT (17559) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '0', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_BLEND0_CONTROL (17577) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '1', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_BLEND1_CONTROL (17595) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '2', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_BLEND2_CONTROL (17613) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '3', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_BLEND3_CONTROL (17631) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '4', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_BLEND4_CONTROL (17649) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '5', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_BLEND5_CONTROL (17667) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '6', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_BLEND6_CONTROL (17685) */
	'C', 'B', '_', 'B', 'L', 'E', 'N', 'D', '7', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_BLEND7_CONTROL (17703) */
	'C', 'S', '_', 'C', 'O', 'P', 'Y', '_', 'S', 'T', 'A', 'T', 'E', '\0', /* CS_COPY_STATE (17721) */
	'G', 'F', 'X', '_', 'C', 'O', 'P', 'Y', '_', 'S', 'T', 'A', 'T', 'E', '\0', /* GFX_COPY_STATE (17735) */
	'P', 'A', '_', 'C', 'L', '_', 'P', 'O', 'I', 'N', 'T', '_', 'X', '_', 'R', 'A', 'D', '\0', /* PA_CL_POINT_X_RAD (17750) */
	'P', 'A', '_', 'C', 'L', '_', 'P', 'O', 'I', 'N', 'T', '_', 'Y', '_', 'R', 'A', 'D', '\0', /* PA_CL_POINT_Y_RAD (17768) */
	'P', 'A', '_', 'C', 'L', '_', 'P', 'O', 'I', 'N', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* PA_CL_POINT_SIZE (17786) */
	'P', 'A', '_', 'C', 'L', '_', 'P', 'O', 'I', 'N', 'T', '_', 'C', 'U', 'L', 'L', '_', 'R', 'A', 'D', '\0', /* PA_CL_POINT_CULL_RAD (17803) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* VGT_DMA_BASE_HI (17824) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'B', 'A', 'S', 'E', '\0', /* VGT_DMA_BASE (17840) */
	'V', 'G', 'T', '_', 'D', 'R', 'A', 'W', '_', 'I', 'N', 'I', 'T', 'I', 'A', 'T', 'O', 'R', '\0', /* VGT_DRAW_INITIATOR (17853) */
	'V', 'G', 'T', '_', 'I', 'M', 'M', 'E', 'D', '_', 'D', 'A', 'T', 'A', '\0', /* VGT_IMMED_DATA (17872) */
	'V', 'G', 'T', '_', 'E', 'V', 'E', 'N', 'T', '_', 'A', 'D', 'D', 'R', 'E', 'S', 'S', '_', 'R', 'E', 'G', '\0', /* VGT_EVENT_ADDRESS_REG (17887) */
	'G', 'E', '_', 'M', 'A', 'X', '_', 'O', 'U', 'T', 'P', 'U', 'T', '_', 'P', 'E', 'R', '_', 'S', 'U', 'B', 'G', 'R', 'O', 'U', 'P', '\0', /* GE_MAX_OUTPUT_PER_SUBGROUP (17909) */
	'D', 'B', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* DB_DEPTH_CONTROL (17936) */
	'D', 'B', '_', 'E', 'Q', 'A', 'A', '\0', /* DB_EQAA (17953) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_COLOR_CONTROL (17961) */
	'D', 'B', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* DB_SHADER_CONTROL (17978) */
	'P', 'A', '_', 'C', 'L', '_', 'C', 'L', 'I', 'P', '_', 'C', 'N', 'T', 'L', '\0', /* PA_CL_CLIP_CNTL (17996) */
	'P', 'A', '_', 'S', 'U', '_', 'S', 'C', '_', 'M', 'O', 'D', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SU_SC_MODE_CNTL (18012) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'T', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* PA_CL_VTE_CNTL (18031) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'S', '_', 'O', 'U', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* PA_CL_VS_OUT_CNTL (18046) */
	'P', 'A', '_', 'C', 'L', '_', 'N', 'A', 'N', 'I', 'N', 'F', '_', 'C', 'N', 'T', 'L', '\0', /* PA_CL_NANINF_CNTL (18064) */
	'P', 'A', '_', 'S', 'U', '_', 'L', 'I', 'N', 'E', '_', 'S', 'T', 'I', 'P', 'P', 'L', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SU_LINE_STIPPLE_CNTL (18082) */
	'P', 'A', '_', 'S', 'U', '_', 'L', 'I', 'N', 'E', '_', 'S', 'T', 'I', 'P', 'P', 'L', 'E', '_', 'S', 'C', 'A', 'L', 'E', '\0', /* PA_SU_LINE_STIPPLE_SCALE (18106) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'R', 'I', 'M', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SU_PRIM_FILTER_CNTL (18131) */
	'P', 'A', '_', 'S', 'U', '_', 'S', 'M', 'A', 'L', 'L', '_', 'P', 'R', 'I', 'M', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SU_SMALL_PRIM_FILTER_CNTL (18154) */
	'P', 'A', '_', 'C', 'L', '_', 'O', 'B', 'J', 'P', 'R', 'I', 'M', '_', 'I', 'D', '_', 'C', 'N', 'T', 'L', '\0', /* PA_CL_OBJPRIM_ID_CNTL (18183) */
	'P', 'A', '_', 'C', 'L', '_', 'N', 'G', 'G', '_', 'C', 'N', 'T', 'L', '\0', /* PA_CL_NGG_CNTL (18205) */
	'P', 'A', '_', 'S', 'U', '_', 'O', 'V', 'E', 'R', '_', 'R', 'A', 'S', 'T', 'E', 'R', 'I', 'Z', 'A', 'T', 'I', 'O', 'N', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SU_OVER_RASTERIZATION_CNTL (18220) */
	'P', 'A', '_', 'S', 'T', 'E', 'R', 'E', 'O', '_', 'C', 'N', 'T', 'L', '\0', /* PA_STEREO_CNTL (18250) */
	'P', 'A', '_', 'S', 'T', 'A', 'T', 'E', '_', 'S', 'T', 'E', 'R', 'E', 'O', '_', 'X', '\0', /* PA_STATE_STEREO_X (18265) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'O', 'I', 'N', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* PA_SU_POINT_SIZE (18283) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'O', 'I', 'N', 'T', '_', 'M', 'I', 'N', 'M', 'A', 'X', '\0', /* PA_SU_POINT_MINMAX (18300) */
	'P', 'A', '_', 'S', 'U', '_', 'L', 'I', 'N', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SU_LINE_CNTL (18319) */
	'P', 'A', '_', 'S', 'C', '_', 'L', 'I', 'N', 'E', '_', 'S', 'T', 'I', 'P', 'P', 'L', 'E', '\0', /* PA_SC_LINE_STIPPLE (18335) */
	'V', 'G', 'T', '_', 'O', 'U', 'T', 'P', 'U', 'T', '_', 'P', 'A', 'T', 'H', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_OUTPUT_PATH_CNTL (18354) */
	'V', 'G', 'T', '_', 'H', 'O', 'S', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_HOS_CNTL (18375) */
	'V', 'G', 'T', '_', 'H', 'O', 'S', '_', 'M', 'A', 'X', '_', 'T', 'E', 'S', 'S', '_', 'L', 'E', 'V', 'E', 'L', '\0', /* VGT_HOS_MAX_TESS_LEVEL (18388) */
	'V', 'G', 'T', '_', 'H', 'O', 'S', '_', 'M', 'I', 'N', '_', 'T', 'E', 'S', 'S', '_', 'L', 'E', 'V', 'E', 'L', '\0', /* VGT_HOS_MIN_TESS_LEVEL (18411) */
	'V', 'G', 'T', '_', 'H', 'O', 'S', '_', 'R', 'E', 'U', 'S', 'E', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* VGT_HOS_REUSE_DEPTH (18434, 18442, 18448) */
	'V', 'G', 'T', '_', 'G', 'R', 'O', 'U', 'P', '_', 'P', 'R', 'I', 'M', '_', 'T', 'Y', 'P', 'E', '\0', /* VGT_GROUP_PRIM_TYPE (18454, 18464) */
	'V', 'G', 'T', '_', 'G', 'R', 'O', 'U', 'P', '_', 'F', 'I', 'R', 'S', 'T', '_', 'D', 'E', 'C', 'R', '\0', /* VGT_GROUP_FIRST_DECR (18474, 18484, 18490) */
	'V', 'G', 'T', '_', 'G', 'R', 'O', 'U', 'P', '_', 'D', 'E', 'C', 'R', '\0', /* VGT_GROUP_DECR (18495) */
	'V', 'G', 'T', '_', 'G', 'R', 'O', 'U', 'P', '_', 'V', 'E', 'C', 'T', '_', '0', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_GROUP_VECT_0_CNTL (18510) */
	'V', 'G', 'T', '_', 'G', 'R', 'O', 'U', 'P', '_', 'V', 'E', 'C', 'T', '_', '1', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_GROUP_VECT_1_CNTL (18532) */
	'V', 'G', 'T', '_', 'G', 'R', 'O', 'U', 'P', '_', 'V', 'E', 'C', 'T', '_', '0', '_', 'F', 'M', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_GROUP_VECT_0_FMT_CNTL (18554) */
	'V', 'G', 'T', '_', 'G', 'R', 'O', 'U', 'P', '_', 'V', 'E', 'C', 'T', '_', '1', '_', 'F', 'M', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_GROUP_VECT_1_FMT_CNTL (18580) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'M', 'O', 'D', 'E', '\0', /* VGT_GS_MODE (18606) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'O', 'N', 'C', 'H', 'I', 'P', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_GS_ONCHIP_CNTL (18618) */
	'P', 'A', '_', 'S', 'C', '_', 'M', 'O', 'D', 'E', '_', 'C', 'N', 'T', 'L', '_', '0', '\0', /* PA_SC_MODE_CNTL_0 (18637) */
	'P', 'A', '_', 'S', 'C', '_', 'M', 'O', 'D', 'E', '_', 'C', 'N', 'T', 'L', '_', '1', '\0', /* PA_SC_MODE_CNTL_1 (18655) */
	'V', 'G', 'T', '_', 'E', 'N', 'H', 'A', 'N', 'C', 'E', '\0', /* VGT_ENHANCE (18673, 18682) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'P', 'E', 'R', '_', 'E', 'S', '\0', /* VGT_GS_PER_ES (18685, 18689) */
	'V', 'G', 'T', '_', 'E', 'S', '_', 'P', 'E', 'R', '_', 'G', 'S', '\0', /* VGT_ES_PER_GS (18699, 18703) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'P', 'E', 'R', '_', 'V', 'S', '\0', /* VGT_GS_PER_VS (18713, 18717) */
	'V', 'G', 'T', '_', 'G', 'S', 'V', 'S', '_', 'R', 'I', 'N', 'G', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '\0', /* VGT_GSVS_RING_OFFSET_1 (18727) */
	'V', 'G', 'T', '_', 'G', 'S', 'V', 'S', '_', 'R', 'I', 'N', 'G', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', '2', '\0', /* VGT_GSVS_RING_OFFSET_2 (18750) */
	'V', 'G', 'T', '_', 'G', 'S', 'V', 'S', '_', 'R', 'I', 'N', 'G', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', '3', '\0', /* VGT_GSVS_RING_OFFSET_3 (18773) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'O', 'U', 'T', '_', 'P', 'R', 'I', 'M', '_', 'T', 'Y', 'P', 'E', '\0', /* VGT_GS_OUT_PRIM_TYPE (18796) */
	'I', 'A', '_', 'E', 'N', 'H', 'A', 'N', 'C', 'E', '\0', /* IA_ENHANCE (18817) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'S', 'I', 'Z', 'E', '\0', /* VGT_DMA_SIZE (18828) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'M', 'A', 'X', '_', 'S', 'I', 'Z', 'E', '\0', /* VGT_DMA_MAX_SIZE (18841, 18849) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'I', 'N', 'D', 'E', 'X', '_', 'T', 'Y', 'P', 'E', '\0', /* VGT_DMA_INDEX_TYPE (18858) */
	'W', 'D', '_', 'E', 'N', 'H', 'A', 'N', 'C', 'E', '\0', /* WD_ENHANCE (18877) */
	'V', 'G', 'T', '_', 'P', 'R', 'I', 'M', 'I', 'T', 'I', 'V', 'E', 'I', 'D', '_', 'E', 'N', '\0', /* VGT_PRIMITIVEID_EN (18888, 18892) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'N', 'U', 'M', '_', 'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', 'S', '\0', /* VGT_DMA_NUM_INSTANCES (18907) */
	'V', 'G', 'T', '_', 'P', 'R', 'I', 'M', 'I', 'T', 'I', 'V', 'E', 'I', 'D', '_', 'R', 'E', 'S', 'E', 'T', '\0', /* VGT_PRIMITIVEID_RESET (18929, 18945) */
	'V', 'G', 'T', '_', 'E', 'V', 'E', 'N', 'T', '_', 'I', 'N', 'I', 'T', 'I', 'A', 'T', 'O', 'R', '\0', /* VGT_EVENT_INITIATOR (18951) */
	'V', 'G', 'T', '_', 'M', 'U', 'L', 'T', 'I', '_', 'P', 'R', 'I', 'M', '_', 'I', 'B', '_', 'R', 'E', 'S', 'E', 'T', '_', 'E', 'N', '\0', /* VGT_MULTI_PRIM_IB_RESET_EN (18971, 18989) */
	'V', 'G', 'T', '_', 'D', 'R', 'A', 'W', '_', 'P', 'A', 'Y', 'L', 'O', 'A', 'D', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_DRAW_PAYLOAD_CNTL (18998) */
	'V', 'G', 'T', '_', 'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', '_', 'S', 'T', 'E', 'P', '_', 'R', 'A', 'T', 'E', '_', '0', '\0', /* VGT_INSTANCE_STEP_RATE_0 (19020) */
	'V', 'G', 'T', '_', 'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', '_', 'S', 'T', 'E', 'P', '_', 'R', 'A', 'T', 'E', '_', '1', '\0', /* VGT_INSTANCE_STEP_RATE_1 (19045) */
	'I', 'A', '_', 'M', 'U', 'L', 'T', 'I', '_', 'V', 'G', 'T', '_', 'P', 'A', 'R', 'A', 'M', '\0', /* IA_MULTI_VGT_PARAM (19070) */
	'V', 'G', 'T', '_', 'E', 'S', 'G', 'S', '_', 'R', 'I', 'N', 'G', '_', 'I', 'T', 'E', 'M', 'S', 'I', 'Z', 'E', '\0', /* VGT_ESGS_RING_ITEMSIZE (19089, 19103) */
	'V', 'G', 'T', '_', 'G', 'S', 'V', 'S', '_', 'R', 'I', 'N', 'G', '_', 'I', 'T', 'E', 'M', 'S', 'I', 'Z', 'E', '\0', /* VGT_GSVS_RING_ITEMSIZE (19112) */
	'V', 'G', 'T', '_', 'R', 'E', 'U', 'S', 'E', '_', 'O', 'F', 'F', '\0', /* VGT_REUSE_OFF (19135, 19139) */
	'V', 'G', 'T', '_', 'V', 'T', 'X', '_', 'C', 'N', 'T', '_', 'E', 'N', '\0', /* VGT_VTX_CNT_EN (19149, 19153) */
	'D', 'B', '_', 'H', 'T', 'I', 'L', 'E', '_', 'S', 'U', 'R', 'F', 'A', 'C', 'E', '\0', /* DB_HTILE_SURFACE (19164, 19176) */
	'D', 'B', '_', 'S', 'R', 'E', 'S', 'U', 'L', 'T', 'S', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'S', 'T', 'A', 'T', 'E', '0', '\0', /* DB_SRESULTS_COMPARE_STATE0 (19181) */
	'D', 'B', '_', 'S', 'R', 'E', 'S', 'U', 'L', 'T', 'S', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'S', 'T', 'A', 'T', 'E', '1', '\0', /* DB_SRESULTS_COMPARE_STATE1 (19208) */
	'D', 'B', '_', 'P', 'R', 'E', 'L', 'O', 'A', 'D', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* DB_PRELOAD_CONTROL (19235) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'S', 'I', 'Z', 'E', '_', '0', '\0', /* VGT_STRMOUT_BUFFER_SIZE_0 (19254) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'V', 'T', 'X', '_', 'S', 'T', 'R', 'I', 'D', 'E', '_', '0', '\0', /* VGT_STRMOUT_VTX_STRIDE_0 (19280) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', '0', '\0', /* VGT_STRMOUT_BUFFER_OFFSET_0 (19305) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'S', 'I', 'Z', 'E', '_', '1', '\0', /* VGT_STRMOUT_BUFFER_SIZE_1 (19333) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'V', 'T', 'X', '_', 'S', 'T', 'R', 'I', 'D', 'E', '_', '1', '\0', /* VGT_STRMOUT_VTX_STRIDE_1 (19359) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', '1', '\0', /* VGT_STRMOUT_BUFFER_OFFSET_1 (19384) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'S', 'I', 'Z', 'E', '_', '2', '\0', /* VGT_STRMOUT_BUFFER_SIZE_2 (19412) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'V', 'T', 'X', '_', 'S', 'T', 'R', 'I', 'D', 'E', '_', '2', '\0', /* VGT_STRMOUT_VTX_STRIDE_2 (19438) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', '2', '\0', /* VGT_STRMOUT_BUFFER_OFFSET_2 (19463) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'S', 'I', 'Z', 'E', '_', '3', '\0', /* VGT_STRMOUT_BUFFER_SIZE_3 (19491) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'V', 'T', 'X', '_', 'S', 'T', 'R', 'I', 'D', 'E', '_', '3', '\0', /* VGT_STRMOUT_VTX_STRIDE_3 (19517) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', '3', '\0', /* VGT_STRMOUT_BUFFER_OFFSET_3 (19542) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'D', 'R', 'A', 'W', '_', 'O', 'P', 'A', 'Q', 'U', 'E', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* VGT_STRMOUT_DRAW_OPAQUE_OFFSET (19570) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'D', 'R', 'A', 'W', '_', 'O', 'P', 'A', 'Q', 'U', 'E', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'F', 'I', 'L', 'L', 'E', 'D', '_', 'S', 'I', 'Z', 'E', '\0', /* VGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE (19601) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'D', 'R', 'A', 'W', '_', 'O', 'P', 'A', 'Q', 'U', 'E', '_', 'V', 'E', 'R', 'T', 'E', 'X', '_', 'S', 'T', 'R', 'I', 'D', 'E', '\0', /* VGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE (19644, 19668, 19675) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'M', 'A', 'X', '_', 'V', 'E', 'R', 'T', '_', 'O', 'U', 'T', '\0', /* VGT_GS_MAX_VERT_OUT (19682, 19689, 19698) */
	'G', 'E', '_', 'N', 'G', 'G', '_', 'S', 'U', 'B', 'G', 'R', 'P', '_', 'C', 'N', 'T', 'L', '\0', /* GE_NGG_SUBGRP_CNTL (19702) */
	'V', 'G', 'T', '_', 'T', 'E', 'S', 'S', '_', 'D', 'I', 'S', 'T', 'R', 'I', 'B', 'U', 'T', 'I', 'O', 'N', '\0', /* VGT_TESS_DISTRIBUTION (19721) */
	'V', 'G', 'T', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'S', 'T', 'A', 'G', 'E', 'S', '_', 'E', 'N', '\0', /* VGT_SHADER_STAGES_EN (19743, 19758) */
	'V', 'G', 'T', '_', 'L', 'S', '_', 'H', 'S', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* VGT_LS_HS_CONFIG (19764) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'V', 'E', 'R', 'T', '_', 'I', 'T', 'E', 'M', 'S', 'I', 'Z', 'E', '\0', /* VGT_GS_VERT_ITEMSIZE (19781) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'V', 'E', 'R', 'T', '_', 'I', 'T', 'E', 'M', 'S', 'I', 'Z', 'E', '_', '1', '\0', /* VGT_GS_VERT_ITEMSIZE_1 (19802) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'V', 'E', 'R', 'T', '_', 'I', 'T', 'E', 'M', 'S', 'I', 'Z', 'E', '_', '2', '\0', /* VGT_GS_VERT_ITEMSIZE_2 (19825) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'V', 'E', 'R', 'T', '_', 'I', 'T', 'E', 'M', 'S', 'I', 'Z', 'E', '_', '3', '\0', /* VGT_GS_VERT_ITEMSIZE_3 (19848) */
	'V', 'G', 'T', '_', 'T', 'F', '_', 'P', 'A', 'R', 'A', 'M', '\0', /* VGT_TF_PARAM (19871) */
	'D', 'B', '_', 'A', 'L', 'P', 'H', 'A', '_', 'T', 'O', '_', 'M', 'A', 'S', 'K', '\0', /* DB_ALPHA_TO_MASK (19884) */
	'V', 'G', 'T', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* VGT_DISPATCH_DRAW_INDEX (19901) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'D', 'B', '_', 'F', 'M', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SU_POLY_OFFSET_DB_FMT_CNTL (19925) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'C', 'L', 'A', 'M', 'P', '\0', /* PA_SU_POLY_OFFSET_CLAMP (19955) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'F', 'R', 'O', 'N', 'T', '_', 'S', 'C', 'A', 'L', 'E', '\0', /* PA_SU_POLY_OFFSET_FRONT_SCALE (19979) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'F', 'R', 'O', 'N', 'T', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* PA_SU_POLY_OFFSET_FRONT_OFFSET (20009) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'B', 'A', 'C', 'K', '_', 'S', 'C', 'A', 'L', 'E', '\0', /* PA_SU_POLY_OFFSET_BACK_SCALE (20040) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'B', 'A', 'C', 'K', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* PA_SU_POLY_OFFSET_BACK_OFFSET (20069) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', '_', 'C', 'N', 'T', '\0', /* VGT_GS_INSTANCE_CNT (20099, 20115) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* VGT_STRMOUT_CONFIG (20119) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* VGT_STRMOUT_BUFFER_CONFIG (20138) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'E', 'V', 'E', 'N', 'T', '_', 'I', 'N', 'I', 'T', 'I', 'A', 'T', 'O', 'R', '\0', /* VGT_DMA_EVENT_INITIATOR (20164) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '_', 'P', 'R', 'I', 'O', 'R', 'I', 'T', 'Y', '_', '0', '\0', /* PA_SC_CENTROID_PRIORITY_0 (20188) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '_', 'P', 'R', 'I', 'O', 'R', 'I', 'T', 'Y', '_', '1', '\0', /* PA_SC_CENTROID_PRIORITY_1 (20214) */
	'P', 'A', '_', 'S', 'C', '_', 'L', 'I', 'N', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SC_LINE_CNTL (20240) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* PA_SC_AA_CONFIG (20256) */
	'P', 'A', '_', 'S', 'U', '_', 'V', 'T', 'X', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SU_VTX_CNTL (20272) */
	'P', 'A', '_', 'C', 'L', '_', 'G', 'B', '_', 'V', 'E', 'R', 'T', '_', 'C', 'L', 'I', 'P', '_', 'A', 'D', 'J', '\0', /* PA_CL_GB_VERT_CLIP_ADJ (20287) */
	'P', 'A', '_', 'C', 'L', '_', 'G', 'B', '_', 'V', 'E', 'R', 'T', '_', 'D', 'I', 'S', 'C', '_', 'A', 'D', 'J', '\0', /* PA_CL_GB_VERT_DISC_ADJ (20310) */
	'P', 'A', '_', 'C', 'L', '_', 'G', 'B', '_', 'H', 'O', 'R', 'Z', '_', 'C', 'L', 'I', 'P', '_', 'A', 'D', 'J', '\0', /* PA_CL_GB_HORZ_CLIP_ADJ (20333) */
	'P', 'A', '_', 'C', 'L', '_', 'G', 'B', '_', 'H', 'O', 'R', 'Z', '_', 'D', 'I', 'S', 'C', '_', 'A', 'D', 'J', '\0', /* PA_CL_GB_HORZ_DISC_ADJ (20356) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '0', 'Y', '0', '_', '0', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0 (20379) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '0', 'Y', '0', '_', '1', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1 (20413) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '0', 'Y', '0', '_', '2', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2 (20447) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '0', 'Y', '0', '_', '3', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3 (20481) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '1', 'Y', '0', '_', '0', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0 (20515) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '1', 'Y', '0', '_', '1', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1 (20549) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '1', 'Y', '0', '_', '2', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2 (20583) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '1', 'Y', '0', '_', '3', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3 (20617) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '0', 'Y', '1', '_', '0', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0 (20651) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '0', 'Y', '1', '_', '1', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1 (20685) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '0', 'Y', '1', '_', '2', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2 (20719) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '0', 'Y', '1', '_', '3', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3 (20753) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '1', 'Y', '1', '_', '0', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0 (20787) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '1', 'Y', '1', '_', '1', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1 (20821) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '1', 'Y', '1', '_', '2', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2 (20855) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'S', '_', 'P', 'I', 'X', 'E', 'L', '_', 'X', '1', 'Y', '1', '_', '3', '\0', /* PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3 (20889) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'X', '0', 'Y', '0', '_', 'X', '1', 'Y', '0', '\0', /* PA_SC_AA_MASK_X0Y0_X1Y0 (20923) */
	'P', 'A', '_', 'S', 'C', '_', 'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'X', '0', 'Y', '1', '_', 'X', '1', 'Y', '1', '\0', /* PA_SC_AA_MASK_X0Y1_X1Y1 (20947) */
	'P', 'A', '_', 'S', 'C', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* PA_SC_SHADER_CONTROL (20971) */
	'P', 'A', '_', 'S', 'C', '_', 'B', 'I', 'N', 'N', 'E', 'R', '_', 'C', 'N', 'T', 'L', '_', '0', '\0', /* PA_SC_BINNER_CNTL_0 (20992) */
	'P', 'A', '_', 'S', 'C', '_', 'B', 'I', 'N', 'N', 'E', 'R', '_', 'C', 'N', 'T', 'L', '_', '1', '\0', /* PA_SC_BINNER_CNTL_1 (21012) */
	'P', 'A', '_', 'S', 'C', '_', 'C', 'O', 'N', 'S', 'E', 'R', 'V', 'A', 'T', 'I', 'V', 'E', '_', 'R', 'A', 'S', 'T', 'E', 'R', 'I', 'Z', 'A', 'T', 'I', 'O', 'N', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SC_CONSERVATIVE_RASTERIZATION_CNTL (21032) */
	'P', 'A', '_', 'S', 'C', '_', 'N', 'G', 'G', '_', 'M', 'O', 'D', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SC_NGG_MODE_CNTL (21070) */
	'V', 'G', 'T', '_', 'V', 'E', 'R', 'T', 'E', 'X', '_', 'R', 'E', 'U', 'S', 'E', '_', 'B', 'L', 'O', 'C', 'K', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_VERTEX_REUSE_BLOCK_CNTL (21090) */
	'V', 'G', 'T', '_', 'O', 'U', 'T', '_', 'D', 'E', 'A', 'L', 'L', 'O', 'C', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_OUT_DEALLOC_CNTL (21118) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR0_BASE (21139) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_COLOR0_PITCH (21154, 21164) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR0_SLICE (21170) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'V', 'I', 'E', 'W', '\0', /* CB_COLOR0_VIEW (21186) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'I', 'N', 'F', 'O', '\0', /* CB_COLOR0_INFO (21201) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'A', 'T', 'T', 'R', 'I', 'B', '\0', /* CB_COLOR0_ATTRIB (21216) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'D', 'C', 'C', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_COLOR0_DCC_CONTROL (21233) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'C', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR0_CMASK (21255) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'C', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR0_CMASK_SLICE (21271) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'F', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR0_FMASK (21293) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'F', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR0_FMASK_SLICE (21309) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '0', '\0', /* CB_COLOR0_CLEAR_WORD0 (21331) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '1', '\0', /* CB_COLOR0_CLEAR_WORD1 (21353) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR0_DCC_BASE (21375) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR1_BASE (21394) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_COLOR1_PITCH (21409) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR1_SLICE (21425) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'V', 'I', 'E', 'W', '\0', /* CB_COLOR1_VIEW (21441) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'I', 'N', 'F', 'O', '\0', /* CB_COLOR1_INFO (21456) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'A', 'T', 'T', 'R', 'I', 'B', '\0', /* CB_COLOR1_ATTRIB (21471) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'D', 'C', 'C', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_COLOR1_DCC_CONTROL (21488) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'C', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR1_CMASK (21510) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'C', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR1_CMASK_SLICE (21526) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'F', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR1_FMASK (21548) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'F', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR1_FMASK_SLICE (21564) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '0', '\0', /* CB_COLOR1_CLEAR_WORD0 (21586) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '1', '\0', /* CB_COLOR1_CLEAR_WORD1 (21608) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR1_DCC_BASE (21630) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR2_BASE (21649) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_COLOR2_PITCH (21664) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR2_SLICE (21680) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'V', 'I', 'E', 'W', '\0', /* CB_COLOR2_VIEW (21696) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'I', 'N', 'F', 'O', '\0', /* CB_COLOR2_INFO (21711) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'A', 'T', 'T', 'R', 'I', 'B', '\0', /* CB_COLOR2_ATTRIB (21726) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'D', 'C', 'C', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_COLOR2_DCC_CONTROL (21743) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'C', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR2_CMASK (21765) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'C', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR2_CMASK_SLICE (21781) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'F', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR2_FMASK (21803) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'F', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR2_FMASK_SLICE (21819) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '0', '\0', /* CB_COLOR2_CLEAR_WORD0 (21841) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '1', '\0', /* CB_COLOR2_CLEAR_WORD1 (21863) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR2_DCC_BASE (21885) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR3_BASE (21904) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_COLOR3_PITCH (21919) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR3_SLICE (21935) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'V', 'I', 'E', 'W', '\0', /* CB_COLOR3_VIEW (21951) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'I', 'N', 'F', 'O', '\0', /* CB_COLOR3_INFO (21966) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'A', 'T', 'T', 'R', 'I', 'B', '\0', /* CB_COLOR3_ATTRIB (21981) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'D', 'C', 'C', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_COLOR3_DCC_CONTROL (21998) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'C', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR3_CMASK (22020) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'C', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR3_CMASK_SLICE (22036) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'F', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR3_FMASK (22058) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'F', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR3_FMASK_SLICE (22074) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '0', '\0', /* CB_COLOR3_CLEAR_WORD0 (22096) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '1', '\0', /* CB_COLOR3_CLEAR_WORD1 (22118) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR3_DCC_BASE (22140) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR4_BASE (22159) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_COLOR4_PITCH (22174) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR4_SLICE (22190) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'V', 'I', 'E', 'W', '\0', /* CB_COLOR4_VIEW (22206) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'I', 'N', 'F', 'O', '\0', /* CB_COLOR4_INFO (22221) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'A', 'T', 'T', 'R', 'I', 'B', '\0', /* CB_COLOR4_ATTRIB (22236) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'D', 'C', 'C', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_COLOR4_DCC_CONTROL (22253) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'C', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR4_CMASK (22275) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'C', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR4_CMASK_SLICE (22291) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'F', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR4_FMASK (22313) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'F', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR4_FMASK_SLICE (22329) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '0', '\0', /* CB_COLOR4_CLEAR_WORD0 (22351) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '1', '\0', /* CB_COLOR4_CLEAR_WORD1 (22373) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR4_DCC_BASE (22395) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR5_BASE (22414) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_COLOR5_PITCH (22429) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR5_SLICE (22445) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'V', 'I', 'E', 'W', '\0', /* CB_COLOR5_VIEW (22461) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'I', 'N', 'F', 'O', '\0', /* CB_COLOR5_INFO (22476) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'A', 'T', 'T', 'R', 'I', 'B', '\0', /* CB_COLOR5_ATTRIB (22491) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'D', 'C', 'C', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_COLOR5_DCC_CONTROL (22508) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'C', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR5_CMASK (22530) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'C', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR5_CMASK_SLICE (22546) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'F', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR5_FMASK (22568) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'F', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR5_FMASK_SLICE (22584) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '0', '\0', /* CB_COLOR5_CLEAR_WORD0 (22606) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '1', '\0', /* CB_COLOR5_CLEAR_WORD1 (22628) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR5_DCC_BASE (22650) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR6_BASE (22669) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_COLOR6_PITCH (22684) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR6_SLICE (22700) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'V', 'I', 'E', 'W', '\0', /* CB_COLOR6_VIEW (22716) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'I', 'N', 'F', 'O', '\0', /* CB_COLOR6_INFO (22731) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'A', 'T', 'T', 'R', 'I', 'B', '\0', /* CB_COLOR6_ATTRIB (22746) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'D', 'C', 'C', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_COLOR6_DCC_CONTROL (22763) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'C', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR6_CMASK (22785) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'C', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR6_CMASK_SLICE (22801) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'F', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR6_FMASK (22823) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'F', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR6_FMASK_SLICE (22839) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '0', '\0', /* CB_COLOR6_CLEAR_WORD0 (22861) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '1', '\0', /* CB_COLOR6_CLEAR_WORD1 (22883) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR6_DCC_BASE (22905) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR7_BASE (22924) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_COLOR7_PITCH (22939) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR7_SLICE (22955) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'V', 'I', 'E', 'W', '\0', /* CB_COLOR7_VIEW (22971) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'I', 'N', 'F', 'O', '\0', /* CB_COLOR7_INFO (22986) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'A', 'T', 'T', 'R', 'I', 'B', '\0', /* CB_COLOR7_ATTRIB (23001) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'D', 'C', 'C', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CB_COLOR7_DCC_CONTROL (23018) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'C', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR7_CMASK (23040) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'C', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR7_CMASK_SLICE (23056) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'F', 'M', 'A', 'S', 'K', '\0', /* CB_COLOR7_FMASK (23078) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'F', 'M', 'A', 'S', 'K', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* CB_COLOR7_FMASK_SLICE (23094) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '0', '\0', /* CB_COLOR7_CLEAR_WORD0 (23116) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'C', 'L', 'E', 'A', 'R', '_', 'W', 'O', 'R', 'D', '1', '\0', /* CB_COLOR7_CLEAR_WORD1 (23138) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '\0', /* CB_COLOR7_DCC_BASE (23160) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR0_BASE_EXT (23179) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR1_BASE_EXT (23198) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR2_BASE_EXT (23217) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR3_BASE_EXT (23236) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR4_BASE_EXT (23255) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR5_BASE_EXT (23274) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR6_BASE_EXT (23293) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR7_BASE_EXT (23312) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'C', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR0_CMASK_BASE_EXT (23331) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'C', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR1_CMASK_BASE_EXT (23356) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'C', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR2_CMASK_BASE_EXT (23381) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'C', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR3_CMASK_BASE_EXT (23406) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'C', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR4_CMASK_BASE_EXT (23431) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'C', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR5_CMASK_BASE_EXT (23456) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'C', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR6_CMASK_BASE_EXT (23481) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'C', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR7_CMASK_BASE_EXT (23506) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'F', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR0_FMASK_BASE_EXT (23531) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'F', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR1_FMASK_BASE_EXT (23556) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'F', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR2_FMASK_BASE_EXT (23581) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'F', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR3_FMASK_BASE_EXT (23606) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'F', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR4_FMASK_BASE_EXT (23631) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'F', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR5_FMASK_BASE_EXT (23656) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'F', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR6_FMASK_BASE_EXT (23681) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'F', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR7_FMASK_BASE_EXT (23706) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR0_DCC_BASE_EXT (23731) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR1_DCC_BASE_EXT (23754) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR2_DCC_BASE_EXT (23777) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR3_DCC_BASE_EXT (23800) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR4_DCC_BASE_EXT (23823) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR5_DCC_BASE_EXT (23846) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR6_DCC_BASE_EXT (23869) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'D', 'C', 'C', '_', 'B', 'A', 'S', 'E', '_', 'E', 'X', 'T', '\0', /* CB_COLOR7_DCC_BASE_EXT (23892) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'A', 'T', 'T', 'R', 'I', 'B', '2', '\0', /* CB_COLOR0_ATTRIB2 (23915) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'A', 'T', 'T', 'R', 'I', 'B', '2', '\0', /* CB_COLOR1_ATTRIB2 (23933) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'A', 'T', 'T', 'R', 'I', 'B', '2', '\0', /* CB_COLOR2_ATTRIB2 (23951) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'A', 'T', 'T', 'R', 'I', 'B', '2', '\0', /* CB_COLOR3_ATTRIB2 (23969) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'A', 'T', 'T', 'R', 'I', 'B', '2', '\0', /* CB_COLOR4_ATTRIB2 (23987) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'A', 'T', 'T', 'R', 'I', 'B', '2', '\0', /* CB_COLOR5_ATTRIB2 (24005) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'A', 'T', 'T', 'R', 'I', 'B', '2', '\0', /* CB_COLOR6_ATTRIB2 (24023) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'A', 'T', 'T', 'R', 'I', 'B', '2', '\0', /* CB_COLOR7_ATTRIB2 (24041) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '0', '_', 'A', 'T', 'T', 'R', 'I', 'B', '3', '\0', /* CB_COLOR0_ATTRIB3 (24059) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '1', '_', 'A', 'T', 'T', 'R', 'I', 'B', '3', '\0', /* CB_COLOR1_ATTRIB3 (24077) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '2', '_', 'A', 'T', 'T', 'R', 'I', 'B', '3', '\0', /* CB_COLOR2_ATTRIB3 (24095) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '3', '_', 'A', 'T', 'T', 'R', 'I', 'B', '3', '\0', /* CB_COLOR3_ATTRIB3 (24113) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '4', '_', 'A', 'T', 'T', 'R', 'I', 'B', '3', '\0', /* CB_COLOR4_ATTRIB3 (24131) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '5', '_', 'A', 'T', 'T', 'R', 'I', 'B', '3', '\0', /* CB_COLOR5_ATTRIB3 (24149) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '6', '_', 'A', 'T', 'T', 'R', 'I', 'B', '3', '\0', /* CB_COLOR6_ATTRIB3 (24167) */
	'C', 'B', '_', 'C', 'O', 'L', 'O', 'R', '7', '_', 'A', 'T', 'T', 'R', 'I', 'B', '3', '\0', /* CB_COLOR7_ATTRIB3 (24185) */
	'C', 'P', '_', 'E', 'O', 'P', '_', 'D', 'O', 'N', 'E', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_EOP_DONE_ADDR_LO (24203) */
	'C', 'P', '_', 'E', 'O', 'P', '_', 'D', 'O', 'N', 'E', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_EOP_DONE_ADDR_HI (24223) */
	'C', 'P', '_', 'E', 'O', 'P', '_', 'D', 'O', 'N', 'E', '_', 'D', 'A', 'T', 'A', '_', 'L', 'O', '\0', /* CP_EOP_DONE_DATA_LO (24243) */
	'C', 'P', '_', 'E', 'O', 'P', '_', 'D', 'O', 'N', 'E', '_', 'D', 'A', 'T', 'A', '_', 'H', 'I', '\0', /* CP_EOP_DONE_DATA_HI (24263) */
	'C', 'P', '_', 'E', 'O', 'P', '_', 'L', 'A', 'S', 'T', '_', 'F', 'E', 'N', 'C', 'E', '_', 'L', 'O', '\0', /* CP_EOP_LAST_FENCE_LO (24283) */
	'C', 'P', '_', 'E', 'O', 'P', '_', 'L', 'A', 'S', 'T', '_', 'F', 'E', 'N', 'C', 'E', '_', 'H', 'I', '\0', /* CP_EOP_LAST_FENCE_HI (24304) */
	'C', 'P', '_', 'S', 'T', 'R', 'E', 'A', 'M', '_', 'O', 'U', 'T', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_STREAM_OUT_ADDR_LO (24325, 24328) */
	'C', 'P', '_', 'S', 'T', 'R', 'E', 'A', 'M', '_', 'O', 'U', 'T', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_STREAM_OUT_ADDR_HI (24347, 24350) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'W', 'R', 'I', 'T', 'T', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '0', '_', 'L', 'O', '\0', /* CP_NUM_PRIM_WRITTEN_COUNT0_LO (24369) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'W', 'R', 'I', 'T', 'T', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '0', '_', 'H', 'I', '\0', /* CP_NUM_PRIM_WRITTEN_COUNT0_HI (24399) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'N', 'E', 'E', 'D', 'E', 'D', '_', 'C', 'O', 'U', 'N', 'T', '0', '_', 'L', 'O', '\0', /* CP_NUM_PRIM_NEEDED_COUNT0_LO (24429) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'N', 'E', 'E', 'D', 'E', 'D', '_', 'C', 'O', 'U', 'N', 'T', '0', '_', 'H', 'I', '\0', /* CP_NUM_PRIM_NEEDED_COUNT0_HI (24458) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'W', 'R', 'I', 'T', 'T', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '1', '_', 'L', 'O', '\0', /* CP_NUM_PRIM_WRITTEN_COUNT1_LO (24487) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'W', 'R', 'I', 'T', 'T', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '1', '_', 'H', 'I', '\0', /* CP_NUM_PRIM_WRITTEN_COUNT1_HI (24517) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'N', 'E', 'E', 'D', 'E', 'D', '_', 'C', 'O', 'U', 'N', 'T', '1', '_', 'L', 'O', '\0', /* CP_NUM_PRIM_NEEDED_COUNT1_LO (24547) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'N', 'E', 'E', 'D', 'E', 'D', '_', 'C', 'O', 'U', 'N', 'T', '1', '_', 'H', 'I', '\0', /* CP_NUM_PRIM_NEEDED_COUNT1_HI (24576) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'W', 'R', 'I', 'T', 'T', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '2', '_', 'L', 'O', '\0', /* CP_NUM_PRIM_WRITTEN_COUNT2_LO (24605) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'W', 'R', 'I', 'T', 'T', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '2', '_', 'H', 'I', '\0', /* CP_NUM_PRIM_WRITTEN_COUNT2_HI (24635) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'N', 'E', 'E', 'D', 'E', 'D', '_', 'C', 'O', 'U', 'N', 'T', '2', '_', 'L', 'O', '\0', /* CP_NUM_PRIM_NEEDED_COUNT2_LO (24665) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'N', 'E', 'E', 'D', 'E', 'D', '_', 'C', 'O', 'U', 'N', 'T', '2', '_', 'H', 'I', '\0', /* CP_NUM_PRIM_NEEDED_COUNT2_HI (24694) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'W', 'R', 'I', 'T', 'T', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '3', '_', 'L', 'O', '\0', /* CP_NUM_PRIM_WRITTEN_COUNT3_LO (24723) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'W', 'R', 'I', 'T', 'T', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '3', '_', 'H', 'I', '\0', /* CP_NUM_PRIM_WRITTEN_COUNT3_HI (24753) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'N', 'E', 'E', 'D', 'E', 'D', '_', 'C', 'O', 'U', 'N', 'T', '3', '_', 'L', 'O', '\0', /* CP_NUM_PRIM_NEEDED_COUNT3_LO (24783) */
	'C', 'P', '_', 'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'N', 'E', 'E', 'D', 'E', 'D', '_', 'C', 'O', 'U', 'N', 'T', '3', '_', 'H', 'I', '\0', /* CP_NUM_PRIM_NEEDED_COUNT3_HI (24812) */
	'C', 'P', '_', 'P', 'I', 'P', 'E', '_', 'S', 'T', 'A', 'T', 'S', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_PIPE_STATS_ADDR_LO (24841, 24844) */
	'C', 'P', '_', 'P', 'I', 'P', 'E', '_', 'S', 'T', 'A', 'T', 'S', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_PIPE_STATS_ADDR_HI (24863, 24866) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'I', 'A', 'V', 'E', 'R', 'T', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', '\0', /* CP_VGT_IAVERT_COUNT_LO (24885) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'I', 'A', 'V', 'E', 'R', 'T', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* CP_VGT_IAVERT_COUNT_HI (24908, 24922) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'I', 'A', 'P', 'R', 'I', 'M', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', '\0', /* CP_VGT_IAPRIM_COUNT_LO (24931) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'I', 'A', 'P', 'R', 'I', 'M', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* CP_VGT_IAPRIM_COUNT_HI (24954) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'G', 'S', 'P', 'R', 'I', 'M', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', '\0', /* CP_VGT_GSPRIM_COUNT_LO (24977) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'G', 'S', 'P', 'R', 'I', 'M', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* CP_VGT_GSPRIM_COUNT_HI (25000) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'V', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', '\0', /* CP_VGT_VSINVOC_COUNT_LO (25023) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'V', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* CP_VGT_VSINVOC_COUNT_HI (25047) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'G', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', '\0', /* CP_VGT_GSINVOC_COUNT_LO (25071) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'G', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* CP_VGT_GSINVOC_COUNT_HI (25095) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'H', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', '\0', /* CP_VGT_HSINVOC_COUNT_LO (25119) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'H', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* CP_VGT_HSINVOC_COUNT_HI (25143) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'D', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', '\0', /* CP_VGT_DSINVOC_COUNT_LO (25167) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'D', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* CP_VGT_DSINVOC_COUNT_HI (25191) */
	'C', 'P', '_', 'P', 'A', '_', 'C', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', '\0', /* CP_PA_CINVOC_COUNT_LO (25215) */
	'C', 'P', '_', 'P', 'A', '_', 'C', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* CP_PA_CINVOC_COUNT_HI (25237) */
	'C', 'P', '_', 'P', 'A', '_', 'C', 'P', 'R', 'I', 'M', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', '\0', /* CP_PA_CPRIM_COUNT_LO (25259) */
	'C', 'P', '_', 'P', 'A', '_', 'C', 'P', 'R', 'I', 'M', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* CP_PA_CPRIM_COUNT_HI (25280) */
	'C', 'P', '_', 'S', 'C', '_', 'P', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '0', '_', 'L', 'O', '\0', /* CP_SC_PSINVOC_COUNT0_LO (25301) */
	'C', 'P', '_', 'S', 'C', '_', 'P', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '0', '_', 'H', 'I', '\0', /* CP_SC_PSINVOC_COUNT0_HI (25325) */
	'C', 'P', '_', 'S', 'C', '_', 'P', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '1', '_', 'L', 'O', '\0', /* CP_SC_PSINVOC_COUNT1_LO (25349) */
	'C', 'P', '_', 'S', 'C', '_', 'P', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '1', '_', 'H', 'I', '\0', /* CP_SC_PSINVOC_COUNT1_HI (25373) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'C', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', '\0', /* CP_VGT_CSINVOC_COUNT_LO (25397) */
	'C', 'P', '_', 'V', 'G', 'T', '_', 'C', 'S', 'I', 'N', 'V', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* CP_VGT_CSINVOC_COUNT_HI (25421) */
	'C', 'P', '_', 'E', 'O', 'P', '_', 'D', 'O', 'N', 'E', '_', 'D', 'O', 'O', 'R', 'B', 'E', 'L', 'L', '\0', /* CP_EOP_DONE_DOORBELL (25445) */
	'C', 'P', '_', 'S', 'T', 'R', 'E', 'A', 'M', '_', 'O', 'U', 'T', '_', 'D', 'O', 'O', 'R', 'B', 'E', 'L', 'L', '\0', /* CP_STREAM_OUT_DOORBELL (25466) */
	'C', 'P', '_', 'S', 'E', 'M', '_', 'D', 'O', 'O', 'R', 'B', 'E', 'L', 'L', '\0', /* CP_SEM_DOORBELL (25489) */
	'C', 'P', '_', 'P', 'I', 'P', 'E', '_', 'S', 'T', 'A', 'T', 'S', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CP_PIPE_STATS_CONTROL (25505) */
	'C', 'P', '_', 'S', 'T', 'R', 'E', 'A', 'M', '_', 'O', 'U', 'T', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CP_STREAM_OUT_CONTROL (25527) */
	'C', 'P', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* CP_STRMOUT_CNTL (25549) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '0', '\0', /* SCRATCH_REG0 (25565) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '1', '\0', /* SCRATCH_REG1 (25578) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '2', '\0', /* SCRATCH_REG2 (25591) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '3', '\0', /* SCRATCH_REG3 (25604) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '4', '\0', /* SCRATCH_REG4 (25617) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '5', '\0', /* SCRATCH_REG5 (25630) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '6', '\0', /* SCRATCH_REG6 (25643) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '7', '\0', /* SCRATCH_REG7 (25656) */
	'C', 'P', '_', 'P', 'I', 'P', 'E', '_', 'S', 'T', 'A', 'T', 'S', '_', 'D', 'O', 'O', 'R', 'B', 'E', 'L', 'L', '\0', /* CP_PIPE_STATS_DOORBELL (25669) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'D', 'D', 'I', 'D', '_', 'C', 'N', 'T', '\0', /* CP_APPEND_DDID_CNT (25692) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'D', 'A', 'T', 'A', '_', 'H', 'I', '\0', /* CP_APPEND_DATA_HI (25711) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'L', 'A', 'S', 'T', '_', 'C', 'S', '_', 'F', 'E', 'N', 'C', 'E', '_', 'H', 'I', '\0', /* CP_APPEND_LAST_CS_FENCE_HI (25729) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'L', 'A', 'S', 'T', '_', 'P', 'S', '_', 'F', 'E', 'N', 'C', 'E', '_', 'H', 'I', '\0', /* CP_APPEND_LAST_PS_FENCE_HI (25756) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'U', 'M', 'S', 'K', '\0', /* SCRATCH_UMSK (25783) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'A', 'D', 'D', 'R', '\0', /* SCRATCH_ADDR (25796) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'A', 'T', 'O', 'M', 'I', 'C', '_', 'P', 'R', 'E', 'O', 'P', '_', 'L', 'O', '\0', /* CP_PFP_ATOMIC_PREOP_LO (25809) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'A', 'T', 'O', 'M', 'I', 'C', '_', 'P', 'R', 'E', 'O', 'P', '_', 'H', 'I', '\0', /* CP_PFP_ATOMIC_PREOP_HI (25832) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '0', '_', 'P', 'R', 'E', 'O', 'P', '_', 'L', 'O', '\0', /* CP_PFP_GDS_ATOMIC0_PREOP_LO (25855) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '0', '_', 'P', 'R', 'E', 'O', 'P', '_', 'H', 'I', '\0', /* CP_PFP_GDS_ATOMIC0_PREOP_HI (25883) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '1', '_', 'P', 'R', 'E', 'O', 'P', '_', 'L', 'O', '\0', /* CP_PFP_GDS_ATOMIC1_PREOP_LO (25911) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '1', '_', 'P', 'R', 'E', 'O', 'P', '_', 'H', 'I', '\0', /* CP_PFP_GDS_ATOMIC1_PREOP_HI (25939) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_APPEND_ADDR_LO (25967) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_APPEND_ADDR_HI (25985) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'D', 'A', 'T', 'A', '\0', /* CP_APPEND_DATA (26003) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'L', 'A', 'S', 'T', '_', 'C', 'S', '_', 'F', 'E', 'N', 'C', 'E', '\0', /* CP_APPEND_LAST_CS_FENCE (26018) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'L', 'A', 'S', 'T', '_', 'P', 'S', '_', 'F', 'E', 'N', 'C', 'E', '\0', /* CP_APPEND_LAST_PS_FENCE (26042) */
	'C', 'P', '_', 'A', 'T', 'O', 'M', 'I', 'C', '_', 'P', 'R', 'E', 'O', 'P', '_', 'L', 'O', '\0', /* CP_ATOMIC_PREOP_LO (26066) */
	'C', 'P', '_', 'A', 'T', 'O', 'M', 'I', 'C', '_', 'P', 'R', 'E', 'O', 'P', '_', 'H', 'I', '\0', /* CP_ATOMIC_PREOP_HI (26085) */
	'C', 'P', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '0', '_', 'P', 'R', 'E', 'O', 'P', '_', 'L', 'O', '\0', /* CP_GDS_ATOMIC0_PREOP_LO (26104) */
	'C', 'P', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '0', '_', 'P', 'R', 'E', 'O', 'P', '_', 'H', 'I', '\0', /* CP_GDS_ATOMIC0_PREOP_HI (26128) */
	'C', 'P', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '1', '_', 'P', 'R', 'E', 'O', 'P', '_', 'L', 'O', '\0', /* CP_GDS_ATOMIC1_PREOP_LO (26152) */
	'C', 'P', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '1', '_', 'P', 'R', 'E', 'O', 'P', '_', 'H', 'I', '\0', /* CP_GDS_ATOMIC1_PREOP_HI (26176) */
	'C', 'P', '_', 'M', 'E', '_', 'M', 'C', '_', 'W', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_ME_MC_WADDR_LO (26200, 26203) */
	'C', 'P', '_', 'M', 'E', '_', 'M', 'C', '_', 'W', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_ME_MC_WADDR_HI (26218, 26221) */
	'C', 'P', '_', 'M', 'E', '_', 'M', 'C', '_', 'W', 'D', 'A', 'T', 'A', '_', 'L', 'O', '\0', /* CP_ME_MC_WDATA_LO (26236) */
	'C', 'P', '_', 'M', 'E', '_', 'M', 'C', '_', 'W', 'D', 'A', 'T', 'A', '_', 'H', 'I', '\0', /* CP_ME_MC_WDATA_HI (26254) */
	'C', 'P', '_', 'M', 'E', '_', 'M', 'C', '_', 'R', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_ME_MC_RADDR_LO (26272, 26275) */
	'C', 'P', '_', 'M', 'E', '_', 'M', 'C', '_', 'R', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_ME_MC_RADDR_HI (26290, 26293) */
	'C', 'P', '_', 'S', 'E', 'M', '_', 'W', 'A', 'I', 'T', '_', 'T', 'I', 'M', 'E', 'R', '\0', /* CP_SEM_WAIT_TIMER (26308) */
	'C', 'P', '_', 'S', 'I', 'G', '_', 'S', 'E', 'M', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_SIG_SEM_ADDR_LO (26326, 26333) */
	'C', 'P', '_', 'S', 'I', 'G', '_', 'S', 'E', 'M', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_SIG_SEM_ADDR_HI (26345, 26352) */
	'C', 'P', '_', 'W', 'A', 'I', 'T', '_', 'R', 'E', 'G', '_', 'M', 'E', 'M', '_', 'T', 'I', 'M', 'E', 'O', 'U', 'T', '\0', /* CP_WAIT_REG_MEM_TIMEOUT (26364) */
	'C', 'P', '_', 'W', 'A', 'I', 'T', '_', 'S', 'E', 'M', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_WAIT_SEM_ADDR_LO (26388) */
	'C', 'P', '_', 'W', 'A', 'I', 'T', '_', 'S', 'E', 'M', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_WAIT_SEM_ADDR_HI (26408) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'P', 'F', 'P', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CP_DMA_PFP_CONTROL (26428) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'M', 'E', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CP_DMA_ME_CONTROL (26447) */
	'C', 'P', '_', 'C', 'O', 'H', 'E', 'R', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* CP_COHER_BASE_HI (26465) */
	'C', 'P', '_', 'C', 'O', 'H', 'E', 'R', '_', 'S', 'T', 'A', 'R', 'T', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* CP_COHER_START_DELAY (26482) */
	'C', 'P', '_', 'C', 'O', 'H', 'E', 'R', '_', 'C', 'N', 'T', 'L', '\0', /* CP_COHER_CNTL (26503) */
	'C', 'P', '_', 'C', 'O', 'H', 'E', 'R', '_', 'S', 'I', 'Z', 'E', '\0', /* CP_COHER_SIZE (26517) */
	'C', 'P', '_', 'C', 'O', 'H', 'E', 'R', '_', 'B', 'A', 'S', 'E', '\0', /* CP_COHER_BASE (26531) */
	'C', 'P', '_', 'C', 'O', 'H', 'E', 'R', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* CP_COHER_STATUS (26545) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'M', 'E', '_', 'S', 'R', 'C', '_', 'A', 'D', 'D', 'R', '\0', /* CP_DMA_ME_SRC_ADDR (26561, 26571) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'M', 'E', '_', 'S', 'R', 'C', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_DMA_ME_SRC_ADDR_HI (26580, 26590) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'M', 'E', '_', 'D', 'S', 'T', '_', 'A', 'D', 'D', 'R', '\0', /* CP_DMA_ME_DST_ADDR (26602, 26612) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'M', 'E', '_', 'D', 'S', 'T', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_DMA_ME_DST_ADDR_HI (26621, 26631) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'M', 'E', '_', 'C', 'O', 'M', 'M', 'A', 'N', 'D', '\0', /* CP_DMA_ME_COMMAND (26643, 26653) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'P', 'F', 'P', '_', 'S', 'R', 'C', '_', 'A', 'D', 'D', 'R', '\0', /* CP_DMA_PFP_SRC_ADDR (26661) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'P', 'F', 'P', '_', 'S', 'R', 'C', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_DMA_PFP_SRC_ADDR_HI (26681) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'P', 'F', 'P', '_', 'D', 'S', 'T', '_', 'A', 'D', 'D', 'R', '\0', /* CP_DMA_PFP_DST_ADDR (26704) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'P', 'F', 'P', '_', 'D', 'S', 'T', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_DMA_PFP_DST_ADDR_HI (26724) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'P', 'F', 'P', '_', 'C', 'O', 'M', 'M', 'A', 'N', 'D', '\0', /* CP_DMA_PFP_COMMAND (26747) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'C', 'N', 'T', 'L', '\0', /* CP_DMA_CNTL (26766) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'R', 'E', 'A', 'D', '_', 'T', 'A', 'G', 'S', '\0', /* CP_DMA_READ_TAGS (26778) */
	'C', 'P', '_', 'C', 'O', 'H', 'E', 'R', '_', 'S', 'I', 'Z', 'E', '_', 'H', 'I', '\0', /* CP_COHER_SIZE_HI (26795) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'I', 'B', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CP_PFP_IB_CONTROL (26812, 26819) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'L', 'O', 'A', 'D', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* CP_PFP_LOAD_CONTROL (26830) */
	'C', 'P', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* CP_SCRATCH_INDEX (26850) */
	'C', 'P', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'D', 'A', 'T', 'A', '\0', /* CP_SCRATCH_DATA (26867) */
	'C', 'P', '_', 'R', 'B', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* CP_RB_OFFSET (26883, 26886) */
	'C', 'P', '_', 'I', 'B', '1', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* CP_IB1_OFFSET (26896, 26899) */
	'C', 'P', '_', 'I', 'B', '2', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* CP_IB2_OFFSET (26910, 26913) */
	'C', 'P', '_', 'I', 'B', '1', '_', 'P', 'R', 'E', 'A', 'M', 'B', 'L', 'E', '_', 'B', 'E', 'G', 'I', 'N', '\0', /* CP_IB1_PREAMBLE_BEGIN (26924, 26927) */
	'C', 'P', '_', 'I', 'B', '1', '_', 'P', 'R', 'E', 'A', 'M', 'B', 'L', 'E', '_', 'E', 'N', 'D', '\0', /* CP_IB1_PREAMBLE_END (26946, 26949) */
	'C', 'P', '_', 'I', 'B', '2', '_', 'P', 'R', 'E', 'A', 'M', 'B', 'L', 'E', '_', 'B', 'E', 'G', 'I', 'N', '\0', /* CP_IB2_PREAMBLE_BEGIN (26966, 26969) */
	'C', 'P', '_', 'I', 'B', '2', '_', 'P', 'R', 'E', 'A', 'M', 'B', 'L', 'E', '_', 'E', 'N', 'D', '\0', /* CP_IB2_PREAMBLE_END (26988, 26991) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'B', '1', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* CP_CE_IB1_OFFSET (27008) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'B', '2', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* CP_CE_IB2_OFFSET (27025) */
	'C', 'P', '_', 'C', 'E', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '\0', /* CP_CE_COUNTER (27042) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'M', 'E', '_', 'C', 'M', 'D', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_DMA_ME_CMD_ADDR_LO (27056) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'M', 'E', '_', 'C', 'M', 'D', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_DMA_ME_CMD_ADDR_HI (27078) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'P', 'F', 'P', '_', 'C', 'M', 'D', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_DMA_PFP_CMD_ADDR_LO (27100) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'P', 'F', 'P', '_', 'C', 'M', 'D', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_DMA_PFP_CMD_ADDR_HI (27123) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'C', 'M', 'D', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* CP_APPEND_CMD_ADDR_LO (27146) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'C', 'M', 'D', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_APPEND_CMD_ADDR_HI (27168) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'N', 'I', 'T', '_', 'C', 'M', 'D', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_CE_INIT_CMD_BUFSZ (27190) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'B', '1', '_', 'C', 'M', 'D', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_CE_IB1_CMD_BUFSZ (27211) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'B', '2', '_', 'C', 'M', 'D', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_CE_IB2_CMD_BUFSZ (27231) */
	'C', 'P', '_', 'I', 'B', '1', '_', 'C', 'M', 'D', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_IB1_CMD_BUFSZ (27251) */
	'C', 'P', '_', 'I', 'B', '2', '_', 'C', 'M', 'D', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_IB2_CMD_BUFSZ (27268) */
	'C', 'P', '_', 'S', 'T', '_', 'C', 'M', 'D', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_ST_CMD_BUFSZ (27285) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'N', 'I', 'T', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* CP_CE_INIT_BASE_LO (27301, 27307) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'N', 'I', 'T', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* CP_CE_INIT_BASE_HI (27320, 27326) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'N', 'I', 'T', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_CE_INIT_BUFSZ (27339, 27345) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'B', '1', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* CP_CE_IB1_BASE_LO (27356, 27362) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'B', '1', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* CP_CE_IB1_BASE_HI (27374, 27380) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'B', '1', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_CE_IB1_BUFSZ (27392, 27398) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'B', '2', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* CP_CE_IB2_BASE_LO (27408, 27414) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'B', '2', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* CP_CE_IB2_BASE_HI (27426, 27432) */
	'C', 'P', '_', 'C', 'E', '_', 'I', 'B', '2', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_CE_IB2_BUFSZ (27444, 27450) */
	'C', 'P', '_', 'I', 'B', '1', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* CP_IB1_BASE_LO (27460) */
	'C', 'P', '_', 'I', 'B', '1', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* CP_IB1_BASE_HI (27475) */
	'C', 'P', '_', 'I', 'B', '1', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_IB1_BUFSZ (27490) */
	'C', 'P', '_', 'I', 'B', '2', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* CP_IB2_BASE_LO (27503) */
	'C', 'P', '_', 'I', 'B', '2', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* CP_IB2_BASE_HI (27518) */
	'C', 'P', '_', 'I', 'B', '2', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_IB2_BUFSZ (27533) */
	'C', 'P', '_', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* CP_ST_BASE_LO (27546, 27549) */
	'C', 'P', '_', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* CP_ST_BASE_HI (27560, 27563) */
	'C', 'P', '_', 'S', 'T', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_ST_BUFSZ (27574, 27577) */
	'C', 'P', '_', 'E', 'O', 'P', '_', 'D', 'O', 'N', 'E', '_', 'E', 'V', 'E', 'N', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* CP_EOP_DONE_EVENT_CNTL (27586) */
	'C', 'P', '_', 'E', 'O', 'P', '_', 'D', 'O', 'N', 'E', '_', 'D', 'A', 'T', 'A', '_', 'C', 'N', 'T', 'L', '\0', /* CP_EOP_DONE_DATA_CNTL (27609) */
	'C', 'P', '_', 'E', 'O', 'P', '_', 'D', 'O', 'N', 'E', '_', 'C', 'N', 'T', 'X', '_', 'I', 'D', '\0', /* CP_EOP_DONE_CNTX_ID (27631, 27643) */
	'C', 'P', '_', 'D', 'B', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* CP_DB_BASE_LO (27651, 27654) */
	'C', 'P', '_', 'D', 'B', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* CP_DB_BASE_HI (27665, 27668) */
	'C', 'P', '_', 'D', 'B', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_DB_BUFSZ (27679, 27682) */
	'C', 'P', '_', 'D', 'B', '_', 'C', 'M', 'D', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_DB_CMD_BUFSZ (27691) */
	'C', 'P', '_', 'C', 'E', '_', 'D', 'B', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* CP_CE_DB_BASE_LO (27707) */
	'C', 'P', '_', 'C', 'E', '_', 'D', 'B', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* CP_CE_DB_BASE_HI (27724) */
	'C', 'P', '_', 'C', 'E', '_', 'D', 'B', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_CE_DB_BUFSZ (27741) */
	'C', 'P', '_', 'C', 'E', '_', 'D', 'B', '_', 'C', 'M', 'D', '_', 'B', 'U', 'F', 'S', 'Z', '\0', /* CP_CE_DB_CMD_BUFSZ (27756) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'C', 'O', 'M', 'P', 'L', 'E', 'T', 'I', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* CP_PFP_COMPLETION_STATUS (27775) */
	'C', 'P', '_', 'C', 'E', '_', 'C', 'O', 'M', 'P', 'L', 'E', 'T', 'I', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* CP_CE_COMPLETION_STATUS (27800) */
	'C', 'P', '_', 'P', 'R', 'E', 'D', '_', 'N', 'O', 'T', '_', 'V', 'I', 'S', 'I', 'B', 'L', 'E', '\0', /* CP_PRED_NOT_VISIBLE (27824, 27832) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'M', 'E', 'T', 'A', 'D', 'A', 'T', 'A', '_', 'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', '\0', /* CP_PFP_METADATA_BASE_ADDR (27844) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'M', 'E', 'T', 'A', 'D', 'A', 'T', 'A', '_', 'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_PFP_METADATA_BASE_ADDR_HI (27870) */
	'C', 'P', '_', 'C', 'E', '_', 'M', 'E', 'T', 'A', 'D', 'A', 'T', 'A', '_', 'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', '\0', /* CP_CE_METADATA_BASE_ADDR (27899) */
	'C', 'P', '_', 'C', 'E', '_', 'M', 'E', 'T', 'A', 'D', 'A', 'T', 'A', '_', 'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_CE_METADATA_BASE_ADDR_HI (27924) */
	'C', 'P', '_', 'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'X', '_', 'I', 'N', 'D', 'R', '_', 'A', 'D', 'D', 'R', '\0', /* CP_DRAW_INDX_INDR_ADDR (27952) */
	'C', 'P', '_', 'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'X', '_', 'I', 'N', 'D', 'R', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_DRAW_INDX_INDR_ADDR_HI (27975) */
	'C', 'P', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'I', 'N', 'D', 'R', '_', 'A', 'D', 'D', 'R', '\0', /* CP_DISPATCH_INDR_ADDR (28001) */
	'C', 'P', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'I', 'N', 'D', 'R', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_DISPATCH_INDR_ADDR_HI (28023) */
	'C', 'P', '_', 'I', 'N', 'D', 'E', 'X', '_', 'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', '\0', /* CP_INDEX_BASE_ADDR (28048) */
	'C', 'P', '_', 'I', 'N', 'D', 'E', 'X', '_', 'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_INDEX_BASE_ADDR_HI (28067) */
	'C', 'P', '_', 'I', 'N', 'D', 'E', 'X', '_', 'T', 'Y', 'P', 'E', '\0', /* CP_INDEX_TYPE (28089) */
	'C', 'P', '_', 'G', 'D', 'S', '_', 'B', 'K', 'U', 'P', '_', 'A', 'D', 'D', 'R', '\0', /* CP_GDS_BKUP_ADDR (28103) */
	'C', 'P', '_', 'G', 'D', 'S', '_', 'B', 'K', 'U', 'P', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* CP_GDS_BKUP_ADDR_HI (28120) */
	'C', 'P', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* CP_SAMPLE_STATUS (28140) */
	'C', 'P', '_', 'M', 'E', '_', 'C', 'O', 'H', 'E', 'R', '_', 'C', 'N', 'T', 'L', '\0', /* CP_ME_COHER_CNTL (28157) */
	'C', 'P', '_', 'M', 'E', '_', 'C', 'O', 'H', 'E', 'R', '_', 'S', 'I', 'Z', 'E', '\0', /* CP_ME_COHER_SIZE (28174) */
	'C', 'P', '_', 'M', 'E', '_', 'C', 'O', 'H', 'E', 'R', '_', 'S', 'I', 'Z', 'E', '_', 'H', 'I', '\0', /* CP_ME_COHER_SIZE_HI (28191) */
	'C', 'P', '_', 'M', 'E', '_', 'C', 'O', 'H', 'E', 'R', '_', 'B', 'A', 'S', 'E', '\0', /* CP_ME_COHER_BASE (28211) */
	'C', 'P', '_', 'M', 'E', '_', 'C', 'O', 'H', 'E', 'R', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* CP_ME_COHER_BASE_HI (28228) */
	'C', 'P', '_', 'M', 'E', '_', 'C', 'O', 'H', 'E', 'R', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* CP_ME_COHER_STATUS (28248) */
	'R', 'L', 'C', '_', 'G', 'P', 'M', '_', 'P', 'E', 'R', 'F', '_', 'C', 'O', 'U', 'N', 'T', '_', '0', '\0', /* RLC_GPM_PERF_COUNT_0 (28267) */
	'R', 'L', 'C', '_', 'G', 'P', 'M', '_', 'P', 'E', 'R', 'F', '_', 'C', 'O', 'U', 'N', 'T', '_', '1', '\0', /* RLC_GPM_PERF_COUNT_1 (28288) */
	'G', 'R', 'B', 'M', '_', 'G', 'F', 'X', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* GRBM_GFX_INDEX (28309) */
	'V', 'G', 'T', '_', 'E', 'S', 'G', 'S', '_', 'R', 'I', 'N', 'G', '_', 'S', 'I', 'Z', 'E', '_', 'U', 'M', 'D', '\0', /* VGT_ESGS_RING_SIZE_UMD (28324) */
	'V', 'G', 'T', '_', 'G', 'S', 'V', 'S', '_', 'R', 'I', 'N', 'G', '_', 'S', 'I', 'Z', 'E', '_', 'U', 'M', 'D', '\0', /* VGT_GSVS_RING_SIZE_UMD (28347) */
	'V', 'G', 'T', '_', 'P', 'R', 'I', 'M', 'I', 'T', 'I', 'V', 'E', '_', 'T', 'Y', 'P', 'E', '\0', /* VGT_PRIMITIVE_TYPE (28370) */
	'V', 'G', 'T', '_', 'I', 'N', 'D', 'E', 'X', '_', 'T', 'Y', 'P', 'E', '\0', /* VGT_INDEX_TYPE (28389) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'F', 'I', 'L', 'L', 'E', 'D', '_', 'S', 'I', 'Z', 'E', '_', '0', '\0', /* VGT_STRMOUT_BUFFER_FILLED_SIZE_0 (28404) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'F', 'I', 'L', 'L', 'E', 'D', '_', 'S', 'I', 'Z', 'E', '_', '1', '\0', /* VGT_STRMOUT_BUFFER_FILLED_SIZE_1 (28437) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'F', 'I', 'L', 'L', 'E', 'D', '_', 'S', 'I', 'Z', 'E', '_', '2', '\0', /* VGT_STRMOUT_BUFFER_FILLED_SIZE_2 (28470) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'M', 'O', 'U', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'F', 'I', 'L', 'L', 'E', 'D', '_', 'S', 'I', 'Z', 'E', '_', '3', '\0', /* VGT_STRMOUT_BUFFER_FILLED_SIZE_3 (28503) */
	'G', 'E', '_', 'M', 'I', 'N', '_', 'V', 'T', 'X', '_', 'I', 'N', 'D', 'X', '\0', /* GE_MIN_VTX_INDX (28536) */
	'G', 'E', '_', 'I', 'N', 'D', 'X', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* GE_INDX_OFFSET (28552) */
	'G', 'E', '_', 'M', 'U', 'L', 'T', 'I', '_', 'P', 'R', 'I', 'M', '_', 'I', 'B', '_', 'R', 'E', 'S', 'E', 'T', '_', 'E', 'N', '\0', /* GE_MULTI_PRIM_IB_RESET_EN (28567) */
	'V', 'G', 'T', '_', 'N', 'U', 'M', '_', 'I', 'N', 'D', 'I', 'C', 'E', 'S', '\0', /* VGT_NUM_INDICES (28593) */
	'V', 'G', 'T', '_', 'N', 'U', 'M', '_', 'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', 'S', '\0', /* VGT_NUM_INSTANCES (28609) */
	'V', 'G', 'T', '_', 'T', 'F', '_', 'R', 'I', 'N', 'G', '_', 'S', 'I', 'Z', 'E', '_', 'U', 'M', 'D', '\0', /* VGT_TF_RING_SIZE_UMD (28627) */
	'V', 'G', 'T', '_', 'H', 'S', '_', 'O', 'F', 'F', 'C', 'H', 'I', 'P', '_', 'P', 'A', 'R', 'A', 'M', '_', 'U', 'M', 'D', '\0', /* VGT_HS_OFFCHIP_PARAM_UMD (28648) */
	'V', 'G', 'T', '_', 'T', 'F', '_', 'M', 'E', 'M', 'O', 'R', 'Y', '_', 'B', 'A', 'S', 'E', '_', 'U', 'M', 'D', '\0', /* VGT_TF_MEMORY_BASE_UMD (28673) */
	'G', 'E', '_', 'D', 'M', 'A', '_', 'F', 'I', 'R', 'S', 'T', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* GE_DMA_FIRST_INDEX (28696) */
	'W', 'D', '_', 'P', 'O', 'S', '_', 'B', 'U', 'F', '_', 'B', 'A', 'S', 'E', '\0', /* WD_POS_BUF_BASE (28715) */
	'W', 'D', '_', 'P', 'O', 'S', '_', 'B', 'U', 'F', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* WD_POS_BUF_BASE_HI (28731) */
	'W', 'D', '_', 'C', 'N', 'T', 'L', '_', 'S', 'B', '_', 'B', 'U', 'F', '_', 'B', 'A', 'S', 'E', '\0', /* WD_CNTL_SB_BUF_BASE (28750) */
	'W', 'D', '_', 'C', 'N', 'T', 'L', '_', 'S', 'B', '_', 'B', 'U', 'F', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* WD_CNTL_SB_BUF_BASE_HI (28770) */
	'W', 'D', '_', 'I', 'N', 'D', 'E', 'X', '_', 'B', 'U', 'F', '_', 'B', 'A', 'S', 'E', '\0', /* WD_INDEX_BUF_BASE (28793) */
	'W', 'D', '_', 'I', 'N', 'D', 'E', 'X', '_', 'B', 'U', 'F', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* WD_INDEX_BUF_BASE_HI (28811) */
	'I', 'A', '_', 'M', 'U', 'L', 'T', 'I', '_', 'V', 'G', 'T', '_', 'P', 'A', 'R', 'A', 'M', '_', 'P', 'I', 'P', 'E', 'D', '\0', /* IA_MULTI_VGT_PARAM_PIPED (28832) */
	'G', 'E', '_', 'M', 'A', 'X', '_', 'V', 'T', 'X', '_', 'I', 'N', 'D', 'X', '\0', /* GE_MAX_VTX_INDX (28857) */
	'V', 'G', 'T', '_', 'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', '_', 'B', 'A', 'S', 'E', '_', 'I', 'D', '\0', /* VGT_INSTANCE_BASE_ID (28873, 28888) */
	'G', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* GE_CNTL (28894) */
	'G', 'E', '_', 'U', 'S', 'E', 'R', '_', 'V', 'G', 'P', 'R', '1', '\0', /* GE_USER_VGPR1 (28902) */
	'G', 'E', '_', 'U', 'S', 'E', 'R', '_', 'V', 'G', 'P', 'R', '2', '\0', /* GE_USER_VGPR2 (28916) */
	'G', 'E', '_', 'U', 'S', 'E', 'R', '_', 'V', 'G', 'P', 'R', '3', '\0', /* GE_USER_VGPR3 (28930) */
	'G', 'E', '_', 'S', 'T', 'E', 'R', 'E', 'O', '_', 'C', 'N', 'T', 'L', '\0', /* GE_STEREO_CNTL (28944) */
	'G', 'E', '_', 'P', 'C', '_', 'A', 'L', 'L', 'O', 'C', '\0', /* GE_PC_ALLOC (28959) */
	'V', 'G', 'T', '_', 'T', 'F', '_', 'M', 'E', 'M', 'O', 'R', 'Y', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '_', 'U', 'M', 'D', '\0', /* VGT_TF_MEMORY_BASE_HI_UMD (28971) */
	'G', 'E', '_', 'U', 'S', 'E', 'R', '_', 'V', 'G', 'P', 'R', '_', 'E', 'N', '\0', /* GE_USER_VGPR_EN (28997) */
	'P', 'A', '_', 'S', 'U', '_', 'L', 'I', 'N', 'E', '_', 'S', 'T', 'I', 'P', 'P', 'L', 'E', '_', 'V', 'A', 'L', 'U', 'E', '\0', /* PA_SU_LINE_STIPPLE_VALUE (29013, 29019, 29032) */
	'P', 'A', '_', 'S', 'C', '_', 'L', 'I', 'N', 'E', '_', 'S', 'T', 'I', 'P', 'P', 'L', 'E', '_', 'S', 'T', 'A', 'T', 'E', '\0', /* PA_SC_LINE_STIPPLE_STATE (29038) */
	'P', 'A', '_', 'S', 'C', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'E', 'X', 'T', 'E', 'N', 'T', '_', 'M', 'I', 'N', '_', '0', '\0', /* PA_SC_SCREEN_EXTENT_MIN_0 (29063) */
	'P', 'A', '_', 'S', 'C', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'E', 'X', 'T', 'E', 'N', 'T', '_', 'M', 'A', 'X', '_', '0', '\0', /* PA_SC_SCREEN_EXTENT_MAX_0 (29089) */
	'P', 'A', '_', 'S', 'C', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'E', 'X', 'T', 'E', 'N', 'T', '_', 'M', 'I', 'N', '_', '1', '\0', /* PA_SC_SCREEN_EXTENT_MIN_1 (29115) */
	'P', 'A', '_', 'S', 'C', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'E', 'X', 'T', 'E', 'N', 'T', '_', 'M', 'A', 'X', '_', '1', '\0', /* PA_SC_SCREEN_EXTENT_MAX_1 (29141) */
	'P', 'A', '_', 'S', 'C', '_', 'P', '3', 'D', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'H', 'V', '_', 'E', 'N', '\0', /* PA_SC_P3D_TRAP_SCREEN_HV_EN (29167) */
	'P', 'A', '_', 'S', 'C', '_', 'P', '3', 'D', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'H', '\0', /* PA_SC_P3D_TRAP_SCREEN_H (29195) */
	'P', 'A', '_', 'S', 'C', '_', 'P', '3', 'D', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'V', '\0', /* PA_SC_P3D_TRAP_SCREEN_V (29219) */
	'P', 'A', '_', 'S', 'C', '_', 'P', '3', 'D', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'O', 'C', 'C', 'U', 'R', 'R', 'E', 'N', 'C', 'E', '\0', /* PA_SC_P3D_TRAP_SCREEN_OCCURRENCE (29243) */
	'P', 'A', '_', 'S', 'C', '_', 'P', '3', 'D', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* PA_SC_P3D_TRAP_SCREEN_COUNT (29276) */
	'P', 'A', '_', 'S', 'C', '_', 'H', 'P', '3', 'D', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'H', 'V', '_', 'E', 'N', '\0', /* PA_SC_HP3D_TRAP_SCREEN_HV_EN (29304) */
	'P', 'A', '_', 'S', 'C', '_', 'H', 'P', '3', 'D', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'H', '\0', /* PA_SC_HP3D_TRAP_SCREEN_H (29333) */
	'P', 'A', '_', 'S', 'C', '_', 'H', 'P', '3', 'D', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'V', '\0', /* PA_SC_HP3D_TRAP_SCREEN_V (29358) */
	'P', 'A', '_', 'S', 'C', '_', 'H', 'P', '3', 'D', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'O', 'C', 'C', 'U', 'R', 'R', 'E', 'N', 'C', 'E', '\0', /* PA_SC_HP3D_TRAP_SCREEN_OCCURRENCE (29383) */
	'P', 'A', '_', 'S', 'C', '_', 'H', 'P', '3', 'D', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* PA_SC_HP3D_TRAP_SCREEN_COUNT (29417) */
	'P', 'A', '_', 'S', 'C', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'H', 'V', '_', 'E', 'N', '\0', /* PA_SC_TRAP_SCREEN_HV_EN (29446) */
	'P', 'A', '_', 'S', 'C', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'H', '\0', /* PA_SC_TRAP_SCREEN_H (29470) */
	'P', 'A', '_', 'S', 'C', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'V', '\0', /* PA_SC_TRAP_SCREEN_V (29490) */
	'P', 'A', '_', 'S', 'C', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'O', 'C', 'C', 'U', 'R', 'R', 'E', 'N', 'C', 'E', '\0', /* PA_SC_TRAP_SCREEN_OCCURRENCE (29510) */
	'P', 'A', '_', 'S', 'C', '_', 'T', 'R', 'A', 'P', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* PA_SC_TRAP_SCREEN_COUNT (29539) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'U', 'S', 'E', 'R', 'D', 'A', 'T', 'A', '_', '0', '\0', /* SQ_THREAD_TRACE_USERDATA_0 (29563) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'U', 'S', 'E', 'R', 'D', 'A', 'T', 'A', '_', '1', '\0', /* SQ_THREAD_TRACE_USERDATA_1 (29590) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'U', 'S', 'E', 'R', 'D', 'A', 'T', 'A', '_', '2', '\0', /* SQ_THREAD_TRACE_USERDATA_2 (29617) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'U', 'S', 'E', 'R', 'D', 'A', 'T', 'A', '_', '3', '\0', /* SQ_THREAD_TRACE_USERDATA_3 (29644) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'U', 'S', 'E', 'R', 'D', 'A', 'T', 'A', '_', '4', '\0', /* SQ_THREAD_TRACE_USERDATA_4 (29671) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'U', 'S', 'E', 'R', 'D', 'A', 'T', 'A', '_', '5', '\0', /* SQ_THREAD_TRACE_USERDATA_5 (29698) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'U', 'S', 'E', 'R', 'D', 'A', 'T', 'A', '_', '6', '\0', /* SQ_THREAD_TRACE_USERDATA_6 (29725) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'U', 'S', 'E', 'R', 'D', 'A', 'T', 'A', '_', '7', '\0', /* SQ_THREAD_TRACE_USERDATA_7 (29752) */
	'S', 'Q', 'C', '_', 'C', 'A', 'C', 'H', 'E', 'S', '\0', /* SQC_CACHES (29779) */
	'S', 'Q', 'C', '_', 'W', 'R', 'I', 'T', 'E', 'B', 'A', 'C', 'K', '\0', /* SQC_WRITEBACK (29790, 29794) */
	'T', 'A', '_', 'C', 'S', '_', 'B', 'C', '_', 'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', '\0', /* TA_CS_BC_BASE_ADDR (29804) */
	'T', 'A', '_', 'C', 'S', '_', 'B', 'C', '_', 'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* TA_CS_BC_BASE_ADDR_HI (29823) */
	'D', 'B', '_', 'O', 'C', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '_', 'C', 'O', 'U', 'N', 'T', '0', '_', 'L', 'O', 'W', '\0', /* DB_OCCLUSION_COUNT0_LOW (29845) */
	'D', 'B', '_', 'O', 'C', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '_', 'C', 'O', 'U', 'N', 'T', '0', '_', 'H', 'I', '\0', /* DB_OCCLUSION_COUNT0_HI (29869) */
	'D', 'B', '_', 'O', 'C', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '_', 'C', 'O', 'U', 'N', 'T', '1', '_', 'L', 'O', 'W', '\0', /* DB_OCCLUSION_COUNT1_LOW (29892) */
	'D', 'B', '_', 'O', 'C', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '_', 'C', 'O', 'U', 'N', 'T', '1', '_', 'H', 'I', '\0', /* DB_OCCLUSION_COUNT1_HI (29916) */
	'D', 'B', '_', 'O', 'C', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '_', 'C', 'O', 'U', 'N', 'T', '2', '_', 'L', 'O', 'W', '\0', /* DB_OCCLUSION_COUNT2_LOW (29939) */
	'D', 'B', '_', 'O', 'C', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '_', 'C', 'O', 'U', 'N', 'T', '2', '_', 'H', 'I', '\0', /* DB_OCCLUSION_COUNT2_HI (29963) */
	'D', 'B', '_', 'O', 'C', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '_', 'C', 'O', 'U', 'N', 'T', '3', '_', 'L', 'O', 'W', '\0', /* DB_OCCLUSION_COUNT3_LOW (29986) */
	'D', 'B', '_', 'O', 'C', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '_', 'C', 'O', 'U', 'N', 'T', '3', '_', 'H', 'I', '\0', /* DB_OCCLUSION_COUNT3_HI (30010) */
	'D', 'B', '_', 'Z', 'P', 'A', 'S', 'S', '_', 'C', 'O', 'U', 'N', 'T', '_', 'L', 'O', 'W', '\0', /* DB_ZPASS_COUNT_LOW (30033) */
	'D', 'B', '_', 'Z', 'P', 'A', 'S', 'S', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', '\0', /* DB_ZPASS_COUNT_HI (30052) */
	'G', 'D', 'S', '_', 'R', 'D', '_', 'A', 'D', 'D', 'R', '\0', /* GDS_RD_ADDR (30070) */
	'G', 'D', 'S', '_', 'R', 'D', '_', 'D', 'A', 'T', 'A', '\0', /* GDS_RD_DATA (30082) */
	'G', 'D', 'S', '_', 'R', 'D', '_', 'B', 'U', 'R', 'S', 'T', '_', 'A', 'D', 'D', 'R', '\0', /* GDS_RD_BURST_ADDR (30094) */
	'G', 'D', 'S', '_', 'R', 'D', '_', 'B', 'U', 'R', 'S', 'T', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* GDS_RD_BURST_COUNT (30112) */
	'G', 'D', 'S', '_', 'R', 'D', '_', 'B', 'U', 'R', 'S', 'T', '_', 'D', 'A', 'T', 'A', '\0', /* GDS_RD_BURST_DATA (30131) */
	'G', 'D', 'S', '_', 'W', 'R', '_', 'A', 'D', 'D', 'R', '\0', /* GDS_WR_ADDR (30149) */
	'G', 'D', 'S', '_', 'W', 'R', '_', 'D', 'A', 'T', 'A', '\0', /* GDS_WR_DATA (30161) */
	'G', 'D', 'S', '_', 'W', 'R', '_', 'B', 'U', 'R', 'S', 'T', '_', 'A', 'D', 'D', 'R', '\0', /* GDS_WR_BURST_ADDR (30173) */
	'G', 'D', 'S', '_', 'W', 'R', '_', 'B', 'U', 'R', 'S', 'T', '_', 'D', 'A', 'T', 'A', '\0', /* GDS_WR_BURST_DATA (30191) */
	'G', 'D', 'S', '_', 'W', 'R', 'I', 'T', 'E', '_', 'C', 'O', 'M', 'P', 'L', 'E', 'T', 'E', '\0', /* GDS_WRITE_COMPLETE (30209, 30219) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'C', 'N', 'T', 'L', '\0', /* GDS_ATOM_CNTL (30228) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'C', 'O', 'M', 'P', 'L', 'E', 'T', 'E', '\0', /* GDS_ATOM_COMPLETE (30242) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'B', 'A', 'S', 'E', '\0', /* GDS_ATOM_BASE (30260) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'S', 'I', 'Z', 'E', '\0', /* GDS_ATOM_SIZE (30274) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'O', 'F', 'F', 'S', 'E', 'T', '0', '\0', /* GDS_ATOM_OFFSET0 (30288, 30297) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'O', 'F', 'F', 'S', 'E', 'T', '1', '\0', /* GDS_ATOM_OFFSET1 (30305, 30314) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'D', 'S', 'T', '\0', /* GDS_ATOM_DST (30322, 30331) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'O', 'P', '\0', /* GDS_ATOM_OP (30335) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'S', 'R', 'C', '0', '\0', /* GDS_ATOM_SRC0 (30347, 30356) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'S', 'R', 'C', '0', '_', 'U', '\0', /* GDS_ATOM_SRC0_U (30361) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'S', 'R', 'C', '1', '\0', /* GDS_ATOM_SRC1 (30377) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'S', 'R', 'C', '1', '_', 'U', '\0', /* GDS_ATOM_SRC1_U (30391) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'R', 'E', 'A', 'D', '0', '\0', /* GDS_ATOM_READ0 (30407) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'R', 'E', 'A', 'D', '0', '_', 'U', '\0', /* GDS_ATOM_READ0_U (30422) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'R', 'E', 'A', 'D', '1', '\0', /* GDS_ATOM_READ1 (30439) */
	'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', '_', 'R', 'E', 'A', 'D', '1', '_', 'U', '\0', /* GDS_ATOM_READ1_U (30454) */
	'G', 'D', 'S', '_', 'G', 'W', 'S', '_', 'R', 'E', 'S', 'O', 'U', 'R', 'C', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* GDS_GWS_RESOURCE_CNTL (30471) */
	'G', 'D', 'S', '_', 'G', 'W', 'S', '_', 'R', 'E', 'S', 'O', 'U', 'R', 'C', 'E', '\0', /* GDS_GWS_RESOURCE (30493, 30503) */
	'G', 'D', 'S', '_', 'G', 'W', 'S', '_', 'R', 'E', 'S', 'O', 'U', 'R', 'C', 'E', '_', 'C', 'N', 'T', '\0', /* GDS_GWS_RESOURCE_CNT (30510, 30518) */
	'G', 'D', 'S', '_', 'O', 'A', '_', 'C', 'N', 'T', 'L', '\0', /* GDS_OA_CNTL (30531) */
	'G', 'D', 'S', '_', 'O', 'A', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '\0', /* GDS_OA_COUNTER (30543) */
	'G', 'D', 'S', '_', 'O', 'A', '_', 'A', 'D', 'D', 'R', 'E', 'S', 'S', '\0', /* GDS_OA_ADDRESS (30558, 30565) */
	'G', 'D', 'S', '_', 'O', 'A', '_', 'I', 'N', 'C', 'D', 'E', 'C', '\0', /* GDS_OA_INCDEC (30573, 30580) */
	'G', 'D', 'S', '_', 'O', 'A', '_', 'R', 'I', 'N', 'G', '_', 'S', 'I', 'Z', 'E', '\0', /* GDS_OA_RING_SIZE (30587) */
	'S', 'P', 'I', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'C', 'N', 'T', 'L', '_', 'R', 'E', 'M', 'A', 'P', '\0', /* SPI_CONFIG_CNTL_REMAP (30604) */
	'S', 'P', 'I', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'C', 'N', 'T', 'L', '_', '1', '_', 'R', 'E', 'M', 'A', 'P', '\0', /* SPI_CONFIG_CNTL_1_REMAP (30626) */
	'S', 'P', 'I', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'C', 'N', 'T', 'L', '_', '2', '_', 'R', 'E', 'M', 'A', 'P', '\0', /* SPI_CONFIG_CNTL_2_REMAP (30650) */
	'S', 'P', 'I', '_', 'W', 'A', 'V', 'E', '_', 'L', 'I', 'M', 'I', 'T', '_', 'C', 'N', 'T', 'L', '_', 'R', 'E', 'M', 'A', 'P', '\0', /* SPI_WAVE_LIMIT_CNTL_REMAP (30674) */
	'C', 'P', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* CPG_PERFCOUNTER1_LO (30700) */
	'C', 'P', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* CPG_PERFCOUNTER1_HI (30720) */
	'C', 'P', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* CPG_PERFCOUNTER0_LO (30740) */
	'C', 'P', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* CPG_PERFCOUNTER0_HI (30760) */
	'C', 'P', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* CPC_PERFCOUNTER1_LO (30780) */
	'C', 'P', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* CPC_PERFCOUNTER1_HI (30800) */
	'C', 'P', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* CPC_PERFCOUNTER0_LO (30820) */
	'C', 'P', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* CPC_PERFCOUNTER0_HI (30840) */
	'C', 'P', 'F', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* CPF_PERFCOUNTER1_LO (30860) */
	'C', 'P', 'F', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* CPF_PERFCOUNTER1_HI (30880) */
	'C', 'P', 'F', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* CPF_PERFCOUNTER0_LO (30900) */
	'C', 'P', 'F', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* CPF_PERFCOUNTER0_HI (30920) */
	'C', 'P', 'F', '_', 'L', 'A', 'T', 'E', 'N', 'C', 'Y', '_', 'S', 'T', 'A', 'T', 'S', '_', 'D', 'A', 'T', 'A', '\0', /* CPF_LATENCY_STATS_DATA (30940) */
	'C', 'P', 'G', '_', 'L', 'A', 'T', 'E', 'N', 'C', 'Y', '_', 'S', 'T', 'A', 'T', 'S', '_', 'D', 'A', 'T', 'A', '\0', /* CPG_LATENCY_STATS_DATA (30963) */
	'C', 'P', 'C', '_', 'L', 'A', 'T', 'E', 'N', 'C', 'Y', '_', 'S', 'T', 'A', 'T', 'S', '_', 'D', 'A', 'T', 'A', '\0', /* CPC_LATENCY_STATS_DATA (30986) */
	'G', 'R', 'B', 'M', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GRBM_PERFCOUNTER0_LO (31009) */
	'G', 'R', 'B', 'M', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GRBM_PERFCOUNTER0_HI (31030) */
	'G', 'R', 'B', 'M', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GRBM_PERFCOUNTER1_LO (31051) */
	'G', 'R', 'B', 'M', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GRBM_PERFCOUNTER1_HI (31072) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* GRBM_SE0_PERFCOUNTER_LO (31093) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* GRBM_SE0_PERFCOUNTER_HI (31117, 31126, 31130) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* GRBM_SE1_PERFCOUNTER_LO (31141) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* GRBM_SE1_PERFCOUNTER_HI (31165) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* GRBM_SE2_PERFCOUNTER_LO (31189) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* GRBM_SE2_PERFCOUNTER_HI (31213) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* GRBM_SE3_PERFCOUNTER_LO (31237) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* GRBM_SE3_PERFCOUNTER_HI (31261) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER0_LO (31285) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER0_HI (31304) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER1_LO (31323) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER1_HI (31342) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER2_LO (31361) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER2_HI (31380) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER3_LO (31399) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER3_HI (31418) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER4_LO (31437) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER4_HI (31456) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER5_LO (31475) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER5_HI (31494) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER6_LO (31513) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER6_HI (31532) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER7_LO (31551) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER7_HI (31570) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '8', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER8_LO (31589) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '8', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER8_HI (31608) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '9', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER9_LO (31627) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '9', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER9_HI (31646) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '0', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER10_LO (31665) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '0', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER10_HI (31685) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '1', '_', 'L', 'O', '\0', /* GE_PERFCOUNTER11_LO (31705) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '1', '_', 'H', 'I', '\0', /* GE_PERFCOUNTER11_HI (31725) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* PA_SU_PERFCOUNTER0_LO (31745) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* PA_SU_PERFCOUNTER0_HI (31767) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* PA_SU_PERFCOUNTER1_LO (31789) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* PA_SU_PERFCOUNTER1_HI (31811) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* PA_SU_PERFCOUNTER2_LO (31833) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* PA_SU_PERFCOUNTER2_HI (31855) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* PA_SU_PERFCOUNTER3_LO (31877) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* PA_SU_PERFCOUNTER3_HI (31899) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* PA_SC_PERFCOUNTER0_LO (31921) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* PA_SC_PERFCOUNTER0_HI (31943) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* PA_SC_PERFCOUNTER1_LO (31965) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* PA_SC_PERFCOUNTER1_HI (31987) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* PA_SC_PERFCOUNTER2_LO (32009) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* PA_SC_PERFCOUNTER2_HI (32031) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* PA_SC_PERFCOUNTER3_LO (32053) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* PA_SC_PERFCOUNTER3_HI (32075) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'L', 'O', '\0', /* PA_SC_PERFCOUNTER4_LO (32097) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'H', 'I', '\0', /* PA_SC_PERFCOUNTER4_HI (32119) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'L', 'O', '\0', /* PA_SC_PERFCOUNTER5_LO (32141) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'H', 'I', '\0', /* PA_SC_PERFCOUNTER5_HI (32163) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'L', 'O', '\0', /* PA_SC_PERFCOUNTER6_LO (32185) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'H', 'I', '\0', /* PA_SC_PERFCOUNTER6_HI (32207) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'L', 'O', '\0', /* PA_SC_PERFCOUNTER7_LO (32229) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'H', 'I', '\0', /* PA_SC_PERFCOUNTER7_HI (32251) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* SPI_PERFCOUNTER0_HI (32273) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* SPI_PERFCOUNTER0_LO (32293) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* SPI_PERFCOUNTER1_HI (32313) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* SPI_PERFCOUNTER1_LO (32333) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* SPI_PERFCOUNTER2_HI (32353) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* SPI_PERFCOUNTER2_LO (32373) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* SPI_PERFCOUNTER3_HI (32393) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* SPI_PERFCOUNTER3_LO (32413) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'H', 'I', '\0', /* SPI_PERFCOUNTER4_HI (32433) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'L', 'O', '\0', /* SPI_PERFCOUNTER4_LO (32453) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'H', 'I', '\0', /* SPI_PERFCOUNTER5_HI (32473) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'L', 'O', '\0', /* SPI_PERFCOUNTER5_LO (32493) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER0_LO (32513) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER0_HI (32532) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER1_LO (32551) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER1_HI (32570) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER2_LO (32589) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER2_HI (32608) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER3_LO (32627) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER3_HI (32646) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER4_LO (32665) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER4_HI (32684) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER5_LO (32703) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER5_HI (32722) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER6_LO (32741) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER6_HI (32760) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER7_LO (32779) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER7_HI (32798) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '8', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER8_LO (32817) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '8', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER8_HI (32836) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '9', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER9_LO (32855) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '9', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER9_HI (32874) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '0', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER10_LO (32893) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '0', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER10_HI (32913) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '1', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER11_LO (32933) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '1', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER11_HI (32953) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '2', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER12_LO (32973) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '2', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER12_HI (32993) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '3', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER13_LO (33013) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '3', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER13_HI (33033) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '4', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER14_LO (33053) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '4', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER14_HI (33073) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '5', '_', 'L', 'O', '\0', /* SQ_PERFCOUNTER15_LO (33093) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '5', '_', 'H', 'I', '\0', /* SQ_PERFCOUNTER15_HI (33113) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* SX_PERFCOUNTER0_LO (33133) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* SX_PERFCOUNTER0_HI (33152) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* SX_PERFCOUNTER1_LO (33171) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* SX_PERFCOUNTER1_HI (33190) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* SX_PERFCOUNTER2_LO (33209) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* SX_PERFCOUNTER2_HI (33228) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* SX_PERFCOUNTER3_LO (33247) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* SX_PERFCOUNTER3_HI (33266) */
	'G', 'C', 'E', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GCEA_PERFCOUNTER2_LO (33285) */
	'G', 'C', 'E', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GCEA_PERFCOUNTER2_HI (33306) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GDS_PERFCOUNTER0_LO (33327) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GDS_PERFCOUNTER0_HI (33347) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GDS_PERFCOUNTER1_LO (33367) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GDS_PERFCOUNTER1_HI (33387) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GDS_PERFCOUNTER2_LO (33407) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GDS_PERFCOUNTER2_HI (33427) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* GDS_PERFCOUNTER3_LO (33447) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* GDS_PERFCOUNTER3_HI (33467) */
	'T', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* TA_PERFCOUNTER0_LO (33487) */
	'T', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* TA_PERFCOUNTER0_HI (33506) */
	'T', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* TA_PERFCOUNTER1_LO (33525) */
	'T', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* TA_PERFCOUNTER1_HI (33544) */
	'T', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* TD_PERFCOUNTER0_LO (33563) */
	'T', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* TD_PERFCOUNTER0_HI (33582) */
	'T', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* TD_PERFCOUNTER1_LO (33601) */
	'T', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* TD_PERFCOUNTER1_HI (33620) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* TCP_PERFCOUNTER0_LO (33639) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* TCP_PERFCOUNTER0_HI (33659) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* TCP_PERFCOUNTER1_LO (33679) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* TCP_PERFCOUNTER1_HI (33699) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* TCP_PERFCOUNTER2_LO (33719) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* TCP_PERFCOUNTER2_HI (33739) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* TCP_PERFCOUNTER3_LO (33759) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* TCP_PERFCOUNTER3_HI (33779) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GL2C_PERFCOUNTER0_LO (33799) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GL2C_PERFCOUNTER0_HI (33820) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GL2C_PERFCOUNTER1_LO (33841) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GL2C_PERFCOUNTER1_HI (33862) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GL2C_PERFCOUNTER2_LO (33883) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GL2C_PERFCOUNTER2_HI (33904) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* GL2C_PERFCOUNTER3_LO (33925) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* GL2C_PERFCOUNTER3_HI (33946) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GL2A_PERFCOUNTER0_LO (33967) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GL2A_PERFCOUNTER0_HI (33988) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GL2A_PERFCOUNTER1_LO (34009) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GL2A_PERFCOUNTER1_HI (34030) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GL2A_PERFCOUNTER2_LO (34051) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GL2A_PERFCOUNTER2_HI (34072) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* GL2A_PERFCOUNTER3_LO (34093) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* GL2A_PERFCOUNTER3_HI (34114) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GL1C_PERFCOUNTER0_LO (34135) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GL1C_PERFCOUNTER0_HI (34156) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GL1C_PERFCOUNTER1_LO (34177) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GL1C_PERFCOUNTER1_HI (34198) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GL1C_PERFCOUNTER2_LO (34219) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GL1C_PERFCOUNTER2_HI (34240) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* GL1C_PERFCOUNTER3_LO (34261) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* GL1C_PERFCOUNTER3_HI (34282) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* CHC_PERFCOUNTER0_LO (34303) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* CHC_PERFCOUNTER0_HI (34323) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* CHC_PERFCOUNTER1_LO (34343) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* CHC_PERFCOUNTER1_HI (34363) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* CHC_PERFCOUNTER2_LO (34383) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* CHC_PERFCOUNTER2_HI (34403) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* CHC_PERFCOUNTER3_LO (34423) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* CHC_PERFCOUNTER3_HI (34443) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* CHCG_PERFCOUNTER0_LO (34463) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* CHCG_PERFCOUNTER0_HI (34484) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* CHCG_PERFCOUNTER1_LO (34505) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* CHCG_PERFCOUNTER1_HI (34526) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* CHCG_PERFCOUNTER2_LO (34547) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* CHCG_PERFCOUNTER2_HI (34568) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* CHCG_PERFCOUNTER3_LO (34589) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* CHCG_PERFCOUNTER3_HI (34610) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* CB_PERFCOUNTER0_LO (34631) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* CB_PERFCOUNTER0_HI (34650) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* CB_PERFCOUNTER1_LO (34669) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* CB_PERFCOUNTER1_HI (34688) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* CB_PERFCOUNTER2_LO (34707) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* CB_PERFCOUNTER2_HI (34726) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* CB_PERFCOUNTER3_LO (34745) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* CB_PERFCOUNTER3_HI (34764) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* DB_PERFCOUNTER0_LO (34783) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* DB_PERFCOUNTER0_HI (34802) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* DB_PERFCOUNTER1_LO (34821) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* DB_PERFCOUNTER1_HI (34840) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* DB_PERFCOUNTER2_LO (34859) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* DB_PERFCOUNTER2_HI (34878) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* DB_PERFCOUNTER3_LO (34897) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* DB_PERFCOUNTER3_HI (34916) */
	'R', 'L', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* RLC_PERFCOUNTER0_LO (34935) */
	'R', 'L', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* RLC_PERFCOUNTER0_HI (34955) */
	'R', 'L', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* RLC_PERFCOUNTER1_LO (34975) */
	'R', 'L', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* RLC_PERFCOUNTER1_HI (34995) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* RMI_PERFCOUNTER0_LO (35015) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* RMI_PERFCOUNTER0_HI (35035) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* RMI_PERFCOUNTER1_LO (35055) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* RMI_PERFCOUNTER1_HI (35075) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* RMI_PERFCOUNTER2_LO (35095) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* RMI_PERFCOUNTER2_HI (35115) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* RMI_PERFCOUNTER3_LO (35135) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* RMI_PERFCOUNTER3_HI (35155) */
	'G', 'C', '_', 'A', 'T', 'C', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* GC_ATC_L2_PERFCOUNTER_LO (35175, 35178) */
	'G', 'C', '_', 'A', 'T', 'C', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* GC_ATC_L2_PERFCOUNTER_HI (35200, 35203) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* GCMC_VM_L2_PERFCOUNTER_LO (35225, 35227) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* GCMC_VM_L2_PERFCOUNTER_HI (35251, 35253) */
	'G', 'C', 'V', 'M', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', '0', '_', 'L', 'O', '\0', /* GCVML2_PERFCOUNTER2_0_LO (35277) */
	'G', 'C', 'V', 'M', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', '1', '_', 'L', 'O', '\0', /* GCVML2_PERFCOUNTER2_1_LO (35302) */
	'G', 'C', 'V', 'M', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', '0', '_', 'H', 'I', '\0', /* GCVML2_PERFCOUNTER2_0_HI (35327) */
	'G', 'C', 'V', 'M', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', '1', '_', 'H', 'I', '\0', /* GCVML2_PERFCOUNTER2_1_HI (35352) */
	'G', 'C', '_', 'A', 'T', 'C', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GC_ATC_L2_PERFCOUNTER2_LO (35377) */
	'G', 'C', '_', 'A', 'T', 'C', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GC_ATC_L2_PERFCOUNTER2_HI (35403) */
	'U', 'T', 'C', 'L', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* UTCL1_PERFCOUNTER0_LO (35429) */
	'U', 'T', 'C', 'L', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* UTCL1_PERFCOUNTER0_HI (35451) */
	'U', 'T', 'C', 'L', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* UTCL1_PERFCOUNTER1_LO (35473) */
	'U', 'T', 'C', 'L', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* UTCL1_PERFCOUNTER1_HI (35495) */
	'G', 'C', 'R', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GCR_PERFCOUNTER0_LO (35517) */
	'G', 'C', 'R', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GCR_PERFCOUNTER0_HI (35537) */
	'G', 'C', 'R', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GCR_PERFCOUNTER1_LO (35557) */
	'G', 'C', 'R', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GCR_PERFCOUNTER1_HI (35577) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* PA_PH_PERFCOUNTER0_LO (35597) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* PA_PH_PERFCOUNTER0_HI (35619) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* PA_PH_PERFCOUNTER1_LO (35641) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* PA_PH_PERFCOUNTER1_HI (35663) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* PA_PH_PERFCOUNTER2_LO (35685) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* PA_PH_PERFCOUNTER2_HI (35707) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* PA_PH_PERFCOUNTER3_LO (35729) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* PA_PH_PERFCOUNTER3_HI (35751) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'L', 'O', '\0', /* PA_PH_PERFCOUNTER4_LO (35773) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'H', 'I', '\0', /* PA_PH_PERFCOUNTER4_HI (35795) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'L', 'O', '\0', /* PA_PH_PERFCOUNTER5_LO (35817) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'H', 'I', '\0', /* PA_PH_PERFCOUNTER5_HI (35839) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'L', 'O', '\0', /* PA_PH_PERFCOUNTER6_LO (35861) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'H', 'I', '\0', /* PA_PH_PERFCOUNTER6_HI (35883) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'L', 'O', '\0', /* PA_PH_PERFCOUNTER7_LO (35905) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'H', 'I', '\0', /* PA_PH_PERFCOUNTER7_HI (35927) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GL1A_PERFCOUNTER0_LO (35949) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GL1A_PERFCOUNTER0_HI (35970) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GL1A_PERFCOUNTER1_LO (35991) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GL1A_PERFCOUNTER1_HI (36012) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GL1A_PERFCOUNTER2_LO (36033) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GL1A_PERFCOUNTER2_HI (36054) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* GL1A_PERFCOUNTER3_LO (36075) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* GL1A_PERFCOUNTER3_HI (36096) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* CHA_PERFCOUNTER0_LO (36117) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* CHA_PERFCOUNTER0_HI (36137) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* CHA_PERFCOUNTER1_LO (36157) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* CHA_PERFCOUNTER1_HI (36177) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* CHA_PERFCOUNTER2_LO (36197) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* CHA_PERFCOUNTER2_HI (36217) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* CHA_PERFCOUNTER3_LO (36237) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* CHA_PERFCOUNTER3_HI (36257) */
	'G', 'U', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GUS_PERFCOUNTER2_LO (36277) */
	'G', 'U', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GUS_PERFCOUNTER2_HI (36297) */
	'C', 'P', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPG_PERFCOUNTER1_SELECT (36317) */
	'C', 'P', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* CPG_PERFCOUNTER0_SELECT1 (36341) */
	'C', 'P', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPG_PERFCOUNTER0_SELECT (36366) */
	'C', 'P', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPC_PERFCOUNTER1_SELECT (36390) */
	'C', 'P', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* CPC_PERFCOUNTER0_SELECT1 (36414) */
	'C', 'P', 'F', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPF_PERFCOUNTER1_SELECT (36439) */
	'C', 'P', 'F', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* CPF_PERFCOUNTER0_SELECT1 (36463) */
	'C', 'P', 'F', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPF_PERFCOUNTER0_SELECT (36488) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'C', 'N', 'T', 'L', '\0', /* CP_PERFMON_CNTL (36512) */
	'C', 'P', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPC_PERFCOUNTER0_SELECT (36528) */
	'C', 'P', 'F', '_', 'T', 'C', '_', 'P', 'E', 'R', 'F', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPF_TC_PERF_COUNTER_WINDOW_SELECT (36552) */
	'C', 'P', 'G', '_', 'T', 'C', '_', 'P', 'E', 'R', 'F', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPG_TC_PERF_COUNTER_WINDOW_SELECT (36586) */
	'C', 'P', 'F', '_', 'L', 'A', 'T', 'E', 'N', 'C', 'Y', '_', 'S', 'T', 'A', 'T', 'S', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPF_LATENCY_STATS_SELECT (36620) */
	'C', 'P', 'G', '_', 'L', 'A', 'T', 'E', 'N', 'C', 'Y', '_', 'S', 'T', 'A', 'T', 'S', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPG_LATENCY_STATS_SELECT (36645) */
	'C', 'P', 'C', '_', 'L', 'A', 'T', 'E', 'N', 'C', 'Y', '_', 'S', 'T', 'A', 'T', 'S', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CPC_LATENCY_STATS_SELECT (36670) */
	'C', 'P', '_', 'D', 'R', 'A', 'W', '_', 'O', 'B', 'J', 'E', 'C', 'T', '\0', /* CP_DRAW_OBJECT (36695) */
	'C', 'P', '_', 'D', 'R', 'A', 'W', '_', 'O', 'B', 'J', 'E', 'C', 'T', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '\0', /* CP_DRAW_OBJECT_COUNTER (36710) */
	'C', 'P', '_', 'D', 'R', 'A', 'W', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'M', 'A', 'S', 'K', '_', 'H', 'I', '\0', /* CP_DRAW_WINDOW_MASK_HI (36733) */
	'C', 'P', '_', 'D', 'R', 'A', 'W', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'H', 'I', '\0', /* CP_DRAW_WINDOW_HI (36756) */
	'C', 'P', '_', 'D', 'R', 'A', 'W', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'L', 'O', '\0', /* CP_DRAW_WINDOW_LO (36774) */
	'C', 'P', '_', 'D', 'R', 'A', 'W', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'C', 'N', 'T', 'L', '\0', /* CP_DRAW_WINDOW_CNTL (36792) */
	'G', 'R', 'B', 'M', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GRBM_PERFCOUNTER0_SELECT (36812) */
	'G', 'R', 'B', 'M', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GRBM_PERFCOUNTER1_SELECT (36837) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GRBM_SE0_PERFCOUNTER_SELECT (36862, 36871) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GRBM_SE1_PERFCOUNTER_SELECT (36890) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GRBM_SE2_PERFCOUNTER_SELECT (36918) */
	'G', 'R', 'B', 'M', '_', 'S', 'E', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GRBM_SE3_PERFCOUNTER_SELECT (36946) */
	'G', 'R', 'B', 'M', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '_', 'H', 'I', '\0', /* GRBM_PERFCOUNTER0_SELECT_HI (36974) */
	'G', 'R', 'B', 'M', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '_', 'H', 'I', '\0', /* GRBM_PERFCOUNTER1_SELECT_HI (37002) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER0_SELECT (37030) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE_PERFCOUNTER0_SELECT1 (37053) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER1_SELECT (37077) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE_PERFCOUNTER1_SELECT1 (37100) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER2_SELECT (37124) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE_PERFCOUNTER2_SELECT1 (37147) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER3_SELECT (37171) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE_PERFCOUNTER3_SELECT1 (37194) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER4_SELECT (37218) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER5_SELECT (37241) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER6_SELECT (37264) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER7_SELECT (37287) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '8', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER8_SELECT (37310) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '9', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER9_SELECT (37333) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER10_SELECT (37356) */
	'G', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE_PERFCOUNTER11_SELECT (37380) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SU_PERFCOUNTER0_SELECT (37404) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* PA_SU_PERFCOUNTER0_SELECT1 (37430) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SU_PERFCOUNTER1_SELECT (37457) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* PA_SU_PERFCOUNTER1_SELECT1 (37483) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SU_PERFCOUNTER2_SELECT (37510) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* PA_SU_PERFCOUNTER2_SELECT1 (37536) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SU_PERFCOUNTER3_SELECT (37563) */
	'P', 'A', '_', 'S', 'U', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* PA_SU_PERFCOUNTER3_SELECT1 (37589) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SC_PERFCOUNTER0_SELECT (37616) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* PA_SC_PERFCOUNTER0_SELECT1 (37642) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SC_PERFCOUNTER1_SELECT (37669) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SC_PERFCOUNTER2_SELECT (37695) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SC_PERFCOUNTER3_SELECT (37721) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SC_PERFCOUNTER4_SELECT (37747) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SC_PERFCOUNTER5_SELECT (37773) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SC_PERFCOUNTER6_SELECT (37799) */
	'P', 'A', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_SC_PERFCOUNTER7_SELECT (37825) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SPI_PERFCOUNTER0_SELECT (37851) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SPI_PERFCOUNTER1_SELECT (37875) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SPI_PERFCOUNTER2_SELECT (37899) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SPI_PERFCOUNTER3_SELECT (37923) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SPI_PERFCOUNTER0_SELECT1 (37947) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SPI_PERFCOUNTER1_SELECT1 (37972) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SPI_PERFCOUNTER2_SELECT1 (37997) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SPI_PERFCOUNTER3_SELECT1 (38022) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SPI_PERFCOUNTER4_SELECT (38047) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SPI_PERFCOUNTER5_SELECT (38071) */
	'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'B', 'I', 'N', 'S', '\0', /* SPI_PERFCOUNTER_BINS (38095) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER0_SELECT (38116) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER1_SELECT (38139) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER2_SELECT (38162) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER3_SELECT (38185) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER4_SELECT (38208) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER5_SELECT (38231) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER6_SELECT (38254) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER7_SELECT (38277) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '8', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER8_SELECT (38300) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '9', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER9_SELECT (38323) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER10_SELECT (38346) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER11_SELECT (38370) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER12_SELECT (38394) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER13_SELECT (38418) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '4', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER14_SELECT (38442) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '5', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SQ_PERFCOUNTER15_SELECT (38466) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'C', 'T', 'R', 'L', '\0', /* SQ_PERFCOUNTER_CTRL (38490) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'C', 'T', 'R', 'L', '2', '\0', /* SQ_PERFCOUNTER_CTRL2 (38510) */
	'G', 'C', 'E', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GCEA_PERFCOUNTER2_SELECT (38531) */
	'G', 'C', 'E', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GCEA_PERFCOUNTER2_SELECT1 (38556) */
	'G', 'C', 'E', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'M', 'O', 'D', 'E', '\0', /* GCEA_PERFCOUNTER2_MODE (38582) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SX_PERFCOUNTER0_SELECT (38605) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SX_PERFCOUNTER1_SELECT (38628) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SX_PERFCOUNTER2_SELECT (38651) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SX_PERFCOUNTER3_SELECT (38674) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SX_PERFCOUNTER0_SELECT1 (38697) */
	'S', 'X', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SX_PERFCOUNTER1_SELECT1 (38721) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GDS_PERFCOUNTER0_SELECT (38745) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GDS_PERFCOUNTER1_SELECT (38769) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GDS_PERFCOUNTER2_SELECT (38793) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GDS_PERFCOUNTER3_SELECT (38817) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GDS_PERFCOUNTER0_SELECT1 (38841) */
	'T', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TA_PERFCOUNTER0_SELECT (38866) */
	'T', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* TA_PERFCOUNTER0_SELECT1 (38889) */
	'T', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TA_PERFCOUNTER1_SELECT (38913) */
	'T', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TD_PERFCOUNTER0_SELECT (38936) */
	'T', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* TD_PERFCOUNTER0_SELECT1 (38959) */
	'T', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TD_PERFCOUNTER1_SELECT (38983) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCP_PERFCOUNTER0_SELECT (39006) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* TCP_PERFCOUNTER0_SELECT1 (39030) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCP_PERFCOUNTER1_SELECT (39055) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* TCP_PERFCOUNTER1_SELECT1 (39079) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCP_PERFCOUNTER2_SELECT (39104) */
	'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCP_PERFCOUNTER3_SELECT (39128) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL2C_PERFCOUNTER0_SELECT (39152) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GL2C_PERFCOUNTER0_SELECT1 (39177) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL2C_PERFCOUNTER1_SELECT (39203) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GL2C_PERFCOUNTER1_SELECT1 (39228) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL2C_PERFCOUNTER2_SELECT (39254) */
	'G', 'L', '2', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL2C_PERFCOUNTER3_SELECT (39279) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL2A_PERFCOUNTER0_SELECT (39304) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GL2A_PERFCOUNTER0_SELECT1 (39329) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL2A_PERFCOUNTER1_SELECT (39355) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GL2A_PERFCOUNTER1_SELECT1 (39380) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL2A_PERFCOUNTER2_SELECT (39406) */
	'G', 'L', '2', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL2A_PERFCOUNTER3_SELECT (39431) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL1C_PERFCOUNTER0_SELECT (39456) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GL1C_PERFCOUNTER0_SELECT1 (39481) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL1C_PERFCOUNTER1_SELECT (39507) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL1C_PERFCOUNTER2_SELECT (39532) */
	'G', 'L', '1', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL1C_PERFCOUNTER3_SELECT (39557) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHC_PERFCOUNTER0_SELECT (39582) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* CHC_PERFCOUNTER0_SELECT1 (39606) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHC_PERFCOUNTER1_SELECT (39631) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHC_PERFCOUNTER2_SELECT (39655) */
	'C', 'H', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHC_PERFCOUNTER3_SELECT (39679) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHCG_PERFCOUNTER0_SELECT (39703) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* CHCG_PERFCOUNTER0_SELECT1 (39728) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHCG_PERFCOUNTER1_SELECT (39754) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHCG_PERFCOUNTER2_SELECT (39779) */
	'C', 'H', 'C', 'G', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHCG_PERFCOUNTER3_SELECT (39804) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'F', 'I', 'L', 'T', 'E', 'R', '\0', /* CB_PERFCOUNTER_FILTER (39829) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CB_PERFCOUNTER0_SELECT (39851) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* CB_PERFCOUNTER0_SELECT1 (39874) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CB_PERFCOUNTER1_SELECT (39898) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CB_PERFCOUNTER2_SELECT (39921) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CB_PERFCOUNTER3_SELECT (39944) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* DB_PERFCOUNTER0_SELECT (39967) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* DB_PERFCOUNTER0_SELECT1 (39990) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* DB_PERFCOUNTER1_SELECT (40014) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* DB_PERFCOUNTER1_SELECT1 (40037) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* DB_PERFCOUNTER2_SELECT (40061) */
	'D', 'B', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* DB_PERFCOUNTER3_SELECT (40084) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'C', 'N', 'T', 'L', '\0', /* RLC_SPM_PERFMON_CNTL (40107) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'R', 'I', 'N', 'G', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* RLC_SPM_PERFMON_RING_BASE_LO (40128) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'R', 'I', 'N', 'G', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* RLC_SPM_PERFMON_RING_BASE_HI (40157, 40173) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'R', 'I', 'N', 'G', '_', 'S', 'I', 'Z', 'E', '\0', /* RLC_SPM_PERFMON_RING_SIZE (40186) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'E', 'G', 'M', 'E', 'N', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* RLC_SPM_PERFMON_SEGMENT_SIZE (40212, 40220) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'R', 'I', 'N', 'G', '_', 'R', 'D', 'P', 'T', 'R', '\0', /* RLC_SPM_RING_RDPTR (40241) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'E', 'G', 'M', 'E', 'N', 'T', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '\0', /* RLC_SPM_SEGMENT_THRESHOLD (40260) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'E', '_', 'M', 'U', 'X', 'S', 'E', 'L', '_', 'A', 'D', 'D', 'R', '\0', /* RLC_SPM_SE_MUXSEL_ADDR (40286) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'E', '_', 'M', 'U', 'X', 'S', 'E', 'L', '_', 'D', 'A', 'T', 'A', '\0', /* RLC_SPM_SE_MUXSEL_DATA (40309) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'G', 'L', 'O', 'B', 'A', 'L', '_', 'M', 'U', 'X', 'S', 'E', 'L', '_', 'A', 'D', 'D', 'R', '\0', /* RLC_SPM_GLOBAL_MUXSEL_ADDR (40332) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'G', 'L', 'O', 'B', 'A', 'L', '_', 'M', 'U', 'X', 'S', 'E', 'L', '_', 'D', 'A', 'T', 'A', '\0', /* RLC_SPM_GLOBAL_MUXSEL_DATA (40359) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'D', 'E', 'S', 'E', 'R', '_', 'S', 'T', 'A', 'R', 'T', '_', 'S', 'K', 'E', 'W', '\0', /* RLC_SPM_DESER_START_SKEW (40386, 40394) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'G', 'L', 'O', 'B', 'A', 'L', 'S', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'S', 'K', 'E', 'W', '\0', /* RLC_SPM_GLOBALS_SAMPLE_SKEW (40411, 40419) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'G', 'L', 'O', 'B', 'A', 'L', 'S', '_', 'M', 'U', 'X', 'S', 'E', 'L', '_', 'S', 'K', 'E', 'W', '\0', /* RLC_SPM_GLOBALS_MUXSEL_SKEW (40439, 40447) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'E', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'S', 'K', 'E', 'W', '\0', /* RLC_SPM_SE_SAMPLE_SKEW (40467, 40475) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'E', '_', 'M', 'U', 'X', 'S', 'E', 'L', '_', 'S', 'K', 'E', 'W', '\0', /* RLC_SPM_SE_MUXSEL_SKEW (40490, 40498) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'G', 'L', 'B', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'D', 'E', 'L', 'A', 'Y', '_', 'I', 'N', 'D', '_', 'A', 'D', 'D', 'R', '\0', /* RLC_SPM_GLB_SAMPLEDELAY_IND_ADDR (40513) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'G', 'L', 'B', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'D', 'E', 'L', 'A', 'Y', '_', 'I', 'N', 'D', '_', 'D', 'A', 'T', 'A', '\0', /* RLC_SPM_GLB_SAMPLEDELAY_IND_DATA (40546) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'E', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'D', 'E', 'L', 'A', 'Y', '_', 'I', 'N', 'D', '_', 'A', 'D', 'D', 'R', '\0', /* RLC_SPM_SE_SAMPLEDELAY_IND_ADDR (40579) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'E', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'D', 'E', 'L', 'A', 'Y', '_', 'I', 'N', 'D', '_', 'D', 'A', 'T', 'A', '\0', /* RLC_SPM_SE_SAMPLEDELAY_IND_DATA (40611) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'R', 'I', 'N', 'G', '_', 'W', 'R', 'P', 'T', 'R', '\0', /* RLC_SPM_RING_WRPTR (40643) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'D', 'A', 'T', 'A', 'R', 'A', 'M', '_', 'A', 'D', 'D', 'R', '\0', /* RLC_SPM_ACCUM_DATARAM_ADDR (40662) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'D', 'A', 'T', 'A', 'R', 'A', 'M', '_', 'D', 'A', 'T', 'A', '\0', /* RLC_SPM_ACCUM_DATARAM_DATA (40689) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'C', 'T', 'R', 'L', 'R', 'A', 'M', '_', 'A', 'D', 'D', 'R', '\0', /* RLC_SPM_ACCUM_CTRLRAM_ADDR (40716) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'C', 'T', 'R', 'L', 'R', 'A', 'M', '_', 'D', 'A', 'T', 'A', '\0', /* RLC_SPM_ACCUM_CTRLRAM_DATA (40743) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* RLC_SPM_ACCUM_STATUS (40770) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'C', 'T', 'R', 'L', '\0', /* RLC_SPM_ACCUM_CTRL (40791) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'M', 'O', 'D', 'E', '\0', /* RLC_SPM_ACCUM_MODE (40810) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '\0', /* RLC_SPM_ACCUM_THRESHOLD (40829) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '_', 'R', 'E', 'Q', 'U', 'E', 'S', 'T', 'E', 'D', '\0', /* RLC_SPM_ACCUM_SAMPLES_REQUESTED (40853) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'D', 'A', 'T', 'A', 'R', 'A', 'M', '_', 'W', 'R', 'C', 'O', 'U', 'N', 'T', '\0', /* RLC_SPM_ACCUM_DATARAM_WRCOUNT (40885) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'E', '3', 'T', 'O', '0', '_', 'S', 'E', 'G', 'M', 'E', 'N', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE (40915) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'G', 'L', 'B', '_', 'S', 'E', 'G', 'M', 'E', 'N', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* RLC_SPM_PERFMON_GLB_SEGMENT_SIZE (40951) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'V', 'I', 'R', 'T', '_', 'C', 'T', 'R', 'L', '\0', /* RLC_SPM_VIRT_CTRL (40984) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'V', 'I', 'R', 'T', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* RLC_SPM_VIRT_STATUS (41002) */
	'R', 'L', 'C', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'C', 'N', 'T', 'L', '\0', /* RLC_PERFMON_CNTL (41022) */
	'R', 'L', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* RLC_PERFCOUNTER0_SELECT (41039) */
	'R', 'L', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* RLC_PERFCOUNTER1_SELECT (41063) */
	'R', 'L', 'C', '_', 'G', 'P', 'U', '_', 'I', 'O', 'V', '_', 'P', 'E', 'R', 'F', '_', 'C', 'N', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* RLC_GPU_IOV_PERF_CNT_CNTL (41087) */
	'R', 'L', 'C', '_', 'G', 'P', 'U', '_', 'I', 'O', 'V', '_', 'P', 'E', 'R', 'F', '_', 'C', 'N', 'T', '_', 'W', 'R', '_', 'A', 'D', 'D', 'R', '\0', /* RLC_GPU_IOV_PERF_CNT_WR_ADDR (41113) */
	'R', 'L', 'C', '_', 'G', 'P', 'U', '_', 'I', 'O', 'V', '_', 'P', 'E', 'R', 'F', '_', 'C', 'N', 'T', '_', 'W', 'R', '_', 'D', 'A', 'T', 'A', '\0', /* RLC_GPU_IOV_PERF_CNT_WR_DATA (41142) */
	'R', 'L', 'C', '_', 'G', 'P', 'U', '_', 'I', 'O', 'V', '_', 'P', 'E', 'R', 'F', '_', 'C', 'N', 'T', '_', 'R', 'D', '_', 'A', 'D', 'D', 'R', '\0', /* RLC_GPU_IOV_PERF_CNT_RD_ADDR (41171) */
	'R', 'L', 'C', '_', 'G', 'P', 'U', '_', 'I', 'O', 'V', '_', 'P', 'E', 'R', 'F', '_', 'C', 'N', 'T', '_', 'R', 'D', '_', 'D', 'A', 'T', 'A', '\0', /* RLC_GPU_IOV_PERF_CNT_RD_DATA (41200) */
	'R', 'L', 'C', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'C', 'L', 'K', '_', 'C', 'N', 'T', 'L', '\0', /* RLC_PERFMON_CLK_CNTL (41229) */
	'R', 'L', 'C', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'C', 'L', 'K', '_', 'C', 'N', 'T', 'L', '_', 'U', 'C', 'O', 'D', 'E', '\0', /* RLC_PERFMON_CLK_CNTL_UCODE (41250) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* RMI_PERFCOUNTER0_SELECT (41277) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* RMI_PERFCOUNTER0_SELECT1 (41301) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* RMI_PERFCOUNTER1_SELECT (41326) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* RMI_PERFCOUNTER2_SELECT (41350) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* RMI_PERFCOUNTER2_SELECT1 (41374) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* RMI_PERFCOUNTER3_SELECT (41399) */
	'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'C', 'N', 'T', 'L', '\0', /* RMI_PERF_COUNTER_CNTL (41423) */
	'G', 'C', '_', 'A', 'T', 'C', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'C', 'F', 'G', '\0', /* GC_ATC_L2_PERFCOUNTER0_CFG (41445, 41448) */
	'G', 'C', '_', 'A', 'T', 'C', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'C', 'F', 'G', '\0', /* GC_ATC_L2_PERFCOUNTER1_CFG (41472, 41475) */
	'G', 'C', '_', 'A', 'T', 'C', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'R', 'S', 'L', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* GC_ATC_L2_PERFCOUNTER_RSLT_CNTL (41499, 41502) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'C', 'F', 'G', '\0', /* GCMC_VM_L2_PERFCOUNTER0_CFG (41531, 41533) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'C', 'F', 'G', '\0', /* GCMC_VM_L2_PERFCOUNTER1_CFG (41559, 41561) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'C', 'F', 'G', '\0', /* GCMC_VM_L2_PERFCOUNTER2_CFG (41587, 41589) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'C', 'F', 'G', '\0', /* GCMC_VM_L2_PERFCOUNTER3_CFG (41615, 41617) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'C', 'F', 'G', '\0', /* GCMC_VM_L2_PERFCOUNTER4_CFG (41643, 41645) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'C', 'F', 'G', '\0', /* GCMC_VM_L2_PERFCOUNTER5_CFG (41671, 41673) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'C', 'F', 'G', '\0', /* GCMC_VM_L2_PERFCOUNTER6_CFG (41699, 41701) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'C', 'F', 'G', '\0', /* GCMC_VM_L2_PERFCOUNTER7_CFG (41727, 41729) */
	'G', 'C', 'M', 'C', '_', 'V', 'M', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'R', 'S', 'L', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL (41755, 41757) */
	'G', 'C', 'V', 'M', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GCVML2_PERFCOUNTER2_0_SELECT (41788) */
	'G', 'C', 'V', 'M', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GCVML2_PERFCOUNTER2_1_SELECT (41817) */
	'G', 'C', 'V', 'M', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GCVML2_PERFCOUNTER2_0_SELECT1 (41846) */
	'G', 'C', 'V', 'M', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GCVML2_PERFCOUNTER2_1_SELECT1 (41876) */
	'G', 'C', 'V', 'M', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', '0', '_', 'M', 'O', 'D', 'E', '\0', /* GCVML2_PERFCOUNTER2_0_MODE (41906) */
	'G', 'C', 'V', 'M', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', '1', '_', 'M', 'O', 'D', 'E', '\0', /* GCVML2_PERFCOUNTER2_1_MODE (41933) */
	'G', 'C', '_', 'A', 'T', 'C', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GC_ATC_L2_PERFCOUNTER2_SELECT (41960) */
	'G', 'C', '_', 'A', 'T', 'C', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GC_ATC_L2_PERFCOUNTER2_SELECT1 (41990) */
	'G', 'C', '_', 'A', 'T', 'C', '_', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'M', 'O', 'D', 'E', '\0', /* GC_ATC_L2_PERFCOUNTER2_MODE (42021) */
	'G', 'C', 'R', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GCR_PERFCOUNTER0_SELECT (42049) */
	'G', 'C', 'R', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GCR_PERFCOUNTER0_SELECT1 (42073) */
	'G', 'C', 'R', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GCR_PERFCOUNTER1_SELECT (42098) */
	'U', 'T', 'C', 'L', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* UTCL1_PERFCOUNTER0_SELECT (42122) */
	'U', 'T', 'C', 'L', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* UTCL1_PERFCOUNTER1_SELECT (42148) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_PH_PERFCOUNTER0_SELECT (42174) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* PA_PH_PERFCOUNTER0_SELECT1 (42200) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_PH_PERFCOUNTER1_SELECT (42227) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_PH_PERFCOUNTER2_SELECT (42253) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_PH_PERFCOUNTER3_SELECT (42279) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '4', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_PH_PERFCOUNTER4_SELECT (42305) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '5', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_PH_PERFCOUNTER5_SELECT (42331) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '6', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_PH_PERFCOUNTER6_SELECT (42357) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '7', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PA_PH_PERFCOUNTER7_SELECT (42383) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* PA_PH_PERFCOUNTER1_SELECT1 (42409) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* PA_PH_PERFCOUNTER2_SELECT1 (42436) */
	'P', 'A', '_', 'P', 'H', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* PA_PH_PERFCOUNTER3_SELECT1 (42463) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL1A_PERFCOUNTER0_SELECT (42490) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GL1A_PERFCOUNTER0_SELECT1 (42515) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL1A_PERFCOUNTER1_SELECT (42541) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL1A_PERFCOUNTER2_SELECT (42566) */
	'G', 'L', '1', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GL1A_PERFCOUNTER3_SELECT (42591) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHA_PERFCOUNTER0_SELECT (42616) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* CHA_PERFCOUNTER0_SELECT1 (42640) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHA_PERFCOUNTER1_SELECT (42665) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHA_PERFCOUNTER2_SELECT (42689) */
	'C', 'H', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* CHA_PERFCOUNTER3_SELECT (42713) */
	'G', 'U', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GUS_PERFCOUNTER2_SELECT (42737) */
	'G', 'U', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GUS_PERFCOUNTER2_SELECT1 (42761) */
	'G', 'U', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'M', 'O', 'D', 'E', '\0', /* GUS_PERFCOUNTER2_MODE (42786) */
	'D', 'S', 'T', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* DST_ADDR_LO (42808) */
	'I', 'B', '_', 'B', 'A', 'S', 'E', '_', 'L', 'O', '\0', /* IB_BASE_LO (42820) */
	'I', 'B', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* IB_BASE_HI (42831) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'W', 'O', 'R', 'D', '0', '\0', /* CP_DMA_WORD0 (42842) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'W', 'O', 'R', 'D', '1', '\0', /* CP_DMA_WORD1 (42855) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'W', 'O', 'R', 'D', '2', '\0', /* CP_DMA_WORD2 (42868) */
	'C', 'P', '_', 'D', 'M', 'A', '_', 'W', 'O', 'R', 'D', '3', '\0', /* CP_DMA_WORD3 (42881) */
	'R', 'E', 'L', 'E', 'A', 'S', 'E', '_', 'M', 'E', 'M', '_', 'O', 'P', '\0', /* RELEASE_MEM_OP (42894) */
	'D', 'M', 'A', '_', 'D', 'A', 'T', 'A', '_', 'W', 'O', 'R', 'D', '0', '\0', /* DMA_DATA_WORD0 (42909) */
	'S', 'R', 'C', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* SRC_ADDR_LO (42924) */
	'G', 'C', 'R', '_', 'C', 'N', 'T', 'L', '\0', /* GCR_CNTL (42936) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'A', 'C', 'T', 'I', 'V', 'E', '\0', /* SQ_WAVE_ACTIVE (42945) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'V', 'A', 'L', 'I', 'D', '_', 'A', 'N', 'D', '_', 'I', 'D', 'L', 'E', '\0', /* SQ_WAVE_VALID_AND_IDLE (42960, 42978) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'C', 'Y', 'C', 'L', 'E', 'S', '\0', /* SQ_WAVE_SHADER_CYCLES (42983, 42998) */
	'C', 'P', '_', 'C', 'P', 'C', '_', 'P', 'R', 'I', 'V', '_', 'V', 'I', 'O', 'L', 'A', 'T', 'I', 'O', 'N', '_', 'A', 'D', 'D', 'R', '\0', /* CP_CPC_PRIV_VIOLATION_ADDR (43005, 43012) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'S', 'T', 'A', 'T', 'U', 'S', '2', '\0', /* SQ_THREAD_TRACE_STATUS2 (43032) */
	'S', 'H', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'E', 'G', '0', '\0', /* SH_RESERVED_REG0 (43056) */
	'S', 'H', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'E', 'G', '1', '\0', /* SH_RESERVED_REG1 (43073) */
	'D', 'B', '_', 'V', 'R', 'S', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* DB_VRS_OVERRIDE_CNTL (43090) */
	'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'E', 'G', '0', '\0', /* CONTEXT_RESERVED_REG0 (43111) */
	'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'E', 'G', '1', '\0', /* CONTEXT_RESERVED_REG1 (43133) */
	'S', 'X', '_', 'P', 'S', '_', 'D', 'O', 'W', 'N', 'C', 'O', 'N', 'V', 'E', 'R', 'T', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* SX_PS_DOWNCONVERT_CONTROL (43155) */
	'P', 'A', '_', 'C', 'L', '_', 'V', 'R', 'S', '_', 'C', 'N', 'T', 'L', '\0', /* PA_CL_VRS_CNTL (43181) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '_', 'A', 'T', 'O', 'M', 'I', 'C', '\0', /* SCRATCH_REG_ATOMIC (43196) */
	'U', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'E', 'G', '0', '\0', /* UCONFIG_RESERVED_REG0 (43215) */
	'U', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'E', 'G', '1', '\0', /* UCONFIG_RESERVED_REG1 (43237) */
	'C', 'P', '_', 'C', 'E', '_', 'A', 'T', 'O', 'M', 'I', 'C', '_', 'P', 'R', 'E', 'O', 'P', '_', 'L', 'O', '\0', /* CP_CE_ATOMIC_PREOP_LO (43259) */
	'C', 'P', '_', 'C', 'E', '_', 'A', 'T', 'O', 'M', 'I', 'C', '_', 'P', 'R', 'E', 'O', 'P', '_', 'H', 'I', '\0', /* CP_CE_ATOMIC_PREOP_HI (43281) */
	'C', 'P', '_', 'C', 'E', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '0', '_', 'P', 'R', 'E', 'O', 'P', '_', 'L', 'O', '\0', /* CP_CE_GDS_ATOMIC0_PREOP_LO (43303) */
	'C', 'P', '_', 'C', 'E', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '0', '_', 'P', 'R', 'E', 'O', 'P', '_', 'H', 'I', '\0', /* CP_CE_GDS_ATOMIC0_PREOP_HI (43330) */
	'C', 'P', '_', 'C', 'E', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '1', '_', 'P', 'R', 'E', 'O', 'P', '_', 'L', 'O', '\0', /* CP_CE_GDS_ATOMIC1_PREOP_LO (43357) */
	'C', 'P', '_', 'C', 'E', '_', 'G', 'D', 'S', '_', 'A', 'T', 'O', 'M', 'I', 'C', '1', '_', 'P', 'R', 'E', 'O', 'P', '_', 'H', 'I', '\0', /* CP_CE_GDS_ATOMIC1_PREOP_HI (43384) */
	'G', 'E', '_', 'V', 'R', 'S', '_', 'R', 'A', 'T', 'E', '\0', /* GE_VRS_RATE (43411) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GE1_PERFCOUNTER0_LO (43423) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GE1_PERFCOUNTER0_HI (43443) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GE1_PERFCOUNTER1_LO (43463) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GE1_PERFCOUNTER1_HI (43483) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GE1_PERFCOUNTER2_LO (43503) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GE1_PERFCOUNTER2_HI (43523) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* GE1_PERFCOUNTER3_LO (43543) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* GE1_PERFCOUNTER3_HI (43563) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GE2_DIST_PERFCOUNTER0_LO (43583) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GE2_DIST_PERFCOUNTER0_HI (43608) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GE2_DIST_PERFCOUNTER1_LO (43633) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GE2_DIST_PERFCOUNTER1_HI (43658) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GE2_DIST_PERFCOUNTER2_LO (43683) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GE2_DIST_PERFCOUNTER2_HI (43708) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* GE2_DIST_PERFCOUNTER3_LO (43733) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* GE2_DIST_PERFCOUNTER3_HI (43758) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* GE2_SE_PERFCOUNTER0_LO (43783) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* GE2_SE_PERFCOUNTER0_HI (43806) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* GE2_SE_PERFCOUNTER1_LO (43829) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* GE2_SE_PERFCOUNTER1_HI (43852) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* GE2_SE_PERFCOUNTER2_LO (43875) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* GE2_SE_PERFCOUNTER2_HI (43898) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* GE2_SE_PERFCOUNTER3_LO (43921) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* GE2_SE_PERFCOUNTER3_HI (43944) */
	'G', 'C', 'E', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* GCEA_PERFCOUNTER_LO (43967) */
	'G', 'C', 'E', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* GCEA_PERFCOUNTER_HI (43987) */
	'G', 'C', 'U', 'T', 'C', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* GCUTCL2_PERFCOUNTER_LO (44007) */
	'G', 'C', 'U', 'T', 'C', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* GCUTCL2_PERFCOUNTER_HI (44030) */
	'G', 'U', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* GUS_PERFCOUNTER_LO (44053) */
	'G', 'U', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* GUS_PERFCOUNTER_HI (44072) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* SDMA0_PERFCNT_PERFCOUNTER_LO (44091) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* SDMA0_PERFCNT_PERFCOUNTER_HI (44120) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* SDMA0_PERFCOUNTER0_LO (44149) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* SDMA0_PERFCOUNTER0_HI (44171) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* SDMA0_PERFCOUNTER1_LO (44193) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* SDMA0_PERFCOUNTER1_HI (44215) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* SDMA1_PERFCNT_PERFCOUNTER_LO (44237) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* SDMA1_PERFCNT_PERFCOUNTER_HI (44266) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* SDMA1_PERFCOUNTER0_LO (44295) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* SDMA1_PERFCOUNTER0_HI (44317) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* SDMA1_PERFCOUNTER1_LO (44339) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* SDMA1_PERFCOUNTER1_HI (44361) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* SDMA2_PERFCNT_PERFCOUNTER_LO (44383) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* SDMA2_PERFCNT_PERFCOUNTER_HI (44412) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* SDMA2_PERFCOUNTER0_LO (44441) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* SDMA2_PERFCOUNTER0_HI (44463) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* SDMA2_PERFCOUNTER1_LO (44485) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* SDMA2_PERFCOUNTER1_HI (44507) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'L', 'O', '\0', /* SDMA3_PERFCNT_PERFCOUNTER_LO (44529) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'H', 'I', '\0', /* SDMA3_PERFCNT_PERFCOUNTER_HI (44558) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* SDMA3_PERFCOUNTER0_LO (44587) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* SDMA3_PERFCOUNTER0_HI (44609) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* SDMA3_PERFCOUNTER1_LO (44631) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* SDMA3_PERFCOUNTER1_HI (44653) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE1_PERFCOUNTER0_SELECT (44675) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE1_PERFCOUNTER0_SELECT1 (44699) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE1_PERFCOUNTER1_SELECT (44724) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE1_PERFCOUNTER1_SELECT1 (44748) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE1_PERFCOUNTER2_SELECT (44773) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE1_PERFCOUNTER2_SELECT1 (44797) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE1_PERFCOUNTER3_SELECT (44822) */
	'G', 'E', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE1_PERFCOUNTER3_SELECT1 (44846) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE2_DIST_PERFCOUNTER0_SELECT (44871) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE2_DIST_PERFCOUNTER0_SELECT1 (44900) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE2_DIST_PERFCOUNTER1_SELECT (44930) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE2_DIST_PERFCOUNTER1_SELECT1 (44959) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE2_DIST_PERFCOUNTER2_SELECT (44989) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE2_DIST_PERFCOUNTER2_SELECT1 (45018) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE2_DIST_PERFCOUNTER3_SELECT (45048) */
	'G', 'E', '2', '_', 'D', 'I', 'S', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE2_DIST_PERFCOUNTER3_SELECT1 (45077) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE2_SE_PERFCOUNTER0_SELECT (45107) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE2_SE_PERFCOUNTER0_SELECT1 (45134) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE2_SE_PERFCOUNTER1_SELECT (45162) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE2_SE_PERFCOUNTER1_SELECT1 (45189) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE2_SE_PERFCOUNTER2_SELECT (45217) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE2_SE_PERFCOUNTER2_SELECT1 (45244) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* GE2_SE_PERFCOUNTER3_SELECT (45272) */
	'G', 'E', '2', '_', 'S', 'E', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GE2_SE_PERFCOUNTER3_SELECT1 (45299) */
	'G', 'C', 'E', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'C', 'F', 'G', '\0', /* GCEA_PERFCOUNTER0_CFG (45327) */
	'G', 'C', 'E', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'C', 'F', 'G', '\0', /* GCEA_PERFCOUNTER1_CFG (45349) */
	'G', 'C', 'E', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'R', 'S', 'L', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* GCEA_PERFCOUNTER_RSLT_CNTL (45371) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GDS_PERFCOUNTER1_SELECT1 (45398) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GDS_PERFCOUNTER2_SELECT1 (45423) */
	'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* GDS_PERFCOUNTER3_SELECT1 (45448) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'W', 'A', '_', 'S', 'E', 'G', 'M', 'E', 'N', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* RLC_SPM_PERFMON_SWA_SEGMENT_SIZE (45473) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'G', 'F', 'X', 'C', 'L', 'O', 'C', 'K', '_', 'H', 'I', 'G', 'H', 'C', 'O', 'U', 'N', 'T', '\0', /* RLC_SPM_GFXCLOCK_HIGHCOUNT (45506) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'G', 'F', 'X', 'C', 'L', 'O', 'C', 'K', '_', 'L', 'O', 'W', 'C', 'O', 'U', 'N', 'T', '\0', /* RLC_SPM_GFXCLOCK_LOWCOUNT (45533) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'W', 'A', '_', 'S', 'E', '3', 'T', 'O', '0', '_', 'S', 'E', 'G', 'M', 'E', 'N', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* RLC_SPM_PERFMON_SWA_SE3TO0_SEGMENT_SIZE (45559) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'G', 'L', 'O', 'B', 'A', 'L', '_', 'M', 'U', 'X', 'S', 'E', 'L', '_', 'A', 'D', 'D', 'R', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* RLC_SPM_GLOBAL_MUXSEL_ADDR_OFFSET (45599) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'E', '_', 'M', 'U', 'X', 'S', 'E', 'L', '_', 'A', 'D', 'D', 'R', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* RLC_SPM_SE_MUXSEL_ADDR_OFFSET (45633) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'S', 'W', 'A', '_', 'D', 'A', 'T', 'A', 'R', 'A', 'M', '_', 'A', 'D', 'D', 'R', '\0', /* RLC_SPM_ACCUM_SWA_DATARAM_ADDR (45663) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'S', 'W', 'A', '_', 'D', 'A', 'T', 'A', 'R', 'A', 'M', '_', 'D', 'A', 'T', 'A', '\0', /* RLC_SPM_ACCUM_SWA_DATARAM_DATA (45694) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'C', 'T', 'R', 'L', 'R', 'A', 'M', '_', 'A', 'D', 'D', 'R', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* RLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET (45725) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'W', 'A', '_', 'G', 'L', 'B', '_', 'S', 'E', 'G', 'M', 'E', 'N', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* RLC_SPM_PERFMON_SWA_GLB_SEGMENT_SIZE (45759) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'A', 'C', 'C', 'U', 'M', '_', 'D', 'A', 'T', 'A', 'R', 'A', 'M', '_', '3', '2', 'B', 'I', 'T', 'C', 'N', 'T', 'R', 'S', '_', 'R', 'E', 'G', 'I', 'O', 'N', 'S', '\0', /* RLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS (45796) */
	'G', 'C', 'U', 'T', 'C', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'C', 'F', 'G', '\0', /* GCUTCL2_PERFCOUNTER0_CFG (45837) */
	'G', 'C', 'U', 'T', 'C', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'C', 'F', 'G', '\0', /* GCUTCL2_PERFCOUNTER1_CFG (45862) */
	'G', 'C', 'U', 'T', 'C', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'C', 'F', 'G', '\0', /* GCUTCL2_PERFCOUNTER2_CFG (45887) */
	'G', 'C', 'U', 'T', 'C', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'C', 'F', 'G', '\0', /* GCUTCL2_PERFCOUNTER3_CFG (45912) */
	'G', 'C', 'U', 'T', 'C', 'L', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'R', 'S', 'L', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* GCUTCL2_PERFCOUNTER_RSLT_CNTL (45937) */
	'G', 'U', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'C', 'F', 'G', '\0', /* GUS_PERFCOUNTER0_CFG (45967) */
	'G', 'U', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'C', 'F', 'G', '\0', /* GUS_PERFCOUNTER1_CFG (45988) */
	'G', 'U', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'R', 'S', 'L', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* GUS_PERFCOUNTER_RSLT_CNTL (46009) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'C', 'F', 'G', '\0', /* SDMA0_PERFCNT_PERFCOUNTER0_CFG (46035) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'C', 'F', 'G', '\0', /* SDMA0_PERFCNT_PERFCOUNTER1_CFG (46066) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'R', 'S', 'L', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL (46097) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'M', 'I', 'S', 'C', '_', 'C', 'N', 'T', 'L', '\0', /* SDMA0_PERFCNT_MISC_CNTL (46133) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SDMA0_PERFCOUNTER0_SELECT (46157) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SDMA0_PERFCOUNTER0_SELECT1 (46183) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SDMA0_PERFCOUNTER1_SELECT (46210) */
	'S', 'D', 'M', 'A', '0', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SDMA0_PERFCOUNTER1_SELECT1 (46236) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'C', 'F', 'G', '\0', /* SDMA1_PERFCNT_PERFCOUNTER0_CFG (46263) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'C', 'F', 'G', '\0', /* SDMA1_PERFCNT_PERFCOUNTER1_CFG (46294) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'R', 'S', 'L', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL (46325) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'M', 'I', 'S', 'C', '_', 'C', 'N', 'T', 'L', '\0', /* SDMA1_PERFCNT_MISC_CNTL (46361) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SDMA1_PERFCOUNTER0_SELECT (46385) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SDMA1_PERFCOUNTER0_SELECT1 (46411) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SDMA1_PERFCOUNTER1_SELECT (46438) */
	'S', 'D', 'M', 'A', '1', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SDMA1_PERFCOUNTER1_SELECT1 (46464) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'C', 'F', 'G', '\0', /* SDMA2_PERFCNT_PERFCOUNTER0_CFG (46491) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'C', 'F', 'G', '\0', /* SDMA2_PERFCNT_PERFCOUNTER1_CFG (46522) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'R', 'S', 'L', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* SDMA2_PERFCNT_PERFCOUNTER_RSLT_CNTL (46553) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'M', 'I', 'S', 'C', '_', 'C', 'N', 'T', 'L', '\0', /* SDMA2_PERFCNT_MISC_CNTL (46589) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SDMA2_PERFCOUNTER0_SELECT (46613) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SDMA2_PERFCOUNTER0_SELECT1 (46639) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SDMA2_PERFCOUNTER1_SELECT (46666) */
	'S', 'D', 'M', 'A', '2', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SDMA2_PERFCOUNTER1_SELECT1 (46692) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'C', 'F', 'G', '\0', /* SDMA3_PERFCNT_PERFCOUNTER0_CFG (46719) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'C', 'F', 'G', '\0', /* SDMA3_PERFCNT_PERFCOUNTER1_CFG (46750) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'R', 'S', 'L', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* SDMA3_PERFCNT_PERFCOUNTER_RSLT_CNTL (46781) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'N', 'T', '_', 'M', 'I', 'S', 'C', '_', 'C', 'N', 'T', 'L', '\0', /* SDMA3_PERFCNT_MISC_CNTL (46817) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SDMA3_PERFCOUNTER0_SELECT (46841) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SDMA3_PERFCOUNTER0_SELECT1 (46867) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SDMA3_PERFCOUNTER1_SELECT (46894) */
	'S', 'D', 'M', 'A', '3', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* SDMA3_PERFCOUNTER1_SELECT1 (46920) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'H', 'W', '_', 'I', 'D', '\0', /* SQ_WAVE_HW_ID (46947) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'I', 'N', 'S', 'T', '_', 'D', 'W', '1', '\0', /* SQ_WAVE_INST_DW1 (46961) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'I', 'B', '_', 'D', 'B', 'G', '0', '\0', /* SQ_WAVE_IB_DBG0 (46978) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'B', 'A', '_', 'L', 'O', '\0', /* SQ_WAVE_TBA_LO (46994) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'B', 'A', '_', 'H', 'I', '\0', /* SQ_WAVE_TBA_HI (47009) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'M', 'A', '_', 'L', 'O', '\0', /* SQ_WAVE_TMA_LO (47024) */
	'S', 'Q', '_', 'W', 'A', 'V', 'E', '_', 'T', 'M', 'A', '_', 'H', 'I', '\0', /* SQ_WAVE_TMA_HI (47039) */
	'S', 'R', 'B', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '2', '\0', /* SRBM_STATUS2 (47054) */
	'S', 'R', 'B', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* SRBM_STATUS (47067) */
	'S', 'R', 'B', 'M', '_', 'S', 'T', 'A', 'T', 'U', 'S', '3', '\0', /* SRBM_STATUS3 (47079) */
	'G', 'R', 'B', 'M', '_', 'C', 'N', 'T', 'L', '\0', /* GRBM_CNTL (47092) */
	'G', 'R', 'B', 'M', '_', 'S', 'K', 'E', 'W', '_', 'C', 'N', 'T', 'L', '\0', /* GRBM_SKEW_CNTL (47102) */
	'G', 'R', 'B', 'M', '_', 'P', 'W', 'R', '_', 'C', 'N', 'T', 'L', '\0', /* GRBM_PWR_CNTL (47117) */
	'G', 'R', 'B', 'M', '_', 'S', 'O', 'F', 'T', '_', 'R', 'E', 'S', 'E', 'T', '\0', /* GRBM_SOFT_RESET (47131) */
	'G', 'R', 'B', 'M', '_', 'D', 'E', 'B', 'U', 'G', '_', 'C', 'N', 'T', 'L', '\0', /* GRBM_DEBUG_CNTL (47147) */
	'G', 'R', 'B', 'M', '_', 'D', 'E', 'B', 'U', 'G', '_', 'D', 'A', 'T', 'A', '\0', /* GRBM_DEBUG_DATA (47163, 47168) */
	'G', 'R', 'B', 'M', '_', 'G', 'F', 'X', '_', 'C', 'L', 'K', 'E', 'N', '_', 'C', 'N', 'T', 'L', '\0', /* GRBM_GFX_CLKEN_CNTL (47179) */
	'G', 'R', 'B', 'M', '_', 'W', 'A', 'I', 'T', '_', 'I', 'D', 'L', 'E', '_', 'C', 'L', 'O', 'C', 'K', 'S', '\0', /* GRBM_WAIT_IDLE_CLOCKS (47199, 47204) */
	'G', 'R', 'B', 'M', '_', 'D', 'E', 'B', 'U', 'G', '\0', /* GRBM_DEBUG (47221) */
	'G', 'R', 'B', 'M', '_', 'D', 'E', 'B', 'U', 'G', '_', 'S', 'N', 'A', 'P', 'S', 'H', 'O', 'T', '\0', /* GRBM_DEBUG_SNAPSHOT (47232) */
	'G', 'R', 'B', 'M', '_', 'R', 'E', 'A', 'D', '_', 'E', 'R', 'R', 'O', 'R', '\0', /* GRBM_READ_ERROR (47252, 47257) */
	'G', 'R', 'B', 'M', '_', 'I', 'N', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* GRBM_INT_CNTL (47268) */
	'D', 'E', 'B', 'U', 'G', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* DEBUG_INDEX (47282) */
	'G', 'R', 'B', 'M', '_', 'N', 'O', 'W', 'H', 'E', 'R', 'E', '\0', /* GRBM_NOWHERE (47294) */
	'G', 'R', 'B', 'M', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '0', '\0', /* GRBM_SCRATCH_REG0 (47307) */
	'G', 'R', 'B', 'M', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '1', '\0', /* GRBM_SCRATCH_REG1 (47325) */
	'G', 'R', 'B', 'M', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '2', '\0', /* GRBM_SCRATCH_REG2 (47343) */
	'G', 'R', 'B', 'M', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '3', '\0', /* GRBM_SCRATCH_REG3 (47361) */
	'G', 'R', 'B', 'M', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '4', '\0', /* GRBM_SCRATCH_REG4 (47379) */
	'G', 'R', 'B', 'M', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '5', '\0', /* GRBM_SCRATCH_REG5 (47397) */
	'G', 'R', 'B', 'M', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '6', '\0', /* GRBM_SCRATCH_REG6 (47415) */
	'G', 'R', 'B', 'M', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'E', 'G', '7', '\0', /* GRBM_SCRATCH_REG7 (47433) */
	'S', 'Q', '_', 'I', 'N', 'T', 'E', 'R', 'R', 'U', 'P', 'T', '_', 'W', 'O', 'R', 'D', '_', 'A', 'U', 'T', 'O', '\0', /* SQ_INTERRUPT_WORD_AUTO (47451) */
	'C', 'P', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'S', 'T', 'A', 'T', '3', '\0', /* CP_STALLED_STAT3 (47474) */
	'C', 'P', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'S', 'T', 'A', 'T', '1', '\0', /* CP_STALLED_STAT1 (47491) */
	'C', 'P', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'S', 'T', 'A', 'T', '2', '\0', /* CP_STALLED_STAT2 (47508) */
	'C', 'P', '_', 'B', 'U', 'S', 'Y', '_', 'S', 'T', 'A', 'T', '\0', /* CP_BUSY_STAT (47525) */
	'C', 'P', '_', 'S', 'T', 'A', 'T', '\0', /* CP_STAT (47538) */
	'C', 'P', '_', 'M', 'E', '_', 'H', 'E', 'A', 'D', 'E', 'R', '_', 'D', 'U', 'M', 'P', '\0', /* CP_ME_HEADER_DUMP (47546) */
	'C', 'P', '_', 'P', 'F', 'P', '_', 'H', 'E', 'A', 'D', 'E', 'R', '_', 'D', 'U', 'M', 'P', '\0', /* CP_PFP_HEADER_DUMP (47564) */
	'C', 'P', '_', 'G', 'R', 'B', 'M', '_', 'F', 'R', 'E', 'E', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* CP_GRBM_FREE_COUNT (47583) */
	'C', 'P', '_', 'C', 'E', '_', 'H', 'E', 'A', 'D', 'E', 'R', '_', 'D', 'U', 'M', 'P', '\0', /* CP_CE_HEADER_DUMP (47602) */
	'C', 'P', '_', 'M', 'C', '_', 'P', 'A', 'C', 'K', '_', 'D', 'E', 'L', 'A', 'Y', '_', 'C', 'N', 'T', '\0', /* CP_MC_PACK_DELAY_CNT (47620, 47626) */
	'C', 'P', '_', 'C', 'S', 'F', '_', 'S', 'T', 'A', 'T', '\0', /* CP_CSF_STAT (47641) */
	'C', 'P', '_', 'C', 'S', 'F', '_', 'C', 'N', 'T', 'L', '\0', /* CP_CSF_CNTL (47653) */
	'C', 'P', '_', 'M', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* CP_ME_CNTL (47665) */
	'C', 'P', '_', 'C', 'N', 'T', 'X', '_', 'S', 'T', 'A', 'T', '\0', /* CP_CNTX_STAT (47676) */
	'C', 'P', '_', 'M', 'E', '_', 'P', 'R', 'E', 'E', 'M', 'P', 'T', 'I', 'O', 'N', '\0', /* CP_ME_PREEMPTION (47689) */
	'C', 'P', '_', 'R', 'B', '2', '_', 'R', 'P', 'T', 'R', '\0', /* CP_RB2_RPTR (47706) */
	'C', 'P', '_', 'R', 'B', '1', '_', 'R', 'P', 'T', 'R', '\0', /* CP_RB1_RPTR (47718) */
	'C', 'P', '_', 'R', 'B', '0', '_', 'R', 'P', 'T', 'R', '\0', /* CP_RB0_RPTR (47730) */
	'C', 'P', '_', 'R', 'B', '_', 'W', 'P', 'T', 'R', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* CP_RB_WPTR_DELAY (47742) */
	'C', 'P', '_', 'R', 'B', '_', 'W', 'P', 'T', 'R', '_', 'P', 'O', 'L', 'L', '_', 'C', 'N', 'T', 'L', '\0', /* CP_RB_WPTR_POLL_CNTL (47759) */
	'C', 'P', '_', 'R', 'O', 'Q', '1', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', 'S', '\0', /* CP_ROQ1_THRESHOLDS (47780) */
	'C', 'P', '_', 'R', 'O', 'Q', '2', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', 'S', '\0', /* CP_ROQ2_THRESHOLDS (47799) */
	'C', 'P', '_', 'S', 'T', 'Q', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', 'S', '\0', /* CP_STQ_THRESHOLDS (47818) */
	'C', 'P', '_', 'Q', 'U', 'E', 'U', 'E', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', 'S', '\0', /* CP_QUEUE_THRESHOLDS (47836) */
	'C', 'P', '_', 'M', 'E', 'Q', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', 'S', '\0', /* CP_MEQ_THRESHOLDS (47856) */
	'C', 'P', '_', 'R', 'O', 'Q', '_', 'A', 'V', 'A', 'I', 'L', '\0', /* CP_ROQ_AVAIL (47874) */
	'C', 'P', '_', 'S', 'T', 'Q', '_', 'A', 'V', 'A', 'I', 'L', '\0', /* CP_STQ_AVAIL (47887) */
	'C', 'P', '_', 'R', 'O', 'Q', '2', '_', 'A', 'V', 'A', 'I', 'L', '\0', /* CP_ROQ2_AVAIL (47900) */
	'C', 'P', '_', 'M', 'E', 'Q', '_', 'A', 'V', 'A', 'I', 'L', '\0', /* CP_MEQ_AVAIL (47914) */
	'C', 'P', '_', 'C', 'M', 'D', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* CP_CMD_INDEX (47927, 47930) */
	'C', 'P', '_', 'C', 'M', 'D', '_', 'D', 'A', 'T', 'A', '\0', /* CP_CMD_DATA (47940) */
	'C', 'P', '_', 'R', 'O', 'Q', '_', 'R', 'B', '_', 'S', 'T', 'A', 'T', '\0', /* CP_ROQ_RB_STAT (47952) */
	'C', 'P', '_', 'R', 'O', 'Q', '_', 'I', 'B', '1', '_', 'S', 'T', 'A', 'T', '\0', /* CP_ROQ_IB1_STAT (47967) */
	'C', 'P', '_', 'R', 'O', 'Q', '_', 'I', 'B', '2', '_', 'S', 'T', 'A', 'T', '\0', /* CP_ROQ_IB2_STAT (47983) */
	'C', 'P', '_', 'S', 'T', 'Q', '_', 'S', 'T', 'A', 'T', '\0', /* CP_STQ_STAT (47999) */
	'C', 'P', '_', 'M', 'E', 'Q', '_', 'S', 'T', 'A', 'T', '\0', /* CP_MEQ_STAT (48011) */
	'C', 'P', '_', 'C', 'E', 'Q', '1', '_', 'A', 'V', 'A', 'I', 'L', '\0', /* CP_CEQ1_AVAIL (48023) */
	'C', 'P', '_', 'C', 'E', 'Q', '2', '_', 'A', 'V', 'A', 'I', 'L', '\0', /* CP_CEQ2_AVAIL (48037) */
	'C', 'P', '_', 'C', 'E', '_', 'R', 'O', 'Q', '_', 'R', 'B', '_', 'S', 'T', 'A', 'T', '\0', /* CP_CE_ROQ_RB_STAT (48051) */
	'C', 'P', '_', 'C', 'E', '_', 'R', 'O', 'Q', '_', 'I', 'B', '1', '_', 'S', 'T', 'A', 'T', '\0', /* CP_CE_ROQ_IB1_STAT (48069) */
	'C', 'P', '_', 'C', 'E', '_', 'R', 'O', 'Q', '_', 'I', 'B', '2', '_', 'S', 'T', 'A', 'T', '\0', /* CP_CE_ROQ_IB2_STAT (48088) */
	'C', 'P', '_', 'I', 'N', 'T', '_', 'S', 'T', 'A', 'T', '_', 'D', 'E', 'B', 'U', 'G', '\0', /* CP_INT_STAT_DEBUG (48107) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* IA_PERFCOUNTER0_SELECT (48125) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* IA_PERFCOUNTER1_SELECT (48148) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* IA_PERFCOUNTER2_SELECT (48171) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* IA_PERFCOUNTER3_SELECT (48194) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* IA_PERFCOUNTER0_LO (48217) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* IA_PERFCOUNTER0_HI (48236) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* IA_PERFCOUNTER1_LO (48255) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* IA_PERFCOUNTER1_HI (48274) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* IA_PERFCOUNTER2_LO (48293) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* IA_PERFCOUNTER2_HI (48312) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* IA_PERFCOUNTER3_LO (48331) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* IA_PERFCOUNTER3_HI (48350) */
	'V', 'G', 'T', '_', 'V', 'T', 'X', '_', 'V', 'E', 'C', 'T', '_', 'E', 'J', 'E', 'C', 'T', '_', 'R', 'E', 'G', '\0', /* VGT_VTX_VECT_EJECT_REG (48369) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'D', 'A', 'T', 'A', '_', 'F', 'I', 'F', 'O', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* VGT_DMA_DATA_FIFO_DEPTH (48392, 48396) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'R', 'E', 'Q', '_', 'F', 'I', 'F', 'O', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* VGT_DMA_REQ_FIFO_DEPTH (48416, 48420) */
	'V', 'G', 'T', '_', 'D', 'R', 'A', 'W', '_', 'I', 'N', 'I', 'T', '_', 'F', 'I', 'F', 'O', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* VGT_DRAW_INIT_FIFO_DEPTH (48439, 48443) */
	'V', 'G', 'T', '_', 'L', 'A', 'S', 'T', '_', 'C', 'O', 'P', 'Y', '_', 'S', 'T', 'A', 'T', 'E', '\0', /* VGT_LAST_COPY_STATE (48464) */
	'V', 'G', 'T', '_', 'C', 'A', 'C', 'H', 'E', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', 'A', 'T', 'I', 'O', 'N', '\0', /* VGT_CACHE_INVALIDATION (48484, 48488) */
	'V', 'G', 'T', '_', 'E', 'S', 'G', 'S', '_', 'R', 'I', 'N', 'G', '_', 'S', 'I', 'Z', 'E', '\0', /* VGT_ESGS_RING_SIZE (48507) */
	'V', 'G', 'T', '_', 'G', 'S', 'V', 'S', '_', 'R', 'I', 'N', 'G', '_', 'S', 'I', 'Z', 'E', '\0', /* VGT_GSVS_RING_SIZE (48526) */
	'V', 'G', 'T', '_', 'F', 'I', 'F', 'O', '_', 'D', 'E', 'P', 'T', 'H', 'S', '\0', /* VGT_FIFO_DEPTHS (48545) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'V', 'E', 'R', 'T', 'E', 'X', '_', 'R', 'E', 'U', 'S', 'E', '\0', /* VGT_GS_VERTEX_REUSE (48561) */
	'V', 'G', 'T', '_', 'M', 'C', '_', 'L', 'A', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_MC_LAT_CNTL (48581) */
	'I', 'A', '_', 'C', 'N', 'T', 'L', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* IA_CNTL_STATUS (48597) */
	'V', 'G', 'T', '_', 'D', 'E', 'B', 'U', 'G', '_', 'C', 'N', 'T', 'L', '\0', /* VGT_DEBUG_CNTL (48612) */
	'V', 'G', 'T', '_', 'D', 'E', 'B', 'U', 'G', '_', 'D', 'A', 'T', 'A', '\0', /* VGT_DEBUG_DATA (48627) */
	'I', 'A', '_', 'D', 'E', 'B', 'U', 'G', '_', 'C', 'N', 'T', 'L', '\0', /* IA_DEBUG_CNTL (48642) */
	'I', 'A', '_', 'D', 'E', 'B', 'U', 'G', '_', 'D', 'A', 'T', 'A', '\0', /* IA_DEBUG_DATA (48656) */
	'V', 'G', 'T', '_', 'C', 'N', 'T', 'L', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* VGT_CNTL_STATUS (48670) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'E', 'I', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* VGT_PERFCOUNTER_SEID_MASK (48686) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* VGT_PERFCOUNTER0_SELECT (48712) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* VGT_PERFCOUNTER1_SELECT (48736) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* VGT_PERFCOUNTER2_SELECT (48760) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* VGT_PERFCOUNTER3_SELECT (48784) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* VGT_PERFCOUNTER0_LO (48808) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* VGT_PERFCOUNTER0_HI (48828) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* VGT_PERFCOUNTER1_LO (48848) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* VGT_PERFCOUNTER1_HI (48868) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* VGT_PERFCOUNTER2_LO (48888) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* VGT_PERFCOUNTER2_HI (48908) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* VGT_PERFCOUNTER3_LO (48928) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* VGT_PERFCOUNTER3_HI (48948) */
	'C', 'G', 'T', 'T', '_', 'V', 'G', 'T', '_', 'C', 'L', 'K', '_', 'C', 'T', 'R', 'L', '\0', /* CGTT_VGT_CLK_CTRL (48968) */
	'I', 'A', '_', 'V', 'M', 'I', 'D', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* IA_VMID_OVERRIDE (48986) */
	'C', 'G', 'T', 'T', '_', 'I', 'A', '_', 'C', 'L', 'K', '_', 'C', 'T', 'R', 'L', '\0', /* CGTT_IA_CLK_CTRL (49003) */
	'V', 'G', 'T', '_', 'T', 'F', '_', 'R', 'I', 'N', 'G', '_', 'S', 'I', 'Z', 'E', '\0', /* VGT_TF_RING_SIZE (49020) */
	'V', 'G', 'T', '_', 'S', 'Y', 'S', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* VGT_SYS_CONFIG (49037) */
	'V', 'G', 'T', '_', 'H', 'S', '_', 'O', 'F', 'F', 'C', 'H', 'I', 'P', '_', 'P', 'A', 'R', 'A', 'M', '\0', /* VGT_HS_OFFCHIP_PARAM (49052) */
	'V', 'G', 'T', '_', 'T', 'F', '_', 'M', 'E', 'M', 'O', 'R', 'Y', '_', 'B', 'A', 'S', 'E', '\0', /* VGT_TF_MEMORY_BASE (49073) */
	'C', 'C', '_', 'G', 'C', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'A', 'R', 'R', 'A', 'Y', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* CC_GC_SHADER_ARRAY_CONFIG (49092) */
	'G', 'C', '_', 'U', 'S', 'E', 'R', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'A', 'R', 'R', 'A', 'Y', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* GC_USER_SHADER_ARRAY_CONFIG (49118) */
	'P', 'A', '_', 'S', 'U', '_', 'D', 'E', 'B', 'U', 'G', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SU_DEBUG_CNTL (49146) */
	'P', 'A', '_', 'S', 'U', '_', 'D', 'E', 'B', 'U', 'G', '_', 'D', 'A', 'T', 'A', '\0', /* PA_SU_DEBUG_DATA (49163) */
	'P', 'A', '_', 'C', 'L', '_', 'C', 'N', 'T', 'L', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* PA_CL_CNTL_STATUS (49180) */
	'P', 'A', '_', 'C', 'L', '_', 'E', 'N', 'H', 'A', 'N', 'C', 'E', '\0', /* PA_CL_ENHANCE (49198) */
	'C', 'G', 'T', 'T', '_', 'P', 'A', '_', 'C', 'L', 'K', '_', 'C', 'T', 'R', 'L', '\0', /* CGTT_PA_CLK_CTRL (49212) */
	'P', 'A', '_', 'S', 'U', '_', 'C', 'N', 'T', 'L', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* PA_SU_CNTL_STATUS (49229) */
	'P', 'A', '_', 'S', 'C', '_', 'F', 'I', 'F', 'O', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SC_FIFO_DEPTH_CNTL (49247) */
	'P', 'A', '_', 'S', 'C', '_', 'F', 'O', 'R', 'C', 'E', '_', 'E', 'O', 'V', '_', 'M', 'A', 'X', '_', 'C', 'N', 'T', 'S', '\0', /* PA_SC_FORCE_EOV_MAX_CNTS (49269) */
	'C', 'G', 'T', 'T', '_', 'S', 'C', '_', 'C', 'L', 'K', '_', 'C', 'T', 'R', 'L', '\0', /* CGTT_SC_CLK_CTRL (49294) */
	'P', 'A', '_', 'S', 'C', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* PA_SC_FIFO_SIZE (49311) */
	'P', 'A', '_', 'S', 'C', '_', 'I', 'F', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* PA_SC_IF_FIFO_SIZE (49327) */
	'P', 'A', '_', 'S', 'C', '_', 'D', 'E', 'B', 'U', 'G', '_', 'C', 'N', 'T', 'L', '\0', /* PA_SC_DEBUG_CNTL (49346) */
	'P', 'A', '_', 'S', 'C', '_', 'D', 'E', 'B', 'U', 'G', '_', 'D', 'A', 'T', 'A', '\0', /* PA_SC_DEBUG_DATA (49363) */
	'P', 'A', '_', 'S', 'C', '_', 'E', 'N', 'H', 'A', 'N', 'C', 'E', '\0', /* PA_SC_ENHANCE (49380) */
	'S', 'Q', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* SQ_CONFIG (49394) */
	'S', 'Q', 'C', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* SQC_CONFIG (49404) */
	'S', 'Q', '_', 'R', 'A', 'N', 'D', 'O', 'M', '_', 'W', 'A', 'V', 'E', '_', 'P', 'R', 'I', '\0', /* SQ_RANDOM_WAVE_PRI (49415) */
	'S', 'Q', '_', 'R', 'E', 'G', '_', 'C', 'R', 'E', 'D', 'I', 'T', 'S', '\0', /* SQ_REG_CREDITS (49434) */
	'S', 'Q', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', 'S', '\0', /* SQ_FIFO_SIZES (49449) */
	'C', 'C', '_', 'S', 'Q', 'C', '_', 'B', 'A', 'N', 'K', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* CC_SQC_BANK_DISABLE (49463) */
	'U', 'S', 'E', 'R', '_', 'S', 'Q', 'C', '_', 'B', 'A', 'N', 'K', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* USER_SQC_BANK_DISABLE (49483) */
	'S', 'Q', '_', 'D', 'E', 'B', 'U', 'G', '_', 'S', 'T', 'S', '_', 'G', 'L', 'O', 'B', 'A', 'L', '\0', /* SQ_DEBUG_STS_GLOBAL (49505) */
	'S', 'Q', '_', 'A', 'L', 'U', '_', 'C', 'L', 'K', '_', 'C', 'T', 'R', 'L', '\0', /* SQ_ALU_CLK_CTRL (49525) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'C', 'L', 'K', '_', 'C', 'T', 'R', 'L', '\0', /* SQ_TEX_CLK_CTRL (49541) */
	'C', 'G', 'T', 'T', '_', 'S', 'Q', '_', 'C', 'L', 'K', '_', 'C', 'T', 'R', 'L', '\0', /* CGTT_SQ_CLK_CTRL (49557) */
	'C', 'G', 'T', 'T', '_', 'S', 'Q', 'G', '_', 'C', 'L', 'K', '_', 'C', 'T', 'R', 'L', '\0', /* CGTT_SQG_CLK_CTRL (49574) */
	'S', 'Q', '_', 'I', 'N', 'D', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* SQ_IND_INDEX (49592) */
	'S', 'Q', '_', 'I', 'N', 'D', '_', 'D', 'A', 'T', 'A', '\0', /* SQ_IND_DATA (49605) */
	'S', 'Q', '_', 'T', 'I', 'M', 'E', '_', 'H', 'I', '\0', /* SQ_TIME_HI (49617) */
	'S', 'Q', '_', 'T', 'I', 'M', 'E', '_', 'L', 'O', '\0', /* SQ_TIME_LO (49628) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'B', 'A', 'S', 'E', '\0', /* SQ_THREAD_TRACE_BASE (49639) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'S', 'I', 'Z', 'E', '\0', /* SQ_THREAD_TRACE_SIZE (49660) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'P', 'E', 'R', 'F', '_', 'M', 'A', 'S', 'K', '\0', /* SQ_THREAD_TRACE_PERF_MASK (49681) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'M', 'O', 'D', 'E', '\0', /* SQ_THREAD_TRACE_MODE (49707) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'C', 'N', 'T', 'R', '\0', /* SQ_THREAD_TRACE_CNTR (49728) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'H', 'I', 'W', 'A', 'T', 'E', 'R', '\0', /* SQ_THREAD_TRACE_HIWATER (49749, 49765) */
	'S', 'Q', '_', 'P', 'O', 'W', 'E', 'R', '_', 'T', 'H', 'R', 'O', 'T', 'T', 'L', 'E', '\0', /* SQ_POWER_THROTTLE (49773) */
	'S', 'Q', '_', 'P', 'O', 'W', 'E', 'R', '_', 'T', 'H', 'R', 'O', 'T', 'T', 'L', 'E', '2', '\0', /* SQ_POWER_THROTTLE2 (49791) */
	'S', 'Q', '_', 'L', 'B', '_', 'C', 'T', 'R', '_', 'C', 'T', 'R', 'L', '\0', /* SQ_LB_CTR_CTRL (49810) */
	'S', 'Q', '_', 'L', 'B', '_', 'D', 'A', 'T', 'A', '_', 'A', 'L', 'U', '_', 'C', 'Y', 'C', 'L', 'E', 'S', '\0', /* SQ_LB_DATA_ALU_CYCLES (49825) */
	'S', 'Q', '_', 'L', 'B', '_', 'D', 'A', 'T', 'A', '_', 'T', 'E', 'X', '_', 'C', 'Y', 'C', 'L', 'E', 'S', '\0', /* SQ_LB_DATA_TEX_CYCLES (49847) */
	'S', 'Q', '_', 'L', 'B', '_', 'D', 'A', 'T', 'A', '_', 'A', 'L', 'U', '_', 'S', 'T', 'A', 'L', 'L', 'S', '\0', /* SQ_LB_DATA_ALU_STALLS (49869) */
	'S', 'Q', '_', 'L', 'B', '_', 'D', 'A', 'T', 'A', '_', 'T', 'E', 'X', '_', 'S', 'T', 'A', 'L', 'L', 'S', '\0', /* SQ_LB_DATA_TEX_STALLS (49891) */
	'S', 'Q', 'C', '_', 'S', 'E', 'C', 'D', 'E', 'D', '_', 'C', 'N', 'T', '\0', /* SQC_SECDED_CNT (49913) */
	'S', 'Q', '_', 'S', 'E', 'C', '_', 'C', 'N', 'T', '\0', /* SQ_SEC_CNT (49928) */
	'S', 'Q', '_', 'D', 'E', 'D', '_', 'C', 'N', 'T', '\0', /* SQ_DED_CNT (49939) */
	'S', 'Q', '_', 'D', 'E', 'D', '_', 'I', 'N', 'F', 'O', '\0', /* SQ_DED_INFO (49950) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'L', 'O', '_', 'P', 'S', '\0', /* SPI_SHADER_TBA_LO_PS (49962) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'H', 'I', '_', 'P', 'S', '\0', /* SPI_SHADER_TBA_HI_PS (49983) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'L', 'O', '_', 'P', 'S', '\0', /* SPI_SHADER_TMA_LO_PS (50004) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'H', 'I', '_', 'P', 'S', '\0', /* SPI_SHADER_TMA_HI_PS (50025) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'L', 'O', '_', 'V', 'S', '\0', /* SPI_SHADER_TBA_LO_VS (50046) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'H', 'I', '_', 'V', 'S', '\0', /* SPI_SHADER_TBA_HI_VS (50067) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'L', 'O', '_', 'V', 'S', '\0', /* SPI_SHADER_TMA_LO_VS (50088) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'H', 'I', '_', 'V', 'S', '\0', /* SPI_SHADER_TMA_HI_VS (50109) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'L', 'O', '_', 'G', 'S', '\0', /* SPI_SHADER_TBA_LO_GS (50130) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'H', 'I', '_', 'G', 'S', '\0', /* SPI_SHADER_TBA_HI_GS (50151) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'L', 'O', '_', 'G', 'S', '\0', /* SPI_SHADER_TMA_LO_GS (50172) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'H', 'I', '_', 'G', 'S', '\0', /* SPI_SHADER_TMA_HI_GS (50193) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'L', 'O', '_', 'E', 'S', '\0', /* SPI_SHADER_TBA_LO_ES (50214) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'H', 'I', '_', 'E', 'S', '\0', /* SPI_SHADER_TBA_HI_ES (50235) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'L', 'O', '_', 'E', 'S', '\0', /* SPI_SHADER_TMA_LO_ES (50256) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'H', 'I', '_', 'E', 'S', '\0', /* SPI_SHADER_TMA_HI_ES (50277) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'L', 'O', '_', 'H', 'S', '\0', /* SPI_SHADER_TBA_LO_HS (50298) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'H', 'I', '_', 'H', 'S', '\0', /* SPI_SHADER_TBA_HI_HS (50319) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'L', 'O', '_', 'H', 'S', '\0', /* SPI_SHADER_TMA_LO_HS (50340) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'H', 'I', '_', 'H', 'S', '\0', /* SPI_SHADER_TMA_HI_HS (50361) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'L', 'O', '_', 'L', 'S', '\0', /* SPI_SHADER_TBA_LO_LS (50382) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'B', 'A', '_', 'H', 'I', '_', 'L', 'S', '\0', /* SPI_SHADER_TBA_HI_LS (50403) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'L', 'O', '_', 'L', 'S', '\0', /* SPI_SHADER_TMA_LO_LS (50424) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'T', 'M', 'A', '_', 'H', 'I', '_', 'L', 'S', '\0', /* SPI_SHADER_TMA_HI_LS (50445) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'M', 'A', 'X', '_', 'W', 'A', 'V', 'E', '_', 'I', 'D', '\0', /* COMPUTE_MAX_WAVE_ID (50466, 50474, 50478) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'T', 'B', 'A', '_', 'L', 'O', '\0', /* COMPUTE_TBA_LO (50486) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'T', 'B', 'A', '_', 'H', 'I', '\0', /* COMPUTE_TBA_HI (50501) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'T', 'M', 'A', '_', 'L', 'O', '\0', /* COMPUTE_TMA_LO (50516) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'T', 'M', 'A', '_', 'H', 'I', '\0', /* COMPUTE_TMA_HI (50531) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'T', 'I', 'C', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'M', 'G', 'M', 'T', '_', 'S', 'E', '0', '\0', /* COMPUTE_STATIC_THREAD_MGMT_SE0 (50546) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'T', 'I', 'C', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'M', 'G', 'M', 'T', '_', 'S', 'E', '1', '\0', /* COMPUTE_STATIC_THREAD_MGMT_SE1 (50577) */
	'S', 'D', 'M', 'A', '0', '_', 'S', 'T', 'A', 'T', 'U', 'S', '_', 'R', 'E', 'G', '\0', /* SDMA0_STATUS_REG (50608) */
	'S', 'D', 'M', 'A', '1', '_', 'S', 'T', 'A', 'T', 'U', 'S', '_', 'R', 'E', 'G', '\0', /* SDMA1_STATUS_REG (50625) */
	'D', 'B', '_', 'D', 'E', 'P', 'T', 'H', '_', 'I', 'N', 'F', 'O', '\0', /* DB_DEPTH_INFO (50642) */
	'D', 'B', '_', 'D', 'E', 'P', 'T', 'H', '_', 'S', 'I', 'Z', 'E', '\0', /* DB_DEPTH_SIZE (50656) */
	'D', 'B', '_', 'D', 'E', 'P', 'T', 'H', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* DB_DEPTH_SLICE (50670) */
	'C', 'P', '_', 'R', 'I', 'N', 'G', 'I', 'D', '\0', /* CP_RINGID (50685, 50688) */
	'C', 'P', '_', 'C', 'P', 'C', '_', 'M', 'C', '_', 'C', 'N', 'T', 'L', '\0', /* CP_CPC_MC_CNTL (50695) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'B', 'A', 'S', 'E', '2', '\0', /* SQ_THREAD_TRACE_BASE2 (50710) */
	'S', 'Q', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'T', 'O', 'K', 'E', 'N', '_', 'M', 'A', 'S', 'K', '2', '\0', /* SQ_THREAD_TRACE_TOKEN_MASK2 (50732) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'T', 'I', 'C', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'M', 'G', 'M', 'T', '_', 'S', 'E', '2', '\0', /* COMPUTE_STATIC_THREAD_MGMT_SE2 (50760) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'T', 'I', 'C', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'M', 'G', 'M', 'T', '_', 'S', 'E', '3', '\0', /* COMPUTE_STATIC_THREAD_MGMT_SE3 (50791) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* WD_PERFCOUNTER0_LO (50822) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* WD_PERFCOUNTER0_HI (50841) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* WD_PERFCOUNTER1_LO (50860) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* WD_PERFCOUNTER1_HI (50879) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* WD_PERFCOUNTER2_LO (50898) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* WD_PERFCOUNTER2_HI (50917) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* WD_PERFCOUNTER3_LO (50936) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* WD_PERFCOUNTER3_HI (50955) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* TCC_PERFCOUNTER0_LO (50974) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* TCC_PERFCOUNTER0_HI (50994) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* TCC_PERFCOUNTER1_LO (51014) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* TCC_PERFCOUNTER1_HI (51034) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* TCC_PERFCOUNTER2_LO (51054) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* TCC_PERFCOUNTER2_HI (51074) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* TCC_PERFCOUNTER3_LO (51094) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* TCC_PERFCOUNTER3_HI (51114) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* TCA_PERFCOUNTER0_LO (51134) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* TCA_PERFCOUNTER0_HI (51154) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* TCA_PERFCOUNTER1_LO (51174) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* TCA_PERFCOUNTER1_HI (51194) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* TCA_PERFCOUNTER2_LO (51214) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* TCA_PERFCOUNTER2_HI (51234) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* TCA_PERFCOUNTER3_LO (51254) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* TCA_PERFCOUNTER3_HI (51274) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'L', 'O', '\0', /* TCS_PERFCOUNTER0_LO (51294) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'H', 'I', '\0', /* TCS_PERFCOUNTER0_HI (51314) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'L', 'O', '\0', /* TCS_PERFCOUNTER1_LO (51334) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'H', 'I', '\0', /* TCS_PERFCOUNTER1_HI (51354) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'L', 'O', '\0', /* TCS_PERFCOUNTER2_LO (51374) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'H', 'I', '\0', /* TCS_PERFCOUNTER2_HI (51394) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'L', 'O', '\0', /* TCS_PERFCOUNTER3_LO (51414) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'H', 'I', '\0', /* TCS_PERFCOUNTER3_HI (51434) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* WD_PERFCOUNTER0_SELECT (51454) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* WD_PERFCOUNTER1_SELECT (51477) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* WD_PERFCOUNTER2_SELECT (51500) */
	'W', 'D', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* WD_PERFCOUNTER3_SELECT (51523) */
	'I', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* IA_PERFCOUNTER0_SELECT1 (51546) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* VGT_PERFCOUNTER0_SELECT1 (51570) */
	'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* VGT_PERFCOUNTER1_SELECT1 (51595) */
	'S', 'Q', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'M', 'A', 'S', 'K', '\0', /* SQ_PERFCOUNTER_MASK (51620) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCC_PERFCOUNTER0_SELECT (51640) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* TCC_PERFCOUNTER0_SELECT1 (51664) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCC_PERFCOUNTER1_SELECT (51689) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* TCC_PERFCOUNTER1_SELECT1 (51713) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCC_PERFCOUNTER2_SELECT (51738) */
	'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCC_PERFCOUNTER3_SELECT (51762) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCA_PERFCOUNTER0_SELECT (51786) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* TCA_PERFCOUNTER0_SELECT1 (51810) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCA_PERFCOUNTER1_SELECT (51835) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* TCA_PERFCOUNTER1_SELECT1 (51859) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCA_PERFCOUNTER2_SELECT (51884) */
	'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCA_PERFCOUNTER3_SELECT (51908) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCS_PERFCOUNTER0_SELECT (51932) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '0', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* TCS_PERFCOUNTER0_SELECT1 (51956) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '1', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCS_PERFCOUNTER1_SELECT (51981) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '2', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCS_PERFCOUNTER2_SELECT (52005) */
	'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '3', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TCS_PERFCOUNTER3_SELECT (52029) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'C', 'P', 'G', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_CPG_PERFMON_SAMPLE_DELAY (52053, 52065) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'C', 'P', 'C', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_CPC_PERFMON_SAMPLE_DELAY (52086) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'C', 'P', 'F', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_CPF_PERFMON_SAMPLE_DELAY (52119) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'C', 'B', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_CB_PERFMON_SAMPLE_DELAY (52152) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'D', 'B', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_DB_PERFMON_SAMPLE_DELAY (52184) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'A', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_PA_PERFMON_SAMPLE_DELAY (52216) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'G', 'D', 'S', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_GDS_PERFMON_SAMPLE_DELAY (52248) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'I', 'A', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_IA_PERFMON_SAMPLE_DELAY (52281) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'C', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_SC_PERFMON_SAMPLE_DELAY (52313) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'T', 'C', 'C', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_TCC_PERFMON_SAMPLE_DELAY (52345) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'T', 'C', 'A', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_TCA_PERFMON_SAMPLE_DELAY (52378) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'T', 'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_TCP_PERFMON_SAMPLE_DELAY (52411) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'T', 'A', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_TA_PERFMON_SAMPLE_DELAY (52444) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'T', 'D', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_TD_PERFMON_SAMPLE_DELAY (52476) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'V', 'G', 'T', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_VGT_PERFMON_SAMPLE_DELAY (52508) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'P', 'I', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_SPI_PERFMON_SAMPLE_DELAY (52541) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'Q', 'G', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_SQG_PERFMON_SAMPLE_DELAY (52574) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'T', 'C', 'S', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_TCS_PERFMON_SAMPLE_DELAY (52607) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'S', 'X', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_SX_PERFMON_SAMPLE_DELAY (52640) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'D', 'B', 'R', '0', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY (52672) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'D', 'B', 'R', '1', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY (52706) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'C', 'B', 'R', '0', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY (52740) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'C', 'B', 'R', '1', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY (52774) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'W', 'A', 'V', 'E', '_', 'R', 'E', 'S', 'T', 'O', 'R', 'E', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* COMPUTE_WAVE_RESTORE_CONTROL (52808) */
	'C', 'P', '_', 'C', 'E', '_', 'R', 'B', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* CP_CE_RB_OFFSET (52837) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '6', '\0', /* SPI_SHADER_USER_DATA_ES_16 (52853) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '7', '\0', /* SPI_SHADER_USER_DATA_ES_17 (52880) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '8', '\0', /* SPI_SHADER_USER_DATA_ES_18 (52907) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '1', '9', '\0', /* SPI_SHADER_USER_DATA_ES_19 (52934) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '0', '\0', /* SPI_SHADER_USER_DATA_ES_20 (52961) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '1', '\0', /* SPI_SHADER_USER_DATA_ES_21 (52988) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '2', '\0', /* SPI_SHADER_USER_DATA_ES_22 (53015) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '3', '\0', /* SPI_SHADER_USER_DATA_ES_23 (53042) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '4', '\0', /* SPI_SHADER_USER_DATA_ES_24 (53069) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '5', '\0', /* SPI_SHADER_USER_DATA_ES_25 (53096) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '6', '\0', /* SPI_SHADER_USER_DATA_ES_26 (53123) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '7', '\0', /* SPI_SHADER_USER_DATA_ES_27 (53150) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '8', '\0', /* SPI_SHADER_USER_DATA_ES_28 (53177) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '2', '9', '\0', /* SPI_SHADER_USER_DATA_ES_29 (53204) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '3', '0', '\0', /* SPI_SHADER_USER_DATA_ES_30 (53231) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'E', 'S', '_', '3', '1', '\0', /* SPI_SHADER_USER_DATA_ES_31 (53258) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '6', '\0', /* SPI_SHADER_USER_DATA_LS_16 (53285) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '7', '\0', /* SPI_SHADER_USER_DATA_LS_17 (53312) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '8', '\0', /* SPI_SHADER_USER_DATA_LS_18 (53339) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '1', '9', '\0', /* SPI_SHADER_USER_DATA_LS_19 (53366) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '0', '\0', /* SPI_SHADER_USER_DATA_LS_20 (53393) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '1', '\0', /* SPI_SHADER_USER_DATA_LS_21 (53420) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '2', '\0', /* SPI_SHADER_USER_DATA_LS_22 (53447) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '3', '\0', /* SPI_SHADER_USER_DATA_LS_23 (53474) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '4', '\0', /* SPI_SHADER_USER_DATA_LS_24 (53501) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '5', '\0', /* SPI_SHADER_USER_DATA_LS_25 (53528) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '6', '\0', /* SPI_SHADER_USER_DATA_LS_26 (53555) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '7', '\0', /* SPI_SHADER_USER_DATA_LS_27 (53582) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '8', '\0', /* SPI_SHADER_USER_DATA_LS_28 (53609) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '2', '9', '\0', /* SPI_SHADER_USER_DATA_LS_29 (53636) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '3', '0', '\0', /* SPI_SHADER_USER_DATA_LS_30 (53663) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'L', 'S', '_', '3', '1', '\0', /* SPI_SHADER_USER_DATA_LS_31 (53690) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '0', '\0', /* SPI_SHADER_USER_DATA_COMMON_0 (53717) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '\0', /* SPI_SHADER_USER_DATA_COMMON_1 (53747) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '\0', /* SPI_SHADER_USER_DATA_COMMON_2 (53777) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '3', '\0', /* SPI_SHADER_USER_DATA_COMMON_3 (53807) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '4', '\0', /* SPI_SHADER_USER_DATA_COMMON_4 (53837) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '5', '\0', /* SPI_SHADER_USER_DATA_COMMON_5 (53867) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '6', '\0', /* SPI_SHADER_USER_DATA_COMMON_6 (53897) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '7', '\0', /* SPI_SHADER_USER_DATA_COMMON_7 (53927) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '8', '\0', /* SPI_SHADER_USER_DATA_COMMON_8 (53957) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '9', '\0', /* SPI_SHADER_USER_DATA_COMMON_9 (53987) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '0', '\0', /* SPI_SHADER_USER_DATA_COMMON_10 (54017) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '1', '\0', /* SPI_SHADER_USER_DATA_COMMON_11 (54048) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '2', '\0', /* SPI_SHADER_USER_DATA_COMMON_12 (54079) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '3', '\0', /* SPI_SHADER_USER_DATA_COMMON_13 (54110) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '4', '\0', /* SPI_SHADER_USER_DATA_COMMON_14 (54141) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '5', '\0', /* SPI_SHADER_USER_DATA_COMMON_15 (54172) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '6', '\0', /* SPI_SHADER_USER_DATA_COMMON_16 (54203) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '7', '\0', /* SPI_SHADER_USER_DATA_COMMON_17 (54234) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '8', '\0', /* SPI_SHADER_USER_DATA_COMMON_18 (54265) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '1', '9', '\0', /* SPI_SHADER_USER_DATA_COMMON_19 (54296) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '0', '\0', /* SPI_SHADER_USER_DATA_COMMON_20 (54327) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '1', '\0', /* SPI_SHADER_USER_DATA_COMMON_21 (54358) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '2', '\0', /* SPI_SHADER_USER_DATA_COMMON_22 (54389) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '3', '\0', /* SPI_SHADER_USER_DATA_COMMON_23 (54420) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '4', '\0', /* SPI_SHADER_USER_DATA_COMMON_24 (54451) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '5', '\0', /* SPI_SHADER_USER_DATA_COMMON_25 (54482) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '6', '\0', /* SPI_SHADER_USER_DATA_COMMON_26 (54513) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '7', '\0', /* SPI_SHADER_USER_DATA_COMMON_27 (54544) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '8', '\0', /* SPI_SHADER_USER_DATA_COMMON_28 (54575) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '2', '9', '\0', /* SPI_SHADER_USER_DATA_COMMON_29 (54606) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '3', '0', '\0', /* SPI_SHADER_USER_DATA_COMMON_30 (54637) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'S', 'E', 'R', '_', 'D', 'A', 'T', 'A', '_', 'C', 'O', 'M', 'M', 'O', 'N', '_', '3', '1', '\0', /* SPI_SHADER_USER_DATA_COMMON_31 (54668) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'T', 'I', 'C', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'M', 'G', 'M', 'T', '_', 'S', 'E', '4', '\0', /* COMPUTE_STATIC_THREAD_MGMT_SE4 (54699) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'T', 'I', 'C', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'M', 'G', 'M', 'T', '_', 'S', 'E', '5', '\0', /* COMPUTE_STATIC_THREAD_MGMT_SE5 (54730) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'T', 'I', 'C', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'M', 'G', 'M', 'T', '_', 'S', 'E', '6', '\0', /* COMPUTE_STATIC_THREAD_MGMT_SE6 (54761) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'T', 'A', 'T', 'I', 'C', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'M', 'G', 'M', 'T', '_', 'S', 'E', '7', '\0', /* COMPUTE_STATIC_THREAD_MGMT_SE7 (54792) */
	'D', 'B', '_', 'Z', '_', 'I', 'N', 'F', 'O', '2', '\0', /* DB_Z_INFO2 (54823) */
	'D', 'B', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'I', 'N', 'F', 'O', '2', '\0', /* DB_STENCIL_INFO2 (54834) */
	'C', 'B', '_', 'M', 'R', 'T', '0', '_', 'E', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_MRT0_EPITCH (54851, 54859) */
	'C', 'B', '_', 'M', 'R', 'T', '1', '_', 'E', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_MRT1_EPITCH (54866) */
	'C', 'B', '_', 'M', 'R', 'T', '2', '_', 'E', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_MRT2_EPITCH (54881) */
	'C', 'B', '_', 'M', 'R', 'T', '3', '_', 'E', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_MRT3_EPITCH (54896) */
	'C', 'B', '_', 'M', 'R', 'T', '4', '_', 'E', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_MRT4_EPITCH (54911) */
	'C', 'B', '_', 'M', 'R', 'T', '5', '_', 'E', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_MRT5_EPITCH (54926) */
	'C', 'B', '_', 'M', 'R', 'T', '6', '_', 'E', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_MRT6_EPITCH (54941) */
	'C', 'B', '_', 'M', 'R', 'T', '7', '_', 'E', 'P', 'I', 'T', 'C', 'H', '\0', /* CB_MRT7_EPITCH (54956) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'M', 'A', 'X', '_', 'P', 'R', 'I', 'M', 'S', '_', 'P', 'E', 'R', '_', 'S', 'U', 'B', 'G', 'R', 'O', 'U', 'P', '\0', /* VGT_GS_MAX_PRIMS_PER_SUBGROUP (54971, 54978) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'D', 'A', 'T', 'A', '_', 'L', 'O', '\0', /* CP_APPEND_DATA_LO (55001) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'L', 'A', 'S', 'T', '_', 'C', 'S', '_', 'F', 'E', 'N', 'C', 'E', '_', 'L', 'O', '\0', /* CP_APPEND_LAST_CS_FENCE_LO (55019) */
	'C', 'P', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'L', 'A', 'S', 'T', '_', 'P', 'S', '_', 'F', 'E', 'N', 'C', 'E', '_', 'L', 'O', '\0', /* CP_APPEND_LAST_PS_FENCE_LO (55046) */
	'V', 'G', 'T', '_', 'T', 'F', '_', 'M', 'E', 'M', 'O', 'R', 'Y', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '\0', /* VGT_TF_MEMORY_BASE_HI (55073) */
	'S', 'P', 'I', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'C', 'N', 'T', 'L', '_', '1', '\0', /* SPI_CONFIG_CNTL_1 (55095) */
	'S', 'P', 'I', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'C', 'N', 'T', 'L', '_', '2', '\0', /* SPI_CONFIG_CNTL_2 (55113) */
	'S', 'P', 'I', '_', 'W', 'A', 'V', 'E', '_', 'L', 'I', 'M', 'I', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* SPI_WAVE_LIMIT_CNTL (55131) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'R', 'M', 'I', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* RLC_SPM_RMI_PERFMON_SAMPLE_DELAY (55151) */
	'R', 'L', 'C', '_', 'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '_', 'M', 'A', 'X', '\0', /* RLC_SPM_PERFMON_SAMPLE_DELAY_MAX (55184, 55211) */
	'F', 'P', '_', 'R', 'O', 'U', 'N', 'D', '\0', /* FP_ROUND (55217) */
	'F', 'P', '_', 'D', 'E', 'N', 'O', 'R', 'M', '\0', /* FP_DENORM (55226) */
	'D', 'X', '1', '0', '_', 'C', 'L', 'A', 'M', 'P', '\0', /* DX10_CLAMP (55236) */
	'I', 'E', 'E', 'E', '\0', /* IEEE (55247) */
	'L', 'O', 'D', '_', 'C', 'L', 'A', 'M', 'P', 'E', 'D', '\0', /* LOD_CLAMPED (55252) */
	'I', 'N', 'V', 'A', 'L', 'I', 'D', '\0', /* INVALID (55264, 55266) */
	'I', 'N', 'P', 'U', 'T', '_', 'D', 'E', 'N', 'O', 'R', 'M', 'A', 'L', '\0', /* INPUT_DENORMAL (55272) */
	'D', 'I', 'V', 'I', 'D', 'E', '_', 'B', 'Y', '_', 'Z', 'E', 'R', 'O', '\0', /* DIVIDE_BY_ZERO (55287) */
	'O', 'V', 'E', 'R', 'F', 'L', 'O', 'W', '\0', /* OVERFLOW (55302) */
	'U', 'N', 'D', 'E', 'R', 'F', 'L', 'O', 'W', '\0', /* UNDERFLOW (55311) */
	'I', 'N', 'E', 'X', 'A', 'C', 'T', '\0', /* INEXACT (55321, 55323) */
	'I', 'N', 'T', '_', 'D', 'I', 'V', 'I', 'D', 'E', '_', 'B', 'Y', '_', 'Z', 'E', 'R', 'O', '\0', /* INT_DIVIDE_BY_ZERO (55329) */
	'A', 'D', 'D', 'R', 'E', 'S', 'S', '_', 'W', 'A', 'T', 'C', 'H', '\0', /* ADDRESS_WATCH (55348) */
	'M', 'E', 'M', 'O', 'R', 'Y', '_', 'V', 'I', 'O', 'L', 'A', 'T', 'I', 'O', 'N', '\0', /* MEMORY_VIOLATION (55362) */
	'E', 'X', 'C', 'P', '_', 'E', 'N', '\0', /* EXCP_EN (55379) */
	'F', 'P', '1', '6', '_', 'O', 'V', 'F', 'L', '\0', /* FP16_OVFL (55387) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'P', 'E', 'R', 'F', '\0', /* DISABLE_PERF (55397) */
	'V', 'S', 'K', 'I', 'P', '\0', /* VSKIP (55410) */
	'C', 'S', 'P', '\0', /* CSP (55416) */
	'S', 'C', 'C', '\0', /* SCC (55420) */
	'S', 'P', 'I', '_', 'P', 'R', 'I', 'O', '\0', /* SPI_PRIO (55424) */
	'U', 'S', 'E', 'R', '_', 'P', 'R', 'I', 'O', '\0', /* USER_PRIO (55433) */
	'P', 'R', 'I', 'V', '\0', /* PRIV (55443) */
	'T', 'R', 'A', 'P', '_', 'E', 'N', '\0', /* TRAP_EN (55448) */
	'T', 'T', 'R', 'A', 'C', 'E', '_', 'E', 'N', '\0', /* TTRACE_EN (55456) */
	'E', 'X', 'P', 'O', 'R', 'T', '_', 'R', 'D', 'Y', '\0', /* EXPORT_RDY (55466) */
	'E', 'X', 'E', 'C', 'Z', '\0', /* EXECZ (55477) */
	'V', 'C', 'C', 'Z', '\0', /* VCCZ (55483) */
	'I', 'N', '_', 'T', 'G', '\0', /* IN_TG (55488) */
	'I', 'N', '_', 'B', 'A', 'R', 'R', 'I', 'E', 'R', '\0', /* IN_BARRIER (55494) */
	'H', 'A', 'L', 'T', '\0', /* HALT (55505) */
	'T', 'R', 'A', 'P', '\0', /* TRAP (55510) */
	'T', 'T', 'R', 'A', 'C', 'E', '_', 'S', 'I', 'M', 'D', '_', 'E', 'N', '\0', /* TTRACE_SIMD_EN (55515, 55522) */
	'E', 'C', 'C', '_', 'E', 'R', 'R', '\0', /* ECC_ERR (55530) */
	'S', 'K', 'I', 'P', '_', 'E', 'X', 'P', 'O', 'R', 'T', '\0', /* SKIP_EXPORT (55538) */
	'P', 'E', 'R', 'F', '_', 'E', 'N', '\0', /* PERF_EN (55550) */
	'F', 'A', 'T', 'A', 'L', '_', 'H', 'A', 'L', 'T', '\0', /* FATAL_HALT (55558) */
	'M', 'U', 'S', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '\0', /* MUST_EXPORT (55569) */
	'E', 'X', 'C', 'P', '\0', /* EXCP (55581) */
	'S', 'A', 'V', 'E', 'C', 'T', 'X', '\0', /* SAVECTX (55586) */
	'I', 'L', 'L', 'E', 'G', 'A', 'L', '_', 'I', 'N', 'S', 'T', '\0', /* ILLEGAL_INST (55594) */
	'E', 'X', 'C', 'P', '_', 'H', 'I', '\0', /* EXCP_HI (55607) */
	'B', 'U', 'F', 'F', 'E', 'R', '_', 'O', 'O', 'B', '\0', /* BUFFER_OOB (55615) */
	'E', 'X', 'C', 'P', '_', 'C', 'Y', 'C', 'L', 'E', '\0', /* EXCP_CYCLE (55626) */
	'E', 'X', 'C', 'P', '_', 'G', 'R', 'O', 'U', 'P', '_', 'M', 'A', 'S', 'K', '\0', /* EXCP_GROUP_MASK (55637) */
	'E', 'X', 'C', 'P', '_', 'W', 'A', 'V', 'E', '6', '4', 'H', 'I', '\0', /* EXCP_WAVE64HI (55653, 55658) */
	'X', 'N', 'A', 'C', 'K', '_', 'E', 'R', 'R', 'O', 'R', '\0', /* XNACK_ERROR (55667) */
	'D', 'P', '_', 'R', 'A', 'T', 'E', '\0', /* DP_RATE (55679) */
	'S', 'I', 'M', 'D', '_', 'I', 'D', '\0', /* SIMD_ID (55687) */
	'P', 'I', 'P', 'E', '_', 'I', 'D', '\0', /* PIPE_ID (55695) */
	'C', 'U', '_', 'I', 'D', '\0', /* CU_ID (55703) */
	'S', 'H', '_', 'I', 'D', '\0', /* SH_ID (55709) */
	'W', 'A', 'V', 'E', '_', 'I', 'D', '_', 'M', 'S', 'B', '\0', /* WAVE_ID_MSB (55715) */
	'T', 'G', '_', 'I', 'D', '\0', /* TG_ID (55727) */
	'V', 'M', '_', 'I', 'D', '\0', /* VM_ID (55733) */
	'Q', 'U', 'E', 'U', 'E', '_', 'I', 'D', '\0', /* QUEUE_ID (55739) */
	'S', 'T', 'A', 'T', 'E', '_', 'I', 'D', '\0', /* STATE_ID (55748) */
	'M', 'E', '_', 'I', 'D', '\0', /* ME_ID (55757) */
	'V', 'G', 'P', 'R', '_', 'B', 'A', 'S', 'E', '\0', /* VGPR_BASE (55763) */
	'V', 'G', 'P', 'R', '_', 'S', 'I', 'Z', 'E', '\0', /* VGPR_SIZE (55773) */
	'S', 'G', 'P', 'R', '_', 'B', 'A', 'S', 'E', '\0', /* SGPR_BASE (55783) */
	'S', 'G', 'P', 'R', '_', 'S', 'I', 'Z', 'E', '\0', /* SGPR_SIZE (55793) */
	'L', 'D', 'S', '_', 'B', 'A', 'S', 'E', '\0', /* LDS_BASE (55803) */
	'L', 'D', 'S', '_', 'S', 'I', 'Z', 'E', '\0', /* LDS_SIZE (55812) */
	'V', 'G', 'P', 'R', '_', 'S', 'H', 'A', 'R', 'E', 'D', '_', 'S', 'I', 'Z', 'E', '\0', /* VGPR_SHARED_SIZE (55821) */
	'V', 'M', '_', 'C', 'N', 'T', '\0', /* VM_CNT (55838) */
	'E', 'X', 'P', '_', 'C', 'N', 'T', '\0', /* EXP_CNT (55845) */
	'L', 'G', 'K', 'M', '_', 'C', 'N', 'T', '_', 'B', 'I', 'T', '4', '\0', /* LGKM_CNT_BIT4 (55853) */
	'L', 'G', 'K', 'M', '_', 'C', 'N', 'T', '\0', /* LGKM_CNT (55867) */
	'V', 'A', 'L', 'U', '_', 'C', 'N', 'T', '\0', /* VALU_CNT (55876) */
	'F', 'I', 'R', 'S', 'T', '_', 'R', 'E', 'P', 'L', 'A', 'Y', '\0', /* FIRST_REPLAY (55885) */
	'R', 'C', 'N', 'T', '\0', /* RCNT (55898) */
	'V', 'M', '_', 'C', 'N', 'T', '_', 'H', 'I', '\0', /* VM_CNT_HI (55903) */
	'L', 'G', 'K', 'M', '_', 'C', 'N', 'T', '_', 'B', 'I', 'T', '5', '\0', /* LGKM_CNT_BIT5 (55913) */
	'R', 'E', 'P', 'L', 'A', 'Y', '_', 'W', '6', '4', 'H', '\0', /* REPLAY_W64H (55927) */
	'V', 'S', '_', 'C', 'N', 'T', '\0', /* VS_CNT (55939) */
	'X', 'N', 'A', 'C', 'K', '\0', /* XNACK (55946) */
	'T', 'A', '_', 'N', 'E', 'E', 'D', '_', 'R', 'E', 'S', 'E', 'T', '\0', /* TA_NEED_RESET (55952) */
	'X', 'N', 'A', 'C', 'K', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* XNACK_OVERRIDE (55966) */
	'X', 'C', 'N', 'T', '\0', /* XCNT (55981) */
	'Q', 'C', 'N', 'T', '\0', /* QCNT (55986) */
	'W', 'A', 'V', 'E', '_', 'I', 'D', 'L', 'E', '\0', /* WAVE_IDLE (55991) */
	'M', 'I', 'S', 'C', '_', 'C', 'N', 'T', '\0', /* MISC_CNT (56001) */
	'W', 'G', 'P', '_', 'I', 'D', '\0', /* WGP_ID (56010) */
	'S', 'A', '_', 'I', 'D', '\0', /* SA_ID (56017) */
	'W', 'G', '_', 'I', 'D', '\0', /* WG_ID (56023) */
	'C', 'O', 'M', 'P', 'A', 'T', '_', 'L', 'E', 'V', 'E', 'L', '\0', /* COMPAT_LEVEL (56029) */
	'P', 'O', 'P', 'S', '_', 'E', 'N', '\0', /* POPS_EN (56042, 56044) */
	'P', 'O', 'P', 'S', '_', 'P', 'A', 'C', 'K', 'E', 'R', '_', 'I', 'D', '\0', /* POPS_PACKER_ID (56050) */
	'D', 'E', 'P', '_', 'M', 'O', 'D', 'E', '\0', /* DEP_MODE (56065) */
	'I', 'N', 'S', 'T', '_', 'P', 'R', 'E', 'F', 'E', 'T', 'C', 'H', '\0', /* INST_PREFETCH (56074) */
	'R', 'E', 'S', 'O', 'U', 'R', 'C', 'E', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* RESOURCE_OVERRIDE (56088) */
	'M', 'E', 'M', '_', 'O', 'R', 'D', 'E', 'R', '\0', /* MEM_ORDER (56106) */
	'F', 'W', 'D', '_', 'P', 'R', 'O', 'G', 'R', 'E', 'S', 'S', '\0', /* FWD_PROGRESS (56116) */
	'W', 'A', 'V', 'E', '6', '4', '\0', /* WAVE64 (56129) */
	'S', 'U', 'B', 'V', '_', 'L', 'O', 'O', 'P', '\0', /* SUBV_LOOP (56136) */
	'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'C', 'M', 'D', 'F', 'I', 'F', 'O', '_', 'A', 'V', 'A', 'I', 'L', '\0', /* ME0PIPE1_CMDFIFO_AVAIL (56146) */
	'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'C', 'F', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME0PIPE1_CF_RQ_PENDING (56169) */
	'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'P', 'F', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME0PIPE1_PF_RQ_PENDING (56192) */
	'M', 'E', '1', 'P', 'I', 'P', 'E', '0', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME1PIPE0_RQ_PENDING (56215) */
	'M', 'E', '1', 'P', 'I', 'P', 'E', '1', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME1PIPE1_RQ_PENDING (56235) */
	'M', 'E', '1', 'P', 'I', 'P', 'E', '2', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME1PIPE2_RQ_PENDING (56255) */
	'M', 'E', '1', 'P', 'I', 'P', 'E', '3', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME1PIPE3_RQ_PENDING (56275) */
	'M', 'E', '2', 'P', 'I', 'P', 'E', '0', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME2PIPE0_RQ_PENDING (56295) */
	'M', 'E', '2', 'P', 'I', 'P', 'E', '1', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME2PIPE1_RQ_PENDING (56315) */
	'M', 'E', '2', 'P', 'I', 'P', 'E', '2', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME2PIPE2_RQ_PENDING (56335) */
	'M', 'E', '2', 'P', 'I', 'P', 'E', '3', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME2PIPE3_RQ_PENDING (56355) */
	'R', 'L', 'C', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* RLC_RQ_PENDING (56375) */
	'U', 'T', 'C', 'L', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* UTCL2_BUSY (56390, 56396) */
	'E', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* EA_BUSY (56401) */
	'R', 'M', 'I', '_', 'B', 'U', 'S', 'Y', '\0', /* RMI_BUSY (56409) */
	'U', 'T', 'C', 'L', '2', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* UTCL2_RQ_PENDING (56418) */
	'C', 'P', 'F', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* CPF_RQ_PENDING (56435) */
	'E', 'A', '_', 'L', 'I', 'N', 'K', '_', 'B', 'U', 'S', 'Y', '\0', /* EA_LINK_BUSY (56450) */
	'S', 'D', 'M', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* SDMA_BUSY (56463, 56464) */
	'S', 'D', 'M', 'A', '0', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* SDMA0_RQ_PENDING (56473) */
	'S', 'D', 'M', 'A', '1', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* SDMA1_RQ_PENDING (56490) */
	'R', 'L', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* RLC_BUSY (56507) */
	'T', 'C', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* TCP_BUSY (56516, 56517) */
	'C', 'P', 'F', '_', 'B', 'U', 'S', 'Y', '\0', /* CPF_BUSY (56525) */
	'C', 'P', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* CPC_BUSY (56534) */
	'C', 'P', 'G', '_', 'B', 'U', 'S', 'Y', '\0', /* CPG_BUSY (56543) */
	'C', 'P', 'A', 'X', 'I', '_', 'B', 'U', 'S', 'Y', '\0', /* CPAXI_BUSY (56552) */
	'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'C', 'M', 'D', 'F', 'I', 'F', 'O', '_', 'A', 'V', 'A', 'I', 'L', '\0', /* ME0PIPE0_CMDFIFO_AVAIL (56563) */
	'R', 'S', 'M', 'U', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* RSMU_RQ_PENDING (56586, 56587) */
	'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'C', 'F', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME0PIPE0_CF_RQ_PENDING (56602) */
	'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'P', 'F', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ME0PIPE0_PF_RQ_PENDING (56625) */
	'G', 'D', 'S', '_', 'D', 'M', 'A', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* GDS_DMA_RQ_PENDING (56648) */
	'D', 'B', '_', 'C', 'L', 'E', 'A', 'N', '\0', /* DB_CLEAN (56667) */
	'C', 'B', '_', 'C', 'L', 'E', 'A', 'N', '\0', /* CB_CLEAN (56676) */
	'T', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* TA_BUSY (56685) */
	'G', 'D', 'S', '_', 'B', 'U', 'S', 'Y', '\0', /* GDS_BUSY (56693) */
	'G', 'E', '_', 'B', 'U', 'S', 'Y', '_', 'N', 'O', '_', 'D', 'M', 'A', '\0', /* GE_BUSY_NO_DMA (56702) */
	'S', 'X', '_', 'B', 'U', 'S', 'Y', '\0', /* SX_BUSY (56717) */
	'G', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* GE_BUSY (56725) */
	'S', 'P', 'I', '_', 'B', 'U', 'S', 'Y', '\0', /* SPI_BUSY (56733) */
	'B', 'C', 'I', '_', 'B', 'U', 'S', 'Y', '\0', /* BCI_BUSY (56742) */
	'S', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* SC_BUSY (56751) */
	'P', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* PA_BUSY (56759) */
	'D', 'B', '_', 'B', 'U', 'S', 'Y', '\0', /* DB_BUSY (56767) */
	'C', 'P', '_', 'C', 'O', 'H', 'E', 'R', 'E', 'N', 'C', 'Y', '_', 'B', 'U', 'S', 'Y', '\0', /* CP_COHERENCY_BUSY (56775) */
	'C', 'B', '_', 'B', 'U', 'S', 'Y', '\0', /* CB_BUSY (56793) */
	'G', 'U', 'I', '_', 'A', 'C', 'T', 'I', 'V', 'E', '\0', /* GUI_ACTIVE (56801) */
	'U', 'T', 'C', 'L', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* UTCL1_BUSY (56812) */
	'G', 'L', '1', 'C', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* GL1CC_BUSY (56823) */
	'G', 'R', 'B', 'M', '_', 'R', 'L', 'C', '_', 'I', 'N', 'T', 'R', '_', 'C', 'R', 'E', 'D', 'I', 'T', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* GRBM_RLC_INTR_CREDIT_PENDING (56834) */
	'G', 'R', 'B', 'M', '_', 'U', 'T', 'C', 'L', '2', '_', 'I', 'N', 'T', 'R', '_', 'C', 'R', 'E', 'D', 'I', 'T', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* GRBM_UTCL2_INTR_CREDIT_PENDING (56863) */
	'G', 'R', 'B', 'M', '_', 'C', 'P', 'F', '_', 'I', 'N', 'T', 'R', '_', 'C', 'R', 'E', 'D', 'I', 'T', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* GRBM_CPF_INTR_CREDIT_PENDING (56894) */
	'M', 'E', 'S', 'P', 'I', 'P', 'E', '0', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* MESPIPE0_RQ_PENDING (56923) */
	'M', 'E', 'S', 'P', 'I', 'P', 'E', '1', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* MESPIPE1_RQ_PENDING (56943) */
	'M', 'E', 'S', 'P', 'I', 'P', 'E', '2', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* MESPIPE2_RQ_PENDING (56963) */
	'M', 'E', 'S', 'P', 'I', 'P', 'E', '3', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* MESPIPE3_RQ_PENDING (56983) */
	'P', 'H', '_', 'B', 'U', 'S', 'Y', '\0', /* PH_BUSY (57003) */
	'C', 'H', '_', 'B', 'U', 'S', 'Y', '\0', /* CH_BUSY (57011) */
	'G', 'L', '2', 'C', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* GL2CC_BUSY (57019) */
	'G', 'U', 'S', '_', 'L', 'I', 'N', 'K', '_', 'B', 'U', 'S', 'Y', '\0', /* GUS_LINK_BUSY (57030) */
	'G', 'U', 'S', '_', 'B', 'U', 'S', 'Y', '\0', /* GUS_BUSY (57044) */
	'P', 'M', 'M', '_', 'B', 'U', 'S', 'Y', '\0', /* PMM_BUSY (57053) */
	'M', 'E', 'C', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_BUSY (57062) */
	'M', 'E', 'C', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_BUSY (57072) */
	'D', 'C', '0', '_', 'B', 'U', 'S', 'Y', '\0', /* DC0_BUSY (57082) */
	'D', 'C', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* DC1_BUSY (57091) */
	'R', 'C', 'I', 'U', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* RCIU1_BUSY (57100) */
	'R', 'C', 'I', 'U', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* RCIU2_BUSY (57111) */
	'R', 'O', 'Q', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ1_BUSY (57122) */
	'R', 'O', 'Q', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ2_BUSY (57132) */
	'T', 'C', 'I', 'U', '_', 'B', 'U', 'S', 'Y', '\0', /* TCIU_BUSY (57142) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'A', 'M', '_', 'B', 'U', 'S', 'Y', '\0', /* SCRATCH_RAM_BUSY (57152) */
	'Q', 'U', '_', 'B', 'U', 'S', 'Y', '\0', /* QU_BUSY (57169) */
	'U', 'T', 'C', 'L', '2', 'I', 'U', '_', 'B', 'U', 'S', 'Y', '\0', /* UTCL2IU_BUSY (57177) */
	'S', 'A', 'V', 'E', '_', 'R', 'E', 'S', 'T', 'O', 'R', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* SAVE_RESTORE_BUSY (57190) */
	'G', 'C', 'R', 'I', 'U', '_', 'B', 'U', 'S', 'Y', '\0', /* GCRIU_BUSY (57208) */
	'M', 'E', 'S', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_BUSY (57219) */
	'M', 'E', 'S', '_', 'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'R', 'A', 'M', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_SCRATCH_RAM_BUSY (57228) */
	'R', 'C', 'I', 'U', '3', '_', 'B', 'U', 'S', 'Y', '\0', /* RCIU3_BUSY (57249) */
	'M', 'E', 'S', '_', 'I', 'N', 'S', 'T', 'R', 'U', 'C', 'T', 'I', 'O', 'N', '_', 'C', 'A', 'C', 'H', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_INSTRUCTION_CACHE_BUSY (57260) */
	'C', 'P', 'G', '_', 'C', 'P', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* CPG_CPC_BUSY (57287) */
	'C', 'P', 'F', '_', 'C', 'P', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* CPF_CPC_BUSY (57300) */
	'M', 'E', 'C', '1', '_', 'L', 'O', 'A', 'D', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_LOAD_BUSY (57313) */
	'M', 'E', 'C', '1', '_', 'S', 'E', 'M', 'A', 'P', 'O', 'H', 'R', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_SEMAPOHRE_BUSY (57328) */
	'M', 'E', 'C', '1', '_', 'M', 'U', 'T', 'E', 'X', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_MUTEX_BUSY (57348) */
	'M', 'E', 'C', '1', '_', 'M', 'E', 'S', 'S', 'A', 'G', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_MESSAGE_BUSY (57364) */
	'M', 'E', 'C', '1', '_', 'E', 'O', 'P', '_', 'Q', 'U', 'E', 'U', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_EOP_QUEUE_BUSY (57382) */
	'M', 'E', 'C', '1', '_', 'I', 'Q', '_', 'Q', 'U', 'E', 'U', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_IQ_QUEUE_BUSY (57402) */
	'M', 'E', 'C', '1', '_', 'I', 'B', '_', 'Q', 'U', 'E', 'U', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_IB_QUEUE_BUSY (57421) */
	'M', 'E', 'C', '1', '_', 'T', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_TC_BUSY (57440, 57445) */
	'M', 'E', 'C', '1', '_', 'D', 'M', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_DMA_BUSY (57453) */
	'M', 'E', 'C', '1', '_', 'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'F', 'L', 'U', 'S', 'H', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_PARTIAL_FLUSH_BUSY (57467) */
	'M', 'E', 'C', '1', '_', 'P', 'I', 'P', 'E', '0', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_PIPE0_BUSY (57491) */
	'M', 'E', 'C', '1', '_', 'P', 'I', 'P', 'E', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_PIPE1_BUSY (57507) */
	'M', 'E', 'C', '1', '_', 'P', 'I', 'P', 'E', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_PIPE2_BUSY (57523) */
	'M', 'E', 'C', '1', '_', 'P', 'I', 'P', 'E', '3', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC1_PIPE3_BUSY (57539) */
	'M', 'E', 'C', '2', '_', 'L', 'O', 'A', 'D', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_LOAD_BUSY (57555) */
	'M', 'E', 'C', '2', '_', 'S', 'E', 'M', 'A', 'P', 'O', 'H', 'R', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_SEMAPOHRE_BUSY (57570) */
	'M', 'E', 'C', '2', '_', 'M', 'U', 'T', 'E', 'X', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_MUTEX_BUSY (57590) */
	'M', 'E', 'C', '2', '_', 'M', 'E', 'S', 'S', 'A', 'G', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_MESSAGE_BUSY (57606) */
	'M', 'E', 'C', '2', '_', 'E', 'O', 'P', '_', 'Q', 'U', 'E', 'U', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_EOP_QUEUE_BUSY (57624) */
	'M', 'E', 'C', '2', '_', 'I', 'Q', '_', 'Q', 'U', 'E', 'U', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_IQ_QUEUE_BUSY (57644) */
	'M', 'E', 'C', '2', '_', 'I', 'B', '_', 'Q', 'U', 'E', 'U', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_IB_QUEUE_BUSY (57663) */
	'M', 'E', 'C', '2', '_', 'T', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_TC_BUSY (57682) */
	'M', 'E', 'C', '2', '_', 'D', 'M', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_DMA_BUSY (57695) */
	'M', 'E', 'C', '2', '_', 'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'F', 'L', 'U', 'S', 'H', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_PARTIAL_FLUSH_BUSY (57709) */
	'M', 'E', 'C', '2', '_', 'P', 'I', 'P', 'E', '0', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_PIPE0_BUSY (57733) */
	'M', 'E', 'C', '2', '_', 'P', 'I', 'P', 'E', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_PIPE1_BUSY (57749) */
	'M', 'E', 'C', '2', '_', 'P', 'I', 'P', 'E', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_PIPE2_BUSY (57765) */
	'M', 'E', 'C', '2', '_', 'P', 'I', 'P', 'E', '3', '_', 'B', 'U', 'S', 'Y', '\0', /* MEC2_PIPE3_BUSY (57781) */
	'R', 'C', 'I', 'U', '_', 'T', 'X', '_', 'F', 'R', 'E', 'E', '_', 'S', 'T', 'A', 'L', 'L', '\0', /* RCIU_TX_FREE_STALL (57797) */
	'R', 'C', 'I', 'U', '_', 'P', 'R', 'I', 'V', '_', 'V', 'I', 'O', 'L', 'A', 'T', 'I', 'O', 'N', '\0', /* RCIU_PRIV_VIOLATION (57816) */
	'T', 'C', 'I', 'U', '_', 'T', 'X', '_', 'F', 'R', 'E', 'E', '_', 'S', 'T', 'A', 'L', 'L', '\0', /* TCIU_TX_FREE_STALL (57836) */
	'M', 'E', 'C', '1', '_', 'D', 'E', 'C', 'O', 'D', 'I', 'N', 'G', '_', 'P', 'A', 'C', 'K', 'E', 'T', '\0', /* MEC1_DECODING_PACKET (57855) */
	'M', 'E', 'C', '1', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'R', 'C', 'I', 'U', '\0', /* MEC1_WAIT_ON_RCIU (57876) */
	'M', 'E', 'C', '1', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'R', 'C', 'I', 'U', '_', 'R', 'E', 'A', 'D', '\0', /* MEC1_WAIT_ON_RCIU_READ (57894) */
	'M', 'E', 'C', '1', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'R', 'O', 'Q', '_', 'D', 'A', 'T', 'A', '\0', /* MEC1_WAIT_ON_ROQ_DATA (57917) */
	'M', 'E', 'C', '2', '_', 'D', 'E', 'C', 'O', 'D', 'I', 'N', 'G', '_', 'P', 'A', 'C', 'K', 'E', 'T', '\0', /* MEC2_DECODING_PACKET (57939) */
	'M', 'E', 'C', '2', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'R', 'C', 'I', 'U', '\0', /* MEC2_WAIT_ON_RCIU (57960) */
	'M', 'E', 'C', '2', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'R', 'C', 'I', 'U', '_', 'R', 'E', 'A', 'D', '\0', /* MEC2_WAIT_ON_RCIU_READ (57978) */
	'M', 'E', 'C', '2', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'R', 'O', 'Q', '_', 'D', 'A', 'T', 'A', '\0', /* MEC2_WAIT_ON_ROQ_DATA (58001) */
	'U', 'T', 'C', 'L', '2', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'F', 'R', 'E', 'E', '\0', /* UTCL2IU_WAITING_ON_FREE (58023) */
	'U', 'T', 'C', 'L', '2', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'T', 'A', 'G', 'S', '\0', /* UTCL2IU_WAITING_ON_TAGS (58047) */
	'U', 'T', 'C', 'L', '1', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'T', 'R', 'A', 'N', 'S', '\0', /* UTCL1_WAITING_ON_TRANS (58071) */
	'G', 'C', 'R', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'F', 'R', 'E', 'E', '\0', /* GCRIU_WAITING_ON_FREE (58094) */
	'P', 'O', 'S', 'T', '_', 'W', 'P', 'T', 'R', '_', 'G', 'F', 'X', '_', 'B', 'U', 'S', 'Y', '\0', /* POST_WPTR_GFX_BUSY (58116) */
	'C', 'S', 'F', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_BUSY (58135) */
	'R', 'O', 'Q', '_', 'A', 'L', 'I', 'G', 'N', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ_ALIGN_BUSY (58144) */
	'R', 'O', 'Q', '_', 'R', 'I', 'N', 'G', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ_RING_BUSY (58159) */
	'R', 'O', 'Q', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ_INDIRECT1_BUSY (58173) */
	'R', 'O', 'Q', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ_INDIRECT2_BUSY (58192) */
	'R', 'O', 'Q', '_', 'S', 'T', 'A', 'T', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ_STATE_BUSY (58211) */
	'R', 'O', 'Q', '_', 'C', 'E', '_', 'R', 'I', 'N', 'G', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ_CE_RING_BUSY (58226) */
	'R', 'O', 'Q', '_', 'C', 'E', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ_CE_INDIRECT1_BUSY (58243) */
	'R', 'O', 'Q', '_', 'C', 'E', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ_CE_INDIRECT2_BUSY (58265) */
	'S', 'E', 'M', 'A', 'P', 'H', 'O', 'R', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* SEMAPHORE_BUSY (58287) */
	'I', 'N', 'T', 'E', 'R', 'R', 'U', 'P', 'T', '_', 'B', 'U', 'S', 'Y', '\0', /* INTERRUPT_BUSY (58302) */
	'H', 'Q', 'D', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_BUSY (58317) */
	'P', 'R', 'T', '_', 'B', 'U', 'S', 'Y', '\0', /* PRT_BUSY (58326) */
	'R', 'C', 'I', 'U', '_', 'B', 'U', 'S', 'Y', '\0', /* RCIU_BUSY (58335) */
	'R', 'C', 'I', 'U', '_', 'G', 'F', 'X', '_', 'B', 'U', 'S', 'Y', '\0', /* RCIU_GFX_BUSY (58345) */
	'R', 'C', 'I', 'U', '_', 'C', 'M', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* RCIU_CMP_BUSY (58359) */
	'R', 'O', 'Q', '_', 'D', 'A', 'T', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ_DATA_BUSY (58373) */
	'R', 'O', 'Q', '_', 'C', 'E', '_', 'D', 'A', 'T', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* ROQ_CE_DATA_BUSY (58387) */
	'M', 'E', 'S', '_', 'H', 'Q', 'D', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_HQD_BUSY (58404) */
	'C', 'P', 'F', '_', 'G', 'F', 'X', '_', 'B', 'U', 'S', 'Y', '\0', /* CPF_GFX_BUSY (58417) */
	'C', 'P', 'F', '_', 'C', 'M', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* CPF_CMP_BUSY (58430) */
	'G', 'R', 'B', 'M', '_', 'C', 'P', 'F', '_', 'S', 'T', 'A', 'T', '_', 'B', 'U', 'S', 'Y', '\0', /* GRBM_CPF_STAT_BUSY (58443) */
	'C', 'P', 'C', '_', 'C', 'P', 'F', '_', 'B', 'U', 'S', 'Y', '\0', /* CPC_CPF_BUSY (58462) */
	'R', 'E', 'G', '_', 'B', 'U', 'S', '_', 'F', 'I', 'F', 'O', '_', 'B', 'U', 'S', 'Y', '\0', /* REG_BUS_FIFO_BUSY (58475) */
	'C', 'S', 'F', '_', 'R', 'I', 'N', 'G', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_RING_BUSY (58493) */
	'C', 'S', 'F', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_INDIRECT1_BUSY (58507) */
	'C', 'S', 'F', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_INDIRECT2_BUSY (58526) */
	'C', 'S', 'F', '_', 'S', 'T', 'A', 'T', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_STATE_BUSY (58545) */
	'C', 'S', 'F', '_', 'C', 'E', '_', 'I', 'N', 'D', 'R', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_CE_INDR1_BUSY (58560) */
	'C', 'S', 'F', '_', 'C', 'E', '_', 'I', 'N', 'D', 'R', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_CE_INDR2_BUSY (58578) */
	'C', 'S', 'F', '_', 'A', 'R', 'B', 'I', 'T', 'E', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_ARBITER_BUSY (58596) */
	'C', 'S', 'F', '_', 'I', 'N', 'P', 'U', 'T', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_INPUT_BUSY (58613) */
	'C', 'S', 'F', '_', 'D', 'A', 'T', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_DATA_BUSY (58628) */
	'C', 'S', 'F', '_', 'C', 'E', '_', 'D', 'A', 'T', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* CSF_CE_DATA_BUSY (58642) */
	'H', 'P', 'D', '_', 'P', 'R', 'O', 'C', 'E', 'S', 'S', 'I', 'N', 'G', '_', 'E', 'O', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* HPD_PROCESSING_EOP_BUSY (58659) */
	'H', 'Q', 'D', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_DISPATCH_BUSY (58683) */
	'H', 'Q', 'D', '_', 'I', 'Q', '_', 'T', 'I', 'M', 'E', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_IQ_TIMER_BUSY (58701) */
	'H', 'Q', 'D', '_', 'D', 'M', 'A', '_', 'O', 'F', 'F', 'L', 'O', 'A', 'D', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_DMA_OFFLOAD_BUSY (58719) */
	'H', 'Q', 'D', '_', 'W', 'A', 'I', 'T', '_', 'S', 'E', 'M', 'A', 'P', 'H', 'O', 'R', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_WAIT_SEMAPHORE_BUSY (58740) */
	'H', 'Q', 'D', '_', 'S', 'I', 'G', 'N', 'A', 'L', '_', 'S', 'E', 'M', 'A', 'P', 'H', 'O', 'R', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_SIGNAL_SEMAPHORE_BUSY (58764) */
	'H', 'Q', 'D', '_', 'M', 'E', 'S', 'S', 'A', 'G', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_MESSAGE_BUSY (58790) */
	'H', 'Q', 'D', '_', 'P', 'Q', '_', 'F', 'E', 'T', 'C', 'H', 'E', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_PQ_FETCHER_BUSY (58807) */
	'H', 'Q', 'D', '_', 'I', 'B', '_', 'F', 'E', 'T', 'C', 'H', 'E', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_IB_FETCHER_BUSY (58827) */
	'H', 'Q', 'D', '_', 'I', 'Q', '_', 'F', 'E', 'T', 'C', 'H', 'E', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_IQ_FETCHER_BUSY (58847) */
	'H', 'Q', 'D', '_', 'E', 'O', 'P', '_', 'F', 'E', 'T', 'C', 'H', 'E', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_EOP_FETCHER_BUSY (58867) */
	'H', 'Q', 'D', '_', 'C', 'O', 'N', 'S', 'U', 'M', 'E', 'D', '_', 'R', 'P', 'T', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_CONSUMED_RPTR_BUSY (58888) */
	'H', 'Q', 'D', '_', 'F', 'E', 'T', 'C', 'H', 'E', 'R', '_', 'A', 'R', 'B', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_FETCHER_ARB_BUSY (58911) */
	'H', 'Q', 'D', '_', 'R', 'O', 'Q', '_', 'A', 'L', 'I', 'G', 'N', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_ROQ_ALIGN_BUSY (58932) */
	'H', 'Q', 'D', '_', 'R', 'O', 'Q', '_', 'E', 'O', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_ROQ_EOP_BUSY (58951) */
	'H', 'Q', 'D', '_', 'R', 'O', 'Q', '_', 'I', 'Q', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_ROQ_IQ_BUSY (58968) */
	'H', 'Q', 'D', '_', 'R', 'O', 'Q', '_', 'P', 'Q', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_ROQ_PQ_BUSY (58984) */
	'H', 'Q', 'D', '_', 'R', 'O', 'Q', '_', 'I', 'B', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_ROQ_IB_BUSY (59000) */
	'H', 'Q', 'D', '_', 'W', 'P', 'T', 'R', '_', 'P', 'O', 'L', 'L', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_WPTR_POLL_BUSY (59016) */
	'H', 'Q', 'D', '_', 'P', 'Q', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_PQ_BUSY (59035) */
	'H', 'Q', 'D', '_', 'I', 'B', '_', 'B', 'U', 'S', 'Y', '\0', /* HQD_IB_BUSY (59047) */
	'R', 'I', 'N', 'G', '_', 'F', 'E', 'T', 'C', 'H', 'I', 'N', 'G', '_', 'D', 'A', 'T', 'A', '\0', /* RING_FETCHING_DATA (59059) */
	'I', 'N', 'D', 'R', '1', '_', 'F', 'E', 'T', 'C', 'H', 'I', 'N', 'G', '_', 'D', 'A', 'T', 'A', '\0', /* INDR1_FETCHING_DATA (59078) */
	'I', 'N', 'D', 'R', '2', '_', 'F', 'E', 'T', 'C', 'H', 'I', 'N', 'G', '_', 'D', 'A', 'T', 'A', '\0', /* INDR2_FETCHING_DATA (59098) */
	'S', 'T', 'A', 'T', 'E', '_', 'F', 'E', 'T', 'C', 'H', 'I', 'N', 'G', '_', 'D', 'A', 'T', 'A', '\0', /* STATE_FETCHING_DATA (59118) */
	'T', 'C', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'F', 'R', 'E', 'E', '\0', /* TCIU_WAITING_ON_FREE (59138) */
	'T', 'C', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'T', 'A', 'G', 'S', '\0', /* TCIU_WAITING_ON_TAGS (59159) */
	'G', 'F', 'X', '_', 'U', 'T', 'C', 'L', '1', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'T', 'R', 'A', 'N', 'S', '\0', /* GFX_UTCL1_WAITING_ON_TRANS (59180) */
	'C', 'M', 'P', '_', 'U', 'T', 'C', 'L', '1', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'T', 'R', 'A', 'N', 'S', '\0', /* CMP_UTCL1_WAITING_ON_TRANS (59207) */
	'R', 'C', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'F', 'R', 'E', 'E', '\0', /* RCIU_WAITING_ON_FREE (59234) */
	'D', 'A', 'T', 'A', '_', 'F', 'E', 'T', 'C', 'H', 'I', 'N', 'G', '_', 'D', 'A', 'T', 'A', '\0', /* DATA_FETCHING_DATA (59255) */
	'G', 'C', 'R', 'I', 'U', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'F', 'R', 'E', 'E', '\0', /* GCRIU_WAIT_ON_FREE (59274) */
	'M', 'E', 'S', '_', 'L', 'O', 'A', 'D', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_LOAD_BUSY (59293) */
	'M', 'E', 'S', '_', 'M', 'U', 'T', 'E', 'X', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_MUTEX_BUSY (59307) */
	'M', 'E', 'S', '_', 'M', 'E', 'S', 'S', 'A', 'G', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_MESSAGE_BUSY (59322) */
	'M', 'E', 'S', '_', 'T', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_TC_BUSY (59339) */
	'M', 'E', 'S', '_', 'D', 'M', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_DMA_BUSY (59351) */
	'M', 'E', 'S', '_', 'P', 'I', 'P', 'E', '0', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_PIPE0_BUSY (59364) */
	'M', 'E', 'S', '_', 'P', 'I', 'P', 'E', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_PIPE1_BUSY (59379) */
	'M', 'E', 'S', '_', 'P', 'I', 'P', 'E', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_PIPE2_BUSY (59394) */
	'M', 'E', 'S', '_', 'P', 'I', 'P', 'E', '3', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_PIPE3_BUSY (59409) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'I', 'N', 'D', 'E', 'X', '_', '6', '4', 'B', 'I', 'T', '_', 'M', 'O', 'D', 'E', '\0', /* SCRATCH_INDEX_64BIT_MODE (59424) */
	'M', 'E', 'S', '_', 'H', 'Q', 'D', '_', 'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_HQD_DISPATCH_BUSY (59449) */
	'M', 'E', 'S', '_', 'H', 'Q', 'D', '_', 'D', 'M', 'A', '_', 'O', 'F', 'F', 'L', 'O', 'A', 'D', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_HQD_DMA_OFFLOAD_BUSY (59471) */
	'M', 'E', 'S', '_', 'H', 'Q', 'D', '_', 'M', 'E', 'S', 'S', 'A', 'G', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_HQD_MESSAGE_BUSY (59496) */
	'M', 'E', 'S', '_', 'H', 'Q', 'D', '_', 'P', 'Q', '_', 'F', 'E', 'T', 'C', 'H', 'E', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_HQD_PQ_FETCHER_BUSY (59517) */
	'M', 'E', 'S', '_', 'H', 'Q', 'D', '_', 'C', 'O', 'N', 'S', 'U', 'M', 'E', 'D', '_', 'R', 'P', 'T', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_HQD_CONSUMED_RPTR_BUSY (59541) */
	'M', 'E', 'S', '_', 'H', 'Q', 'D', '_', 'F', 'E', 'T', 'C', 'H', 'E', 'R', '_', 'A', 'R', 'B', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_HQD_FETCHER_ARB_BUSY (59568) */
	'M', 'E', 'S', '_', 'H', 'Q', 'D', '_', 'R', 'O', 'Q', '_', 'A', 'L', 'I', 'G', 'N', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_HQD_ROQ_ALIGN_BUSY (59593) */
	'M', 'E', 'S', '_', 'H', 'Q', 'D', '_', 'R', 'O', 'Q', '_', 'P', 'Q', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_HQD_ROQ_PQ_BUSY (59616) */
	'M', 'E', 'S', '_', 'H', 'Q', 'D', '_', 'P', 'Q', '_', 'B', 'U', 'S', 'Y', '\0', /* MES_HQD_PQ_BUSY (59636) */
	'B', 'U', 'F', 'F', 'E', 'R', '_', 'I', 'D', '\0', /* BUFFER_ID (59652) */
	'S', 'I', 'M', 'D', '_', 'S', 'E', 'L', '\0', /* SIMD_SEL (59662) */
	'W', 'G', 'P', '_', 'S', 'E', 'L', '\0', /* WGP_SEL (59671) */
	'S', 'A', '_', 'S', 'E', 'L', '\0', /* SA_SEL (59679) */
	'W', 'T', 'Y', 'P', 'E', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '\0', /* WTYPE_INCLUDE (59686) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'V', 'M', 'E', 'M', 'E', 'X', 'E', 'C', '\0', /* TOKEN_EXCLUDE_VMEMEXEC (59700) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'A', 'L', 'U', 'E', 'X', 'E', 'C', '\0', /* TOKEN_EXCLUDE_ALUEXEC (59723) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'V', 'A', 'L', 'U', 'I', 'N', 'S', 'T', '\0', /* TOKEN_EXCLUDE_VALUINST (59745) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'W', 'A', 'V', 'E', 'R', 'D', 'Y', '\0', /* TOKEN_EXCLUDE_WAVERDY (59768) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'I', 'M', 'M', 'E', 'D', '1', '\0', /* TOKEN_EXCLUDE_IMMED1 (59790) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'I', 'M', 'M', 'E', 'D', 'I', 'A', 'T', 'E', '\0', /* TOKEN_EXCLUDE_IMMEDIATE (59811, 59825) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'R', 'E', 'G', '\0', /* TOKEN_EXCLUDE_REG (59835) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'E', 'V', 'E', 'N', 'T', '\0', /* TOKEN_EXCLUDE_EVENT (59853) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'I', 'N', 'S', 'T', '\0', /* TOKEN_EXCLUDE_INST (59873) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'U', 'T', 'I', 'L', 'C', 'T', 'R', '\0', /* TOKEN_EXCLUDE_UTILCTR (59892) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'W', 'A', 'V', 'E', 'A', 'L', 'L', 'O', 'C', '\0', /* TOKEN_EXCLUDE_WAVEALLOC (59914) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '_', 'P', 'E', 'R', 'F', '\0', /* TOKEN_EXCLUDE_PERF (59938) */
	'T', 'O', 'K', 'E', 'N', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '\0', /* TOKEN_EXCLUDE (59957) */
	'R', 'E', 'G', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '_', 'S', 'Q', 'D', 'E', 'C', '\0', /* REG_INCLUDE_SQDEC (59971) */
	'R', 'E', 'G', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '_', 'S', 'H', 'D', 'E', 'C', '\0', /* REG_INCLUDE_SHDEC (59989) */
	'R', 'E', 'G', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '_', 'G', 'F', 'X', 'U', 'D', 'E', 'C', '\0', /* REG_INCLUDE_GFXUDEC (60007) */
	'R', 'E', 'G', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '_', 'C', 'O', 'M', 'P', '\0', /* REG_INCLUDE_COMP (60027) */
	'R', 'E', 'G', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '\0', /* REG_INCLUDE_CONTEXT (60044) */
	'R', 'E', 'G', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* REG_INCLUDE_CONFIG (60064) */
	'R', 'E', 'G', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '_', 'O', 'T', 'H', 'E', 'R', '\0', /* REG_INCLUDE_OTHER (60083) */
	'R', 'E', 'G', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '_', 'R', 'E', 'A', 'D', 'S', '\0', /* REG_INCLUDE_READS (60101) */
	'R', 'E', 'G', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '\0', /* REG_INCLUDE (60119) */
	'I', 'N', 'S', 'T', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '\0', /* INST_EXCLUDE (60131) */
	'R', 'E', 'G', '_', 'D', 'E', 'T', 'A', 'I', 'L', '_', 'A', 'L', 'L', '\0', /* REG_DETAIL_ALL (60144) */
	'A', 'L', 'L', '_', 'V', 'M', 'I', 'D', '\0', /* ALL_VMID (60159) */
	'C', 'H', '_', 'P', 'E', 'R', 'F', '_', 'E', 'N', '\0', /* CH_PERF_EN (60168) */
	'I', 'N', 'T', 'E', 'R', 'R', 'U', 'P', 'T', '_', 'E', 'N', '\0', /* INTERRUPT_EN (60179) */
	'D', 'O', 'U', 'B', 'L', 'E', '_', 'B', 'U', 'F', 'F', 'E', 'R', '\0', /* DOUBLE_BUFFER (60192) */
	'R', 'E', 'G', '_', 'S', 'T', 'A', 'L', 'L', '_', 'E', 'N', '\0', /* REG_STALL_EN (60206) */
	'S', 'P', 'I', '_', 'S', 'T', 'A', 'L', 'L', '_', 'E', 'N', '\0', /* SPI_STALL_EN (60219) */
	'S', 'Q', '_', 'S', 'T', 'A', 'L', 'L', '_', 'E', 'N', '\0', /* SQ_STALL_EN (60232) */
	'R', 'E', 'G', '_', 'D', 'R', 'O', 'P', '_', 'O', 'N', '_', 'S', 'T', 'A', 'L', 'L', '\0', /* REG_DROP_ON_STALL (60244) */
	'U', 'T', 'I', 'L', '_', 'T', 'I', 'M', 'E', 'R', '\0', /* UTIL_TIMER (60262) */
	'W', 'A', 'V', 'E', 'S', 'T', 'A', 'R', 'T', '_', 'M', 'O', 'D', 'E', '\0', /* WAVESTART_MODE (60273) */
	'R', 'T', '_', 'F', 'R', 'E', 'Q', '\0', /* RT_FREQ (60288) */
	'S', 'Y', 'N', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'M', 'A', 'R', 'K', 'E', 'R', 'S', '\0', /* SYNC_COUNT_MARKERS (60296) */
	'S', 'Y', 'N', 'C', '_', 'C', 'O', 'U', 'N', 'T', '_', 'D', 'R', 'A', 'W', 'S', '\0', /* SYNC_COUNT_DRAWS (60315) */
	'C', 'A', 'P', 'T', 'U', 'R', 'E', '_', 'A', 'L', 'L', '\0', /* CAPTURE_ALL (60332) */
	'D', 'R', 'A', 'W', '_', 'E', 'V', 'E', 'N', 'T', '_', 'E', 'N', '\0', /* DRAW_EVENT_EN (60344) */
	'F', 'I', 'N', 'I', 'S', 'H', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* FINISH_PENDING (60358) */
	'F', 'I', 'N', 'I', 'S', 'H', '_', 'D', 'O', 'N', 'E', '\0', /* FINISH_DONE (60373, 60380) */
	'U', 'T', 'C', '_', 'E', 'R', 'R', '\0', /* UTC_ERR (60385) */
	'E', 'V', 'E', 'N', 'T', '_', 'C', 'N', 'T', 'R', '_', 'O', 'V', 'E', 'R', 'F', 'L', 'O', 'W', '\0', /* EVENT_CNTR_OVERFLOW (60393) */
	'E', 'V', 'E', 'N', 'T', '_', 'C', 'N', 'T', 'R', '_', 'S', 'T', 'A', 'L', 'L', '\0', /* EVENT_CNTR_STALL (60413) */
	'S', 'Q', '_', 'E', 'X', 'P', '_', 'M', 'R', 'T', '\0', /* SQ_EXP_MRT (60430) */
	'S', 'Q', '_', 'E', 'X', 'P', '_', 'M', 'R', 'T', 'Z', '\0', /* SQ_EXP_MRTZ (60441) */
	'S', 'Q', '_', 'E', 'X', 'P', '_', 'N', 'U', 'L', 'L', '\0', /* SQ_EXP_NULL (60453) */
	'S', 'Q', '_', 'E', 'X', 'P', '_', 'P', 'O', 'S', '\0', /* SQ_EXP_POS (60465) */
	'S', 'Q', '_', 'E', 'X', 'P', '_', 'P', 'R', 'I', 'M', '\0', /* SQ_EXP_PRIM (60476) */
	'S', 'Q', '_', 'E', 'X', 'P', '_', 'P', 'A', 'R', 'A', 'M', '\0', /* SQ_EXP_PARAM (60488) */
	'T', 'G', 'T', '\0', /* TGT (60501) */
	'C', 'O', 'M', 'P', 'R', '\0', /* COMPR (60505) */
	'V', 'M', '\0', /* VM (60511) */
	'B', 'A', 'S', 'E', '_', 'A', 'D', 'D', 'R', 'E', 'S', 'S', '_', 'H', 'I', '\0', /* BASE_ADDRESS_HI (60514, 60519) */
	'C', 'A', 'C', 'H', 'E', '_', 'S', 'W', 'I', 'Z', 'Z', 'L', 'E', '\0', /* CACHE_SWIZZLE (60530) */
	'S', 'W', 'I', 'Z', 'Z', 'L', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* SWIZZLE_ENABLE (60544) */
	'D', 'S', 'T', '_', 'S', 'E', 'L', '_', 'X', '\0', /* DST_SEL_X (60559) */
	'D', 'S', 'T', '_', 'S', 'E', 'L', '_', 'Y', '\0', /* DST_SEL_Y (60569) */
	'D', 'S', 'T', '_', 'S', 'E', 'L', '_', 'Z', '\0', /* DST_SEL_Z (60579) */
	'D', 'S', 'T', '_', 'S', 'E', 'L', '_', 'W', '\0', /* DST_SEL_W (60589) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', '\0', /* GFX10_FORMAT_INVALID (60599) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_8_UNORM (60620) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_8_SNORM (60641) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_8_USCALED (60662) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_8_SSCALED (60685) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_8_UINT (60708) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_8_SINT (60728) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_16_UNORM (60748) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_16_SNORM (60770) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_16_USCALED (60792) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_16_SSCALED (60816) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_16_UINT (60840) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_16_SINT (60861) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_16_FLOAT (60882) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_8_8_UNORM (60904) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_8_8_SNORM (60927) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_8_8_USCALED (60950) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_8_8_SSCALED (60975) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_8_8_UINT (61000) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_8_8_SINT (61022) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_32_UINT (61044) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_32_SINT (61065) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_32_FLOAT (61086) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_16_16_UNORM (61108) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_16_16_SNORM (61133) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_16_16_USCALED (61158) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_16_16_SSCALED (61185) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_16_16_UINT (61212) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_16_16_SINT (61236) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_16_16_FLOAT (61260) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '1', '_', '1', '1', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_10_11_11_UNORM (61285) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '1', '_', '1', '1', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_10_11_11_SNORM (61313) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '1', '_', '1', '1', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_10_11_11_USCALED (61341) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '1', '_', '1', '1', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_10_11_11_SSCALED (61371) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '1', '_', '1', '1', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_10_11_11_UINT (61401) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '1', '_', '1', '1', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_10_11_11_SINT (61428) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '1', '_', '1', '1', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_10_11_11_FLOAT (61455) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '1', '_', '1', '1', '_', '1', '0', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_11_11_10_UNORM (61483) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '1', '_', '1', '1', '_', '1', '0', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_11_11_10_SNORM (61511) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '1', '_', '1', '1', '_', '1', '0', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_11_11_10_USCALED (61539) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '1', '_', '1', '1', '_', '1', '0', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_11_11_10_SSCALED (61569) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '1', '_', '1', '1', '_', '1', '0', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_11_11_10_UINT (61599) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '1', '_', '1', '1', '_', '1', '0', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_11_11_10_SINT (61626) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '1', '_', '1', '1', '_', '1', '0', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_11_11_10_FLOAT (61653) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', '2', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_10_10_10_2_UNORM (61681) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', '2', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_10_10_10_2_SNORM (61711) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', '2', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_10_10_10_2_USCALED (61741) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', '2', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_10_10_10_2_SSCALED (61773) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', '2', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_10_10_10_2_UINT (61805) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', '2', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_10_10_10_2_SINT (61834) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_2_10_10_10_UNORM (61863) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_2_10_10_10_SNORM (61893) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_2_10_10_10_USCALED (61923) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_2_10_10_10_SSCALED (61955) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_2_10_10_10_UINT (61987) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_2_10_10_10_SINT (62016) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', '8', '_', '8', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_8_8_8_8_UNORM (62045) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', '8', '_', '8', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_8_8_8_8_SNORM (62072) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', '8', '_', '8', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_8_8_8_8_USCALED (62099) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', '8', '_', '8', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_8_8_8_8_SSCALED (62128) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', '8', '_', '8', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_8_8_8_8_UINT (62157) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', '8', '_', '8', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_8_8_8_8_SINT (62183) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_32_32_UINT (62209) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_32_32_SINT (62233) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_32_32_FLOAT (62257) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_16_16_16_16_UNORM (62282) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_16_16_16_16_SNORM (62313) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_16_16_16_16_USCALED (62344) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_16_16_16_16_SSCALED (62377) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_16_16_16_16_UINT (62410) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_16_16_16_16_SINT (62440) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_16_16_16_16_FLOAT (62470) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_32_32_32_UINT (62501) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_32_32_32_SINT (62528) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_32_32_32_FLOAT (62555) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_32_32_32_32_UINT (62583) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_32_32_32_32_SINT (62613) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_32_32_32_32_FLOAT (62643) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', 'S', 'R', 'G', 'B', '\0', /* GFX10_FORMAT_8_SRGB (62674) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', 'S', 'R', 'G', 'B', '\0', /* GFX10_FORMAT_8_8_SRGB (62694) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', '8', '_', '8', '_', 'S', 'R', 'G', 'B', '\0', /* GFX10_FORMAT_8_8_8_8_SRGB (62716) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '6', 'E', '4', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_6E4_FLOAT (62742) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '5', '_', '9', '_', '9', '_', '9', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_5_9_9_9_FLOAT (62765) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '5', '_', '6', '_', '5', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_5_6_5_UNORM (62792) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '_', '5', '_', '5', '_', '5', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_1_5_5_5_UNORM (62817) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '5', '_', '5', '_', '5', '_', '1', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_5_5_5_1_UNORM (62844) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '4', '_', '4', '_', '4', '_', '4', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_4_4_4_4_UNORM (62871) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '4', '_', '4', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_4_4_UNORM (62898) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_1_UNORM (62921) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '_', 'R', 'E', 'V', 'E', 'R', 'S', 'E', 'D', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_1_REVERSED_UNORM (62942) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', 'F', 'L', 'O', 'A', 'T', '_', 'C', 'L', 'A', 'M', 'P', '\0', /* GFX10_FORMAT_32_FLOAT_CLAMP (62972) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '2', '4', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_8_24_UNORM (63000) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '2', '4', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_8_24_UINT (63024) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '4', '_', '8', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_24_8_UNORM (63047) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '4', '_', '8', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_24_8_UINT (63071) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'X', '2', '4', '_', '8', '_', '3', '2', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_X24_8_32_UINT (63094) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'X', '2', '4', '_', '8', '_', '3', '2', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_X24_8_32_FLOAT (63121) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'G', 'B', '_', 'G', 'R', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_GB_GR_UNORM (63149) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'G', 'B', '_', 'G', 'R', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_GB_GR_SNORM (63174) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'G', 'B', '_', 'G', 'R', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_GB_GR_UINT (63199) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'G', 'B', '_', 'G', 'R', '_', 'S', 'R', 'G', 'B', '\0', /* GFX10_FORMAT_GB_GR_SRGB (63223) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'G', '_', 'R', 'G', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_BG_RG_UNORM (63247) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'G', '_', 'R', 'G', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_BG_RG_SNORM (63272) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'G', '_', 'R', 'G', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_BG_RG_UINT (63297) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'G', '_', 'R', 'G', '_', 'S', 'R', 'G', 'B', '\0', /* GFX10_FORMAT_BG_RG_SRGB (63321) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '2', '_', 'F', '1', '\0', /* GFX10_FORMAT_FMASK8_S2_F1 (63345) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '4', '_', 'F', '1', '\0', /* GFX10_FORMAT_FMASK8_S4_F1 (63371) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '8', '_', 'F', '1', '\0', /* GFX10_FORMAT_FMASK8_S8_F1 (63397) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '2', '_', 'F', '2', '\0', /* GFX10_FORMAT_FMASK8_S2_F2 (63423) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '4', '_', 'F', '2', '\0', /* GFX10_FORMAT_FMASK8_S4_F2 (63449) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '4', '_', 'F', '4', '\0', /* GFX10_FORMAT_FMASK8_S4_F4 (63475) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '1', '6', '_', 'S', '1', '6', '_', 'F', '1', '\0', /* GFX10_FORMAT_FMASK16_S16_F1 (63501) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '1', '6', '_', 'S', '8', '_', 'F', '2', '\0', /* GFX10_FORMAT_FMASK16_S8_F2 (63529) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '3', '2', '_', 'S', '1', '6', '_', 'F', '2', '\0', /* GFX10_FORMAT_FMASK32_S16_F2 (63556) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '3', '2', '_', 'S', '8', '_', 'F', '4', '\0', /* GFX10_FORMAT_FMASK32_S8_F4 (63584) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '3', '2', '_', 'S', '8', '_', 'F', '8', '\0', /* GFX10_FORMAT_FMASK32_S8_F8 (63611) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '6', '4', '_', 'S', '1', '6', '_', 'F', '4', '\0', /* GFX10_FORMAT_FMASK64_S16_F4 (63638) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '6', '4', '_', 'S', '1', '6', '_', 'F', '8', '\0', /* GFX10_FORMAT_FMASK64_S16_F8 (63666) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '1', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_BC1_UNORM (63694) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '1', '_', 'S', 'R', 'G', 'B', '\0', /* GFX10_FORMAT_BC1_SRGB (63717) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '2', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_BC2_UNORM (63739) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '2', '_', 'S', 'R', 'G', 'B', '\0', /* GFX10_FORMAT_BC2_SRGB (63762) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '3', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_BC3_UNORM (63784) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '3', '_', 'S', 'R', 'G', 'B', '\0', /* GFX10_FORMAT_BC3_SRGB (63807) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '4', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_BC4_UNORM (63829) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '4', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_BC4_SNORM (63852) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '5', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_BC5_UNORM (63875) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '5', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_BC5_SNORM (63898) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '6', '_', 'U', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_BC6_UFLOAT (63921) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '6', '_', 'S', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_BC6_SFLOAT (63945) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '7', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_BC7_UNORM (63969) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '7', '_', 'S', 'R', 'G', 'B', '\0', /* GFX10_FORMAT_BC7_SRGB (63992) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '8', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_MM_8_UNORM (64014) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '8', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_MM_8_UINT (64038) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '8', '_', '8', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_MM_8_8_UNORM (64061) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '8', '_', '8', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_MM_8_8_UINT (64087) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '8', '_', '8', '_', '8', '_', '8', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_MM_8_8_8_8_UNORM (64112) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '8', '_', '8', '_', '8', '_', '8', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_MM_8_8_8_8_UINT (64142) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', 'V', 'Y', 'U', 'Y', '8', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_MM_VYUY8_UNORM (64171) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', 'V', 'Y', 'U', 'Y', '8', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_MM_VYUY8_UINT (64199) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '1', '0', '_', '1', '1', '_', '1', '1', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_MM_10_11_11_UNORM (64226) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '1', '0', '_', '1', '1', '_', '1', '1', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_MM_10_11_11_UINT (64257) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_MM_2_10_10_10_UNORM (64287) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_MM_2_10_10_10_UINT (64320) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_MM_16_16_16_16_UNORM (64352) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_MM_16_16_16_16_UINT (64386) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '1', '0', '_', 'I', 'N', '_', '1', '6', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_MM_10_IN_16_UNORM (64419) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '1', '0', '_', 'I', 'N', '_', '1', '6', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_MM_10_IN_16_UINT (64450) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '1', '0', '_', 'I', 'N', '_', '1', '6', '_', '1', '6', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_MM_10_IN_16_16_UNORM (64480) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '1', '0', '_', 'I', 'N', '_', '1', '6', '_', '1', '6', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_MM_10_IN_16_16_UINT (64514) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '1', '0', '_', 'I', 'N', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'U', 'N', 'O', 'R', 'M', ' ', '\0', /* GFX10_FORMAT_MM_10_IN_16_16_16_16_UNORM  (64547) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'M', 'M', '_', '1', '0', '_', 'I', 'N', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_MM_10_IN_16_16_16_16_UINT (64588) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '7', 'E', '3', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* GFX10_FORMAT_7E3_FLOAT (64627) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'Y', 'C', 'B', 'C', 'R', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_YCBCR_UNORM (64650) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'Y', 'C', 'B', 'C', 'R', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* GFX10_FORMAT_YCBCR_SNORM (64675) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'Y', 'C', 'B', 'C', 'R', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_YCBCR_USCALED (64700) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'Y', 'C', 'B', 'C', 'R', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* GFX10_FORMAT_YCBCR_SSCALED (64727) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'Y', 'C', 'B', 'C', 'R', '_', 'U', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_YCBCR_UINT (64754) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'Y', 'C', 'B', 'C', 'R', '_', 'S', 'I', 'N', 'T', '\0', /* GFX10_FORMAT_YCBCR_SINT (64778) */
	'G', 'F', 'X', '1', '0', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'Y', 'C', 'B', 'C', 'R', '_', 'S', 'R', 'G', 'B', '\0', /* GFX10_FORMAT_YCBCR_SRGB (64802) */
	'I', 'N', 'D', 'E', 'X', '_', 'S', 'T', 'R', 'I', 'D', 'E', '\0', /* INDEX_STRIDE (64826) */
	'A', 'D', 'D', '_', 'T', 'I', 'D', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* ADD_TID_ENABLE (64839) */
	'R', 'E', 'S', 'O', 'U', 'R', 'C', 'E', '_', 'L', 'E', 'V', 'E', 'L', '\0', /* RESOURCE_LEVEL (64854) */
	'O', 'O', 'B', '_', 'S', 'E', 'L', 'E', 'C', 'T', '_', 'S', 'T', 'R', 'U', 'C', 'T', 'U', 'R', 'E', 'D', '_', 'W', 'I', 'T', 'H', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* OOB_SELECT_STRUCTURED_WITH_OFFSET (64869) */
	'O', 'O', 'B', '_', 'S', 'E', 'L', 'E', 'C', 'T', '_', 'S', 'T', 'R', 'U', 'C', 'T', 'U', 'R', 'E', 'D', '\0', /* OOB_SELECT_STRUCTURED (64903) */
	'O', 'O', 'B', '_', 'S', 'E', 'L', 'E', 'C', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', 'D', '\0', /* OOB_SELECT_DISABLED (64925) */
	'O', 'O', 'B', '_', 'S', 'E', 'L', 'E', 'C', 'T', '_', 'R', 'A', 'W', '\0', /* OOB_SELECT_RAW (64945, 64956) */
	'O', 'O', 'B', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* OOB_SELECT (64960) */
	'C', 'L', 'A', 'M', 'P', '_', 'X', '\0', /* CLAMP_X (64971) */
	'C', 'L', 'A', 'M', 'P', '_', 'Y', '\0', /* CLAMP_Y (64979) */
	'C', 'L', 'A', 'M', 'P', '_', 'Z', '\0', /* CLAMP_Z (64987) */
	'M', 'A', 'X', '_', 'A', 'N', 'I', 'S', 'O', '_', 'R', 'A', 'T', 'I', 'O', '\0', /* MAX_ANISO_RATIO (64995) */
	'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'F', 'U', 'N', 'C', '\0', /* DEPTH_COMPARE_FUNC (65011) */
	'F', 'O', 'R', 'C', 'E', '_', 'U', 'N', 'N', 'O', 'R', 'M', 'A', 'L', 'I', 'Z', 'E', 'D', '\0', /* FORCE_UNNORMALIZED (65030) */
	'A', 'N', 'I', 'S', 'O', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '\0', /* ANISO_THRESHOLD (65049) */
	'M', 'C', '_', 'C', 'O', 'O', 'R', 'D', '_', 'T', 'R', 'U', 'N', 'C', '\0', /* MC_COORD_TRUNC (65065) */
	'F', 'O', 'R', 'C', 'E', '_', 'D', 'E', 'G', 'A', 'M', 'M', 'A', '\0', /* FORCE_DEGAMMA (65080) */
	'A', 'N', 'I', 'S', 'O', '_', 'B', 'I', 'A', 'S', '\0', /* ANISO_BIAS (65094) */
	'T', 'R', 'U', 'N', 'C', '_', 'C', 'O', 'O', 'R', 'D', '\0', /* TRUNC_COORD (65105) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'C', 'U', 'B', 'E', '_', 'W', 'R', 'A', 'P', '\0', /* DISABLE_CUBE_WRAP (65117, 65130) */
	'F', 'I', 'L', 'T', 'E', 'R', '_', 'M', 'O', 'D', 'E', '\0', /* FILTER_MODE (65135) */
	'S', 'K', 'I', 'P', '_', 'D', 'E', 'G', 'A', 'M', 'M', 'A', '\0', /* SKIP_DEGAMMA (65147) */
	'M', 'I', 'N', '_', 'L', 'O', 'D', '\0', /* MIN_LOD (65160) */
	'M', 'A', 'X', '_', 'L', 'O', 'D', '\0', /* MAX_LOD (65168) */
	'P', 'E', 'R', 'F', '_', 'M', 'I', 'P', '\0', /* PERF_MIP (65176) */
	'P', 'E', 'R', 'F', '_', 'Z', '\0', /* PERF_Z (65185) */
	'L', 'O', 'D', '_', 'B', 'I', 'A', 'S', '\0', /* LOD_BIAS (65192) */
	'B', 'O', 'R', 'D', 'E', 'R', '_', 'C', 'O', 'L', 'O', 'R', '_', 'P', 'T', 'R', '\0', /* BORDER_COLOR_PTR (65201) */
	'B', 'O', 'R', 'D', 'E', 'R', '_', 'C', 'O', 'L', 'O', 'R', '_', 'T', 'Y', 'P', 'E', '\0', /* BORDER_COLOR_TYPE (65218) */
	'L', 'O', 'D', '_', 'B', 'I', 'A', 'S', '_', 'S', 'E', 'C', '\0', /* LOD_BIAS_SEC (65236) */
	'X', 'Y', '_', 'M', 'A', 'G', '_', 'F', 'I', 'L', 'T', 'E', 'R', '\0', /* XY_MAG_FILTER (65249) */
	'X', 'Y', '_', 'M', 'I', 'N', '_', 'F', 'I', 'L', 'T', 'E', 'R', '\0', /* XY_MIN_FILTER (65263) */
	'Z', '_', 'F', 'I', 'L', 'T', 'E', 'R', '\0', /* Z_FILTER (65277) */
	'M', 'I', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '\0', /* MIP_FILTER (65286) */
	'M', 'I', 'P', '_', 'P', 'O', 'I', 'N', 'T', '_', 'P', 'R', 'E', 'C', 'L', 'A', 'M', 'P', '\0', /* MIP_POINT_PRECLAMP (65297) */
	'A', 'N', 'I', 'S', 'O', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* ANISO_OVERRIDE (65316) */
	'B', 'L', 'E', 'N', 'D', '_', 'Z', 'E', 'R', 'O', '_', 'P', 'R', 'T', '\0', /* BLEND_ZERO_PRT (65331) */
	'D', 'E', 'R', 'I', 'V', '_', 'A', 'D', 'J', 'U', 'S', 'T', '_', 'E', 'N', '\0', /* DERIV_ADJUST_EN (65346) */
	'G', 'P', 'R', '_', 'W', 'R', 'I', 'T', 'E', '_', 'P', 'R', 'I', 'O', 'R', 'I', 'T', 'Y', '\0', /* GPR_WRITE_PRIORITY (65362, 65372) */
	'E', 'X', 'P', '_', 'P', 'R', 'I', 'O', 'R', 'I', 'T', 'Y', '_', 'O', 'R', 'D', 'E', 'R', '\0', /* EXP_PRIORITY_ORDER (65381) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'S', 'Q', 'G', '_', 'T', 'O', 'P', '_', 'E', 'V', 'E', 'N', 'T', 'S', '\0', /* ENABLE_SQG_TOP_EVENTS (65400) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'S', 'Q', 'G', '_', 'B', 'O', 'P', '_', 'E', 'V', 'E', 'N', 'T', 'S', '\0', /* ENABLE_SQG_BOP_EVENTS (65422) */
	'R', 'S', 'R', 'C', '_', 'M', 'G', 'M', 'T', '_', 'R', 'E', 'S', 'E', 'T', '\0', /* RSRC_MGMT_RESET (65444) */
	'T', 'T', 'R', 'A', 'C', 'E', '_', 'S', 'T', 'A', 'L', 'L', '_', 'A', 'L', 'L', '\0', /* TTRACE_STALL_ALL (65460) */
	'A', 'L', 'L', 'O', 'C', '_', 'A', 'R', 'B', '_', 'L', 'R', 'U', '_', 'E', 'N', 'A', '\0', /* ALLOC_ARB_LRU_ENA (65477) */
	'E', 'X', 'P', '_', 'A', 'R', 'B', '_', 'L', 'R', 'U', '_', 'E', 'N', 'A', '\0', /* EXP_ARB_LRU_ENA (65495) */
	'P', 'S', '_', 'P', 'K', 'R', '_', 'P', 'R', 'I', 'O', 'R', 'I', 'T', 'Y', '_', 'C', 'N', 'T', 'L', '\0', /* PS_PKR_PRIORITY_CNTL (65511) */
	'N', 'U', 'M', '_', 'P', 'I', 'P', 'E', 'S', '\0', /* NUM_PIPES (65532) */
	'P', 'I', 'P', 'E', '_', 'I', 'N', 'T', 'E', 'R', 'L', 'E', 'A', 'V', 'E', '_', 'S', 'I', 'Z', 'E', '\0', /* PIPE_INTERLEAVE_SIZE (65542) */
	'M', 'A', 'X', '_', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', 'E', 'D', '_', 'F', 'R', 'A', 'G', 'S', '\0', /* MAX_COMPRESSED_FRAGS (65563) */
	'N', 'U', 'M', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'E', 'N', 'G', 'I', 'N', 'E', 'S', '\0', /* NUM_SHADER_ENGINES (65584) */
	'N', 'U', 'M', '_', 'R', 'B', '_', 'P', 'E', 'R', '_', 'S', 'E', '\0', /* NUM_RB_PER_SE (65603) */
	'A', 'R', 'R', 'A', 'Y', '_', 'L', 'I', 'N', 'E', 'A', 'R', '_', 'G', 'E', 'N', 'E', 'R', 'A', 'L', '\0', /* ARRAY_LINEAR_GENERAL (65617, 65623) */
	'A', 'R', 'R', 'A', 'Y', '_', 'L', 'I', 'N', 'E', 'A', 'R', '_', 'A', 'L', 'I', 'G', 'N', 'E', 'D', '\0', /* ARRAY_LINEAR_ALIGNED (65638) */
	'A', 'R', 'R', 'A', 'Y', '_', '1', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'N', '1', '\0', /* ARRAY_1D_TILED_THIN1 (65659) */
	'A', 'R', 'R', 'A', 'Y', '_', '1', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'C', 'K', '\0', /* ARRAY_1D_TILED_THICK (65680) */
	'A', 'R', 'R', 'A', 'Y', '_', '2', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'N', '1', '\0', /* ARRAY_2D_TILED_THIN1 (65701) */
	'A', 'R', 'R', 'A', 'Y', '_', 'P', 'R', 'T', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'N', '1', '\0', /* ARRAY_PRT_TILED_THIN1 (65722) */
	'A', 'R', 'R', 'A', 'Y', '_', 'P', 'R', 'T', '_', '2', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'N', '1', '\0', /* ARRAY_PRT_2D_TILED_THIN1 (65744) */
	'A', 'R', 'R', 'A', 'Y', '_', '2', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'C', 'K', '\0', /* ARRAY_2D_TILED_THICK (65769) */
	'A', 'R', 'R', 'A', 'Y', '_', '2', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'X', 'T', 'H', 'I', 'C', 'K', '\0', /* ARRAY_2D_TILED_XTHICK (65790) */
	'A', 'R', 'R', 'A', 'Y', '_', 'P', 'R', 'T', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'C', 'K', '\0', /* ARRAY_PRT_TILED_THICK (65812) */
	'A', 'R', 'R', 'A', 'Y', '_', 'P', 'R', 'T', '_', '2', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'C', 'K', '\0', /* ARRAY_PRT_2D_TILED_THICK (65834) */
	'A', 'R', 'R', 'A', 'Y', '_', 'P', 'R', 'T', '_', '3', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'N', '1', '\0', /* ARRAY_PRT_3D_TILED_THIN1 (65859) */
	'A', 'R', 'R', 'A', 'Y', '_', '3', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'N', '1', '\0', /* ARRAY_3D_TILED_THIN1 (65884) */
	'A', 'R', 'R', 'A', 'Y', '_', '3', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'C', 'K', '\0', /* ARRAY_3D_TILED_THICK (65905) */
	'A', 'R', 'R', 'A', 'Y', '_', '3', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'X', 'T', 'H', 'I', 'C', 'K', '\0', /* ARRAY_3D_TILED_XTHICK (65926) */
	'A', 'R', 'R', 'A', 'Y', '_', 'P', 'R', 'T', '_', '3', 'D', '_', 'T', 'I', 'L', 'E', 'D', '_', 'T', 'H', 'I', 'C', 'K', '\0', /* ARRAY_PRT_3D_TILED_THICK (65948) */
	'A', 'R', 'R', 'A', 'Y', '_', 'M', 'O', 'D', 'E', '\0', /* ARRAY_MODE (65973) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '2', '\0', /* ADDR_SURF_P2 (65984) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '2', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '0', '\0', /* ADDR_SURF_P2_RESERVED0 (65997) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '2', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '1', '\0', /* ADDR_SURF_P2_RESERVED1 (66020, 66033) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '2', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '2', '\0', /* ADDR_SURF_P2_RESERVED2 (66043, 66056) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '4', '_', '8', 'x', '1', '6', '\0', /* ADDR_SURF_P4_8x16 (66066) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '4', '_', '1', '6', 'x', '1', '6', '\0', /* ADDR_SURF_P4_16x16 (66084) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '4', '_', '1', '6', 'x', '3', '2', '\0', /* ADDR_SURF_P4_16x32 (66103) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '4', '_', '3', '2', 'x', '3', '2', '\0', /* ADDR_SURF_P4_32x32 (66122) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '8', '_', '1', '6', 'x', '1', '6', '_', '8', 'x', '1', '6', '\0', /* ADDR_SURF_P8_16x16_8x16 (66141) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '8', '_', '1', '6', 'x', '3', '2', '_', '8', 'x', '1', '6', '\0', /* ADDR_SURF_P8_16x32_8x16 (66165) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '8', '_', '3', '2', 'x', '3', '2', '_', '8', 'x', '1', '6', '\0', /* ADDR_SURF_P8_32x32_8x16 (66189) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '8', '_', '1', '6', 'x', '3', '2', '_', '1', '6', 'x', '1', '6', '\0', /* ADDR_SURF_P8_16x32_16x16 (66213) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '8', '_', '3', '2', 'x', '3', '2', '_', '1', '6', 'x', '1', '6', '\0', /* ADDR_SURF_P8_32x32_16x16 (66238) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '8', '_', '3', '2', 'x', '3', '2', '_', '1', '6', 'x', '3', '2', '\0', /* ADDR_SURF_P8_32x32_16x32 (66263) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '8', '_', '3', '2', 'x', '6', '4', '_', '3', '2', 'x', '3', '2', '\0', /* ADDR_SURF_P8_32x64_32x32 (66288) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '8', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '0', '\0', /* ADDR_SURF_P8_RESERVED0 (66313) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '1', '6', '_', '3', '2', 'x', '3', '2', '_', '8', 'x', '1', '6', '\0', /* ADDR_SURF_P16_32x32_8x16 (66336) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '1', '6', '_', '3', '2', 'x', '3', '2', '_', '1', '6', 'x', '1', '6', '\0', /* ADDR_SURF_P16_32x32_16x16 (66361) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'P', '1', '6', '\0', /* ADDR_SURF_P16 (66387) */
	'P', 'I', 'P', 'E', '_', 'C', 'O', 'N', 'F', 'I', 'G', '\0', /* PIPE_CONFIG (66401) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'T', 'I', 'L', 'E', '_', 'S', 'P', 'L', 'I', 'T', '_', '6', '4', 'B', '\0', /* ADDR_SURF_TILE_SPLIT_64B (66413) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'T', 'I', 'L', 'E', '_', 'S', 'P', 'L', 'I', 'T', '_', '1', '2', '8', 'B', '\0', /* ADDR_SURF_TILE_SPLIT_128B (66438) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'T', 'I', 'L', 'E', '_', 'S', 'P', 'L', 'I', 'T', '_', '2', '5', '6', 'B', '\0', /* ADDR_SURF_TILE_SPLIT_256B (66464) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'T', 'I', 'L', 'E', '_', 'S', 'P', 'L', 'I', 'T', '_', '5', '1', '2', 'B', '\0', /* ADDR_SURF_TILE_SPLIT_512B (66490) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'T', 'I', 'L', 'E', '_', 'S', 'P', 'L', 'I', 'T', '_', '1', 'K', 'B', '\0', /* ADDR_SURF_TILE_SPLIT_1KB (66516) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'T', 'I', 'L', 'E', '_', 'S', 'P', 'L', 'I', 'T', '_', '2', 'K', 'B', '\0', /* ADDR_SURF_TILE_SPLIT_2KB (66541) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'T', 'I', 'L', 'E', '_', 'S', 'P', 'L', 'I', 'T', '_', '4', 'K', 'B', '\0', /* ADDR_SURF_TILE_SPLIT_4KB (66566) */
	'T', 'I', 'L', 'E', '_', 'S', 'P', 'L', 'I', 'T', '\0', /* TILE_SPLIT (66591) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'D', 'I', 'S', 'P', 'L', 'A', 'Y', '_', 'M', 'I', 'C', 'R', 'O', '_', 'T', 'I', 'L', 'I', 'N', 'G', '\0', /* ADDR_SURF_DISPLAY_MICRO_TILING (66602) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'T', 'H', 'I', 'N', '_', 'M', 'I', 'C', 'R', 'O', '_', 'T', 'I', 'L', 'I', 'N', 'G', '\0', /* ADDR_SURF_THIN_MICRO_TILING (66633) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'D', 'E', 'P', 'T', 'H', '_', 'M', 'I', 'C', 'R', 'O', '_', 'T', 'I', 'L', 'I', 'N', 'G', '\0', /* ADDR_SURF_DEPTH_MICRO_TILING (66661) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'R', 'O', 'T', 'A', 'T', 'E', 'D', '_', 'M', 'I', 'C', 'R', 'O', '_', 'T', 'I', 'L', 'I', 'N', 'G', '\0', /* ADDR_SURF_ROTATED_MICRO_TILING (66690) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'T', 'H', 'I', 'C', 'K', '_', 'M', 'I', 'C', 'R', 'O', '_', 'T', 'I', 'L', 'I', 'N', 'G', '\0', /* ADDR_SURF_THICK_MICRO_TILING (66721) */
	'M', 'I', 'C', 'R', 'O', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '_', 'N', 'E', 'W', '\0', /* MICRO_TILE_MODE_NEW (66750) */
	'S', 'A', 'M', 'P', 'L', 'E', '_', 'S', 'P', 'L', 'I', 'T', '\0', /* SAMPLE_SPLIT (66770) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'B', 'A', 'N', 'K', '_', 'W', 'I', 'D', 'T', 'H', '_', '1', '\0', /* ADDR_SURF_BANK_WIDTH_1 (66783) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'B', 'A', 'N', 'K', '_', 'W', 'I', 'D', 'T', 'H', '_', '2', '\0', /* ADDR_SURF_BANK_WIDTH_2 (66806) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'B', 'A', 'N', 'K', '_', 'W', 'I', 'D', 'T', 'H', '_', '4', '\0', /* ADDR_SURF_BANK_WIDTH_4 (66829) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'B', 'A', 'N', 'K', '_', 'W', 'I', 'D', 'T', 'H', '_', '8', '\0', /* ADDR_SURF_BANK_WIDTH_8 (66852) */
	'B', 'A', 'N', 'K', '_', 'W', 'I', 'D', 'T', 'H', '\0', /* BANK_WIDTH (66875, 66880) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'B', 'A', 'N', 'K', '_', 'H', 'E', 'I', 'G', 'H', 'T', '_', '1', '\0', /* ADDR_SURF_BANK_HEIGHT_1 (66886) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'B', 'A', 'N', 'K', '_', 'H', 'E', 'I', 'G', 'H', 'T', '_', '2', '\0', /* ADDR_SURF_BANK_HEIGHT_2 (66910) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'B', 'A', 'N', 'K', '_', 'H', 'E', 'I', 'G', 'H', 'T', '_', '4', '\0', /* ADDR_SURF_BANK_HEIGHT_4 (66934) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'B', 'A', 'N', 'K', '_', 'H', 'E', 'I', 'G', 'H', 'T', '_', '8', '\0', /* ADDR_SURF_BANK_HEIGHT_8 (66958) */
	'B', 'A', 'N', 'K', '_', 'H', 'E', 'I', 'G', 'H', 'T', '\0', /* BANK_HEIGHT (66982, 66987) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'M', 'A', 'C', 'R', 'O', '_', 'A', 'S', 'P', 'E', 'C', 'T', '_', '1', '\0', /* ADDR_SURF_MACRO_ASPECT_1 (66994) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'M', 'A', 'C', 'R', 'O', '_', 'A', 'S', 'P', 'E', 'C', 'T', '_', '2', '\0', /* ADDR_SURF_MACRO_ASPECT_2 (67019) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'M', 'A', 'C', 'R', 'O', '_', 'A', 'S', 'P', 'E', 'C', 'T', '_', '4', '\0', /* ADDR_SURF_MACRO_ASPECT_4 (67044) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'M', 'A', 'C', 'R', 'O', '_', 'A', 'S', 'P', 'E', 'C', 'T', '_', '8', '\0', /* ADDR_SURF_MACRO_ASPECT_8 (67069) */
	'M', 'A', 'C', 'R', 'O', '_', 'T', 'I', 'L', 'E', '_', 'A', 'S', 'P', 'E', 'C', 'T', '\0', /* MACRO_TILE_ASPECT (67094) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', '2', '_', 'B', 'A', 'N', 'K', '\0', /* ADDR_SURF_2_BANK (67112) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', '4', '_', 'B', 'A', 'N', 'K', '\0', /* ADDR_SURF_4_BANK (67129) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', '8', '_', 'B', 'A', 'N', 'K', '\0', /* ADDR_SURF_8_BANK (67146) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', '1', '6', '_', 'B', 'A', 'N', 'K', '\0', /* ADDR_SURF_16_BANK (67163) */
	'N', 'U', 'M', '_', 'B', 'A', 'N', 'K', 'S', '\0', /* NUM_BANKS (67181) */
	'W', 'I', 'D', 'T', 'H', '_', 'L', 'O', '\0', /* WIDTH_LO (67191) */
	'W', 'I', 'D', 'T', 'H', '_', 'H', 'I', '\0', /* WIDTH_HI (67200) */
	'B', 'A', 'S', 'E', '_', 'L', 'E', 'V', 'E', 'L', '\0', /* BASE_LEVEL (67209) */
	'L', 'A', 'S', 'T', '_', 'L', 'E', 'V', 'E', 'L', '\0', /* LAST_LEVEL (67220) */
	'S', 'W', '_', 'M', 'O', 'D', 'E', '\0', /* SW_MODE (67231) */
	'B', 'C', '_', 'S', 'W', 'I', 'Z', 'Z', 'L', 'E', '_', 'X', 'Y', 'Z', 'W', '\0', /* BC_SWIZZLE_XYZW (67239) */
	'B', 'C', '_', 'S', 'W', 'I', 'Z', 'Z', 'L', 'E', '_', 'X', 'W', 'Y', 'Z', '\0', /* BC_SWIZZLE_XWYZ (67255) */
	'B', 'C', '_', 'S', 'W', 'I', 'Z', 'Z', 'L', 'E', '_', 'W', 'Z', 'Y', 'X', '\0', /* BC_SWIZZLE_WZYX (67271) */
	'B', 'C', '_', 'S', 'W', 'I', 'Z', 'Z', 'L', 'E', '_', 'W', 'X', 'Y', 'Z', '\0', /* BC_SWIZZLE_WXYZ (67287) */
	'B', 'C', '_', 'S', 'W', 'I', 'Z', 'Z', 'L', 'E', '_', 'Z', 'Y', 'X', 'W', '\0', /* BC_SWIZZLE_ZYXW (67303) */
	'B', 'C', '_', 'S', 'W', 'I', 'Z', 'Z', 'L', 'E', '_', 'Y', 'X', 'W', 'Z', '\0', /* BC_SWIZZLE_YXWZ (67319) */
	'B', 'C', '_', 'S', 'W', 'I', 'Z', 'Z', 'L', 'E', '\0', /* BC_SWIZZLE (67335) */
	'B', 'A', 'S', 'E', '_', 'A', 'R', 'R', 'A', 'Y', '\0', /* BASE_ARRAY (67346) */
	'A', 'R', 'R', 'A', 'Y', '_', 'P', 'I', 'T', 'C', 'H', '\0', /* ARRAY_PITCH (67357) */
	'M', 'A', 'X', '_', 'M', 'I', 'P', '\0', /* MAX_MIP (67369) */
	'M', 'I', 'N', '_', 'L', 'O', 'D', '_', 'W', 'A', 'R', 'N', '\0', /* MIN_LOD_WARN (67377) */
	'P', 'E', 'R', 'F', '_', 'M', 'O', 'D', '\0', /* PERF_MOD (67390) */
	'C', 'O', 'R', 'N', 'E', 'R', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '\0', /* CORNER_SAMPLES (67399) */
	'L', 'O', 'D', '_', 'H', 'D', 'W', '_', 'C', 'N', 'T', '_', 'E', 'N', '\0', /* LOD_HDW_CNT_EN (67414) */
	'P', 'R', 'T', '_', 'D', 'E', 'F', 'A', 'U', 'L', 'T', '\0', /* PRT_DEFAULT (67429) */
	'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'B', 'A', 'N', 'K', '_', 'I', 'D', '\0', /* COUNTER_BANK_ID (67441) */
	'I', 'T', 'E', 'R', 'A', 'T', 'E', '_', '2', '5', '6', '\0', /* ITERATE_256 (67457) */
	'M', 'A', 'X', '_', 'U', 'N', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', 'E', 'D', '_', 'B', 'L', 'O', 'C', 'K', '_', 'S', 'I', 'Z', 'E', '\0', /* MAX_UNCOMPRESSED_BLOCK_SIZE (67469) */
	'M', 'A', 'X', '_', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', 'E', 'D', '_', 'B', 'L', 'O', 'C', 'K', '_', 'S', 'I', 'Z', 'E', '\0', /* MAX_COMPRESSED_BLOCK_SIZE (67497) */
	'M', 'E', 'T', 'A', '_', 'P', 'I', 'P', 'E', '_', 'A', 'L', 'I', 'G', 'N', 'E', 'D', '\0', /* META_PIPE_ALIGNED (67523, 67528) */
	'W', 'R', 'I', 'T', 'E', '_', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* WRITE_COMPRESS_ENABLE (67541) */
	'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', 'I', 'O', 'N', '_', 'E', 'N', '\0', /* COMPRESSION_EN (67563) */
	'A', 'L', 'P', 'H', 'A', '_', 'I', 'S', '_', 'O', 'N', '_', 'M', 'S', 'B', '\0', /* ALPHA_IS_ON_MSB (67578) */
	'C', 'O', 'L', 'O', 'R', '_', 'T', 'R', 'A', 'N', 'S', 'F', 'O', 'R', 'M', '\0', /* COLOR_TRANSFORM (67594) */
	'M', 'E', 'T', 'A', '_', 'D', 'A', 'T', 'A', '_', 'A', 'D', 'D', 'R', 'E', 'S', 'S', '_', 'L', 'O', '\0', /* META_DATA_ADDRESS_LO (67610) */
	'C', 'U', '_', 'E', 'N', '\0', /* CU_EN (67631) */
	'W', 'A', 'V', 'E', '_', 'L', 'I', 'M', 'I', 'T', '\0', /* WAVE_LIMIT (67637, 67642) */
	'L', 'O', 'C', 'K', '_', 'L', 'O', 'W', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '\0', /* LOCK_LOW_THRESHOLD (67648) */
	'M', 'E', 'M', '_', 'B', 'A', 'S', 'E', '\0', /* MEM_BASE (67667) */
	'V', 'G', 'P', 'R', 'S', '\0', /* VGPRS (67676) */
	'S', 'G', 'P', 'R', 'S', '\0', /* SGPRS (67682) */
	'F', 'P', '_', '3', '2', '_', 'D', 'E', 'N', 'O', 'R', 'M', 'S', '\0', /* FP_32_DENORMS (67688) */
	'F', 'P', '_', '6', '4', '_', 'D', 'E', 'N', 'O', 'R', 'M', 'S', '\0', /* FP_64_DENORMS (67702) */
	'F', 'P', '_', 'A', 'L', 'L', '_', 'D', 'E', 'N', 'O', 'R', 'M', 'S', '\0', /* FP_ALL_DENORMS (67716) */
	'F', 'L', 'O', 'A', 'T', '_', 'M', 'O', 'D', 'E', '\0', /* FLOAT_MODE (67731) */
	'I', 'E', 'E', 'E', '_', 'M', 'O', 'D', 'E', '\0', /* IEEE_MODE (67742) */
	'C', 'U', '_', 'G', 'R', 'O', 'U', 'P', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* CU_GROUP_DISABLE (67752) */
	'M', 'E', 'M', '_', 'O', 'R', 'D', 'E', 'R', 'E', 'D', '\0', /* MEM_ORDERED (67769) */
	'S', 'C', 'R', 'A', 'T', 'C', 'H', '_', 'E', 'N', '\0', /* SCRATCH_EN (67781) */
	'U', 'S', 'E', 'R', '_', 'S', 'G', 'P', 'R', '\0', /* USER_SGPR (67792) */
	'T', 'R', 'A', 'P', '_', 'P', 'R', 'E', 'S', 'E', 'N', 'T', '\0', /* TRAP_PRESENT (67802) */
	'W', 'A', 'V', 'E', '_', 'C', 'N', 'T', '_', 'E', 'N', '\0', /* WAVE_CNT_EN (67815) */
	'E', 'X', 'T', 'R', 'A', '_', 'L', 'D', 'S', '_', 'S', 'I', 'Z', 'E', '\0', /* EXTRA_LDS_SIZE (67827) */
	'L', 'O', 'A', 'D', '_', 'C', 'O', 'L', 'L', 'I', 'S', 'I', 'O', 'N', '_', 'W', 'A', 'V', 'E', 'I', 'D', '\0', /* LOAD_COLLISION_WAVEID (67842) */
	'L', 'O', 'A', 'D', '_', 'I', 'N', 'T', 'R', 'A', 'W', 'A', 'V', 'E', '_', 'C', 'O', 'L', 'L', 'I', 'S', 'I', 'O', 'N', '\0', /* LOAD_INTRAWAVE_COLLISION (67864) */
	'U', 'S', 'E', 'R', '_', 'S', 'G', 'P', 'R', '_', 'M', 'S', 'B', '\0', /* USER_SGPR_MSB (67889) */
	'S', 'H', 'A', 'R', 'E', 'D', '_', 'V', 'G', 'P', 'R', '_', 'C', 'N', 'T', '\0', /* SHARED_VGPR_CNT (67903) */
	'S', 'O', 'F', 'T', '_', 'G', 'R', 'O', 'U', 'P', 'I', 'N', 'G', '_', 'E', 'N', '\0', /* SOFT_GROUPING_EN (67919) */
	'N', 'U', 'M', 'B', 'E', 'R', '_', 'O', 'F', '_', 'R', 'E', 'Q', 'U', 'E', 'S', 'T', 'S', '_', 'P', 'E', 'R', '_', 'C', 'U', '\0', /* NUMBER_OF_REQUESTS_PER_CU (67936) */
	'S', 'O', 'F', 'T', '_', 'G', 'R', 'O', 'U', 'P', 'I', 'N', 'G', '_', 'A', 'L', 'L', 'O', 'C', 'A', 'T', 'I', 'O', 'N', '_', 'T', 'I', 'M', 'E', 'O', 'U', 'T', '\0', /* SOFT_GROUPING_ALLOCATION_TIMEOUT (67962) */
	'H', 'A', 'R', 'D', '_', 'L', 'O', 'C', 'K', '_', 'H', 'Y', 'S', 'T', 'E', 'R', 'E', 'S', 'I', 'S', '\0', /* HARD_LOCK_HYSTERESIS (67995) */
	'H', 'A', 'R', 'D', '_', 'L', 'O', 'C', 'K', '_', 'L', 'O', 'W', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '\0', /* HARD_LOCK_LOW_THRESHOLD (68016) */
	'P', 'R', 'O', 'D', 'U', 'C', 'E', 'R', '_', 'R', 'E', 'Q', 'U', 'E', 'S', 'T', '_', 'L', 'O', 'C', 'K', 'O', 'U', 'T', '\0', /* PRODUCER_REQUEST_LOCKOUT (68040) */
	'G', 'L', 'O', 'B', 'A', 'L', '_', 'S', 'C', 'A', 'N', 'N', 'I', 'N', 'G', '_', 'E', 'N', '\0', /* GLOBAL_SCANNING_EN (68065) */
	'A', 'L', 'L', 'O', 'C', 'A', 'T', 'I', 'O', 'N', '_', 'R', 'A', 'T', 'E', '_', 'T', 'H', 'R', 'O', 'T', 'T', 'L', 'I', 'N', 'G', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '\0', /* ALLOCATION_RATE_THROTTLING_THRESHOLD (68084) */
	'T', 'O', 'T', 'A', 'L', '_', 'W', 'A', 'V', 'E', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* TOTAL_WAVE_COUNT_HIER_SELECT (68121) */
	'P', 'E', 'R', '_', 'T', 'Y', 'P', 'E', '_', 'W', 'A', 'V', 'E', '_', 'C', 'O', 'U', 'N', 'T', '_', 'H', 'I', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PER_TYPE_WAVE_COUNT_HIER_SELECT (68150) */
	'G', 'R', 'O', 'U', 'P', '_', 'U', 'P', 'D', 'A', 'T', 'E', '_', 'E', 'N', '\0', /* GROUP_UPDATE_EN (68182) */
	'T', 'O', 'T', 'A', 'L', '_', 'W', 'A', 'V', 'E', '_', 'C', 'O', 'U', 'N', 'T', '_', 'C', 'O', 'E', 'F', 'F', 'I', 'C', 'I', 'E', 'N', 'T', '\0', /* TOTAL_WAVE_COUNT_COEFFICIENT (68198) */
	'P', 'E', 'R', '_', 'T', 'Y', 'P', 'E', '_', 'W', 'A', 'V', 'E', '_', 'C', 'O', 'U', 'N', 'T', '_', 'C', 'O', 'E', 'F', 'F', 'I', 'C', 'I', 'E', 'N', 'T', '\0', /* PER_TYPE_WAVE_COUNT_COEFFICIENT (68227) */
	'C', 'O', 'N', 'T', 'R', 'I', 'B', 'U', 'T', 'I', 'O', 'N', '\0', /* CONTRIBUTION (68259) */
	'V', 'G', 'P', 'R', '_', 'C', 'O', 'M', 'P', '_', 'C', 'N', 'T', '\0', /* VGPR_COMP_CNT (68272) */
	'C', 'U', '_', 'G', 'R', 'O', 'U', 'P', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* CU_GROUP_ENABLE (68286) */
	'O', 'C', '_', 'L', 'D', 'S', '_', 'E', 'N', '\0', /* OC_LDS_EN (68302) */
	'S', 'O', '_', 'B', 'A', 'S', 'E', '0', '_', 'E', 'N', '\0', /* SO_BASE0_EN (68312) */
	'S', 'O', '_', 'B', 'A', 'S', 'E', '1', '_', 'E', 'N', '\0', /* SO_BASE1_EN (68324) */
	'S', 'O', '_', 'B', 'A', 'S', 'E', '2', '_', 'E', 'N', '\0', /* SO_BASE2_EN (68336) */
	'S', 'O', '_', 'B', 'A', 'S', 'E', '3', '_', 'E', 'N', '\0', /* SO_BASE3_EN (68348) */
	'S', 'O', '_', 'E', 'N', '\0', /* SO_EN (68360) */
	'P', 'C', '_', 'B', 'A', 'S', 'E', '_', 'E', 'N', '\0', /* PC_BASE_EN (68366) */
	'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'D', 'R', 'A', 'W', '_', 'E', 'N', '\0', /* DISPATCH_DRAW_EN (68377) */
	'S', 'K', 'I', 'P', '_', 'U', 'S', 'G', 'P', 'R', '0', '\0', /* SKIP_USGPR0 (68394) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'L', 'A', 'T', 'E', '_', 'A', 'L', 'L', 'O', 'C', '_', 'G', 'S', '\0', /* SPI_SHADER_LATE_ALLOC_GS (68406) */
	'G', 'R', 'O', 'U', 'P', '_', 'F', 'I', 'F', 'O', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* GROUP_FIFO_DEPTH (68431) */
	'W', 'G', 'P', '_', 'M', 'O', 'D', 'E', '\0', /* WGP_MODE (68448) */
	'G', 'S', '_', 'V', 'G', 'P', 'R', '_', 'C', 'O', 'M', 'P', '_', 'C', 'N', 'T', '\0', /* GS_VGPR_COMP_CNT (68457) */
	'E', 'S', '_', 'V', 'G', 'P', 'R', '_', 'C', 'O', 'M', 'P', '_', 'C', 'N', 'T', '\0', /* ES_VGPR_COMP_CNT (68474) */
	'L', 'S', '_', 'V', 'G', 'P', 'R', '_', 'C', 'O', 'M', 'P', '_', 'C', 'N', 'T', '\0', /* LS_VGPR_COMP_CNT (68491) */
	'T', 'G', '_', 'S', 'I', 'Z', 'E', '_', 'E', 'N', '\0', /* TG_SIZE_EN (68508) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'E', 'N', '\0', /* COMPUTE_SHADER_EN (68519) */
	'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'T', 'G', '_', 'E', 'N', '\0', /* PARTIAL_TG_EN (68537) */
	'F', 'O', 'R', 'C', 'E', '_', 'S', 'T', 'A', 'R', 'T', '_', 'A', 'T', '_', '0', '0', '0', '\0', /* FORCE_START_AT_000 (68551) */
	'O', 'R', 'D', 'E', 'R', 'E', 'D', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'E', 'N', 'B', 'L', '\0', /* ORDERED_APPEND_ENBL (68570) */
	'O', 'R', 'D', 'E', 'R', 'E', 'D', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'M', 'O', 'D', 'E', '\0', /* ORDERED_APPEND_MODE (68590) */
	'U', 'S', 'E', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'D', 'I', 'M', 'E', 'N', 'S', 'I', 'O', 'N', 'S', '\0', /* USE_THREAD_DIMENSIONS (68610) */
	'O', 'R', 'D', 'E', 'R', '_', 'M', 'O', 'D', 'E', '\0', /* ORDER_MODE (68632) */
	'S', 'C', 'A', 'L', 'A', 'R', '_', 'L', '1', '_', 'I', 'N', 'V', '_', 'V', 'O', 'L', '\0', /* SCALAR_L1_INV_VOL (68643, 68657) */
	'V', 'E', 'C', 'T', 'O', 'R', '_', 'L', '1', '_', 'I', 'N', 'V', '_', 'V', 'O', 'L', '\0', /* VECTOR_L1_INV_VOL (68661) */
	'T', 'U', 'N', 'N', 'E', 'L', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* TUNNEL_ENABLE (68679) */
	'R', 'E', 'S', 'T', 'O', 'R', 'E', '\0', /* RESTORE (68693) */
	'C', 'S', '_', 'W', '3', '2', '_', 'E', 'N', '\0', /* CS_W32_EN (68701) */
	'N', 'U', 'M', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'F', 'U', 'L', 'L', '\0', /* NUM_THREAD_FULL (68711, 68722) */
	'N', 'U', 'M', '_', 'T', 'H', 'R', 'E', 'A', 'D', '_', 'P', 'A', 'R', 'T', 'I', 'A', 'L', '\0', /* NUM_THREAD_PARTIAL (68727) */
	'B', 'U', 'L', 'K', 'Y', '\0', /* BULKY (68746) */
	'T', 'G', 'I', 'D', '_', 'X', '_', 'E', 'N', '\0', /* TGID_X_EN (68752) */
	'T', 'G', 'I', 'D', '_', 'Y', '_', 'E', 'N', '\0', /* TGID_Y_EN (68762) */
	'T', 'G', 'I', 'D', '_', 'Z', '_', 'E', 'N', '\0', /* TGID_Z_EN (68772) */
	'T', 'I', 'D', 'I', 'G', '_', 'C', 'O', 'M', 'P', '_', 'C', 'N', 'T', '\0', /* TIDIG_COMP_CNT (68782) */
	'E', 'X', 'C', 'P', '_', 'E', 'N', '_', 'M', 'S', 'B', '\0', /* EXCP_EN_MSB (68797) */
	'W', 'A', 'V', 'E', 'S', '_', 'P', 'E', 'R', '_', 'S', 'H', '\0', /* WAVES_PER_SH (68809) */
	'T', 'G', '_', 'P', 'E', 'R', '_', 'C', 'U', '\0', /* TG_PER_CU (68822) */
	'L', 'O', 'C', 'K', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '\0', /* LOCK_THRESHOLD (68832) */
	'S', 'I', 'M', 'D', '_', 'D', 'E', 'S', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* SIMD_DEST_CNTL (68847) */
	'F', 'O', 'R', 'C', 'E', '_', 'S', 'I', 'M', 'D', '_', 'D', 'I', 'S', 'T', '\0', /* FORCE_SIMD_DIST (68862) */
	'C', 'U', '_', 'G', 'R', 'O', 'U', 'P', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* CU_GROUP_COUNT (68878) */
	'W', 'A', 'V', 'E', 'S', '\0', /* WAVES (68893) */
	'W', 'A', 'V', 'E', 'S', 'I', 'Z', 'E', '\0', /* WAVESIZE (68899) */
	'S', 'E', 'N', 'D', '_', 'S', 'E', 'I', 'D', '\0', /* SEND_SEID (68908) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '3', '\0', /* RESERVED3 (68918) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '4', '\0', /* RESERVED4 (68928) */
	'W', 'A', 'V', 'E', '_', 'I', 'D', '_', 'B', 'A', 'S', 'E', '\0', /* WAVE_ID_BASE (68938) */
	'D', 'E', 'D', 'I', 'C', 'A', 'T', 'E', 'D', '_', 'P', 'R', 'E', 'A', 'L', 'L', 'O', 'C', 'A', 'T', 'I', 'O', 'N', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'L', 'I', 'M', 'I', 'T', '\0', /* DEDICATED_PREALLOCATION_BUFFER_LIMIT (68951) */
	'P', 'A', 'Y', 'L', 'O', 'A', 'D', '\0', /* PAYLOAD (68988, 68991) */
	'I', 'S', '_', 'E', 'V', 'E', 'N', 'T', '\0', /* IS_EVENT (68996) */
	'I', 'S', '_', 'S', 'T', 'A', 'T', 'E', '\0', /* IS_STATE (69005) */
	'O', 'F', 'F', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* OFF_DELAY (69014) */
	'D', 'E', 'P', 'T', 'H', '_', 'C', 'L', 'E', 'A', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* DEPTH_CLEAR_ENABLE (69024) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'C', 'L', 'E', 'A', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* STENCIL_CLEAR_ENABLE (69043) */
	'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'P', 'Y', '\0', /* DEPTH_COPY (69064) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'C', 'O', 'P', 'Y', '\0', /* STENCIL_COPY (69075) */
	'R', 'E', 'S', 'U', 'M', 'M', 'A', 'R', 'I', 'Z', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* RESUMMARIZE_ENABLE (69088) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* STENCIL_COMPRESS_DISABLE (69107) */
	'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* DEPTH_COMPRESS_DISABLE (69132) */
	'C', 'O', 'P', 'Y', '_', 'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '\0', /* COPY_CENTROID (69155) */
	'C', 'O', 'P', 'Y', '_', 'S', 'A', 'M', 'P', 'L', 'E', '\0', /* COPY_SAMPLE (69169) */
	'D', 'E', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* DECOMPRESS_ENABLE (69181) */
	'Z', 'P', 'A', 'S', 'S', '_', 'I', 'N', 'C', 'R', 'E', 'M', 'E', 'N', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* ZPASS_INCREMENT_DISABLE (69199) */
	'P', 'E', 'R', 'F', 'E', 'C', 'T', '_', 'Z', 'P', 'A', 'S', 'S', '_', 'C', 'O', 'U', 'N', 'T', 'S', '\0', /* PERFECT_ZPASS_COUNTS (69223) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'C', 'O', 'N', 'S', 'E', 'R', 'V', 'A', 'T', 'I', 'V', 'E', '_', 'Z', 'P', 'A', 'S', 'S', '_', 'C', 'O', 'U', 'N', 'T', 'S', '\0', /* DISABLE_CONSERVATIVE_ZPASS_COUNTS (69244) */
	'E', 'N', 'H', 'A', 'N', 'C', 'E', 'D', '_', 'C', 'O', 'N', 'S', 'E', 'R', 'V', 'A', 'T', 'I', 'V', 'E', '_', 'Z', 'P', 'A', 'S', 'S', '_', 'C', 'O', 'U', 'N', 'T', 'S', '\0', /* ENHANCED_CONSERVATIVE_ZPASS_COUNTS (69278) */
	'S', 'A', 'M', 'P', 'L', 'E', '_', 'R', 'A', 'T', 'E', '\0', /* SAMPLE_RATE (69313) */
	'Z', 'P', 'A', 'S', 'S', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* ZPASS_ENABLE (69325) */
	'Z', 'F', 'A', 'I', 'L', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* ZFAIL_ENABLE (69338) */
	'S', 'F', 'A', 'I', 'L', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* SFAIL_ENABLE (69351) */
	'D', 'B', 'F', 'A', 'I', 'L', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* DBFAIL_ENABLE (69364) */
	'S', 'L', 'I', 'C', 'E', '_', 'E', 'V', 'E', 'N', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* SLICE_EVEN_ENABLE (69378) */
	'S', 'L', 'I', 'C', 'E', '_', 'O', 'D', 'D', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* SLICE_ODD_ENABLE (69396) */
	'S', 'L', 'I', 'C', 'E', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* SLICE_START (69413, 69419) */
	'S', 'L', 'I', 'C', 'E', '_', 'S', 'T', 'A', 'R', 'T', '_', 'H', 'I', '\0', /* SLICE_START_HI (69425) */
	'S', 'L', 'I', 'C', 'E', '_', 'M', 'A', 'X', '\0', /* SLICE_MAX (69440) */
	'Z', '_', 'R', 'E', 'A', 'D', '_', 'O', 'N', 'L', 'Y', '\0', /* Z_READ_ONLY (69450) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'R', 'E', 'A', 'D', '_', 'O', 'N', 'L', 'Y', '\0', /* STENCIL_READ_ONLY (69462) */
	'M', 'I', 'P', 'I', 'D', '\0', /* MIPID (69480) */
	'S', 'L', 'I', 'C', 'E', '_', 'M', 'A', 'X', '_', 'H', 'I', '\0', /* SLICE_MAX_HI (69486) */
	'F', 'O', 'R', 'C', 'E', '_', 'O', 'F', 'F', '\0', /* FORCE_OFF (69499) */
	'F', 'O', 'R', 'C', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* FORCE_ENABLE (69509) */
	'F', 'O', 'R', 'C', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* FORCE_DISABLE (69522) */
	'F', 'O', 'R', 'C', 'E', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '\0', /* FORCE_RESERVED (69536) */
	'F', 'O', 'R', 'C', 'E', '_', 'H', 'I', 'Z', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* FORCE_HIZ_ENABLE (69551, 69559) */
	'F', 'O', 'R', 'C', 'E', '_', 'H', 'I', 'S', '_', 'E', 'N', 'A', 'B', 'L', 'E', '0', '\0', /* FORCE_HIS_ENABLE0 (69568, 69578) */
	'F', 'O', 'R', 'C', 'E', '_', 'H', 'I', 'S', '_', 'E', 'N', 'A', 'B', 'L', 'E', '1', '\0', /* FORCE_HIS_ENABLE1 (69586, 69596) */
	'F', 'O', 'R', 'C', 'E', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'Z', '_', 'O', 'R', 'D', 'E', 'R', '\0', /* FORCE_SHADER_Z_ORDER (69604, 69617) */
	'F', 'A', 'S', 'T', '_', 'Z', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* FAST_Z_DISABLE (69625) */
	'F', 'A', 'S', 'T', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* FAST_STENCIL_DISABLE (69640) */
	'N', 'O', 'O', 'P', '_', 'C', 'U', 'L', 'L', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* NOOP_CULL_DISABLE (69661) */
	'F', 'O', 'R', 'C', 'E', '_', 'C', 'O', 'L', 'O', 'R', '_', 'K', 'I', 'L', 'L', '\0', /* FORCE_COLOR_KILL (69679, 69691) */
	'F', 'O', 'R', 'C', 'E', '_', 'Z', '_', 'R', 'E', 'A', 'D', '\0', /* FORCE_Z_READ (69696) */
	'F', 'O', 'R', 'C', 'E', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'R', 'E', 'A', 'D', '\0', /* FORCE_STENCIL_READ (69709) */
	'F', 'O', 'R', 'C', 'E', '_', 'F', 'U', 'L', 'L', '_', 'Z', '_', 'R', 'A', 'N', 'G', 'E', '\0', /* FORCE_FULL_Z_RANGE (69728) */
	'F', 'O', 'R', 'C', 'E', '_', 'Q', 'C', '_', 'S', 'M', 'A', 'S', 'K', '_', 'C', 'O', 'N', 'F', 'L', 'I', 'C', 'T', '\0', /* FORCE_QC_SMASK_CONFLICT (69747) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'V', 'I', 'E', 'W', 'P', 'O', 'R', 'T', '_', 'C', 'L', 'A', 'M', 'P', '\0', /* DISABLE_VIEWPORT_CLAMP (69771) */
	'I', 'G', 'N', 'O', 'R', 'E', '_', 'S', 'C', '_', 'Z', 'R', 'A', 'N', 'G', 'E', '\0', /* IGNORE_SC_ZRANGE (69794) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'F', 'U', 'L', 'L', 'Y', '_', 'C', 'O', 'V', 'E', 'R', 'E', 'D', '\0', /* DISABLE_FULLY_COVERED (69811) */
	'F', 'O', 'R', 'C', 'E', '_', 'S', 'U', 'M', 'M', '_', 'O', 'F', 'F', '\0', /* FORCE_SUMM_OFF (69833) */
	'F', 'O', 'R', 'C', 'E', '_', 'S', 'U', 'M', 'M', '_', 'M', 'I', 'N', 'Z', '\0', /* FORCE_SUMM_MINZ (69848) */
	'F', 'O', 'R', 'C', 'E', '_', 'S', 'U', 'M', 'M', '_', 'M', 'A', 'X', 'Z', '\0', /* FORCE_SUMM_MAXZ (69864) */
	'F', 'O', 'R', 'C', 'E', '_', 'S', 'U', 'M', 'M', '_', 'B', 'O', 'T', 'H', '\0', /* FORCE_SUMM_BOTH (69880) */
	'F', 'O', 'R', 'C', 'E', '_', 'Z', '_', 'L', 'I', 'M', 'I', 'T', '_', 'S', 'U', 'M', 'M', '\0', /* FORCE_Z_LIMIT_SUMM (69896) */
	'M', 'A', 'X', '_', 'T', 'I', 'L', 'E', 'S', '_', 'I', 'N', '_', 'D', 'T', 'T', '\0', /* MAX_TILES_IN_DTT (69915) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'T', 'I', 'L', 'E', '_', 'R', 'A', 'T', 'E', '_', 'T', 'I', 'L', 'E', 'S', '\0', /* DISABLE_TILE_RATE_TILES (69932) */
	'F', 'O', 'R', 'C', 'E', '_', 'Z', '_', 'D', 'I', 'R', 'T', 'Y', '\0', /* FORCE_Z_DIRTY (69956, 69964) */
	'F', 'O', 'R', 'C', 'E', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'D', 'I', 'R', 'T', 'Y', '\0', /* FORCE_STENCIL_DIRTY (69970) */
	'F', 'O', 'R', 'C', 'E', '_', 'Z', '_', 'V', 'A', 'L', 'I', 'D', '\0', /* FORCE_Z_VALID (69990) */
	'F', 'O', 'R', 'C', 'E', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'V', 'A', 'L', 'I', 'D', '\0', /* FORCE_STENCIL_VALID (70004) */
	'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', 'I', 'O', 'N', '\0', /* PRESERVE_COMPRESSION (70024, 70033) */
	'P', 'S', 'L', 'C', '_', 'A', 'U', 'T', 'O', '\0', /* PSLC_AUTO (70045) */
	'P', 'S', 'L', 'C', '_', 'O', 'N', '_', 'H', 'A', 'N', 'G', '_', 'O', 'N', 'L', 'Y', '\0', /* PSLC_ON_HANG_ONLY (70055) */
	'P', 'S', 'L', 'C', '_', 'A', 'S', 'A', 'P', '\0', /* PSLC_ASAP (70073) */
	'P', 'S', 'L', 'C', '_', 'C', 'O', 'U', 'N', 'T', 'D', 'O', 'W', 'N', '\0', /* PSLC_COUNTDOWN (70083) */
	'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'S', 'Q', 'U', 'A', 'D', '_', 'L', 'A', 'U', 'N', 'C', 'H', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* PARTIAL_SQUAD_LAUNCH_CONTROL (70098) */
	'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'S', 'Q', 'U', 'A', 'D', '_', 'L', 'A', 'U', 'N', 'C', 'H', '_', 'C', 'O', 'U', 'N', 'T', 'D', 'O', 'W', 'N', '\0', /* PARTIAL_SQUAD_LAUNCH_COUNTDOWN (70127) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'Z', 'M', 'A', 'S', 'K', '_', 'E', 'X', 'P', 'C', 'L', 'E', 'A', 'R', '_', 'O', 'P', 'T', 'I', 'M', 'I', 'Z', 'A', 'T', 'I', 'O', 'N', '\0', /* DISABLE_ZMASK_EXPCLEAR_OPTIMIZATION (70158) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'S', 'M', 'E', 'M', '_', 'E', 'X', 'P', 'C', 'L', 'E', 'A', 'R', '_', 'O', 'P', 'T', 'I', 'M', 'I', 'Z', 'A', 'T', 'I', 'O', 'N', '\0', /* DISABLE_SMEM_EXPCLEAR_OPTIMIZATION (70194) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'N', '_', 'V', 'A', 'L', 'I', 'D', 'A', 'T', 'I', 'O', 'N', '\0', /* DISABLE_COLOR_ON_VALIDATION (70229) */
	'D', 'E', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '_', 'Z', '_', 'O', 'N', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* DECOMPRESS_Z_ON_FLUSH (70257) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'R', 'E', 'G', '_', 'S', 'N', 'O', 'O', 'P', '\0', /* DISABLE_REG_SNOOP (70279) */
	'D', 'E', 'P', 'T', 'H', '_', 'B', 'O', 'U', 'N', 'D', 'S', '_', 'H', 'I', 'E', 'R', '_', 'D', 'E', 'P', 'T', 'H', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* DEPTH_BOUNDS_HIER_DEPTH_DISABLE (70297) */
	'S', 'E', 'P', 'A', 'R', 'A', 'T', 'E', '_', 'H', 'I', 'Z', 'S', '_', 'F', 'U', 'N', 'C', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* SEPARATE_HIZS_FUNC_ENABLE (70329) */
	'F', 'R', 'A', 'G', '_', 'N', 'E', 'V', 'E', 'R', '\0', /* FRAG_NEVER (70355) */
	'F', 'R', 'A', 'G', '_', 'L', 'E', 'S', 'S', '\0', /* FRAG_LESS (70366) */
	'F', 'R', 'A', 'G', '_', 'E', 'Q', 'U', 'A', 'L', '\0', /* FRAG_EQUAL (70376) */
	'F', 'R', 'A', 'G', '_', 'L', 'E', 'Q', 'U', 'A', 'L', '\0', /* FRAG_LEQUAL (70387) */
	'F', 'R', 'A', 'G', '_', 'G', 'R', 'E', 'A', 'T', 'E', 'R', '\0', /* FRAG_GREATER (70399) */
	'F', 'R', 'A', 'G', '_', 'N', 'O', 'T', 'E', 'Q', 'U', 'A', 'L', '\0', /* FRAG_NOTEQUAL (70412) */
	'F', 'R', 'A', 'G', '_', 'G', 'E', 'Q', 'U', 'A', 'L', '\0', /* FRAG_GEQUAL (70426) */
	'F', 'R', 'A', 'G', '_', 'A', 'L', 'W', 'A', 'Y', 'S', '\0', /* FRAG_ALWAYS (70438, 70443) */
	'H', 'I', 'Z', '_', 'Z', 'F', 'U', 'N', 'C', '\0', /* HIZ_ZFUNC (70450, 70454) */
	'H', 'I', 'S', '_', 'S', 'F', 'U', 'N', 'C', '_', 'F', 'F', '\0', /* HIS_SFUNC_FF (70460) */
	'H', 'I', 'S', '_', 'S', 'F', 'U', 'N', 'C', '_', 'B', 'F', '\0', /* HIS_SFUNC_BF (70473) */
	'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'Z', 'R', 'A', 'N', 'G', 'E', '\0', /* PRESERVE_ZRANGE (70486) */
	'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'S', 'R', 'E', 'S', 'U', 'L', 'T', 'S', '\0', /* PRESERVE_SRESULTS (70502) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'F', 'A', 'S', 'T', '_', 'P', 'A', 'S', 'S', '\0', /* DISABLE_FAST_PASS (70520) */
	'A', 'L', 'L', 'O', 'W', '_', 'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'R', 'E', 'S', '_', 'H', 'I', 'E', 'R', '_', 'K', 'I', 'L', 'L', '\0', /* ALLOW_PARTIAL_RES_HIER_KILL (70538) */
	'X', '_', 'M', 'A', 'X', '\0', /* X_MAX (70566) */
	'T', 'L', '_', 'X', '\0', /* TL_X (70572) */
	'T', 'L', '_', 'Y', '\0', /* TL_Y (70577) */
	'B', 'R', '_', 'X', '\0', /* BR_X (70582) */
	'B', 'R', '_', 'Y', '\0', /* BR_Y (70587) */
	'F', 'O', 'R', 'C', 'E', '_', 'O', 'N', '\0', /* FORCE_ON (70592) */
	'P', 'U', 'N', 'C', 'H', 'O', 'U', 'T', '_', 'M', 'O', 'D', 'E', '\0', /* PUNCHOUT_MODE (70601) */
	'P', 'O', 'P', 'S', '_', 'D', 'R', 'A', 'I', 'N', '_', 'P', 'S', '_', 'O', 'N', '_', 'O', 'V', 'E', 'R', 'L', 'A', 'P', '\0', /* POPS_DRAIN_PS_ON_OVERLAP (70615) */
	'D', 'I', 'S', 'A', 'L', 'L', 'O', 'W', '_', 'O', 'V', 'E', 'R', 'F', 'L', 'O', 'W', '\0', /* DISALLOW_OVERFLOW (70640) */
	'F', 'I', 'E', 'L', 'D', '_', '1', '\0', /* FIELD_1 (70658) */
	'F', 'I', 'E', 'L', 'D', '_', '2', '\0', /* FIELD_2 (70666) */
	'F', 'I', 'E', 'L', 'D', '_', '3', '\0', /* FIELD_3 (70674) */
	'F', 'I', 'E', 'L', 'D', '_', '4', '\0', /* FIELD_4 (70682) */
	'F', 'I', 'E', 'L', 'D', '_', '5', '\0', /* FIELD_5 (70690) */
	'F', 'I', 'E', 'L', 'D', '_', '6', '\0', /* FIELD_6 (70698) */
	'F', 'I', 'E', 'L', 'D', '_', '7', '\0', /* FIELD_7 (70706) */
	'Z', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', '\0', /* Z_INVALID (70714) */
	'Z', '_', '1', '6', '\0', /* Z_16 (70724) */
	'Z', '_', '2', '4', '\0', /* Z_24 (70729) */
	'Z', '_', '3', '2', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* Z_32_FLOAT (70734) */
	'N', 'U', 'M', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '\0', /* NUM_SAMPLES (70745) */
	'F', 'A', 'U', 'L', 'T', '_', 'Z', 'E', 'R', 'O', '\0', /* FAULT_ZERO (70757) */
	'F', 'A', 'U', 'L', 'T', '_', 'O', 'N', 'E', '\0', /* FAULT_ONE (70768) */
	'F', 'A', 'U', 'L', 'T', '_', 'F', 'A', 'I', 'L', '\0', /* FAULT_FAIL (70778) */
	'F', 'A', 'U', 'L', 'T', '_', 'P', 'A', 'S', 'S', '\0', /* FAULT_PASS (70789) */
	'F', 'A', 'U', 'L', 'T', '_', 'B', 'E', 'H', 'A', 'V', 'I', 'O', 'R', '\0', /* FAULT_BEHAVIOR (70800) */
	'I', 'T', 'E', 'R', 'A', 'T', 'E', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* ITERATE_FLUSH (70815) */
	'P', 'A', 'R', 'T', 'I', 'A', 'L', 'L', 'Y', '_', 'R', 'E', 'S', 'I', 'D', 'E', 'N', 'T', '\0', /* PARTIALLY_RESIDENT (70829) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'F', 'I', 'E', 'L', 'D', '_', '1', '\0', /* RESERVED_FIELD_1 (70848) */
	'M', 'A', 'X', 'M', 'I', 'P', '\0', /* MAXMIP (70865) */
	'D', 'E', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '_', 'O', 'N', '_', 'N', '_', 'Z', 'P', 'L', 'A', 'N', 'E', 'S', '\0', /* DECOMPRESS_ON_N_ZPLANES (70872) */
	'A', 'L', 'L', 'O', 'W', '_', 'E', 'X', 'P', 'C', 'L', 'E', 'A', 'R', '\0', /* ALLOW_EXPCLEAR (70896) */
	'R', 'E', 'A', 'D', '_', 'S', 'I', 'Z', 'E', '\0', /* READ_SIZE (70911) */
	'T', 'I', 'L', 'E', '_', 'S', 'U', 'R', 'F', 'A', 'C', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* TILE_SURFACE_ENABLE (70921) */
	'Z', 'R', 'A', 'N', 'G', 'E', '_', 'P', 'R', 'E', 'C', 'I', 'S', 'I', 'O', 'N', '\0', /* ZRANGE_PRECISION (70941) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', '\0', /* STENCIL_INVALID (70958) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', '8', '\0', /* STENCIL_8 (70974) */
	'T', 'I', 'L', 'E', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* TILE_STENCIL_DISABLE (70984) */
	'C', 'A', 'C', 'H', 'E', '_', 'L', 'R', 'U', '_', 'W', 'R', '\0', /* CACHE_LRU_WR (71005) */
	'C', 'A', 'C', 'H', 'E', '_', 'S', 'T', 'R', 'E', 'A', 'M', '\0', /* CACHE_STREAM (71018) */
	'C', 'A', 'C', 'H', 'E', '_', 'B', 'Y', 'P', 'A', 'S', 'S', '\0', /* CACHE_BYPASS (71031) */
	'U', 'N', 'C', 'A', 'C', 'H', 'E', 'D', '_', 'W', 'R', '\0', /* UNCACHED_WR (71044) */
	'Z', '_', 'W', 'R', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* Z_WR_POLICY (71056) */
	'S', '_', 'W', 'R', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* S_WR_POLICY (71068) */
	'H', 'T', 'I', 'L', 'E', '_', 'W', 'R', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* HTILE_WR_POLICY (71080) */
	'Z', 'P', 'C', 'P', 'S', 'D', '_', 'W', 'R', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* ZPCPSD_WR_POLICY (71096) */
	'C', 'A', 'C', 'H', 'E', '_', 'L', 'R', 'U', '_', 'R', 'D', '\0', /* CACHE_LRU_RD (71113) */
	'C', 'A', 'C', 'H', 'E', '_', 'N', 'O', 'A', '\0', /* CACHE_NOA (71126) */
	'U', 'N', 'C', 'A', 'C', 'H', 'E', 'D', '_', 'R', 'D', '\0', /* UNCACHED_RD (71136) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'D', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* RESERVED_RDPOLICY (71148) */
	'Z', '_', 'R', 'D', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* Z_RD_POLICY (71166) */
	'S', '_', 'R', 'D', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* S_RD_POLICY (71178) */
	'H', 'T', 'I', 'L', 'E', '_', 'R', 'D', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* HTILE_RD_POLICY (71190) */
	'Z', '_', 'B', 'I', 'G', '_', 'P', 'A', 'G', 'E', '\0', /* Z_BIG_PAGE (71206, 71208) */
	'S', '_', 'B', 'I', 'G', '_', 'P', 'A', 'G', 'E', '\0', /* S_BIG_PAGE (71217) */
	'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '_', '2', '5', '6', 'B', '\0', /* DEST_BASE_HI_256B (71228) */
	'W', 'I', 'N', 'D', 'O', 'W', '_', 'X', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* WINDOW_X_OFFSET (71246) */
	'W', 'I', 'N', 'D', 'O', 'W', '_', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* WINDOW_Y_OFFSET (71262, 71269) */
	'W', 'I', 'N', 'D', 'O', 'W', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* WINDOW_OFFSET_DISABLE (71278) */
	'I', 'N', '_', '2', '0', '\0', /* IN_20 (71300) */
	'I', 'N', '_', '2', '1', '\0', /* IN_21 (71306) */
	'I', 'N', '_', '2', '1', '0', '\0', /* IN_210 (71312) */
	'I', 'N', '_', '3', '0', '\0', /* IN_30 (71319) */
	'I', 'N', '_', '3', '1', '\0', /* IN_31 (71325) */
	'I', 'N', '_', '3', '1', '0', '\0', /* IN_310 (71331) */
	'I', 'N', '_', '3', '2', '\0', /* IN_32 (71338) */
	'I', 'N', '_', '3', '2', '0', '\0', /* IN_320 (71344) */
	'I', 'N', '_', '3', '2', '1', '\0', /* IN_321 (71351) */
	'I', 'N', '_', '3', '2', '1', '0', '\0', /* IN_3210 (71358) */
	'C', 'L', 'I', 'P', '_', 'R', 'U', 'L', 'E', '\0', /* CLIP_RULE (71366) */
	'E', 'R', '_', 'T', 'R', 'I', '\0', /* ER_TRI (71376) */
	'E', 'R', '_', 'P', 'O', 'I', 'N', 'T', '\0', /* ER_POINT (71383) */
	'E', 'R', '_', 'R', 'E', 'C', 'T', '\0', /* ER_RECT (71392) */
	'E', 'R', '_', 'L', 'I', 'N', 'E', '_', 'L', 'R', '\0', /* ER_LINE_LR (71400) */
	'E', 'R', '_', 'L', 'I', 'N', 'E', '_', 'R', 'L', '\0', /* ER_LINE_RL (71411) */
	'E', 'R', '_', 'L', 'I', 'N', 'E', '_', 'T', 'B', '\0', /* ER_LINE_TB (71422) */
	'E', 'R', '_', 'L', 'I', 'N', 'E', '_', 'B', 'T', '\0', /* ER_LINE_BT (71433) */
	'H', 'W', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'X', '\0', /* HW_SCREEN_OFFSET_X (71444) */
	'H', 'W', '_', 'S', 'C', 'R', 'E', 'E', 'N', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'Y', '\0', /* HW_SCREEN_OFFSET_Y (71463) */
	'T', 'A', 'R', 'G', 'E', 'T', '0', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* TARGET0_ENABLE (71482) */
	'T', 'A', 'R', 'G', 'E', 'T', '1', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* TARGET1_ENABLE (71497) */
	'T', 'A', 'R', 'G', 'E', 'T', '2', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* TARGET2_ENABLE (71512) */
	'T', 'A', 'R', 'G', 'E', 'T', '3', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* TARGET3_ENABLE (71527) */
	'T', 'A', 'R', 'G', 'E', 'T', '4', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* TARGET4_ENABLE (71542) */
	'T', 'A', 'R', 'G', 'E', 'T', '5', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* TARGET5_ENABLE (71557) */
	'T', 'A', 'R', 'G', 'E', 'T', '6', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* TARGET6_ENABLE (71572) */
	'T', 'A', 'R', 'G', 'E', 'T', '7', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* TARGET7_ENABLE (71587) */
	'O', 'U', 'T', 'P', 'U', 'T', '0', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OUTPUT0_ENABLE (71602) */
	'O', 'U', 'T', 'P', 'U', 'T', '1', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OUTPUT1_ENABLE (71617) */
	'O', 'U', 'T', 'P', 'U', 'T', '2', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OUTPUT2_ENABLE (71632) */
	'O', 'U', 'T', 'P', 'U', 'T', '3', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OUTPUT3_ENABLE (71647) */
	'O', 'U', 'T', 'P', 'U', 'T', '4', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OUTPUT4_ENABLE (71662) */
	'O', 'U', 'T', 'P', 'U', 'T', '5', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OUTPUT5_ENABLE (71677) */
	'O', 'U', 'T', 'P', 'U', 'T', '6', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OUTPUT6_ENABLE (71692) */
	'O', 'U', 'T', 'P', 'U', 'T', '7', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OUTPUT7_ENABLE (71707) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'M', 'A', 'P', '_', '0', '\0', /* RASTER_CONFIG_RB_MAP_0 (71722) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'M', 'A', 'P', '_', '1', '\0', /* RASTER_CONFIG_RB_MAP_1 (71745) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'M', 'A', 'P', '_', '2', '\0', /* RASTER_CONFIG_RB_MAP_2 (71768) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'M', 'A', 'P', '_', '3', '\0', /* RASTER_CONFIG_RB_MAP_3 (71791) */
	'R', 'B', '_', 'M', 'A', 'P', '_', 'P', 'K', 'R', '0', '\0', /* RB_MAP_PKR0 (71814) */
	'R', 'B', '_', 'M', 'A', 'P', '_', 'P', 'K', 'R', '1', '\0', /* RB_MAP_PKR1 (71826) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'X', 'S', 'E', 'L', '2', '_', '0', '\0', /* RASTER_CONFIG_RB_XSEL2_0 (71838) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'X', 'S', 'E', 'L', '2', '_', '1', '\0', /* RASTER_CONFIG_RB_XSEL2_1 (71863) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'X', 'S', 'E', 'L', '2', '_', '2', '\0', /* RASTER_CONFIG_RB_XSEL2_2 (71888) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'X', 'S', 'E', 'L', '2', '_', '3', '\0', /* RASTER_CONFIG_RB_XSEL2_3 (71913) */
	'R', 'B', '_', 'X', 'S', 'E', 'L', '2', '\0', /* RB_XSEL2 (71938) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'X', 'S', 'E', 'L', '_', '0', '\0', /* RASTER_CONFIG_RB_XSEL_0 (71947) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'X', 'S', 'E', 'L', '_', '1', '\0', /* RASTER_CONFIG_RB_XSEL_1 (71971) */
	'R', 'B', '_', 'X', 'S', 'E', 'L', '\0', /* RB_XSEL (71995) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'Y', 'S', 'E', 'L', '_', '0', '\0', /* RASTER_CONFIG_RB_YSEL_0 (72003) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'B', '_', 'Y', 'S', 'E', 'L', '_', '1', '\0', /* RASTER_CONFIG_RB_YSEL_1 (72027) */
	'R', 'B', '_', 'Y', 'S', 'E', 'L', '\0', /* RB_YSEL (72051) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'M', 'A', 'P', '_', '0', '\0', /* RASTER_CONFIG_PKR_MAP_0 (72059) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'M', 'A', 'P', '_', '1', '\0', /* RASTER_CONFIG_PKR_MAP_1 (72083) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'M', 'A', 'P', '_', '2', '\0', /* RASTER_CONFIG_PKR_MAP_2 (72107) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'M', 'A', 'P', '_', '3', '\0', /* RASTER_CONFIG_PKR_MAP_3 (72131) */
	'P', 'K', 'R', '_', 'M', 'A', 'P', '\0', /* PKR_MAP (72155) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'X', 'S', 'E', 'L', '_', '0', '\0', /* RASTER_CONFIG_PKR_XSEL_0 (72163) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'X', 'S', 'E', 'L', '_', '1', '\0', /* RASTER_CONFIG_PKR_XSEL_1 (72188) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'X', 'S', 'E', 'L', '_', '2', '\0', /* RASTER_CONFIG_PKR_XSEL_2 (72213) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'X', 'S', 'E', 'L', '_', '3', '\0', /* RASTER_CONFIG_PKR_XSEL_3 (72238) */
	'P', 'K', 'R', '_', 'X', 'S', 'E', 'L', '\0', /* PKR_XSEL (72263) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'Y', 'S', 'E', 'L', '_', '0', '\0', /* RASTER_CONFIG_PKR_YSEL_0 (72272) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'Y', 'S', 'E', 'L', '_', '1', '\0', /* RASTER_CONFIG_PKR_YSEL_1 (72297) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'Y', 'S', 'E', 'L', '_', '2', '\0', /* RASTER_CONFIG_PKR_YSEL_2 (72322) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'Y', 'S', 'E', 'L', '_', '3', '\0', /* RASTER_CONFIG_PKR_YSEL_3 (72347) */
	'P', 'K', 'R', '_', 'Y', 'S', 'E', 'L', '\0', /* PKR_YSEL (72372) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'X', 'S', 'E', 'L', '2', '_', '0', '\0', /* RASTER_CONFIG_PKR_XSEL2_0 (72381) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'X', 'S', 'E', 'L', '2', '_', '1', '\0', /* RASTER_CONFIG_PKR_XSEL2_1 (72407) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'X', 'S', 'E', 'L', '2', '_', '2', '\0', /* RASTER_CONFIG_PKR_XSEL2_2 (72433) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'P', 'K', 'R', '_', 'X', 'S', 'E', 'L', '2', '_', '3', '\0', /* RASTER_CONFIG_PKR_XSEL2_3 (72459) */
	'P', 'K', 'R', '_', 'X', 'S', 'E', 'L', '2', '\0', /* PKR_XSEL2 (72485) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'M', 'A', 'P', '_', '0', '\0', /* RASTER_CONFIG_SC_MAP_0 (72495) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'M', 'A', 'P', '_', '1', '\0', /* RASTER_CONFIG_SC_MAP_1 (72518) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'M', 'A', 'P', '_', '2', '\0', /* RASTER_CONFIG_SC_MAP_2 (72541) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'M', 'A', 'P', '_', '3', '\0', /* RASTER_CONFIG_SC_MAP_3 (72564) */
	'S', 'C', '_', 'M', 'A', 'P', '\0', /* SC_MAP (72587) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'X', 'S', 'E', 'L', '_', '8', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SC_XSEL_8_WIDE_TILE (72594) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'X', 'S', 'E', 'L', '_', '1', '6', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SC_XSEL_16_WIDE_TILE (72628) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'X', 'S', 'E', 'L', '_', '3', '2', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SC_XSEL_32_WIDE_TILE (72663) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'X', 'S', 'E', 'L', '_', '6', '4', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SC_XSEL_64_WIDE_TILE (72698) */
	'S', 'C', '_', 'X', 'S', 'E', 'L', '\0', /* SC_XSEL (72733) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'Y', 'S', 'E', 'L', '_', '8', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SC_YSEL_8_WIDE_TILE (72741) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'Y', 'S', 'E', 'L', '_', '1', '6', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SC_YSEL_16_WIDE_TILE (72775) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'Y', 'S', 'E', 'L', '_', '3', '2', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SC_YSEL_32_WIDE_TILE (72810) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'C', '_', 'Y', 'S', 'E', 'L', '_', '6', '4', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SC_YSEL_64_WIDE_TILE (72845) */
	'S', 'C', '_', 'Y', 'S', 'E', 'L', '\0', /* SC_YSEL (72880) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'M', 'A', 'P', '_', '0', '\0', /* RASTER_CONFIG_SE_MAP_0 (72888) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'M', 'A', 'P', '_', '1', '\0', /* RASTER_CONFIG_SE_MAP_1 (72911) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'M', 'A', 'P', '_', '2', '\0', /* RASTER_CONFIG_SE_MAP_2 (72934) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'M', 'A', 'P', '_', '3', '\0', /* RASTER_CONFIG_SE_MAP_3 (72957) */
	'S', 'E', '_', 'M', 'A', 'P', '\0', /* SE_MAP (72980) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'X', 'S', 'E', 'L', '_', '8', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_XSEL_8_WIDE_TILE (72987) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'X', 'S', 'E', 'L', '_', '1', '6', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_XSEL_16_WIDE_TILE (73021) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'X', 'S', 'E', 'L', '_', '3', '2', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_XSEL_32_WIDE_TILE (73056) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'X', 'S', 'E', 'L', '_', '6', '4', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_XSEL_64_WIDE_TILE (73091) */
	'S', 'E', '_', 'X', 'S', 'E', 'L', '\0', /* SE_XSEL (73126) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'Y', 'S', 'E', 'L', '_', '8', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_YSEL_8_WIDE_TILE (73134) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'Y', 'S', 'E', 'L', '_', '1', '6', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_YSEL_16_WIDE_TILE (73168) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'Y', 'S', 'E', 'L', '_', '3', '2', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_YSEL_32_WIDE_TILE (73203) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'Y', 'S', 'E', 'L', '_', '6', '4', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_YSEL_64_WIDE_TILE (73238) */
	'S', 'E', '_', 'Y', 'S', 'E', 'L', '\0', /* SE_YSEL (73273) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'M', 'A', 'P', '_', '0', '\0', /* RASTER_CONFIG_SE_PAIR_MAP_0 (73281) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'M', 'A', 'P', '_', '1', '\0', /* RASTER_CONFIG_SE_PAIR_MAP_1 (73309) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'M', 'A', 'P', '_', '2', '\0', /* RASTER_CONFIG_SE_PAIR_MAP_2 (73337) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'M', 'A', 'P', '_', '3', '\0', /* RASTER_CONFIG_SE_PAIR_MAP_3 (73365) */
	'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'M', 'A', 'P', '\0', /* SE_PAIR_MAP (73393) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'X', 'S', 'E', 'L', '_', '8', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_PAIR_XSEL_8_WIDE_TILE (73405) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'X', 'S', 'E', 'L', '_', '1', '6', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_PAIR_XSEL_16_WIDE_TILE (73444) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'X', 'S', 'E', 'L', '_', '3', '2', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_PAIR_XSEL_32_WIDE_TILE (73484) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'X', 'S', 'E', 'L', '_', '6', '4', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_PAIR_XSEL_64_WIDE_TILE (73524) */
	'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'X', 'S', 'E', 'L', '\0', /* SE_PAIR_XSEL (73564) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'Y', 'S', 'E', 'L', '_', '8', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_PAIR_YSEL_8_WIDE_TILE (73577) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'Y', 'S', 'E', 'L', '_', '1', '6', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_PAIR_YSEL_16_WIDE_TILE (73616) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'Y', 'S', 'E', 'L', '_', '3', '2', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_PAIR_YSEL_32_WIDE_TILE (73656) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'Y', 'S', 'E', 'L', '_', '6', '4', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_PAIR_YSEL_64_WIDE_TILE (73696) */
	'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'Y', 'S', 'E', 'L', '\0', /* SE_PAIR_YSEL (73736) */
	'N', 'U', 'M', '_', 'S', 'E', '\0', /* NUM_SE (73749) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'S', 'R', 'B', 'S', 'L', '_', 'D', 'B', '_', 'O', 'P', 'T', 'I', 'M', 'I', 'Z', 'E', 'D', '_', 'P', 'A', 'C', 'K', 'I', 'N', 'G', '\0', /* DISABLE_SRBSL_DB_OPTIMIZED_PACKING (73756) */
	'N', 'U', 'M', '_', 'S', 'C', '\0', /* NUM_SC (73791) */
	'N', 'U', 'M', '_', 'R', 'B', '_', 'P', 'E', 'R', '_', 'S', 'C', '\0', /* NUM_RB_PER_SC (73798) */
	'N', 'U', 'M', '_', 'P', 'A', 'C', 'K', 'E', 'R', '_', 'P', 'E', 'R', '_', 'S', 'C', '\0', /* NUM_PACKER_PER_SC (73812) */
	'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* PERFMON_ENABLE (73830) */
	'L', 'E', 'F', 'T', '_', 'Q', 'T', 'R', '\0', /* LEFT_QTR (73845) */
	'L', 'E', 'F', 'T', '_', 'H', 'A', 'L', 'F', '\0', /* LEFT_HALF (73854) */
	'R', 'I', 'G', 'H', 'T', '_', 'H', 'A', 'L', 'F', '\0', /* RIGHT_HALF (73864) */
	'R', 'I', 'G', 'H', 'T', '_', 'Q', 'T', 'R', '\0', /* RIGHT_QTR (73875) */
	'T', 'O', 'P', '_', 'Q', 'T', 'R', '\0', /* TOP_QTR (73885) */
	'T', 'O', 'P', '_', 'H', 'A', 'L', 'F', '\0', /* TOP_HALF (73893) */
	'B', 'O', 'T', '_', 'H', 'A', 'L', 'F', '\0', /* BOT_HALF (73902) */
	'B', 'O', 'T', '_', 'Q', 'T', 'R', '\0', /* BOT_QTR (73911) */
	'C', 'M', 'A', 'S', 'K', '_', 'W', 'R', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* CMASK_WR_POLICY (73919) */
	'F', 'M', 'A', 'S', 'K', '_', 'W', 'R', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* FMASK_WR_POLICY (73935) */
	'D', 'C', 'C', '_', 'W', 'R', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* DCC_WR_POLICY (73951) */
	'C', 'O', 'L', 'O', 'R', '_', 'W', 'R', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* COLOR_WR_POLICY (73965) */
	'C', 'M', 'A', 'S', 'K', '_', 'R', 'D', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* CMASK_RD_POLICY (73981) */
	'F', 'M', 'A', 'S', 'K', '_', 'R', 'D', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* FMASK_RD_POLICY (73997) */
	'D', 'C', 'C', '_', 'R', 'D', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* DCC_RD_POLICY (74013) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'D', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* COLOR_RD_POLICY (74027) */
	'F', 'M', 'A', 'S', 'K', '_', 'B', 'I', 'G', '_', 'P', 'A', 'G', 'E', '\0', /* FMASK_BIG_PAGE (74043) */
	'C', 'O', 'L', 'O', 'R', '_', 'B', 'I', 'G', '_', 'P', 'A', 'G', 'E', '\0', /* COLOR_BIG_PAGE (74058) */
	'O', 'V', 'E', 'R', 'W', 'R', 'I', 'T', 'E', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'E', 'R', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* OVERWRITE_COMBINER_DISABLE (74073) */
	'O', 'V', 'E', 'R', 'W', 'R', 'I', 'T', 'E', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'E', 'R', '_', 'W', 'A', 'T', 'E', 'R', 'M', 'A', 'R', 'K', '\0', /* OVERWRITE_COMBINER_WATERMARK (74100) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'C', 'O', 'N', 'S', 'T', 'A', 'N', 'T', '_', 'E', 'N', 'C', 'O', 'D', 'E', '_', 'A', 'C', '0', '1', '\0', /* DISABLE_CONSTANT_ENCODE_AC01 (74129) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'C', 'O', 'N', 'S', 'T', 'A', 'N', 'T', '_', 'E', 'N', 'C', 'O', 'D', 'E', '_', 'S', 'I', 'N', 'G', 'L', 'E', '\0', /* DISABLE_CONSTANT_ENCODE_SINGLE (74158) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'C', 'O', 'N', 'S', 'T', 'A', 'N', 'T', '_', 'E', 'N', 'C', 'O', 'D', 'E', '_', 'R', 'E', 'G', '\0', /* DISABLE_CONSTANT_ENCODE_REG (74189) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'E', 'L', 'I', 'M', 'F', 'C', '_', 'S', 'K', 'I', 'P', '_', 'O', 'F', '_', 'A', 'C', '0', '1', '\0', /* DISABLE_ELIMFC_SKIP_OF_AC01 (74217) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'E', 'L', 'I', 'M', 'F', 'C', '_', 'S', 'K', 'I', 'P', '_', 'O', 'F', '_', 'S', 'I', 'N', 'G', 'L', 'E', '\0', /* DISABLE_ELIMFC_SKIP_OF_SINGLE (74245) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'E', 'L', 'I', 'M', 'F', 'C', '_', 'S', 'K', 'I', 'P', '_', 'O', 'F', '_', 'R', 'E', 'G', '\0', /* ENABLE_ELIMFC_SKIP_OF_REG (74275) */
	'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'O', 'U', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* COVERAGE_OUT_ENABLE (74301) */
	'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'O', 'U', 'T', '_', 'M', 'R', 'T', '\0', /* COVERAGE_OUT_MRT (74321) */
	'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'O', 'U', 'T', '_', 'C', 'H', 'A', 'N', 'N', 'E', 'L', '\0', /* COVERAGE_OUT_CHANNEL (74338) */
	'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'O', 'U', 'T', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '\0', /* COVERAGE_OUT_SAMPLES (74359) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'K', 'E', 'E', 'P', '\0', /* STENCIL_KEEP (74380) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'Z', 'E', 'R', 'O', '\0', /* STENCIL_ZERO (74393) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'O', 'N', 'E', 'S', '\0', /* STENCIL_ONES (74406) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'R', 'E', 'P', 'L', 'A', 'C', 'E', '_', 'T', 'E', 'S', 'T', '\0', /* STENCIL_REPLACE_TEST (74419) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'R', 'E', 'P', 'L', 'A', 'C', 'E', '_', 'O', 'P', '\0', /* STENCIL_REPLACE_OP (74440) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'A', 'D', 'D', '_', 'C', 'L', 'A', 'M', 'P', '\0', /* STENCIL_ADD_CLAMP (74459) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'S', 'U', 'B', '_', 'C', 'L', 'A', 'M', 'P', '\0', /* STENCIL_SUB_CLAMP (74477) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'I', 'N', 'V', 'E', 'R', 'T', '\0', /* STENCIL_INVERT (74495) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'A', 'D', 'D', '_', 'W', 'R', 'A', 'P', '\0', /* STENCIL_ADD_WRAP (74510) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'S', 'U', 'B', '_', 'W', 'R', 'A', 'P', '\0', /* STENCIL_SUB_WRAP (74527) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'A', 'N', 'D', '\0', /* STENCIL_AND (74544) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'O', 'R', '\0', /* STENCIL_OR (74556) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'X', 'O', 'R', '\0', /* STENCIL_XOR (74567) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'N', 'A', 'N', 'D', '\0', /* STENCIL_NAND (74579) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'N', 'O', 'R', '\0', /* STENCIL_NOR (74592) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'X', 'N', 'O', 'R', '\0', /* STENCIL_XNOR (74604) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'F', 'A', 'I', 'L', '\0', /* STENCILFAIL (74617) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'Z', 'P', 'A', 'S', 'S', '\0', /* STENCILZPASS (74629) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'Z', 'F', 'A', 'I', 'L', '\0', /* STENCILZFAIL (74642) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'F', 'A', 'I', 'L', '_', 'B', 'F', '\0', /* STENCILFAIL_BF (74655) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'Z', 'P', 'A', 'S', 'S', '_', 'B', 'F', '\0', /* STENCILZPASS_BF (74670) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'Z', 'F', 'A', 'I', 'L', '_', 'B', 'F', '\0', /* STENCILZFAIL_BF (74686) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'T', 'E', 'S', 'T', 'V', 'A', 'L', '\0', /* STENCILTESTVAL (74702) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'M', 'A', 'S', 'K', '\0', /* STENCILMASK (74717) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'W', 'R', 'I', 'T', 'E', 'M', 'A', 'S', 'K', '\0', /* STENCILWRITEMASK (74729) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'O', 'P', 'V', 'A', 'L', '\0', /* STENCILOPVAL (74746) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'T', 'E', 'S', 'T', 'V', 'A', 'L', '_', 'B', 'F', '\0', /* STENCILTESTVAL_BF (74759) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'M', 'A', 'S', 'K', '_', 'B', 'F', '\0', /* STENCILMASK_BF (74777) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'W', 'R', 'I', 'T', 'E', 'M', 'A', 'S', 'K', '_', 'B', 'F', '\0', /* STENCILWRITEMASK_BF (74792) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'O', 'P', 'V', 'A', 'L', '_', 'B', 'F', '\0', /* STENCILOPVAL_BF (74812) */
	'D', 'E', 'F', 'A', 'U', 'L', 'T', '_', 'V', 'A', 'L', '\0', /* DEFAULT_VAL (74828) */
	'F', 'L', 'A', 'T', '_', 'S', 'H', 'A', 'D', 'E', '\0', /* FLAT_SHADE (74840) */
	'C', 'Y', 'L', '_', 'W', 'R', 'A', 'P', '\0', /* CYL_WRAP (74851) */
	'P', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'T', 'E', 'X', '\0', /* PT_SPRITE_TEX (74860) */
	'D', 'U', 'P', '\0', /* DUP (74874) */
	'F', 'P', '1', '6', '_', 'I', 'N', 'T', 'E', 'R', 'P', '_', 'M', 'O', 'D', 'E', '\0', /* FP16_INTERP_MODE (74878) */
	'U', 'S', 'E', '_', 'D', 'E', 'F', 'A', 'U', 'L', 'T', '_', 'A', 'T', 'T', 'R', '1', '\0', /* USE_DEFAULT_ATTR1 (74895) */
	'D', 'E', 'F', 'A', 'U', 'L', 'T', '_', 'V', 'A', 'L', '_', 'A', 'T', 'T', 'R', '1', '\0', /* DEFAULT_VAL_ATTR1 (74913) */
	'P', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'T', 'E', 'X', '_', 'A', 'T', 'T', 'R', '1', '\0', /* PT_SPRITE_TEX_ATTR1 (74931) */
	'A', 'T', 'T', 'R', '0', '_', 'V', 'A', 'L', 'I', 'D', '\0', /* ATTR0_VALID (74951) */
	'A', 'T', 'T', 'R', '1', '_', 'V', 'A', 'L', 'I', 'D', '\0', /* ATTR1_VALID (74963) */
	'V', 'S', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* VS_EXPORT_COUNT (74975) */
	'V', 'S', '_', 'H', 'A', 'L', 'F', '_', 'P', 'A', 'C', 'K', '\0', /* VS_HALF_PACK (74991) */
	'N', 'O', '_', 'P', 'C', '_', 'E', 'X', 'P', 'O', 'R', 'T', '\0', /* NO_PC_EXPORT (75004) */
	'P', 'E', 'R', 'S', 'P', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'E', 'N', 'A', '\0', /* PERSP_SAMPLE_ENA (75017) */
	'P', 'E', 'R', 'S', 'P', '_', 'C', 'E', 'N', 'T', 'E', 'R', '_', 'E', 'N', 'A', '\0', /* PERSP_CENTER_ENA (75034) */
	'P', 'E', 'R', 'S', 'P', '_', 'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '_', 'E', 'N', 'A', '\0', /* PERSP_CENTROID_ENA (75051) */
	'P', 'E', 'R', 'S', 'P', '_', 'P', 'U', 'L', 'L', '_', 'M', 'O', 'D', 'E', 'L', '_', 'E', 'N', 'A', '\0', /* PERSP_PULL_MODEL_ENA (75070) */
	'L', 'I', 'N', 'E', 'A', 'R', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'E', 'N', 'A', '\0', /* LINEAR_SAMPLE_ENA (75091) */
	'L', 'I', 'N', 'E', 'A', 'R', '_', 'C', 'E', 'N', 'T', 'E', 'R', '_', 'E', 'N', 'A', '\0', /* LINEAR_CENTER_ENA (75109) */
	'L', 'I', 'N', 'E', 'A', 'R', '_', 'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '_', 'E', 'N', 'A', '\0', /* LINEAR_CENTROID_ENA (75127) */
	'L', 'I', 'N', 'E', '_', 'S', 'T', 'I', 'P', 'P', 'L', 'E', '_', 'T', 'E', 'X', '_', 'E', 'N', 'A', '\0', /* LINE_STIPPLE_TEX_ENA (75147) */
	'P', 'O', 'S', '_', 'X', '_', 'F', 'L', 'O', 'A', 'T', '_', 'E', 'N', 'A', '\0', /* POS_X_FLOAT_ENA (75168) */
	'P', 'O', 'S', '_', 'Y', '_', 'F', 'L', 'O', 'A', 'T', '_', 'E', 'N', 'A', '\0', /* POS_Y_FLOAT_ENA (75184) */
	'P', 'O', 'S', '_', 'Z', '_', 'F', 'L', 'O', 'A', 'T', '_', 'E', 'N', 'A', '\0', /* POS_Z_FLOAT_ENA (75200) */
	'P', 'O', 'S', '_', 'W', '_', 'F', 'L', 'O', 'A', 'T', '_', 'E', 'N', 'A', '\0', /* POS_W_FLOAT_ENA (75216) */
	'F', 'R', 'O', 'N', 'T', '_', 'F', 'A', 'C', 'E', '_', 'E', 'N', 'A', '\0', /* FRONT_FACE_ENA (75232) */
	'A', 'N', 'C', 'I', 'L', 'L', 'A', 'R', 'Y', '_', 'E', 'N', 'A', '\0', /* ANCILLARY_ENA (75247) */
	'S', 'A', 'M', 'P', 'L', 'E', '_', 'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'E', 'N', 'A', '\0', /* SAMPLE_COVERAGE_ENA (75261) */
	'P', 'O', 'S', '_', 'F', 'I', 'X', 'E', 'D', '_', 'P', 'T', '_', 'E', 'N', 'A', '\0', /* POS_FIXED_PT_ENA (75281) */
	'F', 'L', 'A', 'T', '_', 'S', 'H', 'A', 'D', 'E', '_', 'E', 'N', 'A', '\0', /* FLAT_SHADE_ENA (75298) */
	'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'E', 'N', 'A', '\0', /* PNT_SPRITE_ENA (75313) */
	'S', 'P', 'I', '_', 'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'S', 'E', 'L', '_', '0', '\0', /* SPI_PNT_SPRITE_SEL_0 (75328) */
	'S', 'P', 'I', '_', 'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'S', 'E', 'L', '_', '1', '\0', /* SPI_PNT_SPRITE_SEL_1 (75349) */
	'S', 'P', 'I', '_', 'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'S', 'E', 'L', '_', 'S', '\0', /* SPI_PNT_SPRITE_SEL_S (75370) */
	'S', 'P', 'I', '_', 'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'S', 'E', 'L', '_', 'T', '\0', /* SPI_PNT_SPRITE_SEL_T (75391) */
	'S', 'P', 'I', '_', 'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'S', 'E', 'L', '_', 'N', 'O', 'N', 'E', '\0', /* SPI_PNT_SPRITE_SEL_NONE (75412, 75431) */
	'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'O', 'V', 'R', 'D', '_', 'X', '\0', /* PNT_SPRITE_OVRD_X (75436) */
	'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'O', 'V', 'R', 'D', '_', 'Y', '\0', /* PNT_SPRITE_OVRD_Y (75454) */
	'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'O', 'V', 'R', 'D', '_', 'Z', '\0', /* PNT_SPRITE_OVRD_Z (75472) */
	'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'O', 'V', 'R', 'D', '_', 'W', '\0', /* PNT_SPRITE_OVRD_W (75490) */
	'P', 'N', 'T', '_', 'S', 'P', 'R', 'I', 'T', 'E', '_', 'T', 'O', 'P', '_', '1', '\0', /* PNT_SPRITE_TOP_1 (75508) */
	'N', 'U', 'M', '_', 'I', 'N', 'T', 'E', 'R', 'P', '\0', /* NUM_INTERP (75525) */
	'P', 'A', 'R', 'A', 'M', '_', 'G', 'E', 'N', '\0', /* PARAM_GEN (75536) */
	'O', 'F', 'F', 'C', 'H', 'I', 'P', '_', 'P', 'A', 'R', 'A', 'M', '_', 'E', 'N', '\0', /* OFFCHIP_PARAM_EN (75546) */
	'L', 'A', 'T', 'E', '_', 'P', 'C', '_', 'D', 'E', 'A', 'L', 'L', 'O', 'C', '\0', /* LATE_PC_DEALLOC (75563) */
	'B', 'C', '_', 'O', 'P', 'T', 'I', 'M', 'I', 'Z', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* BC_OPTIMIZE_DISABLE (75579) */
	'P', 'S', '_', 'W', '3', '2', '_', 'E', 'N', '\0', /* PS_W32_EN (75599) */
	'P', 'E', 'R', 'S', 'P', '_', 'C', 'E', 'N', 'T', 'E', 'R', '_', 'C', 'N', 'T', 'L', '\0', /* PERSP_CENTER_CNTL (75609) */
	'P', 'E', 'R', 'S', 'P', '_', 'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '_', 'C', 'N', 'T', 'L', '\0', /* PERSP_CENTROID_CNTL (75627) */
	'L', 'I', 'N', 'E', 'A', 'R', '_', 'C', 'E', 'N', 'T', 'E', 'R', '_', 'C', 'N', 'T', 'L', '\0', /* LINEAR_CENTER_CNTL (75647) */
	'L', 'I', 'N', 'E', 'A', 'R', '_', 'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '_', 'C', 'N', 'T', 'L', '\0', /* LINEAR_CENTROID_CNTL (75666) */
	'P', 'O', 'S', '_', 'F', 'L', 'O', 'A', 'T', '_', 'L', 'O', 'C', 'A', 'T', 'I', 'O', 'N', '\0', /* POS_FLOAT_LOCATION (75687) */
	'P', 'O', 'S', '_', 'F', 'L', 'O', 'A', 'T', '_', 'U', 'L', 'C', '\0', /* POS_FLOAT_ULC (75706) */
	'F', 'R', 'O', 'N', 'T', '_', 'F', 'A', 'C', 'E', '_', 'A', 'L', 'L', '_', 'B', 'I', 'T', 'S', '\0', /* FRONT_FACE_ALL_BITS (75720) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'N', 'O', 'N', 'E', '\0', /* SPI_SHADER_NONE (75740) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', '1', 'C', 'O', 'M', 'P', '\0', /* SPI_SHADER_1COMP (75756) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', '2', 'C', 'O', 'M', 'P', '\0', /* SPI_SHADER_2COMP (75773) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', '4', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '\0', /* SPI_SHADER_4COMPRESS (75790) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', '4', 'C', 'O', 'M', 'P', '\0', /* SPI_SHADER_4COMP (75811) */
	'I', 'D', 'X', '0', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* IDX0_EXPORT_FORMAT (75828) */
	'P', 'O', 'S', '0', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* POS0_EXPORT_FORMAT (75847) */
	'P', 'O', 'S', '1', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* POS1_EXPORT_FORMAT (75866) */
	'P', 'O', 'S', '2', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* POS2_EXPORT_FORMAT (75885) */
	'P', 'O', 'S', '3', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* POS3_EXPORT_FORMAT (75904) */
	'P', 'O', 'S', '4', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* POS4_EXPORT_FORMAT (75923) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'Z', 'E', 'R', 'O', '\0', /* SPI_SHADER_ZERO (75942) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', '3', '2', '_', 'R', '\0', /* SPI_SHADER_32_R (75958) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', '3', '2', '_', 'G', 'R', '\0', /* SPI_SHADER_32_GR (75974) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', '3', '2', '_', 'A', 'R', '\0', /* SPI_SHADER_32_AR (75991) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'F', 'P', '1', '6', '_', 'A', 'B', 'G', 'R', '\0', /* SPI_SHADER_FP16_ABGR (76008) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'N', 'O', 'R', 'M', '1', '6', '_', 'A', 'B', 'G', 'R', '\0', /* SPI_SHADER_UNORM16_ABGR (76029) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'S', 'N', 'O', 'R', 'M', '1', '6', '_', 'A', 'B', 'G', 'R', '\0', /* SPI_SHADER_SNORM16_ABGR (76053) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'U', 'I', 'N', 'T', '1', '6', '_', 'A', 'B', 'G', 'R', '\0', /* SPI_SHADER_UINT16_ABGR (76077) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'S', 'I', 'N', 'T', '1', '6', '_', 'A', 'B', 'G', 'R', '\0', /* SPI_SHADER_SINT16_ABGR (76100) */
	'S', 'P', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', '3', '2', '_', 'A', 'B', 'G', 'R', '\0', /* SPI_SHADER_32_ABGR (76123) */
	'Z', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* Z_EXPORT_FORMAT (76142) */
	'C', 'O', 'L', '0', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* COL0_EXPORT_FORMAT (76158) */
	'C', 'O', 'L', '1', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* COL1_EXPORT_FORMAT (76177) */
	'C', 'O', 'L', '2', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* COL2_EXPORT_FORMAT (76196) */
	'C', 'O', 'L', '3', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* COL3_EXPORT_FORMAT (76215) */
	'C', 'O', 'L', '4', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* COL4_EXPORT_FORMAT (76234) */
	'C', 'O', 'L', '5', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* COL5_EXPORT_FORMAT (76253) */
	'C', 'O', 'L', '6', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* COL6_EXPORT_FORMAT (76272) */
	'C', 'O', 'L', '7', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* COL7_EXPORT_FORMAT (76291) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'N', 'O', '_', 'C', 'O', 'N', 'V', 'E', 'R', 'S', 'I', 'O', 'N', '\0', /* SX_RT_EXPORT_NO_CONVERSION (76310) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '3', '2', '_', 'R', '\0', /* SX_RT_EXPORT_32_R (76337) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '3', '2', '_', 'A', '\0', /* SX_RT_EXPORT_32_A (76355) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '1', '0', '_', '1', '1', '_', '1', '1', '\0', /* SX_RT_EXPORT_10_11_11 (76373) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '\0', /* SX_RT_EXPORT_2_10_10_10 (76395) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '8', '_', '8', '_', '8', '_', '8', '\0', /* SX_RT_EXPORT_8_8_8_8 (76419) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '5', '_', '6', '_', '5', '\0', /* SX_RT_EXPORT_5_6_5 (76440) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '1', '_', '5', '_', '5', '_', '5', '\0', /* SX_RT_EXPORT_1_5_5_5 (76459) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '4', '_', '4', '_', '4', '_', '4', '\0', /* SX_RT_EXPORT_4_4_4_4 (76480) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '1', '6', '_', '1', '6', '_', 'G', 'R', '\0', /* SX_RT_EXPORT_16_16_GR (76501) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '1', '6', '_', '1', '6', '_', 'A', 'R', '\0', /* SX_RT_EXPORT_16_16_AR (76523) */
	'M', 'R', 'T', '0', '\0', /* MRT0 (76545) */
	'M', 'R', 'T', '1', '\0', /* MRT1 (76550) */
	'M', 'R', 'T', '2', '\0', /* MRT2 (76555) */
	'M', 'R', 'T', '3', '\0', /* MRT3 (76560) */
	'M', 'R', 'T', '4', '\0', /* MRT4 (76565) */
	'M', 'R', 'T', '5', '\0', /* MRT5 (76570) */
	'M', 'R', 'T', '6', '\0', /* MRT6 (76575) */
	'M', 'R', 'T', '7', '\0', /* MRT7 (76580) */
	'1', '1', 'B', 'I', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* 11BIT_FORMAT (76585) */
	'1', '0', 'B', 'I', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* 10BIT_FORMAT (76598) */
	'8', 'B', 'I', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* 8BIT_FORMAT (76611) */
	'6', 'B', 'I', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* 6BIT_FORMAT (76623) */
	'5', 'B', 'I', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* 5BIT_FORMAT (76635) */
	'4', 'B', 'I', 'T', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* 4BIT_FORMAT (76647) */
	'M', 'R', 'T', '0', '_', 'E', 'P', 'S', 'I', 'L', 'O', 'N', '\0', /* MRT0_EPSILON (76659) */
	'M', 'R', 'T', '1', '_', 'E', 'P', 'S', 'I', 'L', 'O', 'N', '\0', /* MRT1_EPSILON (76672) */
	'M', 'R', 'T', '2', '_', 'E', 'P', 'S', 'I', 'L', 'O', 'N', '\0', /* MRT2_EPSILON (76685) */
	'M', 'R', 'T', '3', '_', 'E', 'P', 'S', 'I', 'L', 'O', 'N', '\0', /* MRT3_EPSILON (76698) */
	'M', 'R', 'T', '4', '_', 'E', 'P', 'S', 'I', 'L', 'O', 'N', '\0', /* MRT4_EPSILON (76711) */
	'M', 'R', 'T', '5', '_', 'E', 'P', 'S', 'I', 'L', 'O', 'N', '\0', /* MRT5_EPSILON (76724) */
	'M', 'R', 'T', '6', '_', 'E', 'P', 'S', 'I', 'L', 'O', 'N', '\0', /* MRT6_EPSILON (76737) */
	'M', 'R', 'T', '7', '_', 'E', 'P', 'S', 'I', 'L', 'O', 'N', '\0', /* MRT7_EPSILON (76750) */
	'M', 'R', 'T', '0', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT0_COLOR_OPT_DISABLE (76763) */
	'M', 'R', 'T', '0', '_', 'A', 'L', 'P', 'H', 'A', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT0_ALPHA_OPT_DISABLE (76786) */
	'M', 'R', 'T', '1', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT1_COLOR_OPT_DISABLE (76809) */
	'M', 'R', 'T', '1', '_', 'A', 'L', 'P', 'H', 'A', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT1_ALPHA_OPT_DISABLE (76832) */
	'M', 'R', 'T', '2', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT2_COLOR_OPT_DISABLE (76855) */
	'M', 'R', 'T', '2', '_', 'A', 'L', 'P', 'H', 'A', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT2_ALPHA_OPT_DISABLE (76878) */
	'M', 'R', 'T', '3', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT3_COLOR_OPT_DISABLE (76901) */
	'M', 'R', 'T', '3', '_', 'A', 'L', 'P', 'H', 'A', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT3_ALPHA_OPT_DISABLE (76924) */
	'M', 'R', 'T', '4', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT4_COLOR_OPT_DISABLE (76947) */
	'M', 'R', 'T', '4', '_', 'A', 'L', 'P', 'H', 'A', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT4_ALPHA_OPT_DISABLE (76970) */
	'M', 'R', 'T', '5', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT5_COLOR_OPT_DISABLE (76993) */
	'M', 'R', 'T', '5', '_', 'A', 'L', 'P', 'H', 'A', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT5_ALPHA_OPT_DISABLE (77016) */
	'M', 'R', 'T', '6', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT6_COLOR_OPT_DISABLE (77039) */
	'M', 'R', 'T', '6', '_', 'A', 'L', 'P', 'H', 'A', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT6_ALPHA_OPT_DISABLE (77062) */
	'M', 'R', 'T', '7', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT7_COLOR_OPT_DISABLE (77085) */
	'M', 'R', 'T', '7', '_', 'A', 'L', 'P', 'H', 'A', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT7_ALPHA_OPT_DISABLE (77108) */
	'P', 'I', 'X', 'E', 'N', '_', 'Z', 'E', 'R', 'O', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* PIXEN_ZERO_OPT_DISABLE (77131) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'N', 'O', 'N', 'E', '_', 'I', 'G', 'N', 'O', 'R', 'E', '_', 'A', 'L', 'L', '\0', /* BLEND_OPT_PRESERVE_NONE_IGNORE_ALL (77154) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'A', 'L', 'L', '_', 'I', 'G', 'N', 'O', 'R', 'E', '_', 'N', 'O', 'N', 'E', '\0', /* BLEND_OPT_PRESERVE_ALL_IGNORE_NONE (77189) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'C', '1', '_', 'I', 'G', 'N', 'O', 'R', 'E', '_', 'C', '0', '\0', /* BLEND_OPT_PRESERVE_C1_IGNORE_C0 (77224) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'C', '0', '_', 'I', 'G', 'N', 'O', 'R', 'E', '_', 'C', '1', '\0', /* BLEND_OPT_PRESERVE_C0_IGNORE_C1 (77256) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'A', '1', '_', 'I', 'G', 'N', 'O', 'R', 'E', '_', 'A', '0', '\0', /* BLEND_OPT_PRESERVE_A1_IGNORE_A0 (77288) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'A', '0', '_', 'I', 'G', 'N', 'O', 'R', 'E', '_', 'A', '1', '\0', /* BLEND_OPT_PRESERVE_A0_IGNORE_A1 (77320) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'N', 'O', 'N', 'E', '_', 'I', 'G', 'N', 'O', 'R', 'E', '_', 'A', '0', '\0', /* BLEND_OPT_PRESERVE_NONE_IGNORE_A0 (77352) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'P', 'R', 'E', 'S', 'E', 'R', 'V', 'E', '_', 'N', 'O', 'N', 'E', '_', 'I', 'G', 'N', 'O', 'R', 'E', '_', 'N', 'O', 'N', 'E', '\0', /* BLEND_OPT_PRESERVE_NONE_IGNORE_NONE (77386) */
	'C', 'O', 'L', 'O', 'R', '_', 'S', 'R', 'C', '_', 'O', 'P', 'T', '\0', /* COLOR_SRC_OPT (77422) */
	'C', 'O', 'L', 'O', 'R', '_', 'D', 'S', 'T', '_', 'O', 'P', 'T', '\0', /* COLOR_DST_OPT (77436) */
	'O', 'P', 'T', '_', 'C', 'O', 'M', 'B', '_', 'N', 'O', 'N', 'E', '\0', /* OPT_COMB_NONE (77450) */
	'O', 'P', 'T', '_', 'C', 'O', 'M', 'B', '_', 'A', 'D', 'D', '\0', /* OPT_COMB_ADD (77464) */
	'O', 'P', 'T', '_', 'C', 'O', 'M', 'B', '_', 'S', 'U', 'B', 'T', 'R', 'A', 'C', 'T', '\0', /* OPT_COMB_SUBTRACT (77477) */
	'O', 'P', 'T', '_', 'C', 'O', 'M', 'B', '_', 'M', 'I', 'N', '\0', /* OPT_COMB_MIN (77495) */
	'O', 'P', 'T', '_', 'C', 'O', 'M', 'B', '_', 'M', 'A', 'X', '\0', /* OPT_COMB_MAX (77508) */
	'O', 'P', 'T', '_', 'C', 'O', 'M', 'B', '_', 'R', 'E', 'V', 'S', 'U', 'B', 'T', 'R', 'A', 'C', 'T', '\0', /* OPT_COMB_REVSUBTRACT (77521) */
	'O', 'P', 'T', '_', 'C', 'O', 'M', 'B', '_', 'B', 'L', 'E', 'N', 'D', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', 'D', '\0', /* OPT_COMB_BLEND_DISABLED (77542) */
	'O', 'P', 'T', '_', 'C', 'O', 'M', 'B', '_', 'S', 'A', 'F', 'E', '_', 'A', 'D', 'D', '\0', /* OPT_COMB_SAFE_ADD (77566) */
	'C', 'O', 'L', 'O', 'R', '_', 'C', 'O', 'M', 'B', '_', 'F', 'C', 'N', '\0', /* COLOR_COMB_FCN (77584) */
	'A', 'L', 'P', 'H', 'A', '_', 'S', 'R', 'C', '_', 'O', 'P', 'T', '\0', /* ALPHA_SRC_OPT (77599) */
	'A', 'L', 'P', 'H', 'A', '_', 'D', 'S', 'T', '_', 'O', 'P', 'T', '\0', /* ALPHA_DST_OPT (77613) */
	'A', 'L', 'P', 'H', 'A', '_', 'C', 'O', 'M', 'B', '_', 'F', 'C', 'N', '\0', /* ALPHA_COMB_FCN (77627) */
	'B', 'L', 'E', 'N', 'D', '_', 'Z', 'E', 'R', 'O', '\0', /* BLEND_ZERO (77642) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'N', 'E', '\0', /* BLEND_ONE (77653) */
	'B', 'L', 'E', 'N', 'D', '_', 'S', 'R', 'C', '_', 'C', 'O', 'L', 'O', 'R', '\0', /* BLEND_SRC_COLOR (77663) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'N', 'E', '_', 'M', 'I', 'N', 'U', 'S', '_', 'S', 'R', 'C', '_', 'C', 'O', 'L', 'O', 'R', '\0', /* BLEND_ONE_MINUS_SRC_COLOR (77679) */
	'B', 'L', 'E', 'N', 'D', '_', 'S', 'R', 'C', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* BLEND_SRC_ALPHA (77705) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'N', 'E', '_', 'M', 'I', 'N', 'U', 'S', '_', 'S', 'R', 'C', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* BLEND_ONE_MINUS_SRC_ALPHA (77721) */
	'B', 'L', 'E', 'N', 'D', '_', 'D', 'S', 'T', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* BLEND_DST_ALPHA (77747) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'N', 'E', '_', 'M', 'I', 'N', 'U', 'S', '_', 'D', 'S', 'T', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* BLEND_ONE_MINUS_DST_ALPHA (77763) */
	'B', 'L', 'E', 'N', 'D', '_', 'D', 'S', 'T', '_', 'C', 'O', 'L', 'O', 'R', '\0', /* BLEND_DST_COLOR (77789) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'N', 'E', '_', 'M', 'I', 'N', 'U', 'S', '_', 'D', 'S', 'T', '_', 'C', 'O', 'L', 'O', 'R', '\0', /* BLEND_ONE_MINUS_DST_COLOR (77805) */
	'B', 'L', 'E', 'N', 'D', '_', 'S', 'R', 'C', '_', 'A', 'L', 'P', 'H', 'A', '_', 'S', 'A', 'T', 'U', 'R', 'A', 'T', 'E', '\0', /* BLEND_SRC_ALPHA_SATURATE (77831) */
	'B', 'L', 'E', 'N', 'D', '_', 'B', 'O', 'T', 'H', '_', 'S', 'R', 'C', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* BLEND_BOTH_SRC_ALPHA (77856) */
	'B', 'L', 'E', 'N', 'D', '_', 'B', 'O', 'T', 'H', '_', 'I', 'N', 'V', '_', 'S', 'R', 'C', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* BLEND_BOTH_INV_SRC_ALPHA (77877) */
	'B', 'L', 'E', 'N', 'D', '_', 'C', 'O', 'N', 'S', 'T', 'A', 'N', 'T', '_', 'C', 'O', 'L', 'O', 'R', '\0', /* BLEND_CONSTANT_COLOR (77902) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'N', 'E', '_', 'M', 'I', 'N', 'U', 'S', '_', 'C', 'O', 'N', 'S', 'T', 'A', 'N', 'T', '_', 'C', 'O', 'L', 'O', 'R', '\0', /* BLEND_ONE_MINUS_CONSTANT_COLOR (77923) */
	'B', 'L', 'E', 'N', 'D', '_', 'S', 'R', 'C', '1', '_', 'C', 'O', 'L', 'O', 'R', '\0', /* BLEND_SRC1_COLOR (77954) */
	'B', 'L', 'E', 'N', 'D', '_', 'I', 'N', 'V', '_', 'S', 'R', 'C', '1', '_', 'C', 'O', 'L', 'O', 'R', '\0', /* BLEND_INV_SRC1_COLOR (77971) */
	'B', 'L', 'E', 'N', 'D', '_', 'S', 'R', 'C', '1', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* BLEND_SRC1_ALPHA (77992) */
	'B', 'L', 'E', 'N', 'D', '_', 'I', 'N', 'V', '_', 'S', 'R', 'C', '1', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* BLEND_INV_SRC1_ALPHA (78009) */
	'B', 'L', 'E', 'N', 'D', '_', 'C', 'O', 'N', 'S', 'T', 'A', 'N', 'T', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* BLEND_CONSTANT_ALPHA (78030) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'N', 'E', '_', 'M', 'I', 'N', 'U', 'S', '_', 'C', 'O', 'N', 'S', 'T', 'A', 'N', 'T', '_', 'A', 'L', 'P', 'H', 'A', '\0', /* BLEND_ONE_MINUS_CONSTANT_ALPHA (78051) */
	'C', 'O', 'L', 'O', 'R', '_', 'S', 'R', 'C', 'B', 'L', 'E', 'N', 'D', '\0', /* COLOR_SRCBLEND (78082) */
	'C', 'O', 'M', 'B', '_', 'D', 'S', 'T', '_', 'P', 'L', 'U', 'S', '_', 'S', 'R', 'C', '\0', /* COMB_DST_PLUS_SRC (78097) */
	'C', 'O', 'M', 'B', '_', 'S', 'R', 'C', '_', 'M', 'I', 'N', 'U', 'S', '_', 'D', 'S', 'T', '\0', /* COMB_SRC_MINUS_DST (78115) */
	'C', 'O', 'M', 'B', '_', 'M', 'I', 'N', '_', 'D', 'S', 'T', '_', 'S', 'R', 'C', '\0', /* COMB_MIN_DST_SRC (78134) */
	'C', 'O', 'M', 'B', '_', 'M', 'A', 'X', '_', 'D', 'S', 'T', '_', 'S', 'R', 'C', '\0', /* COMB_MAX_DST_SRC (78151) */
	'C', 'O', 'M', 'B', '_', 'D', 'S', 'T', '_', 'M', 'I', 'N', 'U', 'S', '_', 'S', 'R', 'C', '\0', /* COMB_DST_MINUS_SRC (78168) */
	'C', 'O', 'L', 'O', 'R', '_', 'D', 'E', 'S', 'T', 'B', 'L', 'E', 'N', 'D', '\0', /* COLOR_DESTBLEND (78187) */
	'A', 'L', 'P', 'H', 'A', '_', 'S', 'R', 'C', 'B', 'L', 'E', 'N', 'D', '\0', /* ALPHA_SRCBLEND (78203) */
	'A', 'L', 'P', 'H', 'A', '_', 'D', 'E', 'S', 'T', 'B', 'L', 'E', 'N', 'D', '\0', /* ALPHA_DESTBLEND (78218) */
	'S', 'E', 'P', 'A', 'R', 'A', 'T', 'E', '_', 'A', 'L', 'P', 'H', 'A', '_', 'B', 'L', 'E', 'N', 'D', '\0', /* SEPARATE_ALPHA_BLEND (78234) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'R', 'O', 'P', '3', '\0', /* DISABLE_ROP3 (78255, 78263) */
	'S', 'R', 'C', '_', 'S', 'T', 'A', 'T', 'E', '_', 'I', 'D', '\0', /* SRC_STATE_ID (78268) */
	'D', 'I', '_', 'S', 'R', 'C', '_', 'S', 'E', 'L', '_', 'D', 'M', 'A', '\0', /* DI_SRC_SEL_DMA (78281) */
	'D', 'I', '_', 'S', 'R', 'C', '_', 'S', 'E', 'L', '_', 'I', 'M', 'M', 'E', 'D', 'I', 'A', 'T', 'E', '\0', /* DI_SRC_SEL_IMMEDIATE (78296) */
	'D', 'I', '_', 'S', 'R', 'C', '_', 'S', 'E', 'L', '_', 'A', 'U', 'T', 'O', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* DI_SRC_SEL_AUTO_INDEX (78317) */
	'D', 'I', '_', 'S', 'R', 'C', '_', 'S', 'E', 'L', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '\0', /* DI_SRC_SEL_RESERVED (78339) */
	'S', 'O', 'U', 'R', 'C', 'E', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SOURCE_SELECT (78359) */
	'D', 'I', '_', 'M', 'A', 'J', 'O', 'R', '_', 'M', 'O', 'D', 'E', '_', '0', '\0', /* DI_MAJOR_MODE_0 (78373) */
	'D', 'I', '_', 'M', 'A', 'J', 'O', 'R', '_', 'M', 'O', 'D', 'E', '_', '1', '\0', /* DI_MAJOR_MODE_1 (78389) */
	'M', 'A', 'J', 'O', 'R', '_', 'M', 'O', 'D', 'E', '\0', /* MAJOR_MODE (78405) */
	'S', 'P', 'R', 'I', 'T', 'E', '_', 'E', 'N', '_', 'R', '6', 'X', 'X', '\0', /* SPRITE_EN_R6XX (78416) */
	'N', 'O', 'T', '_', 'E', 'O', 'P', '\0', /* NOT_EOP (78431) */
	'U', 'S', 'E', '_', 'O', 'P', 'A', 'Q', 'U', 'E', '\0', /* USE_OPAQUE (78439) */
	'U', 'N', 'R', 'O', 'L', 'L', 'E', 'D', '_', 'I', 'N', 'S', 'T', '\0', /* UNROLLED_INST (78450) */
	'G', 'R', 'B', 'M', '_', 'S', 'K', 'E', 'W', '_', 'N', 'O', '_', 'D', 'E', 'C', '\0', /* GRBM_SKEW_NO_DEC (78464) */
	'R', 'E', 'G', '_', 'R', 'T', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* REG_RT_INDEX (78481) */
	'A', 'D', 'D', 'R', 'E', 'S', 'S', '_', 'L', 'O', 'W', '\0', /* ADDRESS_LOW (78494) */
	'M', 'A', 'X', '_', 'V', 'E', 'R', 'T', 'S', '_', 'P', 'E', 'R', '_', 'S', 'U', 'B', 'G', 'R', 'O', 'U', 'P', '\0', /* MAX_VERTS_PER_SUBGROUP (78506) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* STENCIL_ENABLE (78529) */
	'Z', '_', 'W', 'R', 'I', 'T', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* Z_WRITE_ENABLE (78544) */
	'D', 'E', 'P', 'T', 'H', '_', 'B', 'O', 'U', 'N', 'D', 'S', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* DEPTH_BOUNDS_ENABLE (78559) */
	'B', 'A', 'C', 'K', 'F', 'A', 'C', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* BACKFACE_ENABLE (78579) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'F', 'U', 'N', 'C', '\0', /* STENCILFUNC (78595) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', 'F', 'U', 'N', 'C', '_', 'B', 'F', '\0', /* STENCILFUNC_BF (78607) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'C', 'O', 'L', 'O', 'R', '_', 'W', 'R', 'I', 'T', 'E', 'S', '_', 'O', 'N', '_', 'D', 'E', 'P', 'T', 'H', '_', 'F', 'A', 'I', 'L', '\0', /* ENABLE_COLOR_WRITES_ON_DEPTH_FAIL (78622) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'C', 'O', 'L', 'O', 'R', '_', 'W', 'R', 'I', 'T', 'E', 'S', '_', 'O', 'N', '_', 'D', 'E', 'P', 'T', 'H', '_', 'P', 'A', 'S', 'S', '\0', /* DISABLE_COLOR_WRITES_ON_DEPTH_PASS (78656) */
	'M', 'A', 'X', '_', 'A', 'N', 'C', 'H', 'O', 'R', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '\0', /* MAX_ANCHOR_SAMPLES (78691) */
	'P', 'S', '_', 'I', 'T', 'E', 'R', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '\0', /* PS_ITER_SAMPLES (78710) */
	'M', 'A', 'S', 'K', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'N', 'U', 'M', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '\0', /* MASK_EXPORT_NUM_SAMPLES (78726) */
	'A', 'L', 'P', 'H', 'A', '_', 'T', 'O', '_', 'M', 'A', 'S', 'K', '_', 'N', 'U', 'M', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '\0', /* ALPHA_TO_MASK_NUM_SAMPLES (78750) */
	'H', 'I', 'G', 'H', '_', 'Q', 'U', 'A', 'L', 'I', 'T', 'Y', '_', 'I', 'N', 'T', 'E', 'R', 'S', 'E', 'C', 'T', 'I', 'O', 'N', 'S', '\0', /* HIGH_QUALITY_INTERSECTIONS (78776) */
	'I', 'N', 'C', 'O', 'H', 'E', 'R', 'E', 'N', 'T', '_', 'E', 'Q', 'A', 'A', '_', 'R', 'E', 'A', 'D', 'S', '\0', /* INCOHERENT_EQAA_READS (78803) */
	'I', 'N', 'T', 'E', 'R', 'P', 'O', 'L', 'A', 'T', 'E', '_', 'C', 'O', 'M', 'P', '_', 'Z', '\0', /* INTERPOLATE_COMP_Z (78825) */
	'I', 'N', 'T', 'E', 'R', 'P', 'O', 'L', 'A', 'T', 'E', '_', 'S', 'R', 'C', '_', 'Z', '\0', /* INTERPOLATE_SRC_Z (78844) */
	'S', 'T', 'A', 'T', 'I', 'C', '_', 'A', 'N', 'C', 'H', 'O', 'R', '_', 'A', 'S', 'S', 'O', 'C', 'I', 'A', 'T', 'I', 'O', 'N', 'S', '\0', /* STATIC_ANCHOR_ASSOCIATIONS (78862) */
	'A', 'L', 'P', 'H', 'A', '_', 'T', 'O', '_', 'M', 'A', 'S', 'K', '_', 'E', 'Q', 'A', 'A', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* ALPHA_TO_MASK_EQAA_DISABLE (78889) */
	'O', 'V', 'E', 'R', 'R', 'A', 'S', 'T', 'E', 'R', 'I', 'Z', 'A', 'T', 'I', 'O', 'N', '_', 'A', 'M', 'O', 'U', 'N', 'T', '\0', /* OVERRASTERIZATION_AMOUNT (78916) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'P', 'O', 'S', 'T', 'Z', '_', 'O', 'V', 'E', 'R', 'R', 'A', 'S', 'T', 'E', 'R', 'I', 'Z', 'A', 'T', 'I', 'O', 'N', '\0', /* ENABLE_POSTZ_OVERRASTERIZATION (78941) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'D', 'U', 'A', 'L', '_', 'Q', 'U', 'A', 'D', '\0', /* DISABLE_DUAL_QUAD (78972) */
	'D', 'E', 'G', 'A', 'M', 'M', 'A', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* DEGAMMA_ENABLE (78990) */
	'C', 'B', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* CB_DISABLE (79005) */
	'C', 'B', '_', 'N', 'O', 'R', 'M', 'A', 'L', '\0', /* CB_NORMAL (79016) */
	'C', 'B', '_', 'E', 'L', 'I', 'M', 'I', 'N', 'A', 'T', 'E', '_', 'F', 'A', 'S', 'T', '_', 'C', 'L', 'E', 'A', 'R', '\0', /* CB_ELIMINATE_FAST_CLEAR (79026, 79039) */
	'C', 'B', '_', 'R', 'E', 'S', 'O', 'L', 'V', 'E', '\0', /* CB_RESOLVE (79050) */
	'C', 'B', '_', 'D', 'E', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '\0', /* CB_DECOMPRESS (79061) */
	'C', 'B', '_', 'F', 'M', 'A', 'S', 'K', '_', 'D', 'E', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '\0', /* CB_FMASK_DECOMPRESS (79075) */
	'C', 'B', '_', 'D', 'C', 'C', '_', 'D', 'E', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '\0', /* CB_DCC_DECOMPRESS (79095) */
	'C', 'B', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '\0', /* CB_RESERVED (79113) */
	'R', 'O', 'P', '3', '_', 'C', 'L', 'E', 'A', 'R', '\0', /* ROP3_CLEAR (79125) */
	'X', '_', '0', 'X', '0', '5', '\0', /* X_0X05 (79136) */
	'X', '_', '0', 'X', '0', 'A', '\0', /* X_0X0A (79143) */
	'X', '_', '0', 'X', '0', 'F', '\0', /* X_0X0F (79150) */
	'R', 'O', 'P', '3', '_', 'N', 'O', 'R', '\0', /* ROP3_NOR (79157) */
	'R', 'O', 'P', '3', '_', 'A', 'N', 'D', '_', 'I', 'N', 'V', 'E', 'R', 'T', 'E', 'D', '\0', /* ROP3_AND_INVERTED (79166) */
	'R', 'O', 'P', '3', '_', 'C', 'O', 'P', 'Y', '_', 'I', 'N', 'V', 'E', 'R', 'T', 'E', 'D', '\0', /* ROP3_COPY_INVERTED (79184) */
	'R', 'O', 'P', '3', '_', 'A', 'N', 'D', '_', 'R', 'E', 'V', 'E', 'R', 'S', 'E', '\0', /* ROP3_AND_REVERSE (79203) */
	'X', '_', '0', 'X', '5', '0', '\0', /* X_0X50 (79220) */
	'R', 'O', 'P', '3', '_', 'I', 'N', 'V', 'E', 'R', 'T', '\0', /* ROP3_INVERT (79227) */
	'X', '_', '0', 'X', '5', 'A', '\0', /* X_0X5A (79239) */
	'X', '_', '0', 'X', '5', 'F', '\0', /* X_0X5F (79246) */
	'R', 'O', 'P', '3', '_', 'X', 'O', 'R', '\0', /* ROP3_XOR (79253) */
	'R', 'O', 'P', '3', '_', 'N', 'A', 'N', 'D', '\0', /* ROP3_NAND (79262) */
	'R', 'O', 'P', '3', '_', 'A', 'N', 'D', '\0', /* ROP3_AND (79272) */
	'R', 'O', 'P', '3', '_', 'E', 'Q', 'U', 'I', 'V', 'A', 'L', 'E', 'N', 'T', '\0', /* ROP3_EQUIVALENT (79281) */
	'X', '_', '0', 'X', 'A', '0', '\0', /* X_0XA0 (79297) */
	'X', '_', '0', 'X', 'A', '5', '\0', /* X_0XA5 (79304) */
	'R', 'O', 'P', '3', '_', 'N', 'O', '_', 'O', 'P', '\0', /* ROP3_NO_OP (79311) */
	'X', '_', '0', 'X', 'A', 'F', '\0', /* X_0XAF (79322) */
	'R', 'O', 'P', '3', '_', 'O', 'R', '_', 'I', 'N', 'V', 'E', 'R', 'T', 'E', 'D', '\0', /* ROP3_OR_INVERTED (79329) */
	'R', 'O', 'P', '3', '_', 'C', 'O', 'P', 'Y', '\0', /* ROP3_COPY (79346) */
	'R', 'O', 'P', '3', '_', 'O', 'R', '_', 'R', 'E', 'V', 'E', 'R', 'S', 'E', '\0', /* ROP3_OR_REVERSE (79356) */
	'R', 'O', 'P', '3', '_', 'O', 'R', '\0', /* ROP3_OR (79372) */
	'X', '_', '0', 'X', 'F', '0', '\0', /* X_0XF0 (79380) */
	'X', '_', '0', 'X', 'F', '5', '\0', /* X_0XF5 (79387) */
	'X', '_', '0', 'X', 'F', 'A', '\0', /* X_0XFA (79394) */
	'R', 'O', 'P', '3', '_', 'S', 'E', 'T', '\0', /* ROP3_SET (79401) */
	'Z', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* Z_EXPORT_ENABLE (79410) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'T', 'E', 'S', 'T', '_', 'V', 'A', 'L', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* STENCIL_TEST_VAL_EXPORT_ENABLE (79426) */
	'S', 'T', 'E', 'N', 'C', 'I', 'L', '_', 'O', 'P', '_', 'V', 'A', 'L', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* STENCIL_OP_VAL_EXPORT_ENABLE (79457) */
	'L', 'A', 'T', 'E', '_', 'Z', '\0', /* LATE_Z (79486) */
	'E', 'A', 'R', 'L', 'Y', '_', 'Z', '_', 'T', 'H', 'E', 'N', '_', 'L', 'A', 'T', 'E', '_', 'Z', '\0', /* EARLY_Z_THEN_LATE_Z (79493) */
	'R', 'E', '_', 'Z', '\0', /* RE_Z (79513) */
	'E', 'A', 'R', 'L', 'Y', '_', 'Z', '_', 'T', 'H', 'E', 'N', '_', 'R', 'E', '_', 'Z', '\0', /* EARLY_Z_THEN_RE_Z (79518) */
	'K', 'I', 'L', 'L', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* KILL_ENABLE (79536) */
	'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'T', 'O', '_', 'M', 'A', 'S', 'K', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* COVERAGE_TO_MASK_ENABLE (79548) */
	'M', 'A', 'S', 'K', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* MASK_EXPORT_ENABLE (79572) */
	'E', 'X', 'E', 'C', '_', 'O', 'N', '_', 'H', 'I', 'E', 'R', '_', 'F', 'A', 'I', 'L', '\0', /* EXEC_ON_HIER_FAIL (79591) */
	'E', 'X', 'E', 'C', '_', 'O', 'N', '_', 'N', 'O', 'O', 'P', '\0', /* EXEC_ON_NOOP (79609) */
	'A', 'L', 'P', 'H', 'A', '_', 'T', 'O', '_', 'M', 'A', 'S', 'K', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* ALPHA_TO_MASK_DISABLE (79622) */
	'D', 'E', 'P', 'T', 'H', '_', 'B', 'E', 'F', 'O', 'R', 'E', '_', 'S', 'H', 'A', 'D', 'E', 'R', '\0', /* DEPTH_BEFORE_SHADER (79644) */
	'E', 'X', 'P', 'O', 'R', 'T', '_', 'A', 'N', 'Y', '_', 'Z', '\0', /* EXPORT_ANY_Z (79664) */
	'E', 'X', 'P', 'O', 'R', 'T', '_', 'L', 'E', 'S', 'S', '_', 'T', 'H', 'A', 'N', '_', 'Z', '\0', /* EXPORT_LESS_THAN_Z (79677) */
	'E', 'X', 'P', 'O', 'R', 'T', '_', 'G', 'R', 'E', 'A', 'T', 'E', 'R', '_', 'T', 'H', 'A', 'N', '_', 'Z', '\0', /* EXPORT_GREATER_THAN_Z (79696) */
	'E', 'X', 'P', 'O', 'R', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '\0', /* EXPORT_RESERVED (79718) */
	'C', 'O', 'N', 'S', 'E', 'R', 'V', 'A', 'T', 'I', 'V', 'E', '_', 'Z', '_', 'E', 'X', 'P', 'O', 'R', 'T', '\0', /* CONSERVATIVE_Z_EXPORT (79734) */
	'D', 'U', 'A', 'L', '_', 'Q', 'U', 'A', 'D', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* DUAL_QUAD_DISABLE (79756) */
	'P', 'R', 'I', 'M', 'I', 'T', 'I', 'V', 'E', '_', 'O', 'R', 'D', 'E', 'R', 'E', 'D', '_', 'P', 'I', 'X', 'E', 'L', '_', 'S', 'H', 'A', 'D', 'E', 'R', '\0', /* PRIMITIVE_ORDERED_PIXEL_SHADER (79774) */
	'E', 'X', 'E', 'C', '_', 'I', 'F', '_', 'O', 'V', 'E', 'R', 'L', 'A', 'P', 'P', 'E', 'D', '\0', /* EXEC_IF_OVERLAPPED (79805) */
	'P', 'O', 'P', 'S', '_', 'O', 'V', 'E', 'R', 'L', 'A', 'P', '_', 'N', 'U', 'M', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '\0', /* POPS_OVERLAP_NUM_SAMPLES (79824) */
	'P', 'R', 'E', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* PRE_SHADER_DEPTH_COVERAGE_ENABLE (79849) */
	'U', 'C', 'P', '_', 'E', 'N', 'A', '_', '0', '\0', /* UCP_ENA_0 (79882) */
	'U', 'C', 'P', '_', 'E', 'N', 'A', '_', '1', '\0', /* UCP_ENA_1 (79892) */
	'U', 'C', 'P', '_', 'E', 'N', 'A', '_', '2', '\0', /* UCP_ENA_2 (79902) */
	'U', 'C', 'P', '_', 'E', 'N', 'A', '_', '3', '\0', /* UCP_ENA_3 (79912) */
	'U', 'C', 'P', '_', 'E', 'N', 'A', '_', '4', '\0', /* UCP_ENA_4 (79922) */
	'U', 'C', 'P', '_', 'E', 'N', 'A', '_', '5', '\0', /* UCP_ENA_5 (79932) */
	'P', 'S', '_', 'U', 'C', 'P', '_', 'Y', '_', 'S', 'C', 'A', 'L', 'E', '_', 'N', 'E', 'G', '\0', /* PS_UCP_Y_SCALE_NEG (79942) */
	'P', 'S', '_', 'U', 'C', 'P', '_', 'M', 'O', 'D', 'E', '\0', /* PS_UCP_MODE (79961) */
	'C', 'L', 'I', 'P', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* CLIP_DISABLE (79973) */
	'U', 'C', 'P', '_', 'C', 'U', 'L', 'L', '_', 'O', 'N', 'L', 'Y', '_', 'E', 'N', 'A', '\0', /* UCP_CULL_ONLY_ENA (79986) */
	'B', 'O', 'U', 'N', 'D', 'A', 'R', 'Y', '_', 'E', 'D', 'G', 'E', '_', 'F', 'L', 'A', 'G', '_', 'E', 'N', 'A', '\0', /* BOUNDARY_EDGE_FLAG_ENA (80004) */
	'D', 'X', '_', 'C', 'L', 'I', 'P', '_', 'S', 'P', 'A', 'C', 'E', '_', 'D', 'E', 'F', '\0', /* DX_CLIP_SPACE_DEF (80027) */
	'D', 'I', 'S', '_', 'C', 'L', 'I', 'P', '_', 'E', 'R', 'R', '_', 'D', 'E', 'T', 'E', 'C', 'T', '\0', /* DIS_CLIP_ERR_DETECT (80045) */
	'V', 'T', 'X', '_', 'K', 'I', 'L', 'L', '_', 'O', 'R', '\0', /* VTX_KILL_OR (80065) */
	'D', 'X', '_', 'R', 'A', 'S', 'T', 'E', 'R', 'I', 'Z', 'A', 'T', 'I', 'O', 'N', '_', 'K', 'I', 'L', 'L', '\0', /* DX_RASTERIZATION_KILL (80077) */
	'D', 'X', '_', 'L', 'I', 'N', 'E', 'A', 'R', '_', 'A', 'T', 'T', 'R', '_', 'C', 'L', 'I', 'P', '_', 'E', 'N', 'A', '\0', /* DX_LINEAR_ATTR_CLIP_ENA (80099) */
	'V', 'T', 'E', '_', 'V', 'P', 'O', 'R', 'T', '_', 'P', 'R', 'O', 'V', 'O', 'K', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* VTE_VPORT_PROVOKE_DISABLE (80123) */
	'Z', 'C', 'L', 'I', 'P', '_', 'N', 'E', 'A', 'R', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* ZCLIP_NEAR_DISABLE (80149) */
	'Z', 'C', 'L', 'I', 'P', '_', 'F', 'A', 'R', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* ZCLIP_FAR_DISABLE (80168) */
	'Z', 'C', 'L', 'I', 'P', '_', 'P', 'R', 'O', 'G', '_', 'N', 'E', 'A', 'R', '_', 'E', 'N', 'A', '\0', /* ZCLIP_PROG_NEAR_ENA (80186) */
	'C', 'U', 'L', 'L', '_', 'F', 'R', 'O', 'N', 'T', '\0', /* CULL_FRONT (80206) */
	'C', 'U', 'L', 'L', '_', 'B', 'A', 'C', 'K', '\0', /* CULL_BACK (80217) */
	'X', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'P', 'O', 'L', 'Y', '_', 'M', 'O', 'D', 'E', '\0', /* X_DISABLE_POLY_MODE (80227, 80237) */
	'X', '_', 'D', 'U', 'A', 'L', '_', 'M', 'O', 'D', 'E', '\0', /* X_DUAL_MODE (80247) */
	'X', '_', 'D', 'R', 'A', 'W', '_', 'P', 'O', 'I', 'N', 'T', 'S', '\0', /* X_DRAW_POINTS (80259) */
	'X', '_', 'D', 'R', 'A', 'W', '_', 'L', 'I', 'N', 'E', 'S', '\0', /* X_DRAW_LINES (80273) */
	'X', '_', 'D', 'R', 'A', 'W', '_', 'T', 'R', 'I', 'A', 'N', 'G', 'L', 'E', 'S', '\0', /* X_DRAW_TRIANGLES (80286) */
	'P', 'O', 'L', 'Y', 'M', 'O', 'D', 'E', '_', 'F', 'R', 'O', 'N', 'T', '_', 'P', 'T', 'Y', 'P', 'E', '\0', /* POLYMODE_FRONT_PTYPE (80303) */
	'P', 'O', 'L', 'Y', 'M', 'O', 'D', 'E', '_', 'B', 'A', 'C', 'K', '_', 'P', 'T', 'Y', 'P', 'E', '\0', /* POLYMODE_BACK_PTYPE (80324) */
	'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'F', 'R', 'O', 'N', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* POLY_OFFSET_FRONT_ENABLE (80344) */
	'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'B', 'A', 'C', 'K', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* POLY_OFFSET_BACK_ENABLE (80369) */
	'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'P', 'A', 'R', 'A', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* POLY_OFFSET_PARA_ENABLE (80393) */
	'V', 'T', 'X', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* VTX_WINDOW_OFFSET_ENABLE (80417) */
	'P', 'R', 'O', 'V', 'O', 'K', 'I', 'N', 'G', '_', 'V', 'T', 'X', '_', 'L', 'A', 'S', 'T', '\0', /* PROVOKING_VTX_LAST (80442) */
	'P', 'E', 'R', 'S', 'P', '_', 'C', 'O', 'R', 'R', '_', 'D', 'I', 'S', '\0', /* PERSP_CORR_DIS (80461) */
	'M', 'U', 'L', 'T', 'I', '_', 'P', 'R', 'I', 'M', '_', 'I', 'B', '_', 'E', 'N', 'A', '\0', /* MULTI_PRIM_IB_ENA (80476) */
	'R', 'I', 'G', 'H', 'T', '_', 'T', 'R', 'I', 'A', 'N', 'G', 'L', 'E', '_', 'A', 'L', 'T', 'E', 'R', 'N', 'A', 'T', 'E', '_', 'G', 'R', 'A', 'D', 'I', 'E', 'N', 'T', '_', 'R', 'E', 'F', '\0', /* RIGHT_TRIANGLE_ALTERNATE_GRADIENT_REF (80494) */
	'N', 'E', 'W', '_', 'Q', 'U', 'A', 'D', '_', 'D', 'E', 'C', 'O', 'M', 'P', 'O', 'S', 'I', 'T', 'I', 'O', 'N', '\0', /* NEW_QUAD_DECOMPOSITION (80532) */
	'K', 'E', 'E', 'P', '_', 'T', 'O', 'G', 'E', 'T', 'H', 'E', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* KEEP_TOGETHER_ENABLE (80555) */
	'V', 'P', 'O', 'R', 'T', '_', 'X', '_', 'S', 'C', 'A', 'L', 'E', '_', 'E', 'N', 'A', '\0', /* VPORT_X_SCALE_ENA (80576) */
	'V', 'P', 'O', 'R', 'T', '_', 'X', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'E', 'N', 'A', '\0', /* VPORT_X_OFFSET_ENA (80594) */
	'V', 'P', 'O', 'R', 'T', '_', 'Y', '_', 'S', 'C', 'A', 'L', 'E', '_', 'E', 'N', 'A', '\0', /* VPORT_Y_SCALE_ENA (80613) */
	'V', 'P', 'O', 'R', 'T', '_', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'E', 'N', 'A', '\0', /* VPORT_Y_OFFSET_ENA (80631) */
	'V', 'P', 'O', 'R', 'T', '_', 'Z', '_', 'S', 'C', 'A', 'L', 'E', '_', 'E', 'N', 'A', '\0', /* VPORT_Z_SCALE_ENA (80650) */
	'V', 'P', 'O', 'R', 'T', '_', 'Z', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'E', 'N', 'A', '\0', /* VPORT_Z_OFFSET_ENA (80668) */
	'V', 'T', 'X', '_', 'X', 'Y', '_', 'F', 'M', 'T', '\0', /* VTX_XY_FMT (80687) */
	'V', 'T', 'X', '_', 'Z', '_', 'F', 'M', 'T', '\0', /* VTX_Z_FMT (80698) */
	'V', 'T', 'X', '_', 'W', '0', '_', 'F', 'M', 'T', '\0', /* VTX_W0_FMT (80708) */
	'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'R', 'E', 'F', '\0', /* PERFCOUNTER_REF (80719) */
	'C', 'L', 'I', 'P', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '0', '\0', /* CLIP_DIST_ENA_0 (80735) */
	'C', 'L', 'I', 'P', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '1', '\0', /* CLIP_DIST_ENA_1 (80751) */
	'C', 'L', 'I', 'P', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '2', '\0', /* CLIP_DIST_ENA_2 (80767) */
	'C', 'L', 'I', 'P', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '3', '\0', /* CLIP_DIST_ENA_3 (80783) */
	'C', 'L', 'I', 'P', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '4', '\0', /* CLIP_DIST_ENA_4 (80799) */
	'C', 'L', 'I', 'P', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '5', '\0', /* CLIP_DIST_ENA_5 (80815) */
	'C', 'L', 'I', 'P', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '6', '\0', /* CLIP_DIST_ENA_6 (80831) */
	'C', 'L', 'I', 'P', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '7', '\0', /* CLIP_DIST_ENA_7 (80847) */
	'C', 'U', 'L', 'L', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '0', '\0', /* CULL_DIST_ENA_0 (80863) */
	'C', 'U', 'L', 'L', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '1', '\0', /* CULL_DIST_ENA_1 (80879) */
	'C', 'U', 'L', 'L', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '2', '\0', /* CULL_DIST_ENA_2 (80895) */
	'C', 'U', 'L', 'L', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '3', '\0', /* CULL_DIST_ENA_3 (80911) */
	'C', 'U', 'L', 'L', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '4', '\0', /* CULL_DIST_ENA_4 (80927) */
	'C', 'U', 'L', 'L', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '5', '\0', /* CULL_DIST_ENA_5 (80943) */
	'C', 'U', 'L', 'L', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '6', '\0', /* CULL_DIST_ENA_6 (80959) */
	'C', 'U', 'L', 'L', '_', 'D', 'I', 'S', 'T', '_', 'E', 'N', 'A', '_', '7', '\0', /* CULL_DIST_ENA_7 (80975) */
	'U', 'S', 'E', '_', 'V', 'T', 'X', '_', 'P', 'O', 'I', 'N', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* USE_VTX_POINT_SIZE (80991) */
	'U', 'S', 'E', '_', 'V', 'T', 'X', '_', 'E', 'D', 'G', 'E', '_', 'F', 'L', 'A', 'G', '\0', /* USE_VTX_EDGE_FLAG (81010, 81023) */
	'U', 'S', 'E', '_', 'V', 'T', 'X', '_', 'R', 'E', 'N', 'D', 'E', 'R', '_', 'T', 'A', 'R', 'G', 'E', 'T', '_', 'I', 'N', 'D', 'X', '\0', /* USE_VTX_RENDER_TARGET_INDX (81028) */
	'U', 'S', 'E', '_', 'V', 'T', 'X', '_', 'V', 'I', 'E', 'W', 'P', 'O', 'R', 'T', '_', 'I', 'N', 'D', 'X', '\0', /* USE_VTX_VIEWPORT_INDX (81055) */
	'U', 'S', 'E', '_', 'V', 'T', 'X', '_', 'K', 'I', 'L', 'L', '_', 'F', 'L', 'A', 'G', '\0', /* USE_VTX_KILL_FLAG (81077) */
	'V', 'S', '_', 'O', 'U', 'T', '_', 'M', 'I', 'S', 'C', '_', 'V', 'E', 'C', '_', 'E', 'N', 'A', '\0', /* VS_OUT_MISC_VEC_ENA (81095) */
	'V', 'S', '_', 'O', 'U', 'T', '_', 'C', 'C', 'D', 'I', 'S', 'T', '0', '_', 'V', 'E', 'C', '_', 'E', 'N', 'A', '\0', /* VS_OUT_CCDIST0_VEC_ENA (81115) */
	'V', 'S', '_', 'O', 'U', 'T', '_', 'C', 'C', 'D', 'I', 'S', 'T', '1', '_', 'V', 'E', 'C', '_', 'E', 'N', 'A', '\0', /* VS_OUT_CCDIST1_VEC_ENA (81138) */
	'V', 'S', '_', 'O', 'U', 'T', '_', 'M', 'I', 'S', 'C', '_', 'S', 'I', 'D', 'E', '_', 'B', 'U', 'S', '_', 'E', 'N', 'A', '\0', /* VS_OUT_MISC_SIDE_BUS_ENA (81161) */
	'U', 'S', 'E', '_', 'V', 'T', 'X', '_', 'G', 'S', '_', 'C', 'U', 'T', '_', 'F', 'L', 'A', 'G', '\0', /* USE_VTX_GS_CUT_FLAG (81186) */
	'U', 'S', 'E', '_', 'V', 'T', 'X', '_', 'S', 'H', 'D', '_', 'O', 'B', 'J', 'P', 'R', 'I', 'M', '_', 'I', 'D', '\0', /* USE_VTX_SHD_OBJPRIM_ID (81206) */
	'U', 'S', 'E', '_', 'V', 'T', 'X', '_', 'L', 'I', 'N', 'E', '_', 'W', 'I', 'D', 'T', 'H', '\0', /* USE_VTX_LINE_WIDTH (81229) */
	'V', 'T', 'E', '_', 'X', 'Y', '_', 'I', 'N', 'F', '_', 'D', 'I', 'S', 'C', 'A', 'R', 'D', '\0', /* VTE_XY_INF_DISCARD (81248) */
	'V', 'T', 'E', '_', 'Z', '_', 'I', 'N', 'F', '_', 'D', 'I', 'S', 'C', 'A', 'R', 'D', '\0', /* VTE_Z_INF_DISCARD (81267) */
	'V', 'T', 'E', '_', 'W', '_', 'I', 'N', 'F', '_', 'D', 'I', 'S', 'C', 'A', 'R', 'D', '\0', /* VTE_W_INF_DISCARD (81285) */
	'V', 'T', 'E', '_', '0', 'X', 'N', 'A', 'N', 'I', 'N', 'F', '_', 'I', 'S', '_', '0', '\0', /* VTE_0XNANINF_IS_0 (81303) */
	'V', 'T', 'E', '_', 'X', 'Y', '_', 'N', 'A', 'N', '_', 'R', 'E', 'T', 'A', 'I', 'N', '\0', /* VTE_XY_NAN_RETAIN (81321) */
	'V', 'T', 'E', '_', 'Z', '_', 'N', 'A', 'N', '_', 'R', 'E', 'T', 'A', 'I', 'N', '\0', /* VTE_Z_NAN_RETAIN (81339) */
	'V', 'T', 'E', '_', 'W', '_', 'N', 'A', 'N', '_', 'R', 'E', 'T', 'A', 'I', 'N', '\0', /* VTE_W_NAN_RETAIN (81356) */
	'V', 'T', 'E', '_', 'W', '_', 'R', 'E', 'C', 'I', 'P', '_', 'N', 'A', 'N', '_', 'I', 'S', '_', '0', '\0', /* VTE_W_RECIP_NAN_IS_0 (81373) */
	'V', 'S', '_', 'X', 'Y', '_', 'N', 'A', 'N', '_', 'T', 'O', '_', 'I', 'N', 'F', '\0', /* VS_XY_NAN_TO_INF (81394) */
	'V', 'S', '_', 'X', 'Y', '_', 'I', 'N', 'F', '_', 'R', 'E', 'T', 'A', 'I', 'N', '\0', /* VS_XY_INF_RETAIN (81411) */
	'V', 'S', '_', 'Z', '_', 'N', 'A', 'N', '_', 'T', 'O', '_', 'I', 'N', 'F', '\0', /* VS_Z_NAN_TO_INF (81428) */
	'V', 'S', '_', 'Z', '_', 'I', 'N', 'F', '_', 'R', 'E', 'T', 'A', 'I', 'N', '\0', /* VS_Z_INF_RETAIN (81444) */
	'V', 'S', '_', 'W', '_', 'N', 'A', 'N', '_', 'T', 'O', '_', 'I', 'N', 'F', '\0', /* VS_W_NAN_TO_INF (81460) */
	'V', 'S', '_', 'W', '_', 'I', 'N', 'F', '_', 'R', 'E', 'T', 'A', 'I', 'N', '\0', /* VS_W_INF_RETAIN (81476) */
	'V', 'S', '_', 'C', 'L', 'I', 'P', '_', 'D', 'I', 'S', 'T', '_', 'I', 'N', 'F', '_', 'D', 'I', 'S', 'C', 'A', 'R', 'D', '\0', /* VS_CLIP_DIST_INF_DISCARD (81492) */
	'V', 'T', 'E', '_', 'N', 'O', '_', 'O', 'U', 'T', 'P', 'U', 'T', '_', 'N', 'E', 'G', '_', '0', '\0', /* VTE_NO_OUTPUT_NEG_0 (81517) */
	'L', 'I', 'N', 'E', '_', 'S', 'T', 'I', 'P', 'P', 'L', 'E', '_', 'R', 'E', 'S', 'E', 'T', '\0', /* LINE_STIPPLE_RESET (81537) */
	'E', 'X', 'P', 'A', 'N', 'D', '_', 'F', 'U', 'L', 'L', '_', 'L', 'E', 'N', 'G', 'T', 'H', '\0', /* EXPAND_FULL_LENGTH (81556) */
	'F', 'R', 'A', 'C', 'T', 'I', 'O', 'N', 'A', 'L', '_', 'A', 'C', 'C', 'U', 'M', '\0', /* FRACTIONAL_ACCUM (81575) */
	'D', 'I', 'A', 'M', 'O', 'N', 'D', '_', 'A', 'D', 'J', 'U', 'S', 'T', '\0', /* DIAMOND_ADJUST (81592) */
	'T', 'R', 'I', 'A', 'N', 'G', 'L', 'E', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* TRIANGLE_FILTER_DISABLE (81607) */
	'L', 'I', 'N', 'E', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* LINE_FILTER_DISABLE (81631) */
	'P', 'O', 'I', 'N', 'T', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* POINT_FILTER_DISABLE (81651) */
	'R', 'E', 'C', 'T', 'A', 'N', 'G', 'L', 'E', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* RECTANGLE_FILTER_DISABLE (81672) */
	'T', 'R', 'I', 'A', 'N', 'G', 'L', 'E', '_', 'E', 'X', 'P', 'A', 'N', 'D', '_', 'E', 'N', 'A', '\0', /* TRIANGLE_EXPAND_ENA (81697) */
	'L', 'I', 'N', 'E', '_', 'E', 'X', 'P', 'A', 'N', 'D', '_', 'E', 'N', 'A', '\0', /* LINE_EXPAND_ENA (81717) */
	'P', 'O', 'I', 'N', 'T', '_', 'E', 'X', 'P', 'A', 'N', 'D', '_', 'E', 'N', 'A', '\0', /* POINT_EXPAND_ENA (81733) */
	'R', 'E', 'C', 'T', 'A', 'N', 'G', 'L', 'E', '_', 'E', 'X', 'P', 'A', 'N', 'D', '_', 'E', 'N', 'A', '\0', /* RECTANGLE_EXPAND_ENA (81750) */
	'P', 'R', 'I', 'M', '_', 'E', 'X', 'P', 'A', 'N', 'D', '_', 'C', 'O', 'N', 'S', 'T', 'A', 'N', 'T', '\0', /* PRIM_EXPAND_CONSTANT (81771) */
	'X', 'M', 'A', 'X', '_', 'R', 'I', 'G', 'H', 'T', '_', 'E', 'X', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '\0', /* XMAX_RIGHT_EXCLUSION (81792) */
	'Y', 'M', 'A', 'X', '_', 'B', 'O', 'T', 'T', 'O', 'M', '_', 'E', 'X', 'C', 'L', 'U', 'S', 'I', 'O', 'N', '\0', /* YMAX_BOTTOM_EXCLUSION (81813) */
	'S', 'M', 'A', 'L', 'L', '_', 'P', 'R', 'I', 'M', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* SMALL_PRIM_FILTER_ENABLE (81835) */
	'S', 'R', 'B', 'S', 'L', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* SRBSL_ENABLE (81860) */
	'S', 'C', '_', '1', 'X', 'M', 'S', 'A', 'A', '_', 'C', 'O', 'M', 'P', 'A', 'T', 'I', 'B', 'L', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* SC_1XMSAA_COMPATIBLE_DISABLE (81873) */
	'O', 'B', 'J', '_', 'I', 'D', '_', 'S', 'E', 'L', '\0', /* OBJ_ID_SEL (81902) */
	'A', 'D', 'D', '_', 'P', 'I', 'P', 'E', 'D', '_', 'P', 'R', 'I', 'M', '_', 'I', 'D', '\0', /* ADD_PIPED_PRIM_ID (81913) */
	'V', 'E', 'R', 'T', 'E', 'X', '_', 'R', 'E', 'U', 'S', 'E', '_', 'O', 'F', 'F', '\0', /* VERTEX_REUSE_OFF (81931) */
	'I', 'N', 'D', 'E', 'X', '_', 'B', 'U', 'F', '_', 'E', 'D', 'G', 'E', '_', 'F', 'L', 'A', 'G', '_', 'E', 'N', 'A', '\0', /* INDEX_BUF_EDGE_FLAG_ENA (81948) */
	'D', 'I', 'S', 'C', 'A', 'R', 'D', '_', '0', '_', 'A', 'R', 'E', 'A', '_', 'T', 'R', 'I', 'A', 'N', 'G', 'L', 'E', 'S', '\0', /* DISCARD_0_AREA_TRIANGLES (81972) */
	'D', 'I', 'S', 'C', 'A', 'R', 'D', '_', '0', '_', 'A', 'R', 'E', 'A', '_', 'L', 'I', 'N', 'E', 'S', '\0', /* DISCARD_0_AREA_LINES (81997) */
	'D', 'I', 'S', 'C', 'A', 'R', 'D', '_', '0', '_', 'A', 'R', 'E', 'A', '_', 'P', 'O', 'I', 'N', 'T', 'S', '\0', /* DISCARD_0_AREA_POINTS (82018) */
	'D', 'I', 'S', 'C', 'A', 'R', 'D', '_', '0', '_', 'A', 'R', 'E', 'A', '_', 'R', 'E', 'C', 'T', 'A', 'N', 'G', 'L', 'E', 'S', '\0', /* DISCARD_0_AREA_RECTANGLES (82040) */
	'U', 'S', 'E', '_', 'P', 'R', 'O', 'V', 'O', 'K', 'I', 'N', 'G', '_', 'Z', 'W', '\0', /* USE_PROVOKING_ZW (82066) */
	'S', 'T', 'E', 'R', 'E', 'O', '_', 'M', 'O', 'D', 'E', '\0', /* STEREO_MODE (82083) */
	'R', 'T', '_', 'S', 'L', 'I', 'C', 'E', '_', 'M', 'O', 'D', 'E', '\0', /* RT_SLICE_MODE (82095) */
	'R', 'T', '_', 'S', 'L', 'I', 'C', 'E', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* RT_SLICE_OFFSET (82109) */
	'V', 'P', '_', 'I', 'D', '_', 'M', 'O', 'D', 'E', '\0', /* VP_ID_MODE (82125) */
	'V', 'P', '_', 'I', 'D', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* VP_ID_OFFSET (82136) */
	'M', 'I', 'N', '_', 'S', 'I', 'Z', 'E', '\0', /* MIN_SIZE (82149) */
	'L', 'I', 'N', 'E', '_', 'P', 'A', 'T', 'T', 'E', 'R', 'N', '\0', /* LINE_PATTERN (82158) */
	'R', 'E', 'P', 'E', 'A', 'T', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* REPEAT_COUNT (82171) */
	'P', 'A', 'T', 'T', 'E', 'R', 'N', '_', 'B', 'I', 'T', '_', 'O', 'R', 'D', 'E', 'R', '\0', /* PATTERN_BIT_ORDER (82184) */
	'A', 'U', 'T', 'O', '_', 'R', 'E', 'S', 'E', 'T', '_', 'C', 'N', 'T', 'L', '\0', /* AUTO_RESET_CNTL (82202) */
	'P', 'A', 'T', 'H', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PATH_SELECT (82218) */
	'T', 'E', 'S', 'S', '_', 'M', 'O', 'D', 'E', '\0', /* TESS_MODE (82230) */
	'D', 'I', '_', 'P', 'T', '_', 'N', 'O', 'N', 'E', '\0', /* DI_PT_NONE (82240) */
	'D', 'I', '_', 'P', 'T', '_', 'P', 'O', 'I', 'N', 'T', 'L', 'I', 'S', 'T', '\0', /* DI_PT_POINTLIST (82251, 82257) */
	'D', 'I', '_', 'P', 'T', '_', 'L', 'I', 'N', 'E', 'L', 'I', 'S', 'T', '\0', /* DI_PT_LINELIST (82267) */
	'D', 'I', '_', 'P', 'T', '_', 'L', 'I', 'N', 'E', 'S', 'T', 'R', 'I', 'P', '\0', /* DI_PT_LINESTRIP (82282, 82288) */
	'D', 'I', '_', 'P', 'T', '_', 'T', 'R', 'I', 'L', 'I', 'S', 'T', '\0', /* DI_PT_TRILIST (82298) */
	'D', 'I', '_', 'P', 'T', '_', 'T', 'R', 'I', 'F', 'A', 'N', '\0', /* DI_PT_TRIFAN (82312) */
	'D', 'I', '_', 'P', 'T', '_', 'T', 'R', 'I', 'S', 'T', 'R', 'I', 'P', '\0', /* DI_PT_TRISTRIP (82325, 82331) */
	'D', 'I', '_', 'P', 'T', '_', '2', 'D', '_', 'R', 'E', 'C', 'T', 'A', 'N', 'G', 'L', 'E', '\0', /* DI_PT_2D_RECTANGLE (82340) */
	'D', 'I', '_', 'P', 'T', '_', 'U', 'N', 'U', 'S', 'E', 'D', '_', '1', '\0', /* DI_PT_UNUSED_1 (82359) */
	'D', 'I', '_', 'P', 'T', '_', 'P', 'A', 'T', 'C', 'H', '\0', /* DI_PT_PATCH (82374) */
	'D', 'I', '_', 'P', 'T', '_', 'L', 'I', 'N', 'E', 'L', 'I', 'S', 'T', '_', 'A', 'D', 'J', '\0', /* DI_PT_LINELIST_ADJ (82386) */
	'D', 'I', '_', 'P', 'T', '_', 'L', 'I', 'N', 'E', 'S', 'T', 'R', 'I', 'P', '_', 'A', 'D', 'J', '\0', /* DI_PT_LINESTRIP_ADJ (82405) */
	'D', 'I', '_', 'P', 'T', '_', 'T', 'R', 'I', 'L', 'I', 'S', 'T', '_', 'A', 'D', 'J', '\0', /* DI_PT_TRILIST_ADJ (82425) */
	'D', 'I', '_', 'P', 'T', '_', 'T', 'R', 'I', 'S', 'T', 'R', 'I', 'P', '_', 'A', 'D', 'J', '\0', /* DI_PT_TRISTRIP_ADJ (82443) */
	'D', 'I', '_', 'P', 'T', '_', 'U', 'N', 'U', 'S', 'E', 'D', '_', '3', '\0', /* DI_PT_UNUSED_3 (82462) */
	'D', 'I', '_', 'P', 'T', '_', 'U', 'N', 'U', 'S', 'E', 'D', '_', '4', '\0', /* DI_PT_UNUSED_4 (82477) */
	'D', 'I', '_', 'P', 'T', '_', 'T', 'R', 'I', '_', 'W', 'I', 'T', 'H', '_', 'W', 'F', 'L', 'A', 'G', 'S', '\0', /* DI_PT_TRI_WITH_WFLAGS (82492) */
	'D', 'I', '_', 'P', 'T', '_', 'R', 'E', 'C', 'T', 'L', 'I', 'S', 'T', '\0', /* DI_PT_RECTLIST (82514, 82520) */
	'D', 'I', '_', 'P', 'T', '_', 'L', 'I', 'N', 'E', 'L', 'O', 'O', 'P', '\0', /* DI_PT_LINELOOP (82529) */
	'D', 'I', '_', 'P', 'T', '_', 'Q', 'U', 'A', 'D', 'L', 'I', 'S', 'T', '\0', /* DI_PT_QUADLIST (82544) */
	'D', 'I', '_', 'P', 'T', '_', 'Q', 'U', 'A', 'D', 'S', 'T', 'R', 'I', 'P', '\0', /* DI_PT_QUADSTRIP (82559) */
	'D', 'I', '_', 'P', 'T', '_', 'P', 'O', 'L', 'Y', 'G', 'O', 'N', '\0', /* DI_PT_POLYGON (82575) */
	'R', 'E', 'T', 'A', 'I', 'N', '_', 'O', 'R', 'D', 'E', 'R', '\0', /* RETAIN_ORDER (82589) */
	'R', 'E', 'T', 'A', 'I', 'N', '_', 'Q', 'U', 'A', 'D', 'S', '\0', /* RETAIN_QUADS (82602) */
	'P', 'R', 'I', 'M', '_', 'O', 'R', 'D', 'E', 'R', '\0', /* PRIM_ORDER (82615) */
	'C', 'O', 'M', 'P', '_', 'X', '_', 'E', 'N', '\0', /* COMP_X_EN (82626) */
	'C', 'O', 'M', 'P', '_', 'Y', '_', 'E', 'N', '\0', /* COMP_Y_EN (82636) */
	'C', 'O', 'M', 'P', '_', 'Z', '_', 'E', 'N', '\0', /* COMP_Z_EN (82646) */
	'C', 'O', 'M', 'P', '_', 'W', '_', 'E', 'N', '\0', /* COMP_W_EN (82656) */
	'S', 'H', 'I', 'F', 'T', '\0', /* SHIFT (82666) */
	'X', '_', 'C', 'O', 'N', 'V', '\0', /* X_CONV (82672, 82676) */
	'Y', '_', 'C', 'O', 'N', 'V', '\0', /* Y_CONV (82679) */
	'Z', '_', 'C', 'O', 'N', 'V', '\0', /* Z_CONV (82686) */
	'Z', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* Z_OFFSET (82693) */
	'W', '_', 'C', 'O', 'N', 'V', '\0', /* W_CONV (82702) */
	'G', 'S', '_', 'O', 'F', 'F', '\0', /* GS_OFF (82709) */
	'G', 'S', '_', 'S', 'C', 'E', 'N', 'A', 'R', 'I', 'O', '_', 'A', '\0', /* GS_SCENARIO_A (82716) */
	'G', 'S', '_', 'S', 'C', 'E', 'N', 'A', 'R', 'I', 'O', '_', 'B', '\0', /* GS_SCENARIO_B (82730) */
	'G', 'S', '_', 'S', 'C', 'E', 'N', 'A', 'R', 'I', 'O', '_', 'G', '\0', /* GS_SCENARIO_G (82744) */
	'G', 'S', '_', 'S', 'C', 'E', 'N', 'A', 'R', 'I', 'O', '_', 'C', '\0', /* GS_SCENARIO_C (82758) */
	'S', 'P', 'R', 'I', 'T', 'E', '_', 'E', 'N', '\0', /* SPRITE_EN (82772) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '0', '\0', /* RESERVED_0 (82782) */
	'G', 'S', '_', 'C', 'U', 'T', '_', '1', '0', '2', '4', '\0', /* GS_CUT_1024 (82793) */
	'G', 'S', '_', 'C', 'U', 'T', '_', '5', '1', '2', '\0', /* GS_CUT_512 (82805) */
	'G', 'S', '_', 'C', 'U', 'T', '_', '2', '5', '6', '\0', /* GS_CUT_256 (82816) */
	'G', 'S', '_', 'C', 'U', 'T', '_', '1', '2', '8', '\0', /* GS_CUT_128 (82827) */
	'C', 'U', 'T', '_', 'M', 'O', 'D', 'E', '\0', /* CUT_MODE (82838) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '\0', /* RESERVED_1 (82847) */
	'G', 'S', '_', 'C', '_', 'P', 'A', 'C', 'K', '_', 'E', 'N', '\0', /* GS_C_PACK_EN (82858) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '\0', /* RESERVED_2 (82871) */
	'E', 'S', '_', 'P', 'A', 'S', 'S', 'T', 'H', 'R', 'U', '\0', /* ES_PASSTHRU (82882) */
	'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'M', 'O', 'D', 'E', '\0', /* COMPUTE_MODE (82894) */
	'F', 'A', 'S', 'T', '_', 'C', 'O', 'M', 'P', 'U', 'T', 'E', '_', 'M', 'O', 'D', 'E', '\0', /* FAST_COMPUTE_MODE (82907) */
	'E', 'L', 'E', 'M', 'E', 'N', 'T', '_', 'I', 'N', 'F', 'O', '_', 'E', 'N', '\0', /* ELEMENT_INFO_EN (82925) */
	'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'T', 'H', 'D', '_', 'A', 'T', '_', 'E', 'O', 'I', '\0', /* PARTIAL_THD_AT_EOI (82941) */
	'S', 'U', 'P', 'P', 'R', 'E', 'S', 'S', '_', 'C', 'U', 'T', 'S', '\0', /* SUPPRESS_CUTS (82960) */
	'E', 'S', '_', 'W', 'R', 'I', 'T', 'E', '_', 'O', 'P', 'T', 'I', 'M', 'I', 'Z', 'E', '\0', /* ES_WRITE_OPTIMIZE (82974) */
	'G', 'S', '_', 'W', 'R', 'I', 'T', 'E', '_', 'O', 'P', 'T', 'I', 'M', 'I', 'Z', 'E', '\0', /* GS_WRITE_OPTIMIZE (82992) */
	'O', 'N', 'C', 'H', 'I', 'P', '\0', /* ONCHIP (83010) */
	'E', 'S', '_', 'V', 'E', 'R', 'T', 'S', '_', 'P', 'E', 'R', '_', 'S', 'U', 'B', 'G', 'R', 'P', '\0', /* ES_VERTS_PER_SUBGRP (83017) */
	'G', 'S', '_', 'P', 'R', 'I', 'M', 'S', '_', 'P', 'E', 'R', '_', 'S', 'U', 'B', 'G', 'R', 'P', '\0', /* GS_PRIMS_PER_SUBGRP (83037) */
	'G', 'S', '_', 'I', 'N', 'S', 'T', '_', 'P', 'R', 'I', 'M', 'S', '_', 'I', 'N', '_', 'S', 'U', 'B', 'G', 'R', 'P', '\0', /* GS_INST_PRIMS_IN_SUBGRP (83057) */
	'M', 'S', 'A', 'A', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* MSAA_ENABLE (83081) */
	'V', 'P', 'O', 'R', 'T', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* VPORT_SCISSOR_ENABLE (83093) */
	'L', 'I', 'N', 'E', '_', 'S', 'T', 'I', 'P', 'P', 'L', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* LINE_STIPPLE_ENABLE (83114) */
	'S', 'E', 'N', 'D', '_', 'U', 'N', 'L', 'I', 'T', '_', 'S', 'T', 'I', 'L', 'E', 'S', '_', 'T', 'O', '_', 'P', 'K', 'R', '\0', /* SEND_UNLIT_STILES_TO_PKR (83134) */
	'S', 'C', 'A', 'L', 'E', '_', 'L', 'I', 'N', 'E', '_', 'W', 'I', 'D', 'T', 'H', '_', 'P', 'A', 'D', '\0', /* SCALE_LINE_WIDTH_PAD (83159) */
	'A', 'L', 'T', 'E', 'R', 'N', 'A', 'T', 'E', '_', 'R', 'B', 'S', '_', 'P', 'E', 'R', '_', 'T', 'I', 'L', 'E', '\0', /* ALTERNATE_RBS_PER_TILE (83180) */
	'C', 'O', 'A', 'R', 'S', 'E', '_', 'T', 'I', 'L', 'E', '_', 'S', 'T', 'A', 'R', 'T', 'S', '_', 'O', 'N', '_', 'E', 'V', 'E', 'N', '_', 'R', 'B', '\0', /* COARSE_TILE_STARTS_ON_EVEN_RB (83203) */
	'W', 'A', 'L', 'K', '_', 'S', 'I', 'Z', 'E', '\0', /* WALK_SIZE (83233) */
	'W', 'A', 'L', 'K', '_', 'A', 'L', 'I', 'G', 'N', 'M', 'E', 'N', 'T', '\0', /* WALK_ALIGNMENT (83243) */
	'W', 'A', 'L', 'K', '_', 'A', 'L', 'I', 'G', 'N', '8', '_', 'P', 'R', 'I', 'M', '_', 'F', 'I', 'T', 'S', '_', 'S', 'T', '\0', /* WALK_ALIGN8_PRIM_FITS_ST (83258) */
	'W', 'A', 'L', 'K', '_', 'F', 'E', 'N', 'C', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* WALK_FENCE_ENABLE (83283) */
	'W', 'A', 'L', 'K', '_', 'F', 'E', 'N', 'C', 'E', '_', 'S', 'I', 'Z', 'E', '\0', /* WALK_FENCE_SIZE (83301) */
	'S', 'U', 'P', 'E', 'R', 'T', 'I', 'L', 'E', '_', 'W', 'A', 'L', 'K', '_', 'O', 'R', 'D', 'E', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* SUPERTILE_WALK_ORDER_ENABLE (83317, 83322) */
	'T', 'I', 'L', 'E', '_', 'C', 'O', 'V', 'E', 'R', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* TILE_COVER_DISABLE (83345) */
	'T', 'I', 'L', 'E', '_', 'C', 'O', 'V', 'E', 'R', '_', 'N', 'O', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '\0', /* TILE_COVER_NO_SCISSOR (83364) */
	'Z', 'M', 'M', '_', 'L', 'I', 'N', 'E', '_', 'E', 'X', 'T', 'E', 'N', 'T', '\0', /* ZMM_LINE_EXTENT (83386) */
	'Z', 'M', 'M', '_', 'L', 'I', 'N', 'E', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* ZMM_LINE_OFFSET (83402) */
	'Z', 'M', 'M', '_', 'R', 'E', 'C', 'T', '_', 'E', 'X', 'T', 'E', 'N', 'T', '\0', /* ZMM_RECT_EXTENT (83418) */
	'K', 'I', 'L', 'L', '_', 'P', 'I', 'X', '_', 'P', 'O', 'S', 'T', '_', 'H', 'I', '_', 'Z', '\0', /* KILL_PIX_POST_HI_Z (83434) */
	'K', 'I', 'L', 'L', '_', 'P', 'I', 'X', '_', 'P', 'O', 'S', 'T', '_', 'D', 'E', 'T', 'A', 'I', 'L', '_', 'M', 'A', 'S', 'K', '\0', /* KILL_PIX_POST_DETAIL_MASK (83453) */
	'P', 'S', '_', 'I', 'T', 'E', 'R', '_', 'S', 'A', 'M', 'P', 'L', 'E', '\0', /* PS_ITER_SAMPLE (83479) */
	'M', 'U', 'L', 'T', 'I', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'E', 'N', 'G', 'I', 'N', 'E', '_', 'P', 'R', 'I', 'M', '_', 'D', 'I', 'S', 'C', 'A', 'R', 'D', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* MULTI_SHADER_ENGINE_PRIM_DISCARD_ENABLE (83494) */
	'M', 'U', 'L', 'T', 'I', '_', 'G', 'P', 'U', '_', 'S', 'U', 'P', 'E', 'R', 'T', 'I', 'L', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* MULTI_GPU_SUPERTILE_ENABLE (83534) */
	'G', 'P', 'U', '_', 'I', 'D', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* GPU_ID_OVERRIDE_ENABLE (83561) */
	'G', 'P', 'U', '_', 'I', 'D', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* GPU_ID_OVERRIDE (83584) */
	'M', 'U', 'L', 'T', 'I', '_', 'G', 'P', 'U', '_', 'P', 'R', 'I', 'M', '_', 'D', 'I', 'S', 'C', 'A', 'R', 'D', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* MULTI_GPU_PRIM_DISCARD_ENABLE (83600) */
	'F', 'O', 'R', 'C', 'E', '_', 'E', 'O', 'V', '_', 'C', 'N', 'T', 'D', 'W', 'N', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* FORCE_EOV_CNTDWN_ENABLE (83630) */
	'F', 'O', 'R', 'C', 'E', '_', 'E', 'O', 'V', '_', 'R', 'E', 'Z', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* FORCE_EOV_REZ_ENABLE (83654) */
	'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'P', 'R', 'I', 'M', 'I', 'T', 'I', 'V', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OUT_OF_ORDER_PRIMITIVE_ENABLE (83675) */
	'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'W', 'A', 'T', 'E', 'R', '_', 'M', 'A', 'R', 'K', '\0', /* OUT_OF_ORDER_WATER_MARK (83705) */
	'O', 'U', 'T', 'P', 'R', 'I', 'M', '_', 'T', 'Y', 'P', 'E', '\0', /* OUTPRIM_TYPE (83729) */
	'O', 'U', 'T', 'P', 'R', 'I', 'M', '_', 'T', 'Y', 'P', 'E', '_', '1', '\0', /* OUTPRIM_TYPE_1 (83742) */
	'O', 'U', 'T', 'P', 'R', 'I', 'M', '_', 'T', 'Y', 'P', 'E', '_', '2', '\0', /* OUTPRIM_TYPE_2 (83757) */
	'O', 'U', 'T', 'P', 'R', 'I', 'M', '_', 'T', 'Y', 'P', 'E', '_', '3', '\0', /* OUTPRIM_TYPE_3 (83772) */
	'U', 'N', 'I', 'Q', 'U', 'E', '_', 'T', 'Y', 'P', 'E', '_', 'P', 'E', 'R', '_', 'S', 'T', 'R', 'E', 'A', 'M', '\0', /* UNIQUE_TYPE_PER_STREAM (83787) */
	'V', 'G', 'T', '_', 'I', 'N', 'D', 'E', 'X', '_', '1', '6', '\0', /* VGT_INDEX_16 (83810) */
	'V', 'G', 'T', '_', 'I', 'N', 'D', 'E', 'X', '_', '3', '2', '\0', /* VGT_INDEX_32 (83823) */
	'V', 'G', 'T', '_', 'I', 'N', 'D', 'E', 'X', '_', '8', '\0', /* VGT_INDEX_8 (83836) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'S', 'W', 'A', 'P', '_', 'N', 'O', 'N', 'E', '\0', /* VGT_DMA_SWAP_NONE (83848) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'S', 'W', 'A', 'P', '_', '1', '6', '_', 'B', 'I', 'T', '\0', /* VGT_DMA_SWAP_16_BIT (83866) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'S', 'W', 'A', 'P', '_', '3', '2', '_', 'B', 'I', 'T', '\0', /* VGT_DMA_SWAP_32_BIT (83886) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'S', 'W', 'A', 'P', '_', 'W', 'O', 'R', 'D', '\0', /* VGT_DMA_SWAP_WORD (83906) */
	'S', 'W', 'A', 'P', '_', 'M', 'O', 'D', 'E', '\0', /* SWAP_MODE (83924) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'B', 'U', 'F', '_', 'M', 'E', 'M', '\0', /* VGT_DMA_BUF_MEM (83934) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'B', 'U', 'F', '_', 'R', 'I', 'N', 'G', '\0', /* VGT_DMA_BUF_RING (83950) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'B', 'U', 'F', '_', 'S', 'E', 'T', 'U', 'P', '\0', /* VGT_DMA_BUF_SETUP (83967) */
	'V', 'G', 'T', '_', 'D', 'M', 'A', '_', 'P', 'T', 'R', '_', 'U', 'P', 'D', 'A', 'T', 'E', '\0', /* VGT_DMA_PTR_UPDATE (83985) */
	'B', 'U', 'F', '_', 'T', 'Y', 'P', 'E', '\0', /* BUF_TYPE (84004) */
	'V', 'G', 'T', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '_', 'L', 'R', 'U', '\0', /* VGT_POLICY_LRU (84013) */
	'V', 'G', 'T', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '_', 'S', 'T', 'R', 'E', 'A', 'M', '\0', /* VGT_POLICY_STREAM (84028) */
	'V', 'G', 'T', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '_', 'B', 'Y', 'P', 'A', 'S', 'S', '\0', /* VGT_POLICY_BYPASS (84046) */
	'R', 'D', 'R', 'E', 'Q', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* RDREQ_POLICY (84064) */
	'A', 'T', 'C', '\0', /* ATC (84077) */
	'R', 'E', 'Q', '_', 'P', 'A', 'T', 'H', '\0', /* REQ_PATH (84081) */
	'M', 'T', 'Y', 'P', 'E', '\0', /* MTYPE (84090) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'R', 'E', 'S', 'E', 'T', '_', 'O', 'N', '_', 'E', 'O', 'I', '\0', /* DISABLE_RESET_ON_EOI (84096) */
	'N', 'G', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'P', 'R', 'O', 'V', 'O', 'K', '_', 'R', 'E', 'U', 'S', 'E', '\0', /* NGG_DISABLE_PROVOK_REUSE (84117) */
	'R', 'e', 's', 'e', 'r', 'v', 'e', 'd', '_', '0', 'x', '0', '0', '\0', /* Reserved_0x00 (84142) */
	'S', 'A', 'M', 'P', 'L', 'E', '_', 'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', 'S', 'T', 'A', 'T', 'S', '1', '\0', /* SAMPLE_STREAMOUTSTATS1 (84156) */
	'S', 'A', 'M', 'P', 'L', 'E', '_', 'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', 'S', 'T', 'A', 'T', 'S', '2', '\0', /* SAMPLE_STREAMOUTSTATS2 (84179) */
	'S', 'A', 'M', 'P', 'L', 'E', '_', 'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', 'S', 'T', 'A', 'T', 'S', '3', '\0', /* SAMPLE_STREAMOUTSTATS3 (84202) */
	'C', 'A', 'C', 'H', 'E', '_', 'F', 'L', 'U', 'S', 'H', '_', 'T', 'S', '\0', /* CACHE_FLUSH_TS (84225) */
	'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'D', 'O', 'N', 'E', '\0', /* CONTEXT_DONE (84240) */
	'C', 'A', 'C', 'H', 'E', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* CACHE_FLUSH (84253) */
	'C', 'S', '_', 'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* CS_PARTIAL_FLUSH (84265) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', '_', 'S', 'Y', 'N', 'C', '\0', /* VGT_STREAMOUT_SYNC (84282) */
	'S', 'E', 'T', '_', 'F', 'E', '_', 'I', 'D', '\0', /* SET_FE_ID (84301) */
	'V', 'G', 'T', '_', 'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', '_', 'R', 'E', 'S', 'E', 'T', '\0', /* VGT_STREAMOUT_RESET (84311) */
	'E', 'N', 'D', '_', 'O', 'F', '_', 'P', 'I', 'P', 'E', '_', 'I', 'N', 'C', 'R', '_', 'D', 'E', '\0', /* END_OF_PIPE_INCR_DE (84331) */
	'E', 'N', 'D', '_', 'O', 'F', '_', 'P', 'I', 'P', 'E', '_', 'I', 'B', '_', 'E', 'N', 'D', '\0', /* END_OF_PIPE_IB_END (84351) */
	'R', 'S', 'T', '_', 'P', 'I', 'X', '_', 'C', 'N', 'T', '\0', /* RST_PIX_CNT (84370) */
	'B', 'R', 'E', 'A', 'K', '_', 'B', 'A', 'T', 'C', 'H', '\0', /* BREAK_BATCH (84382) */
	'V', 'S', '_', 'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* VS_PARTIAL_FLUSH (84394) */
	'P', 'S', '_', 'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* PS_PARTIAL_FLUSH (84411) */
	'F', 'L', 'U', 'S', 'H', '_', 'H', 'S', '_', 'O', 'U', 'T', 'P', 'U', 'T', '\0', /* FLUSH_HS_OUTPUT (84428) */
	'F', 'L', 'U', 'S', 'H', '_', 'D', 'F', 'S', 'M', '\0', /* FLUSH_DFSM (84444) */
	'R', 'E', 'S', 'E', 'T', '_', 'T', 'O', '_', 'L', 'O', 'W', 'E', 'S', 'T', '_', 'V', 'G', 'T', '\0', /* RESET_TO_LOWEST_VGT (84455) */
	'C', 'A', 'C', 'H', 'E', '_', 'F', 'L', 'U', 'S', 'H', '_', 'A', 'N', 'D', '_', 'I', 'N', 'V', '_', 'T', 'S', '_', 'E', 'V', 'E', 'N', 'T', '\0', /* CACHE_FLUSH_AND_INV_TS_EVENT (84475) */
	'Z', 'P', 'A', 'S', 'S', '_', 'D', 'O', 'N', 'E', '\0', /* ZPASS_DONE (84504) */
	'C', 'A', 'C', 'H', 'E', '_', 'F', 'L', 'U', 'S', 'H', '_', 'A', 'N', 'D', '_', 'I', 'N', 'V', '_', 'E', 'V', 'E', 'N', 'T', '\0', /* CACHE_FLUSH_AND_INV_EVENT (84515) */
	'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* PERFCOUNTER_START (84541) */
	'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'T', 'O', 'P', '\0', /* PERFCOUNTER_STOP (84559) */
	'P', 'I', 'P', 'E', 'L', 'I', 'N', 'E', 'S', 'T', 'A', 'T', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* PIPELINESTAT_START (84576) */
	'P', 'I', 'P', 'E', 'L', 'I', 'N', 'E', 'S', 'T', 'A', 'T', '_', 'S', 'T', 'O', 'P', '\0', /* PIPELINESTAT_STOP (84595) */
	'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'A', 'M', 'P', 'L', 'E', '\0', /* PERFCOUNTER_SAMPLE (84613) */
	'F', 'L', 'U', 'S', 'H', '_', 'E', 'S', '_', 'O', 'U', 'T', 'P', 'U', 'T', '\0', /* FLUSH_ES_OUTPUT (84632) */
	'B', 'I', 'N', '_', 'C', 'O', 'N', 'F', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '_', 'C', 'H', 'E', 'C', 'K', '\0', /* BIN_CONF_OVERRIDE_CHECK (84648) */
	'S', 'A', 'M', 'P', 'L', 'E', '_', 'P', 'I', 'P', 'E', 'L', 'I', 'N', 'E', 'S', 'T', 'A', 'T', '\0', /* SAMPLE_PIPELINESTAT (84672) */
	'S', 'O', '_', 'V', 'G', 'T', 'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* SO_VGTSTREAMOUT_FLUSH (84692) */
	'S', 'A', 'M', 'P', 'L', 'E', '_', 'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', 'S', 'T', 'A', 'T', 'S', '\0', /* SAMPLE_STREAMOUTSTATS (84714) */
	'R', 'E', 'S', 'E', 'T', '_', 'V', 'T', 'X', '_', 'C', 'N', 'T', '\0', /* RESET_VTX_CNT (84736) */
	'B', 'L', 'O', 'C', 'K', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'D', 'O', 'N', 'E', '\0', /* BLOCK_CONTEXT_DONE (84750) */
	'C', 'S', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'D', 'O', 'N', 'E', '\0', /* CS_CONTEXT_DONE (84769) */
	'V', 'G', 'T', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* VGT_FLUSH (84785) */
	'T', 'G', 'I', 'D', '_', 'R', 'O', 'L', 'L', 'O', 'V', 'E', 'R', '\0', /* TGID_ROLLOVER (84795) */
	'S', 'Q', '_', 'N', 'O', 'N', '_', 'E', 'V', 'E', 'N', 'T', '\0', /* SQ_NON_EVENT (84809) */
	'S', 'C', '_', 'S', 'E', 'N', 'D', '_', 'D', 'B', '_', 'V', 'P', 'Z', '\0', /* SC_SEND_DB_VPZ (84822) */
	'B', 'O', 'T', 'T', 'O', 'M', '_', 'O', 'F', '_', 'P', 'I', 'P', 'E', '_', 'T', 'S', '\0', /* BOTTOM_OF_PIPE_TS (84837) */
	'F', 'L', 'U', 'S', 'H', '_', 'S', 'X', '_', 'T', 'S', '\0', /* FLUSH_SX_TS (84855) */
	'D', 'B', '_', 'C', 'A', 'C', 'H', 'E', '_', 'F', 'L', 'U', 'S', 'H', '_', 'A', 'N', 'D', '_', 'I', 'N', 'V', '\0', /* DB_CACHE_FLUSH_AND_INV (84867) */
	'F', 'L', 'U', 'S', 'H', '_', 'A', 'N', 'D', '_', 'I', 'N', 'V', '_', 'D', 'B', '_', 'D', 'A', 'T', 'A', '_', 'T', 'S', '\0', /* FLUSH_AND_INV_DB_DATA_TS (84890) */
	'F', 'L', 'U', 'S', 'H', '_', 'A', 'N', 'D', '_', 'I', 'N', 'V', '_', 'D', 'B', '_', 'M', 'E', 'T', 'A', '\0', /* FLUSH_AND_INV_DB_META (84915) */
	'F', 'L', 'U', 'S', 'H', '_', 'A', 'N', 'D', '_', 'I', 'N', 'V', '_', 'C', 'B', '_', 'D', 'A', 'T', 'A', '_', 'T', 'S', '\0', /* FLUSH_AND_INV_CB_DATA_TS (84937) */
	'F', 'L', 'U', 'S', 'H', '_', 'A', 'N', 'D', '_', 'I', 'N', 'V', '_', 'C', 'B', '_', 'M', 'E', 'T', 'A', '\0', /* FLUSH_AND_INV_CB_META (84962) */
	'C', 'S', '_', 'D', 'O', 'N', 'E', '\0', /* CS_DONE (84984) */
	'P', 'S', '_', 'D', 'O', 'N', 'E', '\0', /* PS_DONE (84992) */
	'F', 'L', 'U', 'S', 'H', '_', 'A', 'N', 'D', '_', 'I', 'N', 'V', '_', 'C', 'B', '_', 'P', 'I', 'X', 'E', 'L', '_', 'D', 'A', 'T', 'A', '\0', /* FLUSH_AND_INV_CB_PIXEL_DATA (85000) */
	'S', 'X', '_', 'C', 'B', '_', 'R', 'A', 'T', '_', 'A', 'C', 'K', '_', 'R', 'E', 'Q', 'U', 'E', 'S', 'T', '\0', /* SX_CB_RAT_ACK_REQUEST (85028) */
	'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* THREAD_TRACE_START (85050) */
	'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'S', 'T', 'O', 'P', '\0', /* THREAD_TRACE_STOP (85069) */
	'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'M', 'A', 'R', 'K', 'E', 'R', '\0', /* THREAD_TRACE_MARKER (85087) */
	'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'D', 'R', 'A', 'W', '\0', /* THREAD_TRACE_DRAW (85107) */
	'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'F', 'I', 'N', 'I', 'S', 'H', '\0', /* THREAD_TRACE_FINISH (85125) */
	'P', 'I', 'X', 'E', 'L', '_', 'P', 'I', 'P', 'E', '_', 'S', 'T', 'A', 'T', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* PIXEL_PIPE_STAT_CONTROL (85145) */
	'P', 'I', 'X', 'E', 'L', '_', 'P', 'I', 'P', 'E', '_', 'S', 'T', 'A', 'T', '_', 'D', 'U', 'M', 'P', '\0', /* PIXEL_PIPE_STAT_DUMP (85169) */
	'P', 'I', 'X', 'E', 'L', '_', 'P', 'I', 'P', 'E', '_', 'S', 'T', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'T', '\0', /* PIXEL_PIPE_STAT_RESET (85190) */
	'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'S', 'U', 'S', 'P', 'E', 'N', 'D', '\0', /* CONTEXT_SUSPEND (85212) */
	'O', 'F', 'F', 'C', 'H', 'I', 'P', '_', 'H', 'S', '_', 'D', 'E', 'A', 'L', 'L', 'O', 'C', '\0', /* OFFCHIP_HS_DEALLOC (85228) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'N', 'G', 'G', '_', 'P', 'I', 'P', 'E', 'L', 'I', 'N', 'E', '\0', /* ENABLE_NGG_PIPELINE (85247) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'L', 'E', 'G', 'A', 'C', 'Y', '_', 'P', 'I', 'P', 'E', 'L', 'I', 'N', 'E', '\0', /* ENABLE_LEGACY_PIPELINE (85267) */
	'D', 'R', 'A', 'W', '_', 'D', 'O', 'N', 'E', '\0', /* DRAW_DONE (85290) */
	'E', 'V', 'E', 'N', 'T', '_', 'T', 'Y', 'P', 'E', '\0', /* EVENT_TYPE (85300) */
	'E', 'X', 'T', 'E', 'N', 'D', 'E', 'D', '_', 'E', 'V', 'E', 'N', 'T', '\0', /* EXTENDED_EVENT (85311) */
	'M', 'A', 'T', 'C', 'H', '_', 'A', 'L', 'L', '_', 'B', 'I', 'T', 'S', '\0', /* MATCH_ALL_BITS (85326) */
	'O', 'B', 'J', 'P', 'R', 'I', 'M', '_', 'I', 'D', '_', 'E', 'N', '\0', /* OBJPRIM_ID_EN (85341) */
	'E', 'N', '_', 'R', 'E', 'G', '_', 'R', 'T', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* EN_REG_RT_INDEX (85355) */
	'O', 'B', 'J', 'E', 'C', 'T', '_', 'I', 'D', '_', 'I', 'N', 'S', 'T', '_', 'E', 'N', '\0', /* OBJECT_ID_INST_EN (85371) */
	'E', 'N', '_', 'P', 'R', 'I', 'M', '_', 'P', 'A', 'Y', 'L', 'O', 'A', 'D', '\0', /* EN_PRIM_PAYLOAD (85389) */
	'E', 'N', '_', 'D', 'R', 'A', 'W', '_', 'V', 'P', '\0', /* EN_DRAW_VP (85405) */
	'P', 'R', 'I', 'M', 'G', 'R', 'O', 'U', 'P', '_', 'S', 'I', 'Z', 'E', '\0', /* PRIMGROUP_SIZE (85416) */
	'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'V', 'S', '_', 'W', 'A', 'V', 'E', '_', 'O', 'N', '\0', /* PARTIAL_VS_WAVE_ON (85431) */
	'S', 'W', 'I', 'T', 'C', 'H', '_', 'O', 'N', '_', 'E', 'O', 'P', '\0', /* SWITCH_ON_EOP (85450) */
	'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'E', 'S', '_', 'W', 'A', 'V', 'E', '_', 'O', 'N', '\0', /* PARTIAL_ES_WAVE_ON (85464) */
	'S', 'W', 'I', 'T', 'C', 'H', '_', 'O', 'N', '_', 'E', 'O', 'I', '\0', /* SWITCH_ON_EOI (85483) */
	'W', 'D', '_', 'S', 'W', 'I', 'T', 'C', 'H', '_', 'O', 'N', '_', 'E', 'O', 'P', '\0', /* WD_SWITCH_ON_EOP (85497) */
	'F', 'U', 'L', 'L', '_', 'C', 'A', 'C', 'H', 'E', '\0', /* FULL_CACHE (85514) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'F', 'I', 'E', 'L', 'D', '_', '2', '\0', /* RESERVED_FIELD_2 (85525) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'F', 'I', 'E', 'L', 'D', '_', '3', '\0', /* RESERVED_FIELD_3 (85542) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'F', 'I', 'E', 'L', 'D', '_', '4', '\0', /* RESERVED_FIELD_4 (85559) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'F', 'I', 'E', 'L', 'D', '_', '5', '\0', /* RESERVED_FIELD_5 (85576) */
	'D', 'S', 'T', '_', 'O', 'U', 'T', 'S', 'I', 'D', 'E', '_', 'Z', 'E', 'R', 'O', '_', 'T', 'O', '_', 'O', 'N', 'E', '\0', /* DST_OUTSIDE_ZERO_TO_ONE (85593) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'F', 'I', 'E', 'L', 'D', '_', '6', '\0', /* RESERVED_FIELD_6 (85617) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', 'F', 'U', 'N', 'C', '0', '\0', /* COMPAREFUNC0 (85634) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', 'V', 'A', 'L', 'U', 'E', '0', '\0', /* COMPAREVALUE0 (85647) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', 'M', 'A', 'S', 'K', '0', '\0', /* COMPAREMASK0 (85661) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', 'F', 'U', 'N', 'C', '1', '\0', /* COMPAREFUNC1 (85674) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', 'V', 'A', 'L', 'U', 'E', '1', '\0', /* COMPAREVALUE1 (85687) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', 'M', 'A', 'S', 'K', '1', '\0', /* COMPAREMASK1 (85701) */
	'M', 'A', 'X', '_', 'X', '\0', /* MAX_X (85714) */
	'M', 'A', 'X', '_', 'Y', '\0', /* MAX_Y (85720) */
	'P', 'R', 'I', 'M', '_', 'A', 'M', 'P', '_', 'F', 'A', 'C', 'T', 'O', 'R', '\0', /* PRIM_AMP_FACTOR (85726) */
	'T', 'H', 'D', 'S', '_', 'P', 'E', 'R', '_', 'S', 'U', 'B', 'G', 'R', 'P', '\0', /* THDS_PER_SUBGRP (85742) */
	'A', 'C', 'C', 'U', 'M', '_', 'I', 'S', 'O', 'L', 'I', 'N', 'E', '\0', /* ACCUM_ISOLINE (85758) */
	'A', 'C', 'C', 'U', 'M', '_', 'T', 'R', 'I', '\0', /* ACCUM_TRI (85772) */
	'A', 'C', 'C', 'U', 'M', '_', 'Q', 'U', 'A', 'D', '\0', /* ACCUM_QUAD (85782) */
	'D', 'O', 'N', 'U', 'T', '_', 'S', 'P', 'L', 'I', 'T', '\0', /* DONUT_SPLIT (85793) */
	'T', 'R', 'A', 'P', '_', 'S', 'P', 'L', 'I', 'T', '\0', /* TRAP_SPLIT (85805) */
	'L', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'O', 'F', 'F', '\0', /* LS_STAGE_OFF (85816) */
	'L', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'O', 'N', '\0', /* LS_STAGE_ON (85829) */
	'C', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'O', 'N', '\0', /* CS_STAGE_ON (85841) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'L', 'S', '\0', /* RESERVED_LS (85853) */
	'L', 'S', '_', 'E', 'N', '\0', /* LS_EN (85865) */
	'H', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'O', 'F', 'F', '\0', /* HS_STAGE_OFF (85871) */
	'H', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'O', 'N', '\0', /* HS_STAGE_ON (85884) */
	'H', 'S', '_', 'E', 'N', '\0', /* HS_EN (85896) */
	'E', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'O', 'F', 'F', '\0', /* ES_STAGE_OFF (85902) */
	'E', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'D', 'S', '\0', /* ES_STAGE_DS (85915) */
	'E', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'R', 'E', 'A', 'L', '\0', /* ES_STAGE_REAL (85927) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'E', 'S', '\0', /* RESERVED_ES (85941) */
	'G', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'O', 'F', 'F', '\0', /* GS_STAGE_OFF (85953) */
	'G', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'O', 'N', '\0', /* GS_STAGE_ON (85966) */
	'G', 'S', '_', 'E', 'N', '\0', /* GS_EN (85978) */
	'V', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'R', 'E', 'A', 'L', '\0', /* VS_STAGE_REAL (85984) */
	'V', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'D', 'S', '\0', /* VS_STAGE_DS (85998) */
	'V', 'S', '_', 'S', 'T', 'A', 'G', 'E', '_', 'C', 'O', 'P', 'Y', '_', 'S', 'H', 'A', 'D', 'E', 'R', '\0', /* VS_STAGE_COPY_SHADER (86010) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'V', 'S', '\0', /* RESERVED_VS (86031) */
	'V', 'S', '_', 'E', 'N', '\0', /* VS_EN (86043) */
	'D', 'Y', 'N', 'A', 'M', 'I', 'C', '_', 'H', 'S', '\0', /* DYNAMIC_HS (86049) */
	'D', 'I', 'S', '_', 'D', 'E', 'A', 'L', 'L', 'O', 'C', '_', 'A', 'C', 'C', 'U', 'M', '_', '0', '\0', /* DIS_DEALLOC_ACCUM_0 (86060) */
	'D', 'I', 'S', '_', 'D', 'E', 'A', 'L', 'L', 'O', 'C', '_', 'A', 'C', 'C', 'U', 'M', '_', '1', '\0', /* DIS_DEALLOC_ACCUM_1 (86080) */
	'V', 'S', '_', 'W', 'A', 'V', 'E', '_', 'I', 'D', '_', 'E', 'N', '\0', /* VS_WAVE_ID_EN (86100) */
	'P', 'R', 'I', 'M', 'G', 'E', 'N', '_', 'E', 'N', '\0', /* PRIMGEN_EN (86114) */
	'O', 'R', 'D', 'E', 'R', 'E', 'D', '_', 'I', 'D', '_', 'M', 'O', 'D', 'E', '\0', /* ORDERED_ID_MODE (86125) */
	'M', 'A', 'X', '_', 'P', 'R', 'I', 'M', 'G', 'R', 'P', '_', 'I', 'N', '_', 'W', 'A', 'V', 'E', '\0', /* MAX_PRIMGRP_IN_WAVE (86141) */
	'G', 'S', '_', 'F', 'A', 'S', 'T', '_', 'L', 'A', 'U', 'N', 'C', 'H', '\0', /* GS_FAST_LAUNCH (86161) */
	'H', 'S', '_', 'W', '3', '2', '_', 'E', 'N', '\0', /* HS_W32_EN (86176) */
	'G', 'S', '_', 'W', '3', '2', '_', 'E', 'N', '\0', /* GS_W32_EN (86186) */
	'V', 'S', '_', 'W', '3', '2', '_', 'E', 'N', '\0', /* VS_W32_EN (86196) */
	'N', 'G', 'G', '_', 'W', 'A', 'V', 'E', '_', 'I', 'D', '_', 'E', 'N', '\0', /* NGG_WAVE_ID_EN (86206) */
	'P', 'R', 'I', 'M', 'G', 'E', 'N', '_', 'P', 'A', 'S', 'S', 'T', 'H', 'R', 'U', '_', 'E', 'N', '\0', /* PRIMGEN_PASSTHRU_EN (86221) */
	'N', 'U', 'M', '_', 'P', 'A', 'T', 'C', 'H', 'E', 'S', '\0', /* NUM_PATCHES (86241, 86245) */
	'H', 'S', '_', 'N', 'U', 'M', '_', 'I', 'N', 'P', 'U', 'T', '_', 'C', 'P', '\0', /* HS_NUM_INPUT_CP (86253) */
	'H', 'S', '_', 'N', 'U', 'M', '_', 'O', 'U', 'T', 'P', 'U', 'T', '_', 'C', 'P', '\0', /* HS_NUM_OUTPUT_CP (86269) */
	'T', 'E', 'S', 'S', '_', 'I', 'S', 'O', 'L', 'I', 'N', 'E', '\0', /* TESS_ISOLINE (86286) */
	'T', 'E', 'S', 'S', '_', 'T', 'R', 'I', 'A', 'N', 'G', 'L', 'E', '\0', /* TESS_TRIANGLE (86299) */
	'T', 'E', 'S', 'S', '_', 'Q', 'U', 'A', 'D', '\0', /* TESS_QUAD (86313) */
	'P', 'A', 'R', 'T', '_', 'I', 'N', 'T', 'E', 'G', 'E', 'R', '\0', /* PART_INTEGER (86323) */
	'P', 'A', 'R', 'T', '_', 'P', 'O', 'W', '2', '\0', /* PART_POW2 (86336) */
	'P', 'A', 'R', 'T', '_', 'F', 'R', 'A', 'C', '_', 'O', 'D', 'D', '\0', /* PART_FRAC_ODD (86346) */
	'P', 'A', 'R', 'T', '_', 'F', 'R', 'A', 'C', '_', 'E', 'V', 'E', 'N', '\0', /* PART_FRAC_EVEN (86360) */
	'P', 'A', 'R', 'T', 'I', 'T', 'I', 'O', 'N', 'I', 'N', 'G', '\0', /* PARTITIONING (86375) */
	'O', 'U', 'T', 'P', 'U', 'T', '_', 'P', 'O', 'I', 'N', 'T', '\0', /* OUTPUT_POINT (86388) */
	'O', 'U', 'T', 'P', 'U', 'T', '_', 'L', 'I', 'N', 'E', '\0', /* OUTPUT_LINE (86401) */
	'O', 'U', 'T', 'P', 'U', 'T', '_', 'T', 'R', 'I', 'A', 'N', 'G', 'L', 'E', '_', 'C', 'W', '\0', /* OUTPUT_TRIANGLE_CW (86413) */
	'O', 'U', 'T', 'P', 'U', 'T', '_', 'T', 'R', 'I', 'A', 'N', 'G', 'L', 'E', '_', 'C', 'C', 'W', '\0', /* OUTPUT_TRIANGLE_CCW (86432) */
	'T', 'O', 'P', 'O', 'L', 'O', 'G', 'Y', '\0', /* TOPOLOGY (86452) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'R', 'E', 'D', 'U', 'C', '_', 'A', 'X', 'I', 'S', '\0', /* RESERVED_REDUC_AXIS (86461) */
	'D', 'E', 'P', 'R', 'E', 'C', 'A', 'T', 'E', 'D', '\0', /* DEPRECATED (86481) */
	'N', 'U', 'M', '_', 'D', 'S', '_', 'W', 'A', 'V', 'E', 'S', '_', 'P', 'E', 'R', '_', 'S', 'I', 'M', 'D', '\0', /* NUM_DS_WAVES_PER_SIMD (86492) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'D', 'O', 'N', 'U', 'T', 'S', '\0', /* DISABLE_DONUTS (86514, 86522) */
	'N', 'O', '_', 'D', 'I', 'S', 'T', '\0', /* NO_DIST (86529) */
	'T', 'R', 'A', 'P', 'E', 'Z', 'O', 'I', 'D', 'S', '\0', /* TRAPEZOIDS (86537) */
	'D', 'I', 'S', 'T', 'R', 'I', 'B', 'U', 'T', 'I', 'O', 'N', '_', 'M', 'O', 'D', 'E', '\0', /* DISTRIBUTION_MODE (86548) */
	'P', 'R', 'E', '_', 'C', 'L', 'A', 'M', 'P', '_', 'T', 'F', '1', '\0', /* PRE_CLAMP_TF1 (86566) */
	'P', 'O', 'S', 'T', '_', 'C', 'L', 'A', 'M', 'P', '_', 'T', 'F', '1', '\0', /* POST_CLAMP_TF1 (86580) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'T', 'F', '1', '\0', /* DISABLE_TF1 (86595) */
	'D', 'E', 'T', 'E', 'C', 'T', '_', 'O', 'N', 'E', '\0', /* DETECT_ONE (86607) */
	'P', 'R', 'E', '_', 'C', 'L', 'A', 'M', 'P', '_', 'T', 'F', '0', '\0', /* PRE_CLAMP_TF0 (86618) */
	'P', 'O', 'S', 'T', '_', 'C', 'L', 'A', 'M', 'P', '_', 'T', 'F', '0', '\0', /* POST_CLAMP_TF0 (86632) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'T', 'F', '0', '\0', /* DISABLE_TF0 (86647) */
	'D', 'E', 'T', 'E', 'C', 'T', '_', 'Z', 'E', 'R', 'O', '\0', /* DETECT_ZERO (86659) */
	'A', 'L', 'P', 'H', 'A', '_', 'T', 'O', '_', 'M', 'A', 'S', 'K', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* ALPHA_TO_MASK_ENABLE (86671) */
	'A', 'L', 'P', 'H', 'A', '_', 'T', 'O', '_', 'M', 'A', 'S', 'K', '_', 'O', 'F', 'F', 'S', 'E', 'T', '0', '\0', /* ALPHA_TO_MASK_OFFSET0 (86692) */
	'A', 'L', 'P', 'H', 'A', '_', 'T', 'O', '_', 'M', 'A', 'S', 'K', '_', 'O', 'F', 'F', 'S', 'E', 'T', '1', '\0', /* ALPHA_TO_MASK_OFFSET1 (86714) */
	'A', 'L', 'P', 'H', 'A', '_', 'T', 'O', '_', 'M', 'A', 'S', 'K', '_', 'O', 'F', 'F', 'S', 'E', 'T', '2', '\0', /* ALPHA_TO_MASK_OFFSET2 (86736) */
	'A', 'L', 'P', 'H', 'A', '_', 'T', 'O', '_', 'M', 'A', 'S', 'K', '_', 'O', 'F', 'F', 'S', 'E', 'T', '3', '\0', /* ALPHA_TO_MASK_OFFSET3 (86758) */
	'O', 'F', 'F', 'S', 'E', 'T', '_', 'R', 'O', 'U', 'N', 'D', '\0', /* OFFSET_ROUND (86780) */
	'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'N', 'E', 'G', '_', 'N', 'U', 'M', '_', 'D', 'B', '_', 'B', 'I', 'T', 'S', '\0', /* POLY_OFFSET_NEG_NUM_DB_BITS (86793) */
	'P', 'O', 'L', 'Y', '_', 'O', 'F', 'F', 'S', 'E', 'T', '_', 'D', 'B', '_', 'I', 'S', '_', 'F', 'L', 'O', 'A', 'T', '_', 'F', 'M', 'T', '\0', /* POLY_OFFSET_DB_IS_FLOAT_FMT (86821) */
	'E', 'N', '_', 'M', 'A', 'X', '_', 'V', 'E', 'R', 'T', '_', 'O', 'U', 'T', '_', 'P', 'E', 'R', '_', 'G', 'S', '_', 'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', '\0', /* EN_MAX_VERT_OUT_PER_GS_INSTANCE (86849) */
	'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', '_', '0', '_', 'E', 'N', '\0', /* STREAMOUT_0_EN (86881) */
	'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', '_', '1', '_', 'E', 'N', '\0', /* STREAMOUT_1_EN (86896) */
	'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', '_', '2', '_', 'E', 'N', '\0', /* STREAMOUT_2_EN (86911) */
	'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', '_', '3', '_', 'E', 'N', '\0', /* STREAMOUT_3_EN (86926) */
	'R', 'A', 'S', 'T', '_', 'S', 'T', 'R', 'E', 'A', 'M', '\0', /* RAST_STREAM (86941) */
	'E', 'N', '_', 'P', 'R', 'I', 'M', 'S', '_', 'N', 'E', 'E', 'D', 'E', 'D', '_', 'C', 'N', 'T', '\0', /* EN_PRIMS_NEEDED_CNT (86953) */
	'R', 'A', 'S', 'T', '_', 'S', 'T', 'R', 'E', 'A', 'M', '_', 'M', 'A', 'S', 'K', '\0', /* RAST_STREAM_MASK (86973) */
	'U', 'S', 'E', '_', 'R', 'A', 'S', 'T', '_', 'S', 'T', 'R', 'E', 'A', 'M', '_', 'M', 'A', 'S', 'K', '\0', /* USE_RAST_STREAM_MASK (86990) */
	'S', 'T', 'R', 'E', 'A', 'M', '_', '0', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'E', 'N', '\0', /* STREAM_0_BUFFER_EN (87011) */
	'S', 'T', 'R', 'E', 'A', 'M', '_', '1', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'E', 'N', '\0', /* STREAM_1_BUFFER_EN (87030) */
	'S', 'T', 'R', 'E', 'A', 'M', '_', '2', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'E', 'N', '\0', /* STREAM_2_BUFFER_EN (87049) */
	'S', 'T', 'R', 'E', 'A', 'M', '_', '3', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'E', 'N', '\0', /* STREAM_3_BUFFER_EN (87068) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '0', '\0', /* DISTANCE_0 (87087) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '1', '\0', /* DISTANCE_1 (87098) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '2', '\0', /* DISTANCE_2 (87109) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '3', '\0', /* DISTANCE_3 (87120) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '4', '\0', /* DISTANCE_4 (87131) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '5', '\0', /* DISTANCE_5 (87142) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '6', '\0', /* DISTANCE_6 (87153) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '7', '\0', /* DISTANCE_7 (87164) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '8', '\0', /* DISTANCE_8 (87175) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '9', '\0', /* DISTANCE_9 (87186) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '1', '0', '\0', /* DISTANCE_10 (87197) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '1', '1', '\0', /* DISTANCE_11 (87209) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '1', '2', '\0', /* DISTANCE_12 (87221) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '1', '3', '\0', /* DISTANCE_13 (87233) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '1', '4', '\0', /* DISTANCE_14 (87245) */
	'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', '_', '1', '5', '\0', /* DISTANCE_15 (87257) */
	'E', 'X', 'P', 'A', 'N', 'D', '_', 'L', 'I', 'N', 'E', '_', 'W', 'I', 'D', 'T', 'H', '\0', /* EXPAND_LINE_WIDTH (87269) */
	'L', 'A', 'S', 'T', '_', 'P', 'I', 'X', 'E', 'L', '\0', /* LAST_PIXEL (87287) */
	'P', 'E', 'R', 'P', 'E', 'N', 'D', 'I', 'C', 'U', 'L', 'A', 'R', '_', 'E', 'N', 'D', 'C', 'A', 'P', '_', 'E', 'N', 'A', '\0', /* PERPENDICULAR_ENDCAP_ENA (87298) */
	'D', 'X', '1', '0', '_', 'D', 'I', 'A', 'M', 'O', 'N', 'D', '_', 'T', 'E', 'S', 'T', '_', 'E', 'N', 'A', '\0', /* DX10_DIAMOND_TEST_ENA (87323) */
	'E', 'X', 'T', 'R', 'A', '_', 'D', 'X', '_', 'D', 'Y', '_', 'P', 'R', 'E', 'C', 'I', 'S', 'I', 'O', 'N', '\0', /* EXTRA_DX_DY_PRECISION (87345) */
	'M', 'S', 'A', 'A', '_', 'N', 'U', 'M', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '\0', /* MSAA_NUM_SAMPLES (87367) */
	'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '_', 'D', 'T', 'M', 'N', '\0', /* AA_MASK_CENTROID_DTMN (87384) */
	'M', 'A', 'X', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'I', 'S', 'T', '\0', /* MAX_SAMPLE_DIST (87406) */
	'M', 'S', 'A', 'A', '_', 'E', 'X', 'P', 'O', 'S', 'E', 'D', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '\0', /* MSAA_EXPOSED_SAMPLES (87422) */
	'D', 'E', 'T', 'A', 'I', 'L', '_', 'T', 'O', '_', 'E', 'X', 'P', 'O', 'S', 'E', 'D', '_', 'M', 'O', 'D', 'E', '\0', /* DETAIL_TO_EXPOSED_MODE (87443) */
	'I', 'N', 'P', 'U', 'T', '_', 'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '\0', /* INPUT_COVERAGE (87466) */
	'I', 'N', 'P', 'U', 'T', '_', 'I', 'N', 'N', 'E', 'R', '_', 'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '\0', /* INPUT_INNER_COVERAGE (87481) */
	'I', 'N', 'P', 'U', 'T', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '\0', /* INPUT_DEPTH_COVERAGE (87502) */
	'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'T', 'O', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* COVERAGE_TO_SHADER_SELECT (87523) */
	'P', 'I', 'X', '_', 'C', 'E', 'N', 'T', 'E', 'R', '\0', /* PIX_CENTER (87549) */
	'X', '_', 'T', 'R', 'U', 'N', 'C', 'A', 'T', 'E', '\0', /* X_TRUNCATE (87560) */
	'X', '_', 'R', 'O', 'U', 'N', 'D', '\0', /* X_ROUND (87571) */
	'X', '_', 'R', 'O', 'U', 'N', 'D', '_', 'T', 'O', '_', 'E', 'V', 'E', 'N', '\0', /* X_ROUND_TO_EVEN (87579) */
	'X', '_', 'R', 'O', 'U', 'N', 'D', '_', 'T', 'O', '_', 'O', 'D', 'D', '\0', /* X_ROUND_TO_ODD (87595) */
	'R', 'O', 'U', 'N', 'D', '_', 'M', 'O', 'D', 'E', '\0', /* ROUND_MODE (87610) */
	'X', '_', '1', '6', '_', '8', '_', 'F', 'I', 'X', 'E', 'D', '_', 'P', 'O', 'I', 'N', 'T', '_', '1', '_', '1', '6', 'T', 'H', '\0', /* X_16_8_FIXED_POINT_1_16TH (87621) */
	'X', '_', '1', '6', '_', '8', '_', 'F', 'I', 'X', 'E', 'D', '_', 'P', 'O', 'I', 'N', 'T', '_', '1', '_', '8', 'T', 'H', '\0', /* X_16_8_FIXED_POINT_1_8TH (87647) */
	'X', '_', '1', '6', '_', '8', '_', 'F', 'I', 'X', 'E', 'D', '_', 'P', 'O', 'I', 'N', 'T', '_', '1', '_', '4', 'T', 'H', '\0', /* X_16_8_FIXED_POINT_1_4TH (87672) */
	'X', '_', '1', '6', '_', '8', '_', 'F', 'I', 'X', 'E', 'D', '_', 'P', 'O', 'I', 'N', 'T', '_', '1', '_', '2', '\0', /* X_16_8_FIXED_POINT_1_2 (87697) */
	'X', '_', '1', '6', '_', '8', '_', 'F', 'I', 'X', 'E', 'D', '_', 'P', 'O', 'I', 'N', 'T', '_', '1', '\0', /* X_16_8_FIXED_POINT_1 (87720) */
	'X', '_', '1', '6', '_', '8', '_', 'F', 'I', 'X', 'E', 'D', '_', 'P', 'O', 'I', 'N', 'T', '_', '1', '_', '2', '5', '6', 'T', 'H', '\0', /* X_16_8_FIXED_POINT_1_256TH (87741) */
	'X', '_', '1', '4', '_', '1', '0', '_', 'F', 'I', 'X', 'E', 'D', '_', 'P', 'O', 'I', 'N', 'T', '_', '1', '_', '1', '0', '2', '4', 'T', 'H', '\0', /* X_14_10_FIXED_POINT_1_1024TH (87768) */
	'X', '_', '1', '2', '_', '1', '2', '_', 'F', 'I', 'X', 'E', 'D', '_', 'P', 'O', 'I', 'N', 'T', '_', '1', '_', '4', '0', '9', '6', 'T', 'H', '\0', /* X_12_12_FIXED_POINT_1_4096TH (87797) */
	'Q', 'U', 'A', 'N', 'T', '_', 'M', 'O', 'D', 'E', '\0', /* QUANT_MODE (87826) */
	'S', '0', '_', 'X', '\0', /* S0_X (87837) */
	'S', '0', '_', 'Y', '\0', /* S0_Y (87842) */
	'S', '1', '_', 'X', '\0', /* S1_X (87847) */
	'S', '1', '_', 'Y', '\0', /* S1_Y (87852) */
	'S', '2', '_', 'X', '\0', /* S2_X (87857) */
	'S', '2', '_', 'Y', '\0', /* S2_Y (87862) */
	'S', '3', '_', 'X', '\0', /* S3_X (87867) */
	'S', '3', '_', 'Y', '\0', /* S3_Y (87872) */
	'S', '4', '_', 'X', '\0', /* S4_X (87877) */
	'S', '4', '_', 'Y', '\0', /* S4_Y (87882) */
	'S', '5', '_', 'X', '\0', /* S5_X (87887) */
	'S', '5', '_', 'Y', '\0', /* S5_Y (87892) */
	'S', '6', '_', 'X', '\0', /* S6_X (87897) */
	'S', '6', '_', 'Y', '\0', /* S6_Y (87902) */
	'S', '7', '_', 'X', '\0', /* S7_X (87907) */
	'S', '7', '_', 'Y', '\0', /* S7_Y (87912) */
	'S', '8', '_', 'X', '\0', /* S8_X (87917) */
	'S', '8', '_', 'Y', '\0', /* S8_Y (87922) */
	'S', '9', '_', 'X', '\0', /* S9_X (87927) */
	'S', '9', '_', 'Y', '\0', /* S9_Y (87932) */
	'S', '1', '0', '_', 'X', '\0', /* S10_X (87937) */
	'S', '1', '0', '_', 'Y', '\0', /* S10_Y (87943) */
	'S', '1', '1', '_', 'X', '\0', /* S11_X (87949) */
	'S', '1', '1', '_', 'Y', '\0', /* S11_Y (87955) */
	'S', '1', '2', '_', 'X', '\0', /* S12_X (87961) */
	'S', '1', '2', '_', 'Y', '\0', /* S12_Y (87967) */
	'S', '1', '3', '_', 'X', '\0', /* S13_X (87973) */
	'S', '1', '3', '_', 'Y', '\0', /* S13_Y (87979) */
	'S', '1', '4', '_', 'X', '\0', /* S14_X (87985) */
	'S', '1', '4', '_', 'Y', '\0', /* S14_Y (87991) */
	'S', '1', '5', '_', 'X', '\0', /* S15_X (87997) */
	'S', '1', '5', '_', 'Y', '\0', /* S15_Y (88003) */
	'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'X', '0', 'Y', '0', '\0', /* AA_MASK_X0Y0 (88009) */
	'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'X', '1', 'Y', '0', '\0', /* AA_MASK_X1Y0 (88022) */
	'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'X', '0', 'Y', '1', '\0', /* AA_MASK_X0Y1 (88035) */
	'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'X', '1', 'Y', '1', '\0', /* AA_MASK_X1Y1 (88048) */
	'R', 'E', 'A', 'L', 'I', 'G', 'N', '_', 'D', 'Q', 'U', 'A', 'D', 'S', '_', 'A', 'F', 'T', 'E', 'R', '_', 'N', '_', 'W', 'A', 'V', 'E', 'S', '\0', /* REALIGN_DQUADS_AFTER_N_WAVES (88061) */
	'W', 'A', 'V', 'E', '_', 'B', 'R', 'E', 'A', 'K', '_', 'R', 'E', 'G', 'I', 'O', 'N', '_', 'S', 'I', 'Z', 'E', '\0', /* WAVE_BREAK_REGION_SIZE (88090) */
	'B', 'I', 'N', 'N', 'I', 'N', 'G', '_', 'A', 'L', 'L', 'O', 'W', 'E', 'D', '\0', /* BINNING_ALLOWED (88113) */
	'F', 'O', 'R', 'C', 'E', '_', 'B', 'I', 'N', 'N', 'I', 'N', 'G', '_', 'O', 'N', '\0', /* FORCE_BINNING_ON (88129) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'B', 'I', 'N', 'N', 'I', 'N', 'G', '_', 'U', 'S', 'E', '_', 'N', 'E', 'W', '_', 'S', 'C', '\0', /* DISABLE_BINNING_USE_NEW_SC (88146) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'B', 'I', 'N', 'N', 'I', 'N', 'G', '_', 'U', 'S', 'E', '_', 'L', 'E', 'G', 'A', 'C', 'Y', '_', 'S', 'C', '\0', /* DISABLE_BINNING_USE_LEGACY_SC (88173) */
	'B', 'I', 'N', 'N', 'I', 'N', 'G', '_', 'M', 'O', 'D', 'E', '\0', /* BINNING_MODE (88203) */
	'B', 'I', 'N', '_', 'S', 'I', 'Z', 'E', '_', 'X', '\0', /* BIN_SIZE_X (88216) */
	'B', 'I', 'N', '_', 'S', 'I', 'Z', 'E', '_', 'Y', '\0', /* BIN_SIZE_Y (88227) */
	'B', 'I', 'N', '_', 'S', 'I', 'Z', 'E', '_', '3', '2', '_', 'P', 'I', 'X', 'E', 'L', 'S', '\0', /* BIN_SIZE_32_PIXELS (88238) */
	'B', 'I', 'N', '_', 'S', 'I', 'Z', 'E', '_', '6', '4', '_', 'P', 'I', 'X', 'E', 'L', 'S', '\0', /* BIN_SIZE_64_PIXELS (88257) */
	'B', 'I', 'N', '_', 'S', 'I', 'Z', 'E', '_', '1', '2', '8', '_', 'P', 'I', 'X', 'E', 'L', 'S', '\0', /* BIN_SIZE_128_PIXELS (88276) */
	'B', 'I', 'N', '_', 'S', 'I', 'Z', 'E', '_', '2', '5', '6', '_', 'P', 'I', 'X', 'E', 'L', 'S', '\0', /* BIN_SIZE_256_PIXELS (88296) */
	'B', 'I', 'N', '_', 'S', 'I', 'Z', 'E', '_', '5', '1', '2', '_', 'P', 'I', 'X', 'E', 'L', 'S', '\0', /* BIN_SIZE_512_PIXELS (88316) */
	'B', 'I', 'N', '_', 'S', 'I', 'Z', 'E', '_', 'X', '_', 'E', 'X', 'T', 'E', 'N', 'D', '\0', /* BIN_SIZE_X_EXTEND (88336) */
	'B', 'I', 'N', '_', 'S', 'I', 'Z', 'E', '_', 'Y', '_', 'E', 'X', 'T', 'E', 'N', 'D', '\0', /* BIN_SIZE_Y_EXTEND (88354) */
	'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'S', 'T', 'A', 'T', 'E', 'S', '_', 'P', 'E', 'R', '_', 'B', 'I', 'N', '\0', /* CONTEXT_STATES_PER_BIN (88372) */
	'P', 'E', 'R', 'S', 'I', 'S', 'T', 'E', 'N', 'T', '_', 'S', 'T', 'A', 'T', 'E', 'S', '_', 'P', 'E', 'R', '_', 'B', 'I', 'N', '\0', /* PERSISTENT_STATES_PER_BIN (88395) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'S', 'T', 'A', 'R', 'T', '_', 'O', 'F', '_', 'P', 'R', 'I', 'M', '\0', /* DISABLE_START_OF_PRIM (88421) */
	'F', 'P', 'O', 'V', 'S', '_', 'P', 'E', 'R', '_', 'B', 'A', 'T', 'C', 'H', '\0', /* FPOVS_PER_BATCH (88443) */
	'O', 'P', 'T', 'I', 'M', 'A', 'L', '_', 'B', 'I', 'N', '_', 'S', 'E', 'L', 'E', 'C', 'T', 'I', 'O', 'N', '\0', /* OPTIMAL_BIN_SELECTION (88459) */
	'F', 'L', 'U', 'S', 'H', '_', 'O', 'N', '_', 'B', 'I', 'N', 'N', 'I', 'N', 'G', '_', 'T', 'R', 'A', 'N', 'S', 'I', 'T', 'I', 'O', 'N', '\0', /* FLUSH_ON_BINNING_TRANSITION (88481) */
	'B', 'I', 'N', '_', 'M', 'A', 'P', '_', 'M', 'O', 'D', 'E', '_', 'N', 'O', 'N', 'E', '\0', /* BIN_MAP_MODE_NONE (88509) */
	'B', 'I', 'N', '_', 'M', 'A', 'P', '_', 'M', 'O', 'D', 'E', '_', 'R', 'T', 'A', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* BIN_MAP_MODE_RTA_INDEX (88527) */
	'B', 'I', 'N', '_', 'M', 'A', 'P', '_', 'M', 'O', 'D', 'E', '_', 'P', 'O', 'P', 'S', '\0', /* BIN_MAP_MODE_POPS (88550) */
	'B', 'I', 'N', '_', 'M', 'A', 'P', 'P', 'I', 'N', 'G', '_', 'M', 'O', 'D', 'E', '\0', /* BIN_MAPPING_MODE (88568) */
	'M', 'A', 'X', '_', 'A', 'L', 'L', 'O', 'C', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* MAX_ALLOC_COUNT (88585) */
	'M', 'A', 'X', '_', 'P', 'R', 'I', 'M', '_', 'P', 'E', 'R', '_', 'B', 'A', 'T', 'C', 'H', '\0', /* MAX_PRIM_PER_BATCH (88601) */
	'O', 'V', 'E', 'R', '_', 'R', 'A', 'S', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OVER_RAST_ENABLE (88620) */
	'O', 'V', 'E', 'R', '_', 'R', 'A', 'S', 'T', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* OVER_RAST_SAMPLE_SELECT (88637) */
	'U', 'N', 'D', 'E', 'R', '_', 'R', 'A', 'S', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* UNDER_RAST_ENABLE (88661) */
	'U', 'N', 'D', 'E', 'R', '_', 'R', 'A', 'S', 'T', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* UNDER_RAST_SAMPLE_SELECT (88679) */
	'P', 'B', 'B', '_', 'U', 'N', 'C', 'E', 'R', 'T', 'A', 'I', 'N', 'T', 'Y', '_', 'R', 'E', 'G', 'I', 'O', 'N', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* PBB_UNCERTAINTY_REGION_ENABLE (88704) */
	'Z', 'M', 'M', '_', 'T', 'R', 'I', '_', 'E', 'X', 'T', 'E', 'N', 'T', '\0', /* ZMM_TRI_EXTENT (88734) */
	'Z', 'M', 'M', '_', 'T', 'R', 'I', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* ZMM_TRI_OFFSET (88749) */
	'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '_', 'O', 'V', 'E', 'R', '_', 'R', 'A', 'S', 'T', '_', 'I', 'N', 'N', 'E', 'R', '_', 'T', 'O', '_', 'N', 'O', 'R', 'M', 'A', 'L', '\0', /* OVERRIDE_OVER_RAST_INNER_TO_NORMAL (88764) */
	'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '_', 'U', 'N', 'D', 'E', 'R', '_', 'R', 'A', 'S', 'T', '_', 'I', 'N', 'N', 'E', 'R', '_', 'T', 'O', '_', 'N', 'O', 'R', 'M', 'A', 'L', '\0', /* OVERRIDE_UNDER_RAST_INNER_TO_NORMAL (88799) */
	'D', 'E', 'G', 'E', 'N', 'E', 'R', 'A', 'T', 'E', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '_', 'I', 'N', 'N', 'E', 'R', '_', 'T', 'O', '_', 'N', 'O', 'R', 'M', 'A', 'L', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* DEGENERATE_OVERRIDE_INNER_TO_NORMAL_DISABLE (88835) */
	'S', 'C', '_', 'H', 'A', 'L', 'F', '_', 'L', 'S', 'B', '\0', /* SC_HALF_LSB (88879) */
	'S', 'C', '_', 'L', 'S', 'B', '_', 'O', 'N', 'E', '_', 'S', 'I', 'D', 'E', 'D', '\0', /* SC_LSB_ONE_SIDED (88891, 88904) */
	'S', 'C', '_', 'L', 'S', 'B', '_', 'T', 'W', 'O', '_', 'S', 'I', 'D', 'E', 'D', '\0', /* SC_LSB_TWO_SIDED (88908) */
	'U', 'N', 'C', 'E', 'R', 'T', 'A', 'I', 'N', 'T', 'Y', '_', 'R', 'E', 'G', 'I', 'O', 'N', '_', 'M', 'O', 'D', 'E', '\0', /* UNCERTAINTY_REGION_MODE (88925) */
	'O', 'U', 'T', 'E', 'R', '_', 'U', 'N', 'C', 'E', 'R', 'T', 'A', 'I', 'N', 'T', 'Y', '_', 'E', 'D', 'G', 'E', 'R', 'U', 'L', 'E', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* OUTER_UNCERTAINTY_EDGERULE_OVERRIDE (88949) */
	'I', 'N', 'N', 'E', 'R', '_', 'U', 'N', 'C', 'E', 'R', 'T', 'A', 'I', 'N', 'T', 'Y', '_', 'E', 'D', 'G', 'E', 'R', 'U', 'L', 'E', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* INNER_UNCERTAINTY_EDGERULE_OVERRIDE (88985) */
	'N', 'U', 'L', 'L', '_', 'S', 'Q', 'U', 'A', 'D', '_', 'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* NULL_SQUAD_AA_MASK_ENABLE (89021) */
	'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* COVERAGE_AA_MASK_ENABLE (89047) */
	'P', 'R', 'E', 'Z', '_', 'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* PREZ_AA_MASK_ENABLE (89071) */
	'P', 'O', 'S', 'T', 'Z', '_', 'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* POSTZ_AA_MASK_ENABLE (89091) */
	'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* CENTROID_SAMPLE_OVERRIDE (89112) */
	'U', 'N', 'C', 'E', 'R', 'T', 'A', 'I', 'N', 'T', 'Y', '_', 'R', 'E', 'G', 'I', 'O', 'N', '_', 'M', 'U', 'L', 'T', '\0', /* UNCERTAINTY_REGION_MULT (89137) */
	'U', 'N', 'C', 'E', 'R', 'T', 'A', 'I', 'N', 'T', 'Y', '_', 'R', 'E', 'G', 'I', 'O', 'N', '_', 'P', 'B', 'B', '_', 'M', 'U', 'L', 'T', '\0', /* UNCERTAINTY_REGION_PBB_MULT (89161) */
	'M', 'A', 'X', '_', 'D', 'E', 'A', 'L', 'L', 'O', 'C', 'S', '_', 'I', 'N', '_', 'W', 'A', 'V', 'E', '\0', /* MAX_DEALLOCS_IN_WAVE (89189) */
	'M', 'A', 'X', '_', 'F', 'P', 'O', 'V', 'S', '_', 'I', 'N', '_', 'W', 'A', 'V', 'E', '\0', /* MAX_FPOVS_IN_WAVE (89210) */
	'V', 'T', 'X', '_', 'R', 'E', 'U', 'S', 'E', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* VTX_REUSE_DEPTH (89228) */
	'D', 'E', 'A', 'L', 'L', 'O', 'C', '_', 'D', 'I', 'S', 'T', '\0', /* DEALLOC_DIST (89244) */
	'T', 'I', 'L', 'E', '_', 'M', 'A', 'X', '\0', /* TILE_MAX (89257) */
	'F', 'M', 'A', 'S', 'K', '_', 'T', 'I', 'L', 'E', '_', 'M', 'A', 'X', '\0', /* FMASK_TILE_MAX (89266) */
	'M', 'I', 'P', '_', 'L', 'E', 'V', 'E', 'L', '\0', /* MIP_LEVEL (89281) */
	'E', 'N', 'D', 'I', 'A', 'N', '_', 'N', 'O', 'N', 'E', '\0', /* ENDIAN_NONE (89291) */
	'E', 'N', 'D', 'I', 'A', 'N', '_', '8', 'I', 'N', '1', '6', '\0', /* ENDIAN_8IN16 (89303) */
	'E', 'N', 'D', 'I', 'A', 'N', '_', '8', 'I', 'N', '3', '2', '\0', /* ENDIAN_8IN32 (89316) */
	'E', 'N', 'D', 'I', 'A', 'N', '_', '8', 'I', 'N', '6', '4', '\0', /* ENDIAN_8IN64 (89329) */
	'E', 'N', 'D', 'I', 'A', 'N', '\0', /* ENDIAN (89342) */
	'C', 'O', 'L', 'O', 'R', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', '\0', /* COLOR_INVALID (89349) */
	'C', 'O', 'L', 'O', 'R', '_', '8', '\0', /* COLOR_8 (89363) */
	'C', 'O', 'L', 'O', 'R', '_', '1', '6', '\0', /* COLOR_16 (89371) */
	'C', 'O', 'L', 'O', 'R', '_', '8', '_', '8', '\0', /* COLOR_8_8 (89380) */
	'C', 'O', 'L', 'O', 'R', '_', '3', '2', '\0', /* COLOR_32 (89390) */
	'C', 'O', 'L', 'O', 'R', '_', '1', '6', '_', '1', '6', '\0', /* COLOR_16_16 (89399) */
	'C', 'O', 'L', 'O', 'R', '_', '1', '0', '_', '1', '1', '_', '1', '1', '\0', /* COLOR_10_11_11 (89411) */
	'C', 'O', 'L', 'O', 'R', '_', '1', '1', '_', '1', '1', '_', '1', '0', '\0', /* COLOR_11_11_10 (89426) */
	'C', 'O', 'L', 'O', 'R', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', '2', '\0', /* COLOR_10_10_10_2 (89441) */
	'C', 'O', 'L', 'O', 'R', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '\0', /* COLOR_2_10_10_10 (89458) */
	'C', 'O', 'L', 'O', 'R', '_', '8', '_', '8', '_', '8', '_', '8', '\0', /* COLOR_8_8_8_8 (89475) */
	'C', 'O', 'L', 'O', 'R', '_', '3', '2', '_', '3', '2', '\0', /* COLOR_32_32 (89489) */
	'C', 'O', 'L', 'O', 'R', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '\0', /* COLOR_16_16_16_16 (89501) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '3', '\0', /* COLOR_RESERVED_13 (89519) */
	'C', 'O', 'L', 'O', 'R', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', '3', '2', '\0', /* COLOR_32_32_32_32 (89537) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '5', '\0', /* COLOR_RESERVED_15 (89555) */
	'C', 'O', 'L', 'O', 'R', '_', '5', '_', '6', '_', '5', '\0', /* COLOR_5_6_5 (89573) */
	'C', 'O', 'L', 'O', 'R', '_', '1', '_', '5', '_', '5', '_', '5', '\0', /* COLOR_1_5_5_5 (89585) */
	'C', 'O', 'L', 'O', 'R', '_', '5', '_', '5', '_', '5', '_', '1', '\0', /* COLOR_5_5_5_1 (89599) */
	'C', 'O', 'L', 'O', 'R', '_', '4', '_', '4', '_', '4', '_', '4', '\0', /* COLOR_4_4_4_4 (89613) */
	'C', 'O', 'L', 'O', 'R', '_', '8', '_', '2', '4', '\0', /* COLOR_8_24 (89627) */
	'C', 'O', 'L', 'O', 'R', '_', '2', '4', '_', '8', '\0', /* COLOR_24_8 (89638) */
	'C', 'O', 'L', 'O', 'R', '_', 'X', '2', '4', '_', '8', '_', '3', '2', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* COLOR_X24_8_32_FLOAT (89649) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '3', '\0', /* COLOR_RESERVED_23 (89670) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '4', '\0', /* COLOR_RESERVED_24 (89688) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '5', '\0', /* COLOR_RESERVED_25 (89706) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '6', '\0', /* COLOR_RESERVED_26 (89724) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '7', '\0', /* COLOR_RESERVED_27 (89742) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '8', '\0', /* COLOR_RESERVED_28 (89760) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '9', '\0', /* COLOR_RESERVED_29 (89778) */
	'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '3', '0', '\0', /* COLOR_RESERVED_30 (89796) */
	'C', 'O', 'L', 'O', 'R', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', '6', 'E', '4', '\0', /* COLOR_2_10_10_10_6E4 (89814) */
	'N', 'U', 'M', 'B', 'E', 'R', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* NUMBER_UNORM (89835) */
	'N', 'U', 'M', 'B', 'E', 'R', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* NUMBER_SNORM (89848) */
	'N', 'U', 'M', 'B', 'E', 'R', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* NUMBER_USCALED (89861) */
	'N', 'U', 'M', 'B', 'E', 'R', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* NUMBER_SSCALED (89876) */
	'N', 'U', 'M', 'B', 'E', 'R', '_', 'U', 'I', 'N', 'T', '\0', /* NUMBER_UINT (89891) */
	'N', 'U', 'M', 'B', 'E', 'R', '_', 'S', 'I', 'N', 'T', '\0', /* NUMBER_SINT (89903) */
	'N', 'U', 'M', 'B', 'E', 'R', '_', 'S', 'R', 'G', 'B', '\0', /* NUMBER_SRGB (89915) */
	'N', 'U', 'M', 'B', 'E', 'R', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* NUMBER_FLOAT (89927) */
	'N', 'U', 'M', 'B', 'E', 'R', '_', 'T', 'Y', 'P', 'E', '\0', /* NUMBER_TYPE (89940) */
	'S', 'W', 'A', 'P', '_', 'S', 'T', 'D', '\0', /* SWAP_STD (89952) */
	'S', 'W', 'A', 'P', '_', 'A', 'L', 'T', '\0', /* SWAP_ALT (89961) */
	'S', 'W', 'A', 'P', '_', 'S', 'T', 'D', '_', 'R', 'E', 'V', '\0', /* SWAP_STD_REV (89970) */
	'S', 'W', 'A', 'P', '_', 'A', 'L', 'T', '_', 'R', 'E', 'V', '\0', /* SWAP_ALT_REV (89983) */
	'C', 'O', 'M', 'P', '_', 'S', 'W', 'A', 'P', '\0', /* COMP_SWAP (89996) */
	'B', 'L', 'E', 'N', 'D', '_', 'C', 'L', 'A', 'M', 'P', '\0', /* BLEND_CLAMP (90006) */
	'B', 'L', 'E', 'N', 'D', '_', 'B', 'Y', 'P', 'A', 'S', 'S', '\0', /* BLEND_BYPASS (90018) */
	'S', 'I', 'M', 'P', 'L', 'E', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* SIMPLE_FLOAT (90031) */
	'C', 'M', 'A', 'S', 'K', '_', 'I', 'S', '_', 'L', 'I', 'N', 'E', 'A', 'R', '\0', /* CMASK_IS_LINEAR (90044, 90053) */
	'F', 'O', 'R', 'C', 'E', '_', 'O', 'P', 'T', '_', 'A', 'U', 'T', 'O', '\0', /* FORCE_OPT_AUTO (90060) */
	'F', 'O', 'R', 'C', 'E', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* FORCE_OPT_DISABLE (90075) */
	'F', 'O', 'R', 'C', 'E', '_', 'O', 'P', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'I', 'F', '_', 'S', 'R', 'C', '_', 'A', '_', '0', '\0', /* FORCE_OPT_ENABLE_IF_SRC_A_0 (90093) */
	'F', 'O', 'R', 'C', 'E', '_', 'O', 'P', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'I', 'F', '_', 'S', 'R', 'C', '_', 'R', 'G', 'B', '_', '0', '\0', /* FORCE_OPT_ENABLE_IF_SRC_RGB_0 (90121) */
	'F', 'O', 'R', 'C', 'E', '_', 'O', 'P', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'I', 'F', '_', 'S', 'R', 'C', '_', 'A', 'R', 'G', 'B', '_', '0', '\0', /* FORCE_OPT_ENABLE_IF_SRC_ARGB_0 (90151) */
	'F', 'O', 'R', 'C', 'E', '_', 'O', 'P', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'I', 'F', '_', 'S', 'R', 'C', '_', 'A', '_', '1', '\0', /* FORCE_OPT_ENABLE_IF_SRC_A_1 (90182) */
	'F', 'O', 'R', 'C', 'E', '_', 'O', 'P', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'I', 'F', '_', 'S', 'R', 'C', '_', 'R', 'G', 'B', '_', '1', '\0', /* FORCE_OPT_ENABLE_IF_SRC_RGB_1 (90210) */
	'F', 'O', 'R', 'C', 'E', '_', 'O', 'P', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'I', 'F', '_', 'S', 'R', 'C', '_', 'A', 'R', 'G', 'B', '_', '1', '\0', /* FORCE_OPT_ENABLE_IF_SRC_ARGB_1 (90240) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'D', 'O', 'N', 'T', '_', 'R', 'D', '_', 'D', 'S', 'T', '\0', /* BLEND_OPT_DONT_RD_DST (90271) */
	'B', 'L', 'E', 'N', 'D', '_', 'O', 'P', 'T', '_', 'D', 'I', 'S', 'C', 'A', 'R', 'D', '_', 'P', 'I', 'X', 'E', 'L', '\0', /* BLEND_OPT_DISCARD_PIXEL (90293) */
	'F', 'M', 'A', 'S', 'K', '_', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', 'I', 'O', 'N', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* FMASK_COMPRESSION_DISABLE (90317) */
	'F', 'M', 'A', 'S', 'K', '_', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '_', '1', 'F', 'R', 'A', 'G', '_', 'O', 'N', 'L', 'Y', '\0', /* FMASK_COMPRESS_1FRAG_ONLY (90343) */
	'D', 'C', 'C', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* DCC_ENABLE (90369) */
	'C', 'M', 'A', 'S', 'K', '_', 'A', 'D', 'D', 'R', '_', 'T', 'I', 'L', 'E', 'D', '\0', /* CMASK_ADDR_TILED (90380) */
	'C', 'M', 'A', 'S', 'K', '_', 'A', 'D', 'D', 'R', '_', 'L', 'I', 'N', 'E', 'A', 'R', '\0', /* CMASK_ADDR_LINEAR (90397) */
	'C', 'M', 'A', 'S', 'K', '_', 'A', 'D', 'D', 'R', '_', 'C', 'O', 'M', 'P', 'A', 'T', 'I', 'B', 'L', 'E', '\0', /* CMASK_ADDR_COMPATIBLE (90415) */
	'C', 'M', 'A', 'S', 'K', '_', 'A', 'D', 'D', 'R', '_', 'T', 'Y', 'P', 'E', '\0', /* CMASK_ADDR_TYPE (90437) */
	'A', 'L', 'T', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '\0', /* ALT_TILE_MODE (90453) */
	'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* TILE_MODE_INDEX (90467) */
	'F', 'M', 'A', 'S', 'K', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* FMASK_TILE_MODE_INDEX (90483) */
	'F', 'M', 'A', 'S', 'K', '_', 'B', 'A', 'N', 'K', '_', 'H', 'E', 'I', 'G', 'H', 'T', '\0', /* FMASK_BANK_HEIGHT (90505) */
	'N', 'U', 'M', '_', 'F', 'R', 'A', 'G', 'M', 'E', 'N', 'T', 'S', '\0', /* NUM_FRAGMENTS (90523) */
	'F', 'O', 'R', 'C', 'E', '_', 'D', 'S', 'T', '_', 'A', 'L', 'P', 'H', 'A', '_', '1', '\0', /* FORCE_DST_ALPHA_1 (90537) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'F', 'M', 'A', 'S', 'K', '_', 'N', 'O', 'F', 'E', 'T', 'C', 'H', '_', 'O', 'P', 'T', '\0', /* DISABLE_FMASK_NOFETCH_OPT (90555) */
	'L', 'I', 'M', 'I', 'T', '_', 'C', 'O', 'L', 'O', 'R', '_', 'F', 'E', 'T', 'C', 'H', '_', 'T', 'O', '_', '2', '5', '6', 'B', '_', 'M', 'A', 'X', '\0', /* LIMIT_COLOR_FETCH_TO_256B_MAX (90581) */
	'K', 'E', 'Y', '_', 'C', 'L', 'E', 'A', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* KEY_CLEAR_ENABLE (90611) */
	'M', 'A', 'X', '_', 'B', 'L', 'O', 'C', 'K', '_', 'S', 'I', 'Z', 'E', '_', '6', '4', 'B', '\0', /* MAX_BLOCK_SIZE_64B (90628) */
	'M', 'A', 'X', '_', 'B', 'L', 'O', 'C', 'K', '_', 'S', 'I', 'Z', 'E', '_', '1', '2', '8', 'B', '\0', /* MAX_BLOCK_SIZE_128B (90647) */
	'M', 'A', 'X', '_', 'B', 'L', 'O', 'C', 'K', '_', 'S', 'I', 'Z', 'E', '_', '2', '5', '6', 'B', '\0', /* MAX_BLOCK_SIZE_256B (90667) */
	'M', 'I', 'N', '_', 'B', 'L', 'O', 'C', 'K', '_', 'S', 'I', 'Z', 'E', '_', '3', '2', 'B', '\0', /* MIN_BLOCK_SIZE_32B (90687) */
	'M', 'I', 'N', '_', 'B', 'L', 'O', 'C', 'K', '_', 'S', 'I', 'Z', 'E', '_', '6', '4', 'B', '\0', /* MIN_BLOCK_SIZE_64B (90706) */
	'M', 'I', 'N', '_', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', 'E', 'D', '_', 'B', 'L', 'O', 'C', 'K', '_', 'S', 'I', 'Z', 'E', '\0', /* MIN_COMPRESSED_BLOCK_SIZE (90725) */
	'I', 'N', 'D', 'E', 'P', 'E', 'N', 'D', 'E', 'N', 'T', '_', '6', '4', 'B', '_', 'B', 'L', 'O', 'C', 'K', 'S', '\0', /* INDEPENDENT_64B_BLOCKS (90751) */
	'L', 'O', 'S', 'S', 'Y', '_', 'R', 'G', 'B', '_', 'P', 'R', 'E', 'C', 'I', 'S', 'I', 'O', 'N', '\0', /* LOSSY_RGB_PRECISION (90774) */
	'L', 'O', 'S', 'S', 'Y', '_', 'A', 'L', 'P', 'H', 'A', '_', 'P', 'R', 'E', 'C', 'I', 'S', 'I', 'O', 'N', '\0', /* LOSSY_ALPHA_PRECISION (90794) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'C', 'O', 'N', 'S', 'T', 'A', 'N', 'T', '_', 'E', 'N', 'C', 'O', 'D', 'E', '_', 'R', 'E', 'G', '_', 'W', 'R', 'I', 'T', 'E', '\0', /* ENABLE_CONSTANT_ENCODE_REG_WRITE (90816) */
	'I', 'N', 'D', 'E', 'P', 'E', 'N', 'D', 'E', 'N', 'T', '_', '1', '2', '8', 'B', '_', 'B', 'L', 'O', 'C', 'K', 'S', '\0', /* INDEPENDENT_128B_BLOCKS (90849) */
	'B', 'A', 'S', 'E', '_', '2', '5', '6', 'B', '\0', /* BASE_256B (90873) */
	'M', 'I', 'P', '0', '_', 'H', 'E', 'I', 'G', 'H', 'T', '\0', /* MIP0_HEIGHT (90883) */
	'M', 'I', 'P', '0', '_', 'W', 'I', 'D', 'T', 'H', '\0', /* MIP0_WIDTH (90895) */
	'M', 'I', 'P', '0', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* MIP0_DEPTH (90906) */
	'M', 'E', 'T', 'A', '_', 'L', 'I', 'N', 'E', 'A', 'R', '\0', /* META_LINEAR (90917) */
	'C', 'O', 'L', 'O', 'R', '_', 'S', 'W', '_', 'M', 'O', 'D', 'E', '\0', /* COLOR_SW_MODE (90929) */
	'F', 'M', 'A', 'S', 'K', '_', 'S', 'W', '_', 'M', 'O', 'D', 'E', '\0', /* FMASK_SW_MODE (90943) */
	'R', 'E', 'S', 'O', 'U', 'R', 'C', 'E', '_', 'T', 'Y', 'P', 'E', '\0', /* RESOURCE_TYPE (90957) */
	'C', 'M', 'A', 'S', 'K', '_', 'P', 'I', 'P', 'E', '_', 'A', 'L', 'I', 'G', 'N', 'E', 'D', '\0', /* CMASK_PIPE_ALIGNED (90971) */
	'D', 'C', 'C', '_', 'P', 'I', 'P', 'E', '_', 'A', 'L', 'I', 'G', 'N', 'E', 'D', '\0', /* DCC_PIPE_ALIGNED (90990) */
	'D', 'O', 'O', 'R', 'B', 'E', 'L', 'L', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* DOORBELL_OFFSET (91007) */
	'C', 'A', 'C', 'H', 'E', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* CACHE_POLICY (91023) */
	'O', 'F', 'F', 'S', 'E', 'T', '_', 'U', 'P', 'D', 'A', 'T', 'E', '_', 'D', 'O', 'N', 'E', '\0', /* OFFSET_UPDATE_DONE (91036) */
	'O', 'B', 'S', 'O', 'L', 'E', 'T', 'E', '_', 'U', 'M', 'S', 'K', '\0', /* OBSOLETE_UMSK (91055) */
	'O', 'B', 'S', 'O', 'L', 'E', 'T', 'E', '_', 'S', 'W', 'A', 'P', '\0', /* OBSOLETE_SWAP (91069) */
	'M', 'E', 'M', '_', 'A', 'D', 'D', 'R', '_', 'L', 'O', '\0', /* MEM_ADDR_LO (91083) */
	'M', 'E', 'M', '_', 'A', 'D', 'D', 'R', '_', 'H', 'I', '\0', /* MEM_ADDR_HI (91095) */
	'C', 'S', '_', 'P', 'S', '_', 'S', 'E', 'L', '\0', /* CS_PS_SEL (91107) */
	'S', 'E', 'M', '_', 'A', 'D', 'D', 'R', '_', 'S', 'W', 'A', 'P', '\0', /* SEM_ADDR_SWAP (91117, 91121) */
	'S', 'E', 'M', '_', 'U', 'S', 'E', '_', 'M', 'A', 'I', 'L', 'B', 'O', 'X', '\0', /* SEM_USE_MAILBOX (91131) */
	'S', 'E', 'M', '_', 'S', 'I', 'G', 'N', 'A', 'L', '_', 'T', 'Y', 'P', 'E', '\0', /* SEM_SIGNAL_TYPE (91147) */
	'S', 'E', 'M', '_', 'C', 'L', 'I', 'E', 'N', 'T', '_', 'C', 'O', 'D', 'E', '\0', /* SEM_CLIENT_CODE (91163) */
	'S', 'E', 'M', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SEM_SELECT (91179) */
	'M', 'E', 'M', 'L', 'O', 'G', '_', 'C', 'L', 'E', 'A', 'R', '\0', /* MEMLOG_CLEAR (91190) */
	'S', 'R', 'C', '_', 'C', 'A', 'C', 'H', 'E', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* SRC_CACHE_POLICY (91203) */
	'S', 'R', 'C', '_', 'V', 'O', 'L', 'A', 'T', 'L', 'E', '\0', /* SRC_VOLATLE (91220) */
	'D', 'S', 'T', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* DST_SELECT (91232) */
	'D', 'S', 'T', '_', 'C', 'A', 'C', 'H', 'E', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* DST_CACHE_POLICY (91243) */
	'D', 'S', 'T', '_', 'V', 'O', 'L', 'A', 'T', 'L', 'E', '\0', /* DST_VOLATLE (91260) */
	'S', 'R', 'C', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* SRC_SELECT (91272) */
	'C', 'O', 'H', 'E', 'R', '_', 'B', 'A', 'S', 'E', '_', 'H', 'I', '_', '2', '5', '6', 'B', '\0', /* COHER_BASE_HI_256B (91283) */
	'S', 'T', 'A', 'R', 'T', '_', 'D', 'E', 'L', 'A', 'Y', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* START_DELAY_COUNT (91302) */
	'T', 'C', '_', 'N', 'C', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* TC_NC_ACTION_ENA (91320) */
	'T', 'C', '_', 'W', 'C', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* TC_WC_ACTION_ENA (91337) */
	'T', 'C', '_', 'I', 'N', 'V', '_', 'M', 'E', 'T', 'A', 'D', 'A', 'T', 'A', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* TC_INV_METADATA_ACTION_ENA (91354) */
	'T', 'C', 'L', '1', '_', 'V', 'O', 'L', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* TCL1_VOL_ACTION_ENA (91381) */
	'T', 'C', '_', 'W', 'B', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* TC_WB_ACTION_ENA (91401) */
	'T', 'C', 'L', '1', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* TCL1_ACTION_ENA (91418) */
	'T', 'C', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* TC_ACTION_ENA (91434) */
	'C', 'B', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* CB_ACTION_ENA (91448) */
	'D', 'B', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* DB_ACTION_ENA (91462) */
	'S', 'H', '_', 'K', 'C', 'A', 'C', 'H', 'E', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* SH_KCACHE_ACTION_ENA (91476) */
	'S', 'H', '_', 'K', 'C', 'A', 'C', 'H', 'E', '_', 'V', 'O', 'L', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* SH_KCACHE_VOL_ACTION_ENA (91497) */
	'S', 'H', '_', 'I', 'C', 'A', 'C', 'H', 'E', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* SH_ICACHE_ACTION_ENA (91522) */
	'S', 'H', '_', 'K', 'C', 'A', 'C', 'H', 'E', '_', 'W', 'B', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* SH_KCACHE_WB_ACTION_ENA (91543) */
	'M', 'E', 'I', 'D', '\0', /* MEID (91567) */
	'B', 'Y', 'T', 'E', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* BYTE_COUNT (91572) */
	'S', 'A', 'S', '\0', /* SAS (91583) */
	'D', 'A', 'S', '\0', /* DAS (91587) */
	'S', 'A', 'I', 'C', '\0', /* SAIC (91591) */
	'D', 'A', 'I', 'C', '\0', /* DAIC (91596) */
	'R', 'A', 'W', '_', 'W', 'A', 'I', 'T', '\0', /* RAW_WAIT (91601) */
	'D', 'I', 'S', '_', 'W', 'C', '\0', /* DIS_WC (91610) */
	'U', 'T', 'C', 'L', '1', '_', 'F', 'A', 'U', 'L', 'T', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* UTCL1_FAULT_CONTROL (91617) */
	'W', 'A', 'T', 'C', 'H', '_', 'C', 'O', 'N', 'T', 'R', 'O', 'L', '\0', /* WATCH_CONTROL (91637) */
	'M', 'I', 'N', '_', 'A', 'V', 'A', 'I', 'L', 'S', 'Z', '\0', /* MIN_AVAILSZ (91651) */
	'B', 'U', 'F', 'F', 'E', 'R', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* BUFFER_DEPTH (91663) */
	'P', 'I', 'O', '_', 'F', 'I', 'F', 'O', '_', 'E', 'M', 'P', 'T', 'Y', '\0', /* PIO_FIFO_EMPTY (91676) */
	'P', 'I', 'O', '_', 'F', 'I', 'F', 'O', '_', 'F', 'U', 'L', 'L', '\0', /* PIO_FIFO_FULL (91691) */
	'P', 'I', 'O', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* PIO_COUNT (91705) */
	'D', 'M', 'A', '_', 'R', 'E', 'A', 'D', '_', 'T', 'A', 'G', '\0', /* DMA_READ_TAG (91715) */
	'D', 'M', 'A', '_', 'R', 'E', 'A', 'D', '_', 'T', 'A', 'G', '_', 'V', 'A', 'L', 'I', 'D', '\0', /* DMA_READ_TAG_VALID (91728) */
	'C', 'O', 'H', 'E', 'R', '_', 'S', 'I', 'Z', 'E', '_', 'H', 'I', '_', '2', '5', '6', 'B', '\0', /* COHER_SIZE_HI_256B (91747) */
	'I', 'B', '_', 'E', 'N', '\0', /* IB_EN (91766) */
	'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'E', 'G', '_', 'E', 'N', '\0', /* CONFIG_REG_EN (91772) */
	'C', 'N', 'T', 'X', '_', 'R', 'E', 'G', '_', 'E', 'N', '\0', /* CNTX_REG_EN (91786) */
	'S', 'H', '_', 'G', 'F', 'X', '_', 'R', 'E', 'G', '_', 'E', 'N', '\0', /* SH_GFX_REG_EN (91798) */
	'S', 'H', '_', 'C', 'S', '_', 'R', 'E', 'G', '_', 'E', 'N', '\0', /* SH_CS_REG_EN (91812) */
	'R', 'S', 'V', 'D', '\0', /* RSVD (91825) */
	'I', 'N', 'I', 'T', '_', 'C', 'M', 'D', '_', 'R', 'E', 'Q', 'S', 'Z', '\0', /* INIT_CMD_REQSZ (91830) */
	'I', 'B', '1', '_', 'C', 'M', 'D', '_', 'R', 'E', 'Q', 'S', 'Z', '\0', /* IB1_CMD_REQSZ (91845) */
	'I', 'B', '2', '_', 'C', 'M', 'D', '_', 'R', 'E', 'Q', 'S', 'Z', '\0', /* IB2_CMD_REQSZ (91859) */
	'S', 'T', '_', 'C', 'M', 'D', '_', 'R', 'E', 'Q', 'S', 'Z', '\0', /* ST_CMD_REQSZ (91873) */
	'E', 'O', 'P', '_', 'V', 'O', 'L', 'A', 'T', 'I', 'L', 'E', '\0', /* EOP_VOLATILE (91886) */
	'E', 'X', 'E', 'C', 'U', 'T', 'E', '\0', /* EXECUTE (91899) */
	'D', 'S', 'T', '_', 'S', 'E', 'L', '\0', /* DST_SEL (91907) */
	'I', 'N', 'T', '_', 'S', 'E', 'L', '\0', /* INT_SEL (91915) */
	'D', 'A', 'T', 'A', '_', 'S', 'E', 'L', '\0', /* DATA_SEL (91923) */
	'D', 'B', '_', 'C', 'M', 'D', '_', 'R', 'E', 'Q', 'S', 'Z', '\0', /* DB_CMD_REQSZ (91932) */
	'Z', '_', 'P', 'A', 'S', 'S', '_', 'A', 'C', 'I', 'T', 'V', 'E', '\0', /* Z_PASS_ACITVE (91945) */
	'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', '_', 'A', 'C', 'T', 'I', 'V', 'E', '\0', /* STREAMOUT_ACTIVE (91959) */
	'P', 'I', 'P', 'E', 'L', 'I', 'N', 'E', '_', 'A', 'C', 'T', 'I', 'V', 'E', '\0', /* PIPELINE_ACTIVE (91976) */
	'S', 'T', 'I', 'P', 'P', 'L', 'E', '_', 'A', 'C', 'T', 'I', 'V', 'E', '\0', /* STIPPLE_ACTIVE (91992) */
	'V', 'G', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', 'S', '_', 'A', 'C', 'T', 'I', 'V', 'E', '\0', /* VGT_BUFFERS_ACTIVE (92007) */
	'S', 'C', 'R', 'E', 'E', 'N', '_', 'E', 'X', 'T', '_', 'A', 'C', 'T', 'I', 'V', 'E', '\0', /* SCREEN_EXT_ACTIVE (92026) */
	'D', 'R', 'A', 'W', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '_', 'A', 'C', 'T', 'I', 'V', 'E', '\0', /* DRAW_INDIRECT_ACTIVE (92044) */
	'D', 'I', 'S', 'P', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '_', 'A', 'C', 'T', 'I', 'V', 'E', '\0', /* DISP_INDIRECT_ACTIVE (92065) */
	'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', '0', '_', 'E', 'N', 'A', '\0', /* DEST_BASE_0_ENA (92086) */
	'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', '1', '_', 'E', 'N', 'A', '\0', /* DEST_BASE_1_ENA (92102) */
	'C', 'B', '0', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'E', 'N', 'A', '\0', /* CB0_DEST_BASE_ENA (92118) */
	'C', 'B', '1', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'E', 'N', 'A', '\0', /* CB1_DEST_BASE_ENA (92136) */
	'C', 'B', '2', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'E', 'N', 'A', '\0', /* CB2_DEST_BASE_ENA (92154) */
	'C', 'B', '3', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'E', 'N', 'A', '\0', /* CB3_DEST_BASE_ENA (92172) */
	'C', 'B', '4', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'E', 'N', 'A', '\0', /* CB4_DEST_BASE_ENA (92190) */
	'C', 'B', '5', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'E', 'N', 'A', '\0', /* CB5_DEST_BASE_ENA (92208) */
	'C', 'B', '6', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'E', 'N', 'A', '\0', /* CB6_DEST_BASE_ENA (92226) */
	'C', 'B', '7', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'E', 'N', 'A', '\0', /* CB7_DEST_BASE_ENA (92244) */
	'D', 'B', '_', 'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', 'E', 'N', 'A', '\0', /* DB_DEST_BASE_ENA (92262) */
	'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', '2', '_', 'E', 'N', 'A', '\0', /* DEST_BASE_2_ENA (92279) */
	'D', 'E', 'S', 'T', '_', 'B', 'A', 'S', 'E', '_', '3', '_', 'E', 'N', 'A', '\0', /* DEST_BASE_3_ENA (92295) */
	'M', 'A', 'T', 'C', 'H', 'I', 'N', 'G', '_', 'G', 'F', 'X', '_', 'C', 'N', 'T', 'X', '\0', /* MATCHING_GFX_CNTX (92311) */
	'F', 'E', 'A', 'T', 'U', 'R', 'E', '_', 'S', 'E', 'L', '\0', /* FEATURE_SEL (92329) */
	'S', 'E', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* SE_INDEX (92341) */
	'S', 'A', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* SA_INDEX (92350) */
	'W', 'G', 'P', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* WGP_INDEX (92359) */
	'E', 'V', 'E', 'N', 'T', '_', 'S', 'E', 'L', '\0', /* EVENT_SEL (92369) */
	'U', 'N', 'U', 'S', 'E', 'D', '\0', /* UNUSED (92379) */
	'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* INSTANCE_INDEX (92386) */
	'S', 'A', '_', 'B', 'R', 'O', 'A', 'D', 'C', 'A', 'S', 'T', '_', 'W', 'R', 'I', 'T', 'E', 'S', '\0', /* SA_BROADCAST_WRITES (92401) */
	'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', '_', 'B', 'R', 'O', 'A', 'D', 'C', 'A', 'S', 'T', '_', 'W', 'R', 'I', 'T', 'E', 'S', '\0', /* INSTANCE_BROADCAST_WRITES (92421) */
	'S', 'E', '_', 'B', 'R', 'O', 'A', 'D', 'C', 'A', 'S', 'T', '_', 'W', 'R', 'I', 'T', 'E', 'S', '\0', /* SE_BROADCAST_WRITES (92447) */
	'O', 'F', 'F', 'C', 'H', 'I', 'P', '_', 'B', 'U', 'F', 'F', 'E', 'R', 'I', 'N', 'G', '\0', /* OFFCHIP_BUFFERING (92467) */
	'X', '_', '8', 'K', '_', 'D', 'W', 'O', 'R', 'D', 'S', '\0', /* X_8K_DWORDS (92485) */
	'X', '_', '4', 'K', '_', 'D', 'W', 'O', 'R', 'D', 'S', '\0', /* X_4K_DWORDS (92497) */
	'X', '_', '2', 'K', '_', 'D', 'W', 'O', 'R', 'D', 'S', '\0', /* X_2K_DWORDS (92509) */
	'X', '_', '1', 'K', '_', 'D', 'W', 'O', 'R', 'D', 'S', '\0', /* X_1K_DWORDS (92521) */
	'O', 'F', 'F', 'C', 'H', 'I', 'P', '_', 'G', 'R', 'A', 'N', 'U', 'L', 'A', 'R', 'I', 'T', 'Y', '\0', /* OFFCHIP_GRANULARITY (92533) */
	'E', 'N', '_', 'I', 'N', 'S', 'T', '_', 'O', 'P', 'T', '_', 'B', 'A', 'S', 'I', 'C', '\0', /* EN_INST_OPT_BASIC (92553) */
	'E', 'N', '_', 'I', 'N', 'S', 'T', '_', 'O', 'P', 'T', '_', 'A', 'D', 'V', '\0', /* EN_INST_OPT_ADV (92571) */
	'H', 'W', '_', 'U', 'S', 'E', '_', 'O', 'N', 'L', 'Y', '\0', /* HW_USE_ONLY (92587) */
	'P', 'R', 'I', 'M', '_', 'G', 'R', 'P', '_', 'S', 'I', 'Z', 'E', '\0', /* PRIM_GRP_SIZE (92599) */
	'V', 'E', 'R', 'T', '_', 'G', 'R', 'P', '_', 'S', 'I', 'Z', 'E', '\0', /* VERT_GRP_SIZE (92613) */
	'B', 'R', 'E', 'A', 'K', '_', 'W', 'A', 'V', 'E', '_', 'A', 'T', '_', 'E', 'O', 'I', '\0', /* BREAK_WAVE_AT_EOI (92627) */
	'P', 'A', 'C', 'K', 'E', 'T', '_', 'T', 'O', '_', 'O', 'N', 'E', '_', 'P', 'A', '\0', /* PACKET_TO_ONE_PA (92645) */
	'R', 'T', '_', 'S', 'L', 'I', 'C', 'E', '\0', /* RT_SLICE (92662) */
	'V', 'I', 'E', 'W', 'P', 'O', 'R', 'T', '\0', /* VIEWPORT (92671) */
	'E', 'N', '_', 'S', 'T', 'E', 'R', 'E', 'O', '\0', /* EN_STEREO (92680) */
	'O', 'V', 'E', 'R', 'S', 'U', 'B', '_', 'E', 'N', '\0', /* OVERSUB_EN (92690) */
	'N', 'U', 'M', '_', 'P', 'C', '_', 'L', 'I', 'N', 'E', 'S', '\0', /* NUM_PC_LINES (92701) */
	'E', 'N', '_', 'U', 'S', 'E', 'R', '_', 'V', 'G', 'P', 'R', '1', '\0', /* EN_USER_VGPR1 (92714) */
	'E', 'N', '_', 'U', 'S', 'E', 'R', '_', 'V', 'G', 'P', 'R', '2', '\0', /* EN_USER_VGPR2 (92728) */
	'E', 'N', '_', 'U', 'S', 'E', 'R', '_', 'V', 'G', 'P', 'R', '3', '\0', /* EN_USER_VGPR3 (92742) */
	'C', 'U', 'R', 'R', 'E', 'N', 'T', '_', 'P', 'T', 'R', '\0', /* CURRENT_PTR (92756) */
	'C', 'U', 'R', 'R', 'E', 'N', 'T', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* CURRENT_COUNT (92768) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'H', 'V', '_', 'P', 'R', 'E', '_', 'S', 'H', 'A', 'D', 'E', 'R', '\0', /* ENABLE_HV_PRE_SHADER (92782) */
	'F', 'O', 'R', 'C', 'E', '_', 'P', 'R', 'E', '_', 'S', 'H', 'A', 'D', 'E', 'R', '_', 'A', 'L', 'L', '_', 'P', 'I', 'X', 'E', 'L', 'S', '\0', /* FORCE_PRE_SHADER_ALL_PIXELS (92803) */
	'X', '_', 'C', 'O', 'O', 'R', 'D', '\0', /* X_COORD (92831) */
	'Y', '_', 'C', 'O', 'O', 'R', 'D', '\0', /* Y_COORD (92839) */
	'T', 'A', 'R', 'G', 'E', 'T', '_', 'I', 'N', 'S', 'T', '\0', /* TARGET_INST (92847) */
	'T', 'A', 'R', 'G', 'E', 'T', '_', 'D', 'A', 'T', 'A', '\0', /* TARGET_DATA (92859) */
	'I', 'N', 'V', 'A', 'L', 'I', 'D', 'A', 'T', 'E', '\0', /* INVALIDATE (92871) */
	'L', '2', '_', 'W', 'B', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '\0', /* L2_WB_POLICY (92882) */
	'D', 'W', 'B', '\0', /* DWB (92895) */
	'A', 'I', 'N', 'C', '\0', /* AINC (92899) */
	'U', 'N', 'U', 'S', 'E', 'D', '1', '\0', /* UNUSED1 (92904) */
	'D', 'M', 'O', 'D', 'E', '\0', /* DMODE (92912) */
	'U', 'N', 'U', 'S', 'E', 'D', '2', '\0', /* UNUSED2 (92918) */
	'R', 'E', 'L', 'E', 'A', 'S', 'E', '_', 'A', 'L', 'L', '\0', /* RELEASE_ALL (92926) */
	'H', 'E', 'A', 'D', '_', 'Q', 'U', 'E', 'U', 'E', '\0', /* HEAD_QUEUE (92938) */
	'H', 'E', 'A', 'D', '_', 'V', 'A', 'L', 'I', 'D', '\0', /* HEAD_VALID (92949) */
	'H', 'E', 'A', 'D', '_', 'F', 'L', 'A', 'G', '\0', /* HEAD_FLAG (92960) */
	'H', 'A', 'L', 'T', 'E', 'D', '\0', /* HALTED (92970) */
	'D', 'S', '_', 'A', 'D', 'D', 'R', 'E', 'S', 'S', '\0', /* DS_ADDRESS (92977) */
	'C', 'R', 'A', 'W', 'L', 'E', 'R', '_', 'T', 'Y', 'P', 'E', '\0', /* CRAWLER_TYPE (92988) */
	'C', 'R', 'A', 'W', 'L', 'E', 'R', '\0', /* CRAWLER (93001) */
	'N', 'O', '_', 'A', 'L', 'L', 'O', 'C', '\0', /* NO_ALLOC (93009) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'V', 'A', 'L', 'U', 'E', '\0', /* COMPARE_VALUE (93018) */
	'P', 'E', 'R', 'F', '_', 'S', 'E', 'L', '\0', /* PERF_SEL (93032) */
	'P', 'E', 'R', 'F', '_', 'S', 'E', 'L', '1', '\0', /* PERF_SEL1 (93041) */
	'S', 'P', 'M', '_', 'M', 'O', 'D', 'E', '\0', /* SPM_MODE (93051) */
	'C', 'N', 'T', 'R', '_', 'M', 'O', 'D', 'E', '1', '\0', /* CNTR_MODE1 (93060) */
	'C', 'N', 'T', 'R', '_', 'M', 'O', 'D', 'E', '0', '\0', /* CNTR_MODE0 (93071) */
	'P', 'E', 'R', 'F', '_', 'S', 'E', 'L', '2', '\0', /* PERF_SEL2 (93082) */
	'P', 'E', 'R', 'F', '_', 'S', 'E', 'L', '3', '\0', /* PERF_SEL3 (93092) */
	'C', 'N', 'T', 'R', '_', 'M', 'O', 'D', 'E', '3', '\0', /* CNTR_MODE3 (93102) */
	'C', 'N', 'T', 'R', '_', 'M', 'O', 'D', 'E', '2', '\0', /* CNTR_MODE2 (93113) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'A', 'N', 'D', '_', 'R', 'E', 'S', 'E', 'T', '\0', /* CP_PERFMON_STATE_DISABLE_AND_RESET (93124) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'S', 'T', 'A', 'R', 'T', '_', 'C', 'O', 'U', 'N', 'T', 'I', 'N', 'G', '\0', /* CP_PERFMON_STATE_START_COUNTING (93159) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'S', 'T', 'O', 'P', '_', 'C', 'O', 'U', 'N', 'T', 'I', 'N', 'G', '\0', /* CP_PERFMON_STATE_STOP_COUNTING (93191) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '3', '\0', /* CP_PERFMON_STATE_RESERVED_3 (93222, 93239) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'A', 'N', 'D', '_', 'R', 'E', 'S', 'E', 'T', '_', 'P', 'H', 'A', 'N', 'T', 'O', 'M', '\0', /* CP_PERFMON_STATE_DISABLE_AND_RESET_PHANTOM (93250) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'C', 'O', 'U', 'N', 'T', '_', 'A', 'N', 'D', '_', 'D', 'U', 'M', 'P', '_', 'P', 'H', 'A', 'N', 'T', 'O', 'M', '\0', /* CP_PERFMON_STATE_COUNT_AND_DUMP_PHANTOM (93293) */
	'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '\0', /* PERFMON_STATE (93333) */
	'S', 'T', 'R', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'A', 'N', 'D', '_', 'R', 'E', 'S', 'E', 'T', '\0', /* STRM_PERFMON_STATE_DISABLE_AND_RESET (93347) */
	'S', 'T', 'R', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'S', 'T', 'A', 'R', 'T', '_', 'C', 'O', 'U', 'N', 'T', 'I', 'N', 'G', '\0', /* STRM_PERFMON_STATE_START_COUNTING (93384) */
	'S', 'T', 'R', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'S', 'T', 'O', 'P', '_', 'C', 'O', 'U', 'N', 'T', 'I', 'N', 'G', '\0', /* STRM_PERFMON_STATE_STOP_COUNTING (93418) */
	'S', 'T', 'R', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '3', '\0', /* STRM_PERFMON_STATE_RESERVED_3 (93451) */
	'S', 'T', 'R', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'A', 'N', 'D', '_', 'R', 'E', 'S', 'E', 'T', '_', 'P', 'H', 'A', 'N', 'T', 'O', 'M', '\0', /* STRM_PERFMON_STATE_DISABLE_AND_RESET_PHANTOM (93481) */
	'S', 'T', 'R', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '_', 'C', 'O', 'U', 'N', 'T', '_', 'A', 'N', 'D', '_', 'D', 'U', 'M', 'P', '_', 'P', 'H', 'A', 'N', 'T', 'O', 'M', '\0', /* STRM_PERFMON_STATE_COUNT_AND_DUMP_PHANTOM (93526) */
	'S', 'P', 'M', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'T', 'A', 'T', 'E', '\0', /* SPM_PERFMON_STATE (93568) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'M', 'O', 'D', 'E', '_', 'A', 'L', 'W', 'A', 'Y', 'S', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* CP_PERFMON_ENABLE_MODE_ALWAYS_COUNT (93586) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'M', 'O', 'D', 'E', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '\0', /* CP_PERFMON_ENABLE_MODE_RESERVED_1 (93622) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'M', 'O', 'D', 'E', '_', 'C', 'O', 'U', 'N', 'T', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'T', 'R', 'U', 'E', '\0', /* CP_PERFMON_ENABLE_MODE_COUNT_CONTEXT_TRUE (93656) */
	'C', 'P', '_', 'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'M', 'O', 'D', 'E', '_', 'C', 'O', 'U', 'N', 'T', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'F', 'A', 'L', 'S', 'E', '\0', /* CP_PERFMON_ENABLE_MODE_COUNT_CONTEXT_FALSE (93698) */
	'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'E', 'N', 'A', 'B', 'L', 'E', '_', 'M', 'O', 'D', 'E', '\0', /* PERFMON_ENABLE_MODE (93741) */
	'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* PERFMON_SAMPLE_ENABLE (93761) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'D', 'R', 'A', 'W', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'L', 'O', '_', 'M', 'A', 'X', '\0', /* DISABLE_DRAW_WINDOW_LO_MAX (93783) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'D', 'R', 'A', 'W', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'L', 'O', '_', 'M', 'I', 'N', '\0', /* DISABLE_DRAW_WINDOW_LO_MIN (93810) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'D', 'R', 'A', 'W', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'H', 'I', '\0', /* DISABLE_DRAW_WINDOW_HI (93837) */
	'D', 'B', '_', 'C', 'L', 'E', 'A', 'N', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* DB_CLEAN_USER_DEFINED_MASK (93860) */
	'C', 'B', '_', 'C', 'L', 'E', 'A', 'N', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* CB_CLEAN_USER_DEFINED_MASK (93887) */
	'T', 'A', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* TA_BUSY_USER_DEFINED_MASK (93914) */
	'S', 'X', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* SX_BUSY_USER_DEFINED_MASK (93940) */
	'S', 'P', 'I', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* SPI_BUSY_USER_DEFINED_MASK (93966) */
	'S', 'C', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* SC_BUSY_USER_DEFINED_MASK (93993) */
	'P', 'A', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* PA_BUSY_USER_DEFINED_MASK (94019) */
	'G', 'R', 'B', 'M', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* GRBM_BUSY_USER_DEFINED_MASK (94045) */
	'D', 'B', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* DB_BUSY_USER_DEFINED_MASK (94073) */
	'C', 'B', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* CB_BUSY_USER_DEFINED_MASK (94099) */
	'C', 'P', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* CP_BUSY_USER_DEFINED_MASK (94125) */
	'G', 'D', 'S', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* GDS_BUSY_USER_DEFINED_MASK (94151) */
	'B', 'C', 'I', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* BCI_BUSY_USER_DEFINED_MASK (94178) */
	'R', 'L', 'C', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* RLC_BUSY_USER_DEFINED_MASK (94205) */
	'T', 'C', 'P', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* TCP_BUSY_USER_DEFINED_MASK (94232) */
	'G', 'E', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* GE_BUSY_USER_DEFINED_MASK (94259) */
	'U', 'T', 'C', 'L', '2', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* UTCL2_BUSY_USER_DEFINED_MASK (94285) */
	'E', 'A', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* EA_BUSY_USER_DEFINED_MASK (94314) */
	'R', 'M', 'I', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* RMI_BUSY_USER_DEFINED_MASK (94340) */
	'U', 'T', 'C', 'L', '1', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* UTCL1_BUSY_USER_DEFINED_MASK (94367) */
	'G', 'L', '1', 'C', 'C', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* GL1CC_BUSY_USER_DEFINED_MASK (94396) */
	'G', 'L', '2', 'C', 'C', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* GL2CC_BUSY_USER_DEFINED_MASK (94425) */
	'S', 'D', 'M', 'A', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* SDMA_BUSY_USER_DEFINED_MASK (94454) */
	'C', 'H', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* CH_BUSY_USER_DEFINED_MASK (94482) */
	'P', 'H', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* PH_BUSY_USER_DEFINED_MASK (94508) */
	'P', 'M', 'M', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* PMM_BUSY_USER_DEFINED_MASK (94534) */
	'G', 'U', 'S', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* GUS_BUSY_USER_DEFINED_MASK (94561) */
	'P', 'E', 'R', 'F', '_', 'S', 'E', 'L', '0', '\0', /* PERF_SEL0 (94588) */
	'C', 'N', 'T', 'R', '_', 'M', 'O', 'D', 'E', '\0', /* CNTR_MODE (94598) */
	'P', 'E', 'R', 'F', '_', 'M', 'O', 'D', 'E', '0', '\0', /* PERF_MODE0 (94608) */
	'P', 'E', 'R', 'F', '_', 'M', 'O', 'D', 'E', '1', '\0', /* PERF_MODE1 (94619) */
	'P', 'E', 'R', 'F', '_', 'M', 'O', 'D', 'E', '2', '\0', /* PERF_MODE2 (94630) */
	'P', 'E', 'R', 'F', '_', 'M', 'O', 'D', 'E', '3', '\0', /* PERF_MODE3 (94641) */
	'P', 'E', 'R', 'F', '_', 'M', 'O', 'D', 'E', '\0', /* PERF_MODE (94652) */
	'B', 'I', 'N', '0', '_', 'M', 'I', 'N', '\0', /* BIN0_MIN (94662) */
	'B', 'I', 'N', '0', '_', 'M', 'A', 'X', '\0', /* BIN0_MAX (94671) */
	'B', 'I', 'N', '1', '_', 'M', 'I', 'N', '\0', /* BIN1_MIN (94680) */
	'B', 'I', 'N', '1', '_', 'M', 'A', 'X', '\0', /* BIN1_MAX (94689) */
	'B', 'I', 'N', '2', '_', 'M', 'I', 'N', '\0', /* BIN2_MIN (94698) */
	'B', 'I', 'N', '2', '_', 'M', 'A', 'X', '\0', /* BIN2_MAX (94707) */
	'B', 'I', 'N', '3', '_', 'M', 'I', 'N', '\0', /* BIN3_MIN (94716) */
	'B', 'I', 'N', '3', '_', 'M', 'A', 'X', '\0', /* BIN3_MAX (94725) */
	'S', 'Q', 'C', '_', 'B', 'A', 'N', 'K', '_', 'M', 'A', 'S', 'K', '\0', /* SQC_BANK_MASK (94734) */
	'C', 'S', '_', 'E', 'N', '\0', /* CS_EN (94748) */
	'C', 'N', 'T', 'R', '_', 'R', 'A', 'T', 'E', '\0', /* CNTR_RATE (94754) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* DISABLE_FLUSH (94764) */
	'F', 'O', 'R', 'C', 'E', '_', 'E', 'N', '\0', /* FORCE_EN (94778) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'M', 'O', 'D', 'E', '0', '\0', /* COMPARE_MODE0 (94787) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'M', 'O', 'D', 'E', '1', '\0', /* COMPARE_MODE1 (94801) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'M', 'O', 'D', 'E', '2', '\0', /* COMPARE_MODE2 (94815) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'M', 'O', 'D', 'E', '3', '\0', /* COMPARE_MODE3 (94829) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'V', 'A', 'L', 'U', 'E', '0', '\0', /* COMPARE_VALUE0 (94843) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'V', 'A', 'L', 'U', 'E', '1', '\0', /* COMPARE_VALUE1 (94858) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'V', 'A', 'L', 'U', 'E', '2', '\0', /* COMPARE_VALUE2 (94873) */
	'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'V', 'A', 'L', 'U', 'E', '3', '\0', /* COMPARE_VALUE3 (94888) */
	'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '1', '\0', /* PERFCOUNTER_SELECT1 (94903) */
	'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '2', '\0', /* PERFCOUNTER_SELECT2 (94923) */
	'P', 'E', 'R', 'F', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '3', '\0', /* PERFCOUNTER_SELECT3 (94943) */
	'O', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* OP_FILTER_ENABLE (94963) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', '_', 'O', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '_', 'W', 'R', 'I', 'T', 'E', '_', 'O', 'N', 'L', 'Y', '\0', /* CB_PERF_OP_FILTER_SEL_WRITE_ONLY (94980) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', '_', 'O', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '_', 'N', 'E', 'E', 'D', 'S', '_', 'D', 'E', 'S', 'T', 'I', 'N', 'A', 'T', 'I', 'O', 'N', '\0', /* CB_PERF_OP_FILTER_SEL_NEEDS_DESTINATION (95013) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', '_', 'O', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '_', 'R', 'E', 'S', 'O', 'L', 'V', 'E', '\0', /* CB_PERF_OP_FILTER_SEL_RESOLVE (95053) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', '_', 'O', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '_', 'D', 'E', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '\0', /* CB_PERF_OP_FILTER_SEL_DECOMPRESS (95083) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', '_', 'O', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '_', 'F', 'M', 'A', 'S', 'K', '_', 'D', 'E', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '\0', /* CB_PERF_OP_FILTER_SEL_FMASK_DECOMPRESS (95116) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', '_', 'O', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '_', 'E', 'L', 'I', 'M', 'I', 'N', 'A', 'T', 'E', '_', 'F', 'A', 'S', 'T', '_', 'C', 'L', 'E', 'A', 'R', '\0', /* CB_PERF_OP_FILTER_SEL_ELIMINATE_FAST_CLEAR (95155) */
	'O', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '\0', /* OP_FILTER_SEL (95198) */
	'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* FORMAT_FILTER_ENABLE (95212) */
	'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '\0', /* FORMAT_FILTER_SEL (95233) */
	'C', 'L', 'E', 'A', 'R', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* CLEAR_FILTER_ENABLE (95251) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', '_', 'C', 'L', 'E', 'A', 'R', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '_', 'N', 'O', 'N', 'C', 'L', 'E', 'A', 'R', '\0', /* CB_PERF_CLEAR_FILTER_SEL_NONCLEAR (95271) */
	'C', 'B', '_', 'P', 'E', 'R', 'F', '_', 'C', 'L', 'E', 'A', 'R', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '_', 'C', 'L', 'E', 'A', 'R', '\0', /* CB_PERF_CLEAR_FILTER_SEL_CLEAR (95305) */
	'C', 'L', 'E', 'A', 'R', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '\0', /* CLEAR_FILTER_SEL (95336) */
	'M', 'R', 'T', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* MRT_FILTER_ENABLE (95353) */
	'M', 'R', 'T', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '\0', /* MRT_FILTER_SEL (95371) */
	'N', 'U', 'M', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* NUM_SAMPLES_FILTER_ENABLE (95386) */
	'N', 'U', 'M', '_', 'S', 'A', 'M', 'P', 'L', 'E', 'S', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '\0', /* NUM_SAMPLES_FILTER_SEL (95412) */
	'N', 'U', 'M', '_', 'F', 'R', 'A', 'G', 'M', 'E', 'N', 'T', 'S', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* NUM_FRAGMENTS_FILTER_ENABLE (95435) */
	'N', 'U', 'M', '_', 'F', 'R', 'A', 'G', 'M', 'E', 'N', 'T', 'S', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'S', 'E', 'L', '\0', /* NUM_FRAGMENTS_FILTER_SEL (95463) */
	'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'R', 'I', 'N', 'G', '_', 'M', 'O', 'D', 'E', '\0', /* PERFMON_RING_MODE (95488) */
	'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'I', 'N', 'T', 'E', 'R', 'V', 'A', 'L', '\0', /* PERFMON_SAMPLE_INTERVAL (95506) */
	'G', 'L', 'O', 'B', 'A', 'L', '_', 'N', 'U', 'M', '_', 'L', 'I', 'N', 'E', '\0', /* GLOBAL_NUM_LINE (95530) */
	'S', 'E', '0', '_', 'N', 'U', 'M', '_', 'L', 'I', 'N', 'E', '\0', /* SE0_NUM_LINE (95546) */
	'S', 'E', '1', '_', 'N', 'U', 'M', '_', 'L', 'I', 'N', 'E', '\0', /* SE1_NUM_LINE (95559) */
	'S', 'E', '2', '_', 'N', 'U', 'M', '_', 'L', 'I', 'N', 'E', '\0', /* SE2_NUM_LINE (95572) */
	'N', 'U', 'M', '_', 'S', 'E', 'G', 'M', 'E', 'N', 'T', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '\0', /* NUM_SEGMENT_THRESHOLD (95585) */
	'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'S', 'E', 'L', '_', 'A', 'D', 'D', 'R', '\0', /* PERFMON_SEL_ADDR (95607) */
	'd', 'a', 't', 'a', '\0', /* data (95624) */
	'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'R', 'I', 'N', 'G', '_', 'W', 'R', 'P', 'T', 'R', '\0', /* PERFMON_RING_WRPTR (95629) */
	'a', 'd', 'd', 'r', '\0', /* addr (95648) */
	'N', 'u', 'm', 'b', 'S', 'a', 'm', 'p', 'l', 'e', 's', 'C', 'o', 'm', 'p', 'l', 'e', 't', 'e', 'd', '\0', /* NumbSamplesCompleted (95653) */
	'A', 'c', 'c', 'u', 'm', 'D', 'o', 'n', 'e', '\0', /* AccumDone (95674) */
	'S', 'p', 'm', 'D', 'o', 'n', 'e', '\0', /* SpmDone (95684) */
	'A', 'c', 'c', 'u', 'm', 'O', 'v', 'e', 'r', 'f', 'l', 'o', 'w', '\0', /* AccumOverflow (95692) */
	'A', 'c', 'c', 'u', 'm', 'A', 'r', 'm', 'e', 'd', '\0', /* AccumArmed (95706) */
	'S', 'e', 'q', 'u', 'e', 'n', 'c', 'e', 'I', 'n', 'P', 'r', 'o', 'g', 'r', 'e', 's', 's', '\0', /* SequenceInProgress (95717) */
	'F', 'i', 'n', 'a', 'l', 'S', 'e', 'q', 'u', 'e', 'n', 'c', 'e', 'I', 'n', 'P', 'r', 'o', 'g', 'r', 'e', 's', 's', '\0', /* FinalSequenceInProgress (95736) */
	'A', 'l', 'l', 'F', 'i', 'f', 'o', 's', 'E', 'm', 'p', 't', 'y', '\0', /* AllFifosEmpty (95760) */
	'F', 'S', 'M', 'I', 's', 'I', 'd', 'l', 'e', '\0', /* FSMIsIdle (95774) */
	'S', 't', 'r', 'o', 'b', 'e', 'R', 'e', 's', 'e', 't', 'P', 'e', 'r', 'f', 'M', 'o', 'n', 'i', 't', 'o', 'r', 's', '\0', /* StrobeResetPerfMonitors (95784) */
	'S', 't', 'r', 'o', 'b', 'e', 'S', 't', 'a', 'r', 't', 'A', 'c', 'c', 'u', 'm', 'u', 'l', 'a', 't', 'i', 'o', 'n', '\0', /* StrobeStartAccumulation (95808) */
	'S', 't', 'r', 'o', 'b', 'e', 'R', 'e', 'a', 'r', 'm', 'A', 'c', 'c', 'u', 'm', '\0', /* StrobeRearmAccum (95832) */
	'S', 't', 'r', 'o', 'b', 'e', 'S', 'p', 'm', 'D', 'o', 'n', 'e', 'I', 'n', 't', '\0', /* StrobeSpmDoneInt (95849) */
	'S', 't', 'r', 'o', 'b', 'e', 'A', 'c', 'c', 'u', 'm', 'D', 'o', 'n', 'e', 'I', 'n', 't', '\0', /* StrobeAccumDoneInt (95866) */
	'S', 't', 'r', 'o', 'b', 'e', 'R', 'e', 's', 'e', 't', 'A', 'c', 'c', 'u', 'm', '\0', /* StrobeResetAccum (95885) */
	'S', 't', 'r', 'o', 'b', 'e', 'S', 't', 'a', 'r', 't', 'S', 'p', 'm', '\0', /* StrobeStartSpm (95902) */
	'E', 'n', 'a', 'b', 'l', 'e', 'A', 'c', 'c', 'u', 'm', '\0', /* EnableAccum (95917) */
	'A', 'u', 't', 'o', 'A', 'c', 'c', 'u', 'm', 'E', 'n', '\0', /* AutoAccumEn (95929) */
	'A', 'u', 't', 'o', 'S', 'p', 'm', 'E', 'n', '\0', /* AutoSpmEn (95941) */
	'G', 'l', 'o', 'b', 'a', 'l', 's', '_', 'L', 'o', 'a', 'd', 'O', 'v', 'e', 'r', 'r', 'i', 'd', 'e', '\0', /* Globals_LoadOverride (95951) */
	'S', 'E', '0', '_', 'L', 'o', 'a', 'd', 'O', 'v', 'e', 'r', 'r', 'i', 'd', 'e', '\0', /* SE0_LoadOverride (95972) */
	'S', 'E', '1', '_', 'L', 'o', 'a', 'd', 'O', 'v', 'e', 'r', 'r', 'i', 'd', 'e', '\0', /* SE1_LoadOverride (95989) */
	'A', 'u', 't', 'o', 'R', 'e', 's', 'e', 't', 'P', 'e', 'r', 'f', 'm', 'o', 'n', 'D', 'i', 's', 'a', 'b', 'l', 'e', '\0', /* AutoResetPerfmonDisable (96006) */
	'T', 'h', 'r', 'e', 's', 'h', 'o', 'l', 'd', '\0', /* Threshold (96030) */
	'S', 'a', 'm', 'p', 'l', 'e', 's', 'R', 'e', 'q', 'u', 'e', 's', 't', 'e', 'd', '\0', /* SamplesRequested (96040) */
	'D', 'a', 't', 'a', 'R', 'a', 'm', 'W', 'r', 'C', 'o', 'u', 'n', 't', '\0', /* DataRamWrCount (96057) */
	'S', 'E', '3', '_', 'N', 'U', 'M', '_', 'L', 'I', 'N', 'E', '\0', /* SE3_NUM_LINE (96072) */
	'P', 'a', 'u', 's', 'e', 'S', 'p', 'm', 'S', 'a', 'm', 'p', 'l', 'i', 'n', 'g', 'R', 'e', 'q', 'u', 'e', 's', 't', '\0', /* PauseSpmSamplingRequest (96085) */
	'S', 'p', 'm', 'S', 'a', 'm', 'p', 'l', 'i', 'n', 'g', 'P', 'a', 'u', 's', 'e', 'd', '\0', /* SpmSamplingPaused (96109) */
	'M', 'O', 'D', 'E', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* MODE_SELECT (96127) */
	'V', 'F', 'I', 'D', '\0', /* VFID (96139) */
	'C', 'N', 'T', '_', 'I', 'D', '\0', /* CNT_ID (96144) */
	'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'C', 'L', 'O', 'C', 'K', '_', 'S', 'T', 'A', 'T', 'E', '\0', /* PERFMON_CLOCK_STATE (96151) */
	'T', 'R', 'A', 'N', 'S', '_', 'B', 'A', 'S', 'E', 'D', '_', 'P', 'E', 'R', 'F', '_', 'E', 'N', '_', 'S', 'E', 'L', '\0', /* TRANS_BASED_PERF_EN_SEL (96171) */
	'E', 'V', 'E', 'N', 'T', '_', 'B', 'A', 'S', 'E', 'D', '_', 'P', 'E', 'R', 'F', '_', 'E', 'N', '_', 'S', 'E', 'L', '\0', /* EVENT_BASED_PERF_EN_SEL (96195) */
	'T', 'C', '_', 'P', 'E', 'R', 'F', '_', 'E', 'N', '_', 'S', 'E', 'L', '\0', /* TC_PERF_EN_SEL (96219) */
	'P', 'E', 'R', 'F', '_', 'E', 'V', 'E', 'N', 'T', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'M', 'A', 'S', 'K', '0', '\0', /* PERF_EVENT_WINDOW_MASK0 (96234) */
	'P', 'E', 'R', 'F', '_', 'E', 'V', 'E', 'N', 'T', '_', 'W', 'I', 'N', 'D', 'O', 'W', '_', 'M', 'A', 'S', 'K', '1', '\0', /* PERF_EVENT_WINDOW_MASK1 (96258) */
	'P', 'E', 'R', 'F', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'C', 'I', 'D', '\0', /* PERF_COUNTER_CID (96282) */
	'P', 'E', 'R', 'F', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'V', 'M', 'I', 'D', '\0', /* PERF_COUNTER_VMID (96299) */
	'P', 'E', 'R', 'F', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'B', 'U', 'R', 'S', 'T', '_', 'L', 'E', 'N', 'G', 'T', 'H', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '\0', /* PERF_COUNTER_BURST_LENGTH_THRESHOLD (96317) */
	'P', 'E', 'R', 'F', '_', 'S', 'O', 'F', 'T', '_', 'R', 'E', 'S', 'E', 'T', '\0', /* PERF_SOFT_RESET (96353) */
	'P', 'E', 'R', 'F', '_', 'C', 'N', 'T', 'R', '_', 'S', 'P', 'M', '_', 'S', 'E', 'L', '\0', /* PERF_CNTR_SPM_SEL (96369) */
	'P', 'E', 'R', 'F', '_', 'S', 'E', 'L', '_', 'E', 'N', 'D', '\0', /* PERF_SEL_END (96387) */
	'P', 'E', 'R', 'F', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', '\0', /* PERF_COUNTER_SELECT (96400) */
	'S', 'T', 'A', 'R', 'T', '_', 'T', 'R', 'I', 'G', 'G', 'E', 'R', '\0', /* START_TRIGGER (96420) */
	'S', 'T', 'O', 'P', '_', 'T', 'R', 'I', 'G', 'G', 'E', 'R', '\0', /* STOP_TRIGGER (96434) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'A', 'N', 'Y', '\0', /* ENABLE_ANY (96447) */
	'C', 'L', 'E', 'A', 'R', '_', 'A', 'L', 'L', '\0', /* CLEAR_ALL (96458) */
	'S', 'T', 'O', 'P', '_', 'A', 'L', 'L', '_', 'O', 'N', '_', 'S', 'A', 'T', 'U', 'R', 'A', 'T', 'E', '\0', /* STOP_ALL_ON_SATURATE (96468) */
	'C', 'N', 'T', 'L', '_', 'M', 'O', 'D', 'E', '\0', /* CNTL_MODE (96489) */
	'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'M', 'O', 'D', 'E', '\0', /* COUNTER_MODE (96499) */
	'M', 'E', 'M', '_', 'M', 'A', 'P', 'P', 'E', 'D', '_', 'R', 'E', 'G', 'I', 'S', 'T', 'E', 'R', '\0', /* MEM_MAPPED_REGISTER (96512, 96523) */
	'M', 'E', 'M', '_', 'G', 'R', 'B', 'M', '\0', /* MEM_GRBM (96532) */
	'T', 'C', '_', 'L', '2', '\0', /* TC_L2 (96541) */
	'G', 'D', 'S', '\0', /* GDS (96547) */
	'W', 'R', '_', 'O', 'N', 'E', '_', 'A', 'D', 'D', 'R', '\0', /* WR_ONE_ADDR (96551) */
	'W', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'R', 'M', '\0', /* WR_CONFIRM (96563) */
	'P', 'F', 'P', '\0', /* PFP (96574) */
	'E', 'N', 'G', 'I', 'N', 'E', '_', 'S', 'E', 'L', '\0', /* ENGINE_SEL (96578) */
	'I', 'B', '_', 'S', 'I', 'Z', 'E', '\0', /* IB_SIZE (96589) */
	'C', 'H', 'A', 'I', 'N', '\0', /* CHAIN (96597) */
	'D', 'S', 'T', '_', 'A', 'D', 'D', 'R', '_', 'T', 'C', '_', 'L', '2', '\0', /* DST_ADDR_TC_L2 (96603) */
	'E', 'N', 'G', 'I', 'N', 'E', '\0', /* ENGINE (96618) */
	'S', 'R', 'C', '_', 'A', 'D', 'D', 'R', '_', 'T', 'C', '_', 'L', '2', '\0', /* SRC_ADDR_TC_L2 (96625) */
	'S', 'R', 'C', '_', 'S', 'E', 'L', '\0', /* SRC_SEL (96640) */
	'C', 'P', '_', 'S', 'Y', 'N', 'C', '\0', /* CP_SYNC (96648) */
	'M', 'E', 'M', 'O', 'R', 'Y', '\0', /* MEMORY (96656) */
	'I', 'N', 'C', 'R', 'E', 'M', 'E', 'N', 'T', '\0', /* INCREMENT (96663) */
	'N', 'O', '_', 'I', 'N', 'C', 'R', 'E', 'M', 'E', 'N', 'T', '\0', /* NO_INCREMENT (96673) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'W', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'R', 'M', '\0', /* DISABLE_WR_CONFIRM (96686) */
	'E', 'V', 'E', 'N', 'T', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* EVENT_INDEX (96705) */
	'G', 'L', 'M', '_', 'W', 'B', '\0', /* GLM_WB (96717) */
	'G', 'L', 'M', '_', 'I', 'N', 'V', '\0', /* GLM_INV (96724) */
	'G', 'L', 'V', '_', 'I', 'N', 'V', '\0', /* GLV_INV (96732) */
	'G', 'L', '1', '_', 'I', 'N', 'V', '\0', /* GL1_INV (96740) */
	'G', 'L', '2', '_', 'U', 'S', '\0', /* GL2_US (96748) */
	'G', 'L', '2', '_', 'A', 'L', 'L', '\0', /* GL2_ALL (96755) */
	'G', 'L', '2', '_', 'V', 'O', 'L', '\0', /* GL2_VOL (96763) */
	'G', 'L', '2', '_', 'R', 'A', 'N', 'G', 'E', '\0', /* GL2_RANGE (96771) */
	'G', 'L', '2', '_', 'F', 'I', 'R', 'S', 'T', '_', 'L', 'A', 'S', 'T', '\0', /* GL2_FIRST_LAST (96781) */
	'G', 'L', '2', '_', 'D', 'I', 'S', 'C', 'A', 'R', 'D', '\0', /* GL2_DISCARD (96796) */
	'G', 'L', '2', '_', 'I', 'N', 'V', '\0', /* GL2_INV (96808) */
	'G', 'L', '2', '_', 'W', 'B', '\0', /* GL2_WB (96816) */
	'S', 'E', 'Q', '_', 'P', 'A', 'R', 'A', 'L', 'L', 'E', 'L', '\0', /* SEQ_PARALLEL (96823) */
	'S', 'E', 'Q', '_', 'F', 'O', 'R', 'W', 'A', 'R', 'D', '\0', /* SEQ_FORWARD (96836) */
	'S', 'E', 'Q', '_', 'R', 'E', 'V', 'E', 'R', 'S', 'E', '\0', /* SEQ_REVERSE (96848) */
	'S', 'E', 'Q', '\0', /* SEQ (96860) */
	'G', 'L', 'I', '_', 'N', 'O', 'P', '\0', /* GLI_NOP (96864) */
	'G', 'L', 'I', '_', 'A', 'L', 'L', '\0', /* GLI_ALL (96872) */
	'G', 'L', 'I', '_', 'R', 'A', 'N', 'G', 'E', '\0', /* GLI_RANGE (96880) */
	'G', 'L', 'I', '_', 'F', 'I', 'R', 'S', 'T', '_', 'L', 'A', 'S', 'T', '\0', /* GLI_FIRST_LAST (96890) */
	'G', 'L', 'I', '_', 'I', 'N', 'V', '\0', /* GLI_INV (96905) */
	'G', 'L', '1', '_', 'A', 'L', 'L', '\0', /* GL1_ALL (96913) */
	'G', 'L', '1', '_', 'R', 'A', 'N', 'G', 'E', '\0', /* GL1_RANGE (96921) */
	'G', 'L', '1', '_', 'F', 'I', 'R', 'S', 'T', '_', 'L', 'A', 'S', 'T', '\0', /* GL1_FIRST_LAST (96931) */
	'G', 'L', 'K', '_', 'W', 'B', '\0', /* GLK_WB (96946) */
	'G', 'L', 'K', '_', 'I', 'N', 'V', '\0', /* GLK_INV (96953) */
	'R', 'A', 'N', 'G', 'E', '_', 'I', 'S', '_', 'P', 'A', '\0', /* RANGE_IS_PA (96961) */
	'W', 'A', 'V', 'E', '_', 'S', 'L', 'O', 'T', '\0', /* WAVE_SLOT (96973) */
	'U', 'T', 'C', '_', 'E', 'R', 'R', 'O', 'R', '\0', /* UTC_ERROR (96983) */
	'S', 'D', 'M', 'A', '_', 'S', 'C', 'H', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* SDMA_SCH_RQ_PENDING (96993) */
	'S', 'D', 'M', 'A', '2', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* SDMA2_RQ_PENDING (97013) */
	'S', 'D', 'M', 'A', '3', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* SDMA3_RQ_PENDING (97030) */
	'B', 'O', 'P', '_', 'E', 'V', 'E', 'N', 'T', 'S', '_', 'T', 'O', 'K', 'E', 'N', '_', 'I', 'N', 'C', 'L', 'U', 'D', 'E', '\0', /* BOP_EVENTS_TOKEN_INCLUDE (97047) */
	'R', 'E', 'G', '_', 'E', 'X', 'C', 'L', 'U', 'D', 'E', '\0', /* REG_EXCLUDE (97072) */
	'L', 'O', 'W', 'A', 'T', 'E', 'R', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* LOWATER_OFFSET (97084) */
	'A', 'U', 'T', 'O', '_', 'F', 'L', 'U', 'S', 'H', '_', 'P', 'A', 'D', 'D', 'I', 'N', 'G', '_', 'D', 'I', 'S', '\0', /* AUTO_FLUSH_PADDING_DIS (97099) */
	'A', 'U', 'T', 'O', '_', 'F', 'L', 'U', 'S', 'H', '_', 'M', 'O', 'D', 'E', '\0', /* AUTO_FLUSH_MODE (97122) */
	'O', 'W', 'N', 'E', 'R', '_', 'V', 'M', 'I', 'D', '\0', /* OWNER_VMID (97138) */
	'B', 'U', 'F', '0', '_', 'F', 'U', 'L', 'L', '\0', /* BUF0_FULL (97149) */
	'B', 'U', 'F', '1', '_', 'F', 'U', 'L', 'L', '\0', /* BUF1_FULL (97159) */
	'P', 'A', 'C', 'K', 'E', 'T', '_', 'L', 'O', 'S', 'T', '_', 'B', 'U', 'F', '_', 'N', 'O', '_', 'L', 'O', 'C', 'K', 'D', 'O', 'W', 'N', '\0', /* PACKET_LOST_BUF_NO_LOCKDOWN (97169) */
	'L', 'L', 'C', '_', 'N', 'O', 'A', 'L', 'L', 'O', 'C', '\0', /* LLC_NOALLOC (97197) */
	'F', 'O', 'R', 'C', 'E', '_', 'H', 'A', 'L', 'F', '_', 'R', 'A', 'T', 'E', '_', 'P', 'C', '_', 'E', 'X', 'P', '\0', /* FORCE_HALF_RATE_PC_EXP (97209) */
	'N', 'U', 'M', '_', 'P', 'K', 'R', 'S', '\0', /* NUM_PKRS (97232) */
	'L', 'O', 'A', 'D', '_', 'P', 'R', 'O', 'V', 'O', 'K', 'I', 'N', 'G', '_', 'V', 'T', 'X', '\0', /* LOAD_PROVOKING_VTX (97241) */
	'P', 'S', '_', 'I', 'N', 'V', 'O', 'K', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* PS_INVOKE_DISABLE (97260) */
	'F', 'O', 'R', 'C', 'E', '_', 'V', 'R', 'S', '_', 'R', 'A', 'T', 'E', '_', 'F', 'I', 'N', 'E', '\0', /* FORCE_VRS_RATE_FINE (97278) */
	'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '_', 'C', 'O', 'M', 'P', 'U', 'T', 'A', 'T', 'I', 'O', 'N', '_', 'M', 'O', 'D', 'E', '\0', /* CENTROID_COMPUTATION_MODE (97298) */
	'V', 'R', 'S', '_', 'C', 'O', 'M', 'B', '_', 'M', 'O', 'D', 'E', '_', 'P', 'A', 'S', 'S', 'T', 'H', 'R', 'U', '\0', /* VRS_COMB_MODE_PASSTHRU (97324) */
	'V', 'R', 'S', '_', 'C', 'O', 'M', 'B', '_', 'M', 'O', 'D', 'E', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* VRS_COMB_MODE_OVERRIDE (97347) */
	'V', 'R', 'S', '_', 'C', 'O', 'M', 'B', '_', 'M', 'O', 'D', 'E', '_', 'M', 'I', 'N', '\0', /* VRS_COMB_MODE_MIN (97370) */
	'V', 'R', 'S', '_', 'C', 'O', 'M', 'B', '_', 'M', 'O', 'D', 'E', '_', 'M', 'A', 'X', '\0', /* VRS_COMB_MODE_MAX (97388) */
	'V', 'R', 'S', '_', 'C', 'O', 'M', 'B', '_', 'M', 'O', 'D', 'E', '_', 'S', 'A', 'T', 'U', 'R', 'A', 'T', 'E', '\0', /* VRS_COMB_MODE_SATURATE (97406) */
	'V', 'R', 'S', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '_', 'R', 'A', 'T', 'E', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'E', 'R', '_', 'M', 'O', 'D', 'E', '\0', /* VRS_OVERRIDE_RATE_COMBINER_MODE (97429) */
	'V', 'R', 'S', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '_', 'R', 'A', 'T', 'E', '_', 'X', '\0', /* VRS_OVERRIDE_RATE_X (97461, 97474) */
	'V', 'R', 'S', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '_', 'R', 'A', 'T', 'E', '_', 'Y', '\0', /* VRS_OVERRIDE_RATE_Y (97481, 97494) */
	'Z', '_', 'N', 'O', 'A', 'L', 'L', 'O', 'C', '\0', /* Z_NOALLOC (97501) */
	'S', '_', 'N', 'O', 'A', 'L', 'L', 'O', 'C', '\0', /* S_NOALLOC (97511) */
	'H', 'T', 'I', 'L', 'E', '_', 'N', 'O', 'A', 'L', 'L', 'O', 'C', '\0', /* HTILE_NOALLOC (97521) */
	'Z', 'P', 'C', 'P', 'S', 'D', '_', 'N', 'O', 'A', 'L', 'L', 'O', 'C', '\0', /* ZPCPSD_NOALLOC (97535) */
	'C', 'M', 'A', 'S', 'K', '_', 'L', '3', '_', 'B', 'Y', 'P', 'A', 'S', 'S', '\0', /* CMASK_L3_BYPASS (97550) */
	'F', 'M', 'A', 'S', 'K', '_', 'L', '3', '_', 'B', 'Y', 'P', 'A', 'S', 'S', '\0', /* FMASK_L3_BYPASS (97566) */
	'D', 'C', 'C', '_', 'L', '3', '_', 'B', 'Y', 'P', 'A', 'S', 'S', '\0', /* DCC_L3_BYPASS (97582) */
	'C', 'O', 'L', 'O', 'R', '_', 'L', '3', '_', 'B', 'Y', 'P', 'A', 'S', 'S', '\0', /* COLOR_L3_BYPASS (97596) */
	'R', 'O', 'T', 'A', 'T', 'E', '_', 'P', 'C', '_', 'P', 'T', 'R', '\0', /* ROTATE_PC_PTR (97612) */
	'P', 'R', 'I', 'M', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* PRIM_EXPORT_COUNT (97626) */
	'N', 'U', 'M', '_', 'P', 'R', 'I', 'M', '_', 'I', 'N', 'T', 'E', 'R', 'P', '\0', /* NUM_PRIM_INTERP (97644) */
	'M', 'R', 'T', '0', '_', 'F', 'M', 'T', '_', 'M', 'A', 'P', 'P', 'I', 'N', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT0_FMT_MAPPING_DISABLE (97660) */
	'M', 'R', 'T', '1', '_', 'F', 'M', 'T', '_', 'M', 'A', 'P', 'P', 'I', 'N', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT1_FMT_MAPPING_DISABLE (97685) */
	'M', 'R', 'T', '2', '_', 'F', 'M', 'T', '_', 'M', 'A', 'P', 'P', 'I', 'N', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT2_FMT_MAPPING_DISABLE (97710) */
	'M', 'R', 'T', '3', '_', 'F', 'M', 'T', '_', 'M', 'A', 'P', 'P', 'I', 'N', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT3_FMT_MAPPING_DISABLE (97735) */
	'M', 'R', 'T', '4', '_', 'F', 'M', 'T', '_', 'M', 'A', 'P', 'P', 'I', 'N', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT4_FMT_MAPPING_DISABLE (97760) */
	'M', 'R', 'T', '5', '_', 'F', 'M', 'T', '_', 'M', 'A', 'P', 'P', 'I', 'N', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT5_FMT_MAPPING_DISABLE (97785) */
	'M', 'R', 'T', '6', '_', 'F', 'M', 'T', '_', 'M', 'A', 'P', 'P', 'I', 'N', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT6_FMT_MAPPING_DISABLE (97810) */
	'M', 'R', 'T', '7', '_', 'F', 'M', 'T', '_', 'M', 'A', 'P', 'P', 'I', 'N', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* MRT7_FMT_MAPPING_DISABLE (97835) */
	'S', 'X', '_', 'R', 'T', '_', 'E', 'X', 'P', 'O', 'R', 'T', '_', '9', '_', '9', '_', '9', '_', 'E', '5', '\0', /* SX_RT_EXPORT_9_9_9_E5 (97860) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', '1', 'F', 'R', 'A', 'G', '_', 'P', 'S', '_', 'I', 'N', 'V', 'O', 'K', 'E', '\0', /* ENABLE_1FRAG_PS_INVOKE (97882) */
	'U', 'S', 'E', '_', 'V', 'T', 'X', '_', 'V', 'R', 'S', '_', 'R', 'A', 'T', 'E', '\0', /* USE_VTX_VRS_RATE (97905) */
	'B', 'Y', 'P', 'A', 'S', 'S', '_', 'V', 'T', 'X', '_', 'R', 'A', 'T', 'E', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'E', 'R', '\0', /* BYPASS_VTX_RATE_COMBINER (97922) */
	'B', 'Y', 'P', 'A', 'S', 'S', '_', 'P', 'R', 'I', 'M', '_', 'R', 'A', 'T', 'E', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'E', 'R', '\0', /* BYPASS_PRIM_RATE_COMBINER (97947) */
	'V', 'E', 'R', 'T', 'E', 'X', '_', 'R', 'E', 'U', 'S', 'E', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* VERTEX_REUSE_DEPTH (97973) */
	'V', 'E', 'R', 'T', 'E', 'X', '_', 'R', 'A', 'T', 'E', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'E', 'R', '_', 'M', 'O', 'D', 'E', '\0', /* VERTEX_RATE_COMBINER_MODE (97992) */
	'P', 'R', 'I', 'M', 'I', 'T', 'I', 'V', 'E', '_', 'R', 'A', 'T', 'E', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'E', 'R', '_', 'M', 'O', 'D', 'E', '\0', /* PRIMITIVE_RATE_COMBINER_MODE (98018) */
	'H', 'T', 'I', 'L', 'E', '_', 'R', 'A', 'T', 'E', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'E', 'R', '_', 'M', 'O', 'D', 'E', '\0', /* HTILE_RATE_COMBINER_MODE (98047) */
	'S', 'A', 'M', 'P', 'L', 'E', '_', 'I', 'T', 'E', 'R', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'E', 'R', '_', 'M', 'O', 'D', 'E', '\0', /* SAMPLE_ITER_COMBINER_MODE (98072) */
	'E', 'X', 'P', 'O', 'S', 'E', '_', 'V', 'R', 'S', '_', 'P', 'I', 'X', 'E', 'L', 'S', '_', 'M', 'A', 'S', 'K', '\0', /* EXPOSE_VRS_PIXELS_MASK (98098) */
	'C', 'M', 'A', 'S', 'K', '_', 'R', 'A', 'T', 'E', '_', 'H', 'I', 'N', 'T', '_', 'F', 'O', 'R', 'C', 'E', '_', 'Z', 'E', 'R', 'O', '\0', /* CMASK_RATE_HINT_FORCE_ZERO (98121) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'I', 'N', 'S', 'T', 'A', 'N', 'C', 'E', '_', 'P', 'A', 'C', 'K', 'I', 'N', 'G', '\0', /* DISABLE_INSTANCE_PACKING (98148) */
	'E', 'N', '_', 'V', 'R', 'S', '_', 'R', 'A', 'T', 'E', '\0', /* EN_VRS_RATE (98173) */
	'V', 'R', 'S', '_', 'H', 'T', 'I', 'L', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* VRS_HTILE_DISABLE (98185) */
	'V', 'R', 'S', '_', 'H', 'T', 'I', 'L', 'E', '_', '2', 'B', 'I', 'T', '_', 'E', 'N', 'C', 'O', 'D', 'I', 'N', 'G', '\0', /* VRS_HTILE_2BIT_ENCODING (98203, 98218) */
	'V', 'R', 'S', '_', 'H', 'T', 'I', 'L', 'E', '_', '4', 'B', 'I', 'T', '_', 'E', 'N', 'C', 'O', 'D', 'I', 'N', 'G', '\0', /* VRS_HTILE_4BIT_ENCODING (98227) */
	'V', 'R', 'S', '_', 'H', 'T', 'I', 'L', 'E', '_', 'E', 'N', 'C', 'O', 'D', 'I', 'N', 'G', '\0', /* VRS_HTILE_ENCODING (98251) */
	'P', 'R', 'I', 'M', 'G', 'E', 'N', '_', 'P', 'A', 'S', 'S', 'T', 'H', 'R', 'U', '_', 'N', 'O', '_', 'M', 'S', 'G', '\0', /* PRIMGEN_PASSTHRU_NO_MSG (98270) */
	'S', 'A', 'M', 'P', 'L', 'E', '_', 'C', 'O', 'V', 'E', 'R', 'A', 'G', 'E', '_', 'E', 'N', 'C', 'O', 'D', 'I', 'N', 'G', '\0', /* SAMPLE_COVERAGE_ENCODING (98294) */
	'C', 'O', 'V', 'E', 'R', 'E', 'D', '_', 'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '_', 'I', 'S', '_', 'C', 'E', 'N', 'T', 'E', 'R', '\0', /* COVERED_CENTROID_IS_CENTER (98319) */
	'C', 'O', 'L', 'O', 'R', '_', '5', '_', '9', '_', '9', '_', '9', '\0', /* COLOR_5_9_9_9 (98346) */
	'N', 'B', 'C', '_', 'T', 'I', 'L', 'I', 'N', 'G', '\0', /* NBC_TILING (98360) */
	'S', 'K', 'I', 'P', '_', 'L', 'O', 'W', '_', 'C', 'O', 'M', 'P', '_', 'R', 'A', 'T', 'I', 'O', '\0', /* SKIP_LOW_COMP_RATIO (98371) */
	'D', 'C', 'C', '_', 'C', 'O', 'M', 'P', 'R', 'E', 'S', 'S', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* DCC_COMPRESS_DISABLE (98391) */
	'V', 'R', 'S', '_', 'R', 'A', 'T', 'E', '_', 'H', 'I', 'N', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* VRS_RATE_HINT_ENABLE (98412) */
	'I', 'M', 'M', 'E', 'D', '\0', /* IMMED (98433) */
	'r', 'e', 's', 'e', 'r', 'v', 'e', 'd', '2', '7', '\0', /* reserved27 (98439) */
	'r', 'e', 's', 'e', 'r', 'v', 'e', 'd', '3', '1', '\0', /* reserved31 (98450) */
	'S', 'E', 'M', '_', 'P', 'R', 'I', 'V', '\0', /* SEM_PRIV (98461) */
	'U', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'R', 'E', 'G', '_', 'E', 'N', '\0', /* UCONFIG_REG_EN (98470) */
	'A', 'C', 'T', 'I', 'O', 'N', '_', 'P', 'I', 'P', 'E', '_', 'I', 'D', '\0', /* ACTION_PIPE_ID (98485) */
	'A', 'C', 'T', 'I', 'O', 'N', '_', 'I', 'D', '\0', /* ACTION_ID (98500) */
	'H', 'E', 'A', 'D', '_', 'Q', 'U', 'E', 'U', 'E', '1', '\0', /* HEAD_QUEUE1 (98510) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'P', 'E', 'R', 'F', '\0', /* DISABLE_ME0PIPE0_PERF (98522) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'P', 'E', 'R', 'F', '\0', /* DISABLE_ME0PIPE1_PERF (98544) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'M', 'E', '1', 'P', 'I', 'P', 'E', '0', '_', 'P', 'E', 'R', 'F', '\0', /* DISABLE_ME1PIPE0_PERF (98566) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'M', 'E', '1', 'P', 'I', 'P', 'E', '1', '_', 'P', 'E', 'R', 'F', '\0', /* DISABLE_ME1PIPE1_PERF (98588) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'M', 'E', '1', 'P', 'I', 'P', 'E', '2', '_', 'P', 'E', 'R', 'F', '\0', /* DISABLE_ME1PIPE2_PERF (98610) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'M', 'E', '1', 'P', 'I', 'P', 'E', '3', '_', 'P', 'E', 'R', 'F', '\0', /* DISABLE_ME1PIPE3_PERF (98632) */
	'S', 'w', 'a', 'A', 'c', 'c', 'u', 'm', 'D', 'o', 'n', 'e', '\0', /* SwaAccumDone (98654) */
	'S', 'w', 'a', 'S', 'p', 'm', 'D', 'o', 'n', 'e', '\0', /* SwaSpmDone (98667) */
	'S', 'w', 'a', 'A', 'c', 'c', 'u', 'm', 'O', 'v', 'e', 'r', 'f', 'l', 'o', 'w', '\0', /* SwaAccumOverflow (98678) */
	'S', 'w', 'a', 'A', 'c', 'c', 'u', 'm', 'A', 'r', 'm', 'e', 'd', '\0', /* SwaAccumArmed (98695) */
	'A', 'l', 'l', 'S', 'e', 'g', 's', 'D', 'o', 'n', 'e', '\0', /* AllSegsDone (98709) */
	'R', 'e', 'a', 'r', 'm', 'S', 'w', 'a', 'P', 'e', 'n', 'd', 'i', 'n', 'g', '\0', /* RearmSwaPending (98721) */
	'R', 'e', 'a', 'r', 'm', 'S', 'p', 'p', 'P', 'e', 'n', 'd', 'i', 'n', 'g', '\0', /* RearmSppPending (98737) */
	'S', 't', 'r', 'o', 'b', 'e', 'R', 'e', 's', 'e', 't', 'S', 'p', 'm', 'B', 'l', 'o', 'c', 'k', '\0', /* StrobeResetSpmBlock (98753) */
	'S', 't', 'r', 'o', 'b', 'e', 'R', 'e', 'a', 'r', 'm', 'S', 'w', 'a', 'A', 'c', 'c', 'u', 'm', '\0', /* StrobeRearmSwaAccum (98773) */
	'S', 't', 'r', 'o', 'b', 'e', 'S', 't', 'a', 'r', 't', 'S', 'w', 'a', '\0', /* StrobeStartSwa (98793) */
	'S', 't', 'r', 'o', 'b', 'e', 'P', 'e', 'r', 'f', 'm', 'o', 'n', 'S', 'a', 'm', 'p', 'l', 'e', 'W', 'i', 'r', 'e', 's', '\0', /* StrobePerfmonSampleWires (98808) */
	'E', 'n', 'a', 'b', 'l', 'e', 'S', 'p', 'm', 'W', 'i', 't', 'h', 'A', 'c', 'c', 'u', 'm', 'M', 'o', 'd', 'e', '\0', /* EnableSpmWithAccumMode (98833) */
	'E', 'n', 'a', 'b', 'l', 'e', 'S', 'P', 'P', 'M', 'o', 'd', 'e', '\0', /* EnableSPPMode (98856) */
	'S', 'w', 'a', 'A', 'u', 't', 'o', 'R', 'e', 's', 'e', 't', 'P', 'e', 'r', 'f', 'm', 'o', 'n', 'D', 'i', 's', 'a', 'b', 'l', 'e', '\0', /* SwaAutoResetPerfmonDisable (98870) */
	'S', 'w', 'a', 'A', 'u', 't', 'o', 'A', 'c', 'c', 'u', 'm', 'E', 'n', '\0', /* SwaAutoAccumEn (98897) */
	'S', 'w', 'a', 'A', 'u', 't', 'o', 'S', 'p', 'm', 'E', 'n', '\0', /* SwaAutoSpmEn (98912) */
	'G', 'l', 'o', 'b', 'a', 'l', 's', '_', 'S', 'w', 'a', 'L', 'o', 'a', 'd', 'O', 'v', 'e', 'r', 'r', 'i', 'd', 'e', '\0', /* Globals_SwaLoadOverride (98925) */
	'S', 'E', '0', '_', 'S', 'w', 'a', 'L', 'o', 'a', 'd', 'O', 'v', 'e', 'r', 'r', 'i', 'd', 'e', '\0', /* SE0_SwaLoadOverride (98949) */
	'S', 'E', '1', '_', 'S', 'w', 'a', 'L', 'o', 'a', 'd', 'O', 'v', 'e', 'r', 'r', 'i', 'd', 'e', '\0', /* SE1_SwaLoadOverride (98969) */
	'S', 'E', '2', '_', 'L', 'o', 'a', 'd', 'O', 'v', 'e', 'r', 'r', 'i', 'd', 'e', '\0', /* SE2_LoadOverride (98989) */
	'S', 'E', '2', '_', 'S', 'w', 'a', 'L', 'o', 'a', 'd', 'O', 'v', 'e', 'r', 'r', 'i', 'd', 'e', '\0', /* SE2_SwaLoadOverride (99006) */
	'S', 'E', '3', '_', 'L', 'o', 'a', 'd', 'O', 'v', 'e', 'r', 'r', 'i', 'd', 'e', '\0', /* SE3_LoadOverride (99026) */
	'S', 'E', '3', '_', 'S', 'w', 'a', 'L', 'o', 'a', 'd', 'O', 'v', 'e', 'r', 'r', 'i', 'd', 'e', '\0', /* SE3_SwaLoadOverride (99043) */
	'g', 'l', 'o', 'b', 'a', 'l', '_', 'o', 'f', 'f', 's', 'e', 't', '\0', /* global_offset (99063) */
	's', 'p', 'm', 'w', 'i', 't', 'h', 'a', 'c', 'c', 'u', 'm', '_', 's', 'e', '_', 'o', 'f', 'f', 's', 'e', 't', '\0', /* spmwithaccum_se_offset (99077) */
	's', 'p', 'm', 'w', 'i', 't', 'h', 'a', 'c', 'c', 'u', 'm', '_', 'g', 'l', 'o', 'b', 'a', 'l', '_', 'o', 'f', 'f', 's', 'e', 't', '\0', /* spmwithaccum_global_offset (99100) */
	's', 'p', 'p', '_', 'a', 'd', 'd', 'r', '_', 'r', 'e', 'g', 'i', 'o', 'n', '\0', /* spp_addr_region (99127) */
	's', 'w', 'a', '_', 'a', 'd', 'd', 'r', '_', 'r', 'e', 'g', 'i', 'o', 'n', '\0', /* swa_addr_region (99143) */
	'C', 'M', 'D', '_', 'O', 'P', '\0', /* CMD_OP (99159) */
	'D', 'E', 'B', 'U', 'G', '_', 'E', 'N', '\0', /* DEBUG_EN (99166) */
	'W', 'A', 'V', 'E', '_', 'P', 'R', 'I', 'O', '\0', /* WAVE_PRIO (99175) */
	'T', 'T', 'R', 'A', 'C', 'E', '_', 'C', 'U', '_', 'E', 'N', '\0', /* TTRACE_CU_EN (99185) */
	'C', 'O', 'N', 'D', '_', 'D', 'B', 'G', '_', 'U', 'S', 'E', 'R', '\0', /* COND_DBG_USER (99198) */
	'C', 'O', 'N', 'D', '_', 'D', 'B', 'G', '_', 'S', 'Y', 'S', '\0', /* COND_DBG_SYS (99212) */
	'D', 'A', 'T', 'A', '_', 'A', 'T', 'C', '\0', /* DATA_ATC (99225) */
	'I', 'N', 'S', 'T', '_', 'A', 'T', 'C', '\0', /* INST_ATC (99234) */
	'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'C', 'A', 'C', 'H', 'E', '_', 'C', 'T', 'R', 'L', '\0', /* DISPATCH_CACHE_CTRL (99243) */
	'I', 'B', 'U', 'F', '_', 'S', 'T', '\0', /* IBUF_ST (99263) */
	'P', 'C', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', '\0', /* PC_INVALID (99271) */
	'N', 'E', 'E', 'D', '_', 'N', 'E', 'X', 'T', '_', 'D', 'W', '\0', /* NEED_NEXT_DW (99282) */
	'N', 'O', '_', 'P', 'R', 'E', 'F', 'E', 'T', 'C', 'H', '_', 'C', 'N', 'T', '\0', /* NO_PREFETCH_CNT (99295) */
	'I', 'B', 'U', 'F', '_', 'R', 'P', 'T', 'R', '\0', /* IBUF_RPTR (99311) */
	'I', 'B', 'U', 'F', '_', 'W', 'P', 'T', 'R', '\0', /* IBUF_WPTR (99321) */
	'I', 'N', 'S', 'T', '_', 'S', 'T', 'R', '_', 'S', 'T', '\0', /* INST_STR_ST (99331) */
	'E', 'C', 'C', '_', 'S', 'T', '\0', /* ECC_ST (99343) */
	'I', 'S', '_', 'H', 'Y', 'B', '\0', /* IS_HYB (99350) */
	'H', 'Y', 'B', '_', 'C', 'N', 'T', '\0', /* HYB_CNT (99357) */
	'N', 'E', 'E', 'D', '_', 'K', 'I', 'L', 'L', '_', 'I', 'F', 'E', 'T', 'C', 'H', '\0', /* NEED_KILL_IFETCH (99365) */
	'S', 'D', 'M', 'A', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* SDMA_RQ_PENDING (99382) */
	'T', 'S', 'T', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* TST_RQ_PENDING (99398) */
	'V', 'C', 'E', '0', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* VCE0_RQ_PENDING (99413) */
	'V', 'P', '8', '_', 'B', 'U', 'S', 'Y', '\0', /* VP8_BUSY (99429) */
	'S', 'D', 'M', 'A', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* SDMA1_BUSY (99438) */
	'V', 'C', 'E', '0', '_', 'B', 'U', 'S', 'Y', '\0', /* VCE0_BUSY (99449) */
	'X', 'D', 'M', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* XDMA_BUSY (99459) */
	'C', 'H', 'U', 'B', '_', 'B', 'U', 'S', 'Y', '\0', /* CHUB_BUSY (99469) */
	'S', 'D', 'M', 'A', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* SDMA2_BUSY (99479) */
	'S', 'D', 'M', 'A', '3', '_', 'B', 'U', 'S', 'Y', '\0', /* SDMA3_BUSY (99490) */
	'S', 'A', 'M', 'S', 'C', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* SAMSCP_BUSY (99501) */
	'I', 'S', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* ISP_BUSY (99513) */
	'V', 'C', 'E', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* VCE1_BUSY (99522) */
	'O', 'D', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* ODE_BUSY (99532) */
	'S', 'A', 'M', 'S', 'C', 'P', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* SAMSCP_RQ_PENDING (99541) */
	'I', 'S', 'P', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ISP_RQ_PENDING (99559) */
	'V', 'C', 'E', '1', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* VCE1_RQ_PENDING (99574) */
	'U', 'V', 'D', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* UVD_RQ_PENDING (99590) */
	'S', 'A', 'M', 'M', 'S', 'P', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* SAMMSP_RQ_PENDING (99605) */
	'A', 'C', 'P', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* ACP_RQ_PENDING (99623) */
	'G', 'R', 'B', 'M', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* GRBM_RQ_PENDING (99638) */
	'H', 'I', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* HI_RQ_PENDING (99654) */
	'V', 'M', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* VMC_BUSY (99668) */
	'M', 'C', 'B', '_', 'B', 'U', 'S', 'Y', '\0', /* MCB_BUSY (99677) */
	'M', 'C', 'B', '_', 'N', 'O', 'N', '_', 'D', 'I', 'S', 'P', 'L', 'A', 'Y', '_', 'B', 'U', 'S', 'Y', '\0', /* MCB_NON_DISPLAY_BUSY (99686) */
	'M', 'C', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* MCC_BUSY (99707) */
	'M', 'C', 'D', '_', 'B', 'U', 'S', 'Y', '\0', /* MCD_BUSY (99716) */
	'V', 'M', 'C', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* VMC1_BUSY (99725) */
	'S', 'E', 'M', '_', 'B', 'U', 'S', 'Y', '\0', /* SEM_BUSY (99735) */
	'A', 'C', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* ACP_BUSY (99744) */
	'I', 'H', '_', 'B', 'U', 'S', 'Y', '\0', /* IH_BUSY (99753) */
	'U', 'V', 'D', '_', 'B', 'U', 'S', 'Y', '\0', /* UVD_BUSY (99761) */
	'S', 'A', 'M', 'M', 'S', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* SAMMSP_BUSY (99770) */
	'G', 'C', 'A', 'T', 'C', 'L', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* GCATCL2_BUSY (99782) */
	'O', 'S', 'A', 'T', 'C', 'L', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* OSATCL2_BUSY (99795) */
	'B', 'I', 'F', '_', 'B', 'U', 'S', 'Y', '\0', /* BIF_BUSY (99808) */
	'M', 'C', 'C', '0', '_', 'B', 'U', 'S', 'Y', '\0', /* MCC0_BUSY (99817) */
	'M', 'C', 'C', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* MCC1_BUSY (99827) */
	'M', 'C', 'C', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* MCC2_BUSY (99837) */
	'M', 'C', 'C', '3', '_', 'B', 'U', 'S', 'Y', '\0', /* MCC3_BUSY (99847) */
	'M', 'C', 'C', '4', '_', 'B', 'U', 'S', 'Y', '\0', /* MCC4_BUSY (99857) */
	'M', 'C', 'C', '5', '_', 'B', 'U', 'S', 'Y', '\0', /* MCC5_BUSY (99867) */
	'M', 'C', 'C', '6', '_', 'B', 'U', 'S', 'Y', '\0', /* MCC6_BUSY (99877) */
	'M', 'C', 'C', '7', '_', 'B', 'U', 'S', 'Y', '\0', /* MCC7_BUSY (99887) */
	'M', 'C', 'D', '0', '_', 'B', 'U', 'S', 'Y', '\0', /* MCD0_BUSY (99897) */
	'M', 'C', 'D', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* MCD1_BUSY (99907) */
	'M', 'C', 'D', '2', '_', 'B', 'U', 'S', 'Y', '\0', /* MCD2_BUSY (99917) */
	'M', 'C', 'D', '3', '_', 'B', 'U', 'S', 'Y', '\0', /* MCD3_BUSY (99927) */
	'M', 'C', 'D', '4', '_', 'B', 'U', 'S', 'Y', '\0', /* MCD4_BUSY (99937) */
	'M', 'C', 'D', '5', '_', 'B', 'U', 'S', 'Y', '\0', /* MCD5_BUSY (99947) */
	'M', 'C', 'D', '6', '_', 'B', 'U', 'S', 'Y', '\0', /* MCD6_BUSY (99957) */
	'M', 'C', 'D', '7', '_', 'B', 'U', 'S', 'Y', '\0', /* MCD7_BUSY (99967) */
	'R', 'E', 'A', 'D', '_', 'T', 'I', 'M', 'E', 'O', 'U', 'T', '\0', /* READ_TIMEOUT (99977) */
	'S', 'K', 'E', 'W', '_', 'T', 'O', 'P', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '\0', /* SKEW_TOP_THRESHOLD (99990) */
	'S', 'K', 'E', 'W', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* SKEW_COUNT (100009) */
	'R', 'E', 'Q', '_', 'T', 'Y', 'P', 'E', '\0', /* REQ_TYPE (100020) */
	'R', 'S', 'P', '_', 'T', 'Y', 'P', 'E', '\0', /* RSP_TYPE (100029) */
	'S', 'R', 'B', 'M', '_', 'R', 'Q', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* SRBM_RQ_PENDING (100038) */
	'W', 'D', '_', 'B', 'U', 'S', 'Y', '_', 'N', 'O', '_', 'D', 'M', 'A', '\0', /* WD_BUSY_NO_DMA (100054) */
	'V', 'G', 'T', '_', 'B', 'U', 'S', 'Y', '\0', /* VGT_BUSY (100069) */
	'I', 'A', '_', 'B', 'U', 'S', 'Y', '_', 'N', 'O', '_', 'D', 'M', 'A', '\0', /* IA_BUSY_NO_DMA (100078) */
	'I', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* IA_BUSY (100093) */
	'W', 'D', '_', 'B', 'U', 'S', 'Y', '\0', /* WD_BUSY (100101) */
	'S', 'O', 'F', 'T', '_', 'R', 'E', 'S', 'E', 'T', '_', 'C', 'P', '\0', /* SOFT_RESET_CP (100109) */
	'S', 'O', 'F', 'T', '_', 'R', 'E', 'S', 'E', 'T', '_', 'R', 'L', 'C', '\0', /* SOFT_RESET_RLC (100123) */
	'S', 'O', 'F', 'T', '_', 'R', 'E', 'S', 'E', 'T', '_', 'G', 'F', 'X', '\0', /* SOFT_RESET_GFX (100138) */
	'S', 'O', 'F', 'T', '_', 'R', 'E', 'S', 'E', 'T', '_', 'C', 'P', 'F', '\0', /* SOFT_RESET_CPF (100153) */
	'S', 'O', 'F', 'T', '_', 'R', 'E', 'S', 'E', 'T', '_', 'C', 'P', 'C', '\0', /* SOFT_RESET_CPC (100168) */
	'S', 'O', 'F', 'T', '_', 'R', 'E', 'S', 'E', 'T', '_', 'C', 'P', 'G', '\0', /* SOFT_RESET_CPG (100183) */
	'G', 'R', 'B', 'M', '_', 'D', 'E', 'B', 'U', 'G', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* GRBM_DEBUG_INDEX (100198) */
	'S', 'H', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* SH_INDEX (100215) */
	'S', 'H', '_', 'B', 'R', 'O', 'A', 'D', 'C', 'A', 'S', 'T', '_', 'W', 'R', 'I', 'T', 'E', 'S', '\0', /* SH_BROADCAST_WRITES (100224) */
	'P', 'R', 'E', 'F', 'I', 'X', '_', 'D', 'E', 'L', 'A', 'Y', '_', 'C', 'N', 'T', '\0', /* PREFIX_DELAY_CNT (100244) */
	'P', 'O', 'S', 'T', '_', 'D', 'E', 'L', 'A', 'Y', '_', 'C', 'N', 'T', '\0', /* POST_DELAY_CNT (100261) */
	'I', 'G', 'N', 'O', 'R', 'E', '_', 'R', 'D', 'Y', '\0', /* IGNORE_RDY (100276) */
	'I', 'G', 'N', 'O', 'R', 'E', '_', 'F', 'A', 'O', '\0', /* IGNORE_FAO (100287) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'R', 'E', 'A', 'D', '_', 'T', 'I', 'M', 'E', 'O', 'U', 'T', '\0', /* DISABLE_READ_TIMEOUT (100298) */
	'S', 'N', 'A', 'P', 'S', 'H', 'O', 'T', '_', 'F', 'R', 'E', 'E', '_', 'C', 'N', 'T', 'R', 'S', '\0', /* SNAPSHOT_FREE_CNTRS (100319) */
	'H', 'Y', 'S', 'T', 'E', 'R', 'E', 'S', 'I', 'S', '_', 'G', 'U', 'I', '_', 'A', 'C', 'T', 'I', 'V', 'E', '\0', /* HYSTERESIS_GUI_ACTIVE (100339) */
	'G', 'F', 'X', '_', 'C', 'L', 'O', 'C', 'K', '_', 'D', 'O', 'M', 'A', 'I', 'N', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* GFX_CLOCK_DOMAIN_OVERRIDE (100361) */
	'C', 'P', 'F', '_', 'R', 'D', 'Y', '\0', /* CPF_RDY (100387) */
	'C', 'P', 'G', '_', 'R', 'D', 'Y', '\0', /* CPG_RDY (100395) */
	'S', 'R', 'B', 'M', '_', 'R', 'D', 'Y', '\0', /* SRBM_RDY (100403) */
	'W', 'D', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'R', 'D', 'Y', '\0', /* WD_ME0PIPE0_RDY (100412) */
	'W', 'D', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'R', 'D', 'Y', '\0', /* WD_ME0PIPE1_RDY (100428) */
	'S', 'E', '0', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'R', 'D', 'Y', '0', '\0', /* SE0SPI_ME0PIPE0_RDY0 (100444) */
	'S', 'E', '0', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'R', 'D', 'Y', '0', '\0', /* SE0SPI_ME0PIPE1_RDY0 (100465) */
	'S', 'E', '1', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'R', 'D', 'Y', '0', '\0', /* SE1SPI_ME0PIPE0_RDY0 (100486) */
	'G', 'D', 'S', '_', 'R', 'D', 'Y', '\0', /* GDS_RDY (100507) */
	'S', 'E', '1', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'R', 'D', 'Y', '0', '\0', /* SE1SPI_ME0PIPE1_RDY0 (100515) */
	'S', 'E', '2', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'R', 'D', 'Y', '0', '\0', /* SE2SPI_ME0PIPE0_RDY0 (100536) */
	'S', 'E', '2', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'R', 'D', 'Y', '0', '\0', /* SE2SPI_ME0PIPE1_RDY0 (100557) */
	'S', 'E', '3', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'R', 'D', 'Y', '0', '\0', /* SE3SPI_ME0PIPE0_RDY0 (100578) */
	'S', 'E', '3', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'R', 'D', 'Y', '0', '\0', /* SE3SPI_ME0PIPE1_RDY0 (100599) */
	'S', 'E', '0', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'R', 'D', 'Y', '1', '\0', /* SE0SPI_ME0PIPE0_RDY1 (100620) */
	'S', 'E', '0', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'R', 'D', 'Y', '1', '\0', /* SE0SPI_ME0PIPE1_RDY1 (100641) */
	'S', 'E', '1', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'R', 'D', 'Y', '1', '\0', /* SE1SPI_ME0PIPE0_RDY1 (100662) */
	'S', 'E', '1', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'R', 'D', 'Y', '1', '\0', /* SE1SPI_ME0PIPE1_RDY1 (100683) */
	'S', 'E', '2', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'R', 'D', 'Y', '1', '\0', /* SE2SPI_ME0PIPE0_RDY1 (100704) */
	'S', 'E', '2', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'R', 'D', 'Y', '1', '\0', /* SE2SPI_ME0PIPE1_RDY1 (100725) */
	'S', 'E', '3', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '0', '_', 'R', 'D', 'Y', '1', '\0', /* SE3SPI_ME0PIPE0_RDY1 (100746) */
	'S', 'E', '3', 'S', 'P', 'I', '_', 'M', 'E', '0', 'P', 'I', 'P', 'E', '1', '_', 'R', 'D', 'Y', '1', '\0', /* SE3SPI_ME0PIPE1_RDY1 (100767) */
	'R', 'E', 'A', 'D', '_', 'A', 'D', 'D', 'R', 'E', 'S', 'S', '\0', /* READ_ADDRESS (100788) */
	'R', 'E', 'A', 'D', '_', 'P', 'I', 'P', 'E', 'I', 'D', '\0', /* READ_PIPEID (100801) */
	'R', 'E', 'A', 'D', '_', 'M', 'E', 'I', 'D', '\0', /* READ_MEID (100813) */
	'R', 'D', 'E', 'R', 'R', '_', 'I', 'N', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* RDERR_INT_ENABLE (100823) */
	'G', 'U', 'I', '_', 'I', 'D', 'L', 'E', '_', 'I', 'N', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* GUI_IDLE_INT_ENABLE (100840) */
	'V', 'G', 'T', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* VGT_BUSY_USER_DEFINED_MASK (100860) */
	'I', 'A', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* IA_BUSY_USER_DEFINED_MASK (100887) */
	'T', 'C', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* TC_BUSY_USER_DEFINED_MASK (100913) */
	'W', 'D', '_', 'B', 'U', 'S', 'Y', '_', 'U', 'S', 'E', 'R', '_', 'D', 'E', 'F', 'I', 'N', 'E', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* WD_BUSY_USER_DEFINED_MASK (100939) */
	'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '\0', /* THREAD_TRACE (100965) */
	'W', 'L', 'T', '\0', /* WLT (100978) */
	'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'B', 'U', 'F', '_', 'F', 'U', 'L', 'L', '\0', /* THREAD_TRACE_BUF_FULL (100982) */
	'R', 'E', 'G', '_', 'T', 'I', 'M', 'E', 'S', 'T', 'A', 'M', 'P', '\0', /* REG_TIMESTAMP (101004) */
	'C', 'M', 'D', '_', 'T', 'I', 'M', 'E', 'S', 'T', 'A', 'M', 'P', '\0', /* CMD_TIMESTAMP (101018) */
	'H', 'O', 'S', 'T', '_', 'C', 'M', 'D', '_', 'O', 'V', 'E', 'R', 'F', 'L', 'O', 'W', '\0', /* HOST_CMD_OVERFLOW (101032, 101037) */
	'H', 'O', 'S', 'T', '_', 'R', 'E', 'G', '_', 'O', 'V', 'E', 'R', 'F', 'L', 'O', 'W', '\0', /* HOST_REG_OVERFLOW (101050) */
	'I', 'M', 'M', 'E', 'D', '_', 'O', 'V', 'E', 'R', 'F', 'L', 'O', 'W', '\0', /* IMMED_OVERFLOW (101068) */
	'S', 'T', 'R', 'E', 'A', 'M', '_', 'O', 'U', 'T', '_', 'A', 'D', 'D', 'R', '_', 'S', 'W', 'A', 'P', '\0', /* STREAM_OUT_ADDR_SWAP (101083) */
	'P', 'I', 'P', 'E', '_', 'S', 'T', 'A', 'T', 'S', '_', 'A', 'D', 'D', 'R', '_', 'S', 'W', 'A', 'P', '\0', /* PIPE_STATS_ADDR_SWAP (101104) */
	'M', 'E', '_', 'M', 'C', '_', 'W', 'A', 'D', 'D', 'R', '_', 'S', 'W', 'A', 'P', '\0', /* ME_MC_WADDR_SWAP (101125) */
	'M', 'E', '_', 'M', 'C', '_', 'R', 'A', 'D', 'D', 'R', '_', 'S', 'W', 'A', 'P', '\0', /* ME_MC_RADDR_SWAP (101142) */
	'T', 'C', '_', 'V', 'O', 'L', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* TC_VOL_ACTION_ENA (101159) */
	'P', 'H', 'A', 'S', 'E', '1', '_', 'S', 'T', 'A', 'T', 'U', 'S', '\0', /* PHASE1_STATUS (101177) */
	'S', 'R', 'C', '_', 'S', 'W', 'A', 'P', '\0', /* SRC_SWAP (101191) */
	'D', 'S', 'T', '_', 'S', 'W', 'A', 'P', '\0', /* DST_SWAP (101200) */
	'C', 'E', '_', 'T', 'O', '_', 'C', 'S', 'F', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* CE_TO_CSF_NOT_RDY_TO_RCV (101209) */
	'C', 'E', '_', 'T', 'O', '_', 'R', 'A', 'M', '_', 'I', 'N', 'I', 'T', '_', 'F', 'E', 'T', 'C', 'H', 'E', 'R', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* CE_TO_RAM_INIT_FETCHER_NOT_RDY_TO_RCV (101234) */
	'C', 'E', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'D', 'A', 'T', 'A', '_', 'F', 'R', 'O', 'M', '_', 'R', 'A', 'M', '_', 'I', 'N', 'I', 'T', '_', 'F', 'E', 'T', 'C', 'H', 'E', 'R', '\0', /* CE_WAITING_ON_DATA_FROM_RAM_INIT_FETCHER (101272) */
	'C', 'E', '_', 'T', 'O', '_', 'R', 'A', 'M', '_', 'I', 'N', 'I', 'T', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '\0', /* CE_TO_RAM_INIT_NOT_RDY (101313) */
	'C', 'E', '_', 'T', 'O', '_', 'R', 'A', 'M', '_', 'D', 'U', 'M', 'P', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '\0', /* CE_TO_RAM_DUMP_NOT_RDY (101336) */
	'C', 'E', '_', 'T', 'O', '_', 'R', 'A', 'M', '_', 'W', 'R', 'I', 'T', 'E', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '\0', /* CE_TO_RAM_WRITE_NOT_RDY (101359) */
	'C', 'E', '_', 'T', 'O', '_', 'I', 'N', 'C', '_', 'F', 'I', 'F', 'O', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* CE_TO_INC_FIFO_NOT_RDY_TO_RCV (101383) */
	'C', 'E', '_', 'T', 'O', '_', 'W', 'R', '_', 'F', 'I', 'F', 'O', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* CE_TO_WR_FIFO_NOT_RDY_TO_RCV (101413) */
	'C', 'E', '_', 'T', 'O', '_', 'M', 'I', 'U', '_', 'W', 'R', 'I', 'T', 'E', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* CE_TO_MIU_WRITE_NOT_RDY_TO_RCV (101442) */
	'C', 'E', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'D', 'A', 'T', 'A', '\0', /* CE_WAITING_ON_BUFFER_DATA (101473) */
	'C', 'E', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'C', 'E', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'F', 'L', 'A', 'G', '\0', /* CE_WAITING_ON_CE_BUFFER_FLAG (101499) */
	'C', 'E', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'D', 'E', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '\0', /* CE_WAITING_ON_DE_COUNTER (101528) */
	'C', 'E', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'D', 'E', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '_', 'U', 'N', 'D', 'E', 'R', 'F', 'L', 'O', 'W', '\0', /* CE_WAITING_ON_DE_COUNTER_UNDERFLOW (101553) */
	'R', 'B', 'I', 'U', '_', 'T', 'O', '_', 'D', 'M', 'A', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* RBIU_TO_DMA_NOT_RDY_TO_RCV (101588) */
	'R', 'B', 'I', 'U', '_', 'T', 'O', '_', 'S', 'E', 'M', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* RBIU_TO_SEM_NOT_RDY_TO_RCV (101615) */
	'R', 'B', 'I', 'U', '_', 'T', 'O', '_', 'M', 'E', 'M', 'W', 'R', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* RBIU_TO_MEMWR_NOT_RDY_TO_RCV (101642) */
	'M', 'E', '_', 'H', 'A', 'S', '_', 'A', 'C', 'T', 'I', 'V', 'E', '_', 'C', 'E', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'F', 'L', 'A', 'G', '\0', /* ME_HAS_ACTIVE_CE_BUFFER_FLAG (101671) */
	'M', 'E', '_', 'H', 'A', 'S', '_', 'A', 'C', 'T', 'I', 'V', 'E', '_', 'D', 'E', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'F', 'L', 'A', 'G', '\0', /* ME_HAS_ACTIVE_DE_BUFFER_FLAG (101700) */
	'M', 'E', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'O', 'N', '_', 'T', 'C', '_', 'W', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'R', 'M', '\0', /* ME_STALLED_ON_TC_WR_CONFIRM (101729) */
	'M', 'E', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'O', 'N', '_', 'A', 'T', 'O', 'M', 'I', 'C', '_', 'R', 'T', 'N', '_', 'D', 'A', 'T', 'A', '\0', /* ME_STALLED_ON_ATOMIC_RTN_DATA (101757) */
	'M', 'E', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'M', 'C', '_', 'R', 'E', 'A', 'D', '_', 'D', 'A', 'T', 'A', '\0', /* ME_WAITING_ON_MC_READ_DATA (101787) */
	'M', 'E', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'R', 'E', 'G', '_', 'R', 'E', 'A', 'D', '_', 'D', 'A', 'T', 'A', '\0', /* ME_WAITING_ON_REG_READ_DATA (101814) */
	'M', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'R', 'D', 'R', 'E', 'Q', '_', 'F', 'R', 'E', 'E', '\0', /* MIU_WAITING_ON_RDREQ_FREE (101842) */
	'M', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'W', 'R', 'R', 'E', 'Q', '_', 'F', 'R', 'E', 'E', '\0', /* MIU_WAITING_ON_WRREQ_FREE (101868) */
	'R', 'C', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'G', 'D', 'S', '_', 'F', 'R', 'E', 'E', '\0', /* RCIU_WAITING_ON_GDS_FREE (101894) */
	'R', 'C', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'G', 'R', 'B', 'M', '_', 'F', 'R', 'E', 'E', '\0', /* RCIU_WAITING_ON_GRBM_FREE (101919) */
	'R', 'C', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'V', 'G', 'T', '_', 'F', 'R', 'E', 'E', '\0', /* RCIU_WAITING_ON_VGT_FREE (101945) */
	'R', 'C', 'I', 'U', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'O', 'N', '_', 'M', 'E', '_', 'R', 'E', 'A', 'D', '\0', /* RCIU_STALLED_ON_ME_READ (101970) */
	'R', 'C', 'I', 'U', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'O', 'N', '_', 'D', 'M', 'A', '_', 'R', 'E', 'A', 'D', '\0', /* RCIU_STALLED_ON_DMA_READ (101994) */
	'R', 'C', 'I', 'U', '_', 'H', 'A', 'L', 'T', 'E', 'D', '_', 'B', 'Y', '_', 'R', 'E', 'G', '_', 'V', 'I', 'O', 'L', 'A', 'T', 'I', 'O', 'N', '\0', /* RCIU_HALTED_BY_REG_VIOLATION (102019) */
	'R', 'C', 'I', 'U', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'O', 'N', '_', 'A', 'P', 'P', 'E', 'N', 'D', '_', 'R', 'E', 'A', 'D', '\0', /* RCIU_STALLED_ON_APPEND_READ (102048) */
	'P', 'F', 'P', '_', 'T', 'O', '_', 'C', 'S', 'F', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* PFP_TO_CSF_NOT_RDY_TO_RCV (102076) */
	'P', 'F', 'P', '_', 'T', 'O', '_', 'M', 'E', 'Q', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* PFP_TO_MEQ_NOT_RDY_TO_RCV (102102) */
	'P', 'F', 'P', '_', 'T', 'O', '_', 'R', 'C', 'I', 'U', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* PFP_TO_RCIU_NOT_RDY_TO_RCV (102128) */
	'P', 'F', 'P', '_', 'T', 'O', '_', 'V', 'G', 'T', '_', 'W', 'R', 'I', 'T', 'E', 'S', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* PFP_TO_VGT_WRITES_PENDING (102155) */
	'P', 'F', 'P', '_', 'R', 'C', 'I', 'U', '_', 'R', 'E', 'A', 'D', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* PFP_RCIU_READ_PENDING (102181) */
	'P', 'F', 'P', '_', 'M', 'I', 'U', '_', 'R', 'E', 'A', 'D', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* PFP_MIU_READ_PENDING (102203) */
	'P', 'F', 'P', '_', 'T', 'O', '_', 'M', 'I', 'U', '_', 'W', 'R', 'I', 'T', 'E', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* PFP_TO_MIU_WRITE_NOT_RDY_TO_RCV (102224) */
	'P', 'F', 'P', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'D', 'A', 'T', 'A', '\0', /* PFP_WAITING_ON_BUFFER_DATA (102256) */
	'M', 'E', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'C', 'E', '_', 'C', 'O', 'U', 'N', 'T', 'E', 'R', '\0', /* ME_WAIT_ON_CE_COUNTER (102283) */
	'M', 'E', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'A', 'V', 'A', 'I', 'L', '_', 'B', 'U', 'F', 'F', 'E', 'R', '\0', /* ME_WAIT_ON_AVAIL_BUFFER (102305) */
	'G', 'F', 'X', '_', 'C', 'N', 'T', 'X', '_', 'N', 'O', 'T', '_', 'A', 'V', 'A', 'I', 'L', '_', 'T', 'O', '_', 'M', 'E', '\0', /* GFX_CNTX_NOT_AVAIL_TO_ME (102329) */
	'M', 'E', '_', 'R', 'C', 'I', 'U', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* ME_RCIU_NOT_RDY_TO_RCV (102354) */
	'M', 'E', '_', 'T', 'O', '_', 'C', 'O', 'N', 'S', 'T', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* ME_TO_CONST_NOT_RDY_TO_RCV (102377) */
	'M', 'E', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'R', 'O', 'M', '_', 'P', 'F', 'P', '\0', /* ME_WAITING_DATA_FROM_PFP (102404) */
	'M', 'E', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'P', 'A', 'R', 'T', 'I', 'A', 'L', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* ME_WAITING_ON_PARTIAL_FLUSH (102429) */
	'M', 'E', 'Q', '_', 'T', 'O', '_', 'M', 'E', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* MEQ_TO_ME_NOT_RDY_TO_RCV (102457) */
	'S', 'T', 'Q', '_', 'T', 'O', '_', 'M', 'E', '_', 'N', 'O', 'T', '_', 'R', 'D', 'Y', '_', 'T', 'O', '_', 'R', 'C', 'V', '\0', /* STQ_TO_ME_NOT_RDY_TO_RCV (102482) */
	'M', 'E', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'R', 'O', 'M', '_', 'S', 'T', 'Q', '\0', /* ME_WAITING_DATA_FROM_STQ (102507) */
	'P', 'F', 'P', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'O', 'N', '_', 'T', 'C', '_', 'W', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'R', 'M', '\0', /* PFP_STALLED_ON_TC_WR_CONFIRM (102532) */
	'P', 'F', 'P', '_', 'S', 'T', 'A', 'L', 'L', 'E', 'D', '_', 'O', 'N', '_', 'A', 'T', 'O', 'M', 'I', 'C', '_', 'R', 'T', 'N', '_', 'D', 'A', 'T', 'A', '\0', /* PFP_STALLED_ON_ATOMIC_RTN_DATA (102561) */
	'E', 'O', 'P', 'D', '_', 'F', 'I', 'F', 'O', '_', 'N', 'E', 'E', 'D', 'S', '_', 'S', 'C', '_', 'E', 'O', 'P', '_', 'D', 'O', 'N', 'E', '\0', /* EOPD_FIFO_NEEDS_SC_EOP_DONE (102592) */
	'E', 'O', 'P', 'D', '_', 'F', 'I', 'F', 'O', '_', 'N', 'E', 'E', 'D', 'S', '_', 'W', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'R', 'M', '\0', /* EOPD_FIFO_NEEDS_WR_CONFIRM (102620) */
	'S', 'T', 'R', 'M', 'O', '_', 'W', 'R', '_', 'O', 'F', '_', 'P', 'R', 'I', 'M', '_', 'D', 'A', 'T', 'A', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* STRMO_WR_OF_PRIM_DATA_PENDING (102647) */
	'P', 'I', 'P', 'E', '_', 'S', 'T', 'A', 'T', 'S', '_', 'W', 'R', '_', 'D', 'A', 'T', 'A', '_', 'P', 'E', 'N', 'D', 'I', 'N', 'G', '\0', /* PIPE_STATS_WR_DATA_PENDING (102677) */
	'A', 'P', 'P', 'E', 'N', 'D', '_', 'R', 'D', 'Y', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'C', 'S', '_', 'D', 'O', 'N', 'E', '\0', /* APPEND_RDY_WAIT_ON_CS_DONE (102704) */
	'A', 'P', 'P', 'E', 'N', 'D', '_', 'R', 'D', 'Y', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'P', 'S', '_', 'D', 'O', 'N', 'E', '\0', /* APPEND_RDY_WAIT_ON_PS_DONE (102731) */
	'A', 'P', 'P', 'E', 'N', 'D', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'W', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'R', 'M', '\0', /* APPEND_WAIT_ON_WR_CONFIRM (102758) */
	'A', 'P', 'P', 'E', 'N', 'D', '_', 'A', 'C', 'T', 'I', 'V', 'E', '_', 'P', 'A', 'R', 'T', 'I', 'T', 'I', 'O', 'N', '\0', /* APPEND_ACTIVE_PARTITION (102784) */
	'A', 'P', 'P', 'E', 'N', 'D', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'T', 'O', '_', 'S', 'E', 'N', 'D', '_', 'M', 'E', 'M', 'W', 'R', 'I', 'T', 'E', '\0', /* APPEND_WAITING_TO_SEND_MEMWRITE (102808) */
	'S', 'U', 'R', 'F', '_', 'S', 'Y', 'N', 'C', '_', 'N', 'E', 'E', 'D', 'S', '_', 'I', 'D', 'L', 'E', '_', 'C', 'N', 'T', 'X', 'S', '\0', /* SURF_SYNC_NEEDS_IDLE_CNTXS (102840) */
	'S', 'U', 'R', 'F', '_', 'S', 'Y', 'N', 'C', '_', 'N', 'E', 'E', 'D', 'S', '_', 'A', 'L', 'L', '_', 'C', 'L', 'E', 'A', 'N', '\0', /* SURF_SYNC_NEEDS_ALL_CLEAN (102867) */
	'C', 'O', 'H', 'E', 'R', '_', 'C', 'N', 'T', '_', 'N', 'E', 'Q', '_', 'Z', 'E', 'R', 'O', '\0', /* COHER_CNT_NEQ_ZERO (102893) */
	'P', 'F', 'P', '_', 'P', 'A', 'R', 'S', 'I', 'N', 'G', '_', 'P', 'A', 'C', 'K', 'E', 'T', 'S', '\0', /* PFP_PARSING_PACKETS (102912) */
	'M', 'E', '_', 'P', 'A', 'R', 'S', 'I', 'N', 'G', '_', 'P', 'A', 'C', 'K', 'E', 'T', 'S', '\0', /* ME_PARSING_PACKETS (102932) */
	'R', 'C', 'I', 'U', '_', 'P', 'F', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* RCIU_PFP_BUSY (102951, 102956) */
	'R', 'C', 'I', 'U', '_', 'M', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* RCIU_ME_BUSY (102965, 102970) */
	'S', 'E', 'M', '_', 'C', 'M', 'D', 'F', 'I', 'F', 'O', '_', 'N', 'O', 'T', '_', 'E', 'M', 'P', 'T', 'Y', '\0', /* SEM_CMDFIFO_NOT_EMPTY (102978) */
	'S', 'E', 'M', '_', 'F', 'A', 'I', 'L', 'E', 'D', '_', 'A', 'N', 'D', '_', 'H', 'O', 'L', 'D', 'I', 'N', 'G', '\0', /* SEM_FAILED_AND_HOLDING (103000) */
	'S', 'E', 'M', '_', 'P', 'O', 'L', 'L', 'I', 'N', 'G', '_', 'F', 'O', 'R', '_', 'P', 'A', 'S', 'S', '\0', /* SEM_POLLING_FOR_PASS (103023) */
	'G', 'F', 'X', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'B', 'U', 'S', 'Y', '\0', /* GFX_CONTEXT_BUSY (103044) */
	'M', 'E', '_', 'P', 'A', 'R', 'S', 'E', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* ME_PARSER_BUSY (103061) */
	'E', 'O', 'P', '_', 'D', 'O', 'N', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* EOP_DONE_BUSY (103076) */
	'S', 'T', 'R', 'M', '_', 'O', 'U', 'T', '_', 'B', 'U', 'S', 'Y', '\0', /* STRM_OUT_BUSY (103090) */
	'P', 'I', 'P', 'E', '_', 'S', 'T', 'A', 'T', 'S', '_', 'B', 'U', 'S', 'Y', '\0', /* PIPE_STATS_BUSY (103104) */
	'R', 'C', 'I', 'U', '_', 'C', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* RCIU_CE_BUSY (103120, 103125) */
	'C', 'E', '_', 'P', 'A', 'R', 'S', 'I', 'N', 'G', '_', 'P', 'A', 'C', 'K', 'E', 'T', 'S', '\0', /* CE_PARSING_PACKETS (103133) */
	'M', 'I', 'U', '_', 'R', 'D', 'R', 'E', 'Q', '_', 'B', 'U', 'S', 'Y', '\0', /* MIU_RDREQ_BUSY (103152) */
	'M', 'I', 'U', '_', 'W', 'R', 'R', 'E', 'Q', '_', 'B', 'U', 'S', 'Y', '\0', /* MIU_WRREQ_BUSY (103167) */
	'D', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* DC_BUSY (103182) */
	'M', 'E', 'Q', '_', 'B', 'U', 'S', 'Y', '\0', /* MEQ_BUSY (103190) */
	'Q', 'U', 'E', 'R', 'Y', '_', 'B', 'U', 'S', 'Y', '\0', /* QUERY_BUSY (103199) */
	'S', 'U', 'R', 'F', 'A', 'C', 'E', '_', 'S', 'Y', 'N', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* SURFACE_SYNC_BUSY (103210) */
	'C', 'P', 'C', '_', 'C', 'P', 'G', '_', 'B', 'U', 'S', 'Y', '\0', /* CPC_CPG_BUSY (103228) */
	'F', 'R', 'E', 'E', '_', 'C', 'O', 'U', 'N', 'T', '_', 'G', 'D', 'S', '\0', /* FREE_COUNT_GDS (103241) */
	'F', 'R', 'E', 'E', '_', 'C', 'O', 'U', 'N', 'T', '_', 'P', 'F', 'P', '\0', /* FREE_COUNT_PFP (103256) */
	'B', 'U', 'F', 'F', 'E', 'R', '_', 'S', 'L', 'O', 'T', 'S', '_', 'A', 'L', 'L', 'O', 'C', 'A', 'T', 'E', 'D', '\0', /* BUFFER_SLOTS_ALLOCATED (103271) */
	'B', 'U', 'F', 'F', 'E', 'R', '_', 'R', 'E', 'Q', 'U', 'E', 'S', 'T', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* BUFFER_REQUEST_COUNT (103294) */
	'F', 'E', 'T', 'C', 'H', '_', 'B', 'U', 'F', 'F', 'E', 'R', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* FETCH_BUFFER_DEPTH (103315) */
	'C', 'E', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', 'A', 'T', 'E', '_', 'I', 'C', 'A', 'C', 'H', 'E', '\0', /* CE_INVALIDATE_ICACHE (103334) */
	'P', 'F', 'P', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', 'A', 'T', 'E', '_', 'I', 'C', 'A', 'C', 'H', 'E', '\0', /* PFP_INVALIDATE_ICACHE (103355) */
	'M', 'E', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', 'A', 'T', 'E', '_', 'I', 'C', 'A', 'C', 'H', 'E', '\0', /* ME_INVALIDATE_ICACHE (103377) */
	'C', 'E', '_', 'H', 'A', 'L', 'T', '\0', /* CE_HALT (103398) */
	'C', 'E', '_', 'S', 'T', 'E', 'P', '\0', /* CE_STEP (103406) */
	'P', 'F', 'P', '_', 'H', 'A', 'L', 'T', '\0', /* PFP_HALT (103414) */
	'P', 'F', 'P', '_', 'S', 'T', 'E', 'P', '\0', /* PFP_STEP (103423) */
	'M', 'E', '_', 'H', 'A', 'L', 'T', '\0', /* ME_HALT (103432) */
	'M', 'E', '_', 'S', 'T', 'E', 'P', '\0', /* ME_STEP (103440) */
	'A', 'C', 'T', 'I', 'V', 'E', '_', 'H', 'P', '3', 'D', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', 'S', '\0', /* ACTIVE_HP3D_CONTEXTS (103448) */
	'C', 'U', 'R', 'R', 'E', 'N', 'T', '_', 'H', 'P', '3', 'D', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '\0', /* CURRENT_HP3D_CONTEXT (103469) */
	'A', 'C', 'T', 'I', 'V', 'E', '_', 'G', 'F', 'X', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', 'S', '\0', /* ACTIVE_GFX_CONTEXTS (103490) */
	'C', 'U', 'R', 'R', 'E', 'N', 'T', '_', 'G', 'F', 'X', '_', 'C', 'O', 'N', 'T', 'E', 'X', 'T', '\0', /* CURRENT_GFX_CONTEXT (103510) */
	'M', 'E', '_', 'C', 'N', 'T', 'X', 'S', 'W', '_', 'P', 'R', 'E', 'E', 'M', 'P', 'T', 'I', 'O', 'N', '\0', /* ME_CNTXSW_PREEMPTION (103530) */
	'R', 'B', '_', 'R', 'P', 'T', 'R', '\0', /* RB_RPTR (103551) */
	'P', 'R', 'E', '_', 'W', 'R', 'I', 'T', 'E', '_', 'T', 'I', 'M', 'E', 'R', '\0', /* PRE_WRITE_TIMER (103559) */
	'P', 'R', 'E', '_', 'W', 'R', 'I', 'T', 'E', '_', 'L', 'I', 'M', 'I', 'T', '\0', /* PRE_WRITE_LIMIT (103575) */
	'P', 'O', 'L', 'L', '_', 'F', 'R', 'E', 'Q', 'U', 'E', 'N', 'C', 'Y', '\0', /* POLL_FREQUENCY (103591) */
	'I', 'D', 'L', 'E', '_', 'P', 'O', 'L', 'L', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* IDLE_POLL_COUNT (103606) */
	'R', 'B', '1', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* RB1_START (103622) */
	'R', 'B', '2', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* RB2_START (103632) */
	'R', '0', '_', 'I', 'B', '1', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* R0_IB1_START (103642) */
	'R', '1', '_', 'I', 'B', '1', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* R1_IB1_START (103655) */
	'R', '2', '_', 'I', 'B', '1', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* R2_IB1_START (103668) */
	'R', '0', '_', 'I', 'B', '2', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* R0_IB2_START (103681) */
	'R', '1', '_', 'I', 'B', '2', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* R1_IB2_START (103694) */
	'R', '2', '_', 'I', 'B', '2', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* R2_IB2_START (103707) */
	'S', 'T', 'Q', '0', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* STQ0_START (103720) */
	'S', 'T', 'Q', '1', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* STQ1_START (103731) */
	'S', 'T', 'Q', '2', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* STQ2_START (103742) */
	'R', 'O', 'Q', '_', 'I', 'B', '1', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* ROQ_IB1_START (103753) */
	'R', 'O', 'Q', '_', 'I', 'B', '2', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* ROQ_IB2_START (103767) */
	'M', 'E', 'Q', '1', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* MEQ1_START (103781) */
	'M', 'E', 'Q', '2', '_', 'S', 'T', 'A', 'R', 'T', '\0', /* MEQ2_START (103792) */
	'R', 'O', 'Q', '_', 'C', 'N', 'T', '_', 'R', 'I', 'N', 'G', '\0', /* ROQ_CNT_RING (103803) */
	'R', 'O', 'Q', '_', 'C', 'N', 'T', '_', 'I', 'B', '1', '\0', /* ROQ_CNT_IB1 (103816) */
	'S', 'T', 'Q', '_', 'C', 'N', 'T', '\0', /* STQ_CNT (103828) */
	'R', 'O', 'Q', '_', 'C', 'N', 'T', '_', 'I', 'B', '2', '\0', /* ROQ_CNT_IB2 (103836) */
	'M', 'E', 'Q', '_', 'C', 'N', 'T', '\0', /* MEQ_CNT (103848) */
	'C', 'M', 'D', '_', 'M', 'E', '_', 'S', 'E', 'L', '\0', /* CMD_ME_SEL (103856) */
	'C', 'M', 'D', '_', 'Q', 'U', 'E', 'U', 'E', '_', 'S', 'E', 'L', '\0', /* CMD_QUEUE_SEL (103867) */
	'R', 'O', 'Q', '_', 'R', 'P', 'T', 'R', '_', 'P', 'R', 'I', 'M', 'A', 'R', 'Y', '\0', /* ROQ_RPTR_PRIMARY (103881) */
	'R', 'O', 'Q', '_', 'W', 'P', 'T', 'R', '_', 'P', 'R', 'I', 'M', 'A', 'R', 'Y', '\0', /* ROQ_WPTR_PRIMARY (103898) */
	'R', 'O', 'Q', '_', 'R', 'P', 'T', 'R', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '1', '\0', /* ROQ_RPTR_INDIRECT1 (103915) */
	'R', 'O', 'Q', '_', 'W', 'P', 'T', 'R', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '1', '\0', /* ROQ_WPTR_INDIRECT1 (103934) */
	'R', 'O', 'Q', '_', 'R', 'P', 'T', 'R', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '2', '\0', /* ROQ_RPTR_INDIRECT2 (103953) */
	'R', 'O', 'Q', '_', 'W', 'P', 'T', 'R', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '2', '\0', /* ROQ_WPTR_INDIRECT2 (103972) */
	'S', 'T', 'Q', '_', 'R', 'P', 'T', 'R', '\0', /* STQ_RPTR (103991) */
	'M', 'E', 'Q', '_', 'R', 'P', 'T', 'R', '\0', /* MEQ_RPTR (104000) */
	'M', 'E', 'Q', '_', 'W', 'P', 'T', 'R', '\0', /* MEQ_WPTR (104009) */
	'C', 'E', 'Q', '_', 'C', 'N', 'T', '_', 'R', 'I', 'N', 'G', '\0', /* CEQ_CNT_RING (104018) */
	'C', 'E', 'Q', '_', 'C', 'N', 'T', '_', 'I', 'B', '1', '\0', /* CEQ_CNT_IB1 (104031) */
	'C', 'E', 'Q', '_', 'C', 'N', 'T', '_', 'I', 'B', '2', '\0', /* CEQ_CNT_IB2 (104043) */
	'C', 'E', 'Q', '_', 'R', 'P', 'T', 'R', '_', 'P', 'R', 'I', 'M', 'A', 'R', 'Y', '\0', /* CEQ_RPTR_PRIMARY (104055) */
	'C', 'E', 'Q', '_', 'W', 'P', 'T', 'R', '_', 'P', 'R', 'I', 'M', 'A', 'R', 'Y', '\0', /* CEQ_WPTR_PRIMARY (104072) */
	'C', 'E', 'Q', '_', 'R', 'P', 'T', 'R', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '1', '\0', /* CEQ_RPTR_INDIRECT1 (104089) */
	'C', 'E', 'Q', '_', 'W', 'P', 'T', 'R', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '1', '\0', /* CEQ_WPTR_INDIRECT1 (104108) */
	'C', 'E', 'Q', '_', 'R', 'P', 'T', 'R', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '2', '\0', /* CEQ_RPTR_INDIRECT2 (104127) */
	'C', 'E', 'Q', '_', 'W', 'P', 'T', 'R', '_', 'I', 'N', 'D', 'I', 'R', 'E', 'C', 'T', '2', '\0', /* CEQ_WPTR_INDIRECT2 (104146) */
	'C', 'P', '_', 'E', 'C', 'C', '_', 'E', 'R', 'R', 'O', 'R', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* CP_ECC_ERROR_INT_ASSERTED (104165) */
	'W', 'R', 'M', '_', 'P', 'O', 'L', 'L', '_', 'T', 'I', 'M', 'E', 'O', 'U', 'T', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* WRM_POLL_TIMEOUT_INT_ASSERTED (104191) */
	'C', 'N', 'T', 'X', '_', 'B', 'U', 'S', 'Y', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* CNTX_BUSY_INT_ASSERTED (104221) */
	'C', 'N', 'T', 'X', '_', 'E', 'M', 'P', 'T', 'Y', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* CNTX_EMPTY_INT_ASSERTED (104244) */
	'P', 'R', 'I', 'V', '_', 'I', 'N', 'S', 'T', 'R', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* PRIV_INSTR_INT_ASSERTED (104268) */
	'P', 'R', 'I', 'V', '_', 'R', 'E', 'G', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* PRIV_REG_INT_ASSERTED (104292) */
	'O', 'P', 'C', 'O', 'D', 'E', '_', 'E', 'R', 'R', 'O', 'R', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* OPCODE_ERROR_INT_ASSERTED (104314) */
	'T', 'I', 'M', 'E', '_', 'S', 'T', 'A', 'M', 'P', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* TIME_STAMP_INT_ASSERTED (104340) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', 'B', 'I', 'T', '_', 'E', 'R', 'R', 'O', 'R', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* RESERVED_BIT_ERROR_INT_ASSERTED (104364) */
	'G', 'E', 'N', 'E', 'R', 'I', 'C', '2', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* GENERIC2_INT_ASSERTED (104396) */
	'G', 'E', 'N', 'E', 'R', 'I', 'C', '1', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* GENERIC1_INT_ASSERTED (104418) */
	'G', 'E', 'N', 'E', 'R', 'I', 'C', '0', '_', 'I', 'N', 'T', '_', 'A', 'S', 'S', 'E', 'R', 'T', 'E', 'D', '\0', /* GENERIC0_INT_ASSERTED (104440) */
	'P', 'R', 'I', 'M', '_', 'C', 'O', 'U', 'N', 'T', '\0', /* PRIM_COUNT (104462) */
	'D', 'S', 'T', '_', 'S', 'T', 'A', 'T', 'E', '_', 'I', 'D', '\0', /* DST_STATE_ID (104473) */
	'V', 'S', '_', 'N', 'O', '_', 'E', 'X', 'T', 'R', 'A', '_', 'B', 'U', 'F', 'F', 'E', 'R', '\0', /* VS_NO_EXTRA_BUFFER (104486) */
	'A', 'U', 'T', 'O', '_', 'I', 'N', 'V', 'L', 'D', '_', 'E', 'N', '\0', /* AUTO_INVLD_EN (104505) */
	'U', 'S', 'E', '_', 'G', 'S', '_', 'D', 'O', 'N', 'E', '\0', /* USE_GS_DONE (104519) */
	'D', 'I', 'S', '_', 'R', 'A', 'N', 'G', 'E', '_', 'F', 'U', 'L', 'L', '_', 'I', 'N', 'V', 'L', 'D', '\0', /* DIS_RANGE_FULL_INVLD (104531) */
	'G', 'S', '_', 'L', 'A', 'T', 'E', '_', 'A', 'L', 'L', 'O', 'C', '_', 'E', 'N', '\0', /* GS_LATE_ALLOC_EN (104552) */
	'S', 'T', 'R', 'E', 'A', 'M', 'O', 'U', 'T', '_', 'F', 'U', 'L', 'L', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* STREAMOUT_FULL_FLUSH (104569) */
	'E', 'S', '_', 'L', 'I', 'M', 'I', 'T', '\0', /* ES_LIMIT (104590) */
	'V', 'S', '_', 'D', 'E', 'A', 'L', 'L', 'O', 'C', '_', 'T', 'B', 'L', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* VS_DEALLOC_TBL_DEPTH (104599) */
	'C', 'L', 'I', 'P', 'P', '_', 'F', 'I', 'F', 'O', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* CLIPP_FIFO_DEPTH (104620) */
	'V', 'E', 'R', 'T', '_', 'R', 'E', 'U', 'S', 'E', '\0', /* VERT_REUSE (104637) */
	'M', 'C', '_', 'T', 'I', 'M', 'E', '_', 'S', 'T', 'A', 'M', 'P', '_', 'R', 'E', 'S', '\0', /* MC_TIME_STAMP_RES (104648) */
	'I', 'A', '_', 'D', 'M', 'A', '_', 'B', 'U', 'S', 'Y', '\0', /* IA_DMA_BUSY (104666) */
	'I', 'A', '_', 'D', 'M', 'A', '_', 'R', 'E', 'Q', '_', 'B', 'U', 'S', 'Y', '\0', /* IA_DMA_REQ_BUSY (104678) */
	'I', 'A', '_', 'G', 'R', 'P', '_', 'B', 'U', 'S', 'Y', '\0', /* IA_GRP_BUSY (104694) */
	'I', 'A', '_', 'A', 'D', 'C', '_', 'B', 'U', 'S', 'Y', '\0', /* IA_ADC_BUSY (104706) */
	'V', 'G', 'T', '_', 'D', 'E', 'B', 'U', 'G', '_', 'I', 'N', 'D', 'X', '\0', /* VGT_DEBUG_INDX (104718) */
	'V', 'G', 'T', '_', 'D', 'E', 'B', 'U', 'G', '_', 'S', 'E', 'L', '_', 'B', 'U', 'S', '_', 'B', '\0', /* VGT_DEBUG_SEL_BUS_B (104733) */
	'I', 'A', '_', 'D', 'E', 'B', 'U', 'G', '_', 'I', 'N', 'D', 'X', '\0', /* IA_DEBUG_INDX (104753) */
	'I', 'A', '_', 'D', 'E', 'B', 'U', 'G', '_', 'S', 'E', 'L', '_', 'B', 'U', 'S', '_', 'B', '\0', /* IA_DEBUG_SEL_BUS_B (104767) */
	'V', 'G', 'T', '_', 'O', 'U', 'T', '_', 'I', 'N', 'D', 'X', '_', 'B', 'U', 'S', 'Y', '\0', /* VGT_OUT_INDX_BUSY (104786) */
	'V', 'G', 'T', '_', 'O', 'U', 'T', '_', 'B', 'U', 'S', 'Y', '\0', /* VGT_OUT_BUSY (104804) */
	'V', 'G', 'T', '_', 'P', 'T', '_', 'B', 'U', 'S', 'Y', '\0', /* VGT_PT_BUSY (104817) */
	'V', 'G', 'T', '_', 'T', 'E', '_', 'B', 'U', 'S', 'Y', '\0', /* VGT_TE_BUSY (104829) */
	'V', 'G', 'T', '_', 'V', 'R', '_', 'B', 'U', 'S', 'Y', '\0', /* VGT_VR_BUSY (104841) */
	'V', 'G', 'T', '_', 'P', 'I', '_', 'B', 'U', 'S', 'Y', '\0', /* VGT_PI_BUSY (104853) */
	'V', 'G', 'T', '_', 'G', 'S', '_', 'B', 'U', 'S', 'Y', '\0', /* VGT_GS_BUSY (104865) */
	'V', 'G', 'T', '_', 'H', 'S', '_', 'B', 'U', 'S', 'Y', '\0', /* VGT_HS_BUSY (104877) */
	'V', 'G', 'T', '_', 'T', 'E', '1', '1', '_', 'B', 'U', 'S', 'Y', '\0', /* VGT_TE11_BUSY (104889) */
	'P', 'E', 'R', 'F', '_', 'S', 'E', 'I', 'D', '_', 'I', 'G', 'N', 'O', 'R', 'E', '_', 'M', 'A', 'S', 'K', '\0', /* PERF_SEID_IGNORE_MASK (104903) */
	'D', 'I', '_', 'P', 'T', '_', 'U', 'N', 'U', 'S', 'E', 'D', '_', '0', '\0', /* DI_PT_UNUSED_0 (104925) */
	'D', 'I', '_', 'P', 'T', '_', '2', 'D', '_', 'C', 'O', 'P', 'Y', '_', 'R', 'E', 'C', 'T', '_', 'L', 'I', 'S', 'T', '_', 'V', '0', '\0', /* DI_PT_2D_COPY_RECT_LIST_V0 (104940) */
	'D', 'I', '_', 'P', 'T', '_', '2', 'D', '_', 'C', 'O', 'P', 'Y', '_', 'R', 'E', 'C', 'T', '_', 'L', 'I', 'S', 'T', '_', 'V', '1', '\0', /* DI_PT_2D_COPY_RECT_LIST_V1 (104967) */
	'D', 'I', '_', 'P', 'T', '_', '2', 'D', '_', 'C', 'O', 'P', 'Y', '_', 'R', 'E', 'C', 'T', '_', 'L', 'I', 'S', 'T', '_', 'V', '2', '\0', /* DI_PT_2D_COPY_RECT_LIST_V2 (104994) */
	'D', 'I', '_', 'P', 'T', '_', '2', 'D', '_', 'C', 'O', 'P', 'Y', '_', 'R', 'E', 'C', 'T', '_', 'L', 'I', 'S', 'T', '_', 'V', '3', '\0', /* DI_PT_2D_COPY_RECT_LIST_V3 (105021) */
	'D', 'I', '_', 'P', 'T', '_', '2', 'D', '_', 'F', 'I', 'L', 'L', '_', 'R', 'E', 'C', 'T', '_', 'L', 'I', 'S', 'T', '\0', /* DI_PT_2D_FILL_RECT_LIST (105048) */
	'D', 'I', '_', 'P', 'T', '_', '2', 'D', '_', 'L', 'I', 'N', 'E', '_', 'S', 'T', 'R', 'I', 'P', '\0', /* DI_PT_2D_LINE_STRIP (105072) */
	'D', 'I', '_', 'P', 'T', '_', '2', 'D', '_', 'T', 'R', 'I', '_', 'S', 'T', 'R', 'I', 'P', '\0', /* DI_PT_2D_TRI_STRIP (105092) */
	'O', 'N', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* ON_DELAY (105111) */
	'O', 'F', 'F', '_', 'H', 'Y', 'S', 'T', 'E', 'R', 'E', 'S', 'I', 'S', '\0', /* OFF_HYSTERESIS (105120) */
	'S', 'O', 'F', 'T', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '7', '\0', /* SOFT_OVERRIDE7 (105135) */
	'P', 'E', 'R', 'F', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* PERF_ENABLE (105150) */
	'D', 'B', 'G', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* DBG_ENABLE (105162) */
	'S', 'O', 'F', 'T', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '4', '\0', /* SOFT_OVERRIDE4 (105173) */
	'S', 'O', 'F', 'T', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '3', '\0', /* SOFT_OVERRIDE3 (105188) */
	'G', 'S', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* GS_OVERRIDE (105203) */
	'C', 'O', 'R', 'E', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* CORE_OVERRIDE (105215) */
	'R', 'E', 'G', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* REG_OVERRIDE (105229) */
	'S', 'O', 'F', 'T', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '2', '\0', /* SOFT_OVERRIDE2 (105242) */
	'D', 'U', 'A', 'L', '_', 'C', 'O', 'R', 'E', '_', 'E', 'N', '\0', /* DUAL_CORE_EN (105257) */
	'M', 'A', 'X', '_', 'L', 'S', '_', 'H', 'S', '_', 'T', 'H', 'D', 'G', 'R', 'P', '\0', /* MAX_LS_HS_THDGRP (105270) */
	'A', 'D', 'C', '_', 'E', 'V', 'E', 'N', 'T', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* ADC_EVENT_FILTER_DISABLE (105287) */
	'D', 'P', 'F', 'P', '_', 'R', 'A', 'T', 'E', '\0', /* DPFP_RATE (105312) */
	'S', 'Q', 'C', '_', 'B', 'A', 'L', 'A', 'N', 'C', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* SQC_BALANCE_DISABLE (105322) */
	'H', 'A', 'L', 'F', '_', 'L', 'D', 'S', '\0', /* HALF_LDS (105342) */
	'I', 'N', 'A', 'C', 'T', 'I', 'V', 'E', '_', 'C', 'U', 'S', '\0', /* INACTIVE_CUS (105351) */
	'S', 'U', '_', 'D', 'E', 'B', 'U', 'G', '_', 'I', 'N', 'D', 'X', '\0', /* SU_DEBUG_INDX (105364) */
	'C', 'L', '_', 'B', 'U', 'S', 'Y', '\0', /* CL_BUSY (105378) */
	'C', 'L', 'I', 'P', '_', 'V', 'T', 'X', '_', 'R', 'E', 'O', 'R', 'D', 'E', 'R', '_', 'E', 'N', 'A', '\0', /* CLIP_VTX_REORDER_ENA (105386) */
	'N', 'U', 'M', '_', 'C', 'L', 'I', 'P', '_', 'S', 'E', 'Q', '\0', /* NUM_CLIP_SEQ (105407) */
	'C', 'L', 'I', 'P', 'P', 'E', 'D', '_', 'P', 'R', 'I', 'M', '_', 'S', 'E', 'Q', '_', 'S', 'T', 'A', 'L', 'L', '\0', /* CLIPPED_PRIM_SEQ_STALL (105420) */
	'V', 'E', '_', 'N', 'A', 'N', '_', 'P', 'R', 'O', 'C', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* VE_NAN_PROC_DISABLE (105443) */
	'X', 'T', 'R', 'A', '_', 'D', 'E', 'B', 'U', 'G', '_', 'R', 'E', 'G', '_', 'S', 'E', 'L', '\0', /* XTRA_DEBUG_REG_SEL (105463) */
	'E', 'C', 'O', '_', 'S', 'P', 'A', 'R', 'E', '3', '\0', /* ECO_SPARE3 (105482) */
	'E', 'C', 'O', '_', 'S', 'P', 'A', 'R', 'E', '2', '\0', /* ECO_SPARE2 (105493) */
	'E', 'C', 'O', '_', 'S', 'P', 'A', 'R', 'E', '1', '\0', /* ECO_SPARE1 (105504) */
	'E', 'C', 'O', '_', 'S', 'P', 'A', 'R', 'E', '0', '\0', /* ECO_SPARE0 (105515) */
	'S', 'O', 'F', 'T', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '6', '\0', /* SOFT_OVERRIDE6 (105526) */
	'S', 'O', 'F', 'T', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '5', '\0', /* SOFT_OVERRIDE5 (105541) */
	'S', 'U', '_', 'C', 'L', 'K', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* SU_CLK_OVERRIDE (105556) */
	'C', 'L', '_', 'C', 'L', 'K', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* CL_CLK_OVERRIDE (105572) */
	'R', 'E', 'G', '_', 'C', 'L', 'K', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '\0', /* REG_CLK_OVERRIDE (105588) */
	'S', 'U', '_', 'B', 'U', 'S', 'Y', '\0', /* SU_BUSY (105605) */
	'F', 'O', 'R', 'C', 'E', '_', 'E', 'O', 'V', '_', 'M', 'A', 'X', '_', 'C', 'L', 'K', '_', 'C', 'N', 'T', '\0', /* FORCE_EOV_MAX_CLK_CNT (105613) */
	'F', 'O', 'R', 'C', 'E', '_', 'E', 'O', 'V', '_', 'M', 'A', 'X', '_', 'R', 'E', 'Z', '_', 'C', 'N', 'T', '\0', /* FORCE_EOV_MAX_REZ_CNT (105635) */
	'S', 'O', 'F', 'T', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '1', '\0', /* SOFT_OVERRIDE1 (105657) */
	'S', 'O', 'F', 'T', '_', 'O', 'V', 'E', 'R', 'R', 'I', 'D', 'E', '0', '\0', /* SOFT_OVERRIDE0 (105672) */
	'S', 'C', '_', 'F', 'R', 'O', 'N', 'T', 'E', 'N', 'D', '_', 'P', 'R', 'I', 'M', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* SC_FRONTEND_PRIM_FIFO_SIZE (105687) */
	'S', 'C', '_', 'B', 'A', 'C', 'K', 'E', 'N', 'D', '_', 'P', 'R', 'I', 'M', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* SC_BACKEND_PRIM_FIFO_SIZE (105714) */
	'S', 'C', '_', 'H', 'I', 'Z', '_', 'T', 'I', 'L', 'E', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* SC_HIZ_TILE_FIFO_SIZE (105740) */
	'S', 'C', '_', 'E', 'A', 'R', 'L', 'Y', 'Z', '_', 'T', 'I', 'L', 'E', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* SC_EARLYZ_TILE_FIFO_SIZE (105762) */
	'S', 'C', '_', 'D', 'B', '_', 'T', 'I', 'L', 'E', '_', 'I', 'F', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* SC_DB_TILE_IF_FIFO_SIZE (105787) */
	'S', 'C', '_', 'D', 'B', '_', 'Q', 'U', 'A', 'D', '_', 'I', 'F', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* SC_DB_QUAD_IF_FIFO_SIZE (105811) */
	'S', 'C', '_', 'S', 'P', 'I', '_', 'I', 'F', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* SC_SPI_IF_FIFO_SIZE (105835) */
	'S', 'C', '_', 'B', 'C', 'I', '_', 'I', 'F', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* SC_BCI_IF_FIFO_SIZE (105855) */
	'S', 'C', '_', 'D', 'E', 'B', 'U', 'G', '_', 'I', 'N', 'D', 'X', '\0', /* SC_DEBUG_INDX (105875) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'P', 'A', '_', 'S', 'C', '_', 'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '\0', /* ENABLE_PA_SC_OUT_OF_ORDER (105889) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'S', 'C', '_', 'D', 'B', '_', 'T', 'I', 'L', 'E', '_', 'F', 'I', 'X', '\0', /* DISABLE_SC_DB_TILE_FIX (105915) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'A', 'A', '_', 'M', 'A', 'S', 'K', '_', 'F', 'U', 'L', 'L', '_', 'F', 'I', 'X', '\0', /* DISABLE_AA_MASK_FULL_FIX (105938) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', '1', 'X', 'M', 'S', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', 'A', 'T', 'I', 'O', 'N', 'S', '\0', /* ENABLE_1XMSAA_SAMPLE_LOCATIONS (105963) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', '1', 'X', 'M', 'S', 'A', 'A', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'L', 'O', 'C', '_', 'C', 'E', 'N', 'T', 'R', 'O', 'I', 'D', '\0', /* ENABLE_1XMSAA_SAMPLE_LOC_CENTROID (105994) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'S', 'C', 'I', 'S', 'S', 'O', 'R', '_', 'F', 'I', 'X', '\0', /* DISABLE_SCISSOR_FIX (106028) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'P', 'W', '_', 'B', 'U', 'B', 'B', 'L', 'E', '_', 'C', 'O', 'L', 'L', 'A', 'P', 'S', 'E', '\0', /* DISABLE_PW_BUBBLE_COLLAPSE (106048) */
	'S', 'E', 'N', 'D', '_', 'U', 'N', 'L', 'I', 'T', '_', 'S', 'T', 'I', 'L', 'E', 'S', '_', 'T', 'O', '_', 'P', 'A', 'C', 'K', 'E', 'R', '\0', /* SEND_UNLIT_STILES_TO_PACKER (106075) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'D', 'U', 'A', 'L', 'G', 'R', 'A', 'D', '_', 'P', 'E', 'R', 'F', '_', 'O', 'P', 'T', 'I', 'M', 'I', 'Z', 'A', 'T', 'I', 'O', 'N', '\0', /* DISABLE_DUALGRAD_PERF_OPTIMIZATION (106103) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'S', 'C', '_', 'P', 'R', 'O', 'C', 'E', 'S', 'S', '_', 'R', 'E', 'S', 'E', 'T', '_', 'P', 'R', 'I', 'M', '\0', /* DISABLE_SC_PROCESS_RESET_PRIM (106138) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'S', 'C', '_', 'P', 'R', 'O', 'C', 'E', 'S', 'S', '_', 'R', 'E', 'S', 'E', 'T', '_', 'S', 'U', 'P', 'E', 'R', 'T', 'I', 'L', 'E', '\0', /* DISABLE_SC_PROCESS_RESET_SUPERTILE (106168) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'S', 'C', '_', 'P', 'R', 'O', 'C', 'E', 'S', 'S', '_', 'R', 'E', 'S', 'E', 'T', '_', 'T', 'I', 'L', 'E', '\0', /* DISABLE_SC_PROCESS_RESET_TILE (106203) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'P', 'A', '_', 'S', 'C', '_', 'G', 'U', 'I', 'D', 'A', 'N', 'C', 'E', '\0', /* DISABLE_PA_SC_GUIDANCE (106233) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'E', 'O', 'V', '_', 'A', 'L', 'L', '_', 'C', 'T', 'R', 'L', '_', 'O', 'N', 'L', 'Y', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'A', 'T', 'I', 'O', 'N', 'S', '\0', /* DISABLE_EOV_ALL_CTRL_ONLY_COMBINATIONS (106256) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'M', 'U', 'L', 'T', 'I', 'C', 'Y', 'C', 'L', 'E', '_', 'B', 'U', 'B', 'B', 'L', 'E', '_', 'F', 'R', 'E', 'E', 'Z', 'E', '\0', /* ENABLE_MULTICYCLE_BUBBLE_FREEZE (106295) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'P', 'A', '_', 'S', 'C', '_', 'G', 'U', 'I', 'D', 'A', 'N', 'C', 'E', '\0', /* DISABLE_OUT_OF_ORDER_PA_SC_GUIDANCE (106327) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'P', 'O', 'L', 'Y', '_', 'M', 'O', 'D', 'E', '\0', /* ENABLE_OUT_OF_ORDER_POLY_MODE (106363) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'E', 'O', 'P', '_', 'S', 'Y', 'N', 'C', '_', 'N', 'U', 'L', 'L', '_', 'P', 'R', 'I', 'M', 'S', '_', 'L', 'A', 'S', 'T', '\0', /* DISABLE_OUT_OF_ORDER_EOP_SYNC_NULL_PRIMS_LAST (106393) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '_', 'S', 'W', 'I', 'T', 'C', 'H', 'I', 'N', 'G', '\0', /* DISABLE_OUT_OF_ORDER_THRESHOLD_SWITCHING (106439) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'T', 'H', 'R', 'E', 'S', 'H', 'O', 'L', 'D', '_', 'S', 'W', 'I', 'T', 'C', 'H', '_', 'A', 'T', '_', 'E', 'O', 'P', 'G', '_', 'O', 'N', 'L', 'Y', '\0', /* ENABLE_OUT_OF_ORDER_THRESHOLD_SWITCH_AT_EOPG_ONLY (106480) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'D', 'E', 'S', 'I', 'R', 'E', 'D', '_', 'F', 'I', 'F', 'O', '_', 'E', 'M', 'P', 'T', 'Y', '_', 'S', 'W', 'I', 'T', 'C', 'H', 'I', 'N', 'G', '\0', /* DISABLE_OUT_OF_ORDER_DESIRED_FIFO_EMPTY_SWITCHING (106530) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'S', 'E', 'L', 'E', 'C', 'T', 'E', 'D', '_', 'F', 'I', 'F', 'O', '_', 'E', 'M', 'P', 'T', 'Y', '_', 'S', 'W', 'I', 'T', 'C', 'H', 'I', 'N', 'G', '\0', /* DISABLE_OUT_OF_ORDER_SELECTED_FIFO_EMPTY_SWITCHING (106580) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'E', 'M', 'P', 'T', 'Y', '_', 'S', 'W', 'I', 'T', 'C', 'H', 'I', 'N', 'G', '_', 'H', 'Y', 'S', 'T', 'E', 'R', 'Y', 'S', 'I', 'S', '\0', /* DISABLE_OUT_OF_ORDER_EMPTY_SWITCHING_HYSTERYSIS (106631) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'O', 'U', 'T', '_', 'O', 'F', '_', 'O', 'R', 'D', 'E', 'R', '_', 'D', 'E', 'S', 'I', 'R', 'E', 'D', '_', 'F', 'I', 'F', 'O', '_', 'I', 'S', '_', 'N', 'E', 'X', 'T', '_', 'F', 'E', 'I', 'D', '\0', /* ENABLE_OUT_OF_ORDER_DESIRED_FIFO_IS_NEXT_FEID (106679) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'S', 'C', 'A', '_', 'B', 'Y', 'P', 'A', 'S', 'S', '\0', /* DISABLE_SCA_BYPASS (106725) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'I', 'B', '_', 'D', 'E', 'P', '_', 'C', 'H', 'E', 'C', 'K', '\0', /* DISABLE_IB_DEP_CHECK (106744) */
	'E', 'N', 'A', 'B', 'L', 'E', '_', 'S', 'O', 'F', 'T', '_', 'C', 'L', 'A', 'U', 'S', 'E', '\0', /* ENABLE_SOFT_CLAUSE (106765) */
	'E', 'A', 'R', 'L', 'Y', '_', 'T', 'A', '_', 'D', 'O', 'N', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* EARLY_TA_DONE_DISABLE (106784) */
	'D', 'U', 'A', '_', 'F', 'L', 'A', 'T', '_', 'L', 'O', 'C', 'K', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* DUA_FLAT_LOCK_ENABLE (106806) */
	'D', 'U', 'A', '_', 'L', 'D', 'S', '_', 'B', 'Y', 'P', 'A', 'S', 'S', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* DUA_LDS_BYPASS_DISABLE (106827) */
	'D', 'U', 'A', '_', 'F', 'L', 'A', 'T', '_', 'L', 'D', 'S', '_', 'P', 'I', 'N', 'G', 'P', 'O', 'N', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* DUA_FLAT_LDS_PINGPONG_DISABLE (106850) */
	'I', 'N', 'S', 'T', '_', 'C', 'A', 'C', 'H', 'E', '_', 'S', 'I', 'Z', 'E', '\0', /* INST_CACHE_SIZE (106880) */
	'D', 'A', 'T', 'A', '_', 'C', 'A', 'C', 'H', 'E', '_', 'S', 'I', 'Z', 'E', '\0', /* DATA_CACHE_SIZE (106896) */
	'M', 'I', 'S', 'S', '_', 'F', 'I', 'F', 'O', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* MISS_FIFO_DEPTH (106912) */
	'H', 'I', 'T', '_', 'F', 'I', 'F', 'O', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* HIT_FIFO_DEPTH (106928) */
	'F', 'O', 'R', 'C', 'E', '_', 'A', 'L', 'W', 'A', 'Y', 'S', '_', 'M', 'I', 'S', 'S', '\0', /* FORCE_ALWAYS_MISS (106943) */
	'F', 'O', 'R', 'C', 'E', '_', 'I', 'N', '_', 'O', 'R', 'D', 'E', 'R', '\0', /* FORCE_IN_ORDER (106961) */
	'I', 'D', 'E', 'N', 'T', 'I', 'T', 'Y', '_', 'H', 'A', 'S', 'H', '_', 'B', 'A', 'N', 'K', '\0', /* IDENTITY_HASH_BANK (106976) */
	'I', 'D', 'E', 'N', 'T', 'I', 'T', 'Y', '_', 'H', 'A', 'S', 'H', '_', 'S', 'E', 'T', '\0', /* IDENTITY_HASH_SET (106995) */
	'P', 'E', 'R', '_', 'V', 'M', 'I', 'D', '_', 'I', 'N', 'V', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* PER_VMID_INV_DISABLE (107013) */
	'I', 'N', 'S', 'T', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', 'A', 'T', 'E', '\0', /* INST_INVALIDATE (107034) */
	'D', 'A', 'T', 'A', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', 'A', 'T', 'E', '\0', /* DATA_INVALIDATE (107050) */
	'I', 'N', 'V', 'A', 'L', 'I', 'D', 'A', 'T', 'E', '_', 'V', 'O', 'L', 'A', 'T', 'I', 'L', 'E', '\0', /* INVALIDATE_VOLATILE (107066) */
	'R', 'E', 'T', '\0', /* RET (107086) */
	'R', 'U', 'I', '\0', /* RUI (107090) */
	'R', 'N', 'G', '\0', /* RNG (107094) */
	'S', 'R', 'B', 'M', '_', 'C', 'R', 'E', 'D', 'I', 'T', 'S', '\0', /* SRBM_CREDITS (107098) */
	'C', 'M', 'D', '_', 'C', 'R', 'E', 'D', 'I', 'T', 'S', '\0', /* CMD_CREDITS (107111) */
	'R', 'E', 'G', '_', 'B', 'U', 'S', 'Y', '\0', /* REG_BUSY (107123) */
	'S', 'R', 'B', 'M', '_', 'O', 'V', 'E', 'R', 'F', 'L', 'O', 'W', '\0', /* SRBM_OVERFLOW (107132) */
	'I', 'N', 'T', 'E', 'R', 'R', 'U', 'P', 'T', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* INTERRUPT_FIFO_SIZE (107146) */
	'T', 'T', 'R', 'A', 'C', 'E', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* TTRACE_FIFO_SIZE (107166) */
	'E', 'X', 'P', 'O', 'R', 'T', '_', 'B', 'U', 'F', '_', 'S', 'I', 'Z', 'E', '\0', /* EXPORT_BUF_SIZE (107183) */
	'V', 'M', 'E', 'M', '_', 'D', 'A', 'T', 'A', '_', 'F', 'I', 'F', 'O', '_', 'S', 'I', 'Z', 'E', '\0', /* VMEM_DATA_FIFO_SIZE (107199) */
	'S', 'Q', 'C', '0', '_', 'B', 'A', 'N', 'K', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* SQC0_BANK_DISABLE (107219) */
	'S', 'Q', 'C', '1', '_', 'B', 'A', 'N', 'K', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* SQC1_BANK_DISABLE (107237) */
	'S', 'Q', 'C', '2', '_', 'B', 'A', 'N', 'K', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* SQC2_BANK_DISABLE (107255) */
	'S', 'Q', 'C', '3', '_', 'B', 'A', 'N', 'K', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* SQC3_BANK_DISABLE (107273) */
	'I', 'N', 'T', 'E', 'R', 'R', 'U', 'P', 'T', '_', 'M', 'S', 'G', '_', 'B', 'U', 'S', 'Y', '\0', /* INTERRUPT_MSG_BUSY (107291) */
	'W', 'A', 'V', 'E', '_', 'L', 'E', 'V', 'E', 'L', '_', 'S', 'H', '0', '\0', /* WAVE_LEVEL_SH0 (107310) */
	'W', 'A', 'V', 'E', '_', 'L', 'E', 'V', 'E', 'L', '_', 'S', 'H', '1', '\0', /* WAVE_LEVEL_SH1 (107325) */
	'S', 'Q', 'C', '_', 'C', 'L', 'I', 'E', 'N', 'T', '_', 'M', 'A', 'S', 'K', '\0', /* SQC_CLIENT_MASK (107340) */
	'S', 'I', 'M', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* SIMD_MASK (107356) */
	'F', 'O', 'R', 'C', 'E', '_', 'C', 'U', '_', 'O', 'N', '_', 'S', 'H', '0', '\0', /* FORCE_CU_ON_SH0 (107366) */
	'F', 'O', 'R', 'C', 'E', '_', 'C', 'U', '_', 'O', 'N', '_', 'S', 'H', '1', '\0', /* FORCE_CU_ON_SH1 (107382) */
	'T', 'H', 'R', 'E', 'A', 'D', '_', 'I', 'D', '\0', /* THREAD_ID (107398) */
	'A', 'U', 'T', 'O', '_', 'I', 'N', 'C', 'R', '\0', /* AUTO_INCR (107408) */
	'F', 'O', 'R', 'C', 'E', '_', 'R', 'E', 'A', 'D', '\0', /* FORCE_READ (107418) */
	'U', 'N', 'I', 'N', 'D', 'E', 'X', 'E', 'D', '\0', /* UNINDEXED (107429) */
	'C', 'U', '_', 'S', 'E', 'L', '\0', /* CU_SEL (107439) */
	'S', 'H', '_', 'S', 'E', 'L', '\0', /* SH_SEL (107446) */
	'V', 'M', '_', 'I', 'D', '_', 'M', 'A', 'S', 'K', '\0', /* VM_ID_MASK (107453) */
	'R', 'A', 'N', 'D', 'O', 'M', '_', 'S', 'E', 'E', 'D', '\0', /* RANDOM_SEED (107464) */
	'R', 'E', 'G', '_', 'M', 'A', 'S', 'K', '\0', /* REG_MASK (107476) */
	'S', 'H', '0', '_', 'M', 'A', 'S', 'K', '\0', /* SH0_MASK (107485) */
	'S', 'H', '1', '_', 'M', 'A', 'S', 'K', '\0', /* SH1_MASK (107494) */
	'R', 'E', 'A', 'D', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* READ_OFFSET (107503) */
	'N', 'E', 'W', '_', 'B', 'U', 'F', '\0', /* NEW_BUF (107515) */
	'M', 'A', 'S', 'K', '_', 'P', 'S', '\0', /* MASK_PS (107523) */
	'M', 'A', 'S', 'K', '_', 'V', 'S', '\0', /* MASK_VS (107531) */
	'M', 'A', 'S', 'K', '_', 'G', 'S', '\0', /* MASK_GS (107539) */
	'M', 'A', 'S', 'K', '_', 'E', 'S', '\0', /* MASK_ES (107547) */
	'M', 'A', 'S', 'K', '_', 'H', 'S', '\0', /* MASK_HS (107555) */
	'M', 'A', 'S', 'K', '_', 'L', 'S', '\0', /* MASK_LS (107563) */
	'M', 'A', 'S', 'K', '_', 'C', 'S', '\0', /* MASK_CS (107571) */
	'C', 'A', 'P', 'T', 'U', 'R', 'E', '_', 'M', 'O', 'D', 'E', '\0', /* CAPTURE_MODE (107579) */
	'A', 'U', 'T', 'O', 'F', 'L', 'U', 'S', 'H', '_', 'E', 'N', '\0', /* AUTOFLUSH_EN (107592) */
	'I', 'S', 'S', 'U', 'E', '_', 'M', 'A', 'S', 'K', '\0', /* ISSUE_MASK (107605) */
	'T', 'E', 'S', 'T', '_', 'M', 'O', 'D', 'E', '\0', /* TEST_MODE (107616) */
	'R', 'E', 'S', 'E', 'T', '_', 'B', 'U', 'F', 'F', 'E', 'R', '\0', /* RESET_BUFFER (107626) */
	'M', 'I', 'N', '_', 'P', 'O', 'W', 'E', 'R', '\0', /* MIN_POWER (107639) */
	'M', 'A', 'X', '_', 'P', 'O', 'W', 'E', 'R', '\0', /* MAX_POWER (107649) */
	'P', 'H', 'A', 'S', 'E', '_', 'O', 'F', 'F', 'S', 'E', 'T', '\0', /* PHASE_OFFSET (107659) */
	'M', 'A', 'X', '_', 'P', 'O', 'W', 'E', 'R', '_', 'D', 'E', 'L', 'T', 'A', '\0', /* MAX_POWER_DELTA (107672) */
	'S', 'H', 'O', 'R', 'T', '_', 'T', 'E', 'R', 'M', '_', 'I', 'N', 'T', 'E', 'R', 'V', 'A', 'L', '_', 'S', 'I', 'Z', 'E', '\0', /* SHORT_TERM_INTERVAL_SIZE (107688) */
	'L', 'O', 'N', 'G', '_', 'T', 'E', 'R', 'M', '_', 'I', 'N', 'T', 'E', 'R', 'V', 'A', 'L', '_', 'R', 'A', 'T', 'I', 'O', '\0', /* LONG_TERM_INTERVAL_RATIO (107713) */
	'U', 'S', 'E', '_', 'R', 'E', 'F', '_', 'C', 'L', 'O', 'C', 'K', '\0', /* USE_REF_CLOCK (107738) */
	'I', 'N', 'S', 'T', '_', 'S', 'E', 'C', '\0', /* INST_SEC (107752) */
	'I', 'N', 'S', 'T', '_', 'D', 'E', 'D', '\0', /* INST_DED (107761) */
	'D', 'A', 'T', 'A', '_', 'S', 'E', 'C', '\0', /* DATA_SEC (107770) */
	'D', 'A', 'T', 'A', '_', 'D', 'E', 'D', '\0', /* DATA_DED (107779) */
	'L', 'D', 'S', '_', 'S', 'E', 'C', '\0', /* LDS_SEC (107788) */
	'S', 'G', 'P', 'R', '_', 'S', 'E', 'C', '\0', /* SGPR_SEC (107796) */
	'V', 'G', 'P', 'R', '_', 'S', 'E', 'C', '\0', /* VGPR_SEC (107805) */
	'L', 'D', 'S', '_', 'D', 'E', 'D', '\0', /* LDS_DED (107814) */
	'S', 'G', 'P', 'R', '_', 'D', 'E', 'D', '\0', /* SGPR_DED (107822) */
	'V', 'G', 'P', 'R', '_', 'D', 'E', 'D', '\0', /* VGPR_DED (107831) */
	'S', 'Q', '_', 'S', 'E', 'L', '_', '0', '\0', /* SQ_SEL_0 (107840) */
	'S', 'Q', '_', 'S', 'E', 'L', '_', '1', '\0', /* SQ_SEL_1 (107849) */
	'S', 'Q', '_', 'S', 'E', 'L', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '0', '\0', /* SQ_SEL_RESERVED_0 (107858) */
	'S', 'Q', '_', 'S', 'E', 'L', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '\0', /* SQ_SEL_RESERVED_1 (107876) */
	'S', 'Q', '_', 'S', 'E', 'L', '_', 'X', '\0', /* SQ_SEL_X (107894) */
	'S', 'Q', '_', 'S', 'E', 'L', '_', 'Y', '\0', /* SQ_SEL_Y (107903) */
	'S', 'Q', '_', 'S', 'E', 'L', '_', 'Z', '\0', /* SQ_SEL_Z (107912) */
	'S', 'Q', '_', 'S', 'E', 'L', '_', 'W', '\0', /* SQ_SEL_W (107921) */
	'B', 'U', 'F', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* BUF_NUM_FORMAT_UNORM (107930) */
	'B', 'U', 'F', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* BUF_NUM_FORMAT_SNORM (107951) */
	'B', 'U', 'F', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* BUF_NUM_FORMAT_USCALED (107972) */
	'B', 'U', 'F', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* BUF_NUM_FORMAT_SSCALED (107995) */
	'B', 'U', 'F', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'I', 'N', 'T', '\0', /* BUF_NUM_FORMAT_UINT (108018) */
	'B', 'U', 'F', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', 'I', 'N', 'T', '\0', /* BUF_NUM_FORMAT_SINT (108038) */
	'B', 'U', 'F', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', 'N', 'O', 'R', 'M', '_', 'O', 'G', 'L', '\0', /* BUF_NUM_FORMAT_SNORM_OGL (108058) */
	'B', 'U', 'F', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* BUF_NUM_FORMAT_FLOAT (108083) */
	'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* NUM_FORMAT (108104) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', '\0', /* BUF_DATA_FORMAT_INVALID (108115) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '\0', /* BUF_DATA_FORMAT_8 (108139) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '\0', /* BUF_DATA_FORMAT_16 (108157) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '\0', /* BUF_DATA_FORMAT_8_8 (108176) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '\0', /* BUF_DATA_FORMAT_32 (108196) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '\0', /* BUF_DATA_FORMAT_16_16 (108215) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '1', '_', '1', '1', '\0', /* BUF_DATA_FORMAT_10_11_11 (108237) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '1', '_', '1', '1', '_', '1', '0', '\0', /* BUF_DATA_FORMAT_11_11_10 (108262) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', '2', '\0', /* BUF_DATA_FORMAT_10_10_10_2 (108287) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '\0', /* BUF_DATA_FORMAT_2_10_10_10 (108314) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', '8', '_', '8', '\0', /* BUF_DATA_FORMAT_8_8_8_8 (108341) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '\0', /* BUF_DATA_FORMAT_32_32 (108365) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '\0', /* BUF_DATA_FORMAT_16_16_16_16 (108387) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', '3', '2', '\0', /* BUF_DATA_FORMAT_32_32_32 (108415) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', '3', '2', '\0', /* BUF_DATA_FORMAT_32_32_32_32 (108440) */
	'B', 'U', 'F', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '5', '\0', /* BUF_DATA_FORMAT_RESERVED_15 (108468) */
	'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '\0', /* DATA_FORMAT (108496) */
	'E', 'L', 'E', 'M', 'E', 'N', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* ELEMENT_SIZE (108508) */
	'H', 'A', 'S', 'H', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* HASH_ENABLE (108521) */
	'H', 'E', 'A', 'P', '\0', /* HEAP (108533) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'B', 'U', 'F', '\0', /* SQ_RSRC_BUF (108538) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'B', 'U', 'F', '_', 'R', 'S', 'V', 'D', '_', '1', '\0', /* SQ_RSRC_BUF_RSVD_1 (108550) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'B', 'U', 'F', '_', 'R', 'S', 'V', 'D', '_', '2', '\0', /* SQ_RSRC_BUF_RSVD_2 (108569) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'B', 'U', 'F', '_', 'R', 'S', 'V', 'D', '_', '3', '\0', /* SQ_RSRC_BUF_RSVD_3 (108588) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'I', 'N', 'V', 'A', 'L', 'I', 'D', '\0', /* IMG_DATA_FORMAT_INVALID (108607) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '\0', /* IMG_DATA_FORMAT_8 (108631) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '\0', /* IMG_DATA_FORMAT_16 (108649) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '\0', /* IMG_DATA_FORMAT_8_8 (108668) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_32 (108688) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '\0', /* IMG_DATA_FORMAT_16_16 (108707) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '1', '_', '1', '1', '\0', /* IMG_DATA_FORMAT_10_11_11 (108729) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '1', '_', '1', '1', '_', '1', '0', '\0', /* IMG_DATA_FORMAT_11_11_10 (108754) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '0', '_', '1', '0', '_', '1', '0', '_', '2', '\0', /* IMG_DATA_FORMAT_10_10_10_2 (108779) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '_', '1', '0', '_', '1', '0', '_', '1', '0', '\0', /* IMG_DATA_FORMAT_2_10_10_10 (108806) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '8', '_', '8', '_', '8', '\0', /* IMG_DATA_FORMAT_8_8_8_8 (108833) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_32_32 (108857) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '\0', /* IMG_DATA_FORMAT_16_16_16_16 (108879) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_32_32_32 (108907) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_32_32_32_32 (108932) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '5', '\0', /* IMG_DATA_FORMAT_RESERVED_15 (108960) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '5', '_', '6', '_', '5', '\0', /* IMG_DATA_FORMAT_5_6_5 (108988) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '_', '5', '_', '5', '_', '5', '\0', /* IMG_DATA_FORMAT_1_5_5_5 (109010) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '5', '_', '5', '_', '5', '_', '1', '\0', /* IMG_DATA_FORMAT_5_5_5_1 (109034) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '4', '_', '4', '_', '4', '_', '4', '\0', /* IMG_DATA_FORMAT_4_4_4_4 (109058) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', '2', '4', '\0', /* IMG_DATA_FORMAT_8_24 (109082) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '2', '4', '_', '8', '\0', /* IMG_DATA_FORMAT_24_8 (109103) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'X', '2', '4', '_', '8', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_X24_8_32 (109124) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '3', '\0', /* IMG_DATA_FORMAT_RESERVED_23 (109149) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '4', '\0', /* IMG_DATA_FORMAT_RESERVED_24 (109177) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '5', '\0', /* IMG_DATA_FORMAT_RESERVED_25 (109205) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '6', '\0', /* IMG_DATA_FORMAT_RESERVED_26 (109233) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '7', '\0', /* IMG_DATA_FORMAT_RESERVED_27 (109261) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '8', '\0', /* IMG_DATA_FORMAT_RESERVED_28 (109289) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '2', '9', '\0', /* IMG_DATA_FORMAT_RESERVED_29 (109317) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '3', '0', '\0', /* IMG_DATA_FORMAT_RESERVED_30 (109345) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '3', '1', '\0', /* IMG_DATA_FORMAT_RESERVED_31 (109373) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'G', 'B', '_', 'G', 'R', '\0', /* IMG_DATA_FORMAT_GB_GR (109401) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'G', '_', 'R', 'G', '\0', /* IMG_DATA_FORMAT_BG_RG (109423) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '5', '_', '9', '_', '9', '_', '9', '\0', /* IMG_DATA_FORMAT_5_9_9_9 (109445) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '1', '\0', /* IMG_DATA_FORMAT_BC1 (109469) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '2', '\0', /* IMG_DATA_FORMAT_BC2 (109489) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '3', '\0', /* IMG_DATA_FORMAT_BC3 (109509) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '4', '\0', /* IMG_DATA_FORMAT_BC4 (109529) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '5', '\0', /* IMG_DATA_FORMAT_BC5 (109549) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '6', '\0', /* IMG_DATA_FORMAT_BC6 (109569) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'B', 'C', '7', '\0', /* IMG_DATA_FORMAT_BC7 (109589) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '4', '2', '\0', /* IMG_DATA_FORMAT_RESERVED_42 (109609) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '4', '3', '\0', /* IMG_DATA_FORMAT_RESERVED_43 (109637) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '2', '_', 'F', '1', '\0', /* IMG_DATA_FORMAT_FMASK8_S2_F1 (109665) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '4', '_', 'F', '1', '\0', /* IMG_DATA_FORMAT_FMASK8_S4_F1 (109694) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '8', '_', 'F', '1', '\0', /* IMG_DATA_FORMAT_FMASK8_S8_F1 (109723) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '2', '_', 'F', '2', '\0', /* IMG_DATA_FORMAT_FMASK8_S2_F2 (109752) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '4', '_', 'F', '2', '\0', /* IMG_DATA_FORMAT_FMASK8_S4_F2 (109781) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '8', '_', 'S', '4', '_', 'F', '4', '\0', /* IMG_DATA_FORMAT_FMASK8_S4_F4 (109810) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '1', '6', '_', 'S', '1', '6', '_', 'F', '1', '\0', /* IMG_DATA_FORMAT_FMASK16_S16_F1 (109839) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '1', '6', '_', 'S', '8', '_', 'F', '2', '\0', /* IMG_DATA_FORMAT_FMASK16_S8_F2 (109870) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '3', '2', '_', 'S', '1', '6', '_', 'F', '2', '\0', /* IMG_DATA_FORMAT_FMASK32_S16_F2 (109900) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '3', '2', '_', 'S', '8', '_', 'F', '4', '\0', /* IMG_DATA_FORMAT_FMASK32_S8_F4 (109931) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '3', '2', '_', 'S', '8', '_', 'F', '8', '\0', /* IMG_DATA_FORMAT_FMASK32_S8_F8 (109961) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '6', '4', '_', 'S', '1', '6', '_', 'F', '4', '\0', /* IMG_DATA_FORMAT_FMASK64_S16_F4 (109991) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '6', '4', '_', 'S', '1', '6', '_', 'F', '8', '\0', /* IMG_DATA_FORMAT_FMASK64_S16_F8 (110022) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '4', '_', '4', '\0', /* IMG_DATA_FORMAT_4_4 (110053) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '6', '_', '5', '_', '5', '\0', /* IMG_DATA_FORMAT_6_5_5 (110073) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '\0', /* IMG_DATA_FORMAT_1 (110095) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '_', 'R', 'E', 'V', 'E', 'R', 'S', 'E', 'D', '\0', /* IMG_DATA_FORMAT_1_REVERSED (110113) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', 'A', 'S', '_', '8', '\0', /* IMG_DATA_FORMAT_32_AS_8 (110140) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', 'A', 'S', '_', '8', '_', '8', '\0', /* IMG_DATA_FORMAT_32_AS_8_8 (110164) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '3', '2', '_', 'A', 'S', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_32_AS_32_32_32_32 (110190) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'N', 'O', 'R', 'M', '\0', /* IMG_NUM_FORMAT_UNORM (110224) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', 'N', 'O', 'R', 'M', '\0', /* IMG_NUM_FORMAT_SNORM (110245) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* IMG_NUM_FORMAT_USCALED (110266) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* IMG_NUM_FORMAT_SSCALED (110289) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'I', 'N', 'T', '\0', /* IMG_NUM_FORMAT_UINT (110312) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', 'I', 'N', 'T', '\0', /* IMG_NUM_FORMAT_SINT (110332) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', 'N', 'O', 'R', 'M', '_', 'O', 'G', 'L', '\0', /* IMG_NUM_FORMAT_SNORM_OGL (110352) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'L', 'O', 'A', 'T', '\0', /* IMG_NUM_FORMAT_FLOAT (110377) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '8', '\0', /* IMG_NUM_FORMAT_RESERVED_8 (110398) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', 'R', 'G', 'B', '\0', /* IMG_NUM_FORMAT_SRGB (110424) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'B', 'N', 'O', 'R', 'M', '\0', /* IMG_NUM_FORMAT_UBNORM (110444) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'B', 'N', 'O', 'R', 'M', '_', 'O', 'G', 'L', '\0', /* IMG_NUM_FORMAT_UBNORM_OGL (110466) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'B', 'I', 'N', 'T', '\0', /* IMG_NUM_FORMAT_UBINT (110492) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'B', 'S', 'C', 'A', 'L', 'E', 'D', '\0', /* IMG_NUM_FORMAT_UBSCALED (110513) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '4', '\0', /* IMG_NUM_FORMAT_RESERVED_14 (110537) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '5', '\0', /* IMG_NUM_FORMAT_RESERVED_15 (110564) */
	'I', 'N', 'T', 'E', 'R', 'L', 'A', 'C', 'E', 'D', '\0', /* INTERLACED (110591) */
	'T', 'I', 'L', 'I', 'N', 'G', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* TILING_INDEX (110602) */
	'P', 'O', 'W', '2', '_', 'P', 'A', 'D', '\0', /* POW2_PAD (110615) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', 'R', 'S', 'V', 'D', '_', '0', '\0', /* SQ_RSRC_IMG_RSVD_0 (110624) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', 'R', 'S', 'V', 'D', '_', '1', '\0', /* SQ_RSRC_IMG_RSVD_1 (110643) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', 'R', 'S', 'V', 'D', '_', '2', '\0', /* SQ_RSRC_IMG_RSVD_2 (110662) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', 'R', 'S', 'V', 'D', '_', '3', '\0', /* SQ_RSRC_IMG_RSVD_3 (110681) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', 'R', 'S', 'V', 'D', '_', '4', '\0', /* SQ_RSRC_IMG_RSVD_4 (110700) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', 'R', 'S', 'V', 'D', '_', '5', '\0', /* SQ_RSRC_IMG_RSVD_5 (110719) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', 'R', 'S', 'V', 'D', '_', '6', '\0', /* SQ_RSRC_IMG_RSVD_6 (110738) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', 'R', 'S', 'V', 'D', '_', '7', '\0', /* SQ_RSRC_IMG_RSVD_7 (110757) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', '1', 'D', '\0', /* SQ_RSRC_IMG_1D (110776) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', '2', 'D', '\0', /* SQ_RSRC_IMG_2D (110791) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', '3', 'D', '\0', /* SQ_RSRC_IMG_3D (110806) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', 'C', 'U', 'B', 'E', '\0', /* SQ_RSRC_IMG_CUBE (110821) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', '1', 'D', '_', 'A', 'R', 'R', 'A', 'Y', '\0', /* SQ_RSRC_IMG_1D_ARRAY (110838) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', '2', 'D', '_', 'A', 'R', 'R', 'A', 'Y', '\0', /* SQ_RSRC_IMG_2D_ARRAY (110859) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', '2', 'D', '_', 'M', 'S', 'A', 'A', '\0', /* SQ_RSRC_IMG_2D_MSAA (110880) */
	'S', 'Q', '_', 'R', 'S', 'R', 'C', '_', 'I', 'M', 'G', '_', '2', 'D', '_', 'M', 'S', 'A', 'A', '_', 'A', 'R', 'R', 'A', 'Y', '\0', /* SQ_RSRC_IMG_2D_MSAA_ARRAY (110900) */
	'L', 'A', 'S', 'T', '_', 'A', 'R', 'R', 'A', 'Y', '\0', /* LAST_ARRAY (110926) */
	'U', 'N', 'U', 'N', 'S', 'E', 'D', '\0', /* UNUNSED (110937) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'W', 'R', 'A', 'P', '\0', /* SQ_TEX_WRAP (110945) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'M', 'I', 'R', 'R', 'O', 'R', '\0', /* SQ_TEX_MIRROR (110957) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'C', 'L', 'A', 'M', 'P', '_', 'L', 'A', 'S', 'T', '_', 'T', 'E', 'X', 'E', 'L', '\0', /* SQ_TEX_CLAMP_LAST_TEXEL (110971) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'M', 'I', 'R', 'R', 'O', 'R', '_', 'O', 'N', 'C', 'E', '_', 'L', 'A', 'S', 'T', '_', 'T', 'E', 'X', 'E', 'L', '\0', /* SQ_TEX_MIRROR_ONCE_LAST_TEXEL (110995) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'C', 'L', 'A', 'M', 'P', '_', 'H', 'A', 'L', 'F', '_', 'B', 'O', 'R', 'D', 'E', 'R', '\0', /* SQ_TEX_CLAMP_HALF_BORDER (111025) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'M', 'I', 'R', 'R', 'O', 'R', '_', 'O', 'N', 'C', 'E', '_', 'H', 'A', 'L', 'F', '_', 'B', 'O', 'R', 'D', 'E', 'R', '\0', /* SQ_TEX_MIRROR_ONCE_HALF_BORDER (111050) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'C', 'L', 'A', 'M', 'P', '_', 'B', 'O', 'R', 'D', 'E', 'R', '\0', /* SQ_TEX_CLAMP_BORDER (111081) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'M', 'I', 'R', 'R', 'O', 'R', '_', 'O', 'N', 'C', 'E', '_', 'B', 'O', 'R', 'D', 'E', 'R', '\0', /* SQ_TEX_MIRROR_ONCE_BORDER (111101) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'N', 'E', 'V', 'E', 'R', '\0', /* SQ_TEX_DEPTH_COMPARE_NEVER (111127) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'L', 'E', 'S', 'S', '\0', /* SQ_TEX_DEPTH_COMPARE_LESS (111154) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'E', 'Q', 'U', 'A', 'L', '\0', /* SQ_TEX_DEPTH_COMPARE_EQUAL (111180) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'L', 'E', 'S', 'S', 'E', 'Q', 'U', 'A', 'L', '\0', /* SQ_TEX_DEPTH_COMPARE_LESSEQUAL (111207) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'G', 'R', 'E', 'A', 'T', 'E', 'R', '\0', /* SQ_TEX_DEPTH_COMPARE_GREATER (111238) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'N', 'O', 'T', 'E', 'Q', 'U', 'A', 'L', '\0', /* SQ_TEX_DEPTH_COMPARE_NOTEQUAL (111267) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'G', 'R', 'E', 'A', 'T', 'E', 'R', 'E', 'Q', 'U', 'A', 'L', '\0', /* SQ_TEX_DEPTH_COMPARE_GREATEREQUAL (111297) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'D', 'E', 'P', 'T', 'H', '_', 'C', 'O', 'M', 'P', 'A', 'R', 'E', '_', 'A', 'L', 'W', 'A', 'Y', 'S', '\0', /* SQ_TEX_DEPTH_COMPARE_ALWAYS (111331) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'M', 'O', 'D', 'E', '_', 'B', 'L', 'E', 'N', 'D', '\0', /* SQ_IMG_FILTER_MODE_BLEND (111359) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'M', 'O', 'D', 'E', '_', 'M', 'I', 'N', '\0', /* SQ_IMG_FILTER_MODE_MIN (111384) */
	'S', 'Q', '_', 'I', 'M', 'G', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'M', 'O', 'D', 'E', '_', 'M', 'A', 'X', '\0', /* SQ_IMG_FILTER_MODE_MAX (111407) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'X', 'Y', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'P', 'O', 'I', 'N', 'T', '\0', /* SQ_TEX_XY_FILTER_POINT (111430) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'X', 'Y', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'B', 'I', 'L', 'I', 'N', 'E', 'A', 'R', '\0', /* SQ_TEX_XY_FILTER_BILINEAR (111453) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'X', 'Y', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'A', 'N', 'I', 'S', 'O', '_', 'P', 'O', 'I', 'N', 'T', '\0', /* SQ_TEX_XY_FILTER_ANISO_POINT (111479) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'X', 'Y', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'A', 'N', 'I', 'S', 'O', '_', 'B', 'I', 'L', 'I', 'N', 'E', 'A', 'R', '\0', /* SQ_TEX_XY_FILTER_ANISO_BILINEAR (111508) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'Z', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'N', 'O', 'N', 'E', '\0', /* SQ_TEX_Z_FILTER_NONE (111540) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'Z', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'P', 'O', 'I', 'N', 'T', '\0', /* SQ_TEX_Z_FILTER_POINT (111561) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'Z', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'L', 'I', 'N', 'E', 'A', 'R', '\0', /* SQ_TEX_Z_FILTER_LINEAR (111583) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'M', 'I', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'N', 'O', 'N', 'E', '\0', /* SQ_TEX_MIP_FILTER_NONE (111606) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'M', 'I', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'P', 'O', 'I', 'N', 'T', '\0', /* SQ_TEX_MIP_FILTER_POINT (111629) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'M', 'I', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'L', 'I', 'N', 'E', 'A', 'R', '\0', /* SQ_TEX_MIP_FILTER_LINEAR (111653) */
	'D', 'I', 'S', 'A', 'B', 'L', 'E', '_', 'L', 'S', 'B', '_', 'C', 'E', 'I', 'L', '\0', /* DISABLE_LSB_CEIL (111678) */
	'F', 'I', 'L', 'T', 'E', 'R', '_', 'P', 'R', 'E', 'C', '_', 'F', 'I', 'X', '\0', /* FILTER_PREC_FIX (111695) */
	'U', 'P', 'G', 'R', 'A', 'D', 'E', 'D', '_', 'D', 'E', 'P', 'T', 'H', '\0', /* UPGRADED_DEPTH (111711) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'B', 'O', 'R', 'D', 'E', 'R', '_', 'C', 'O', 'L', 'O', 'R', '_', 'T', 'R', 'A', 'N', 'S', '_', 'B', 'L', 'A', 'C', 'K', '\0', /* SQ_TEX_BORDER_COLOR_TRANS_BLACK (111726) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'B', 'O', 'R', 'D', 'E', 'R', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'P', 'A', 'Q', 'U', 'E', '_', 'B', 'L', 'A', 'C', 'K', '\0', /* SQ_TEX_BORDER_COLOR_OPAQUE_BLACK (111758) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'B', 'O', 'R', 'D', 'E', 'R', '_', 'C', 'O', 'L', 'O', 'R', '_', 'O', 'P', 'A', 'Q', 'U', 'E', '_', 'W', 'H', 'I', 'T', 'E', '\0', /* SQ_TEX_BORDER_COLOR_OPAQUE_WHITE (111791) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'B', 'O', 'R', 'D', 'E', 'R', '_', 'C', 'O', 'L', 'O', 'R', '_', 'R', 'E', 'G', 'I', 'S', 'T', 'E', 'R', '\0', /* SQ_TEX_BORDER_COLOR_REGISTER (111824) */
	'B', 'A', 'N', 'K', '_', 'I', 'N', 'T', 'E', 'R', 'L', 'E', 'A', 'V', 'E', '_', 'S', 'I', 'Z', 'E', '\0', /* BANK_INTERLEAVE_SIZE (111853) */
	'S', 'H', 'A', 'D', 'E', 'R', '_', 'E', 'N', 'G', 'I', 'N', 'E', '_', 'T', 'I', 'L', 'E', '_', 'S', 'I', 'Z', 'E', '\0', /* SHADER_ENGINE_TILE_SIZE (111874) */
	'N', 'U', 'M', '_', 'G', 'P', 'U', 'S', '\0', /* NUM_GPUS (111898) */
	'M', 'U', 'L', 'T', 'I', '_', 'G', 'P', 'U', '_', 'T', 'I', 'L', 'E', '_', 'S', 'I', 'Z', 'E', '\0', /* MULTI_GPU_TILE_SIZE (111907) */
	'R', 'O', 'W', '_', 'S', 'I', 'Z', 'E', '\0', /* ROW_SIZE (111927) */
	'N', 'U', 'M', '_', 'L', 'O', 'W', 'E', 'R', '_', 'P', 'I', 'P', 'E', 'S', '\0', /* NUM_LOWER_PIPES (111936) */
	'A', 'D', 'D', 'R', '_', 'S', 'U', 'R', 'F', '_', 'T', 'H', 'I', 'C', 'K', '_', 'M', 'I', 'C', 'R', 'O', '_', 'T', 'I', 'L', 'I', 'N', 'G', '_', 'G', 'F', 'X', '6', '\0', /* ADDR_SURF_THICK_MICRO_TILING_GFX6 (111952) */
	'M', 'I', 'C', 'R', 'O', '_', 'T', 'I', 'L', 'E', '_', 'M', 'O', 'D', 'E', '\0', /* MICRO_TILE_MODE (111986) */
	'D', 'E', 'B', 'U', 'G', '_', 'M', 'O', 'D', 'E', '\0', /* DEBUG_MODE (112002) */
	'C', 'A', 'C', 'H', 'E', '_', 'C', 'T', 'L', '\0', /* CACHE_CTL (112013) */
	'C', 'D', 'B', 'G', '_', 'U', 'S', 'E', 'R', '\0', /* CDBG_USER (112023) */
	'D', 'I', 'S', 'P', 'A', 'T', 'C', 'H', '_', 'C', 'A', 'C', 'H', 'E', '_', 'C', 'N', 'T', 'L', '\0', /* DISPATCH_CACHE_CNTL (112033) */
	'W', 'A', 'V', 'E', 'S', '_', 'P', 'E', 'R', '_', 'S', 'H', '_', 'G', 'F', 'X', '6', '\0', /* WAVES_PER_SH_GFX6 (112053) */
	'S', 'H', '0', '_', 'C', 'U', '_', 'E', 'N', '\0', /* SH0_CU_EN (112071) */
	'S', 'H', '1', '_', 'C', 'U', '_', 'E', 'N', '\0', /* SH1_CU_EN (112081) */
	'R', 'E', 'G', '_', 'I', 'D', 'L', 'E', '\0', /* REG_IDLE (112091) */
	'R', 'B', '_', 'E', 'M', 'P', 'T', 'Y', '\0', /* RB_EMPTY (112100) */
	'R', 'B', '_', 'F', 'U', 'L', 'L', '\0', /* RB_FULL (112109) */
	'R', 'B', '_', 'C', 'M', 'D', '_', 'I', 'D', 'L', 'E', '\0', /* RB_CMD_IDLE (112117) */
	'R', 'B', '_', 'C', 'M', 'D', '_', 'F', 'U', 'L', 'L', '\0', /* RB_CMD_FULL (112129) */
	'I', 'B', '_', 'C', 'M', 'D', '_', 'I', 'D', 'L', 'E', '\0', /* IB_CMD_IDLE (112141) */
	'I', 'B', '_', 'C', 'M', 'D', '_', 'F', 'U', 'L', 'L', '\0', /* IB_CMD_FULL (112153) */
	'B', 'L', 'O', 'C', 'K', '_', 'I', 'D', 'L', 'E', '\0', /* BLOCK_IDLE (112165) */
	'I', 'N', 'S', 'I', 'D', 'E', '_', 'I', 'B', '\0', /* INSIDE_IB (112176) */
	'E', 'X', '_', 'I', 'D', 'L', 'E', '\0', /* EX_IDLE (112186) */
	'E', 'X', '_', 'I', 'D', 'L', 'E', '_', 'P', 'O', 'L', 'L', '_', 'T', 'I', 'M', 'E', 'R', '_', 'E', 'X', 'P', 'I', 'R', 'E', '\0', /* EX_IDLE_POLL_TIMER_EXPIRE (112194) */
	'P', 'A', 'C', 'K', 'E', 'T', '_', 'R', 'E', 'A', 'D', 'Y', '\0', /* PACKET_READY (112220) */
	'M', 'C', '_', 'W', 'R', '_', 'I', 'D', 'L', 'E', '\0', /* MC_WR_IDLE (112233) */
	'S', 'R', 'B', 'M', '_', 'I', 'D', 'L', 'E', '\0', /* SRBM_IDLE (112244) */
	'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'E', 'M', 'P', 'T', 'Y', '\0', /* CONTEXT_EMPTY (112254) */
	'D', 'E', 'L', 'T', 'A', '_', 'R', 'P', 'T', 'R', '_', 'F', 'U', 'L', 'L', '\0', /* DELTA_RPTR_FULL (112268) */
	'R', 'B', '_', 'M', 'C', '_', 'R', 'R', 'E', 'Q', '_', 'I', 'D', 'L', 'E', '\0', /* RB_MC_RREQ_IDLE (112284) */
	'I', 'B', '_', 'M', 'C', '_', 'R', 'R', 'E', 'Q', '_', 'I', 'D', 'L', 'E', '\0', /* IB_MC_RREQ_IDLE (112300) */
	'M', 'C', '_', 'R', 'D', '_', 'I', 'D', 'L', 'E', '\0', /* MC_RD_IDLE (112316) */
	'D', 'E', 'L', 'T', 'A', '_', 'R', 'P', 'T', 'R', '_', 'E', 'M', 'P', 'T', 'Y', '\0', /* DELTA_RPTR_EMPTY (112327) */
	'M', 'C', '_', 'R', 'D', '_', 'R', 'E', 'T', '_', 'S', 'T', 'A', 'L', 'L', '\0', /* MC_RD_RET_STALL (112344) */
	'M', 'C', '_', 'R', 'D', '_', 'N', 'O', '_', 'P', 'O', 'L', 'L', '_', 'I', 'D', 'L', 'E', '\0', /* MC_RD_NO_POLL_IDLE (112360) */
	'P', 'R', 'E', 'V', '_', 'C', 'M', 'D', '_', 'I', 'D', 'L', 'E', '\0', /* PREV_CMD_IDLE (112379) */
	'S', 'E', 'M', '_', 'I', 'D', 'L', 'E', '\0', /* SEM_IDLE (112393) */
	'S', 'E', 'M', '_', 'R', 'E', 'Q', '_', 'S', 'T', 'A', 'L', 'L', '\0', /* SEM_REQ_STALL (112402) */
	'S', 'E', 'M', '_', 'R', 'E', 'S', 'P', '_', 'S', 'T', 'A', 'T', 'E', '\0', /* SEM_RESP_STATE (112416) */
	'I', 'N', 'T', '_', 'I', 'D', 'L', 'E', '\0', /* INT_IDLE (112431) */
	'I', 'N', 'T', '_', 'R', 'E', 'Q', '_', 'S', 'T', 'A', 'L', 'L', '\0', /* INT_REQ_STALL (112440) */
	'A', 'D', 'D', 'R', '5', '_', 'S', 'W', 'I', 'Z', 'Z', 'L', 'E', '_', 'M', 'A', 'S', 'K', '\0', /* ADDR5_SWIZZLE_MASK (112454) */
	'P', 'I', 'T', 'C', 'H', '_', 'T', 'I', 'L', 'E', '_', 'M', 'A', 'X', '\0', /* PITCH_TILE_MAX (112473) */
	'H', 'E', 'I', 'G', 'H', 'T', '_', 'T', 'I', 'L', 'E', '_', 'M', 'A', 'X', '\0', /* HEIGHT_TILE_MAX (112488) */
	'S', 'L', 'I', 'C', 'E', '_', 'T', 'I', 'L', 'E', '_', 'M', 'A', 'X', '\0', /* SLICE_TILE_MAX (112504) */
	'V', 'G', 'T', '_', 'P', 'O', 'L', 'I', 'C', 'Y', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '\0', /* VGT_POLICY_RESERVED (112519) */
	'R', 'e', 's', 'e', 'r', 'v', 'e', 'd', '_', '0', 'x', '0', '9', '\0', /* Reserved_0x09 (112539) */
	'R', 'e', 's', 'e', 'r', 'v', 'e', 'd', '_', '0', 'x', '0', 'E', '\0', /* Reserved_0x0E (112553) */
	'F', 'L', 'U', 'S', 'H', '_', 'L', 'S', '_', 'O', 'U', 'T', 'P', 'U', 'T', '\0', /* FLUSH_LS_OUTPUT (112567) */
	'R', 'e', 's', 'e', 'r', 'v', 'e', 'd', '_', '0', 'x', '1', '3', '\0', /* Reserved_0x13 (112583) */
	'F', 'L', 'U', 'S', 'H', '_', 'G', 'S', '_', 'O', 'U', 'T', 'P', 'U', 'T', '\0', /* FLUSH_GS_OUTPUT (112597) */
	'R', 'e', 's', 'e', 'r', 'v', 'e', 'd', '_', '0', 'x', '2', '5', '\0', /* Reserved_0x25 (112613) */
	'T', 'H', 'R', 'E', 'A', 'D', '_', 'T', 'R', 'A', 'C', 'E', '_', 'F', 'L', 'U', 'S', 'H', '\0', /* THREAD_TRACE_FLUSH (112627) */
	'H', 'T', 'I', 'L', 'E', '_', 'U', 'S', 'E', 'S', '_', 'P', 'R', 'E', 'L', 'O', 'A', 'D', '_', 'W', 'I', 'N', '\0', /* HTILE_USES_PRELOAD_WIN (112646) */
	'P', 'R', 'E', 'L', 'O', 'A', 'D', '\0', /* PRELOAD (112669) */
	'P', 'R', 'E', 'F', 'E', 'T', 'C', 'H', '_', 'W', 'I', 'D', 'T', 'H', '\0', /* PREFETCH_WIDTH (112677) */
	'P', 'R', 'E', 'F', 'E', 'T', 'C', 'H', '_', 'H', 'E', 'I', 'G', 'H', 'T', '\0', /* PREFETCH_HEIGHT (112692) */
	'8', '_', 'I', 'N', '_', '1', '6', '\0', /* 8_IN_16 (112708) */
	'8', '_', 'I', 'N', '_', '3', '2', '\0', /* 8_IN_32 (112716) */
	'8', '_', 'I', 'N', '_', '6', '4', '\0', /* 8_IN_64 (112724) */
	'M', 'I', 'U', '_', 'R', 'D', 'R', 'E', 'Q', '_', 'F', 'R', 'E', 'E', '_', 'S', 'T', 'A', 'L', 'L', '\0', /* MIU_RDREQ_FREE_STALL (112732) */
	'M', 'I', 'U', '_', 'W', 'R', 'R', 'E', 'Q', '_', 'F', 'R', 'E', 'E', '_', 'S', 'T', 'A', 'L', 'L', '\0', /* MIU_WRREQ_FREE_STALL (112753) */
	'M', 'E', 'C', '1', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'M', 'C', '_', 'R', 'E', 'A', 'D', '\0', /* MEC1_WAIT_ON_MC_READ (112774) */
	'M', 'E', 'C', '1', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'M', 'C', '_', 'W', 'R', '_', 'A', 'C', 'K', '\0', /* MEC1_WAIT_ON_MC_WR_ACK (112795) */
	'M', 'E', 'C', '2', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'M', 'C', '_', 'R', 'E', 'A', 'D', '\0', /* MEC2_WAIT_ON_MC_READ (112818) */
	'M', 'E', 'C', '2', '_', 'W', 'A', 'I', 'T', '_', 'O', 'N', '_', 'M', 'C', '_', 'W', 'R', '_', 'A', 'C', 'K', '\0', /* MEC2_WAIT_ON_MC_WR_ACK (112839) */
	'O', 'U', 'T', 'S', 'T', 'A', 'N', 'D', 'I', 'N', 'G', '_', 'R', 'E', 'A', 'D', '_', 'T', 'A', 'G', 'S', '\0', /* OUTSTANDING_READ_TAGS (112862) */
	'I', 'N', 'S', 'T', '_', 'M', 'A', 'S', 'K', '\0', /* INST_MASK (112884) */
	'S', 'R', 'C', '_', 'A', 'T', 'C', '\0', /* SRC_ATC (112894) */
	'S', 'R', 'C', '_', 'V', 'O', 'L', 'A', 'T', 'I', 'L', 'E', '\0', /* SRC_VOLATILE (112902) */
	'D', 'S', 'T', '_', 'A', 'T', 'C', '\0', /* DST_ATC (112915) */
	'D', 'S', 'T', '_', 'V', 'O', 'L', 'A', 'T', 'I', 'L', 'E', '\0', /* DST_VOLATILE (112923) */
	'W', 'B', 'I', 'N', 'V', '_', 'T', 'C', '_', 'O', 'P', '\0', /* WBINV_TC_OP (112936) */
	'W', 'B', 'I', 'N', 'V', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* WBINV_ACTION_ENA (112948) */
	'G', 'P', 'R', '_', 'I', 'D', 'X', '_', 'E', 'N', '\0', /* GPR_IDX_EN (112965) */
	'A', 'L', 'L', 'O', 'W', '_', 'R', 'E', 'P', 'L', 'A', 'Y', '\0', /* ALLOW_REPLAY (112976) */
	'I', 'X', 'N', 'A', 'C', 'K', '\0', /* IXNACK (112989) */
	'T', 'C', 'C', '_', 'C', 'C', '_', 'R', 'E', 'S', 'I', 'D', 'E', 'N', 'T', '\0', /* TCC_CC_RESIDENT (112996) */
	'A', 'T', 'C', 'L', '2', 'I', 'U', '_', 'B', 'U', 'S', 'Y', '\0', /* ATCL2IU_BUSY (113012) */
	'A', 'T', 'C', 'L', '2', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'F', 'R', 'E', 'E', '\0', /* ATCL2IU_WAITING_ON_FREE (113025) */
	'A', 'T', 'C', 'L', '2', 'I', 'U', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'T', 'A', 'G', 'S', '\0', /* ATCL2IU_WAITING_ON_TAGS (113049) */
	'A', 'T', 'C', 'L', '1', '_', 'W', 'A', 'I', 'T', 'I', 'N', 'G', '_', 'O', 'N', '_', 'T', 'R', 'A', 'N', 'S', '\0', /* ATCL1_WAITING_ON_TRANS (113073) */
	'B', 'U', 'F', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '6', '\0', /* BUF_NUM_FORMAT_RESERVED_6 (113096) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '6', '\0', /* IMG_NUM_FORMAT_RESERVED_6 (113122) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '0', '\0', /* IMG_NUM_FORMAT_RESERVED_10 (113148) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '1', '\0', /* IMG_NUM_FORMAT_RESERVED_11 (113175) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '2', '\0', /* IMG_NUM_FORMAT_RESERVED_12 (113202) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '3', '\0', /* IMG_NUM_FORMAT_RESERVED_13 (113229) */
	'L', 'O', 'S', 'T', '_', 'A', 'L', 'P', 'H', 'A', '_', 'B', 'I', 'T', 'S', '\0', /* LOST_ALPHA_BITS (113256) */
	'L', 'O', 'S', 'T', '_', 'C', 'O', 'L', 'O', 'R', '_', 'B', 'I', 'T', 'S', '\0', /* LOST_COLOR_BITS (113272) */
	'C', 'O', 'M', 'P', 'A', 'T', '_', 'M', 'O', 'D', 'E', '\0', /* COMPAT_MODE (113288) */
	'S', 'Q', '_', 'T', 'E', 'X', '_', 'M', 'I', 'P', '_', 'F', 'I', 'L', 'T', 'E', 'R', '_', 'P', 'O', 'I', 'N', 'T', '_', 'A', 'N', 'I', 'S', 'O', '_', 'A', 'D', 'J', '\0', /* SQ_TEX_MIP_FILTER_POINT_ANISO_ADJ (113300) */
	'C', 'L', 'E', 'A', 'R', '_', 'D', 'I', 'S', 'A', 'L', 'L', 'O', 'W', 'E', 'D', '\0', /* CLEAR_DISALLOWED (113334) */
	'O', 'V', 'E', 'R', 'W', 'R', 'I', 'T', 'E', '_', 'C', 'O', 'M', 'B', 'I', 'N', 'E', 'R', '_', 'M', 'R', 'T', '_', 'S', 'H', 'A', 'R', 'I', 'N', 'G', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* OVERWRITE_COMBINER_MRT_SHARING_DISABLE (113351) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '4', '\0', /* RESERVED_4 (113390) */
	'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '5', '\0', /* RESERVED_5 (113401) */
	'T', 'C', '_', 'C', 'O', 'M', 'P', 'A', 'T', 'I', 'B', 'L', 'E', '\0', /* TC_COMPATIBLE (113412) */
	'S', 'R', 'C', '_', 'M', 'T', 'Y', 'P', 'E', '\0', /* SRC_MTYPE (113426) */
	'D', 'S', 'T', '_', 'M', 'T', 'Y', 'P', 'E', '\0', /* DST_MTYPE (113436) */
	'T', 'C', '_', 'S', 'D', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* TC_SD_ACTION_ENA (113446) */
	'S', 'H', '_', 'S', 'D', '_', 'A', 'C', 'T', 'I', 'O', 'N', '_', 'E', 'N', 'A', '\0', /* SH_SD_ACTION_ENA (113463) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', 'A', 'S', '_', '3', '2', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_16_AS_32_32 (113480) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', 'A', 'S', '_', '8', '_', '8', '_', '8', '_', '8', '\0', /* IMG_DATA_FORMAT_8_AS_8_8_8_8 (113508) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'E', 'T', 'C', '2', '_', 'R', 'G', 'B', '\0', /* IMG_DATA_FORMAT_ETC2_RGB (113537) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'E', 'T', 'C', '2', '_', 'R', 'G', 'B', 'A', '\0', /* IMG_DATA_FORMAT_ETC2_RGBA (113562) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'E', 'T', 'C', '2', '_', 'R', '\0', /* IMG_DATA_FORMAT_ETC2_R (113588) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'E', 'T', 'C', '2', '_', 'R', 'G', '\0', /* IMG_DATA_FORMAT_ETC2_RG (113611) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'E', 'T', 'C', '2', '_', 'R', 'G', 'B', 'A', '1', '\0', /* IMG_DATA_FORMAT_ETC2_RGBA1 (113635) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', 'A', 'S', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '\0', /* IMG_DATA_FORMAT_16_AS_16_16_16_16 (113662) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '1', '6', '_', 'A', 'S', '_', '3', '2', '_', '3', '2', '_', '3', '2', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_16_AS_32_32_32_32 (113696) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', 'A', 'S', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_8_AS_32 (113730) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '8', '_', 'A', 'S', '_', '3', '2', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_8_AS_32_32 (113754) */
	'P', 'O', 'P', 'S', '_', 'P', 'A', 'C', 'K', 'E', 'R', '0', '\0', /* POPS_PACKER0 (113781) */
	'P', 'O', 'P', 'S', '_', 'P', 'A', 'C', 'K', 'E', 'R', '1', '\0', /* POPS_PACKER1 (113794) */
	'N', 'O', '_', 'P', 'R', 'E', 'F', 'E', 'T', 'C', 'H', '_', 'C', 'N', 'T', '_', 'H', 'I', '\0', /* NO_PREFETCH_CNT_HI (113807) */
	'B', 'U', 'F', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'N', 'O', 'R', 'M', '_', 'U', 'I', 'N', 'T', '\0', /* BUF_NUM_FORMAT_UNORM_UINT (113826) */
	'U', 'S', 'E', 'R', '_', 'V', 'M', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* USER_VM_ENABLE (113852) */
	'U', 'S', 'E', 'R', '_', 'V', 'M', '_', 'M', 'O', 'D', 'E', '\0', /* USER_VM_MODE (113867) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', '6', 'E', '4', '\0', /* IMG_DATA_FORMAT_6E4 (113880) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '\0', /* IMG_DATA_FORMAT_FMASK (113900) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'A', 'S', 'T', 'C', '_', '2', 'D', '_', 'L', 'D', 'R', '\0', /* IMG_DATA_FORMAT_ASTC_2D_LDR (113922) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'A', 'S', 'T', 'C', '_', '2', 'D', '_', 'H', 'D', 'R', '\0', /* IMG_DATA_FORMAT_ASTC_2D_HDR (113950) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'A', 'S', 'T', 'C', '_', '2', 'D', '_', 'L', 'D', 'R', '_', 'S', 'R', 'G', 'B', '\0', /* IMG_DATA_FORMAT_ASTC_2D_LDR_SRGB (113978) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'A', 'S', 'T', 'C', '_', '3', 'D', '_', 'L', 'D', 'R', '\0', /* IMG_DATA_FORMAT_ASTC_3D_LDR (114011) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'A', 'S', 'T', 'C', '_', '3', 'D', '_', 'H', 'D', 'R', '\0', /* IMG_DATA_FORMAT_ASTC_3D_HDR (114039) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'A', 'S', 'T', 'C', '_', '3', 'D', '_', 'L', 'D', 'R', '_', 'S', 'R', 'G', 'B', '\0', /* IMG_DATA_FORMAT_ASTC_3D_LDR_SRGB (114067) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'N', '_', 'I', 'N', '_', '1', '6', '\0', /* IMG_DATA_FORMAT_N_IN_16 (114100) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'N', '_', 'I', 'N', '_', '1', '6', '_', '1', '6', '\0', /* IMG_DATA_FORMAT_N_IN_16_16 (114124) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'N', '_', 'I', 'N', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '\0', /* IMG_DATA_FORMAT_N_IN_16_16_16_16 (114151) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'N', '_', 'I', 'N', '_', '1', '6', '_', 'A', 'S', '_', '1', '6', '_', '1', '6', '_', '1', '6', '_', '1', '6', '\0', /* IMG_DATA_FORMAT_N_IN_16_AS_16_16_16_16 (114184) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '5', '6', '\0', /* IMG_DATA_FORMAT_RESERVED_56 (114223) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '5', '9', '\0', /* IMG_DATA_FORMAT_RESERVED_59 (114251) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '6', '0', '\0', /* IMG_DATA_FORMAT_RESERVED_60 (114279) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', '8', '_', '1', '6', '\0', /* IMG_DATA_FORMAT_S8_16 (114307) */
	'I', 'M', 'G', '_', 'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', '8', '_', '3', '2', '\0', /* IMG_DATA_FORMAT_S8_32 (114329) */
	'D', 'A', 'T', 'A', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'S', 'T', 'E', 'N', 'C', 'I', 'L', '\0', /* DATA_FORMAT_STENCIL (114351) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'U', 'N', 'O', 'R', 'M', '_', 'U', 'I', 'N', 'T', '\0', /* IMG_NUM_FORMAT_UNORM_UINT (114371) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '8', '_', '2', '_', '1', '\0', /* IMG_NUM_FORMAT_FMASK_8_2_1 (114397) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '8', '_', '4', '_', '1', '\0', /* IMG_NUM_FORMAT_FMASK_8_4_1 (114424) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '8', '_', '8', '_', '1', '\0', /* IMG_NUM_FORMAT_FMASK_8_8_1 (114451) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '8', '_', '2', '_', '2', '\0', /* IMG_NUM_FORMAT_FMASK_8_2_2 (114478) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '8', '_', '4', '_', '2', '\0', /* IMG_NUM_FORMAT_FMASK_8_4_2 (114505) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '8', '_', '4', '_', '4', '\0', /* IMG_NUM_FORMAT_FMASK_8_4_4 (114532) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '1', '6', '_', '1', '6', '_', '1', '\0', /* IMG_NUM_FORMAT_FMASK_16_16_1 (114559) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '1', '6', '_', '8', '_', '2', '\0', /* IMG_NUM_FORMAT_FMASK_16_8_2 (114588) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '3', '2', '_', '1', '6', '_', '2', '\0', /* IMG_NUM_FORMAT_FMASK_32_16_2 (114616) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '3', '2', '_', '8', '_', '4', '\0', /* IMG_NUM_FORMAT_FMASK_32_8_4 (114645) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '3', '2', '_', '8', '_', '8', '\0', /* IMG_NUM_FORMAT_FMASK_32_8_8 (114673) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '6', '4', '_', '1', '6', '_', '4', '\0', /* IMG_NUM_FORMAT_FMASK_64_16_4 (114701) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', '6', '4', '_', '1', '6', '_', '8', '\0', /* IMG_NUM_FORMAT_FMASK_64_16_8 (114730) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '3', '\0', /* IMG_NUM_FORMAT_FMASK_RESERVED_13 (114759) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '4', '\0', /* IMG_NUM_FORMAT_FMASK_RESERVED_14 (114792) */
	'I', 'M', 'G', '_', 'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '_', 'R', 'E', 'S', 'E', 'R', 'V', 'E', 'D', '_', '1', '5', '\0', /* IMG_NUM_FORMAT_FMASK_RESERVED_15 (114825) */
	'N', 'U', 'M', '_', 'F', 'O', 'R', 'M', 'A', 'T', '_', 'F', 'M', 'A', 'S', 'K', '\0', /* NUM_FORMAT_FMASK (114858) */
	'M', 'E', 'T', 'A', '_', 'D', 'I', 'R', 'E', 'C', 'T', '\0', /* META_DIRECT (114875) */
	'M', 'E', 'T', 'A', '_', 'D', 'A', 'T', 'A', '_', 'A', 'D', 'D', 'R', 'E', 'S', 'S', '\0', /* META_DATA_ADDRESS (114887) */
	'M', 'E', 'T', 'A', '_', 'R', 'B', '_', 'A', 'L', 'I', 'G', 'N', 'E', 'D', '\0', /* META_RB_ALIGNED (114905, 114910) */
	'S', 'E', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* SE_ENABLE (114921) */
	'S', 'I', 'M', 'D', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* SIMD_DISABLE (114931) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'X', 'S', 'E', 'L', '_', '1', '2', '8', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_XSEL_128_WIDE_TILE (114944) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'Y', 'S', 'E', 'L', '_', '1', '2', '8', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_YSEL_128_WIDE_TILE (114980) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'X', 'S', 'E', 'L', '_', '1', '2', '8', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_PAIR_XSEL_128_WIDE_TILE (115016) */
	'R', 'A', 'S', 'T', 'E', 'R', '_', 'C', 'O', 'N', 'F', 'I', 'G', '_', 'S', 'E', '_', 'P', 'A', 'I', 'R', '_', 'Y', 'S', 'E', 'L', '_', '1', '2', '8', '_', 'W', 'I', 'D', 'E', '_', 'T', 'I', 'L', 'E', '\0', /* RASTER_CONFIG_SE_PAIR_YSEL_128_WIDE_TILE (115057) */
	'E', 'N', '_', '3', '2', 'B', 'I', 'T', '_', 'O', 'B', 'J', 'P', 'R', 'I', 'M', 'I', 'D', '\0', /* EN_32BIT_OBJPRIMID (115098) */
	'A', 'v', 'a', 'i', 'l', 'a', 'b', 'l', 'e', '_', '0', 'x', '1', 'c', '\0', /* Available_0x1c (115117) */
	'A', 'v', 'a', 'i', 'l', 'a', 'b', 'l', 'e', '_', '0', 'x', '1', 'd', '\0', /* Available_0x1d (115132) */
	'R', 'e', 's', 'e', 'r', 'v', 'e', 'd', '_', '0', 'x', '3', 'f', '\0', /* Reserved_0x3f (115147) */
	'E', 'N', '_', 'P', 'I', 'P', 'E', 'L', 'I', 'N', 'E', '_', 'P', 'R', 'I', 'M', 'I', 'D', '\0', /* EN_PIPELINE_PRIMID (115161) */
	'C', 'U', '_', 'I', 'N', 'D', 'E', 'X', '\0', /* CU_INDEX (115180) */
	'T', 'C', '_', 'P', 'E', 'R', 'F', '_', 'E', 'N', '\0', /* TC_PERF_EN (115189) */
	'V', 'T', 'X', '_', 'D', 'O', 'N', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* VTX_DONE_DELAY (115200) */
	'I', 'N', 'T', 'E', 'R', 'P', '_', 'O', 'N', 'E', '_', 'P', 'R', 'I', 'M', '_', 'P', 'E', 'R', '_', 'R', 'O', 'W', '\0', /* INTERP_ONE_PRIM_PER_ROW (115215) */
	'B', 'A', 'T', 'O', 'N', '_', 'R', 'E', 'S', 'E', 'T', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* BATON_RESET_DISABLE (115239) */
	'P', 'C', '_', 'L', 'I', 'M', 'I', 'T', '_', 'E', 'N', 'A', 'B', 'L', 'E', '\0', /* PC_LIMIT_ENABLE (115259) */
	'P', 'C', '_', 'L', 'I', 'M', 'I', 'T', '_', 'S', 'T', 'R', 'I', 'C', 'T', '\0', /* PC_LIMIT_STRICT (115275) */
	'C', 'R', 'C', '_', 'S', 'I', 'M', 'D', '_', 'I', 'D', '_', 'W', 'A', 'D', 'D', 'R', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* CRC_SIMD_ID_WADDR_DISABLE (115291) */
	'L', 'B', 'P', 'W', '_', 'C', 'U', '_', 'C', 'H', 'K', '_', 'M', 'O', 'D', 'E', '\0', /* LBPW_CU_CHK_MODE (115317) */
	'L', 'B', 'P', 'W', '_', 'C', 'U', '_', 'C', 'H', 'K', '_', 'C', 'N', 'T', '\0', /* LBPW_CU_CHK_CNT (115334) */
	'C', 'S', 'C', '_', 'P', 'W', 'R', '_', 'S', 'A', 'V', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* CSC_PWR_SAVE_DISABLE (115350) */
	'C', 'S', 'G', '_', 'P', 'W', 'R', '_', 'S', 'A', 'V', 'E', '_', 'D', 'I', 'S', 'A', 'B', 'L', 'E', '\0', /* CSG_PWR_SAVE_DISABLE (115371) */
	'P', 'C', '_', 'L', 'I', 'M', 'I', 'T', '_', 'S', 'I', 'Z', 'E', '\0', /* PC_LIMIT_SIZE (115392) */
	'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'S', 'A', 'V', 'E', '_', 'W', 'A', 'I', 'T', '_', 'G', 'D', 'S', '_', 'R', 'E', 'Q', 'U', 'E', 'S', 'T', '_', 'C', 'Y', 'C', 'L', 'E', '_', 'O', 'V', 'H', 'D', '\0', /* CONTEXT_SAVE_WAIT_GDS_REQUEST_CYCLE_OVHD (115406) */
	'C', 'O', 'N', 'T', 'E', 'X', 'T', '_', 'S', 'A', 'V', 'E', '_', 'W', 'A', 'I', 'T', '_', 'G', 'D', 'S', '_', 'G', 'R', 'A', 'N', 'T', '_', 'C', 'Y', 'C', 'L', 'E', '_', 'O', 'V', 'H', 'D', '\0', /* CONTEXT_SAVE_WAIT_GDS_GRANT_CYCLE_OVHD (115447) */
	'P', 'S', '_', 'W', 'A', 'V', 'E', '_', 'G', 'R', 'A', 'N', '\0', /* PS_WAVE_GRAN (115486) */
	'V', 'S', '_', 'W', 'A', 'V', 'E', '_', 'G', 'R', 'A', 'N', '\0', /* VS_WAVE_GRAN (115499) */
	'G', 'S', '_', 'W', 'A', 'V', 'E', '_', 'G', 'R', 'A', 'N', '\0', /* GS_WAVE_GRAN (115512) */
	'H', 'S', '_', 'W', 'A', 'V', 'E', '_', 'G', 'R', 'A', 'N', '\0', /* HS_WAVE_GRAN (115525) */
	'C', 'N', 'T', 'R', '_', 'S', 'E', 'L', '0', '\0', /* CNTR_SEL0 (115538) */
	'C', 'N', 'T', 'R', '_', 'S', 'E', 'L', '1', '\0', /* CNTR_SEL1 (115548) */
	'C', 'N', 'T', 'R', '_', 'S', 'E', 'L', '2', '\0', /* CNTR_SEL2 (115558) */
	'C', 'N', 'T', 'R', '_', 'S', 'E', 'L', '3', '\0', /* CNTR_SEL3 (115568) */
	'P', 'E', 'R', 'F', 'M', 'O', 'N', '_', 'M', 'A', 'X', '_', 'S', 'A', 'M', 'P', 'L', 'E', '_', 'D', 'E', 'L', 'A', 'Y', '\0', /* PERFMON_MAX_SAMPLE_DELAY (115578) */
};

static const int sid_strings_offsets[] = {
	/* 0 */ -1, 55264, 55272, -1, 55287, -1, -1, -1, 55302, -1, -1, -1, -1, -1, -1, -1, 55311, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55321, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55329, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55348, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55362,
	/* 257 */ -1, 59700, 59723, -1, 59745, -1, -1, -1, 59768, -1, -1, -1, -1, -1, -1, -1, 59790, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59811, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59835, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59853, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59873, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59892, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59914, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59938,
	/* 2306 */ -1, 59971, 59989, -1, 60007, -1, -1, -1, 60027, -1, -1, -1, -1, -1, -1, -1, 60044, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 60064, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 60083, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 60101,
	/* 2435 */ 60430, -1, -1, -1, -1, -1, -1, -1, 60441, 60453, -1, -1, 60465, -1, -1, -1, -1, -1, -1, -1, 60476, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 60488,
	/* 2468 */ 60599, 60620, 60641, 60662, 60685, 60708, 60728, 60748, 60770, 60792, 60816, 60840, 60861, 60882, 60904, 60927, 60950, 60975, 61000, 61022, 61044, 61065, 61086, 61108, 61133, 61158, 61185, 61212, 61236, 61260, 61285, 61313, 61341, 61371, 61401, 61428, 61455, 61483, 61511, 61539, 61569, 61599, 61626, 61653, 61681, 61711, 61741, 61773, 61805, 61834, 61863, 61893, 61923, 61955, 61987, 62016, 62045, 62072, 62099, 62128, 62157, 62183, 62209, 62233, 62257, 62282, 62313, 62344, 62377, 62410, 62440, 62470, 62501, 62528, 62555, 62583, 62613, 62643, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62674, 62694, 62716, 62742, 62765, 62792, 62817, 62844, 62871, 62898, 62921, 62942, 62972, 63000, 63024, 63047, 63071, 63094, 63121, 63149, 63174, 63199, 63223, 63247, 63272, 63297, 63321, -1, 63345, 63371, 63397, 63423, 63449, 63475, 63501, 63529, 63556, 63584, 63611, 63638, 63666, 63694, 63717, 63739, 63762, 63784, 63807, 63829, 63852, 63875, 63898, 63921, 63945, 63969, 63992, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 64014, 64038, 64061, 64087, 64112, 64142, 64171, 64199, 64226, 64257, 64287, 64320, 64352, 64386, 64419, 64450, 64480, 64514, 64547, 64588, 64627, 64650, 64675, 64700, 64727, 64754, 64778, 64802,
	/* 2761 */ 64869, 64903, 64925, 64945,
	/* 2765 */ 65617, 65638, 65659, 65680, 65701, 65722, 65744, 65769, 65790, 65812, 65834, 65859, 65884, 65905, 65926, 65948,
	/* 2781 */ 65984, 65997, 66020, 66043, 66066, 66084, 66103, 66122, 66141, 66165, 66189, 66213, 66238, 66263, 66288, 66313, 66336, 66361, 66387,
	/* 2800 */ 66413, 66438, 66464, 66490, 66516, 66541, 66566,
	/* 2807 */ 66602, 66633, 66661, 66690, 66721,
	/* 2812 */ 66783, 66806, 66829, 66852,
	/* 2816 */ 66886, 66910, 66934, 66958,
	/* 2820 */ 66994, 67019, 67044, 67069,
	/* 2824 */ 67112, 67129, 67146, 67163,
	/* 2828 */ 67239, 67255, 67271, 67287, 67303, 67319,
	/* 2834 */ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 67688, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 67702, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 67716,
	/* 3075 */ 69499, 69509, 69522, 69536,
	/* 3079 */ 69833, 69848, 69864, 69880,
	/* 3083 */ 70045, 70055, 70073, 70083,
	/* 3087 */ 70355, 70366, 70376, 70387, 70399, 70412, 70426, 70438,
	/* 3095 */ 245, 70592, 69499, 10365,
	/* 3099 */ 70714, 70724, 70729, 70734,
	/* 3103 */ 70757, 70768, 70778, 70789,
	/* 3107 */ 70958, 70974,
	/* 3109 */ 71005, 71018, 71031, 71044,
	/* 3113 */ 71113, 71126, 71136, 71148,
	/* 3117 */ -1, 19698, 12992, -1, 13030, -1, -1, -1, 13372, -1, -1, -1, -1, -1, -1, -1, 13068, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71300, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71306, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71312, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 13106, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71319, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71325, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71331, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71338, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71344, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71351, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71358,
	/* 35886 */ 71722, 71745, 71768, 71791,
	/* 35890 */ 71838, 71863, 71888, 71913,
	/* 35894 */ 71947, 71971,
	/* 35896 */ 72003, 72027,
	/* 35898 */ 72059, 72083, 72107, 72131,
	/* 35902 */ 72163, 72188, 72213, 72238,
	/* 35906 */ 72272, 72297, 72322, 72347,
	/* 35910 */ 72381, 72407, 72433, 72459,
	/* 35914 */ 72495, 72518, 72541, 72564,
	/* 35918 */ 72594, 72628, 72663, 72698,
	/* 35922 */ 72741, 72775, 72810, 72845,
	/* 35926 */ 72888, 72911, 72934, 72957,
	/* 35930 */ 72987, 73021, 73056, 73091,
	/* 35934 */ 73134, 73168, 73203, 73238,
	/* 35938 */ 73281, 73309, 73337, 73365,
	/* 35942 */ 73405, 73444, 73484, 73524,
	/* 35946 */ 73577, 73616, 73656, 73696,
	/* 35950 */ 74380, 74393, 74406, 74419, 74440, 74459, 74477, 74495, 74510, 74527, 74544, 74556, 74567, 74579, 74592, 74604,
	/* 35966 */ 75328, 75349, 75370, 75391, 75412,
	/* 35971 */ 75740, 75756, 75773, 75790, 75811,
	/* 35976 */ 75942, 75958, 75974, 75991, 76008, 76029, 76053, 76077, 76100, 76123,
	/* 35986 */ 76310, 76337, 76355, 76373, 76395, 76419, 76440, 76459, 76480, 76501, 76523,
	/* 35997 */ 55323, 76585, -1, 76598, -1, -1, 76611, -1, -1, -1, -1, 76623, -1, 76635, -1, 76647,
	/* 36013 */ 77154, 77189, 77224, 77256, 77288, 77320, 77352, 77386,
	/* 36021 */ 77450, 77464, 77477, 77495, 77508, 77521, 77542, 77566,
	/* 36029 */ 77642, 77653, 77663, 77679, 77705, 77721, 77747, 77763, 77789, 77805, 77831, 77856, 77877, 77902, 77923, 77954, 77971, 77992, 78009, 78030, 78051,
	/* 36050 */ 78097, 78115, 78134, 78151, 78168,
	/* 36055 */ 78281, 78296, 78317, 78339,
	/* 36059 */ 78373, 78389,
	/* 36061 */ 79005, 79016, 79026, 79050, 79061, 79075, 79095, 79113,
	/* 36069 */ 79125, -1, -1, -1, -1, 79136, -1, -1, -1, -1, 79143, -1, -1, -1, -1, 79150, -1, 79157, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79166, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79184, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79203, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79220, -1, -1, -1, -1, 79227, -1, -1, -1, -1, 79239, -1, -1, -1, -1, 79246, -1, -1, -1, -1, -1, -1, 79253, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79262, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79272, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79281, -1, -1, -1, -1, -1, -1, 79297, -1, -1, -1, -1, 79304, -1, -1, -1, -1, 79311, -1, -1, -1, -1, 79322, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79329, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79346, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79356, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79372, -1, 79380, -1, -1, -1, -1, 79387, -1, -1, -1, -1, 79394, -1, -1, -1, -1, 79401,
	/* 36325 */ 79486, 79493, 79513, 79518,
	/* 36329 */ 79664, 79677, 79696, 79718,
	/* 36333 */ 80227, 80247,
	/* 36335 */ 80259, 80273, 80286,
	/* 36338 */ 82240, 82251, 82267, 82282, 82298, 82312, 82325, 82340, 82359, 82374, 82386, 82405, 82425, 82443, 82462, 82477, 82492, 82514, 82529, 82544, 82559, 82575,
	/* 36360 */ 82709, 82716, 82730, 82744, 82758, 82772,
	/* 36366 */ 82793, 82805, 82816, 82827,
	/* 36370 */ 82257, 82288, 82331, 82520,
	/* 36374 */ 83810, 83823, 83836,
	/* 36377 */ 83848, 83866, 83886, 83906,
	/* 36381 */ 83934, 83950, 83967, 83985,
	/* 36385 */ 84013, 84028, 84046,
	/* 36388 */ 84142, 84156, 84179, 84202, 84225, 84240, 84253, 84265, 84282, 84301, 84311, 84331, 84351, 84370, 84382, 84394, 84411, 84428, 84444, 84455, 84475, 84504, 84515, 84541, 84559, 84576, 84595, 84613, 84632, 84648, 84672, 84692, 84714, 84736, 84750, 84769, 84785, 84795, 84809, 84822, 84837, 84855, 84867, 84890, 84915, 84937, 84962, 84984, 84992, 85000, 85028, 85050, 85069, 85087, 85107, 85125, 85145, 85169, 85190, 85212, 85228, 85247, 85267, 85290,
	/* 36452 */ 85816, 85829, 85841, 85853,
	/* 36456 */ 85871, 85884,
	/* 36458 */ 85902, 85915, 85927, 85941,
	/* 36462 */ 85953, 85966,
	/* 36464 */ 85984, 85998, 86010, 86031,
	/* 36468 */ 86286, 86299, 86313,
	/* 36471 */ 86323, 86336, 86346, 86360,
	/* 36475 */ 86388, 86401, 86413, 86432,
	/* 36479 */ 86529, 86245, 86522, 86537,
	/* 36483 */ 86566, 86580, 86595,
	/* 36486 */ 86618, 86632, 86647,
	/* 36489 */ 87466, 87481, 87502, 64956,
	/* 36493 */ 87560, 87571, 87579, 87595,
	/* 36497 */ 87621, 87647, 87672, 87697, 87720, 87741, 87768, 87797,
	/* 36505 */ 88113, 88129, 88146, 88173,
	/* 36509 */ 88238, 88257, 88276, 88296, 88316,
	/* 36514 */ 88509, 88527, 88550,
	/* 36517 */ 88879, 88891, 88908,
	/* 36520 */ 89291, 89303, 89316, 89329,
	/* 36524 */ 89349, 89363, 89371, 89380, 89390, 89399, 89411, 89426, 89441, 89458, 89475, 89489, 89501, 89519, 89537, 89555, 89573, 89585, 89599, 89613, 89627, 89638, 89649, 89670, 89688, 89706, 89724, 89742, 89760, 89778, 89796, 89814,
	/* 36556 */ 89835, 89848, 89861, 89876, 89891, 89903, 89915, 89927,
	/* 36564 */ 89952, 89961, 89970, 89983,
	/* 36568 */ 90060, 90075, 90093, 90121, 90151, 90182, 90210, 90240,
	/* 36576 */ 90380, 90397, 90415,
	/* 36579 */ 90628, 90647, 90667,
	/* 36582 */ 90687, 90706,
	/* 36584 */ 92485, 92497, 92509, 92521,
	/* 36588 */ 93124, 93159, 93191, 93222, 93250, 93293,
	/* 36594 */ 93347, 93384, 93418, 93451, 93481, 93526,
	/* 36600 */ 93586, 93622, 93656, 93698,
	/* 36604 */ 94980, 95013, 95053, 95083, 95116, 95155,
	/* 36610 */ 95271, 95305,
	/* 36612 */ 96512, 96532, 96541, 96547, 10365, 456,
	/* 36618 */ 509, 96574, 18682, 984,
	/* 36622 */ 26612, 96547, 11049, 96603,
	/* 36626 */ 26571, 96547, 391, 96625,
	/* 36630 */ 96656, 96523,
	/* 36632 */ 96663, 96673,
	/* 36634 */ 96755, 96763, 96771, 96781,
	/* 36638 */ 96823, 96836, 96848,
	/* 36641 */ 96864, 96872, 96880, 96890,
	/* 36645 */ 96913, -1, 96921, 96931,
	/* 36649 */ 97324, 97347, 97370, 97388, 97406,
	/* 36654 */ 76310, 76337, 76355, 76373, 76395, 76419, 76440, 76459, 76480, 76501, 76523, 97860,
	/* 36666 */ 98185, 98203, 98227,
	/* 36669 */ 89349, 89363, 89371, 89380, 89390, 89399, 89411, 89426, 89441, 89458, 89475, 89489, 89501, -1, 89537, -1, 89573, 89585, 89599, 89613, 89627, 89638, 89649, -1, 98346,
	/* 36694 */ 82240, 82251, 82267, 82282, 82298, 82312, 82325, 104925, 82359, 82374, 82386, 82405, 82425, 82443, 82462, 82477, 82492, 82514, 82529, 82544, 82559, 82575, 104940, 104967, 104994, 105021, 105048, 105072, 105092,
	/* 36723 */ 107840, 107849, 107858, 107876, 107894, 107903, 107912, 107921,
	/* 36731 */ 107930, 107951, 107972, 107995, 108018, 108038, 108058, 108083,
	/* 36739 */ 108115, 108139, 108157, 108176, 108196, 108215, 108237, 108262, 108287, 108314, 108341, 108365, 108387, 108415, 108440, 108468,
	/* 36755 */ 108538, 108550, 108569, 108588,
	/* 36759 */ 108607, 108631, 108649, 108668, 108688, 108707, 108729, 108754, 108779, 108806, 108833, 108857, 108879, 108907, 108932, 108960, 108988, 109010, 109034, 109058, 109082, 109103, 109124, 109149, 109177, 109205, 109233, 109261, 109289, 109317, 109345, 109373, 109401, 109423, 109445, 109469, 109489, 109509, 109529, 109549, 109569, 109589, 109609, 109637, 109665, 109694, 109723, 109752, 109781, 109810, 109839, 109870, 109900, 109931, 109961, 109991, 110022, 110053, 110073, 110095, 110113, 110140, 110164, 110190,
	/* 36823 */ 110224, 110245, 110266, 110289, 110312, 110332, 110352, 110377, 110398, 110424, 110444, 110466, 110492, 110513, 110537, 110564,
	/* 36839 */ 110624, 110643, 110662, 110681, 110700, 110719, 110738, 110757, 110776, 110791, 110806, 110821, 110838, 110859, 110880, 110900,
	/* 36855 */ 110945, 110957, 110971, 110995, 111025, 111050, 111081, 111101,
	/* 36863 */ 111127, 111154, 111180, 111207, 111238, 111267, 111297, 111331,
	/* 36871 */ 111359, 111384, 111407,
	/* 36874 */ 111430, 111453, 111479, 111508,
	/* 36878 */ 111540, 111561, 111583,
	/* 36881 */ 111606, 111629, 111653,
	/* 36884 */ 111726, 111758, 111791, 111824,
	/* 36888 */ 66602, 66633, 66661, 111952,
	/* 36892 */ 84013, 84028, 84046, 112519,
	/* 36896 */ 84142, 84156, 84179, 84202, 84225, 84240, 84253, 84265, 84282, 112539, 84311, 84331, 84351, 84370, 112553, 84394, 84411, 84428, 112567, 112583, 84475, 84504, 84515, 84541, 84559, 84576, 84595, 84613, 84632, 112597, 84672, 84692, 84714, 84736, 84750, 84769, 84785, 112613, 84809, 84822, 84837, 84855, 84867, 84890, 84915, 84937, 84962, 84984, 84992, 85000, 85028, 85050, 85069, 85087, 112627, 85125, 85145, 85169, 85190, 85212,
	/* 36956 */ 75431, 112708, 112716, 112724,
	/* 36960 */ 26612, 96547, -1, 96603,
	/* 36964 */ 107930, 107951, 107972, 107995, 108018, 108038, 113096, 108083,
	/* 36972 */ 110224, 110245, 110266, 110289, 110312, 110332, 113122, 110377, 110398, 110424, 113148, 113175, 113202, 113229, 110537, 110564,
	/* 36988 */ 111606, 111629, 111653, 113300,
	/* 36992 */ 84142, 84156, 84179, 84202, 84225, 84240, 84253, 84265, 84282, 112539, 84311, 84331, 84351, 84370, 112553, 84394, 84411, 84428, 112567, 112583, 84475, 84504, 84515, 84541, 84559, 84576, 84595, 84613, 84632, 112597, 84672, 84692, 84714, 84736, 84750, 84769, 84785, 84795, 84809, 84822, 84837, 84855, 84867, 84890, 84915, 84937, 84962, 84984, 84992, 85000, 85028, 85050, 85069, 85087, 112627, 85125, 85145, 85169, 85190, 85212, 85228,
	/* 37053 */ 108607, 108631, 108649, 108668, 108688, 108707, 108729, 108754, 108779, 108806, 108833, 108857, 108879, 108907, 108932, 113480, 108988, 109010, 109034, 109058, 109082, 109103, 109124, 113508, 113537, 113562, 113588, 113611, 113635, 109317, 109345, 109373, 109401, 109423, 109445, 109469, 109489, 109509, 109529, 109549, 109569, 109589, 113662, 113696, 109665, 109694, 109723, 109752, 109781, 109810, 109839, 109870, 109900, 109931, 109961, 109991, 110022, 110053, 110073, 110095, 110113, 113730, 113754, 110190,
	/* 37117 */ 107930, 107951, 107972, 107995, 108018, 108038, 113826, 108083,
	/* 37125 */ 108607, 108631, 108649, 108668, 108688, 108707, 108729, 108754, 108779, 108806, 108833, 108857, 108879, 108907, 108932, 108960, 108988, 109010, 109034, 109058, 109082, 109103, 109124, 113508, 113537, 113562, 113588, 113611, 113635, 109317, 109345, 113880, 109401, 109423, 109445, 109469, 109489, 109509, 109529, 109549, 109569, 109589, 113480, 113662, 113696, 113900, 113922, 113950, 113978, 114011, 114039, 114067, 114100, 114124, 114151, 114184, 114223, 110053, 110073, 114251, 114279, 113730, 113754, 110190,
	/* 37189 */ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 114307, 114329,
	/* 37250 */ 110224, 110245, 110266, 110289, 110312, 110332, 114371, 110377, 110398, 110424, 113148, 113175, 113202, 113229, 110537, 110564,
	/* 37266 */ 114397, 114424, 114451, 114478, 114505, 114532, 114559, 114588, 114616, 114645, 114673, 114701, 114730, 114759, 114792, 114825,
	/* 37282 */ 72987, 73021, 73056, 73091, 114944,
	/* 37287 */ 73134, 73168, 73203, 73238, 114980,
	/* 37292 */ 73405, 73444, 73484, 73524, 115016,
	/* 37297 */ 73577, 73616, 73656, 73696, 115057,
	/* 37302 */ 84142, 84156, 84179, 84202, 84225, 84240, 84253, 84265, 84282, 112539, 84311, 84331, 84351, 84370, 84382, 84394, 84411, 84428, 84444, 84455, 84475, 84504, 84515, 84541, 84559, 84576, 84595, 84613, 115117, 115132, 84672, 84692, 84714, 84736, 84750, 84769, 84785, 84795, 84809, 84822, 84837, 84855, 84867, 84890, 84915, 84937, 84962, 84984, 84992, 85000, 85028, 85050, 85069, 85087, 112627, 85125, 85145, 85169, 85190, 85212, 85228, 85247, 85267, 115147,
};

#endif
